		/* Calcul du signe des determinants 3x3 */
		/* avec    l'arithmetique    redondante */
                /* Programme      de      chronometrage */
		/* Sylvain Pion              Juillet 95 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "arith.h"
#include "AR2x2.h"
#include "AR3x3.h"
#include "runtime.h"

#define RAND_MAX 32767

double hasard();

int main ()
{
    int signe, j, tab[10];
    double Na = 5000;
    double Nm = 500;
    double N2 = 500;
    double N3 = 500;
    double tim;
    double ad,bd,cd,dd,ed,fd,gd,hd,id;
    NOMBRE *pl, *p3l, *al, *a3l, *anl, *a, *b, *c, *d, *e, *f, *g, *h, *i;
    NOMBRE *det, *p1, *p2, *p3, *p4, *p5, *p6;
    srand(getpid());

    ad = hasard ();    bd = hasard ();    cd = hasard ();
    dd = hasard ();    ed = hasard ();    fd = hasard ();
    gd = hasard ();    hd = hasard ();    id = hasard ();

    /*
ad= 1201814450400360.0;
bd= -45016896831270.0;
cd= -857705757793388.0;
dd= -1724694276017031.0;
ed= -30677585414681.0;
fd= -1736859419614923.0;
gd= -463936313571930.0;
hd= -390677691600464.0;
id= -920329720349980.0;
*/
    
    a = AR_dbl (&ad);    b = AR_dbl (&bd);    c = AR_dbl (&cd);
    d = AR_dbl (&dd);    e = AR_dbl (&ed);    f = AR_dbl (&fd);
    g = AR_dbl (&gd);    h = AR_dbl (&hd);    i = AR_dbl (&id);


    AR_flush(a);    AR_flush(b);    AR_flush(c); 
    AR_flush(d);    AR_flush(e);    AR_flush(f); 
    AR_flush(g);    AR_flush(h);    AR_flush(i); 

    tab[0] = 9;
    tab[1] = (int) a;    tab[2] = (int) b;    tab[3] = (int) c;
    tab[4] = (int) d;    tab[5] = (int) e;    tab[6] = (int) f;
    tab[7] = (int) g;    tab[8] = (int) h;    tab[9] = (int) i;

    det = AR_pmpmpm( p1 = AR_mul(a,AR_mul(e,i)),
		     p2 = AR_mul(a,AR_mul(f,h)),
		     p3 = AR_mul(b,AR_mul(f,g)),
		     p4 = AR_mul(b,AR_mul(i,d)),
		     p5 = AR_mul(c,AR_mul(d,h)),
		     p6 = AR_mul(c,AR_mul(e,g)));

    AR_flush(det);

    AR_affiche(a);    AR_affiche(b);    AR_affiche(c);
    AR_affiche(d);    AR_affiche(e);    AR_affiche(f);
    AR_affiche(g);    AR_affiche(h);    AR_affiche(i);
    AR_affiche(p1);    AR_affiche(p2);    AR_affiche(p3);
    AR_affiche(p4);    AR_affiche(p5);    AR_affiche(p6);
    AR_affiche(det);

    InitRuntime();
/*    tim = PartialRuntime();

    for(j=0; j<Na; ++j) {
	al = AR_add3(a,b,c);
	AR_flush (al);
	AR_free (al);
    };

    tim = PartialRuntime()-tim;
    printf("Add3: %e\n",tim/Na);
    tim = PartialRuntime();

    for(j=0; j<Nm; ++j) {
	al = AR_mul3(a,b,c);
	AR_flush (al);
	AR_free (al);
    };

    tim = PartialRuntime()-tim;
    printf("Mul3: %e\n",tim/Nm);
    tim = PartialRuntime();

    for(j=0; j<Nm; ++j) {
	al = AR_mul(a,pl=AR_mul(b,c));
	AR_flush (al);
	AR_free (al);
	AR_free (pl);
    };

    tim = PartialRuntime()-tim;
    printf("Mul3_old: %e\n",tim/Nm);
    tim = PartialRuntime();

    for(j=0; j<Na; ++j) {
	al = AR_add(a,b);
	AR_flush (al);
	AR_free (al);
    };

    tim = PartialRuntime()-tim;
    printf("Add: %e\n",tim/Na);
    tim = PartialRuntime();

    for(j=0; j<Na; ++j) {
	al = AR_sub(a,b);
	AR_flush (al);
	AR_free (al);
    };

    tim = PartialRuntime()-tim;
    printf("Sub: %e\n",tim/Na);
    tim = PartialRuntime();

    for(j=0; j<Na; ++j) {
	al = AR_add(a,a3l = AR_minus(b));
	AR_flush (al);
	AR_free (al);
	AR_free (a3l);
    };

    tim = PartialRuntime()-tim;
    printf("Sub_old: %e\n",tim/Na);
    tim = PartialRuntime();

    for(j=0; j<Nm; ++j) {
	pl = AR_mul(a,b);
	AR_flush (pl);
	AR_free (pl);
    };

    tim = PartialRuntime()-tim;
    printf("Mul: %e\n",tim/Nm);


    AR_flush(al = AR_sub(a,b));
    AR_flush(pl = AR_mul(a,b));
    AR_flush(p3l = AR_mul3(a,b,c));
    AR_flush(a3l = AR_add3(a,b,c));
    AR_flush(anl = AR_addn(tab));
      
    printf("a := "); AR_affiche (a);
    printf("b := "); AR_affiche (b);
    printf("c := "); AR_affiche (c);
    printf("d := "); AR_affiche (d);
    printf("e := "); AR_affiche (e);
    printf("f := "); AR_affiche (f);
    printf("g := "); AR_affiche (g);
    printf("h := "); AR_affiche (h);
    printf("i := "); AR_affiche (i);

    printf("0-(a-b)+"); AR_affiche (al);
    printf("0-(a+b+c)+"); AR_affiche (a3l);
    printf("\n0-(a*b)+"); AR_affiche (pl);
    printf("\n0-(a+b+c+d+e+f+g+h+i)+"); AR_affiche(anl);
    printf("0-(a*b*c)+"); AR_affiche (p3l);
    printf("0-(a*b*c)+"); AR_affiche (a3l);
    */
/*    printf("quit;\n"); */

    tim = PartialRuntime();
    for (j=0; j<N2; ++j) signe = AR_det2(ad,bd,cd,dd);
    tim = PartialRuntime()-tim;
    printf("2x2: %e\n",tim/N2);

    tim = PartialRuntime();
    for (j=0; j<N3; ++j) signe = AR_det3(ad,bd,cd,dd,ed,fd,gd,hd,id);
    tim = PartialRuntime()-tim;
    printf("3x3: %e\n",tim/N3);

/*    AR_free(b);    AR_free(c);    AR_free(d);
    AR_free(al);    AR_free(pl);    AR_free(a3l);
*/
    return 0;
}

double hasard ()
{
    double x =
        ((double)(rand() % 32768)) + ((double)32768)*(
            ((double)(rand() % 32768)) + ((double)32768)*(
                ((double)(rand() % 32768)) + ((double)32768)*(
                    ((double)(rand() % 256  )) )));
    
    return ((rand() % 2) ? x : -x);
}
