#include "runtime.h"
#include <stdio.h>

#if defined(hp) || defined(solaris)
#define SystemV
#endif


/**************************/
#ifdef SystemV /* System V */
#include <sys/times.h>

#ifdef solaris			/* Solaris */
#include <limits.h>
#endif

#else  /* System BSD */

#include <sys/time.h>
#include <sys/resource.h>

#endif

static double INIT_TIME_CPU_RUNTIME,INIT_PARTIAL_TIME_CPU_RUNTIME;

/*****************************************************************/
#ifdef SystemV /* System V */
double Runtime()
{struct tms t;
  
 times(&t);
 return(t.tms_utime*10.0);
}

/**************************/

double InitRuntime()
{
#ifdef solaris
  fprintf(stderr,"SunOS 5... ");
#endif
  fprintf(stderr,"RUNTIME : System V\n");
  INIT_PARTIAL_TIME_CPU_RUNTIME=INIT_TIME_CPU_RUNTIME=Runtime();
  return(INIT_TIME_CPU_RUNTIME);
}

/*****************************************************************/

#else  /* System BSD */

double Runtime()
{struct rusage r;
 struct timeval t;

 t.tv_usec=0;
 getrusage(0, &r);
 t = r.ru_utime;
 return(1000.0*t.tv_sec + (t.tv_usec/1000.0));
}

/**************************/

double InitRuntime()
{
  fprintf(stderr,"RUNTIME : System BSD\n");
  INIT_PARTIAL_TIME_CPU_RUNTIME=INIT_TIME_CPU_RUNTIME=Runtime();
  return(INIT_TIME_CPU_RUNTIME);
}
#endif

/*****************************************************************/

double TotalRuntime()		/* returns seconds */
{
  INIT_PARTIAL_TIME_CPU_RUNTIME=Runtime();
  return((INIT_PARTIAL_TIME_CPU_RUNTIME-INIT_TIME_CPU_RUNTIME)/1000.0);
}  

/**************************/

double PartialRuntime()		/* returns seconds */
{double v,w;

 w=Runtime();
 v=(w-INIT_PARTIAL_TIME_CPU_RUNTIME)/1000.0;
 INIT_PARTIAL_TIME_CPU_RUNTIME=w;
 return(v);
}  
/*****************************************************************/

