		/* Calcul du signe des determinants 3x3 */
		/* avec    l'arithmetique    redondante */
		/* Sylvain Pion              Juillet 95 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "arith.h"

int AR_det3 (	double ad, double bd, double cd,
		double dd, double ed, double fd,
		double gd, double hd, double id)
{
    NOMBRE *a, *b, *c, *d, *e, *f, *g, *h, *i, *det;
    int signe;

    a = AR_dbl (&ad);    b = AR_dbl (&bd);    c = AR_dbl (&cd);
    d = AR_dbl (&dd);    e = AR_dbl (&ed);    f = AR_dbl (&fd);
    g = AR_dbl (&gd);    h = AR_dbl (&hd);    i = AR_dbl (&id);

    det = AR_pmpmpm( AR_mul(a,AR_mul(e,i)),
		     AR_mul(a,AR_mul(f,h)),
		     AR_mul(b,AR_mul(f,g)),
		     AR_mul(b,AR_mul(i,d)),
		     AR_mul(c,AR_mul(d,h)),
		     AR_mul(c,AR_mul(e,g)));

    signe = get_sign(det);
    AR_free_rec (det);
    return signe;
}
