#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "arith.h"


	/* Initialisateur des operations d'arite 1 */

NOMBRE *init_1 (int oper, int interne, void *a)
{
    NOMBRE *s;
    int i;
      
    s = (NOMBRE *) malloc(sizeof(NOMBRE));
    (*s).arg = (void **) malloc(4+4*interne);
    (*s).op = oper;
    (*s).disp = 0;
    (*s).calc = NULL;
    ((*s).arg)[0] = a;  
    for (i=0; i<interne; i++) { ((*s).arg)[i+1] = NULL;};

    return s;
}

        /* Initialisateur des operations d'arite 2 */

NOMBRE *init_2 (int oper, int interne, void *a, void *b)
{
    NOMBRE *s;
    int i;

    s = (NOMBRE *) malloc(sizeof(NOMBRE));
    (*s).arg = (void **) malloc(8+4*interne);
    (*s).op = oper;
    (*s).disp = 0;
    (*s).calc = NULL;
    ((*s).arg)[0] = a;
    ((*s).arg)[1] = b;
    for (i=0; i<interne; i++) { ((*s).arg)[i+2] = NULL;};

    return s;
}

        /* Initialisateur des operations d'arite 3 */

NOMBRE *init_3 (int oper, int interne, void *a, void *b, void *c)
{
    NOMBRE *s;
    int i;

    s = (NOMBRE *) malloc(sizeof(NOMBRE));
    (*s).arg = (void **) malloc(12+4*interne);
    (*s).op = oper;
    (*s).disp = 0;
    (*s).calc = NULL;
    ((*s).arg)[0] = a;
    ((*s).arg)[1] = b;
    ((*s).arg)[2] = c;
    for (i=0; i<interne; i++) { ((*s).arg)[i+3] = NULL;};

    return s;
}

        /* Initialisateur des operations d'arite 6 */

NOMBRE *init_6 (int oper, int interne, void *a, void *b, void *c, void *d, void *e, void *f)
{
    NOMBRE *s;
    int i;

    s = (NOMBRE *) malloc(sizeof(NOMBRE));
    (*s).arg = (void **) malloc(24+4*interne);
    (*s).op = oper;
    (*s).disp = 0;
    (*s).calc = NULL;
    ((*s).arg)[0] = a;
    ((*s).arg)[1] = b;
    ((*s).arg)[2] = c;
    ((*s).arg)[3] = d;
    ((*s).arg)[4] = e;
    ((*s).arg)[5] = f;
    for (i=0; i<interne; i++) { ((*s).arg)[i+6] = NULL;};

    return s;
}

       /* Initialisateur des operations d'arite 2 (1 pointeur et 1 int) */

NOMBRE *init_mixt (int oper, int interne, void *a, int b)
{
    NOMBRE *s;
    int i;

    s = (NOMBRE *) malloc(sizeof(NOMBRE));
    (*s).arg = (void **) malloc(8+4*interne);
    (*s).op = oper;
    (*s).disp = 0;
    (*s).calc = NULL;
    ((*s).arg)[0] = a;
    ((*s).arg)[1] = (void *) b;
    for (i=0; i<interne; i++) { ((*s).arg)[i+1] = NULL;};

    return s;
}

        /* Initialisateur pour les operations a n operandes */

NOMBRE *init_n (int oper, int interne, void *a)
{
/* l'argument passe est un pointeur vers un tableau contenant [0]:n, et [1]...[n]: les (NOMBRE*) operandes */
    NOMBRE *s;
    int i, n = (int) a;

    s = (NOMBRE *) malloc(sizeof(NOMBRE));
    (*s).arg = (void **) a;
    (*s).op = oper;
    (*s).disp = 0;
    (*s).calc = NULL;
    for (i=1+n; i<=(interne+n); i++) { ((*s).arg)[i] = NULL;};

    return s;
}

        /* Retourne l'exposant s'il est calcule, et provoque son calcul sinon */ 

int get_exp (NOMBRE *a)
{
    if (get_disp(a) == 0) next_step(a);
    if (get_disp(a) == -1) {return -1024*1024*1024;};
    switch ((*a).op) {
    case MINUS:
    case TRUNC:
	return( get_exp((NOMBRE *) (*a).arg[0]) );
    case SHIFT:
	return( get_exp((NOMBRE *) (*a).arg[0]) + (int) (*a).arg[1]);
    default:
	return( (*a).expo );
    };
}

        /* Retourne le champ disp */ 

int get_disp (NOMBRE *a)
{
    switch ((*a).op) {
    case MINUS:
    case SHIFT:
	return( get_disp((NOMBRE *) (*a).arg[0]) );
    case TRUNC:
    {
	int d = get_disp((NOMBRE *) (*a).arg[0]);
	int e = (int) (*a).arg[1];
	if (d>=0) {return ((d>=e) ? (-e-1) : d);}
	else {return max(d,-e-1);};
    };
    default:
	return( (*a).disp );
    };
}

        /* Retourne calc[n] s'il est calcule, et sinon, provoque son calcul */

short get_nth (NOMBRE *a, int n)
{
    if  (n<0)              return 0;
    if ((get_disp(a) == 0) && ((*a).op != TRUNC)) next_step(a);
    switch ((*a).op) {
    case MINUS:
	return (-get_nth((NOMBRE *) (*a).arg[0],n));
    case SHIFT:
	return ( get_nth((NOMBRE *) (*a).arg[0],n));
    case TRUNC:
	return ((n>=((int) (*a).arg[1])) ? 0 : get_nth((NOMBRE *) (*a).arg[0],n));
    default: 
    {
	int d = get_disp(a);
	if (d < 0)  return ( (n+2+d > 0) ? 0 : (*a).calc[n]);
	if (n>=d)   {next_step(a); return (get_nth(a,n));}
	else        return ((*a).calc[n]);
    };
    };
}

        /* Retourne le signe (-1/0/1) */

short get_sign (NOMBRE *a)
{
    switch ((*a).op) {
    case MUL3:
	return (get_sign((NOMBRE *)(*a).arg[0])*get_sign((NOMBRE *)(*a).arg[1])*get_sign((NOMBRE *)(*a).arg[2]));
    case MUL:
	return (get_sign((NOMBRE *)(*a).arg[0])*get_sign((NOMBRE *)(*a).arg[1]));
    case MUL_DIG:
	return (get_sign((NOMBRE *)(*a).arg[0])*sig(((int)(*a).arg[1])));
    default:
	if (get_disp(a) == 0)  next_step(a);
	if (get_disp(a) == -1) {return 0;}
	else return ((get_nth(a,0)>0) ? 1 : -1);
    };
}

         /* Provoque le calcul jusqu'au bout */

void AR_flush (NOMBRE *a)
{
    while (get_disp(a) >=0) next_step(a);
}

         /* Libere un NOMBRE recursivement (ses arguments aussi...) */

void AR_free_rec (NOMBRE *a)
{
/* free recursif: a manier avec prudence et parcimonie : pour les "bons" arbres de calculs (sans cycle) */
    switch ((*a).op) {
    case ADDn:
    {
	int i=1;
	for(; i<= (int) (*a).arg[0]; i++) AR_free_rec ((NOMBRE *) (*a).arg[i]);
	break;
    };
    case PMPMPM:
	AR_free_rec ((NOMBRE *) (*a).arg[5]);
	AR_free_rec ((NOMBRE *) (*a).arg[4]);
	AR_free_rec ((NOMBRE *) (*a).arg[3]);
    case MUL3:
    case ADD3:
	AR_free_rec ((NOMBRE *) (*a).arg[2]);
    case ADD:
    case SUB:
    case MUL:
	AR_free_rec ((NOMBRE *) (*a).arg[1]);
    case MINUS:
    case SHIFT:
    case MUL_DIG:
    case TRUNC:
	AR_free_rec ((NOMBRE *) (*a).arg[0]);
    default:
	AR_free(a);
    };
}

         /* Libere un NOMBRE */

void AR_free (NOMBRE *a)
{
    if ((*a).op == MUL)  {
	free ((void *) (*a).arg[2]);
    };
    if ((*a).op == MUL3) {
	free ((void *) (*a).arg[3]);
	free ((void *) (*a).arg[4]);
	free ((void *) (*a).arg[5]);
    };

    switch ((*a).op) {
    case MINUS:
    case TRUNC:
    case SHIFT:
	break;
    default:
	free ((void *) (*a).calc);
    };
    free ((void *) (*a).arg);
    free ((void *) a);
}

         /* Declenche l'etape suivante du calcul */

void next_step (NOMBRE *a)
{
    if (get_disp(a) >=0) {
	switch ((*a).op) {
	case DBL:     next_dbl (a); break;
	case ADDn:    next_addn (a); break;
	case PMPMPM:  next_pmpmpm (a); break;
	case ADD3:    next_add3 (a); break;
	case ADD:     next_add (a); break;
	case SUB:     next_sub (a); break;
	case MUL:     next_mul (a); break;
	case MUL3:    next_mul3 (a); break;
	case MUL_DIG: next_mul_dig (a); break;
	case MINUS:
	case SHIFT:
	case TRUNC:   next_step ((NOMBRE *) (*a).arg[0]); break;
	default:      printf("Erreur dans next_step : %d \a\n", (*a).op); break;
	};
    };
}

void AR_affiche (NOMBRE *a)
{
    int i;
    printf("%d ",0 );
    for (i=0; i+get_disp(a)<-1; ++i) {
	printf("+ (%d)*2^(%d)",get_nth(a,i),(get_exp(a)-i-1)*15);
	if (i+get_disp(a)<-2) {printf("\n");}
    };
    printf(";\n");
}

void recale_fort (NOMBRE *a)
{
    int i;
    /* On ne peut pas se permettre d'avoir (*a).disp = 0 en sortie */
    while (((*a).disp > 1) && ((*a).calc[0] == 0)) {
	for (i=0;i<(*a).disp-1;i++) { (*a).calc[i] = (*a).calc[i+1];};
	--(*a).expo;
	--(*a).disp;
    };
    while (((*a).disp < -1) && ((*a).calc[0] == 0)) {
	for (i=0;i<-(*a).disp-2;i++) { (*a).calc[i] = (*a).calc[i+1];};
	--(*a).expo;
	++(*a).disp;
    };
}

void recale_faible (NOMBRE *a)
{
    while (((*a).disp < -1) && ((*a).calc[-2-(*a).disp] == 0))
	++(*a).disp;
}

void next_mul_dig (NOMBRE *a)
{
    NOMBRE *b = (NOMBRE *) (*a).arg[0];
    int eb,db;
    int c = (int) (*a).arg[1];
    int ja = -2;

    eb = get_exp(b);

    if ((*a).disp == 0) {
	if ((c == 0) || (get_disp(b) == -1)) {(*a).disp = -1;}
	else {
	    (*a).disp = 1;
	    (*a).calc = (short *) malloc(TAILLE * (sizeof(short)));
	    (*a).calc[0] = 0;
	    (*a).expo = eb+3;
	    while ((*a).calc[0] == 0) {
		next_mul_dig(a);
		(*a).calc[0] = (*a).calc[1];
		--(*a).expo;
		--(*a).disp;
	    };
	};
    }
    else {
	int u0,u1,u2, s0,s1,t1,t2, r;
	ja = (*a).expo - (*a).disp;

	u0 = c * (int) get_nth(b, eb-ja);
	u1 = c * (int) get_nth(b, eb-ja+1);
	u2 = c * (int) get_nth(b, eb-ja+2);
	
	s0 = u0 % AR_2_15;
	s1 = u1 % AR_2_15;
	t1 = u1 / AR_2_15;
	t2 = u2 / AR_2_15;
	
	r = ((s1 + t2 + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	r = ((s0 + t1 + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14 + ((s1 + t2 - r) / AR_2_15);
	
	if (((*a).disp % TAILLE)==0) {
	    (*a).calc = (short *) realloc((void *) (*a).calc, ((*a).disp + TAILLE)*sizeof(short));
	};
	
	(*a).calc[(*a).disp++] = (short) r;
	
	if (((db = get_disp(b))<0) && (ja <= (eb+db+1))) {
	    (*a).disp = -(++(*a).disp);
	    recale_faible(a);
	};
    };
}

void next_dbl (NOMBRE *a)
{
    short a0,a1,a2,a3;
    double d = ldexp(*( (double *) ((*a).arg[0])),-45);
    d -= (double) (a0 = nint(d));
    d -= (double) (a1 = nint(d = ldexp(d,15)));
    d -= (double) (a2 = nint(d = ldexp(d,15)));
    a3 = nint(d = ldexp(d,15));

    (*a).disp = -5;
    (*a).expo = 4;
    (*a).calc = (short *) malloc(4 * sizeof(short));
    (*a).calc[0] = a0;
    (*a).calc[1] = a1;
    (*a).calc[2] = a2;
    (*a).calc[3] = a3;

    recale_fort(a);
    recale_faible(a);
}

void next_add (NOMBRE *a)
{
    NOMBRE *b, *c;
    int eb,ec, db,dc, ja, t,s;
    b = (NOMBRE *) (*a).arg[0];
    c = (NOMBRE *) (*a).arg[1];

    eb = get_exp (b);
    ec = get_exp (c);

    if ((*a).disp > 0) {
	ja = (*a).expo - (*a).disp;

	s = (int) get_nth(b, eb-ja+1) + (int) get_nth(c, ec-ja+1);
	t = ((s  + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	t = (s-t) / AR_2_15;
	s = (int) get_nth(b, eb-ja) + (int) get_nth(c, ec-ja);
	s = ((s  + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	
	if (((*a).disp % TAILLE)==0) {
	    (*a).calc = (short *) realloc((void *) (*a).calc, ((*a).disp + TAILLE)*sizeof(short));
	};
	(*a).calc[(*a).disp++] = (short) t+s;
	
	if (((((db = get_disp(b))<-1) && (ja<(eb+db+1))) || (db == -1)) &&
	    ((((dc = get_disp(c))<-1) && (ja<(ec+dc+1))) || (dc == -1))) {
	    (*a).disp = - (++(*a).disp);
	    recale_faible(a);
	};
    }
    else {
	(*a).disp = 1;
	(*a).calc = (short *) malloc(TAILLE * (sizeof(short)));
	(*a).calc[0] = 0;
	(*a).expo = max(eb,ec)+2;
	while (((*a).calc[0] == 0)  && ((*a).disp > 0)) {
	    next_add(a);
	    (*a).calc[0] = (*a).calc[1];
	    --(*a).expo;
	    --(*a).disp;
	};
	if ((*a).disp <0) {(*a).disp = -1;};
    };
}

void next_add3 (NOMBRE *a)
{
    NOMBRE *b, *c, *d;
    int eb,ec,ed, db,dc,dd, ja, t,s;
    b = (NOMBRE *) (*a).arg[0];
    c = (NOMBRE *) (*a).arg[1];
    d = (NOMBRE *) (*a).arg[2];

    eb = get_exp (b);
    ec = get_exp (c);
    ed = get_exp (d);

    if ((*a).disp > 0) {
	ja = (*a).expo - (*a).disp;

	s = (int) get_nth(b, eb-ja+1) + (int) get_nth(c, ec-ja+1) + (int) get_nth(d, ed-ja+1);
	t = ((s  + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	t = (s-t) / AR_2_15;
	s = (int) get_nth(b, eb-ja) + (int) get_nth(c, ec-ja) + (int) get_nth(d, ed-ja);
	s = ((s  + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	
	if (((*a).disp % TAILLE)==0) {
	    (*a).calc = (short *) realloc((void *) (*a).calc, ((*a).disp + TAILLE)*sizeof(short));
	};
	(*a).calc[(*a).disp++] = (short) t+s;
	
	if (((((db = get_disp(b))<-1) && (ja<(eb+db+1))) || (db == -1)) &&
	    ((((dc = get_disp(c))<-1) && (ja<(ec+dc+1))) || (dc == -1)) &&
	    ((((dd = get_disp(d))<-1) && (ja<(ed+dd+1))) || (dd == -1))) {
	    (*a).disp = - (++(*a).disp);
	    recale_faible(a);
	};
    }
    else {
	(*a).disp = 1;
	(*a).calc = (short *) malloc(TAILLE * (sizeof(short)));
	(*a).calc[0] = 0;
	(*a).expo = max(eb,max(ec,ed))+2;
	while (((*a).calc[0] == 0)  && ((*a).disp > 0)) {
	    next_add3(a);
	    (*a).calc[0] = (*a).calc[1];
	    --(*a).expo;
	    --(*a).disp;
	};
	if ((*a).disp <0) {(*a).disp = -1;};
    };
}

void next_pmpmpm (NOMBRE *a)
{
    NOMBRE *b, *c, *d, *e, *f, *g;
    int eb,ec,ed,ee,ef,eg, db,dc,dd,de,df,dg, ja, t,s;

    b = (NOMBRE *) (*a).arg[0];    c = (NOMBRE *) (*a).arg[1];
    d = (NOMBRE *) (*a).arg[2];    e = (NOMBRE *) (*a).arg[3];
    f = (NOMBRE *) (*a).arg[4];    g = (NOMBRE *) (*a).arg[5];

    eb = get_exp (b);    ec = get_exp (c);    ed = get_exp (d);
    ee = get_exp (e);    ef = get_exp (f);    eg = get_exp (g);

    if ((*a).disp > 0) {
	ja = (*a).expo - (*a).disp;

	s = (int) get_nth(b, eb-ja+1) -
	    (int) get_nth(c, ec-ja+1) +
	    (int) get_nth(d, ed-ja+1) -
	    (int) get_nth(e, ee-ja+1) +
	    (int) get_nth(f, ef-ja+1) -
	    (int) get_nth(g, eg-ja+1);
	t = ((s + 4*AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	t = (s-t) / AR_2_15;
	s = (int) get_nth(b, eb-ja) -
	    (int) get_nth(c, ec-ja) +
	    (int) get_nth(d, ed-ja) -
	    (int) get_nth(e, ee-ja) +
	    (int) get_nth(f, ef-ja) -
	    (int) get_nth(g, eg-ja);
	s = ((s + 4*AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	
	if (((*a).disp % TAILLE)==0) {
	    (*a).calc = (short *) realloc((void *) (*a).calc, ((*a).disp + TAILLE)*sizeof(short));
	};
	(*a).calc[(*a).disp++] = (short) t+s;
	
	if (((((db = get_disp(b))<-1) && (ja<(eb+db+1))) || (db == -1)) &&
	    ((((dc = get_disp(c))<-1) && (ja<(ec+dc+1))) || (dc == -1)) &&
	    ((((dd = get_disp(d))<-1) && (ja<(ed+dd+1))) || (dd == -1)) &&
	    ((((de = get_disp(e))<-1) && (ja<(ee+de+1))) || (de == -1)) &&
	    ((((df = get_disp(f))<-1) && (ja<(ef+df+1))) || (df == -1)) &&
	    ((((dg = get_disp(g))<-1) && (ja<(eg+dg+1))) || (dg == -1))) {
	    (*a).disp = - (++(*a).disp);
	    recale_faible(a);
	};
    }
    else {
	(*a).disp = 1;
	(*a).calc = (short *) malloc(TAILLE * (sizeof(short)));
	(*a).calc[0] = 0;
	(*a).expo = max(max(eb,ec),max(max(ed,ee),max(ef,eg)))+2;
	while (((*a).calc[0] == 0)  && ((*a).disp > 0)) {
	    next_pmpmpm(a);
	    (*a).calc[0] = (*a).calc[1];
	    --(*a).expo;
	    --(*a).disp;
	};
	if ((*a).disp <0) {(*a).disp = -1;};
    };
}

void next_addn (NOMBRE *a)
{
    int d,e, i,ja, t, s,ss,bool;
    int n = (int) (*a).arg[0];
    NOMBRE *N;

    if ((*a).disp > 0) {
	ja = (*a).expo - (*a).disp;

	for (i=1, ss=s=0;i<=n;++i) {
	    N = (NOMBRE *) (*a).arg[i];
	    e = get_exp(N);
	    s += (int) get_nth(N, e-ja+1);
	    ss += (int) get_nth(N, e-ja);
	};
	t = ((s  + n*AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	t = (s-t) / AR_2_15;
	s = ((ss  + n*AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	
	if (((*a).disp % TAILLE)==0) {
	    (*a).calc = (short *) realloc((void *) (*a).calc, ((*a).disp + TAILLE)*sizeof(short));
	};
	(*a).calc[(*a).disp++] = (short) t+s;
	
	for (i=1, bool=1; (i<=n) && bool; ++i) {
	    bool = bool && ((((d = get_disp((NOMBRE *) (*a).arg[i]))<-1) && (ja<(get_exp((NOMBRE *) (*a).arg[i])+d+1))) || (d == -1));};
	if (bool == 1) {
	    (*a).disp = - (++(*a).disp);
	    recale_faible(a);
	};
    }
    else {
	(*a).disp = 1;
	(*a).calc = (short *) malloc(TAILLE * (sizeof(short)));
	(*a).calc[0] = 0;
	ja = get_exp((NOMBRE *) (*a).arg[1]);
	for (i=2;i<=n;++i) { ja = max (ja,get_exp((NOMBRE *) (*a).arg[i]));};
	(*a).expo = ja+2;
	while (((*a).calc[0] == 0)  && ((*a).disp > 0)) {
	    next_addn(a);
	    (*a).calc[0] = (*a).calc[1];
	    --(*a).expo;
	    --(*a).disp;
	};
	if ((*a).disp <0) {(*a).disp = -1;};
    };
}

void next_sub (NOMBRE *a)
{
    NOMBRE *b, *c;
    int eb,ec, db,dc, ja, t,s;
    b = (NOMBRE *) (*a).arg[0];
    c = (NOMBRE *) (*a).arg[1];

    eb = get_exp (b);
    ec = get_exp (c);

    if ((*a).disp > 0) {
	ja = (*a).expo - (*a).disp;

	s = (int) get_nth(b, eb-ja+1) - (int) get_nth(c, ec-ja+1);
	t = ((s  + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	t = (s-t) / AR_2_15;
	s = (int) get_nth(b, eb-ja) - (int) get_nth(c, ec-ja);
	s = ((s  + AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	
	if (((*a).disp % TAILLE)==0) {
	    (*a).calc = (short *) realloc((void *) (*a).calc, ((*a).disp + TAILLE)*sizeof(short));
	};
	(*a).calc[(*a).disp++] = (short) t+s;
	
	if (((((db = get_disp(b))<-1) && (ja<(eb+db+1))) || (db == -1)) &&
	    ((((dc = get_disp(c))<-1) && (ja<(ec+dc+1))) || (dc == -1))) {
	    (*a).disp = - (++(*a).disp);
	    recale_faible(a);
	};
    }
    else {
	(*a).disp = 1;
	(*a).calc = (short *) malloc(TAILLE * (sizeof(short)));
	(*a).calc[0] = 0;
	(*a).expo = max(eb,ec)+2;
	while (((*a).calc[0] == 0)  && ((*a).disp > 0)) {
	    next_sub(a);
	    (*a).calc[0] = (*a).calc[1];
	    --(*a).expo;
	    --(*a).disp;
	};
	if ((*a).disp <0) {(*a).disp = -1;};
    };
}

void next_mul (NOMBRE *c)
{
    NOMBRE *a,*b;
    int ea,eb;
    int *w, *z;

    a = (NOMBRE *) (*c).arg[0];
    b = (NOMBRE *) (*c).arg[1];

    ea = get_exp(a);
    eb = get_exp(b);

    if ((*c).disp == 0) {
	if ((get_disp(a) == -1) || (get_disp(b) == -1)) {(*c).disp = -1;}
	else {
	    w = (int *) malloc(3*sizeof(int));
	    w[0] = w[1] = w[2] = 0;
	    (*c).arg[2] = w;
	    (*c).disp = 1;
	    (*c).calc = (short *) malloc(TAILLE * (sizeof(short)));
	    (*c).calc[0] = 0;
	    (*c).expo = ea+eb+2;
	    while ((*c).calc[0] == 0) {
		next_mul(c);
		(*c).calc[0] = (*c).calc[1];
		--(*c).expo;
		(*c).disp = 1;
	    };
	};
    }
    else {
	int j,k,aj,bj,cj,da,db;
	int zz=0;

	j = (*c).disp + (ea+eb-(*c).expo)+1;
	w = (int *) (*c).arg[2];
	z = (int *) malloc((j+4)*sizeof(int));

	aj = get_nth(a,j);
	bj = get_nth(b,j);

	for (k=j+2; k>-2; --k) {
	    zz += ((k<=j) ? w[k+2] : 0) + ((k>1) ? (get_nth(a,k-2) * bj + ((k<=j+1) ? get_nth(b,k-2) : 0) * aj) :0);
	    z[k+1] = (((zz % AR_2_15)+ AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	    zz = (zz - z[k+1]) / AR_2_15;
	};

	if ((zz != 0) || (z[0] != 0)) {printf ("Erreur possible!\a\n");};

	free(w);
	(*c).arg[2] = z;
	cj = z[1];
	z[1] = 0;

	if (((*c).disp % TAILLE)==0) {
	    (*c).calc = (short *) realloc((void *) (*c).calc, ((*c).disp + TAILLE)*sizeof(short));
	};
	
	(*c).calc[(*c).disp++] = cj;
	
	if (((da = get_disp(a)) < 0) &&
	    ((db = get_disp(b)) < 0) &&
	    (((*c).expo - (*c).disp)<(ea+da+eb+db+3))) {
	    (*c).disp = -(++(*c).disp);
	    recale_faible(c);
	};
    };
}

void next_mul3 (NOMBRE *d)
{
    NOMBRE *a,*b,*c;
    int ea,eb,ec;
    int *w, *ab, *bc, *ac, *z;

    a = (NOMBRE *) (*d).arg[0];
    b = (NOMBRE *) (*d).arg[1];
    c = (NOMBRE *) (*d).arg[2];

    ea = get_exp(a);
    eb = get_exp(b);
    ec = get_exp(c);

    if ((*d).disp == 0) {
	if ((get_disp(a) == -1) || (get_disp(b) == -1) || (get_disp(c) == -1)) {(*d).disp = -1;}
	else {
	    w  = (int *) ((*d).arg[3] = malloc(3*sizeof(int)));
	    ab = (int *) ((*d).arg[4] = malloc(3*sizeof(int)));
	    ac = (int *) ((*d).arg[5] = malloc(sizeof(int)));
	    (*d).arg[6] = NULL;
	    ac[0] = ab[0] = ab[1] = ab[2] = w[0] = w[1] = w[2] = 0;
	    (*d).disp = 1;
	    (*d).calc = (short *) malloc(TAILLE * (sizeof(short)));
	    (*d).calc[0] = 0;
	    (*d).expo = ea+eb+ec+2;
	    while ((*d).calc[0] == 0) {
		next_mul3(d);
		(*d).calc[0] = (*d).calc[1];
		--(*d).expo;
		(*d).disp = 1;
	    };
	};
    }
    else {
	int j,k,aj,bj,cj,bj1,cj1,dj,zz,da,db,dc;
	int *aa, *bb;

	j  = (*d).disp + (ea+eb+ec-(*d).expo)+1;
	w  = (int *) (*d).arg[3];
	ab = (int *) (*d).arg[4];
	ac = (int *) (*d).arg[5];
	bc = (int *) (*d).arg[6];

	aj  = get_nth(a,j);
	bj  = get_nth(b,j);
	cj  = get_nth(c,j);
	bj1 = get_nth(b,j-1);
	cj1 = get_nth(c,j-1);

	aa = (int *) malloc((2*j+5)*sizeof(int));

	for (k=2*j+2, zz=0; k>=0; --k) {
	    zz += ((k<=2*j) ? ab[k] : 0) + get_nth(a,k-j-2)*bj + ((k<2*j+2) ? get_nth(b,k-j-2)*aj : 0);
	    aa[k] = (((zz % AR_2_15)+ AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	    zz = (zz - aa[k]) / AR_2_15;
	};

	bb = ab; ab = aa; aa = bb;

	for (k=2*j+1, zz=0; k>=0; --k) {
	    zz += ((k<2*j) ? ac[k] : 0) + get_nth(a,k-j-1)*cj1 + ((k<=2*j) ? get_nth(c,k-j-2)*aj : 0);
	    aa[k] = (((zz % AR_2_15)+ AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	    zz = (zz - aa[k]) / AR_2_15;
	};

	bb = ac; ac = aa; aa = bb;

	for (k=2*j, zz=0; k>=0; --k) {
	    zz += ((k<2*j-1) ? bc[k] : 0) + (((k<=2*j) && (k>j)) ? get_nth(b,k-j-1)*cj1 + ((k<2*j) ? get_nth(c,k-j-1)*bj1 :0):0);
	    aa[k] = (((zz % AR_2_15)+ AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	    zz = (zz - aa[k]) / AR_2_15;
	};

	free(bc);
	bc = aa;
	z = (int *) malloc((2*j+5)*sizeof(int));

	for (k=2*j+4,zz=0; k>=0; --k) {
	    zz += ((k<=2*j+1) ? w[k+1] : 0) + ((k>=2) ? ab[k-2]*cj + ((k<2*j+4) ? ac[k-2]*bj + ((k<2*j+3) ? bc[k-2]*aj :0) :0) : 0);
 	    z[k] = (((zz % AR_2_15)+ AR_2_16 + AR_2_14) % AR_2_15) - AR_2_14;
	    zz = (zz - z[k]) / AR_2_15;
	};

 	if ((zz   != 0) || (z[0] != 0)) {printf ("Erreur possible!\a\n");};

	free(w);
	(*d).arg[3] = z;
	(*d).arg[4] = ab;
	(*d).arg[5] = ac;
	(*d).arg[6] = aa;

	dj = z[1];
	z[1] = 0;

	if (((*d).disp % TAILLE)==0) {
	    (*d).calc = (short *) realloc((void *) (*d).calc, ((*d).disp + TAILLE)*sizeof(short));
	};
	
	(*d).calc[(*d).disp++] = dj;
	
	if (((da = get_disp(a)) < 0) &&
	    ((db = get_disp(b)) < 0) &&
	    ((dc = get_disp(c)) < 0) &&
	    (((*d).expo-(*d).disp) < (ea+da+eb+db+ec+dc+4))) {
	    (*d).disp = -(++(*d).disp);
	    recale_faible(d);
 	};
    };
}
