			/* Arithmetique  Redondante */
			/* Sylvain Pion, Juillet 95 */

/* les 3 lignes qui suivent servent uniquement a la compatibilite gcc & CC */

#define malloc(a) (char*) malloc(a)
#define free(a)     free((char *) (a))
#define realloc(a,b) (char *) realloc((char *) (a),b)

typedef struct nombre {
	int	op, disp, expo;    /* # d'operation, disponibilite, exposant */
	void	**arg;		   /* pointe les arguments */
	short	*calc;		   /* contient ce qui est deja calcule */
} NOMBRE;

typedef union {
        double d;
        struct { unsigned long i0, i1;} i;
        struct { unsigned short s0, s1, s2, s3;} s;
} FLOT;

#define DBL	 0
#define MINUS	 1
#define SUB      2
#define ADD	 3
#define ADD3     4
#define ADDn     5
#define PMPMPM   6
#define SHIFT    7
#define TRUNC    8
#define MUL	 9
#define MUL3     10
#define MUL_DIG  11

#define TAILLE   8                     /* Allocation des digits par paquets de taille TAILLE */
#define max(a,b) (((a)>(b)) ? (a) : (b))
#define min(a,b) (((a)<(b)) ? (a) : (b))
#define sig(a)   (((a)==0) ? 0 : (((a)>0) ? 1 : -1))

#define AR_2_14 (1024*16)		/* 2^14 */
#define AR_2_15 (1024*32)		/* 2^15 */
#define AR_2_16 (1024*64)		/* 2^16 */
#define AR_2_30 (AR_2_15*1024.0*32.0)	/* 2^30 */
#define AR_2_45 (AR_2_30*1024.0*32.0)	/* 2^45 */
#define AR_2_52 (AR_2_45*128.0)		/* 2^52 */


NOMBRE *init_1       (int oper, int interne, void *a);
NOMBRE *init_2       (int oper, int interne, void *a, void *b);
NOMBRE *init_3       (int oper, int interne, void *a, void *b, void *c);
NOMBRE *init_6       (int oper, int interne, void *a, void *b, void *c, void *d, void *e, void *f);
NOMBRE *init_n       (int oper, int interne, void *a);
NOMBRE *init_mixt    (int oper, int interne, void *a, int b);


#define AR_minus(a)	  init_1 (MINUS, 0, a)
#define AR_dbl(a)	  init_1 (DBL, 0, a)
#define AR_add(a,b)	  init_2 (ADD, 0, a, b) 
#define AR_add3(a,b,c)    init_3 (ADD3, 0, a, b, c)
#define AR_addn(a)        init_n (ADDn, 0, a)
#define AR_pmpmpm(a,b,c,d,e,f) init_6 (PMPMPM, 0, a,b,c,d,e,f)
#define AR_sub(a,b)	  init_2 (SUB, 0, a, b) 
#define AR_mul(a,b)	  init_2 (MUL, 1, a, b)
#define AR_mul3(a,b,c)    init_3 (MUL3, 4, a, b, c)

#define AR_mul_dig(a,b) init_mixt (MUL_DIG, 0, a, b)
#define AR_shift(a,b)   init_mixt (SHIFT, 0, a, b)
#define AR_trunc(a,b)   init_mixt (TRUNC, 0, a, b)


short	get_sign     (NOMBRE *a);
int     get_exp      (NOMBRE *a);
int     get_disp     (NOMBRE *a);
short	get_nth      (NOMBRE *a, int n);

void    AR_flush     (NOMBRE *a);
void    AR_free      (NOMBRE *a);
void    AR_free_rec  (NOMBRE *a);
void    recale_fort  (NOMBRE *a);
void    recale_faible (NOMBRE *a);

void	next_step    (NOMBRE *a);
void    next_dbl     (NOMBRE *a);
void    next_int     (NOMBRE *a);
void    next_add     (NOMBRE *a);
void    next_sub     (NOMBRE *a);
void    next_add3    (NOMBRE *a);
void    next_addn    (NOMBRE *a);
void    next_pmpmpm  (NOMBRE *a);
void    next_mul     (NOMBRE *a);
void    next_mul_dig (NOMBRE *a);
void    next_mul3    (NOMBRE *a);

void    AR_affiche   (NOMBRE *a);
