	/* Calcule sgn(a*d-b*c), de maniere exacte, avec des doubles */
	/* Sylvain Pion, le 28/6/95 */

#include <stdio.h>

#define DEC 3.0*256.0*1024.0*1024.0*1024.0*1024.0*1024.0*1024.0*1024.0
							/* 3.2^78 */
#define DEC2 DEC*1024.0*1024.0*128.0			/* 3.2^(78+27) */

#define deco(a,a1,a2,t) a2 = a - (a1 = (a + t) - t)
#define decomp(x,y,z)  deco(x,y,z,DEC)
#define decomp2(x,y,z) deco(x,y,z,DEC2)

int signe(double a, double b, double c, double d)
{
	double g;

	g = (a*d)-(b*c);

	if (g != 0)	{return( (g>0) ? 1 : -1 );}
	else {
		double a1,a2, b1,b2, c1,c2, d1,d2, x,y;

		decomp (a,a1,a2);
		decomp (b,b1,b2);
		decomp (c,c1,c2);
		decomp (d,d1,d2);

		g = (a1*d1) - (b1*c1);
		x = (a2*d1) + (a1*d2);
		y = (b2*c1) + (b1*c2);

		decomp2(x,a1,b1);
		decomp2(y,c1,d1);

		g += a1 - c1;
		g += b1 - d1;
		g += ((a2*d2)-(b2*c2));

		if (g>0) {return 1;}
		else {return( (g<0) ? -1 : 0 );};
	};
}
