#include "prims.h"


Point3d::Point3d(const integer x, const integer y, const integer z){
(*this).x = x;
(*this).y = y;
(*this).z = z;
} /* adds=0 multiplies=0 normalizes=0 */


Point2d::Point2d(const integer x, const integer y){
(*this).x = x;
(*this).y = y;
} /* adds=0 multiplies=0 normalizes=0 */


Point4d::Point4d(const integer x, const integer y, const integer z, const integer w){
(*this).x = x;
(*this).y = y;
(*this).z = z;
(*this).w = w;
} /* adds=0 multiplies=0 normalizes=0 */


Plane::Plane(const integer a, const integer b, const integer c, const integer d){
(*this).a = a;
(*this).b = b;
(*this).c = c;
(*this).d = d;
} /* adds=0 multiplies=0 normalizes=0 */


integer orient2d(const Point2d& a, const Point2d& b, const Point2d& c){
integer LNans;
LNt[1] = (a.x-c.x)*(b.y-c.y)-(b.x-c.x)*(a.y-c.y);
if (-LNP2[59]<LNt[1] && LNt[1]<LNP2[59]) {	/* the high order 50 bits of 109 are accurate */
  LNt[2] = a.x;
  LNt[3] = float(LNP2x3[74]+LNt[2])-LNP2x3[74];	//[1,53]<<0
  LNt[2] -= LNt[3];
  LNt[4] = c.x;
  LNt[5] = float(LNP2x3[74]+LNt[4])-LNP2x3[74];	//[1,53]<<0
  LNt[4] -= LNt[5];
  LNt[6] = LNt[2]-LNt[4];
  LNt[7] = float(LNP2x3[53]+LNt[6])-LNP2x3[53];	//[22,53]<<0
  LNt[6] -= LNt[7];
  LNt[8] = float(LNP2x3[45]+LNt[6])-LNP2x3[45];	//[8,31]<<0
  LNt[6] -= LNt[8];
  LNt[9] = LNt[3]-LNt[5]+LNt[7]+LNt[8];
  LNt[10] = float(LNP2x3[68]+LNt[9])-LNP2x3[68];	//[7,30]<<23
  LNt[9] -= LNt[10];
  LNt[11] = b.y;
  LNt[12] = float(LNP2x3[74]+LNt[11])-LNP2x3[74];	//[1,53]<<0
  LNt[11] -= LNt[12];
  LNt[13] = c.y;
  LNt[14] = float(LNP2x3[74]+LNt[13])-LNP2x3[74];	//[1,53]<<0
  LNt[13] -= LNt[14];
  LNt[15] = LNt[11]-LNt[13];
  LNt[16] = float(LNP2x3[53]+LNt[15])-LNP2x3[53];	//[22,53]<<0
  LNt[15] -= LNt[16];
  LNt[17] = float(LNP2x3[45]+LNt[15])-LNP2x3[45];	//[8,31]<<0
  LNt[15] -= LNt[17];
  LNt[18] = LNt[12]-LNt[14]+LNt[16]+LNt[17];
  LNt[19] = float(LNP2x3[68]+LNt[18])-LNP2x3[68];	//[7,30]<<23
  LNt[18] -= LNt[19];
  LNt[20] = b.x;
  LNt[21] = float(LNP2x3[74]+LNt[20])-LNP2x3[74];	//[1,53]<<0
  LNt[20] -= LNt[21];
  LNt[22] = LNt[20]-LNt[4];
  LNt[23] = float(LNP2x3[53]+LNt[22])-LNP2x3[53];	//[22,53]<<0
  LNt[22] -= LNt[23];
  LNt[24] = float(LNP2x3[45]+LNt[22])-LNP2x3[45];	//[8,31]<<0
  LNt[22] -= LNt[24];
  LNt[25] = LNt[21]-LNt[5]+LNt[23]+LNt[24];
  LNt[26] = float(LNP2x3[68]+LNt[25])-LNP2x3[68];	//[7,30]<<23
  LNt[25] -= LNt[26];
  LNt[27] = a.y;
  LNt[28] = float(LNP2x3[74]+LNt[27])-LNP2x3[74];	//[1,53]<<0
  LNt[27] -= LNt[28];
  LNt[29] = LNt[27]-LNt[13];
  LNt[30] = float(LNP2x3[53]+LNt[29])-LNP2x3[53];	//[22,53]<<0
  LNt[29] -= LNt[30];
  LNt[31] = float(LNP2x3[45]+LNt[29])-LNP2x3[45];	//[8,31]<<0
  LNt[29] -= LNt[31];
  LNt[32] = LNt[28]-LNt[14]+LNt[30]+LNt[31];
  LNt[33] = float(LNP2x3[68]+LNt[32])-LNP2x3[68];	//[7,30]<<23
  LNt[32] -= LNt[33];
  LNt[34] = LNt[6]*LNt[19]+LNt[9]*LNt[18]+LNt[10]*LNt[15]-(LNt[22]*LNt[33]+LNt[25]*LNt[32]+LNt[26]*LNt[29]);
  LNt[35] = LNt[6]*LNt[15]-LNt[22]*LNt[29];
  LNt[36] = LNt[6]*LNt[18]+LNt[9]*LNt[15]-(LNt[22]*LNt[32]+LNt[25]*LNt[29]);
  LNt[37] = LNt[9]*LNt[19]+LNt[10]*LNt[18]-(LNt[25]*LNt[33]+LNt[26]*LNt[32]);
  LNt[38] = LNt[10]*LNt[19]-LNt[26]*LNt[33];
  LNt[1] = (((((LNt[38])+LNt[37])+LNt[34])+LNt[36])+LNt[35]);
}
if (LNt[1]<0){
  LNt[0] = -1.;
}else{
  if (LNt[1]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=38 multiplies=20 normalizes=18 */


int LN_det2x2(double ax, double ay, double bx, double by){
integer LNans;
LNt[1] = ax*by-ay*bx;
if (-LNP2[56]<LNt[1] && LNt[1]<LNP2[56]) {	/* the high order 51 bits of 107 are accurate */
  LNt[2] = ax;
  LNt[3] = float(LNP2x3[53]+LNt[2])-LNP2x3[53];	//[22,53]<<0
  LNt[2] -= LNt[3];
  LNt[4] = float(LNP2x3[45]+LNt[2])-LNP2x3[45];	//[8,31]<<0
  LNt[2] -= LNt[4];
  LNt[5] = LNt[3]+LNt[4];
  LNt[6] = float(LNP2x3[68]+LNt[5])-LNP2x3[68];	//[7,30]<<23
  LNt[5] -= LNt[6];
  LNt[7] = by;
  LNt[8] = float(LNP2x3[53]+LNt[7])-LNP2x3[53];	//[22,53]<<0
  LNt[7] -= LNt[8];
  LNt[9] = float(LNP2x3[45]+LNt[7])-LNP2x3[45];	//[8,31]<<0
  LNt[7] -= LNt[9];
  LNt[10] = LNt[8]+LNt[9];
  LNt[11] = float(LNP2x3[68]+LNt[10])-LNP2x3[68];	//[7,30]<<23
  LNt[10] -= LNt[11];
  LNt[12] = ay;
  LNt[13] = float(LNP2x3[53]+LNt[12])-LNP2x3[53];	//[22,53]<<0
  LNt[12] -= LNt[13];
  LNt[14] = float(LNP2x3[45]+LNt[12])-LNP2x3[45];	//[8,31]<<0
  LNt[12] -= LNt[14];
  LNt[15] = LNt[13]+LNt[14];
  LNt[16] = float(LNP2x3[68]+LNt[15])-LNP2x3[68];	//[7,30]<<23
  LNt[15] -= LNt[16];
  LNt[17] = bx;
  LNt[18] = float(LNP2x3[53]+LNt[17])-LNP2x3[53];	//[22,53]<<0
  LNt[17] -= LNt[18];
  LNt[19] = float(LNP2x3[45]+LNt[17])-LNP2x3[45];	//[8,31]<<0
  LNt[17] -= LNt[19];
  LNt[20] = LNt[18]+LNt[19];
  LNt[21] = float(LNP2x3[68]+LNt[20])-LNP2x3[68];	//[7,30]<<23
  LNt[20] -= LNt[21];
  LNt[22] = LNt[2]*LNt[11]+LNt[5]*LNt[10]+LNt[6]*LNt[7]-(LNt[12]*LNt[21]+LNt[15]*LNt[20]+LNt[16]*LNt[17]);
  LNt[23] = LNt[2]*LNt[7]-LNt[12]*LNt[17];
  LNt[24] = LNt[2]*LNt[10]+LNt[5]*LNt[7]-(LNt[12]*LNt[20]+LNt[15]*LNt[17]);
  LNt[25] = LNt[5]*LNt[11]+LNt[6]*LNt[10]-(LNt[15]*LNt[21]+LNt[16]*LNt[20]);
  LNt[26] = LNt[6]*LNt[11]-LNt[16]*LNt[21];
  LNt[1] = (((((LNt[26])+LNt[25])+LNt[22])+LNt[24])+LNt[23]);
}
if (LNt[1]<0){
  LNt[0] = -1.;
}else{
  if (LNt[1]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return (int) LNans;
} /* adds=22 multiplies=20 normalizes=12 */

integer horient2d(const Point2d& a, const Point2d& b){
integer LNans;
LNt[1] = a.x*b.y-a.y*b.x;
if (-LNP2[56]<LNt[1] && LNt[1]<LNP2[56]) {	/* the high order 51 bits of 107 are accurate */
  LNt[2] = a.x;
  LNt[3] = float(LNP2x3[53]+LNt[2])-LNP2x3[53];	//[22,53]<<0
  LNt[2] -= LNt[3];
  LNt[4] = float(LNP2x3[45]+LNt[2])-LNP2x3[45];	//[8,31]<<0
  LNt[2] -= LNt[4];
  LNt[5] = LNt[3]+LNt[4];
  LNt[6] = float(LNP2x3[68]+LNt[5])-LNP2x3[68];	//[7,30]<<23
  LNt[5] -= LNt[6];
  LNt[7] = b.y;
  LNt[8] = float(LNP2x3[53]+LNt[7])-LNP2x3[53];	//[22,53]<<0
  LNt[7] -= LNt[8];
  LNt[9] = float(LNP2x3[45]+LNt[7])-LNP2x3[45];	//[8,31]<<0
  LNt[7] -= LNt[9];
  LNt[10] = LNt[8]+LNt[9];
  LNt[11] = float(LNP2x3[68]+LNt[10])-LNP2x3[68];	//[7,30]<<23
  LNt[10] -= LNt[11];
  LNt[12] = a.y;
  LNt[13] = float(LNP2x3[53]+LNt[12])-LNP2x3[53];	//[22,53]<<0
  LNt[12] -= LNt[13];
  LNt[14] = float(LNP2x3[45]+LNt[12])-LNP2x3[45];	//[8,31]<<0
  LNt[12] -= LNt[14];
  LNt[15] = LNt[13]+LNt[14];
  LNt[16] = float(LNP2x3[68]+LNt[15])-LNP2x3[68];	//[7,30]<<23
  LNt[15] -= LNt[16];
  LNt[17] = b.x;
  LNt[18] = float(LNP2x3[53]+LNt[17])-LNP2x3[53];	//[22,53]<<0
  LNt[17] -= LNt[18];
  LNt[19] = float(LNP2x3[45]+LNt[17])-LNP2x3[45];	//[8,31]<<0
  LNt[17] -= LNt[19];
  LNt[20] = LNt[18]+LNt[19];
  LNt[21] = float(LNP2x3[68]+LNt[20])-LNP2x3[68];	//[7,30]<<23
  LNt[20] -= LNt[21];
  LNt[22] = LNt[2]*LNt[11]+LNt[5]*LNt[10]+LNt[6]*LNt[7]-(LNt[12]*LNt[21]+LNt[15]*LNt[20]+LNt[16]*LNt[17]);
  LNt[23] = LNt[2]*LNt[7]-LNt[12]*LNt[17];
  LNt[24] = LNt[2]*LNt[10]+LNt[5]*LNt[7]-(LNt[12]*LNt[20]+LNt[15]*LNt[17]);
  LNt[25] = LNt[5]*LNt[11]+LNt[6]*LNt[10]-(LNt[15]*LNt[21]+LNt[16]*LNt[20]);
  LNt[26] = LNt[6]*LNt[11]-LNt[16]*LNt[21];
  LNt[1] = (((((LNt[26])+LNt[25])+LNt[22])+LNt[24])+LNt[23]);
}
if (LNt[1]<0){
  LNt[0] = -1.;
}else{
  if (LNt[1]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=22 multiplies=20 normalizes=12 */


integer orient3d(const Point3d& a, const Point3d& b, const Point3d& c, const Point3d& d){
integer LNans;
LNt[1] = a.y-c.y;
LNt[2] = a.z-d.z;
LNt[3] = a.z-c.z;
LNt[4] = a.y-d.y;
LNt[5] = a.x-c.x;
LNt[6] = a.x-d.x;
LNt[7] = (a.x-b.x)*(LNt[1]*LNt[2]-LNt[3]*LNt[4])-(a.y-b.y)*(LNt[5]*LNt[2]-LNt[3]*LNt[6])+(a.z-b.z)*(LNt[5]*LNt[4]-LNt[1]*LNt[6]);
if (-LNP2[118]<LNt[7] && LNt[7]<LNP2[118]) {	/* the high order 47 bits of 165 are accurate */
  LNt[8] = a.x;
  LNt[9] = float(LNP2x3[74]+LNt[8])-LNP2x3[74];	//[1,53]<<0
  LNt[8] -= LNt[9];
  LNt[10] = b.x;
  LNt[11] = float(LNP2x3[74]+LNt[10])-LNP2x3[74];	//[1,53]<<0
  LNt[10] -= LNt[11];
  LNt[12] = LNt[8]-LNt[10];
  LNt[13] = float(LNP2x3[53]+LNt[12])-LNP2x3[53];	//[22,53]<<0
  LNt[12] -= LNt[13];
  LNt[14] = float(LNP2x3[45]+LNt[12])-LNP2x3[45];	//[8,31]<<0
  LNt[12] -= LNt[14];
  LNt[15] = LNt[9]-LNt[11]+LNt[13]+LNt[14];
  LNt[16] = float(LNP2x3[68]+LNt[15])-LNP2x3[68];	//[7,30]<<23
  LNt[15] -= LNt[16];
  LNt[17] = a.y;
  LNt[18] = float(LNP2x3[74]+LNt[17])-LNP2x3[74];	//[1,53]<<0
  LNt[17] -= LNt[18];
  LNt[19] = c.y;
  LNt[20] = float(LNP2x3[74]+LNt[19])-LNP2x3[74];	//[1,53]<<0
  LNt[19] -= LNt[20];
  LNt[21] = LNt[17]-LNt[19];
  LNt[22] = float(LNP2x3[53]+LNt[21])-LNP2x3[53];	//[22,53]<<0
  LNt[21] -= LNt[22];
  LNt[23] = float(LNP2x3[45]+LNt[21])-LNP2x3[45];	//[8,31]<<0
  LNt[21] -= LNt[23];
  LNt[24] = LNt[18]-LNt[20]+LNt[22]+LNt[23];
  LNt[25] = float(LNP2x3[68]+LNt[24])-LNP2x3[68];	//[7,30]<<23
  LNt[24] -= LNt[25];
  LNt[26] = a.z;
  LNt[27] = float(LNP2x3[74]+LNt[26])-LNP2x3[74];	//[1,53]<<0
  LNt[26] -= LNt[27];
  LNt[28] = d.z;
  LNt[29] = float(LNP2x3[74]+LNt[28])-LNP2x3[74];	//[1,53]<<0
  LNt[28] -= LNt[29];
  LNt[30] = LNt[26]-LNt[28];
  LNt[31] = float(LNP2x3[53]+LNt[30])-LNP2x3[53];	//[22,53]<<0
  LNt[30] -= LNt[31];
  LNt[32] = float(LNP2x3[45]+LNt[30])-LNP2x3[45];	//[8,31]<<0
  LNt[30] -= LNt[32];
  LNt[33] = LNt[27]-LNt[29]+LNt[31]+LNt[32];
  LNt[34] = float(LNP2x3[68]+LNt[33])-LNP2x3[68];	//[7,30]<<23
  LNt[33] -= LNt[34];
  LNt[35] = c.z;
  LNt[36] = float(LNP2x3[74]+LNt[35])-LNP2x3[74];	//[1,53]<<0
  LNt[35] -= LNt[36];
  LNt[37] = LNt[26]-LNt[35];
  LNt[38] = float(LNP2x3[53]+LNt[37])-LNP2x3[53];	//[22,53]<<0
  LNt[37] -= LNt[38];
  LNt[39] = float(LNP2x3[45]+LNt[37])-LNP2x3[45];	//[8,31]<<0
  LNt[37] -= LNt[39];
  LNt[40] = LNt[27]-LNt[36]+LNt[38]+LNt[39];
  LNt[41] = float(LNP2x3[68]+LNt[40])-LNP2x3[68];	//[7,30]<<23
  LNt[40] -= LNt[41];
  LNt[42] = d.y;
  LNt[43] = float(LNP2x3[74]+LNt[42])-LNP2x3[74];	//[1,53]<<0
  LNt[42] -= LNt[43];
  LNt[44] = LNt[17]-LNt[42];
  LNt[45] = float(LNP2x3[53]+LNt[44])-LNP2x3[53];	//[22,53]<<0
  LNt[44] -= LNt[45];
  LNt[46] = float(LNP2x3[45]+LNt[44])-LNP2x3[45];	//[8,31]<<0
  LNt[44] -= LNt[46];
  LNt[47] = LNt[18]-LNt[43]+LNt[45]+LNt[46];
  LNt[48] = float(LNP2x3[68]+LNt[47])-LNP2x3[68];	//[7,30]<<23
  LNt[47] -= LNt[48];
  LNt[49] = LNt[21]*LNt[34]+LNt[24]*LNt[33]+LNt[25]*LNt[30]-(LNt[37]*LNt[48]+LNt[40]*LNt[47]+LNt[41]*LNt[44]);
  LNt[50] = LNt[21]*LNt[30]-LNt[37]*LNt[44];
  LNt[51] = float(LNP2x3[47]+LNt[50])-LNP2x3[47];	//[22,47]<<0
  LNt[50] -= LNt[51];
  LNt[52] = float(LNP2x3[45]+LNt[50])-LNP2x3[45];	//[2,25]<<0
  LNt[50] -= LNt[52];
  LNt[53] = LNt[21]*LNt[33]+LNt[24]*LNt[30]-(LNt[37]*LNt[47]+LNt[40]*LNt[44])+LNt[51]+LNt[52];
  LNt[54] = float(LNP2x3[71]+LNt[53])-LNP2x3[71];	//[22,48]<<23
  LNt[53] -= LNt[54];
  LNt[55] = float(LNP2x3[68]+LNt[53])-LNP2x3[68];	//[3,26]<<23
  LNt[53] -= LNt[55];
  LNt[56] = LNt[49]+LNt[54]+LNt[55];
  LNt[57] = float(LNP2x3[95]+LNt[56])-LNP2x3[95];	//[22,49]<<46
  LNt[56] -= LNt[57];
  LNt[58] = float(LNP2x3[91]+LNt[56])-LNP2x3[91];	//[4,27]<<46
  LNt[56] -= LNt[58];
  LNt[59] = LNt[24]*LNt[34]+LNt[25]*LNt[33]-(LNt[40]*LNt[48]+LNt[41]*LNt[47])+LNt[57]+LNt[58];
  LNt[60] = float(LNP2x3[114]+LNt[59])-LNP2x3[114];	//[9,32]<<69
  LNt[59] -= LNt[60];
  LNt[61] = LNt[25]*LNt[34]-LNt[41]*LNt[48]+LNt[60];
  LNt[62] = b.y;
  LNt[63] = float(LNP2x3[74]+LNt[62])-LNP2x3[74];	//[1,53]<<0
  LNt[62] -= LNt[63];
  LNt[64] = LNt[17]-LNt[62];
  LNt[65] = float(LNP2x3[53]+LNt[64])-LNP2x3[53];	//[22,53]<<0
  LNt[64] -= LNt[65];
  LNt[66] = float(LNP2x3[45]+LNt[64])-LNP2x3[45];	//[8,31]<<0
  LNt[64] -= LNt[66];
  LNt[67] = LNt[18]-LNt[63]+LNt[65]+LNt[66];
  LNt[68] = float(LNP2x3[68]+LNt[67])-LNP2x3[68];	//[7,30]<<23
  LNt[67] -= LNt[68];
  LNt[69] = c.x;
  LNt[70] = float(LNP2x3[74]+LNt[69])-LNP2x3[74];	//[1,53]<<0
  LNt[69] -= LNt[70];
  LNt[71] = LNt[8]-LNt[69];
  LNt[72] = float(LNP2x3[53]+LNt[71])-LNP2x3[53];	//[22,53]<<0
  LNt[71] -= LNt[72];
  LNt[73] = float(LNP2x3[45]+LNt[71])-LNP2x3[45];	//[8,31]<<0
  LNt[71] -= LNt[73];
  LNt[74] = LNt[9]-LNt[70]+LNt[72]+LNt[73];
  LNt[75] = float(LNP2x3[68]+LNt[74])-LNP2x3[68];	//[7,30]<<23
  LNt[74] -= LNt[75];
  LNt[76] = d.x;
  LNt[77] = float(LNP2x3[74]+LNt[76])-LNP2x3[74];	//[1,53]<<0
  LNt[76] -= LNt[77];
  LNt[78] = LNt[8]-LNt[76];
  LNt[79] = float(LNP2x3[53]+LNt[78])-LNP2x3[53];	//[22,53]<<0
  LNt[78] -= LNt[79];
  LNt[80] = float(LNP2x3[45]+LNt[78])-LNP2x3[45];	//[8,31]<<0
  LNt[78] -= LNt[80];
  LNt[81] = LNt[9]-LNt[77]+LNt[79]+LNt[80];
  LNt[82] = float(LNP2x3[68]+LNt[81])-LNP2x3[68];	//[7,30]<<23
  LNt[81] -= LNt[82];
  LNt[83] = LNt[71]*LNt[34]+LNt[74]*LNt[33]+LNt[75]*LNt[30]-(LNt[37]*LNt[82]+LNt[40]*LNt[81]+LNt[41]*LNt[78]);
  LNt[84] = LNt[71]*LNt[30]-LNt[37]*LNt[78];
  LNt[85] = float(LNP2x3[47]+LNt[84])-LNP2x3[47];	//[22,47]<<0
  LNt[84] -= LNt[85];
  LNt[86] = float(LNP2x3[45]+LNt[84])-LNP2x3[45];	//[2,25]<<0
  LNt[84] -= LNt[86];
  LNt[87] = LNt[71]*LNt[33]+LNt[74]*LNt[30]-(LNt[37]*LNt[81]+LNt[40]*LNt[78])+LNt[85]+LNt[86];
  LNt[88] = float(LNP2x3[71]+LNt[87])-LNP2x3[71];	//[22,48]<<23
  LNt[87] -= LNt[88];
  LNt[89] = float(LNP2x3[68]+LNt[87])-LNP2x3[68];	//[3,26]<<23
  LNt[87] -= LNt[89];
  LNt[90] = LNt[83]+LNt[88]+LNt[89];
  LNt[91] = float(LNP2x3[95]+LNt[90])-LNP2x3[95];	//[22,49]<<46
  LNt[90] -= LNt[91];
  LNt[92] = float(LNP2x3[91]+LNt[90])-LNP2x3[91];	//[4,27]<<46
  LNt[90] -= LNt[92];
  LNt[93] = LNt[74]*LNt[34]+LNt[75]*LNt[33]-(LNt[40]*LNt[82]+LNt[41]*LNt[81])+LNt[91]+LNt[92];
  LNt[94] = float(LNP2x3[114]+LNt[93])-LNP2x3[114];	//[9,32]<<69
  LNt[93] -= LNt[94];
  LNt[95] = LNt[75]*LNt[34]-LNt[41]*LNt[82]+LNt[94];
  LNt[96] = LNt[12]*LNt[56]+LNt[15]*LNt[53]+LNt[16]*LNt[50]-(LNt[64]*LNt[90]+LNt[67]*LNt[87]+LNt[68]*LNt[84]);
  LNt[97] = LNt[12]*LNt[59]+LNt[15]*LNt[56]+LNt[16]*LNt[53]-(LNt[64]*LNt[93]+LNt[67]*LNt[90]+LNt[68]*LNt[87]);
  LNt[98] = LNt[12]*LNt[61]+LNt[15]*LNt[59]+LNt[16]*LNt[56]-(LNt[64]*LNt[95]+LNt[67]*LNt[93]+LNt[68]*LNt[90]);
  LNt[99] = b.z;
  LNt[100] = float(LNP2x3[74]+LNt[99])-LNP2x3[74];	//[1,53]<<0
  LNt[99] -= LNt[100];
  LNt[101] = LNt[26]-LNt[99];
  LNt[102] = float(LNP2x3[53]+LNt[101])-LNP2x3[53];	//[22,53]<<0
  LNt[101] -= LNt[102];
  LNt[103] = float(LNP2x3[45]+LNt[101])-LNP2x3[45];	//[8,31]<<0
  LNt[101] -= LNt[103];
  LNt[104] = LNt[27]-LNt[100]+LNt[102]+LNt[103];
  LNt[105] = float(LNP2x3[68]+LNt[104])-LNP2x3[68];	//[7,30]<<23
  LNt[104] -= LNt[105];
  LNt[106] = LNt[71]*LNt[48]+LNt[74]*LNt[47]+LNt[75]*LNt[44]-(LNt[21]*LNt[82]+LNt[24]*LNt[81]+LNt[25]*LNt[78]);
  LNt[107] = LNt[71]*LNt[44]-LNt[21]*LNt[78];
  LNt[108] = float(LNP2x3[47]+LNt[107])-LNP2x3[47];	//[22,47]<<0
  LNt[107] -= LNt[108];
  LNt[109] = float(LNP2x3[45]+LNt[107])-LNP2x3[45];	//[2,25]<<0
  LNt[107] -= LNt[109];
  LNt[110] = LNt[71]*LNt[47]+LNt[74]*LNt[44]-(LNt[21]*LNt[81]+LNt[24]*LNt[78])+LNt[108]+LNt[109];
  LNt[111] = float(LNP2x3[71]+LNt[110])-LNP2x3[71];	//[22,48]<<23
  LNt[110] -= LNt[111];
  LNt[112] = float(LNP2x3[68]+LNt[110])-LNP2x3[68];	//[3,26]<<23
  LNt[110] -= LNt[112];
  LNt[113] = LNt[106]+LNt[111]+LNt[112];
  LNt[114] = float(LNP2x3[95]+LNt[113])-LNP2x3[95];	//[22,49]<<46
  LNt[113] -= LNt[114];
  LNt[115] = float(LNP2x3[91]+LNt[113])-LNP2x3[91];	//[4,27]<<46
  LNt[113] -= LNt[115];
  LNt[116] = LNt[74]*LNt[48]+LNt[75]*LNt[47]-(LNt[24]*LNt[82]+LNt[25]*LNt[81])+LNt[114]+LNt[115];
  LNt[117] = float(LNP2x3[114]+LNt[116])-LNP2x3[114];	//[9,32]<<69
  LNt[116] -= LNt[117];
  LNt[118] = LNt[75]*LNt[48]-LNt[25]*LNt[82]+LNt[117];
  LNt[119] = LNt[12]*LNt[53]+LNt[15]*LNt[50]-(LNt[64]*LNt[87]+LNt[67]*LNt[84])+LNt[101]*LNt[110]+LNt[104]*LNt[107];
  LNt[120] = LNt[15]*LNt[61]+LNt[16]*LNt[59]-(LNt[67]*LNt[95]+LNt[68]*LNt[93])+LNt[104]*LNt[118]+LNt[105]*LNt[116];
  LNt[121] = LNt[12]*LNt[50]-LNt[64]*LNt[84]+LNt[101]*LNt[107];
  LNt[122] = LNt[96]+LNt[101]*LNt[113]+LNt[104]*LNt[110]+LNt[105]*LNt[107];
  LNt[123] = LNt[97]+LNt[101]*LNt[116]+LNt[104]*LNt[113]+LNt[105]*LNt[110];
  LNt[124] = LNt[98]+LNt[101]*LNt[118]+LNt[104]*LNt[116]+LNt[105]*LNt[113];
  LNt[125] = LNt[16]*LNt[61]-LNt[68]*LNt[95]+LNt[105]*LNt[118];
  LNt[7] = (((((((LNt[125])+LNt[120])+LNt[124])+LNt[123])+LNt[122])+LNt[119])+LNt[121]);
}
if (LNt[7]<0){
  LNt[0] = -1.;
}else{
  if (LNt[7]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=154 multiplies=108 normalizes=60 */


int LN_det3x3(double ax, double ay, double az, double bx, double by, double bz, double cx, double cy,double cz){
integer LNans;
LNt[1] = ax*(by*cz-bz*cy)-ay*(bx*cz-bz*cx)+az*(bx*cy-by*cx);
if (-LNP2[114]<LNt[1] && LNt[1]<LNP2[114]) {	/* the high order 48 bits of 162 are accurate */
  LNt[2] = ax;
  LNt[3] = float(LNP2x3[53]+LNt[2])-LNP2x3[53];	//[22,53]<<0
  LNt[2] -= LNt[3];
  LNt[4] = float(LNP2x3[45]+LNt[2])-LNP2x3[45];	//[8,31]<<0
  LNt[2] -= LNt[4];
  LNt[5] = LNt[3]+LNt[4];
  LNt[6] = float(LNP2x3[68]+LNt[5])-LNP2x3[68];	//[7,30]<<23
  LNt[5] -= LNt[6];
  LNt[7] = by;
  LNt[8] = float(LNP2x3[53]+LNt[7])-LNP2x3[53];	//[22,53]<<0
  LNt[7] -= LNt[8];
  LNt[9] = float(LNP2x3[45]+LNt[7])-LNP2x3[45];	//[8,31]<<0
  LNt[7] -= LNt[9];
  LNt[10] = LNt[8]+LNt[9];
  LNt[11] = float(LNP2x3[68]+LNt[10])-LNP2x3[68];	//[7,30]<<23
  LNt[10] -= LNt[11];
  LNt[12] = cz;
  LNt[13] = float(LNP2x3[53]+LNt[12])-LNP2x3[53];	//[22,53]<<0
  LNt[12] -= LNt[13];
  LNt[14] = float(LNP2x3[45]+LNt[12])-LNP2x3[45];	//[8,31]<<0
  LNt[12] -= LNt[14];
  LNt[15] = LNt[13]+LNt[14];
  LNt[16] = float(LNP2x3[68]+LNt[15])-LNP2x3[68];	//[7,30]<<23
  LNt[15] -= LNt[16];
  LNt[17] = bz;
  LNt[18] = float(LNP2x3[53]+LNt[17])-LNP2x3[53];	//[22,53]<<0
  LNt[17] -= LNt[18];
  LNt[19] = float(LNP2x3[45]+LNt[17])-LNP2x3[45];	//[8,31]<<0
  LNt[17] -= LNt[19];
  LNt[20] = LNt[18]+LNt[19];
  LNt[21] = float(LNP2x3[68]+LNt[20])-LNP2x3[68];	//[7,30]<<23
  LNt[20] -= LNt[21];
  LNt[22] = cy;
  LNt[23] = float(LNP2x3[53]+LNt[22])-LNP2x3[53];	//[22,53]<<0
  LNt[22] -= LNt[23];
  LNt[24] = float(LNP2x3[45]+LNt[22])-LNP2x3[45];	//[8,31]<<0
  LNt[22] -= LNt[24];
  LNt[25] = LNt[23]+LNt[24];
  LNt[26] = float(LNP2x3[68]+LNt[25])-LNP2x3[68];	//[7,30]<<23
  LNt[25] -= LNt[26];
  LNt[27] = LNt[7]*LNt[16]+LNt[10]*LNt[15]+LNt[11]*LNt[12]-(LNt[17]*LNt[26]+LNt[20]*LNt[25]+LNt[21]*LNt[22]);
  LNt[28] = LNt[7]*LNt[12]-LNt[17]*LNt[22];
  LNt[29] = float(LNP2x3[47]+LNt[28])-LNP2x3[47];	//[22,47]<<0
  LNt[28] -= LNt[29];
  LNt[30] = float(LNP2x3[45]+LNt[28])-LNP2x3[45];	//[2,25]<<0
  LNt[28] -= LNt[30];
  LNt[31] = LNt[7]*LNt[15]+LNt[10]*LNt[12]-(LNt[17]*LNt[25]+LNt[20]*LNt[22])+LNt[29]+LNt[30];
  LNt[32] = float(LNP2x3[71]+LNt[31])-LNP2x3[71];	//[22,48]<<23
  LNt[31] -= LNt[32];
  LNt[33] = float(LNP2x3[68]+LNt[31])-LNP2x3[68];	//[3,26]<<23
  LNt[31] -= LNt[33];
  LNt[34] = LNt[27]+LNt[32]+LNt[33];
  LNt[35] = float(LNP2x3[95]+LNt[34])-LNP2x3[95];	//[22,49]<<46
  LNt[34] -= LNt[35];
  LNt[36] = float(LNP2x3[91]+LNt[34])-LNP2x3[91];	//[4,27]<<46
  LNt[34] -= LNt[36];
  LNt[37] = LNt[10]*LNt[16]+LNt[11]*LNt[15]-(LNt[20]*LNt[26]+LNt[21]*LNt[25])+LNt[35]+LNt[36];
  LNt[38] = float(LNP2x3[114]+LNt[37])-LNP2x3[114];	//[9,32]<<69
  LNt[37] -= LNt[38];
  LNt[39] = LNt[11]*LNt[16]-LNt[21]*LNt[26]+LNt[38];
  LNt[40] = ay;
  LNt[41] = float(LNP2x3[53]+LNt[40])-LNP2x3[53];	//[22,53]<<0
  LNt[40] -= LNt[41];
  LNt[42] = float(LNP2x3[45]+LNt[40])-LNP2x3[45];	//[8,31]<<0
  LNt[40] -= LNt[42];
  LNt[43] = LNt[41]+LNt[42];
  LNt[44] = float(LNP2x3[68]+LNt[43])-LNP2x3[68];	//[7,30]<<23
  LNt[43] -= LNt[44];
  LNt[45] = bx;
  LNt[46] = float(LNP2x3[53]+LNt[45])-LNP2x3[53];	//[22,53]<<0
  LNt[45] -= LNt[46];
  LNt[47] = float(LNP2x3[45]+LNt[45])-LNP2x3[45];	//[8,31]<<0
  LNt[45] -= LNt[47];
  LNt[48] = LNt[46]+LNt[47];
  LNt[49] = float(LNP2x3[68]+LNt[48])-LNP2x3[68];	//[7,30]<<23
  LNt[48] -= LNt[49];
  LNt[50] = cx;
  LNt[51] = float(LNP2x3[53]+LNt[50])-LNP2x3[53];	//[22,53]<<0
  LNt[50] -= LNt[51];
  LNt[52] = float(LNP2x3[45]+LNt[50])-LNP2x3[45];	//[8,31]<<0
  LNt[50] -= LNt[52];
  LNt[53] = LNt[51]+LNt[52];
  LNt[54] = float(LNP2x3[68]+LNt[53])-LNP2x3[68];	//[7,30]<<23
  LNt[53] -= LNt[54];
  LNt[55] = LNt[45]*LNt[16]+LNt[48]*LNt[15]+LNt[49]*LNt[12]-(LNt[17]*LNt[54]+LNt[20]*LNt[53]+LNt[21]*LNt[50]);
  LNt[56] = LNt[45]*LNt[12]-LNt[17]*LNt[50];
  LNt[57] = float(LNP2x3[47]+LNt[56])-LNP2x3[47];	//[22,47]<<0
  LNt[56] -= LNt[57];
  LNt[58] = float(LNP2x3[45]+LNt[56])-LNP2x3[45];	//[2,25]<<0
  LNt[56] -= LNt[58];
  LNt[59] = LNt[45]*LNt[15]+LNt[48]*LNt[12]-(LNt[17]*LNt[53]+LNt[20]*LNt[50])+LNt[57]+LNt[58];
  LNt[60] = float(LNP2x3[71]+LNt[59])-LNP2x3[71];	//[22,48]<<23
  LNt[59] -= LNt[60];
  LNt[61] = float(LNP2x3[68]+LNt[59])-LNP2x3[68];	//[3,26]<<23
  LNt[59] -= LNt[61];
  LNt[62] = LNt[55]+LNt[60]+LNt[61];
  LNt[63] = float(LNP2x3[95]+LNt[62])-LNP2x3[95];	//[22,49]<<46
  LNt[62] -= LNt[63];
  LNt[64] = float(LNP2x3[91]+LNt[62])-LNP2x3[91];	//[4,27]<<46
  LNt[62] -= LNt[64];
  LNt[65] = LNt[48]*LNt[16]+LNt[49]*LNt[15]-(LNt[20]*LNt[54]+LNt[21]*LNt[53])+LNt[63]+LNt[64];
  LNt[66] = float(LNP2x3[114]+LNt[65])-LNP2x3[114];	//[9,32]<<69
  LNt[65] -= LNt[66];
  LNt[67] = LNt[49]*LNt[16]-LNt[21]*LNt[54]+LNt[66];
  LNt[68] = LNt[2]*LNt[34]+LNt[5]*LNt[31]+LNt[6]*LNt[28]-(LNt[40]*LNt[62]+LNt[43]*LNt[59]+LNt[44]*LNt[56]);
  LNt[69] = LNt[2]*LNt[37]+LNt[5]*LNt[34]+LNt[6]*LNt[31]-(LNt[40]*LNt[65]+LNt[43]*LNt[62]+LNt[44]*LNt[59]);
  LNt[70] = LNt[2]*LNt[39]+LNt[5]*LNt[37]+LNt[6]*LNt[34]-(LNt[40]*LNt[67]+LNt[43]*LNt[65]+LNt[44]*LNt[62]);
  LNt[71] = az;
  LNt[72] = float(LNP2x3[53]+LNt[71])-LNP2x3[53];	//[22,53]<<0
  LNt[71] -= LNt[72];
  LNt[73] = float(LNP2x3[45]+LNt[71])-LNP2x3[45];	//[8,31]<<0
  LNt[71] -= LNt[73];
  LNt[74] = LNt[72]+LNt[73];
  LNt[75] = float(LNP2x3[68]+LNt[74])-LNP2x3[68];	//[7,30]<<23
  LNt[74] -= LNt[75];
  LNt[76] = LNt[45]*LNt[26]+LNt[48]*LNt[25]+LNt[49]*LNt[22]-(LNt[7]*LNt[54]+LNt[10]*LNt[53]+LNt[11]*LNt[50]);
  LNt[77] = LNt[45]*LNt[22]-LNt[7]*LNt[50];
  LNt[78] = float(LNP2x3[47]+LNt[77])-LNP2x3[47];	//[22,47]<<0
  LNt[77] -= LNt[78];
  LNt[79] = float(LNP2x3[45]+LNt[77])-LNP2x3[45];	//[2,25]<<0
  LNt[77] -= LNt[79];
  LNt[80] = LNt[45]*LNt[25]+LNt[48]*LNt[22]-(LNt[7]*LNt[53]+LNt[10]*LNt[50])+LNt[78]+LNt[79];
  LNt[81] = float(LNP2x3[71]+LNt[80])-LNP2x3[71];	//[22,48]<<23
  LNt[80] -= LNt[81];
  LNt[82] = float(LNP2x3[68]+LNt[80])-LNP2x3[68];	//[3,26]<<23
  LNt[80] -= LNt[82];
  LNt[83] = LNt[76]+LNt[81]+LNt[82];
  LNt[84] = float(LNP2x3[95]+LNt[83])-LNP2x3[95];	//[22,49]<<46
  LNt[83] -= LNt[84];
  LNt[85] = float(LNP2x3[91]+LNt[83])-LNP2x3[91];	//[4,27]<<46
  LNt[83] -= LNt[85];
  LNt[86] = LNt[48]*LNt[26]+LNt[49]*LNt[25]-(LNt[10]*LNt[54]+LNt[11]*LNt[53])+LNt[84]+LNt[85];
  LNt[87] = float(LNP2x3[114]+LNt[86])-LNP2x3[114];	//[9,32]<<69
  LNt[86] -= LNt[87];
  LNt[88] = LNt[49]*LNt[26]-LNt[11]*LNt[54]+LNt[87];
  LNt[89] = LNt[2]*LNt[31]+LNt[5]*LNt[28]-(LNt[40]*LNt[59]+LNt[43]*LNt[56])+LNt[71]*LNt[80]+LNt[74]*LNt[77];
  LNt[90] = LNt[5]*LNt[39]+LNt[6]*LNt[37]-(LNt[43]*LNt[67]+LNt[44]*LNt[65])+LNt[74]*LNt[88]+LNt[75]*LNt[86];
  LNt[91] = LNt[2]*LNt[28]-LNt[40]*LNt[56]+LNt[71]*LNt[77];
  LNt[92] = LNt[68]+LNt[71]*LNt[83]+LNt[74]*LNt[80]+LNt[75]*LNt[77];
  LNt[93] = LNt[69]+LNt[71]*LNt[86]+LNt[74]*LNt[83]+LNt[75]*LNt[80];
  LNt[94] = LNt[70]+LNt[71]*LNt[88]+LNt[74]*LNt[86]+LNt[75]*LNt[83];
  LNt[95] = LNt[6]*LNt[39]-LNt[44]*LNt[67]+LNt[75]*LNt[88];
  LNt[1] = (((((((LNt[95])+LNt[90])+LNt[94])+LNt[93])+LNt[92])+LNt[89])+LNt[91]);
}
if (LNt[1]<0){
  LNt[0] = -1.;
}else{
  if (LNt[1]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return (int) LNans;
} /* adds=118 multiplies=108 normalizes=48 */

integer horient3d(const Point3d& a, const Point3d& b, const Point3d& c){
integer LNans;
LNt[1] = a.x*(b.y*c.z-b.z*c.y)-a.y*(b.x*c.z-b.z*c.x)+a.z*(b.x*c.y-b.y*c.x);
if (-LNP2[114]<LNt[1] && LNt[1]<LNP2[114]) {	/* the high order 48 bits of 162 are accurate */
  LNt[2] = a.x;
  LNt[3] = float(LNP2x3[53]+LNt[2])-LNP2x3[53];	//[22,53]<<0
  LNt[2] -= LNt[3];
  LNt[4] = float(LNP2x3[45]+LNt[2])-LNP2x3[45];	//[8,31]<<0
  LNt[2] -= LNt[4];
  LNt[5] = LNt[3]+LNt[4];
  LNt[6] = float(LNP2x3[68]+LNt[5])-LNP2x3[68];	//[7,30]<<23
  LNt[5] -= LNt[6];
  LNt[7] = b.y;
  LNt[8] = float(LNP2x3[53]+LNt[7])-LNP2x3[53];	//[22,53]<<0
  LNt[7] -= LNt[8];
  LNt[9] = float(LNP2x3[45]+LNt[7])-LNP2x3[45];	//[8,31]<<0
  LNt[7] -= LNt[9];
  LNt[10] = LNt[8]+LNt[9];
  LNt[11] = float(LNP2x3[68]+LNt[10])-LNP2x3[68];	//[7,30]<<23
  LNt[10] -= LNt[11];
  LNt[12] = c.z;
  LNt[13] = float(LNP2x3[53]+LNt[12])-LNP2x3[53];	//[22,53]<<0
  LNt[12] -= LNt[13];
  LNt[14] = float(LNP2x3[45]+LNt[12])-LNP2x3[45];	//[8,31]<<0
  LNt[12] -= LNt[14];
  LNt[15] = LNt[13]+LNt[14];
  LNt[16] = float(LNP2x3[68]+LNt[15])-LNP2x3[68];	//[7,30]<<23
  LNt[15] -= LNt[16];
  LNt[17] = b.z;
  LNt[18] = float(LNP2x3[53]+LNt[17])-LNP2x3[53];	//[22,53]<<0
  LNt[17] -= LNt[18];
  LNt[19] = float(LNP2x3[45]+LNt[17])-LNP2x3[45];	//[8,31]<<0
  LNt[17] -= LNt[19];
  LNt[20] = LNt[18]+LNt[19];
  LNt[21] = float(LNP2x3[68]+LNt[20])-LNP2x3[68];	//[7,30]<<23
  LNt[20] -= LNt[21];
  LNt[22] = c.y;
  LNt[23] = float(LNP2x3[53]+LNt[22])-LNP2x3[53];	//[22,53]<<0
  LNt[22] -= LNt[23];
  LNt[24] = float(LNP2x3[45]+LNt[22])-LNP2x3[45];	//[8,31]<<0
  LNt[22] -= LNt[24];
  LNt[25] = LNt[23]+LNt[24];
  LNt[26] = float(LNP2x3[68]+LNt[25])-LNP2x3[68];	//[7,30]<<23
  LNt[25] -= LNt[26];
  LNt[27] = LNt[7]*LNt[16]+LNt[10]*LNt[15]+LNt[11]*LNt[12]-(LNt[17]*LNt[26]+LNt[20]*LNt[25]+LNt[21]*LNt[22]);
  LNt[28] = LNt[7]*LNt[12]-LNt[17]*LNt[22];
  LNt[29] = float(LNP2x3[47]+LNt[28])-LNP2x3[47];	//[22,47]<<0
  LNt[28] -= LNt[29];
  LNt[30] = float(LNP2x3[45]+LNt[28])-LNP2x3[45];	//[2,25]<<0
  LNt[28] -= LNt[30];
  LNt[31] = LNt[7]*LNt[15]+LNt[10]*LNt[12]-(LNt[17]*LNt[25]+LNt[20]*LNt[22])+LNt[29]+LNt[30];
  LNt[32] = float(LNP2x3[71]+LNt[31])-LNP2x3[71];	//[22,48]<<23
  LNt[31] -= LNt[32];
  LNt[33] = float(LNP2x3[68]+LNt[31])-LNP2x3[68];	//[3,26]<<23
  LNt[31] -= LNt[33];
  LNt[34] = LNt[27]+LNt[32]+LNt[33];
  LNt[35] = float(LNP2x3[95]+LNt[34])-LNP2x3[95];	//[22,49]<<46
  LNt[34] -= LNt[35];
  LNt[36] = float(LNP2x3[91]+LNt[34])-LNP2x3[91];	//[4,27]<<46
  LNt[34] -= LNt[36];
  LNt[37] = LNt[10]*LNt[16]+LNt[11]*LNt[15]-(LNt[20]*LNt[26]+LNt[21]*LNt[25])+LNt[35]+LNt[36];
  LNt[38] = float(LNP2x3[114]+LNt[37])-LNP2x3[114];	//[9,32]<<69
  LNt[37] -= LNt[38];
  LNt[39] = LNt[11]*LNt[16]-LNt[21]*LNt[26]+LNt[38];
  LNt[40] = a.y;
  LNt[41] = float(LNP2x3[53]+LNt[40])-LNP2x3[53];	//[22,53]<<0
  LNt[40] -= LNt[41];
  LNt[42] = float(LNP2x3[45]+LNt[40])-LNP2x3[45];	//[8,31]<<0
  LNt[40] -= LNt[42];
  LNt[43] = LNt[41]+LNt[42];
  LNt[44] = float(LNP2x3[68]+LNt[43])-LNP2x3[68];	//[7,30]<<23
  LNt[43] -= LNt[44];
  LNt[45] = b.x;
  LNt[46] = float(LNP2x3[53]+LNt[45])-LNP2x3[53];	//[22,53]<<0
  LNt[45] -= LNt[46];
  LNt[47] = float(LNP2x3[45]+LNt[45])-LNP2x3[45];	//[8,31]<<0
  LNt[45] -= LNt[47];
  LNt[48] = LNt[46]+LNt[47];
  LNt[49] = float(LNP2x3[68]+LNt[48])-LNP2x3[68];	//[7,30]<<23
  LNt[48] -= LNt[49];
  LNt[50] = c.x;
  LNt[51] = float(LNP2x3[53]+LNt[50])-LNP2x3[53];	//[22,53]<<0
  LNt[50] -= LNt[51];
  LNt[52] = float(LNP2x3[45]+LNt[50])-LNP2x3[45];	//[8,31]<<0
  LNt[50] -= LNt[52];
  LNt[53] = LNt[51]+LNt[52];
  LNt[54] = float(LNP2x3[68]+LNt[53])-LNP2x3[68];	//[7,30]<<23
  LNt[53] -= LNt[54];
  LNt[55] = LNt[45]*LNt[16]+LNt[48]*LNt[15]+LNt[49]*LNt[12]-(LNt[17]*LNt[54]+LNt[20]*LNt[53]+LNt[21]*LNt[50]);
  LNt[56] = LNt[45]*LNt[12]-LNt[17]*LNt[50];
  LNt[57] = float(LNP2x3[47]+LNt[56])-LNP2x3[47];	//[22,47]<<0
  LNt[56] -= LNt[57];
  LNt[58] = float(LNP2x3[45]+LNt[56])-LNP2x3[45];	//[2,25]<<0
  LNt[56] -= LNt[58];
  LNt[59] = LNt[45]*LNt[15]+LNt[48]*LNt[12]-(LNt[17]*LNt[53]+LNt[20]*LNt[50])+LNt[57]+LNt[58];
  LNt[60] = float(LNP2x3[71]+LNt[59])-LNP2x3[71];	//[22,48]<<23
  LNt[59] -= LNt[60];
  LNt[61] = float(LNP2x3[68]+LNt[59])-LNP2x3[68];	//[3,26]<<23
  LNt[59] -= LNt[61];
  LNt[62] = LNt[55]+LNt[60]+LNt[61];
  LNt[63] = float(LNP2x3[95]+LNt[62])-LNP2x3[95];	//[22,49]<<46
  LNt[62] -= LNt[63];
  LNt[64] = float(LNP2x3[91]+LNt[62])-LNP2x3[91];	//[4,27]<<46
  LNt[62] -= LNt[64];
  LNt[65] = LNt[48]*LNt[16]+LNt[49]*LNt[15]-(LNt[20]*LNt[54]+LNt[21]*LNt[53])+LNt[63]+LNt[64];
  LNt[66] = float(LNP2x3[114]+LNt[65])-LNP2x3[114];	//[9,32]<<69
  LNt[65] -= LNt[66];
  LNt[67] = LNt[49]*LNt[16]-LNt[21]*LNt[54]+LNt[66];
  LNt[68] = LNt[2]*LNt[34]+LNt[5]*LNt[31]+LNt[6]*LNt[28]-(LNt[40]*LNt[62]+LNt[43]*LNt[59]+LNt[44]*LNt[56]);
  LNt[69] = LNt[2]*LNt[37]+LNt[5]*LNt[34]+LNt[6]*LNt[31]-(LNt[40]*LNt[65]+LNt[43]*LNt[62]+LNt[44]*LNt[59]);
  LNt[70] = LNt[2]*LNt[39]+LNt[5]*LNt[37]+LNt[6]*LNt[34]-(LNt[40]*LNt[67]+LNt[43]*LNt[65]+LNt[44]*LNt[62]);
  LNt[71] = a.z;
  LNt[72] = float(LNP2x3[53]+LNt[71])-LNP2x3[53];	//[22,53]<<0
  LNt[71] -= LNt[72];
  LNt[73] = float(LNP2x3[45]+LNt[71])-LNP2x3[45];	//[8,31]<<0
  LNt[71] -= LNt[73];
  LNt[74] = LNt[72]+LNt[73];
  LNt[75] = float(LNP2x3[68]+LNt[74])-LNP2x3[68];	//[7,30]<<23
  LNt[74] -= LNt[75];
  LNt[76] = LNt[45]*LNt[26]+LNt[48]*LNt[25]+LNt[49]*LNt[22]-(LNt[7]*LNt[54]+LNt[10]*LNt[53]+LNt[11]*LNt[50]);
  LNt[77] = LNt[45]*LNt[22]-LNt[7]*LNt[50];
  LNt[78] = float(LNP2x3[47]+LNt[77])-LNP2x3[47];	//[22,47]<<0
  LNt[77] -= LNt[78];
  LNt[79] = float(LNP2x3[45]+LNt[77])-LNP2x3[45];	//[2,25]<<0
  LNt[77] -= LNt[79];
  LNt[80] = LNt[45]*LNt[25]+LNt[48]*LNt[22]-(LNt[7]*LNt[53]+LNt[10]*LNt[50])+LNt[78]+LNt[79];
  LNt[81] = float(LNP2x3[71]+LNt[80])-LNP2x3[71];	//[22,48]<<23
  LNt[80] -= LNt[81];
  LNt[82] = float(LNP2x3[68]+LNt[80])-LNP2x3[68];	//[3,26]<<23
  LNt[80] -= LNt[82];
  LNt[83] = LNt[76]+LNt[81]+LNt[82];
  LNt[84] = float(LNP2x3[95]+LNt[83])-LNP2x3[95];	//[22,49]<<46
  LNt[83] -= LNt[84];
  LNt[85] = float(LNP2x3[91]+LNt[83])-LNP2x3[91];	//[4,27]<<46
  LNt[83] -= LNt[85];
  LNt[86] = LNt[48]*LNt[26]+LNt[49]*LNt[25]-(LNt[10]*LNt[54]+LNt[11]*LNt[53])+LNt[84]+LNt[85];
  LNt[87] = float(LNP2x3[114]+LNt[86])-LNP2x3[114];	//[9,32]<<69
  LNt[86] -= LNt[87];
  LNt[88] = LNt[49]*LNt[26]-LNt[11]*LNt[54]+LNt[87];
  LNt[89] = LNt[2]*LNt[31]+LNt[5]*LNt[28]-(LNt[40]*LNt[59]+LNt[43]*LNt[56])+LNt[71]*LNt[80]+LNt[74]*LNt[77];
  LNt[90] = LNt[5]*LNt[39]+LNt[6]*LNt[37]-(LNt[43]*LNt[67]+LNt[44]*LNt[65])+LNt[74]*LNt[88]+LNt[75]*LNt[86];
  LNt[91] = LNt[2]*LNt[28]-LNt[40]*LNt[56]+LNt[71]*LNt[77];
  LNt[92] = LNt[68]+LNt[71]*LNt[83]+LNt[74]*LNt[80]+LNt[75]*LNt[77];
  LNt[93] = LNt[69]+LNt[71]*LNt[86]+LNt[74]*LNt[83]+LNt[75]*LNt[80];
  LNt[94] = LNt[70]+LNt[71]*LNt[88]+LNt[74]*LNt[86]+LNt[75]*LNt[83];
  LNt[95] = LNt[6]*LNt[39]-LNt[44]*LNt[67]+LNt[75]*LNt[88];
  LNt[1] = (((((((LNt[95])+LNt[90])+LNt[94])+LNt[93])+LNt[92])+LNt[89])+LNt[91]);
}
if (LNt[1]<0){
  LNt[0] = -1.;
}else{
  if (LNt[1]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=118 multiplies=108 normalizes=48 */


integer incircle2d(const Point2d& a, const Point2d& b, const Point2d& c, const Point2d& d){
integer LNans;
LNt[1] = a.y-c.y;
LNt[2] = a.x*a.x+a.y*a.y;
LNt[3] = LNt[2]-(d.x*d.x+d.y*d.y);
LNt[4] = LNt[2]-(c.x*c.x+c.y*c.y);
LNt[5] = a.y-d.y;
LNt[6] = a.x-c.x;
LNt[7] = a.x-d.x;
LNt[8] = (a.x-b.x)*(LNt[1]*LNt[3]-LNt[4]*LNt[5])-(a.y-b.y)*(LNt[6]*LNt[3]-LNt[4]*LNt[7])+(LNt[2]-(b.x*b.x+b.y*b.y))*(LNt[6]*LNt[5]-LNt[1]*LNt[7]);
if (-LNP2[174]<LNt[8] && LNt[8]<LNP2[174]) {	/* the high order 45 bits of 219 are accurate */
  LNt[9] = a.x;
  LNt[10] = float(LNP2x3[53]+LNt[9])-LNP2x3[53];	//[22,53]<<0
  LNt[9] -= LNt[10];
  LNt[11] = float(LNP2x3[45]+LNt[9])-LNP2x3[45];	//[8,31]<<0
  LNt[9] -= LNt[11];
  LNt[12] = LNt[10]+LNt[11];
  LNt[13] = float(LNP2x3[68]+LNt[12])-LNP2x3[68];	//[7,30]<<23
  LNt[12] -= LNt[13];
  LNt[14] = b.x;
  LNt[15] = float(LNP2x3[53]+LNt[14])-LNP2x3[53];	//[22,53]<<0
  LNt[14] -= LNt[15];
  LNt[16] = float(LNP2x3[45]+LNt[14])-LNP2x3[45];	//[8,31]<<0
  LNt[14] -= LNt[16];
  LNt[17] = LNt[15]+LNt[16];
  LNt[18] = float(LNP2x3[68]+LNt[17])-LNP2x3[68];	//[7,30]<<23
  LNt[17] -= LNt[18];
  LNt[19] = LNt[9]-LNt[14];
  LNt[20] = float(LNP2x3[45]+LNt[19])-LNP2x3[45];	//[1,24]<<0
  LNt[19] -= LNt[20];
  LNt[21] = LNt[12]-LNt[17]+LNt[20];
  LNt[22] = float(LNP2x3[68]+LNt[21])-LNP2x3[68];	//[1,24]<<23
  LNt[21] -= LNt[22];
  LNt[23] = a.y;
  LNt[24] = float(LNP2x3[53]+LNt[23])-LNP2x3[53];	//[22,53]<<0
  LNt[23] -= LNt[24];
  LNt[25] = float(LNP2x3[45]+LNt[23])-LNP2x3[45];	//[8,31]<<0
  LNt[23] -= LNt[25];
  LNt[26] = LNt[24]+LNt[25];
  LNt[27] = float(LNP2x3[68]+LNt[26])-LNP2x3[68];	//[7,30]<<23
  LNt[26] -= LNt[27];
  LNt[28] = c.y;
  LNt[29] = float(LNP2x3[53]+LNt[28])-LNP2x3[53];	//[22,53]<<0
  LNt[28] -= LNt[29];
  LNt[30] = float(LNP2x3[45]+LNt[28])-LNP2x3[45];	//[8,31]<<0
  LNt[28] -= LNt[30];
  LNt[31] = LNt[29]+LNt[30];
  LNt[32] = float(LNP2x3[68]+LNt[31])-LNP2x3[68];	//[7,30]<<23
  LNt[31] -= LNt[32];
  LNt[33] = LNt[23]-LNt[28];
  LNt[34] = float(LNP2x3[45]+LNt[33])-LNP2x3[45];	//[1,24]<<0
  LNt[33] -= LNt[34];
  LNt[35] = LNt[26]-LNt[31]+LNt[34];
  LNt[36] = float(LNP2x3[68]+LNt[35])-LNP2x3[68];	//[1,24]<<23
  LNt[35] -= LNt[36];
  LNt[37] = LNt[27]-LNt[32]+LNt[36];
  LNt[38] = LNt[9]*LNt[13]+LNt[12]*LNt[12]+LNt[13]*LNt[9]+LNt[23]*LNt[27]+LNt[26]*LNt[26]+LNt[27]*LNt[23];
  LNt[39] = LNt[9]*LNt[9]+LNt[23]*LNt[23];
  LNt[40] = LNt[9]*LNt[12]+LNt[12]*LNt[9]+LNt[23]*LNt[26]+LNt[26]*LNt[23];
  LNt[41] = LNt[12]*LNt[13]+LNt[13]*LNt[12]+LNt[26]*LNt[27]+LNt[27]*LNt[26];
  LNt[42] = LNt[13]*LNt[13]+LNt[27]*LNt[27];
  LNt[43] = d.x;
  LNt[44] = float(LNP2x3[53]+LNt[43])-LNP2x3[53];	//[22,53]<<0
  LNt[43] -= LNt[44];
  LNt[45] = float(LNP2x3[45]+LNt[43])-LNP2x3[45];	//[8,31]<<0
  LNt[43] -= LNt[45];
  LNt[46] = LNt[44]+LNt[45];
  LNt[47] = float(LNP2x3[68]+LNt[46])-LNP2x3[68];	//[7,30]<<23
  LNt[46] -= LNt[47];
  LNt[48] = d.y;
  LNt[49] = float(LNP2x3[53]+LNt[48])-LNP2x3[53];	//[22,53]<<0
  LNt[48] -= LNt[49];
  LNt[50] = float(LNP2x3[45]+LNt[48])-LNP2x3[45];	//[8,31]<<0
  LNt[48] -= LNt[50];
  LNt[51] = LNt[49]+LNt[50];
  LNt[52] = float(LNP2x3[68]+LNt[51])-LNP2x3[68];	//[7,30]<<23
  LNt[51] -= LNt[52];
  LNt[53] = LNt[43]*LNt[47]+LNt[46]*LNt[46]+LNt[47]*LNt[43]+LNt[48]*LNt[52]+LNt[51]*LNt[51]+LNt[52]*LNt[48];
  LNt[54] = LNt[39]-(LNt[43]*LNt[43]+LNt[48]*LNt[48]);
  LNt[55] = float(LNP2x3[48]+LNt[54])-LNP2x3[48];	//[22,48]<<0
  LNt[54] -= LNt[55];
  LNt[56] = float(LNP2x3[45]+LNt[54])-LNP2x3[45];	//[3,26]<<0
  LNt[54] -= LNt[56];
  LNt[57] = LNt[40]-(LNt[43]*LNt[46]+LNt[46]*LNt[43]+LNt[48]*LNt[51]+LNt[51]*LNt[48])+LNt[55]+LNt[56];
  LNt[58] = float(LNP2x3[72]+LNt[57])-LNP2x3[72];	//[22,49]<<23
  LNt[57] -= LNt[58];
  LNt[59] = float(LNP2x3[68]+LNt[57])-LNP2x3[68];	//[4,27]<<23
  LNt[57] -= LNt[59];
  LNt[60] = LNt[38]-LNt[53]+LNt[58]+LNt[59];
  LNt[61] = float(LNP2x3[96]+LNt[60])-LNP2x3[96];	//[22,50]<<46
  LNt[60] -= LNt[61];
  LNt[62] = float(LNP2x3[91]+LNt[60])-LNP2x3[91];	//[5,28]<<46
  LNt[60] -= LNt[62];
  LNt[63] = LNt[41]-(LNt[46]*LNt[47]+LNt[47]*LNt[46]+LNt[51]*LNt[52]+LNt[52]*LNt[51])+LNt[61]+LNt[62];
  LNt[64] = float(LNP2x3[114]+LNt[63])-LNP2x3[114];	//[10,33]<<69
  LNt[63] -= LNt[64];
  LNt[65] = LNt[42]-(LNt[47]*LNt[47]+LNt[52]*LNt[52])+LNt[64];
  LNt[66] = c.x;
  LNt[67] = float(LNP2x3[53]+LNt[66])-LNP2x3[53];	//[22,53]<<0
  LNt[66] -= LNt[67];
  LNt[68] = float(LNP2x3[45]+LNt[66])-LNP2x3[45];	//[8,31]<<0
  LNt[66] -= LNt[68];
  LNt[69] = LNt[67]+LNt[68];
  LNt[70] = float(LNP2x3[68]+LNt[69])-LNP2x3[68];	//[7,30]<<23
  LNt[69] -= LNt[70];
  LNt[71] = LNt[66]*LNt[70]+LNt[69]*LNt[69]+LNt[70]*LNt[66]+LNt[28]*LNt[32]+LNt[31]*LNt[31]+LNt[32]*LNt[28];
  LNt[72] = LNt[39]-(LNt[66]*LNt[66]+LNt[28]*LNt[28]);
  LNt[73] = float(LNP2x3[48]+LNt[72])-LNP2x3[48];	//[22,48]<<0
  LNt[72] -= LNt[73];
  LNt[74] = float(LNP2x3[45]+LNt[72])-LNP2x3[45];	//[3,26]<<0
  LNt[72] -= LNt[74];
  LNt[75] = LNt[40]-(LNt[66]*LNt[69]+LNt[69]*LNt[66]+LNt[28]*LNt[31]+LNt[31]*LNt[28])+LNt[73]+LNt[74];
  LNt[76] = float(LNP2x3[72]+LNt[75])-LNP2x3[72];	//[22,49]<<23
  LNt[75] -= LNt[76];
  LNt[77] = float(LNP2x3[68]+LNt[75])-LNP2x3[68];	//[4,27]<<23
  LNt[75] -= LNt[77];
  LNt[78] = LNt[38]-LNt[71]+LNt[76]+LNt[77];
  LNt[79] = float(LNP2x3[96]+LNt[78])-LNP2x3[96];	//[22,50]<<46
  LNt[78] -= LNt[79];
  LNt[80] = float(LNP2x3[91]+LNt[78])-LNP2x3[91];	//[5,28]<<46
  LNt[78] -= LNt[80];
  LNt[81] = LNt[41]-(LNt[69]*LNt[70]+LNt[70]*LNt[69]+LNt[31]*LNt[32]+LNt[32]*LNt[31])+LNt[79]+LNt[80];
  LNt[82] = float(LNP2x3[114]+LNt[81])-LNP2x3[114];	//[10,33]<<69
  LNt[81] -= LNt[82];
  LNt[83] = LNt[42]-(LNt[70]*LNt[70]+LNt[32]*LNt[32])+LNt[82];
  LNt[84] = LNt[23]-LNt[48];
  LNt[85] = float(LNP2x3[45]+LNt[84])-LNP2x3[45];	//[1,24]<<0
  LNt[84] -= LNt[85];
  LNt[86] = LNt[26]-LNt[51]+LNt[85];
  LNt[87] = float(LNP2x3[68]+LNt[86])-LNP2x3[68];	//[1,24]<<23
  LNt[86] -= LNt[87];
  LNt[88] = LNt[27]-LNt[52]+LNt[87];
  LNt[89] = LNt[33]*LNt[60]+LNt[35]*LNt[57]+LNt[37]*LNt[54]-(LNt[72]*LNt[88]+LNt[75]*LNt[86]+LNt[78]*LNt[84]);
  LNt[90] = LNt[33]*LNt[63]+LNt[35]*LNt[60]+LNt[37]*LNt[57]-(LNt[75]*LNt[88]+LNt[78]*LNt[86]+LNt[81]*LNt[84]);
  LNt[91] = LNt[33]*LNt[65]+LNt[35]*LNt[63]+LNt[37]*LNt[60]-(LNt[78]*LNt[88]+LNt[81]*LNt[86]+LNt[83]*LNt[84]);
  LNt[92] = LNt[33]*LNt[54]-LNt[72]*LNt[84];
  LNt[93] = float(LNP2x3[47]+LNt[92])-LNP2x3[47];	//[22,47]<<0
  LNt[92] -= LNt[93];
  LNt[94] = float(LNP2x3[45]+LNt[92])-LNP2x3[45];	//[2,25]<<0
  LNt[92] -= LNt[94];
  LNt[95] = LNt[33]*LNt[57]+LNt[35]*LNt[54]-(LNt[72]*LNt[86]+LNt[75]*LNt[84])+LNt[93]+LNt[94];
  LNt[96] = float(LNP2x3[71]+LNt[95])-LNP2x3[71];	//[22,48]<<23
  LNt[95] -= LNt[96];
  LNt[97] = float(LNP2x3[68]+LNt[95])-LNP2x3[68];	//[3,26]<<23
  LNt[95] -= LNt[97];
  LNt[98] = LNt[89]+LNt[96]+LNt[97];
  LNt[99] = float(LNP2x3[95]+LNt[98])-LNP2x3[95];	//[22,49]<<46
  LNt[98] -= LNt[99];
  LNt[100] = float(LNP2x3[91]+LNt[98])-LNP2x3[91];	//[4,27]<<46
  LNt[98] -= LNt[100];
  LNt[101] = LNt[90]+LNt[99]+LNt[100];
  LNt[102] = float(LNP2x3[118]+LNt[101])-LNP2x3[118];	//[22,49]<<69
  LNt[101] -= LNt[102];
  LNt[103] = float(LNP2x3[114]+LNt[101])-LNP2x3[114];	//[4,27]<<69
  LNt[101] -= LNt[103];
  LNt[104] = LNt[91]+LNt[102]+LNt[103];
  LNt[105] = (float(LNP2x3[125]+LNt[104]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[104] -= LNt[105];
  LNt[106] = (float(LNP2x3[125]+LNt[104]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[104] -= LNt[106];
  LNt[107] = LNt[35]*LNt[65]+LNt[37]*LNt[63]-(LNt[81]*LNt[88]+LNt[83]*LNt[86])+LNt[105]+LNt[106];
  LNt[108] = (float(LNP2x3[125]+LNt[107]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[107] -= LNt[108];
  LNt[109] = LNt[37]*LNt[65]-LNt[83]*LNt[88]+LNt[108];
  LNt[110] = (float(LNP2x3[125]+LNt[109]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[2,25]<<138
  LNt[109] -= LNt[110];
  LNt[111] = LNt[13]-LNt[18]+LNt[22];
  LNt[112] = b.y;
  LNt[113] = float(LNP2x3[53]+LNt[112])-LNP2x3[53];	//[22,53]<<0
  LNt[112] -= LNt[113];
  LNt[114] = float(LNP2x3[45]+LNt[112])-LNP2x3[45];	//[8,31]<<0
  LNt[112] -= LNt[114];
  LNt[115] = LNt[113]+LNt[114];
  LNt[116] = float(LNP2x3[68]+LNt[115])-LNP2x3[68];	//[7,30]<<23
  LNt[115] -= LNt[116];
  LNt[117] = LNt[23]-LNt[112];
  LNt[118] = float(LNP2x3[45]+LNt[117])-LNP2x3[45];	//[1,24]<<0
  LNt[117] -= LNt[118];
  LNt[119] = LNt[26]-LNt[115]+LNt[118];
  LNt[120] = float(LNP2x3[68]+LNt[119])-LNP2x3[68];	//[1,24]<<23
  LNt[119] -= LNt[120];
  LNt[121] = LNt[9]-LNt[66];
  LNt[122] = float(LNP2x3[45]+LNt[121])-LNP2x3[45];	//[1,24]<<0
  LNt[121] -= LNt[122];
  LNt[123] = LNt[12]-LNt[69]+LNt[122];
  LNt[124] = float(LNP2x3[68]+LNt[123])-LNP2x3[68];	//[1,24]<<23
  LNt[123] -= LNt[124];
  LNt[125] = LNt[13]-LNt[70]+LNt[124];
  LNt[126] = LNt[9]-LNt[43];
  LNt[127] = float(LNP2x3[45]+LNt[126])-LNP2x3[45];	//[1,24]<<0
  LNt[126] -= LNt[127];
  LNt[128] = LNt[12]-LNt[46]+LNt[127];
  LNt[129] = float(LNP2x3[68]+LNt[128])-LNP2x3[68];	//[1,24]<<23
  LNt[128] -= LNt[129];
  LNt[130] = LNt[13]-LNt[47]+LNt[129];
  LNt[131] = LNt[121]*LNt[60]+LNt[123]*LNt[57]+LNt[125]*LNt[54]-(LNt[72]*LNt[130]+LNt[75]*LNt[128]+LNt[78]*LNt[126]);
  LNt[132] = LNt[121]*LNt[63]+LNt[123]*LNt[60]+LNt[125]*LNt[57]-(LNt[75]*LNt[130]+LNt[78]*LNt[128]+LNt[81]*LNt[126]);
  LNt[133] = LNt[121]*LNt[65]+LNt[123]*LNt[63]+LNt[125]*LNt[60]-(LNt[78]*LNt[130]+LNt[81]*LNt[128]+LNt[83]*LNt[126]);
  LNt[134] = LNt[121]*LNt[54]-LNt[72]*LNt[126];
  LNt[135] = float(LNP2x3[47]+LNt[134])-LNP2x3[47];	//[22,47]<<0
  LNt[134] -= LNt[135];
  LNt[136] = float(LNP2x3[45]+LNt[134])-LNP2x3[45];	//[2,25]<<0
  LNt[134] -= LNt[136];
  LNt[137] = LNt[121]*LNt[57]+LNt[123]*LNt[54]-(LNt[72]*LNt[128]+LNt[75]*LNt[126])+LNt[135]+LNt[136];
  LNt[138] = float(LNP2x3[71]+LNt[137])-LNP2x3[71];	//[22,48]<<23
  LNt[137] -= LNt[138];
  LNt[139] = float(LNP2x3[68]+LNt[137])-LNP2x3[68];	//[3,26]<<23
  LNt[137] -= LNt[139];
  LNt[140] = LNt[131]+LNt[138]+LNt[139];
  LNt[141] = float(LNP2x3[95]+LNt[140])-LNP2x3[95];	//[22,49]<<46
  LNt[140] -= LNt[141];
  LNt[142] = float(LNP2x3[91]+LNt[140])-LNP2x3[91];	//[4,27]<<46
  LNt[140] -= LNt[142];
  LNt[143] = LNt[132]+LNt[141]+LNt[142];
  LNt[144] = float(LNP2x3[118]+LNt[143])-LNP2x3[118];	//[22,49]<<69
  LNt[143] -= LNt[144];
  LNt[145] = float(LNP2x3[114]+LNt[143])-LNP2x3[114];	//[4,27]<<69
  LNt[143] -= LNt[145];
  LNt[146] = LNt[133]+LNt[144]+LNt[145];
  LNt[147] = (float(LNP2x3[125]+LNt[146]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[146] -= LNt[147];
  LNt[148] = (float(LNP2x3[125]+LNt[146]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[146] -= LNt[148];
  LNt[149] = LNt[123]*LNt[65]+LNt[125]*LNt[63]-(LNt[81]*LNt[130]+LNt[83]*LNt[128])+LNt[147]+LNt[148];
  LNt[150] = (float(LNP2x3[125]+LNt[149]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[149] -= LNt[150];
  LNt[151] = LNt[125]*LNt[65]-LNt[83]*LNt[130]+LNt[150];
  LNt[152] = (float(LNP2x3[125]+LNt[151]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[2,25]<<138
  LNt[151] -= LNt[152];
  LNt[153] = LNt[27]-LNt[116]+LNt[120];
  LNt[154] = LNt[19]*LNt[98]+LNt[21]*LNt[95]+LNt[111]*LNt[92]-(LNt[117]*LNt[140]+LNt[119]*LNt[137]+LNt[153]*LNt[134]);
  LNt[155] = LNt[19]*LNt[101]+LNt[21]*LNt[98]+LNt[111]*LNt[95]-(LNt[117]*LNt[143]+LNt[119]*LNt[140]+LNt[153]*LNt[137]);
  LNt[156] = LNt[19]*LNt[104]+LNt[21]*LNt[101]+LNt[111]*LNt[98]-(LNt[117]*LNt[146]+LNt[119]*LNt[143]+LNt[153]*LNt[140]);
  LNt[157] = LNt[19]*LNt[107]+LNt[21]*LNt[104]+LNt[111]*LNt[101]-(LNt[117]*LNt[149]+LNt[119]*LNt[146]+LNt[153]*LNt[143]);
  LNt[158] = LNt[19]*LNt[109]+LNt[21]*LNt[107]+LNt[111]*LNt[104]-(LNt[117]*LNt[151]+LNt[119]*LNt[149]+LNt[153]*LNt[146]);
  LNt[159] = LNt[19]*LNt[110]+LNt[21]*LNt[109]+LNt[111]*LNt[107]-(LNt[117]*LNt[152]+LNt[119]*LNt[151]+LNt[153]*LNt[149]);
  LNt[160] = LNt[14]*LNt[18]+LNt[17]*LNt[17]+LNt[18]*LNt[14]+LNt[112]*LNt[116]+LNt[115]*LNt[115]+LNt[116]*LNt[112];
  LNt[161] = LNt[39]-(LNt[14]*LNt[14]+LNt[112]*LNt[112]);
  LNt[162] = float(LNP2x3[48]+LNt[161])-LNP2x3[48];	//[22,48]<<0
  LNt[161] -= LNt[162];
  LNt[163] = float(LNP2x3[45]+LNt[161])-LNP2x3[45];	//[3,26]<<0
  LNt[161] -= LNt[163];
  LNt[164] = LNt[40]-(LNt[14]*LNt[17]+LNt[17]*LNt[14]+LNt[112]*LNt[115]+LNt[115]*LNt[112])+LNt[162]+LNt[163];
  LNt[165] = float(LNP2x3[72]+LNt[164])-LNP2x3[72];	//[22,49]<<23
  LNt[164] -= LNt[165];
  LNt[166] = float(LNP2x3[68]+LNt[164])-LNP2x3[68];	//[4,27]<<23
  LNt[164] -= LNt[166];
  LNt[167] = LNt[38]-LNt[160]+LNt[165]+LNt[166];
  LNt[168] = float(LNP2x3[96]+LNt[167])-LNP2x3[96];	//[22,50]<<46
  LNt[167] -= LNt[168];
  LNt[169] = float(LNP2x3[91]+LNt[167])-LNP2x3[91];	//[5,28]<<46
  LNt[167] -= LNt[169];
  LNt[170] = LNt[41]-(LNt[17]*LNt[18]+LNt[18]*LNt[17]+LNt[115]*LNt[116]+LNt[116]*LNt[115])+LNt[168]+LNt[169];
  LNt[171] = float(LNP2x3[114]+LNt[170])-LNP2x3[114];	//[10,33]<<69
  LNt[170] -= LNt[171];
  LNt[172] = LNt[121]*LNt[88]+LNt[123]*LNt[86]+LNt[125]*LNt[84]-(LNt[33]*LNt[130]+LNt[35]*LNt[128]+LNt[37]*LNt[126]);
  LNt[173] = LNt[121]*LNt[84]-LNt[33]*LNt[126];
  LNt[174] = float(LNP2x3[47]+LNt[173])-LNP2x3[47];	//[22,47]<<0
  LNt[173] -= LNt[174];
  LNt[175] = float(LNP2x3[45]+LNt[173])-LNP2x3[45];	//[2,25]<<0
  LNt[173] -= LNt[175];
  LNt[176] = LNt[121]*LNt[86]+LNt[123]*LNt[84]-(LNt[33]*LNt[128]+LNt[35]*LNt[126])+LNt[174]+LNt[175];
  LNt[177] = float(LNP2x3[71]+LNt[176])-LNP2x3[71];	//[22,48]<<23
  LNt[176] -= LNt[177];
  LNt[178] = float(LNP2x3[68]+LNt[176])-LNP2x3[68];	//[3,26]<<23
  LNt[176] -= LNt[178];
  LNt[179] = LNt[172]+LNt[177]+LNt[178];
  LNt[180] = float(LNP2x3[95]+LNt[179])-LNP2x3[95];	//[22,49]<<46
  LNt[179] -= LNt[180];
  LNt[181] = float(LNP2x3[91]+LNt[179])-LNP2x3[91];	//[4,27]<<46
  LNt[179] -= LNt[181];
  LNt[182] = LNt[123]*LNt[88]+LNt[125]*LNt[86]-(LNt[35]*LNt[130]+LNt[37]*LNt[128])+LNt[180]+LNt[181];
  LNt[183] = float(LNP2x3[114]+LNt[182])-LNP2x3[114];	//[10,33]<<69
  LNt[182] -= LNt[183];
  LNt[184] = LNt[125]*LNt[88]-LNt[37]*LNt[130]+LNt[183];
  LNt[185] = LNt[42]-(LNt[18]*LNt[18]+LNt[116]*LNt[116])+LNt[171];
  LNt[186] = LNt[161]*LNt[184]+LNt[164]*LNt[182]+LNt[167]*LNt[179]+LNt[170]*LNt[176]+LNt[185]*LNt[173];
  LNt[187] = LNt[19]*LNt[95]+LNt[21]*LNt[92]-(LNt[117]*LNt[137]+LNt[119]*LNt[134])+LNt[161]*LNt[176]+LNt[164]*LNt[173];
  LNt[188] = LNt[21]*LNt[110]+LNt[111]*LNt[109]-(LNt[119]*LNt[152]+LNt[153]*LNt[151])+LNt[185]*LNt[184];
  LNt[189] = LNt[19]*LNt[92]-LNt[117]*LNt[134]+LNt[161]*LNt[173];
  LNt[190] = LNt[154]+LNt[161]*LNt[179]+LNt[164]*LNt[176]+LNt[167]*LNt[173];
  LNt[191] = LNt[155]+LNt[161]*LNt[182]+LNt[164]*LNt[179]+LNt[167]*LNt[176]+LNt[170]*LNt[173];
  LNt[192] = LNt[156]+LNt[186];
  LNt[193] = LNt[157]+LNt[164]*LNt[184]+LNt[167]*LNt[182]+LNt[170]*LNt[179]+LNt[185]*LNt[176];
  LNt[194] = LNt[158]+LNt[167]*LNt[184]+LNt[170]*LNt[182]+LNt[185]*LNt[179];
  LNt[195] = LNt[159]+LNt[170]*LNt[184]+LNt[185]*LNt[182];
  LNt[196] = LNt[111]*LNt[110]-LNt[153]*LNt[152];
  LNt[197] = (((((((LNt[196])+LNt[188])+LNt[195])+LNt[194])+LNt[193])+LNt[192])+LNt[191])+LNt[190];
  LNt[8] = (((LNt[197])+LNt[187])+LNt[189]);
}
if (LNt[8]<0){
  LNt[0] = -1.;
}else{
  if (LNt[8]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=304 multiplies=240 normalizes=88 */


integer wincircle2d(const WPoint2d& a, const WPoint2d& b, const WPoint2d& c, const WPoint2d& d){
integer LNans;
LNt[1] = a.y-c.y;
LNt[2] = a.x*a.x+a.y*a.y-a.w;
LNt[3] = LNt[2]-(d.x*d.x+d.y*d.y-d.w);
LNt[4] = LNt[2]-(c.x*c.x+c.y*c.y-c.w);
LNt[5] = a.y-d.y;
LNt[6] = a.x-c.x;
LNt[7] = a.x-d.x;
LNt[8] = (a.x-b.x)*(LNt[1]*LNt[3]-LNt[4]*LNt[5])-(a.y-b.y)*(LNt[6]*LNt[3]-LNt[4]*LNt[7])+(LNt[2]-(b.x*b.x+b.y*b.y-b.w))*(LNt[6]*LNt[5]-LNt[1]*LNt[7]);
if (-LNP2[176]<LNt[8] && LNt[8]<LNP2[176]) {	/* the high order 44 bits of 220 are accurate */
  LNt[9] = a.x;
  LNt[10] = float(LNP2x3[53]+LNt[9])-LNP2x3[53];	//[22,53]<<0
  LNt[9] -= LNt[10];
  LNt[11] = float(LNP2x3[45]+LNt[9])-LNP2x3[45];	//[8,31]<<0
  LNt[9] -= LNt[11];
  LNt[12] = LNt[10]+LNt[11];
  LNt[13] = float(LNP2x3[68]+LNt[12])-LNP2x3[68];	//[7,30]<<23
  LNt[12] -= LNt[13];
  LNt[14] = b.x;
  LNt[15] = float(LNP2x3[53]+LNt[14])-LNP2x3[53];	//[22,53]<<0
  LNt[14] -= LNt[15];
  LNt[16] = float(LNP2x3[45]+LNt[14])-LNP2x3[45];	//[8,31]<<0
  LNt[14] -= LNt[16];
  LNt[17] = LNt[15]+LNt[16];
  LNt[18] = float(LNP2x3[68]+LNt[17])-LNP2x3[68];	//[7,30]<<23
  LNt[17] -= LNt[18];
  LNt[19] = LNt[9]-LNt[14];
  LNt[20] = float(LNP2x3[45]+LNt[19])-LNP2x3[45];	//[1,24]<<0
  LNt[19] -= LNt[20];
  LNt[21] = LNt[12]-LNt[17]+LNt[20];
  LNt[22] = float(LNP2x3[68]+LNt[21])-LNP2x3[68];	//[1,24]<<23
  LNt[21] -= LNt[22];
  LNt[23] = a.y;
  LNt[24] = float(LNP2x3[53]+LNt[23])-LNP2x3[53];	//[22,53]<<0
  LNt[23] -= LNt[24];
  LNt[25] = float(LNP2x3[45]+LNt[23])-LNP2x3[45];	//[8,31]<<0
  LNt[23] -= LNt[25];
  LNt[26] = LNt[24]+LNt[25];
  LNt[27] = float(LNP2x3[68]+LNt[26])-LNP2x3[68];	//[7,30]<<23
  LNt[26] -= LNt[27];
  LNt[28] = c.y;
  LNt[29] = float(LNP2x3[53]+LNt[28])-LNP2x3[53];	//[22,53]<<0
  LNt[28] -= LNt[29];
  LNt[30] = float(LNP2x3[45]+LNt[28])-LNP2x3[45];	//[8,31]<<0
  LNt[28] -= LNt[30];
  LNt[31] = LNt[29]+LNt[30];
  LNt[32] = float(LNP2x3[68]+LNt[31])-LNP2x3[68];	//[7,30]<<23
  LNt[31] -= LNt[32];
  LNt[33] = LNt[23]-LNt[28];
  LNt[34] = float(LNP2x3[45]+LNt[33])-LNP2x3[45];	//[1,24]<<0
  LNt[33] -= LNt[34];
  LNt[35] = LNt[26]-LNt[31]+LNt[34];
  LNt[36] = float(LNP2x3[68]+LNt[35])-LNP2x3[68];	//[1,24]<<23
  LNt[35] -= LNt[36];
  LNt[37] = LNt[27]-LNt[32]+LNt[36];
  LNt[38] = LNt[9]*LNt[13]+LNt[12]*LNt[12]+LNt[13]*LNt[9]+LNt[23]*LNt[27]+LNt[26]*LNt[26]+LNt[27]*LNt[23];
  LNt[39] = a.w;
  LNt[40] = float(LNP2x3[74]+LNt[39])-LNP2x3[74];	//[1,53]<<0
  LNt[39] -= LNt[40];
  LNt[41] = LNt[9]*LNt[9]+LNt[23]*LNt[23]-LNt[39];
  LNt[42] = float(LNP2x3[74]+LNt[41])-LNP2x3[74];	//[1,53]<<0
  LNt[41] -= LNt[42];
  LNt[43] = LNt[9]*LNt[12]+LNt[12]*LNt[9]+LNt[23]*LNt[26]+LNt[26]*LNt[23]-LNt[40]+LNt[42];
  LNt[44] = LNt[12]*LNt[13]+LNt[13]*LNt[12]+LNt[26]*LNt[27]+LNt[27]*LNt[26];
  LNt[45] = LNt[13]*LNt[13]+LNt[27]*LNt[27];
  LNt[46] = d.x;
  LNt[47] = float(LNP2x3[53]+LNt[46])-LNP2x3[53];	//[22,53]<<0
  LNt[46] -= LNt[47];
  LNt[48] = float(LNP2x3[45]+LNt[46])-LNP2x3[45];	//[8,31]<<0
  LNt[46] -= LNt[48];
  LNt[49] = LNt[47]+LNt[48];
  LNt[50] = float(LNP2x3[68]+LNt[49])-LNP2x3[68];	//[7,30]<<23
  LNt[49] -= LNt[50];
  LNt[51] = d.y;
  LNt[52] = float(LNP2x3[53]+LNt[51])-LNP2x3[53];	//[22,53]<<0
  LNt[51] -= LNt[52];
  LNt[53] = float(LNP2x3[45]+LNt[51])-LNP2x3[45];	//[8,31]<<0
  LNt[51] -= LNt[53];
  LNt[54] = LNt[52]+LNt[53];
  LNt[55] = float(LNP2x3[68]+LNt[54])-LNP2x3[68];	//[7,30]<<23
  LNt[54] -= LNt[55];
  LNt[56] = LNt[46]*LNt[50]+LNt[49]*LNt[49]+LNt[50]*LNt[46]+LNt[51]*LNt[55]+LNt[54]*LNt[54]+LNt[55]*LNt[51];
  LNt[57] = d.w;
  LNt[58] = float(LNP2x3[74]+LNt[57])-LNP2x3[74];	//[1,53]<<0
  LNt[57] -= LNt[58];
  LNt[59] = LNt[46]*LNt[46]+LNt[51]*LNt[51]-LNt[57];
  LNt[60] = float(LNP2x3[74]+LNt[59])-LNP2x3[74];	//[1,53]<<0
  LNt[59] -= LNt[60];
  LNt[61] = LNt[43]-(LNt[46]*LNt[49]+LNt[49]*LNt[46]+LNt[51]*LNt[54]+LNt[54]*LNt[51]-LNt[58]+LNt[60]);
  LNt[62] = LNt[41]-LNt[59];
  LNt[63] = float(LNP2x3[53]+LNt[62])-LNP2x3[53];	//[22,53]<<0
  LNt[62] -= LNt[63];
  LNt[64] = float(LNP2x3[45]+LNt[62])-LNP2x3[45];	//[8,31]<<0
  LNt[62] -= LNt[64];
  LNt[65] = LNt[61]+LNt[63]+LNt[64];
  LNt[66] = float(LNP2x3[73]+LNt[65])-LNP2x3[73];	//[22,50]<<23
  LNt[65] -= LNt[66];
  LNt[67] = float(LNP2x3[68]+LNt[65])-LNP2x3[68];	//[5,28]<<23
  LNt[65] -= LNt[67];
  LNt[68] = LNt[38]-LNt[56]+LNt[66]+LNt[67];
  LNt[69] = float(LNP2x3[96]+LNt[68])-LNP2x3[96];	//[22,50]<<46
  LNt[68] -= LNt[69];
  LNt[70] = float(LNP2x3[91]+LNt[68])-LNP2x3[91];	//[5,28]<<46
  LNt[68] -= LNt[70];
  LNt[71] = LNt[44]-(LNt[49]*LNt[50]+LNt[50]*LNt[49]+LNt[54]*LNt[55]+LNt[55]*LNt[54])+LNt[69]+LNt[70];
  LNt[72] = float(LNP2x3[114]+LNt[71])-LNP2x3[114];	//[10,33]<<69
  LNt[71] -= LNt[72];
  LNt[73] = LNt[45]-(LNt[50]*LNt[50]+LNt[55]*LNt[55])+LNt[72];
  LNt[74] = c.x;
  LNt[75] = float(LNP2x3[53]+LNt[74])-LNP2x3[53];	//[22,53]<<0
  LNt[74] -= LNt[75];
  LNt[76] = float(LNP2x3[45]+LNt[74])-LNP2x3[45];	//[8,31]<<0
  LNt[74] -= LNt[76];
  LNt[77] = LNt[75]+LNt[76];
  LNt[78] = float(LNP2x3[68]+LNt[77])-LNP2x3[68];	//[7,30]<<23
  LNt[77] -= LNt[78];
  LNt[79] = LNt[74]*LNt[78]+LNt[77]*LNt[77]+LNt[78]*LNt[74]+LNt[28]*LNt[32]+LNt[31]*LNt[31]+LNt[32]*LNt[28];
  LNt[80] = c.w;
  LNt[81] = float(LNP2x3[74]+LNt[80])-LNP2x3[74];	//[1,53]<<0
  LNt[80] -= LNt[81];
  LNt[82] = LNt[74]*LNt[74]+LNt[28]*LNt[28]-LNt[80];
  LNt[83] = float(LNP2x3[74]+LNt[82])-LNP2x3[74];	//[1,53]<<0
  LNt[82] -= LNt[83];
  LNt[84] = LNt[43]-(LNt[74]*LNt[77]+LNt[77]*LNt[74]+LNt[28]*LNt[31]+LNt[31]*LNt[28]-LNt[81]+LNt[83]);
  LNt[85] = LNt[41]-LNt[82];
  LNt[86] = float(LNP2x3[53]+LNt[85])-LNP2x3[53];	//[22,53]<<0
  LNt[85] -= LNt[86];
  LNt[87] = float(LNP2x3[45]+LNt[85])-LNP2x3[45];	//[8,31]<<0
  LNt[85] -= LNt[87];
  LNt[88] = LNt[84]+LNt[86]+LNt[87];
  LNt[89] = float(LNP2x3[73]+LNt[88])-LNP2x3[73];	//[22,50]<<23
  LNt[88] -= LNt[89];
  LNt[90] = float(LNP2x3[68]+LNt[88])-LNP2x3[68];	//[5,28]<<23
  LNt[88] -= LNt[90];
  LNt[91] = LNt[38]-LNt[79]+LNt[89]+LNt[90];
  LNt[92] = float(LNP2x3[96]+LNt[91])-LNP2x3[96];	//[22,50]<<46
  LNt[91] -= LNt[92];
  LNt[93] = float(LNP2x3[91]+LNt[91])-LNP2x3[91];	//[5,28]<<46
  LNt[91] -= LNt[93];
  LNt[94] = LNt[44]-(LNt[77]*LNt[78]+LNt[78]*LNt[77]+LNt[31]*LNt[32]+LNt[32]*LNt[31])+LNt[92]+LNt[93];
  LNt[95] = float(LNP2x3[114]+LNt[94])-LNP2x3[114];	//[10,33]<<69
  LNt[94] -= LNt[95];
  LNt[96] = LNt[45]-(LNt[78]*LNt[78]+LNt[32]*LNt[32])+LNt[95];
  LNt[97] = LNt[23]-LNt[51];
  LNt[98] = float(LNP2x3[45]+LNt[97])-LNP2x3[45];	//[1,24]<<0
  LNt[97] -= LNt[98];
  LNt[99] = LNt[26]-LNt[54]+LNt[98];
  LNt[100] = float(LNP2x3[68]+LNt[99])-LNP2x3[68];	//[1,24]<<23
  LNt[99] -= LNt[100];
  LNt[101] = LNt[27]-LNt[55]+LNt[100];
  LNt[102] = LNt[33]*LNt[68]+LNt[35]*LNt[65]+LNt[37]*LNt[62]-(LNt[85]*LNt[101]+LNt[88]*LNt[99]+LNt[91]*LNt[97]);
  LNt[103] = LNt[33]*LNt[71]+LNt[35]*LNt[68]+LNt[37]*LNt[65]-(LNt[88]*LNt[101]+LNt[91]*LNt[99]+LNt[94]*LNt[97]);
  LNt[104] = LNt[33]*LNt[73]+LNt[35]*LNt[71]+LNt[37]*LNt[68]-(LNt[91]*LNt[101]+LNt[94]*LNt[99]+LNt[96]*LNt[97]);
  LNt[105] = LNt[33]*LNt[62]-LNt[85]*LNt[97];
  LNt[106] = float(LNP2x3[47]+LNt[105])-LNP2x3[47];	//[22,47]<<0
  LNt[105] -= LNt[106];
  LNt[107] = float(LNP2x3[45]+LNt[105])-LNP2x3[45];	//[2,25]<<0
  LNt[105] -= LNt[107];
  LNt[108] = LNt[33]*LNt[65]+LNt[35]*LNt[62]-(LNt[85]*LNt[99]+LNt[88]*LNt[97])+LNt[106]+LNt[107];
  LNt[109] = float(LNP2x3[71]+LNt[108])-LNP2x3[71];	//[22,48]<<23
  LNt[108] -= LNt[109];
  LNt[110] = float(LNP2x3[68]+LNt[108])-LNP2x3[68];	//[3,26]<<23
  LNt[108] -= LNt[110];
  LNt[111] = LNt[102]+LNt[109]+LNt[110];
  LNt[112] = float(LNP2x3[95]+LNt[111])-LNP2x3[95];	//[22,49]<<46
  LNt[111] -= LNt[112];
  LNt[113] = float(LNP2x3[91]+LNt[111])-LNP2x3[91];	//[4,27]<<46
  LNt[111] -= LNt[113];
  LNt[114] = LNt[103]+LNt[112]+LNt[113];
  LNt[115] = float(LNP2x3[118]+LNt[114])-LNP2x3[118];	//[22,49]<<69
  LNt[114] -= LNt[115];
  LNt[116] = float(LNP2x3[114]+LNt[114])-LNP2x3[114];	//[4,27]<<69
  LNt[114] -= LNt[116];
  LNt[117] = LNt[104]+LNt[115]+LNt[116];
  LNt[118] = (float(LNP2x3[125]+LNt[117]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[117] -= LNt[118];
  LNt[119] = (float(LNP2x3[125]+LNt[117]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[117] -= LNt[119];
  LNt[120] = LNt[35]*LNt[73]+LNt[37]*LNt[71]-(LNt[94]*LNt[101]+LNt[96]*LNt[99])+LNt[118]+LNt[119];
  LNt[121] = (float(LNP2x3[125]+LNt[120]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[120] -= LNt[121];
  LNt[122] = LNt[37]*LNt[73]-LNt[96]*LNt[101]+LNt[121];
  LNt[123] = (float(LNP2x3[125]+LNt[122]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[2,25]<<138
  LNt[122] -= LNt[123];
  LNt[124] = LNt[13]-LNt[18]+LNt[22];
  LNt[125] = b.y;
  LNt[126] = float(LNP2x3[53]+LNt[125])-LNP2x3[53];	//[22,53]<<0
  LNt[125] -= LNt[126];
  LNt[127] = float(LNP2x3[45]+LNt[125])-LNP2x3[45];	//[8,31]<<0
  LNt[125] -= LNt[127];
  LNt[128] = LNt[126]+LNt[127];
  LNt[129] = float(LNP2x3[68]+LNt[128])-LNP2x3[68];	//[7,30]<<23
  LNt[128] -= LNt[129];
  LNt[130] = LNt[23]-LNt[125];
  LNt[131] = float(LNP2x3[45]+LNt[130])-LNP2x3[45];	//[1,24]<<0
  LNt[130] -= LNt[131];
  LNt[132] = LNt[26]-LNt[128]+LNt[131];
  LNt[133] = float(LNP2x3[68]+LNt[132])-LNP2x3[68];	//[1,24]<<23
  LNt[132] -= LNt[133];
  LNt[134] = LNt[9]-LNt[74];
  LNt[135] = float(LNP2x3[45]+LNt[134])-LNP2x3[45];	//[1,24]<<0
  LNt[134] -= LNt[135];
  LNt[136] = LNt[12]-LNt[77]+LNt[135];
  LNt[137] = float(LNP2x3[68]+LNt[136])-LNP2x3[68];	//[1,24]<<23
  LNt[136] -= LNt[137];
  LNt[138] = LNt[13]-LNt[78]+LNt[137];
  LNt[139] = LNt[9]-LNt[46];
  LNt[140] = float(LNP2x3[45]+LNt[139])-LNP2x3[45];	//[1,24]<<0
  LNt[139] -= LNt[140];
  LNt[141] = LNt[12]-LNt[49]+LNt[140];
  LNt[142] = float(LNP2x3[68]+LNt[141])-LNP2x3[68];	//[1,24]<<23
  LNt[141] -= LNt[142];
  LNt[143] = LNt[13]-LNt[50]+LNt[142];
  LNt[144] = LNt[134]*LNt[68]+LNt[136]*LNt[65]+LNt[138]*LNt[62]-(LNt[85]*LNt[143]+LNt[88]*LNt[141]+LNt[91]*LNt[139]);
  LNt[145] = LNt[134]*LNt[71]+LNt[136]*LNt[68]+LNt[138]*LNt[65]-(LNt[88]*LNt[143]+LNt[91]*LNt[141]+LNt[94]*LNt[139]);
  LNt[146] = LNt[134]*LNt[73]+LNt[136]*LNt[71]+LNt[138]*LNt[68]-(LNt[91]*LNt[143]+LNt[94]*LNt[141]+LNt[96]*LNt[139]);
  LNt[147] = LNt[134]*LNt[62]-LNt[85]*LNt[139];
  LNt[148] = float(LNP2x3[47]+LNt[147])-LNP2x3[47];	//[22,47]<<0
  LNt[147] -= LNt[148];
  LNt[149] = float(LNP2x3[45]+LNt[147])-LNP2x3[45];	//[2,25]<<0
  LNt[147] -= LNt[149];
  LNt[150] = LNt[134]*LNt[65]+LNt[136]*LNt[62]-(LNt[85]*LNt[141]+LNt[88]*LNt[139])+LNt[148]+LNt[149];
  LNt[151] = float(LNP2x3[71]+LNt[150])-LNP2x3[71];	//[22,48]<<23
  LNt[150] -= LNt[151];
  LNt[152] = float(LNP2x3[68]+LNt[150])-LNP2x3[68];	//[3,26]<<23
  LNt[150] -= LNt[152];
  LNt[153] = LNt[144]+LNt[151]+LNt[152];
  LNt[154] = float(LNP2x3[95]+LNt[153])-LNP2x3[95];	//[22,49]<<46
  LNt[153] -= LNt[154];
  LNt[155] = float(LNP2x3[91]+LNt[153])-LNP2x3[91];	//[4,27]<<46
  LNt[153] -= LNt[155];
  LNt[156] = LNt[145]+LNt[154]+LNt[155];
  LNt[157] = float(LNP2x3[118]+LNt[156])-LNP2x3[118];	//[22,49]<<69
  LNt[156] -= LNt[157];
  LNt[158] = float(LNP2x3[114]+LNt[156])-LNP2x3[114];	//[4,27]<<69
  LNt[156] -= LNt[158];
  LNt[159] = LNt[146]+LNt[157]+LNt[158];
  LNt[160] = (float(LNP2x3[125]+LNt[159]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[159] -= LNt[160];
  LNt[161] = (float(LNP2x3[125]+LNt[159]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[159] -= LNt[161];
  LNt[162] = LNt[136]*LNt[73]+LNt[138]*LNt[71]-(LNt[94]*LNt[143]+LNt[96]*LNt[141])+LNt[160]+LNt[161];
  LNt[163] = (float(LNP2x3[125]+LNt[162]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[162] -= LNt[163];
  LNt[164] = LNt[138]*LNt[73]-LNt[96]*LNt[143]+LNt[163];
  LNt[165] = (float(LNP2x3[125]+LNt[164]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[2,25]<<138
  LNt[164] -= LNt[165];
  LNt[166] = LNt[27]-LNt[129]+LNt[133];
  LNt[167] = LNt[19]*LNt[111]+LNt[21]*LNt[108]+LNt[124]*LNt[105]-(LNt[130]*LNt[153]+LNt[132]*LNt[150]+LNt[166]*LNt[147]);
  LNt[168] = LNt[19]*LNt[114]+LNt[21]*LNt[111]+LNt[124]*LNt[108]-(LNt[130]*LNt[156]+LNt[132]*LNt[153]+LNt[166]*LNt[150]);
  LNt[169] = LNt[19]*LNt[117]+LNt[21]*LNt[114]+LNt[124]*LNt[111]-(LNt[130]*LNt[159]+LNt[132]*LNt[156]+LNt[166]*LNt[153]);
  LNt[170] = LNt[19]*LNt[120]+LNt[21]*LNt[117]+LNt[124]*LNt[114]-(LNt[130]*LNt[162]+LNt[132]*LNt[159]+LNt[166]*LNt[156]);
  LNt[171] = LNt[19]*LNt[122]+LNt[21]*LNt[120]+LNt[124]*LNt[117]-(LNt[130]*LNt[164]+LNt[132]*LNt[162]+LNt[166]*LNt[159]);
  LNt[172] = LNt[19]*LNt[123]+LNt[21]*LNt[122]+LNt[124]*LNt[120]-(LNt[130]*LNt[165]+LNt[132]*LNt[164]+LNt[166]*LNt[162]);
  LNt[173] = LNt[14]*LNt[18]+LNt[17]*LNt[17]+LNt[18]*LNt[14]+LNt[125]*LNt[129]+LNt[128]*LNt[128]+LNt[129]*LNt[125];
  LNt[174] = b.w;
  LNt[175] = float(LNP2x3[74]+LNt[174])-LNP2x3[74];	//[1,53]<<0
  LNt[174] -= LNt[175];
  LNt[176] = LNt[14]*LNt[14]+LNt[125]*LNt[125]-LNt[174];
  LNt[177] = float(LNP2x3[74]+LNt[176])-LNP2x3[74];	//[1,53]<<0
  LNt[176] -= LNt[177];
  LNt[178] = LNt[14]*LNt[17]+LNt[17]*LNt[14]+LNt[125]*LNt[128]+LNt[128]*LNt[125]-LNt[175]+LNt[177];
  LNt[179] = LNt[41]-LNt[176];
  LNt[180] = float(LNP2x3[53]+LNt[179])-LNP2x3[53];	//[22,53]<<0
  LNt[179] -= LNt[180];
  LNt[181] = float(LNP2x3[45]+LNt[179])-LNP2x3[45];	//[8,31]<<0
  LNt[179] -= LNt[181];
  LNt[182] = LNt[43]-LNt[178]+LNt[180]+LNt[181];
  LNt[183] = float(LNP2x3[73]+LNt[182])-LNP2x3[73];	//[22,50]<<23
  LNt[182] -= LNt[183];
  LNt[184] = float(LNP2x3[68]+LNt[182])-LNP2x3[68];	//[5,28]<<23
  LNt[182] -= LNt[184];
  LNt[185] = LNt[38]-LNt[173]+LNt[183]+LNt[184];
  LNt[186] = float(LNP2x3[96]+LNt[185])-LNP2x3[96];	//[22,50]<<46
  LNt[185] -= LNt[186];
  LNt[187] = float(LNP2x3[91]+LNt[185])-LNP2x3[91];	//[5,28]<<46
  LNt[185] -= LNt[187];
  LNt[188] = LNt[44]-(LNt[17]*LNt[18]+LNt[18]*LNt[17]+LNt[128]*LNt[129]+LNt[129]*LNt[128])+LNt[186]+LNt[187];
  LNt[189] = float(LNP2x3[114]+LNt[188])-LNP2x3[114];	//[10,33]<<69
  LNt[188] -= LNt[189];
  LNt[190] = LNt[134]*LNt[101]+LNt[136]*LNt[99]+LNt[138]*LNt[97]-(LNt[33]*LNt[143]+LNt[35]*LNt[141]+LNt[37]*LNt[139]);
  LNt[191] = LNt[134]*LNt[97]-LNt[33]*LNt[139];
  LNt[192] = float(LNP2x3[47]+LNt[191])-LNP2x3[47];	//[22,47]<<0
  LNt[191] -= LNt[192];
  LNt[193] = float(LNP2x3[45]+LNt[191])-LNP2x3[45];	//[2,25]<<0
  LNt[191] -= LNt[193];
  LNt[194] = LNt[134]*LNt[99]+LNt[136]*LNt[97]-(LNt[33]*LNt[141]+LNt[35]*LNt[139])+LNt[192]+LNt[193];
  LNt[195] = float(LNP2x3[71]+LNt[194])-LNP2x3[71];	//[22,48]<<23
  LNt[194] -= LNt[195];
  LNt[196] = float(LNP2x3[68]+LNt[194])-LNP2x3[68];	//[3,26]<<23
  LNt[194] -= LNt[196];
  LNt[197] = LNt[190]+LNt[195]+LNt[196];
  LNt[198] = float(LNP2x3[95]+LNt[197])-LNP2x3[95];	//[22,49]<<46
  LNt[197] -= LNt[198];
  LNt[199] = float(LNP2x3[91]+LNt[197])-LNP2x3[91];	//[4,27]<<46
  LNt[197] -= LNt[199];
  LNt[200] = LNt[136]*LNt[101]+LNt[138]*LNt[99]-(LNt[35]*LNt[143]+LNt[37]*LNt[141])+LNt[198]+LNt[199];
  LNt[201] = float(LNP2x3[114]+LNt[200])-LNP2x3[114];	//[10,33]<<69
  LNt[200] -= LNt[201];
  LNt[202] = LNt[138]*LNt[101]-LNt[37]*LNt[143]+LNt[201];
  LNt[203] = LNt[45]-(LNt[18]*LNt[18]+LNt[129]*LNt[129])+LNt[189];
  LNt[204] = LNt[179]*LNt[202]+LNt[182]*LNt[200]+LNt[185]*LNt[197]+LNt[188]*LNt[194]+LNt[203]*LNt[191];
  LNt[205] = LNt[19]*LNt[108]+LNt[21]*LNt[105]-(LNt[130]*LNt[150]+LNt[132]*LNt[147])+LNt[179]*LNt[194]+LNt[182]*LNt[191];
  LNt[206] = LNt[21]*LNt[123]+LNt[124]*LNt[122]-(LNt[132]*LNt[165]+LNt[166]*LNt[164])+LNt[203]*LNt[202];
  LNt[207] = LNt[19]*LNt[105]-LNt[130]*LNt[147]+LNt[179]*LNt[191];
  LNt[208] = LNt[167]+LNt[179]*LNt[197]+LNt[182]*LNt[194]+LNt[185]*LNt[191];
  LNt[209] = LNt[168]+LNt[179]*LNt[200]+LNt[182]*LNt[197]+LNt[185]*LNt[194]+LNt[188]*LNt[191];
  LNt[210] = LNt[169]+LNt[204];
  LNt[211] = LNt[170]+LNt[182]*LNt[202]+LNt[185]*LNt[200]+LNt[188]*LNt[197]+LNt[203]*LNt[194];
  LNt[212] = LNt[171]+LNt[185]*LNt[202]+LNt[188]*LNt[200]+LNt[203]*LNt[197];
  LNt[213] = LNt[172]+LNt[188]*LNt[202]+LNt[203]*LNt[200];
  LNt[214] = LNt[124]*LNt[123]-LNt[166]*LNt[165];
  LNt[215] = (((((((LNt[214])+LNt[206])+LNt[213])+LNt[212])+LNt[211])+LNt[210])+LNt[209])+LNt[208];
  LNt[8] = (((LNt[215])+LNt[205])+LNt[207]);
}
if (LNt[8]<0){
  LNt[0] = -1.;
}else{
  if (LNt[8]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=320 multiplies=240 normalizes=96 */


WLPoint2d::WLPoint2d(const integer x, const integer y, const integer w){
LNt[0] = x;
LNt[1] = float(LNP2x3[53]+LNt[0])-LNP2x3[53];	//[22,53]<<0
LNt[0] -= LNt[1];
LNt[2] = float(LNP2x3[45]+LNt[0])-LNP2x3[45];	//[8,31]<<0
LNt[0] -= LNt[2];
LNt[3] = LNt[1]+LNt[2];
LNt[4] = float(LNP2x3[68]+LNt[3])-LNP2x3[68];	//[7,30]<<23
LNt[3] -= LNt[4];
LNt[5] = y;
LNt[6] = float(LNP2x3[53]+LNt[5])-LNP2x3[53];	//[22,53]<<0
LNt[5] -= LNt[6];
LNt[7] = float(LNP2x3[45]+LNt[5])-LNP2x3[45];	//[8,31]<<0
LNt[5] -= LNt[7];
LNt[8] = LNt[6]+LNt[7];
LNt[9] = float(LNP2x3[68]+LNt[8])-LNP2x3[68];	//[7,30]<<23
LNt[8] -= LNt[9];
LNt[10] = LNt[0]*LNt[4]+LNt[3]*LNt[3]+LNt[4]*LNt[0]+LNt[5]*LNt[9]+LNt[8]*LNt[8]+LNt[9]*LNt[5];
LNt[11] = w;
LNt[12] = float(LNP2x3[74]+LNt[11])-LNP2x3[74];	//[1,53]<<0
LNt[11] -= LNt[12];
(*this).x = LNt[0];
(*this).y = LNt[5];
(*this).z.v0 = LNt[0]*LNt[0]+LNt[5]*LNt[5]-LNt[11];
LNt[13] = float(LNP2x3[53]+(*this).z.v0)-LNP2x3[53];	//[22,53]<<0
(*this).z.v0 -= LNt[13];
LNt[14] = float(LNP2x3[45]+(*this).z.v0)-LNP2x3[45];	//[8,31]<<0
(*this).z.v0 -= LNt[14];
(*this).z.v1 = LNt[0]*LNt[3]+LNt[3]*LNt[0]+LNt[5]*LNt[8]+LNt[8]*LNt[5]-LNt[12]+LNt[13]+LNt[14];
LNt[15] = float(LNP2x3[72]+(*this).z.v1)-LNP2x3[72];	//[22,49]<<23
(*this).z.v1 -= LNt[15];
LNt[16] = float(LNP2x3[68]+(*this).z.v1)-LNP2x3[68];	//[4,27]<<23
(*this).z.v1 -= LNt[16];
(*this).z.v2 = LNt[10]+LNt[15]+LNt[16];
LNt[17] = float(LNP2x3[95]+(*this).z.v2)-LNP2x3[95];	//[22,49]<<46
(*this).z.v2 -= LNt[17];
LNt[18] = float(LNP2x3[86]+(*this).z.v2)-LNP2x3[86];	//[9,27]<<46
(*this).z.v2 -= LNt[18];
} /* adds=22 multiplies=18 normalizes=13 */


integer wincircle2d(const WLPoint2d& a, const WLPoint2d& b, const WLPoint2d& c, const WLPoint2d& d){
integer LNans;
LNt[1] = a.y-c.y;
LNt[2] = a.z.v2+a.z.v1+a.z.v0;
LNt[3] = LNt[2]-(d.z.v2+d.z.v1+d.z.v0);
LNt[4] = LNt[2]-(c.z.v2+c.z.v1+c.z.v0);
LNt[5] = a.y-d.y;
LNt[6] = a.x-c.x;
LNt[7] = a.x-d.x;
LNt[8] = (a.x-b.x)*(LNt[1]*LNt[3]-LNt[4]*LNt[5])-(a.y-b.y)*(LNt[6]*LNt[3]-LNt[4]*LNt[7])+(LNt[2]-(b.z.v2+b.z.v1+b.z.v0))*(LNt[6]*LNt[5]-LNt[1]*LNt[7]);
if (-LNP2[130]<LNt[8] && LNt[8]<LNP2[130]) {	/* the high order 46 bits of 176 are accurate */
  LNt[9] = a.x;
  LNt[10] = float(LNP2x3[74]+LNt[9])-LNP2x3[74];	//[1,53]<<0
  LNt[9] -= LNt[10];
  LNt[11] = b.x;
  LNt[12] = float(LNP2x3[74]+LNt[11])-LNP2x3[74];	//[1,53]<<0
  LNt[11] -= LNt[12];
  LNt[13] = LNt[9]-LNt[11];
  LNt[14] = float(LNP2x3[53]+LNt[13])-LNP2x3[53];	//[22,53]<<0
  LNt[13] -= LNt[14];
  LNt[15] = float(LNP2x3[45]+LNt[13])-LNP2x3[45];	//[8,31]<<0
  LNt[13] -= LNt[15];
  LNt[16] = LNt[10]-LNt[12]+LNt[14]+LNt[15];
  LNt[17] = float(LNP2x3[68]+LNt[16])-LNP2x3[68];	//[7,30]<<23
  LNt[16] -= LNt[17];
  LNt[18] = a.y;
  LNt[19] = float(LNP2x3[74]+LNt[18])-LNP2x3[74];	//[1,53]<<0
  LNt[18] -= LNt[19];
  LNt[20] = c.y;
  LNt[21] = float(LNP2x3[74]+LNt[20])-LNP2x3[74];	//[1,53]<<0
  LNt[20] -= LNt[21];
  LNt[22] = LNt[18]-LNt[20];
  LNt[23] = float(LNP2x3[53]+LNt[22])-LNP2x3[53];	//[22,53]<<0
  LNt[22] -= LNt[23];
  LNt[24] = float(LNP2x3[45]+LNt[22])-LNP2x3[45];	//[8,31]<<0
  LNt[22] -= LNt[24];
  LNt[25] = LNt[19]-LNt[21]+LNt[23]+LNt[24];
  LNt[26] = float(LNP2x3[68]+LNt[25])-LNP2x3[68];	//[7,30]<<23
  LNt[25] -= LNt[26];
  LNt[27] = a.z.v0-d.z.v0;
  LNt[28] = float(LNP2x3[45]+LNt[27])-LNP2x3[45];	//[1,24]<<0
  LNt[27] -= LNt[28];
  LNt[29] = a.z.v1-d.z.v1+LNt[28];
  LNt[30] = float(LNP2x3[68]+LNt[29])-LNP2x3[68];	//[1,24]<<23
  LNt[29] -= LNt[30];
  LNt[31] = a.z.v2-d.z.v2+LNt[30];
  LNt[32] = a.z.v0-c.z.v0;
  LNt[33] = float(LNP2x3[45]+LNt[32])-LNP2x3[45];	//[1,24]<<0
  LNt[32] -= LNt[33];
  LNt[34] = a.z.v1-c.z.v1+LNt[33];
  LNt[35] = float(LNP2x3[68]+LNt[34])-LNP2x3[68];	//[1,24]<<23
  LNt[34] -= LNt[35];
  LNt[36] = a.z.v2-c.z.v2+LNt[35];
  LNt[37] = d.y;
  LNt[38] = float(LNP2x3[74]+LNt[37])-LNP2x3[74];	//[1,53]<<0
  LNt[37] -= LNt[38];
  LNt[39] = LNt[18]-LNt[37];
  LNt[40] = float(LNP2x3[53]+LNt[39])-LNP2x3[53];	//[22,53]<<0
  LNt[39] -= LNt[40];
  LNt[41] = float(LNP2x3[45]+LNt[39])-LNP2x3[45];	//[8,31]<<0
  LNt[39] -= LNt[41];
  LNt[42] = LNt[19]-LNt[38]+LNt[40]+LNt[41];
  LNt[43] = float(LNP2x3[68]+LNt[42])-LNP2x3[68];	//[7,30]<<23
  LNt[42] -= LNt[43];
  LNt[44] = LNt[22]*LNt[31]+LNt[25]*LNt[29]+LNt[26]*LNt[27]-(LNt[32]*LNt[43]+LNt[34]*LNt[42]+LNt[36]*LNt[39]);
  LNt[45] = LNt[22]*LNt[27]-LNt[32]*LNt[39];
  LNt[46] = float(LNP2x3[47]+LNt[45])-LNP2x3[47];	//[22,47]<<0
  LNt[45] -= LNt[46];
  LNt[47] = float(LNP2x3[45]+LNt[45])-LNP2x3[45];	//[2,25]<<0
  LNt[45] -= LNt[47];
  LNt[48] = LNt[22]*LNt[29]+LNt[25]*LNt[27]-(LNt[32]*LNt[42]+LNt[34]*LNt[39])+LNt[46]+LNt[47];
  LNt[49] = float(LNP2x3[71]+LNt[48])-LNP2x3[71];	//[22,48]<<23
  LNt[48] -= LNt[49];
  LNt[50] = float(LNP2x3[68]+LNt[48])-LNP2x3[68];	//[3,26]<<23
  LNt[48] -= LNt[50];
  LNt[51] = LNt[44]+LNt[49]+LNt[50];
  LNt[52] = float(LNP2x3[95]+LNt[51])-LNP2x3[95];	//[22,49]<<46
  LNt[51] -= LNt[52];
  LNt[53] = float(LNP2x3[91]+LNt[51])-LNP2x3[91];	//[4,27]<<46
  LNt[51] -= LNt[53];
  LNt[54] = LNt[25]*LNt[31]+LNt[26]*LNt[29]-(LNt[34]*LNt[43]+LNt[36]*LNt[42])+LNt[52]+LNt[53];
  LNt[55] = float(LNP2x3[114]+LNt[54])-LNP2x3[114];	//[21,44]<<69
  LNt[54] -= LNt[55];
  LNt[56] = LNt[26]*LNt[31]-LNt[36]*LNt[43]+LNt[55];
  LNt[57] = (float(LNP2x3[125]+LNt[56]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[56] -= LNt[57];
  LNt[58] = b.y;
  LNt[59] = float(LNP2x3[74]+LNt[58])-LNP2x3[74];	//[1,53]<<0
  LNt[58] -= LNt[59];
  LNt[60] = LNt[18]-LNt[58];
  LNt[61] = float(LNP2x3[53]+LNt[60])-LNP2x3[53];	//[22,53]<<0
  LNt[60] -= LNt[61];
  LNt[62] = float(LNP2x3[45]+LNt[60])-LNP2x3[45];	//[8,31]<<0
  LNt[60] -= LNt[62];
  LNt[63] = LNt[19]-LNt[59]+LNt[61]+LNt[62];
  LNt[64] = float(LNP2x3[68]+LNt[63])-LNP2x3[68];	//[7,30]<<23
  LNt[63] -= LNt[64];
  LNt[65] = c.x;
  LNt[66] = float(LNP2x3[74]+LNt[65])-LNP2x3[74];	//[1,53]<<0
  LNt[65] -= LNt[66];
  LNt[67] = LNt[9]-LNt[65];
  LNt[68] = float(LNP2x3[53]+LNt[67])-LNP2x3[53];	//[22,53]<<0
  LNt[67] -= LNt[68];
  LNt[69] = float(LNP2x3[45]+LNt[67])-LNP2x3[45];	//[8,31]<<0
  LNt[67] -= LNt[69];
  LNt[70] = LNt[10]-LNt[66]+LNt[68]+LNt[69];
  LNt[71] = float(LNP2x3[68]+LNt[70])-LNP2x3[68];	//[7,30]<<23
  LNt[70] -= LNt[71];
  LNt[72] = d.x;
  LNt[73] = float(LNP2x3[74]+LNt[72])-LNP2x3[74];	//[1,53]<<0
  LNt[72] -= LNt[73];
  LNt[74] = LNt[9]-LNt[72];
  LNt[75] = float(LNP2x3[53]+LNt[74])-LNP2x3[53];	//[22,53]<<0
  LNt[74] -= LNt[75];
  LNt[76] = float(LNP2x3[45]+LNt[74])-LNP2x3[45];	//[8,31]<<0
  LNt[74] -= LNt[76];
  LNt[77] = LNt[10]-LNt[73]+LNt[75]+LNt[76];
  LNt[78] = float(LNP2x3[68]+LNt[77])-LNP2x3[68];	//[7,30]<<23
  LNt[77] -= LNt[78];
  LNt[79] = LNt[67]*LNt[31]+LNt[70]*LNt[29]+LNt[71]*LNt[27]-(LNt[32]*LNt[78]+LNt[34]*LNt[77]+LNt[36]*LNt[74]);
  LNt[80] = LNt[67]*LNt[27]-LNt[32]*LNt[74];
  LNt[81] = float(LNP2x3[47]+LNt[80])-LNP2x3[47];	//[22,47]<<0
  LNt[80] -= LNt[81];
  LNt[82] = float(LNP2x3[45]+LNt[80])-LNP2x3[45];	//[2,25]<<0
  LNt[80] -= LNt[82];
  LNt[83] = LNt[67]*LNt[29]+LNt[70]*LNt[27]-(LNt[32]*LNt[77]+LNt[34]*LNt[74])+LNt[81]+LNt[82];
  LNt[84] = float(LNP2x3[71]+LNt[83])-LNP2x3[71];	//[22,48]<<23
  LNt[83] -= LNt[84];
  LNt[85] = float(LNP2x3[68]+LNt[83])-LNP2x3[68];	//[3,26]<<23
  LNt[83] -= LNt[85];
  LNt[86] = LNt[79]+LNt[84]+LNt[85];
  LNt[87] = float(LNP2x3[95]+LNt[86])-LNP2x3[95];	//[22,49]<<46
  LNt[86] -= LNt[87];
  LNt[88] = float(LNP2x3[91]+LNt[86])-LNP2x3[91];	//[4,27]<<46
  LNt[86] -= LNt[88];
  LNt[89] = LNt[70]*LNt[31]+LNt[71]*LNt[29]-(LNt[34]*LNt[78]+LNt[36]*LNt[77])+LNt[87]+LNt[88];
  LNt[90] = float(LNP2x3[114]+LNt[89])-LNP2x3[114];	//[21,44]<<69
  LNt[89] -= LNt[90];
  LNt[91] = LNt[71]*LNt[31]-LNt[36]*LNt[78]+LNt[90];
  LNt[92] = (float(LNP2x3[125]+LNt[91]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[91] -= LNt[92];
  LNt[93] = LNt[13]*LNt[51]+LNt[16]*LNt[48]+LNt[17]*LNt[45]-(LNt[60]*LNt[86]+LNt[63]*LNt[83]+LNt[64]*LNt[80]);
  LNt[94] = LNt[13]*LNt[54]+LNt[16]*LNt[51]+LNt[17]*LNt[48]-(LNt[60]*LNt[89]+LNt[63]*LNt[86]+LNt[64]*LNt[83]);
  LNt[95] = LNt[13]*LNt[56]+LNt[16]*LNt[54]+LNt[17]*LNt[51]-(LNt[60]*LNt[91]+LNt[63]*LNt[89]+LNt[64]*LNt[86]);
  LNt[96] = LNt[13]*LNt[57]+LNt[16]*LNt[56]+LNt[17]*LNt[54]-(LNt[60]*LNt[92]+LNt[63]*LNt[91]+LNt[64]*LNt[89]);
  LNt[97] = a.z.v0-b.z.v0;
  LNt[98] = float(LNP2x3[45]+LNt[97])-LNP2x3[45];	//[1,24]<<0
  LNt[97] -= LNt[98];
  LNt[99] = a.z.v1-b.z.v1+LNt[98];
  LNt[100] = float(LNP2x3[68]+LNt[99])-LNP2x3[68];	//[1,24]<<23
  LNt[99] -= LNt[100];
  LNt[101] = LNt[67]*LNt[43]+LNt[70]*LNt[42]+LNt[71]*LNt[39]-(LNt[22]*LNt[78]+LNt[25]*LNt[77]+LNt[26]*LNt[74]);
  LNt[102] = LNt[67]*LNt[39]-LNt[22]*LNt[74];
  LNt[103] = float(LNP2x3[47]+LNt[102])-LNP2x3[47];	//[22,47]<<0
  LNt[102] -= LNt[103];
  LNt[104] = float(LNP2x3[45]+LNt[102])-LNP2x3[45];	//[2,25]<<0
  LNt[102] -= LNt[104];
  LNt[105] = LNt[67]*LNt[42]+LNt[70]*LNt[39]-(LNt[22]*LNt[77]+LNt[25]*LNt[74])+LNt[103]+LNt[104];
  LNt[106] = float(LNP2x3[71]+LNt[105])-LNP2x3[71];	//[22,48]<<23
  LNt[105] -= LNt[106];
  LNt[107] = float(LNP2x3[68]+LNt[105])-LNP2x3[68];	//[3,26]<<23
  LNt[105] -= LNt[107];
  LNt[108] = LNt[101]+LNt[106]+LNt[107];
  LNt[109] = float(LNP2x3[95]+LNt[108])-LNP2x3[95];	//[22,49]<<46
  LNt[108] -= LNt[109];
  LNt[110] = float(LNP2x3[91]+LNt[108])-LNP2x3[91];	//[4,27]<<46
  LNt[108] -= LNt[110];
  LNt[111] = LNt[70]*LNt[43]+LNt[71]*LNt[42]-(LNt[25]*LNt[78]+LNt[26]*LNt[77])+LNt[109]+LNt[110];
  LNt[112] = float(LNP2x3[114]+LNt[111])-LNP2x3[114];	//[9,32]<<69
  LNt[111] -= LNt[112];
  LNt[113] = LNt[71]*LNt[43]-LNt[26]*LNt[78]+LNt[112];
  LNt[114] = a.z.v2-b.z.v2+LNt[100];
  LNt[115] = LNt[13]*LNt[48]+LNt[16]*LNt[45]-(LNt[60]*LNt[83]+LNt[63]*LNt[80])+LNt[97]*LNt[105]+LNt[99]*LNt[102];
  LNt[116] = LNt[16]*LNt[57]+LNt[17]*LNt[56]-(LNt[63]*LNt[92]+LNt[64]*LNt[91])+LNt[114]*LNt[113];
  LNt[117] = LNt[13]*LNt[45]-LNt[60]*LNt[80]+LNt[97]*LNt[102];
  LNt[118] = LNt[93]+LNt[97]*LNt[108]+LNt[99]*LNt[105]+LNt[114]*LNt[102];
  LNt[119] = LNt[94]+LNt[97]*LNt[111]+LNt[99]*LNt[108]+LNt[114]*LNt[105];
  LNt[120] = LNt[95]+LNt[97]*LNt[113]+LNt[99]*LNt[111]+LNt[114]*LNt[108];
  LNt[121] = LNt[96]+LNt[99]*LNt[113]+LNt[114]*LNt[111];
  LNt[122] = LNt[17]*LNt[57]-LNt[64]*LNt[92];
  LNt[123] = (((((((LNt[122])+LNt[116])+LNt[121])+LNt[120])+LNt[119])+LNt[118])+LNt[115])+LNt[117];
  LNt[8] = (LNt[123]);
}
if (LNt[8]<0){
  LNt[0] = -1.;
}else{
  if (LNt[8]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=171 multiplies=114 normalizes=55 */


integer orient4d(const Point4d& a, const Point4d& b, const Point4d& c, const Point4d& d, const Point4d& e){
integer LNans;
LNt[1] = c.y-e.y;
LNt[2] = a.z-e.z;
LNt[3] = b.w-e.w;
LNt[4] = b.z-e.z;
LNt[5] = a.w-e.w;
LNt[6] = LNt[2]*LNt[3]-LNt[4]*LNt[5];
LNt[7] = c.z-e.z;
LNt[8] = a.y-e.y;
LNt[9] = b.y-e.y;
LNt[10] = LNt[8]*LNt[3]-LNt[9]*LNt[5];
LNt[11] = c.w-e.w;
LNt[12] = LNt[8]*LNt[4]-LNt[9]*LNt[2];
LNt[13] = c.x-e.x;
LNt[14] = a.x-e.x;
LNt[15] = b.x-e.x;
LNt[16] = LNt[14]*LNt[3]-LNt[5]*LNt[15];
LNt[17] = LNt[14]*LNt[4]-LNt[2]*LNt[15];
LNt[18] = (0.-(d.x-e.x))*(LNt[1]*LNt[6]-LNt[7]*LNt[10]+LNt[11]*LNt[12])+(d.y-e.y)*(LNt[13]*LNt[6]-LNt[7]*LNt[16]+LNt[11]*LNt[17]);
LNt[19] = LNt[14]*LNt[9]-LNt[8]*LNt[15];
LNt[20] = LNt[18]-(d.z-e.z)*(LNt[13]*LNt[10]-LNt[1]*LNt[16]+LNt[11]*LNt[19])+(d.w-e.w)*(LNt[13]*LNt[12]-LNt[1]*LNt[17]+LNt[7]*LNt[19]);
if (-LNP2[180]<LNt[20] && LNt[20]<LNP2[180]) {	/* the high order 43 bits of 223 are accurate */
  LNt[21] = d.x;
  LNt[22] = float(LNP2x3[74]+LNt[21])-LNP2x3[74];	//[1,53]<<0
  LNt[21] -= LNt[22];
  LNt[23] = e.x;
  LNt[24] = float(LNP2x3[74]+LNt[23])-LNP2x3[74];	//[1,53]<<0
  LNt[23] -= LNt[24];
  LNt[25] = LNt[21]-LNt[23];
  LNt[26] = float(LNP2x3[74]+LNt[25])-LNP2x3[74];	//[1,53]<<0
  LNt[25] -= LNt[26];
  LNt[27] = 0.-LNt[25];
  LNt[28] = float(LNP2x3[53]+LNt[27])-LNP2x3[53];	//[22,53]<<0
  LNt[27] -= LNt[28];
  LNt[29] = float(LNP2x3[45]+LNt[27])-LNP2x3[45];	//[8,31]<<0
  LNt[27] -= LNt[29];
  LNt[30] = 0.0-(LNt[22]-LNt[24]+LNt[26])+LNt[28]+LNt[29];
  LNt[31] = float(LNP2x3[68]+LNt[30])-LNP2x3[68];	//[7,30]<<23
  LNt[30] -= LNt[31];
  LNt[32] = c.y;
  LNt[33] = float(LNP2x3[74]+LNt[32])-LNP2x3[74];	//[1,53]<<0
  LNt[32] -= LNt[33];
  LNt[34] = e.y;
  LNt[35] = float(LNP2x3[74]+LNt[34])-LNP2x3[74];	//[1,53]<<0
  LNt[34] -= LNt[35];
  LNt[36] = LNt[32]-LNt[34];
  LNt[37] = float(LNP2x3[53]+LNt[36])-LNP2x3[53];	//[22,53]<<0
  LNt[36] -= LNt[37];
  LNt[38] = float(LNP2x3[45]+LNt[36])-LNP2x3[45];	//[8,31]<<0
  LNt[36] -= LNt[38];
  LNt[39] = LNt[33]-LNt[35]+LNt[37]+LNt[38];
  LNt[40] = float(LNP2x3[68]+LNt[39])-LNP2x3[68];	//[7,30]<<23
  LNt[39] -= LNt[40];
  LNt[41] = a.z;
  LNt[42] = float(LNP2x3[74]+LNt[41])-LNP2x3[74];	//[1,53]<<0
  LNt[41] -= LNt[42];
  LNt[43] = e.z;
  LNt[44] = float(LNP2x3[74]+LNt[43])-LNP2x3[74];	//[1,53]<<0
  LNt[43] -= LNt[44];
  LNt[45] = LNt[41]-LNt[43];
  LNt[46] = float(LNP2x3[53]+LNt[45])-LNP2x3[53];	//[22,53]<<0
  LNt[45] -= LNt[46];
  LNt[47] = float(LNP2x3[45]+LNt[45])-LNP2x3[45];	//[8,31]<<0
  LNt[45] -= LNt[47];
  LNt[48] = LNt[42]-LNt[44]+LNt[46]+LNt[47];
  LNt[49] = float(LNP2x3[68]+LNt[48])-LNP2x3[68];	//[7,30]<<23
  LNt[48] -= LNt[49];
  LNt[50] = b.w;
  LNt[51] = float(LNP2x3[74]+LNt[50])-LNP2x3[74];	//[1,53]<<0
  LNt[50] -= LNt[51];
  LNt[52] = e.w;
  LNt[53] = float(LNP2x3[74]+LNt[52])-LNP2x3[74];	//[1,53]<<0
  LNt[52] -= LNt[53];
  LNt[54] = LNt[50]-LNt[52];
  LNt[55] = float(LNP2x3[53]+LNt[54])-LNP2x3[53];	//[22,53]<<0
  LNt[54] -= LNt[55];
  LNt[56] = float(LNP2x3[45]+LNt[54])-LNP2x3[45];	//[8,31]<<0
  LNt[54] -= LNt[56];
  LNt[57] = LNt[51]-LNt[53]+LNt[55]+LNt[56];
  LNt[58] = float(LNP2x3[68]+LNt[57])-LNP2x3[68];	//[7,30]<<23
  LNt[57] -= LNt[58];
  LNt[59] = b.z;
  LNt[60] = float(LNP2x3[74]+LNt[59])-LNP2x3[74];	//[1,53]<<0
  LNt[59] -= LNt[60];
  LNt[61] = LNt[59]-LNt[43];
  LNt[62] = float(LNP2x3[53]+LNt[61])-LNP2x3[53];	//[22,53]<<0
  LNt[61] -= LNt[62];
  LNt[63] = float(LNP2x3[45]+LNt[61])-LNP2x3[45];	//[8,31]<<0
  LNt[61] -= LNt[63];
  LNt[64] = LNt[60]-LNt[44]+LNt[62]+LNt[63];
  LNt[65] = float(LNP2x3[68]+LNt[64])-LNP2x3[68];	//[7,30]<<23
  LNt[64] -= LNt[65];
  LNt[66] = a.w;
  LNt[67] = float(LNP2x3[74]+LNt[66])-LNP2x3[74];	//[1,53]<<0
  LNt[66] -= LNt[67];
  LNt[68] = LNt[66]-LNt[52];
  LNt[69] = float(LNP2x3[53]+LNt[68])-LNP2x3[53];	//[22,53]<<0
  LNt[68] -= LNt[69];
  LNt[70] = float(LNP2x3[45]+LNt[68])-LNP2x3[45];	//[8,31]<<0
  LNt[68] -= LNt[70];
  LNt[71] = LNt[67]-LNt[53]+LNt[69]+LNt[70];
  LNt[72] = float(LNP2x3[68]+LNt[71])-LNP2x3[68];	//[7,30]<<23
  LNt[71] -= LNt[72];
  LNt[73] = LNt[45]*LNt[58]+LNt[48]*LNt[57]+LNt[49]*LNt[54]-(LNt[61]*LNt[72]+LNt[64]*LNt[71]+LNt[65]*LNt[68]);
  LNt[74] = LNt[45]*LNt[54]-LNt[61]*LNt[68];
  LNt[75] = float(LNP2x3[47]+LNt[74])-LNP2x3[47];	//[22,47]<<0
  LNt[74] -= LNt[75];
  LNt[76] = float(LNP2x3[45]+LNt[74])-LNP2x3[45];	//[2,25]<<0
  LNt[74] -= LNt[76];
  LNt[77] = LNt[45]*LNt[57]+LNt[48]*LNt[54]-(LNt[61]*LNt[71]+LNt[64]*LNt[68])+LNt[75]+LNt[76];
  LNt[78] = float(LNP2x3[71]+LNt[77])-LNP2x3[71];	//[22,48]<<23
  LNt[77] -= LNt[78];
  LNt[79] = float(LNP2x3[68]+LNt[77])-LNP2x3[68];	//[3,26]<<23
  LNt[77] -= LNt[79];
  LNt[80] = LNt[73]+LNt[78]+LNt[79];
  LNt[81] = float(LNP2x3[95]+LNt[80])-LNP2x3[95];	//[22,49]<<46
  LNt[80] -= LNt[81];
  LNt[82] = float(LNP2x3[91]+LNt[80])-LNP2x3[91];	//[4,27]<<46
  LNt[80] -= LNt[82];
  LNt[83] = LNt[48]*LNt[58]+LNt[49]*LNt[57]-(LNt[64]*LNt[72]+LNt[65]*LNt[71])+LNt[81]+LNt[82];
  LNt[84] = float(LNP2x3[114]+LNt[83])-LNP2x3[114];	//[9,32]<<69
  LNt[83] -= LNt[84];
  LNt[85] = LNt[49]*LNt[58]-LNt[65]*LNt[72]+LNt[84];
  LNt[86] = c.z;
  LNt[87] = float(LNP2x3[74]+LNt[86])-LNP2x3[74];	//[1,53]<<0
  LNt[86] -= LNt[87];
  LNt[88] = LNt[86]-LNt[43];
  LNt[89] = float(LNP2x3[53]+LNt[88])-LNP2x3[53];	//[22,53]<<0
  LNt[88] -= LNt[89];
  LNt[90] = float(LNP2x3[45]+LNt[88])-LNP2x3[45];	//[8,31]<<0
  LNt[88] -= LNt[90];
  LNt[91] = LNt[87]-LNt[44]+LNt[89]+LNt[90];
  LNt[92] = float(LNP2x3[68]+LNt[91])-LNP2x3[68];	//[7,30]<<23
  LNt[91] -= LNt[92];
  LNt[93] = a.y;
  LNt[94] = float(LNP2x3[74]+LNt[93])-LNP2x3[74];	//[1,53]<<0
  LNt[93] -= LNt[94];
  LNt[95] = LNt[93]-LNt[34];
  LNt[96] = float(LNP2x3[53]+LNt[95])-LNP2x3[53];	//[22,53]<<0
  LNt[95] -= LNt[96];
  LNt[97] = float(LNP2x3[45]+LNt[95])-LNP2x3[45];	//[8,31]<<0
  LNt[95] -= LNt[97];
  LNt[98] = LNt[94]-LNt[35]+LNt[96]+LNt[97];
  LNt[99] = float(LNP2x3[68]+LNt[98])-LNP2x3[68];	//[7,30]<<23
  LNt[98] -= LNt[99];
  LNt[100] = b.y;
  LNt[101] = float(LNP2x3[74]+LNt[100])-LNP2x3[74];	//[1,53]<<0
  LNt[100] -= LNt[101];
  LNt[102] = LNt[100]-LNt[34];
  LNt[103] = float(LNP2x3[53]+LNt[102])-LNP2x3[53];	//[22,53]<<0
  LNt[102] -= LNt[103];
  LNt[104] = float(LNP2x3[45]+LNt[102])-LNP2x3[45];	//[8,31]<<0
  LNt[102] -= LNt[104];
  LNt[105] = LNt[101]-LNt[35]+LNt[103]+LNt[104];
  LNt[106] = float(LNP2x3[68]+LNt[105])-LNP2x3[68];	//[7,30]<<23
  LNt[105] -= LNt[106];
  LNt[107] = LNt[95]*LNt[58]+LNt[98]*LNt[57]+LNt[99]*LNt[54]-(LNt[102]*LNt[72]+LNt[105]*LNt[71]+LNt[106]*LNt[68]);
  LNt[108] = LNt[95]*LNt[54]-LNt[102]*LNt[68];
  LNt[109] = float(LNP2x3[47]+LNt[108])-LNP2x3[47];	//[22,47]<<0
  LNt[108] -= LNt[109];
  LNt[110] = float(LNP2x3[45]+LNt[108])-LNP2x3[45];	//[2,25]<<0
  LNt[108] -= LNt[110];
  LNt[111] = LNt[95]*LNt[57]+LNt[98]*LNt[54]-(LNt[102]*LNt[71]+LNt[105]*LNt[68])+LNt[109]+LNt[110];
  LNt[112] = float(LNP2x3[71]+LNt[111])-LNP2x3[71];	//[22,48]<<23
  LNt[111] -= LNt[112];
  LNt[113] = float(LNP2x3[68]+LNt[111])-LNP2x3[68];	//[3,26]<<23
  LNt[111] -= LNt[113];
  LNt[114] = LNt[107]+LNt[112]+LNt[113];
  LNt[115] = float(LNP2x3[95]+LNt[114])-LNP2x3[95];	//[22,49]<<46
  LNt[114] -= LNt[115];
  LNt[116] = float(LNP2x3[91]+LNt[114])-LNP2x3[91];	//[4,27]<<46
  LNt[114] -= LNt[116];
  LNt[117] = LNt[98]*LNt[58]+LNt[99]*LNt[57]-(LNt[105]*LNt[72]+LNt[106]*LNt[71])+LNt[115]+LNt[116];
  LNt[118] = float(LNP2x3[114]+LNt[117])-LNP2x3[114];	//[9,32]<<69
  LNt[117] -= LNt[118];
  LNt[119] = LNt[99]*LNt[58]-LNt[106]*LNt[72]+LNt[118];
  LNt[120] = LNt[36]*LNt[80]+LNt[39]*LNt[77]+LNt[40]*LNt[74]-(LNt[88]*LNt[114]+LNt[91]*LNt[111]+LNt[92]*LNt[108]);
  LNt[121] = LNt[36]*LNt[83]+LNt[39]*LNt[80]+LNt[40]*LNt[77]-(LNt[88]*LNt[117]+LNt[91]*LNt[114]+LNt[92]*LNt[111]);
  LNt[122] = LNt[36]*LNt[85]+LNt[39]*LNt[83]+LNt[40]*LNt[80]-(LNt[88]*LNt[119]+LNt[91]*LNt[117]+LNt[92]*LNt[114]);
  LNt[123] = c.w;
  LNt[124] = float(LNP2x3[74]+LNt[123])-LNP2x3[74];	//[1,53]<<0
  LNt[123] -= LNt[124];
  LNt[125] = LNt[123]-LNt[52];
  LNt[126] = float(LNP2x3[53]+LNt[125])-LNP2x3[53];	//[22,53]<<0
  LNt[125] -= LNt[126];
  LNt[127] = float(LNP2x3[45]+LNt[125])-LNP2x3[45];	//[8,31]<<0
  LNt[125] -= LNt[127];
  LNt[128] = LNt[124]-LNt[53]+LNt[126]+LNt[127];
  LNt[129] = float(LNP2x3[68]+LNt[128])-LNP2x3[68];	//[7,30]<<23
  LNt[128] -= LNt[129];
  LNt[130] = LNt[95]*LNt[65]+LNt[98]*LNt[64]+LNt[99]*LNt[61]-(LNt[102]*LNt[49]+LNt[105]*LNt[48]+LNt[106]*LNt[45]);
  LNt[131] = LNt[95]*LNt[61]-LNt[102]*LNt[45];
  LNt[132] = float(LNP2x3[47]+LNt[131])-LNP2x3[47];	//[22,47]<<0
  LNt[131] -= LNt[132];
  LNt[133] = float(LNP2x3[45]+LNt[131])-LNP2x3[45];	//[2,25]<<0
  LNt[131] -= LNt[133];
  LNt[134] = LNt[95]*LNt[64]+LNt[98]*LNt[61]-(LNt[102]*LNt[48]+LNt[105]*LNt[45])+LNt[132]+LNt[133];
  LNt[135] = float(LNP2x3[71]+LNt[134])-LNP2x3[71];	//[22,48]<<23
  LNt[134] -= LNt[135];
  LNt[136] = float(LNP2x3[68]+LNt[134])-LNP2x3[68];	//[3,26]<<23
  LNt[134] -= LNt[136];
  LNt[137] = LNt[130]+LNt[135]+LNt[136];
  LNt[138] = float(LNP2x3[95]+LNt[137])-LNP2x3[95];	//[22,49]<<46
  LNt[137] -= LNt[138];
  LNt[139] = float(LNP2x3[91]+LNt[137])-LNP2x3[91];	//[4,27]<<46
  LNt[137] -= LNt[139];
  LNt[140] = LNt[98]*LNt[65]+LNt[99]*LNt[64]-(LNt[105]*LNt[49]+LNt[106]*LNt[48])+LNt[138]+LNt[139];
  LNt[141] = float(LNP2x3[114]+LNt[140])-LNP2x3[114];	//[9,32]<<69
  LNt[140] -= LNt[141];
  LNt[142] = LNt[99]*LNt[65]-LNt[106]*LNt[49]+LNt[141];
  LNt[143] = LNt[36]*LNt[77]+LNt[39]*LNt[74]-(LNt[88]*LNt[111]+LNt[91]*LNt[108])+LNt[125]*LNt[134]+LNt[128]*LNt[131];
  LNt[144] = LNt[39]*LNt[85]+LNt[40]*LNt[83]-(LNt[91]*LNt[119]+LNt[92]*LNt[117])+LNt[128]*LNt[142]+LNt[129]*LNt[140];
  LNt[145] = LNt[36]*LNt[74]-LNt[88]*LNt[108]+LNt[125]*LNt[131];
  LNt[146] = float(LNP2x3[48]+LNt[145])-LNP2x3[48];	//[22,48]<<0
  LNt[145] -= LNt[146];
  LNt[147] = float(LNP2x3[45]+LNt[145])-LNP2x3[45];	//[3,26]<<0
  LNt[145] -= LNt[147];
  LNt[148] = LNt[143]+LNt[146]+LNt[147];
  LNt[149] = float(LNP2x3[72]+LNt[148])-LNP2x3[72];	//[22,49]<<23
  LNt[148] -= LNt[149];
  LNt[150] = float(LNP2x3[68]+LNt[148])-LNP2x3[68];	//[4,27]<<23
  LNt[148] -= LNt[150];
  LNt[151] = LNt[120]+LNt[125]*LNt[137]+LNt[128]*LNt[134]+LNt[129]*LNt[131]+LNt[149]+LNt[150];
  LNt[152] = float(LNP2x3[96]+LNt[151])-LNP2x3[96];	//[22,50]<<46
  LNt[151] -= LNt[152];
  LNt[153] = float(LNP2x3[91]+LNt[151])-LNP2x3[91];	//[5,28]<<46
  LNt[151] -= LNt[153];
  LNt[154] = LNt[121]+LNt[125]*LNt[140]+LNt[128]*LNt[137]+LNt[129]*LNt[134]+LNt[152]+LNt[153];
  LNt[155] = float(LNP2x3[119]+LNt[154])-LNP2x3[119];	//[22,50]<<69
  LNt[154] -= LNt[155];
  LNt[156] = float(LNP2x3[114]+LNt[154])-LNP2x3[114];	//[5,28]<<69
  LNt[154] -= LNt[156];
  LNt[157] = LNt[122]+LNt[125]*LNt[142]+LNt[128]*LNt[140]+LNt[129]*LNt[137]+LNt[155]+LNt[156];
  LNt[158] = (float(LNP2x3[125]+LNt[157]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[157] -= LNt[158];
  LNt[159] = (float(LNP2x3[125]+LNt[157]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[157] -= LNt[159];
  LNt[160] = LNt[144]+LNt[158]+LNt[159];
  LNt[161] = (float(LNP2x3[125]+LNt[160]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[160] -= LNt[161];
  LNt[162] = LNt[40]*LNt[85]-LNt[92]*LNt[119]+LNt[129]*LNt[142]+LNt[161];
  LNt[163] = (float(LNP2x3[125]+LNt[162]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[162] -= LNt[163];
  LNt[164] = d.y;
  LNt[165] = float(LNP2x3[74]+LNt[164])-LNP2x3[74];	//[1,53]<<0
  LNt[164] -= LNt[165];
  LNt[166] = LNt[164]-LNt[34];
  LNt[167] = float(LNP2x3[53]+LNt[166])-LNP2x3[53];	//[22,53]<<0
  LNt[166] -= LNt[167];
  LNt[168] = float(LNP2x3[45]+LNt[166])-LNP2x3[45];	//[8,31]<<0
  LNt[166] -= LNt[168];
  LNt[169] = LNt[165]-LNt[35]+LNt[167]+LNt[168];
  LNt[170] = float(LNP2x3[68]+LNt[169])-LNP2x3[68];	//[7,30]<<23
  LNt[169] -= LNt[170];
  LNt[171] = c.x;
  LNt[172] = float(LNP2x3[74]+LNt[171])-LNP2x3[74];	//[1,53]<<0
  LNt[171] -= LNt[172];
  LNt[173] = LNt[171]-LNt[23];
  LNt[174] = float(LNP2x3[53]+LNt[173])-LNP2x3[53];	//[22,53]<<0
  LNt[173] -= LNt[174];
  LNt[175] = float(LNP2x3[45]+LNt[173])-LNP2x3[45];	//[8,31]<<0
  LNt[173] -= LNt[175];
  LNt[176] = LNt[172]-LNt[24]+LNt[174]+LNt[175];
  LNt[177] = float(LNP2x3[68]+LNt[176])-LNP2x3[68];	//[7,30]<<23
  LNt[176] -= LNt[177];
  LNt[178] = a.x;
  LNt[179] = float(LNP2x3[74]+LNt[178])-LNP2x3[74];	//[1,53]<<0
  LNt[178] -= LNt[179];
  LNt[180] = LNt[178]-LNt[23];
  LNt[181] = float(LNP2x3[53]+LNt[180])-LNP2x3[53];	//[22,53]<<0
  LNt[180] -= LNt[181];
  LNt[182] = float(LNP2x3[45]+LNt[180])-LNP2x3[45];	//[8,31]<<0
  LNt[180] -= LNt[182];
  LNt[183] = LNt[179]-LNt[24]+LNt[181]+LNt[182];
  LNt[184] = float(LNP2x3[68]+LNt[183])-LNP2x3[68];	//[7,30]<<23
  LNt[183] -= LNt[184];
  LNt[185] = b.x;
  LNt[186] = float(LNP2x3[74]+LNt[185])-LNP2x3[74];	//[1,53]<<0
  LNt[185] -= LNt[186];
  LNt[187] = LNt[185]-LNt[23];
  LNt[188] = float(LNP2x3[53]+LNt[187])-LNP2x3[53];	//[22,53]<<0
  LNt[187] -= LNt[188];
  LNt[189] = float(LNP2x3[45]+LNt[187])-LNP2x3[45];	//[8,31]<<0
  LNt[187] -= LNt[189];
  LNt[190] = LNt[186]-LNt[24]+LNt[188]+LNt[189];
  LNt[191] = float(LNP2x3[68]+LNt[190])-LNP2x3[68];	//[7,30]<<23
  LNt[190] -= LNt[191];
  LNt[192] = LNt[180]*LNt[58]+LNt[183]*LNt[57]+LNt[184]*LNt[54]-(LNt[68]*LNt[191]+LNt[71]*LNt[190]+LNt[72]*LNt[187]);
  LNt[193] = LNt[180]*LNt[54]-LNt[68]*LNt[187];
  LNt[194] = float(LNP2x3[47]+LNt[193])-LNP2x3[47];	//[22,47]<<0
  LNt[193] -= LNt[194];
  LNt[195] = float(LNP2x3[45]+LNt[193])-LNP2x3[45];	//[2,25]<<0
  LNt[193] -= LNt[195];
  LNt[196] = LNt[180]*LNt[57]+LNt[183]*LNt[54]-(LNt[68]*LNt[190]+LNt[71]*LNt[187])+LNt[194]+LNt[195];
  LNt[197] = float(LNP2x3[71]+LNt[196])-LNP2x3[71];	//[22,48]<<23
  LNt[196] -= LNt[197];
  LNt[198] = float(LNP2x3[68]+LNt[196])-LNP2x3[68];	//[3,26]<<23
  LNt[196] -= LNt[198];
  LNt[199] = LNt[192]+LNt[197]+LNt[198];
  LNt[200] = float(LNP2x3[95]+LNt[199])-LNP2x3[95];	//[22,49]<<46
  LNt[199] -= LNt[200];
  LNt[201] = float(LNP2x3[91]+LNt[199])-LNP2x3[91];	//[4,27]<<46
  LNt[199] -= LNt[201];
  LNt[202] = LNt[183]*LNt[58]+LNt[184]*LNt[57]-(LNt[71]*LNt[191]+LNt[72]*LNt[190])+LNt[200]+LNt[201];
  LNt[203] = float(LNP2x3[114]+LNt[202])-LNP2x3[114];	//[9,32]<<69
  LNt[202] -= LNt[203];
  LNt[204] = LNt[184]*LNt[58]-LNt[72]*LNt[191]+LNt[203];
  LNt[205] = LNt[173]*LNt[80]+LNt[176]*LNt[77]+LNt[177]*LNt[74]-(LNt[88]*LNt[199]+LNt[91]*LNt[196]+LNt[92]*LNt[193]);
  LNt[206] = LNt[173]*LNt[83]+LNt[176]*LNt[80]+LNt[177]*LNt[77]-(LNt[88]*LNt[202]+LNt[91]*LNt[199]+LNt[92]*LNt[196]);
  LNt[207] = LNt[173]*LNt[85]+LNt[176]*LNt[83]+LNt[177]*LNt[80]-(LNt[88]*LNt[204]+LNt[91]*LNt[202]+LNt[92]*LNt[199]);
  LNt[208] = LNt[180]*LNt[65]+LNt[183]*LNt[64]+LNt[184]*LNt[61]-(LNt[45]*LNt[191]+LNt[48]*LNt[190]+LNt[49]*LNt[187]);
  LNt[209] = LNt[180]*LNt[61]-LNt[45]*LNt[187];
  LNt[210] = float(LNP2x3[47]+LNt[209])-LNP2x3[47];	//[22,47]<<0
  LNt[209] -= LNt[210];
  LNt[211] = float(LNP2x3[45]+LNt[209])-LNP2x3[45];	//[2,25]<<0
  LNt[209] -= LNt[211];
  LNt[212] = LNt[180]*LNt[64]+LNt[183]*LNt[61]-(LNt[45]*LNt[190]+LNt[48]*LNt[187])+LNt[210]+LNt[211];
  LNt[213] = float(LNP2x3[71]+LNt[212])-LNP2x3[71];	//[22,48]<<23
  LNt[212] -= LNt[213];
  LNt[214] = float(LNP2x3[68]+LNt[212])-LNP2x3[68];	//[3,26]<<23
  LNt[212] -= LNt[214];
  LNt[215] = LNt[208]+LNt[213]+LNt[214];
  LNt[216] = float(LNP2x3[95]+LNt[215])-LNP2x3[95];	//[22,49]<<46
  LNt[215] -= LNt[216];
  LNt[217] = float(LNP2x3[91]+LNt[215])-LNP2x3[91];	//[4,27]<<46
  LNt[215] -= LNt[217];
  LNt[218] = LNt[183]*LNt[65]+LNt[184]*LNt[64]-(LNt[48]*LNt[191]+LNt[49]*LNt[190])+LNt[216]+LNt[217];
  LNt[219] = float(LNP2x3[114]+LNt[218])-LNP2x3[114];	//[9,32]<<69
  LNt[218] -= LNt[219];
  LNt[220] = LNt[184]*LNt[65]-LNt[49]*LNt[191]+LNt[219];
  LNt[221] = LNt[173]*LNt[77]+LNt[176]*LNt[74]-(LNt[88]*LNt[196]+LNt[91]*LNt[193])+LNt[125]*LNt[212]+LNt[128]*LNt[209];
  LNt[222] = LNt[176]*LNt[85]+LNt[177]*LNt[83]-(LNt[91]*LNt[204]+LNt[92]*LNt[202])+LNt[128]*LNt[220]+LNt[129]*LNt[218];
  LNt[223] = LNt[173]*LNt[74]-LNt[88]*LNt[193]+LNt[125]*LNt[209];
  LNt[224] = float(LNP2x3[48]+LNt[223])-LNP2x3[48];	//[22,48]<<0
  LNt[223] -= LNt[224];
  LNt[225] = float(LNP2x3[45]+LNt[223])-LNP2x3[45];	//[3,26]<<0
  LNt[223] -= LNt[225];
  LNt[226] = LNt[221]+LNt[224]+LNt[225];
  LNt[227] = float(LNP2x3[72]+LNt[226])-LNP2x3[72];	//[22,49]<<23
  LNt[226] -= LNt[227];
  LNt[228] = float(LNP2x3[68]+LNt[226])-LNP2x3[68];	//[4,27]<<23
  LNt[226] -= LNt[228];
  LNt[229] = LNt[205]+LNt[125]*LNt[215]+LNt[128]*LNt[212]+LNt[129]*LNt[209]+LNt[227]+LNt[228];
  LNt[230] = float(LNP2x3[96]+LNt[229])-LNP2x3[96];	//[22,50]<<46
  LNt[229] -= LNt[230];
  LNt[231] = float(LNP2x3[91]+LNt[229])-LNP2x3[91];	//[5,28]<<46
  LNt[229] -= LNt[231];
  LNt[232] = LNt[206]+LNt[125]*LNt[218]+LNt[128]*LNt[215]+LNt[129]*LNt[212]+LNt[230]+LNt[231];
  LNt[233] = float(LNP2x3[119]+LNt[232])-LNP2x3[119];	//[22,50]<<69
  LNt[232] -= LNt[233];
  LNt[234] = float(LNP2x3[114]+LNt[232])-LNP2x3[114];	//[5,28]<<69
  LNt[232] -= LNt[234];
  LNt[235] = LNt[207]+LNt[125]*LNt[220]+LNt[128]*LNt[218]+LNt[129]*LNt[215]+LNt[233]+LNt[234];
  LNt[236] = (float(LNP2x3[125]+LNt[235]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[235] -= LNt[236];
  LNt[237] = (float(LNP2x3[125]+LNt[235]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[235] -= LNt[237];
  LNt[238] = LNt[222]+LNt[236]+LNt[237];
  LNt[239] = (float(LNP2x3[125]+LNt[238]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[238] -= LNt[239];
  LNt[240] = LNt[177]*LNt[85]-LNt[92]*LNt[204]+LNt[129]*LNt[220]+LNt[239];
  LNt[241] = (float(LNP2x3[125]+LNt[240]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[240] -= LNt[241];
  LNt[242] = LNt[27]*LNt[151]+LNt[30]*LNt[148]+LNt[31]*LNt[145]+LNt[166]*LNt[229]+LNt[169]*LNt[226]+LNt[170]*LNt[223];
  LNt[243] = LNt[27]*LNt[154]+LNt[30]*LNt[151]+LNt[31]*LNt[148]+LNt[166]*LNt[232]+LNt[169]*LNt[229]+LNt[170]*LNt[226];
  LNt[244] = LNt[27]*LNt[157]+LNt[30]*LNt[154]+LNt[31]*LNt[151]+LNt[166]*LNt[235]+LNt[169]*LNt[232]+LNt[170]*LNt[229];
  LNt[245] = LNt[27]*LNt[160]+LNt[30]*LNt[157]+LNt[31]*LNt[154]+LNt[166]*LNt[238]+LNt[169]*LNt[235]+LNt[170]*LNt[232];
  LNt[246] = LNt[27]*LNt[162]+LNt[30]*LNt[160]+LNt[31]*LNt[157]+LNt[166]*LNt[240]+LNt[169]*LNt[238]+LNt[170]*LNt[235];
  LNt[247] = LNt[27]*LNt[163]+LNt[30]*LNt[162]+LNt[31]*LNt[160]+LNt[166]*LNt[241]+LNt[169]*LNt[240]+LNt[170]*LNt[238];
  LNt[248] = d.z;
  LNt[249] = float(LNP2x3[74]+LNt[248])-LNP2x3[74];	//[1,53]<<0
  LNt[248] -= LNt[249];
  LNt[250] = LNt[248]-LNt[43];
  LNt[251] = float(LNP2x3[53]+LNt[250])-LNP2x3[53];	//[22,53]<<0
  LNt[250] -= LNt[251];
  LNt[252] = float(LNP2x3[45]+LNt[250])-LNP2x3[45];	//[8,31]<<0
  LNt[250] -= LNt[252];
  LNt[253] = LNt[249]-LNt[44]+LNt[251]+LNt[252];
  LNt[254] = float(LNP2x3[68]+LNt[253])-LNP2x3[68];	//[7,30]<<23
  LNt[253] -= LNt[254];
  LNt[255] = LNt[173]*LNt[114]+LNt[176]*LNt[111]+LNt[177]*LNt[108]-(LNt[36]*LNt[199]+LNt[39]*LNt[196]+LNt[40]*LNt[193]);
  LNt[256] = LNt[173]*LNt[117]+LNt[176]*LNt[114]+LNt[177]*LNt[111]-(LNt[36]*LNt[202]+LNt[39]*LNt[199]+LNt[40]*LNt[196]);
  LNt[257] = LNt[173]*LNt[119]+LNt[176]*LNt[117]+LNt[177]*LNt[114]-(LNt[36]*LNt[204]+LNt[39]*LNt[202]+LNt[40]*LNt[199]);
  LNt[258] = LNt[180]*LNt[106]+LNt[183]*LNt[105]+LNt[184]*LNt[102]-(LNt[95]*LNt[191]+LNt[98]*LNt[190]+LNt[99]*LNt[187]);
  LNt[259] = LNt[180]*LNt[102]-LNt[95]*LNt[187];
  LNt[260] = float(LNP2x3[47]+LNt[259])-LNP2x3[47];	//[22,47]<<0
  LNt[259] -= LNt[260];
  LNt[261] = float(LNP2x3[45]+LNt[259])-LNP2x3[45];	//[2,25]<<0
  LNt[259] -= LNt[261];
  LNt[262] = LNt[180]*LNt[105]+LNt[183]*LNt[102]-(LNt[95]*LNt[190]+LNt[98]*LNt[187])+LNt[260]+LNt[261];
  LNt[263] = float(LNP2x3[71]+LNt[262])-LNP2x3[71];	//[22,48]<<23
  LNt[262] -= LNt[263];
  LNt[264] = float(LNP2x3[68]+LNt[262])-LNP2x3[68];	//[3,26]<<23
  LNt[262] -= LNt[264];
  LNt[265] = LNt[258]+LNt[263]+LNt[264];
  LNt[266] = float(LNP2x3[95]+LNt[265])-LNP2x3[95];	//[22,49]<<46
  LNt[265] -= LNt[266];
  LNt[267] = float(LNP2x3[91]+LNt[265])-LNP2x3[91];	//[4,27]<<46
  LNt[265] -= LNt[267];
  LNt[268] = LNt[183]*LNt[106]+LNt[184]*LNt[105]-(LNt[98]*LNt[191]+LNt[99]*LNt[190])+LNt[266]+LNt[267];
  LNt[269] = float(LNP2x3[114]+LNt[268])-LNP2x3[114];	//[9,32]<<69
  LNt[268] -= LNt[269];
  LNt[270] = LNt[184]*LNt[106]-LNt[99]*LNt[191]+LNt[269];
  LNt[271] = LNt[173]*LNt[111]+LNt[176]*LNt[108]-(LNt[36]*LNt[196]+LNt[39]*LNt[193])+LNt[125]*LNt[262]+LNt[128]*LNt[259];
  LNt[272] = LNt[176]*LNt[119]+LNt[177]*LNt[117]-(LNt[39]*LNt[204]+LNt[40]*LNt[202])+LNt[128]*LNt[270]+LNt[129]*LNt[268];
  LNt[273] = LNt[173]*LNt[108]-LNt[36]*LNt[193]+LNt[125]*LNt[259];
  LNt[274] = float(LNP2x3[48]+LNt[273])-LNP2x3[48];	//[22,48]<<0
  LNt[273] -= LNt[274];
  LNt[275] = float(LNP2x3[45]+LNt[273])-LNP2x3[45];	//[3,26]<<0
  LNt[273] -= LNt[275];
  LNt[276] = LNt[271]+LNt[274]+LNt[275];
  LNt[277] = float(LNP2x3[72]+LNt[276])-LNP2x3[72];	//[22,49]<<23
  LNt[276] -= LNt[277];
  LNt[278] = float(LNP2x3[68]+LNt[276])-LNP2x3[68];	//[4,27]<<23
  LNt[276] -= LNt[278];
  LNt[279] = LNt[255]+LNt[125]*LNt[265]+LNt[128]*LNt[262]+LNt[129]*LNt[259]+LNt[277]+LNt[278];
  LNt[280] = float(LNP2x3[96]+LNt[279])-LNP2x3[96];	//[22,50]<<46
  LNt[279] -= LNt[280];
  LNt[281] = float(LNP2x3[91]+LNt[279])-LNP2x3[91];	//[5,28]<<46
  LNt[279] -= LNt[281];
  LNt[282] = LNt[256]+LNt[125]*LNt[268]+LNt[128]*LNt[265]+LNt[129]*LNt[262]+LNt[280]+LNt[281];
  LNt[283] = float(LNP2x3[119]+LNt[282])-LNP2x3[119];	//[22,50]<<69
  LNt[282] -= LNt[283];
  LNt[284] = float(LNP2x3[114]+LNt[282])-LNP2x3[114];	//[5,28]<<69
  LNt[282] -= LNt[284];
  LNt[285] = LNt[257]+LNt[125]*LNt[270]+LNt[128]*LNt[268]+LNt[129]*LNt[265]+LNt[283]+LNt[284];
  LNt[286] = (float(LNP2x3[125]+LNt[285]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[285] -= LNt[286];
  LNt[287] = (float(LNP2x3[125]+LNt[285]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[285] -= LNt[287];
  LNt[288] = LNt[272]+LNt[286]+LNt[287];
  LNt[289] = (float(LNP2x3[125]+LNt[288]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[288] -= LNt[289];
  LNt[290] = LNt[177]*LNt[119]-LNt[40]*LNt[204]+LNt[129]*LNt[270]+LNt[289];
  LNt[291] = (float(LNP2x3[125]+LNt[290]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[290] -= LNt[291];
  LNt[292] = LNt[27]*LNt[148]+LNt[30]*LNt[145]+LNt[166]*LNt[226]+LNt[169]*LNt[223]-(LNt[250]*LNt[276]+LNt[253]*LNt[273]);
  LNt[293] = LNt[30]*LNt[163]+LNt[31]*LNt[162]+LNt[169]*LNt[241]+LNt[170]*LNt[240]-(LNt[253]*LNt[291]+LNt[254]*LNt[290]);
  LNt[294] = d.w;
  LNt[295] = float(LNP2x3[74]+LNt[294])-LNP2x3[74];	//[1,53]<<0
  LNt[294] -= LNt[295];
  LNt[296] = LNt[294]-LNt[52];
  LNt[297] = float(LNP2x3[53]+LNt[296])-LNP2x3[53];	//[22,53]<<0
  LNt[296] -= LNt[297];
  LNt[298] = float(LNP2x3[45]+LNt[296])-LNP2x3[45];	//[8,31]<<0
  LNt[296] -= LNt[298];
  LNt[299] = LNt[295]-LNt[53]+LNt[297]+LNt[298];
  LNt[300] = float(LNP2x3[68]+LNt[299])-LNP2x3[68];	//[7,30]<<23
  LNt[299] -= LNt[300];
  LNt[301] = LNt[173]*LNt[137]+LNt[176]*LNt[134]+LNt[177]*LNt[131]-(LNt[36]*LNt[215]+LNt[39]*LNt[212]+LNt[40]*LNt[209]);
  LNt[302] = LNt[173]*LNt[140]+LNt[176]*LNt[137]+LNt[177]*LNt[134]-(LNt[36]*LNt[218]+LNt[39]*LNt[215]+LNt[40]*LNt[212]);
  LNt[303] = LNt[173]*LNt[142]+LNt[176]*LNt[140]+LNt[177]*LNt[137]-(LNt[36]*LNt[220]+LNt[39]*LNt[218]+LNt[40]*LNt[215]);
  LNt[304] = LNt[173]*LNt[134]+LNt[176]*LNt[131]-(LNt[36]*LNt[212]+LNt[39]*LNt[209])+LNt[88]*LNt[262]+LNt[91]*LNt[259];
  LNt[305] = LNt[176]*LNt[142]+LNt[177]*LNt[140]-(LNt[39]*LNt[220]+LNt[40]*LNt[218])+LNt[91]*LNt[270]+LNt[92]*LNt[268];
  LNt[306] = LNt[173]*LNt[131]-LNt[36]*LNt[209]+LNt[88]*LNt[259];
  LNt[307] = float(LNP2x3[48]+LNt[306])-LNP2x3[48];	//[22,48]<<0
  LNt[306] -= LNt[307];
  LNt[308] = float(LNP2x3[45]+LNt[306])-LNP2x3[45];	//[3,26]<<0
  LNt[306] -= LNt[308];
  LNt[309] = LNt[304]+LNt[307]+LNt[308];
  LNt[310] = float(LNP2x3[72]+LNt[309])-LNP2x3[72];	//[22,49]<<23
  LNt[309] -= LNt[310];
  LNt[311] = float(LNP2x3[68]+LNt[309])-LNP2x3[68];	//[4,27]<<23
  LNt[309] -= LNt[311];
  LNt[312] = LNt[301]+LNt[88]*LNt[265]+LNt[91]*LNt[262]+LNt[92]*LNt[259]+LNt[310]+LNt[311];
  LNt[313] = float(LNP2x3[96]+LNt[312])-LNP2x3[96];	//[22,50]<<46
  LNt[312] -= LNt[313];
  LNt[314] = float(LNP2x3[91]+LNt[312])-LNP2x3[91];	//[5,28]<<46
  LNt[312] -= LNt[314];
  LNt[315] = LNt[302]+LNt[88]*LNt[268]+LNt[91]*LNt[265]+LNt[92]*LNt[262]+LNt[313]+LNt[314];
  LNt[316] = float(LNP2x3[119]+LNt[315])-LNP2x3[119];	//[22,50]<<69
  LNt[315] -= LNt[316];
  LNt[317] = float(LNP2x3[114]+LNt[315])-LNP2x3[114];	//[5,28]<<69
  LNt[315] -= LNt[317];
  LNt[318] = LNt[303]+LNt[88]*LNt[270]+LNt[91]*LNt[268]+LNt[92]*LNt[265]+LNt[316]+LNt[317];
  LNt[319] = (float(LNP2x3[125]+LNt[318]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[318] -= LNt[319];
  LNt[320] = (float(LNP2x3[125]+LNt[318]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[318] -= LNt[320];
  LNt[321] = LNt[305]+LNt[319]+LNt[320];
  LNt[322] = (float(LNP2x3[125]+LNt[321]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[321] -= LNt[322];
  LNt[323] = LNt[177]*LNt[142]-LNt[40]*LNt[220]+LNt[92]*LNt[270]+LNt[322];
  LNt[324] = (float(LNP2x3[125]+LNt[323]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[323] -= LNt[324];
  LNt[325] = LNt[242]-(LNt[250]*LNt[279]+LNt[253]*LNt[276]+LNt[254]*LNt[273])+LNt[296]*LNt[312]+LNt[299]*LNt[309]+LNt[300]*LNt[306];
  LNt[326] = LNt[243]-(LNt[250]*LNt[282]+LNt[253]*LNt[279]+LNt[254]*LNt[276])+LNt[296]*LNt[315]+LNt[299]*LNt[312]+LNt[300]*LNt[309];
  LNt[327] = LNt[244]-(LNt[250]*LNt[285]+LNt[253]*LNt[282]+LNt[254]*LNt[279])+LNt[296]*LNt[318]+LNt[299]*LNt[315]+LNt[300]*LNt[312];
  LNt[328] = LNt[245]-(LNt[250]*LNt[288]+LNt[253]*LNt[285]+LNt[254]*LNt[282])+LNt[296]*LNt[321]+LNt[299]*LNt[318]+LNt[300]*LNt[315];
  LNt[329] = LNt[246]-(LNt[250]*LNt[290]+LNt[253]*LNt[288]+LNt[254]*LNt[285])+LNt[296]*LNt[323]+LNt[299]*LNt[321]+LNt[300]*LNt[318];
  LNt[330] = LNt[247]-(LNt[250]*LNt[291]+LNt[253]*LNt[290]+LNt[254]*LNt[288])+LNt[296]*LNt[324]+LNt[299]*LNt[323]+LNt[300]*LNt[321];
  LNt[331] = LNt[27]*LNt[145]+LNt[166]*LNt[223]-LNt[250]*LNt[273]+LNt[296]*LNt[306];
  LNt[332] = LNt[292]+LNt[296]*LNt[309]+LNt[299]*LNt[306];
  LNt[333] = LNt[293]+LNt[299]*LNt[324]+LNt[300]*LNt[323];
  LNt[334] = LNt[31]*LNt[163]+LNt[170]*LNt[241]-LNt[254]*LNt[291]+LNt[300]*LNt[324];
  LNt[335] = (((((((LNt[334])+LNt[333])+LNt[330])+LNt[329])+LNt[328])+LNt[327])+LNt[326])+LNt[325];
  LNt[20] = (((LNt[335])+LNt[332])+LNt[331]);
}
if (LNt[20]<0){
  LNt[0] = -1.;
}else{
  if (LNt[20]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=512 multiplies=412 normalizes=159 */


integer horient4d(const Point4d& a, const Point4d& b, const Point4d& c, const Point4d& d){
integer LNans;
LNt[1] = a.z*b.w-b.z*a.w;
LNt[2] = a.y*b.w-b.y*a.w;
LNt[3] = a.y*b.z-b.y*a.z;
LNt[4] = a.x*b.w-a.w*b.x;
LNt[5] = a.x*b.z-a.z*b.x;
LNt[6] = (0.-d.x)*(c.y*LNt[1]-c.z*LNt[2]+c.w*LNt[3])+d.y*(c.x*LNt[1]-c.z*LNt[4]+c.w*LNt[5]);
LNt[7] = a.x*b.y-a.y*b.x;
LNt[8] = LNt[6]-d.z*(c.x*LNt[2]-c.y*LNt[4]+c.w*LNt[7])+d.w*(c.x*LNt[3]-c.y*LNt[5]+c.z*LNt[7]);
if (-LNP2[175]<LNt[8] && LNt[8]<LNP2[175]) {	/* the high order 44 bits of 219 are accurate */
  LNt[9] = d.x;
  LNt[10] = float(LNP2x3[74]+LNt[9])-LNP2x3[74];	//[1,53]<<0
  LNt[9] -= LNt[10];
  LNt[11] = 0.-LNt[9];
  LNt[12] = float(LNP2x3[53]+LNt[11])-LNP2x3[53];	//[22,53]<<0
  LNt[11] -= LNt[12];
  LNt[13] = float(LNP2x3[45]+LNt[11])-LNP2x3[45];	//[8,31]<<0
  LNt[11] -= LNt[13];
  LNt[14] = 0.0-LNt[10]+LNt[12]+LNt[13];
  LNt[15] = float(LNP2x3[68]+LNt[14])-LNP2x3[68];	//[7,30]<<23
  LNt[14] -= LNt[15];
  LNt[16] = c.y;
  LNt[17] = float(LNP2x3[53]+LNt[16])-LNP2x3[53];	//[22,53]<<0
  LNt[16] -= LNt[17];
  LNt[18] = float(LNP2x3[45]+LNt[16])-LNP2x3[45];	//[8,31]<<0
  LNt[16] -= LNt[18];
  LNt[19] = LNt[17]+LNt[18];
  LNt[20] = float(LNP2x3[68]+LNt[19])-LNP2x3[68];	//[7,30]<<23
  LNt[19] -= LNt[20];
  LNt[21] = a.z;
  LNt[22] = float(LNP2x3[53]+LNt[21])-LNP2x3[53];	//[22,53]<<0
  LNt[21] -= LNt[22];
  LNt[23] = float(LNP2x3[45]+LNt[21])-LNP2x3[45];	//[8,31]<<0
  LNt[21] -= LNt[23];
  LNt[24] = LNt[22]+LNt[23];
  LNt[25] = float(LNP2x3[68]+LNt[24])-LNP2x3[68];	//[7,30]<<23
  LNt[24] -= LNt[25];
  LNt[26] = b.w;
  LNt[27] = float(LNP2x3[53]+LNt[26])-LNP2x3[53];	//[22,53]<<0
  LNt[26] -= LNt[27];
  LNt[28] = float(LNP2x3[45]+LNt[26])-LNP2x3[45];	//[8,31]<<0
  LNt[26] -= LNt[28];
  LNt[29] = LNt[27]+LNt[28];
  LNt[30] = float(LNP2x3[68]+LNt[29])-LNP2x3[68];	//[7,30]<<23
  LNt[29] -= LNt[30];
  LNt[31] = b.z;
  LNt[32] = float(LNP2x3[53]+LNt[31])-LNP2x3[53];	//[22,53]<<0
  LNt[31] -= LNt[32];
  LNt[33] = float(LNP2x3[45]+LNt[31])-LNP2x3[45];	//[8,31]<<0
  LNt[31] -= LNt[33];
  LNt[34] = LNt[32]+LNt[33];
  LNt[35] = float(LNP2x3[68]+LNt[34])-LNP2x3[68];	//[7,30]<<23
  LNt[34] -= LNt[35];
  LNt[36] = a.w;
  LNt[37] = float(LNP2x3[53]+LNt[36])-LNP2x3[53];	//[22,53]<<0
  LNt[36] -= LNt[37];
  LNt[38] = float(LNP2x3[45]+LNt[36])-LNP2x3[45];	//[8,31]<<0
  LNt[36] -= LNt[38];
  LNt[39] = LNt[37]+LNt[38];
  LNt[40] = float(LNP2x3[68]+LNt[39])-LNP2x3[68];	//[7,30]<<23
  LNt[39] -= LNt[40];
  LNt[41] = LNt[21]*LNt[30]+LNt[24]*LNt[29]+LNt[25]*LNt[26]-(LNt[31]*LNt[40]+LNt[34]*LNt[39]+LNt[35]*LNt[36]);
  LNt[42] = LNt[21]*LNt[26]-LNt[31]*LNt[36];
  LNt[43] = float(LNP2x3[47]+LNt[42])-LNP2x3[47];	//[22,47]<<0
  LNt[42] -= LNt[43];
  LNt[44] = float(LNP2x3[45]+LNt[42])-LNP2x3[45];	//[2,25]<<0
  LNt[42] -= LNt[44];
  LNt[45] = LNt[21]*LNt[29]+LNt[24]*LNt[26]-(LNt[31]*LNt[39]+LNt[34]*LNt[36])+LNt[43]+LNt[44];
  LNt[46] = float(LNP2x3[71]+LNt[45])-LNP2x3[71];	//[22,48]<<23
  LNt[45] -= LNt[46];
  LNt[47] = float(LNP2x3[68]+LNt[45])-LNP2x3[68];	//[3,26]<<23
  LNt[45] -= LNt[47];
  LNt[48] = LNt[41]+LNt[46]+LNt[47];
  LNt[49] = float(LNP2x3[95]+LNt[48])-LNP2x3[95];	//[22,49]<<46
  LNt[48] -= LNt[49];
  LNt[50] = float(LNP2x3[91]+LNt[48])-LNP2x3[91];	//[4,27]<<46
  LNt[48] -= LNt[50];
  LNt[51] = LNt[24]*LNt[30]+LNt[25]*LNt[29]-(LNt[34]*LNt[40]+LNt[35]*LNt[39])+LNt[49]+LNt[50];
  LNt[52] = float(LNP2x3[114]+LNt[51])-LNP2x3[114];	//[9,32]<<69
  LNt[51] -= LNt[52];
  LNt[53] = LNt[25]*LNt[30]-LNt[35]*LNt[40]+LNt[52];
  LNt[54] = c.z;
  LNt[55] = float(LNP2x3[53]+LNt[54])-LNP2x3[53];	//[22,53]<<0
  LNt[54] -= LNt[55];
  LNt[56] = float(LNP2x3[45]+LNt[54])-LNP2x3[45];	//[8,31]<<0
  LNt[54] -= LNt[56];
  LNt[57] = LNt[55]+LNt[56];
  LNt[58] = float(LNP2x3[68]+LNt[57])-LNP2x3[68];	//[7,30]<<23
  LNt[57] -= LNt[58];
  LNt[59] = a.y;
  LNt[60] = float(LNP2x3[53]+LNt[59])-LNP2x3[53];	//[22,53]<<0
  LNt[59] -= LNt[60];
  LNt[61] = float(LNP2x3[45]+LNt[59])-LNP2x3[45];	//[8,31]<<0
  LNt[59] -= LNt[61];
  LNt[62] = LNt[60]+LNt[61];
  LNt[63] = float(LNP2x3[68]+LNt[62])-LNP2x3[68];	//[7,30]<<23
  LNt[62] -= LNt[63];
  LNt[64] = b.y;
  LNt[65] = float(LNP2x3[53]+LNt[64])-LNP2x3[53];	//[22,53]<<0
  LNt[64] -= LNt[65];
  LNt[66] = float(LNP2x3[45]+LNt[64])-LNP2x3[45];	//[8,31]<<0
  LNt[64] -= LNt[66];
  LNt[67] = LNt[65]+LNt[66];
  LNt[68] = float(LNP2x3[68]+LNt[67])-LNP2x3[68];	//[7,30]<<23
  LNt[67] -= LNt[68];
  LNt[69] = LNt[59]*LNt[30]+LNt[62]*LNt[29]+LNt[63]*LNt[26]-(LNt[64]*LNt[40]+LNt[67]*LNt[39]+LNt[68]*LNt[36]);
  LNt[70] = LNt[59]*LNt[26]-LNt[64]*LNt[36];
  LNt[71] = float(LNP2x3[47]+LNt[70])-LNP2x3[47];	//[22,47]<<0
  LNt[70] -= LNt[71];
  LNt[72] = float(LNP2x3[45]+LNt[70])-LNP2x3[45];	//[2,25]<<0
  LNt[70] -= LNt[72];
  LNt[73] = LNt[59]*LNt[29]+LNt[62]*LNt[26]-(LNt[64]*LNt[39]+LNt[67]*LNt[36])+LNt[71]+LNt[72];
  LNt[74] = float(LNP2x3[71]+LNt[73])-LNP2x3[71];	//[22,48]<<23
  LNt[73] -= LNt[74];
  LNt[75] = float(LNP2x3[68]+LNt[73])-LNP2x3[68];	//[3,26]<<23
  LNt[73] -= LNt[75];
  LNt[76] = LNt[69]+LNt[74]+LNt[75];
  LNt[77] = float(LNP2x3[95]+LNt[76])-LNP2x3[95];	//[22,49]<<46
  LNt[76] -= LNt[77];
  LNt[78] = float(LNP2x3[91]+LNt[76])-LNP2x3[91];	//[4,27]<<46
  LNt[76] -= LNt[78];
  LNt[79] = LNt[62]*LNt[30]+LNt[63]*LNt[29]-(LNt[67]*LNt[40]+LNt[68]*LNt[39])+LNt[77]+LNt[78];
  LNt[80] = float(LNP2x3[114]+LNt[79])-LNP2x3[114];	//[9,32]<<69
  LNt[79] -= LNt[80];
  LNt[81] = LNt[63]*LNt[30]-LNt[68]*LNt[40]+LNt[80];
  LNt[82] = LNt[16]*LNt[48]+LNt[19]*LNt[45]+LNt[20]*LNt[42]-(LNt[54]*LNt[76]+LNt[57]*LNt[73]+LNt[58]*LNt[70]);
  LNt[83] = LNt[16]*LNt[51]+LNt[19]*LNt[48]+LNt[20]*LNt[45]-(LNt[54]*LNt[79]+LNt[57]*LNt[76]+LNt[58]*LNt[73]);
  LNt[84] = LNt[16]*LNt[53]+LNt[19]*LNt[51]+LNt[20]*LNt[48]-(LNt[54]*LNt[81]+LNt[57]*LNt[79]+LNt[58]*LNt[76]);
  LNt[85] = c.w;
  LNt[86] = float(LNP2x3[53]+LNt[85])-LNP2x3[53];	//[22,53]<<0
  LNt[85] -= LNt[86];
  LNt[87] = float(LNP2x3[45]+LNt[85])-LNP2x3[45];	//[8,31]<<0
  LNt[85] -= LNt[87];
  LNt[88] = LNt[86]+LNt[87];
  LNt[89] = float(LNP2x3[68]+LNt[88])-LNP2x3[68];	//[7,30]<<23
  LNt[88] -= LNt[89];
  LNt[90] = LNt[59]*LNt[35]+LNt[62]*LNt[34]+LNt[63]*LNt[31]-(LNt[64]*LNt[25]+LNt[67]*LNt[24]+LNt[68]*LNt[21]);
  LNt[91] = LNt[59]*LNt[31]-LNt[64]*LNt[21];
  LNt[92] = float(LNP2x3[47]+LNt[91])-LNP2x3[47];	//[22,47]<<0
  LNt[91] -= LNt[92];
  LNt[93] = float(LNP2x3[45]+LNt[91])-LNP2x3[45];	//[2,25]<<0
  LNt[91] -= LNt[93];
  LNt[94] = LNt[59]*LNt[34]+LNt[62]*LNt[31]-(LNt[64]*LNt[24]+LNt[67]*LNt[21])+LNt[92]+LNt[93];
  LNt[95] = float(LNP2x3[71]+LNt[94])-LNP2x3[71];	//[22,48]<<23
  LNt[94] -= LNt[95];
  LNt[96] = float(LNP2x3[68]+LNt[94])-LNP2x3[68];	//[3,26]<<23
  LNt[94] -= LNt[96];
  LNt[97] = LNt[90]+LNt[95]+LNt[96];
  LNt[98] = float(LNP2x3[95]+LNt[97])-LNP2x3[95];	//[22,49]<<46
  LNt[97] -= LNt[98];
  LNt[99] = float(LNP2x3[91]+LNt[97])-LNP2x3[91];	//[4,27]<<46
  LNt[97] -= LNt[99];
  LNt[100] = LNt[62]*LNt[35]+LNt[63]*LNt[34]-(LNt[67]*LNt[25]+LNt[68]*LNt[24])+LNt[98]+LNt[99];
  LNt[101] = float(LNP2x3[114]+LNt[100])-LNP2x3[114];	//[9,32]<<69
  LNt[100] -= LNt[101];
  LNt[102] = LNt[63]*LNt[35]-LNt[68]*LNt[25]+LNt[101];
  LNt[103] = LNt[16]*LNt[45]+LNt[19]*LNt[42]-(LNt[54]*LNt[73]+LNt[57]*LNt[70])+LNt[85]*LNt[94]+LNt[88]*LNt[91];
  LNt[104] = LNt[19]*LNt[53]+LNt[20]*LNt[51]-(LNt[57]*LNt[81]+LNt[58]*LNt[79])+LNt[88]*LNt[102]+LNt[89]*LNt[100];
  LNt[105] = LNt[16]*LNt[42]-LNt[54]*LNt[70]+LNt[85]*LNt[91];
  LNt[106] = float(LNP2x3[48]+LNt[105])-LNP2x3[48];	//[22,48]<<0
  LNt[105] -= LNt[106];
  LNt[107] = float(LNP2x3[45]+LNt[105])-LNP2x3[45];	//[3,26]<<0
  LNt[105] -= LNt[107];
  LNt[108] = LNt[103]+LNt[106]+LNt[107];
  LNt[109] = float(LNP2x3[72]+LNt[108])-LNP2x3[72];	//[22,49]<<23
  LNt[108] -= LNt[109];
  LNt[110] = float(LNP2x3[68]+LNt[108])-LNP2x3[68];	//[4,27]<<23
  LNt[108] -= LNt[110];
  LNt[111] = LNt[82]+LNt[85]*LNt[97]+LNt[88]*LNt[94]+LNt[89]*LNt[91]+LNt[109]+LNt[110];
  LNt[112] = float(LNP2x3[96]+LNt[111])-LNP2x3[96];	//[22,50]<<46
  LNt[111] -= LNt[112];
  LNt[113] = float(LNP2x3[91]+LNt[111])-LNP2x3[91];	//[5,28]<<46
  LNt[111] -= LNt[113];
  LNt[114] = LNt[83]+LNt[85]*LNt[100]+LNt[88]*LNt[97]+LNt[89]*LNt[94]+LNt[112]+LNt[113];
  LNt[115] = float(LNP2x3[119]+LNt[114])-LNP2x3[119];	//[22,50]<<69
  LNt[114] -= LNt[115];
  LNt[116] = float(LNP2x3[114]+LNt[114])-LNP2x3[114];	//[5,28]<<69
  LNt[114] -= LNt[116];
  LNt[117] = LNt[84]+LNt[85]*LNt[102]+LNt[88]*LNt[100]+LNt[89]*LNt[97]+LNt[115]+LNt[116];
  LNt[118] = (float(LNP2x3[125]+LNt[117]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[117] -= LNt[118];
  LNt[119] = (float(LNP2x3[125]+LNt[117]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[117] -= LNt[119];
  LNt[120] = LNt[104]+LNt[118]+LNt[119];
  LNt[121] = (float(LNP2x3[125]+LNt[120]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[120] -= LNt[121];
  LNt[122] = LNt[20]*LNt[53]-LNt[58]*LNt[81]+LNt[89]*LNt[102]+LNt[121];
  LNt[123] = (float(LNP2x3[125]+LNt[122]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[122] -= LNt[123];
  LNt[124] = d.y;
  LNt[125] = float(LNP2x3[53]+LNt[124])-LNP2x3[53];	//[22,53]<<0
  LNt[124] -= LNt[125];
  LNt[126] = float(LNP2x3[45]+LNt[124])-LNP2x3[45];	//[8,31]<<0
  LNt[124] -= LNt[126];
  LNt[127] = LNt[125]+LNt[126];
  LNt[128] = float(LNP2x3[68]+LNt[127])-LNP2x3[68];	//[7,30]<<23
  LNt[127] -= LNt[128];
  LNt[129] = c.x;
  LNt[130] = float(LNP2x3[53]+LNt[129])-LNP2x3[53];	//[22,53]<<0
  LNt[129] -= LNt[130];
  LNt[131] = float(LNP2x3[45]+LNt[129])-LNP2x3[45];	//[8,31]<<0
  LNt[129] -= LNt[131];
  LNt[132] = LNt[130]+LNt[131];
  LNt[133] = float(LNP2x3[68]+LNt[132])-LNP2x3[68];	//[7,30]<<23
  LNt[132] -= LNt[133];
  LNt[134] = a.x;
  LNt[135] = float(LNP2x3[53]+LNt[134])-LNP2x3[53];	//[22,53]<<0
  LNt[134] -= LNt[135];
  LNt[136] = float(LNP2x3[45]+LNt[134])-LNP2x3[45];	//[8,31]<<0
  LNt[134] -= LNt[136];
  LNt[137] = LNt[135]+LNt[136];
  LNt[138] = float(LNP2x3[68]+LNt[137])-LNP2x3[68];	//[7,30]<<23
  LNt[137] -= LNt[138];
  LNt[139] = b.x;
  LNt[140] = float(LNP2x3[53]+LNt[139])-LNP2x3[53];	//[22,53]<<0
  LNt[139] -= LNt[140];
  LNt[141] = float(LNP2x3[45]+LNt[139])-LNP2x3[45];	//[8,31]<<0
  LNt[139] -= LNt[141];
  LNt[142] = LNt[140]+LNt[141];
  LNt[143] = float(LNP2x3[68]+LNt[142])-LNP2x3[68];	//[7,30]<<23
  LNt[142] -= LNt[143];
  LNt[144] = LNt[134]*LNt[30]+LNt[137]*LNt[29]+LNt[138]*LNt[26]-(LNt[36]*LNt[143]+LNt[39]*LNt[142]+LNt[40]*LNt[139]);
  LNt[145] = LNt[134]*LNt[26]-LNt[36]*LNt[139];
  LNt[146] = float(LNP2x3[47]+LNt[145])-LNP2x3[47];	//[22,47]<<0
  LNt[145] -= LNt[146];
  LNt[147] = float(LNP2x3[45]+LNt[145])-LNP2x3[45];	//[2,25]<<0
  LNt[145] -= LNt[147];
  LNt[148] = LNt[134]*LNt[29]+LNt[137]*LNt[26]-(LNt[36]*LNt[142]+LNt[39]*LNt[139])+LNt[146]+LNt[147];
  LNt[149] = float(LNP2x3[71]+LNt[148])-LNP2x3[71];	//[22,48]<<23
  LNt[148] -= LNt[149];
  LNt[150] = float(LNP2x3[68]+LNt[148])-LNP2x3[68];	//[3,26]<<23
  LNt[148] -= LNt[150];
  LNt[151] = LNt[144]+LNt[149]+LNt[150];
  LNt[152] = float(LNP2x3[95]+LNt[151])-LNP2x3[95];	//[22,49]<<46
  LNt[151] -= LNt[152];
  LNt[153] = float(LNP2x3[91]+LNt[151])-LNP2x3[91];	//[4,27]<<46
  LNt[151] -= LNt[153];
  LNt[154] = LNt[137]*LNt[30]+LNt[138]*LNt[29]-(LNt[39]*LNt[143]+LNt[40]*LNt[142])+LNt[152]+LNt[153];
  LNt[155] = float(LNP2x3[114]+LNt[154])-LNP2x3[114];	//[9,32]<<69
  LNt[154] -= LNt[155];
  LNt[156] = LNt[138]*LNt[30]-LNt[40]*LNt[143]+LNt[155];
  LNt[157] = LNt[129]*LNt[48]+LNt[132]*LNt[45]+LNt[133]*LNt[42]-(LNt[54]*LNt[151]+LNt[57]*LNt[148]+LNt[58]*LNt[145]);
  LNt[158] = LNt[129]*LNt[51]+LNt[132]*LNt[48]+LNt[133]*LNt[45]-(LNt[54]*LNt[154]+LNt[57]*LNt[151]+LNt[58]*LNt[148]);
  LNt[159] = LNt[129]*LNt[53]+LNt[132]*LNt[51]+LNt[133]*LNt[48]-(LNt[54]*LNt[156]+LNt[57]*LNt[154]+LNt[58]*LNt[151]);
  LNt[160] = LNt[134]*LNt[35]+LNt[137]*LNt[34]+LNt[138]*LNt[31]-(LNt[21]*LNt[143]+LNt[24]*LNt[142]+LNt[25]*LNt[139]);
  LNt[161] = LNt[134]*LNt[31]-LNt[21]*LNt[139];
  LNt[162] = float(LNP2x3[47]+LNt[161])-LNP2x3[47];	//[22,47]<<0
  LNt[161] -= LNt[162];
  LNt[163] = float(LNP2x3[45]+LNt[161])-LNP2x3[45];	//[2,25]<<0
  LNt[161] -= LNt[163];
  LNt[164] = LNt[134]*LNt[34]+LNt[137]*LNt[31]-(LNt[21]*LNt[142]+LNt[24]*LNt[139])+LNt[162]+LNt[163];
  LNt[165] = float(LNP2x3[71]+LNt[164])-LNP2x3[71];	//[22,48]<<23
  LNt[164] -= LNt[165];
  LNt[166] = float(LNP2x3[68]+LNt[164])-LNP2x3[68];	//[3,26]<<23
  LNt[164] -= LNt[166];
  LNt[167] = LNt[160]+LNt[165]+LNt[166];
  LNt[168] = float(LNP2x3[95]+LNt[167])-LNP2x3[95];	//[22,49]<<46
  LNt[167] -= LNt[168];
  LNt[169] = float(LNP2x3[91]+LNt[167])-LNP2x3[91];	//[4,27]<<46
  LNt[167] -= LNt[169];
  LNt[170] = LNt[137]*LNt[35]+LNt[138]*LNt[34]-(LNt[24]*LNt[143]+LNt[25]*LNt[142])+LNt[168]+LNt[169];
  LNt[171] = float(LNP2x3[114]+LNt[170])-LNP2x3[114];	//[9,32]<<69
  LNt[170] -= LNt[171];
  LNt[172] = LNt[138]*LNt[35]-LNt[25]*LNt[143]+LNt[171];
  LNt[173] = LNt[129]*LNt[45]+LNt[132]*LNt[42]-(LNt[54]*LNt[148]+LNt[57]*LNt[145])+LNt[85]*LNt[164]+LNt[88]*LNt[161];
  LNt[174] = LNt[132]*LNt[53]+LNt[133]*LNt[51]-(LNt[57]*LNt[156]+LNt[58]*LNt[154])+LNt[88]*LNt[172]+LNt[89]*LNt[170];
  LNt[175] = LNt[129]*LNt[42]-LNt[54]*LNt[145]+LNt[85]*LNt[161];
  LNt[176] = float(LNP2x3[48]+LNt[175])-LNP2x3[48];	//[22,48]<<0
  LNt[175] -= LNt[176];
  LNt[177] = float(LNP2x3[45]+LNt[175])-LNP2x3[45];	//[3,26]<<0
  LNt[175] -= LNt[177];
  LNt[178] = LNt[173]+LNt[176]+LNt[177];
  LNt[179] = float(LNP2x3[72]+LNt[178])-LNP2x3[72];	//[22,49]<<23
  LNt[178] -= LNt[179];
  LNt[180] = float(LNP2x3[68]+LNt[178])-LNP2x3[68];	//[4,27]<<23
  LNt[178] -= LNt[180];
  LNt[181] = LNt[157]+LNt[85]*LNt[167]+LNt[88]*LNt[164]+LNt[89]*LNt[161]+LNt[179]+LNt[180];
  LNt[182] = float(LNP2x3[96]+LNt[181])-LNP2x3[96];	//[22,50]<<46
  LNt[181] -= LNt[182];
  LNt[183] = float(LNP2x3[91]+LNt[181])-LNP2x3[91];	//[5,28]<<46
  LNt[181] -= LNt[183];
  LNt[184] = LNt[158]+LNt[85]*LNt[170]+LNt[88]*LNt[167]+LNt[89]*LNt[164]+LNt[182]+LNt[183];
  LNt[185] = float(LNP2x3[119]+LNt[184])-LNP2x3[119];	//[22,50]<<69
  LNt[184] -= LNt[185];
  LNt[186] = float(LNP2x3[114]+LNt[184])-LNP2x3[114];	//[5,28]<<69
  LNt[184] -= LNt[186];
  LNt[187] = LNt[159]+LNt[85]*LNt[172]+LNt[88]*LNt[170]+LNt[89]*LNt[167]+LNt[185]+LNt[186];
  LNt[188] = (float(LNP2x3[125]+LNt[187]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[187] -= LNt[188];
  LNt[189] = (float(LNP2x3[125]+LNt[187]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[187] -= LNt[189];
  LNt[190] = LNt[174]+LNt[188]+LNt[189];
  LNt[191] = (float(LNP2x3[125]+LNt[190]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[190] -= LNt[191];
  LNt[192] = LNt[133]*LNt[53]-LNt[58]*LNt[156]+LNt[89]*LNt[172]+LNt[191];
  LNt[193] = (float(LNP2x3[125]+LNt[192]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[192] -= LNt[193];
  LNt[194] = LNt[11]*LNt[111]+LNt[14]*LNt[108]+LNt[15]*LNt[105]+LNt[124]*LNt[181]+LNt[127]*LNt[178]+LNt[128]*LNt[175];
  LNt[195] = LNt[11]*LNt[114]+LNt[14]*LNt[111]+LNt[15]*LNt[108]+LNt[124]*LNt[184]+LNt[127]*LNt[181]+LNt[128]*LNt[178];
  LNt[196] = LNt[11]*LNt[117]+LNt[14]*LNt[114]+LNt[15]*LNt[111]+LNt[124]*LNt[187]+LNt[127]*LNt[184]+LNt[128]*LNt[181];
  LNt[197] = LNt[11]*LNt[120]+LNt[14]*LNt[117]+LNt[15]*LNt[114]+LNt[124]*LNt[190]+LNt[127]*LNt[187]+LNt[128]*LNt[184];
  LNt[198] = LNt[11]*LNt[122]+LNt[14]*LNt[120]+LNt[15]*LNt[117]+LNt[124]*LNt[192]+LNt[127]*LNt[190]+LNt[128]*LNt[187];
  LNt[199] = LNt[11]*LNt[123]+LNt[14]*LNt[122]+LNt[15]*LNt[120]+LNt[124]*LNt[193]+LNt[127]*LNt[192]+LNt[128]*LNt[190];
  LNt[200] = d.z;
  LNt[201] = float(LNP2x3[53]+LNt[200])-LNP2x3[53];	//[22,53]<<0
  LNt[200] -= LNt[201];
  LNt[202] = float(LNP2x3[45]+LNt[200])-LNP2x3[45];	//[8,31]<<0
  LNt[200] -= LNt[202];
  LNt[203] = LNt[201]+LNt[202];
  LNt[204] = float(LNP2x3[68]+LNt[203])-LNP2x3[68];	//[7,30]<<23
  LNt[203] -= LNt[204];
  LNt[205] = LNt[129]*LNt[76]+LNt[132]*LNt[73]+LNt[133]*LNt[70]-(LNt[16]*LNt[151]+LNt[19]*LNt[148]+LNt[20]*LNt[145]);
  LNt[206] = LNt[129]*LNt[79]+LNt[132]*LNt[76]+LNt[133]*LNt[73]-(LNt[16]*LNt[154]+LNt[19]*LNt[151]+LNt[20]*LNt[148]);
  LNt[207] = LNt[129]*LNt[81]+LNt[132]*LNt[79]+LNt[133]*LNt[76]-(LNt[16]*LNt[156]+LNt[19]*LNt[154]+LNt[20]*LNt[151]);
  LNt[208] = LNt[134]*LNt[68]+LNt[137]*LNt[67]+LNt[138]*LNt[64]-(LNt[59]*LNt[143]+LNt[62]*LNt[142]+LNt[63]*LNt[139]);
  LNt[209] = LNt[134]*LNt[64]-LNt[59]*LNt[139];
  LNt[210] = float(LNP2x3[47]+LNt[209])-LNP2x3[47];	//[22,47]<<0
  LNt[209] -= LNt[210];
  LNt[211] = float(LNP2x3[45]+LNt[209])-LNP2x3[45];	//[2,25]<<0
  LNt[209] -= LNt[211];
  LNt[212] = LNt[134]*LNt[67]+LNt[137]*LNt[64]-(LNt[59]*LNt[142]+LNt[62]*LNt[139])+LNt[210]+LNt[211];
  LNt[213] = float(LNP2x3[71]+LNt[212])-LNP2x3[71];	//[22,48]<<23
  LNt[212] -= LNt[213];
  LNt[214] = float(LNP2x3[68]+LNt[212])-LNP2x3[68];	//[3,26]<<23
  LNt[212] -= LNt[214];
  LNt[215] = LNt[208]+LNt[213]+LNt[214];
  LNt[216] = float(LNP2x3[95]+LNt[215])-LNP2x3[95];	//[22,49]<<46
  LNt[215] -= LNt[216];
  LNt[217] = float(LNP2x3[91]+LNt[215])-LNP2x3[91];	//[4,27]<<46
  LNt[215] -= LNt[217];
  LNt[218] = LNt[137]*LNt[68]+LNt[138]*LNt[67]-(LNt[62]*LNt[143]+LNt[63]*LNt[142])+LNt[216]+LNt[217];
  LNt[219] = float(LNP2x3[114]+LNt[218])-LNP2x3[114];	//[9,32]<<69
  LNt[218] -= LNt[219];
  LNt[220] = LNt[138]*LNt[68]-LNt[63]*LNt[143]+LNt[219];
  LNt[221] = LNt[129]*LNt[73]+LNt[132]*LNt[70]-(LNt[16]*LNt[148]+LNt[19]*LNt[145])+LNt[85]*LNt[212]+LNt[88]*LNt[209];
  LNt[222] = LNt[132]*LNt[81]+LNt[133]*LNt[79]-(LNt[19]*LNt[156]+LNt[20]*LNt[154])+LNt[88]*LNt[220]+LNt[89]*LNt[218];
  LNt[223] = LNt[129]*LNt[70]-LNt[16]*LNt[145]+LNt[85]*LNt[209];
  LNt[224] = float(LNP2x3[48]+LNt[223])-LNP2x3[48];	//[22,48]<<0
  LNt[223] -= LNt[224];
  LNt[225] = float(LNP2x3[45]+LNt[223])-LNP2x3[45];	//[3,26]<<0
  LNt[223] -= LNt[225];
  LNt[226] = LNt[221]+LNt[224]+LNt[225];
  LNt[227] = float(LNP2x3[72]+LNt[226])-LNP2x3[72];	//[22,49]<<23
  LNt[226] -= LNt[227];
  LNt[228] = float(LNP2x3[68]+LNt[226])-LNP2x3[68];	//[4,27]<<23
  LNt[226] -= LNt[228];
  LNt[229] = LNt[205]+LNt[85]*LNt[215]+LNt[88]*LNt[212]+LNt[89]*LNt[209]+LNt[227]+LNt[228];
  LNt[230] = float(LNP2x3[96]+LNt[229])-LNP2x3[96];	//[22,50]<<46
  LNt[229] -= LNt[230];
  LNt[231] = float(LNP2x3[91]+LNt[229])-LNP2x3[91];	//[5,28]<<46
  LNt[229] -= LNt[231];
  LNt[232] = LNt[206]+LNt[85]*LNt[218]+LNt[88]*LNt[215]+LNt[89]*LNt[212]+LNt[230]+LNt[231];
  LNt[233] = float(LNP2x3[119]+LNt[232])-LNP2x3[119];	//[22,50]<<69
  LNt[232] -= LNt[233];
  LNt[234] = float(LNP2x3[114]+LNt[232])-LNP2x3[114];	//[5,28]<<69
  LNt[232] -= LNt[234];
  LNt[235] = LNt[207]+LNt[85]*LNt[220]+LNt[88]*LNt[218]+LNt[89]*LNt[215]+LNt[233]+LNt[234];
  LNt[236] = (float(LNP2x3[125]+LNt[235]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[235] -= LNt[236];
  LNt[237] = (float(LNP2x3[125]+LNt[235]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[235] -= LNt[237];
  LNt[238] = LNt[222]+LNt[236]+LNt[237];
  LNt[239] = (float(LNP2x3[125]+LNt[238]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[238] -= LNt[239];
  LNt[240] = LNt[133]*LNt[81]-LNt[20]*LNt[156]+LNt[89]*LNt[220]+LNt[239];
  LNt[241] = (float(LNP2x3[125]+LNt[240]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[240] -= LNt[241];
  LNt[242] = LNt[11]*LNt[108]+LNt[14]*LNt[105]+LNt[124]*LNt[178]+LNt[127]*LNt[175]-(LNt[200]*LNt[226]+LNt[203]*LNt[223]);
  LNt[243] = LNt[14]*LNt[123]+LNt[15]*LNt[122]+LNt[127]*LNt[193]+LNt[128]*LNt[192]-(LNt[203]*LNt[241]+LNt[204]*LNt[240]);
  LNt[244] = d.w;
  LNt[245] = float(LNP2x3[53]+LNt[244])-LNP2x3[53];	//[22,53]<<0
  LNt[244] -= LNt[245];
  LNt[246] = float(LNP2x3[45]+LNt[244])-LNP2x3[45];	//[8,31]<<0
  LNt[244] -= LNt[246];
  LNt[247] = LNt[245]+LNt[246];
  LNt[248] = float(LNP2x3[68]+LNt[247])-LNP2x3[68];	//[7,30]<<23
  LNt[247] -= LNt[248];
  LNt[249] = LNt[129]*LNt[97]+LNt[132]*LNt[94]+LNt[133]*LNt[91]-(LNt[16]*LNt[167]+LNt[19]*LNt[164]+LNt[20]*LNt[161]);
  LNt[250] = LNt[129]*LNt[100]+LNt[132]*LNt[97]+LNt[133]*LNt[94]-(LNt[16]*LNt[170]+LNt[19]*LNt[167]+LNt[20]*LNt[164]);
  LNt[251] = LNt[129]*LNt[102]+LNt[132]*LNt[100]+LNt[133]*LNt[97]-(LNt[16]*LNt[172]+LNt[19]*LNt[170]+LNt[20]*LNt[167]);
  LNt[252] = LNt[129]*LNt[94]+LNt[132]*LNt[91]-(LNt[16]*LNt[164]+LNt[19]*LNt[161])+LNt[54]*LNt[212]+LNt[57]*LNt[209];
  LNt[253] = LNt[132]*LNt[102]+LNt[133]*LNt[100]-(LNt[19]*LNt[172]+LNt[20]*LNt[170])+LNt[57]*LNt[220]+LNt[58]*LNt[218];
  LNt[254] = LNt[129]*LNt[91]-LNt[16]*LNt[161]+LNt[54]*LNt[209];
  LNt[255] = float(LNP2x3[48]+LNt[254])-LNP2x3[48];	//[22,48]<<0
  LNt[254] -= LNt[255];
  LNt[256] = float(LNP2x3[45]+LNt[254])-LNP2x3[45];	//[3,26]<<0
  LNt[254] -= LNt[256];
  LNt[257] = LNt[252]+LNt[255]+LNt[256];
  LNt[258] = float(LNP2x3[72]+LNt[257])-LNP2x3[72];	//[22,49]<<23
  LNt[257] -= LNt[258];
  LNt[259] = float(LNP2x3[68]+LNt[257])-LNP2x3[68];	//[4,27]<<23
  LNt[257] -= LNt[259];
  LNt[260] = LNt[249]+LNt[54]*LNt[215]+LNt[57]*LNt[212]+LNt[58]*LNt[209]+LNt[258]+LNt[259];
  LNt[261] = float(LNP2x3[96]+LNt[260])-LNP2x3[96];	//[22,50]<<46
  LNt[260] -= LNt[261];
  LNt[262] = float(LNP2x3[91]+LNt[260])-LNP2x3[91];	//[5,28]<<46
  LNt[260] -= LNt[262];
  LNt[263] = LNt[250]+LNt[54]*LNt[218]+LNt[57]*LNt[215]+LNt[58]*LNt[212]+LNt[261]+LNt[262];
  LNt[264] = float(LNP2x3[119]+LNt[263])-LNP2x3[119];	//[22,50]<<69
  LNt[263] -= LNt[264];
  LNt[265] = float(LNP2x3[114]+LNt[263])-LNP2x3[114];	//[5,28]<<69
  LNt[263] -= LNt[265];
  LNt[266] = LNt[251]+LNt[54]*LNt[220]+LNt[57]*LNt[218]+LNt[58]*LNt[215]+LNt[264]+LNt[265];
  LNt[267] = (float(LNP2x3[125]+LNt[266]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[266] -= LNt[267];
  LNt[268] = (float(LNP2x3[125]+LNt[266]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[266] -= LNt[268];
  LNt[269] = LNt[253]+LNt[267]+LNt[268];
  LNt[270] = (float(LNP2x3[125]+LNt[269]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[269] -= LNt[270];
  LNt[271] = LNt[133]*LNt[102]-LNt[20]*LNt[172]+LNt[58]*LNt[220]+LNt[270];
  LNt[272] = (float(LNP2x3[125]+LNt[271]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[271] -= LNt[272];
  LNt[273] = LNt[194]-(LNt[200]*LNt[229]+LNt[203]*LNt[226]+LNt[204]*LNt[223])+LNt[244]*LNt[260]+LNt[247]*LNt[257]+LNt[248]*LNt[254];
  LNt[274] = LNt[195]-(LNt[200]*LNt[232]+LNt[203]*LNt[229]+LNt[204]*LNt[226])+LNt[244]*LNt[263]+LNt[247]*LNt[260]+LNt[248]*LNt[257];
  LNt[275] = LNt[196]-(LNt[200]*LNt[235]+LNt[203]*LNt[232]+LNt[204]*LNt[229])+LNt[244]*LNt[266]+LNt[247]*LNt[263]+LNt[248]*LNt[260];
  LNt[276] = LNt[197]-(LNt[200]*LNt[238]+LNt[203]*LNt[235]+LNt[204]*LNt[232])+LNt[244]*LNt[269]+LNt[247]*LNt[266]+LNt[248]*LNt[263];
  LNt[277] = LNt[198]-(LNt[200]*LNt[240]+LNt[203]*LNt[238]+LNt[204]*LNt[235])+LNt[244]*LNt[271]+LNt[247]*LNt[269]+LNt[248]*LNt[266];
  LNt[278] = LNt[199]-(LNt[200]*LNt[241]+LNt[203]*LNt[240]+LNt[204]*LNt[238])+LNt[244]*LNt[272]+LNt[247]*LNt[271]+LNt[248]*LNt[269];
  LNt[279] = LNt[11]*LNt[105]+LNt[124]*LNt[175]-LNt[200]*LNt[223]+LNt[244]*LNt[254];
  LNt[280] = LNt[242]+LNt[244]*LNt[257]+LNt[247]*LNt[254];
  LNt[281] = LNt[243]+LNt[247]*LNt[272]+LNt[248]*LNt[271];
  LNt[282] = LNt[15]*LNt[123]+LNt[128]*LNt[193]-LNt[204]*LNt[241]+LNt[248]*LNt[272];
  LNt[283] = (((((((LNt[282])+LNt[281])+LNt[278])+LNt[277])+LNt[276])+LNt[275])+LNt[274])+LNt[273];
  LNt[8] = (((LNt[283])+LNt[280])+LNt[279]);
}
if (LNt[8]<0){
  LNt[0] = -1.;
}else{
  if (LNt[8]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=448 multiplies=412 normalizes=139 */


integer incircle3d(const Point3d& a, const Point3d& b, const Point3d& c, const Point3d& d, const Point3d& e){
integer LNans;
LNt[1] = c.y-e.y;
LNt[2] = a.z-e.z;
LNt[3] = e.x*e.x+e.y*e.y+e.z*e.z;
LNt[4] = b.x*b.x+b.y*b.y+b.z*b.z-LNt[3];
LNt[5] = b.z-e.z;
LNt[6] = a.x*a.x+a.y*a.y+a.z*a.z-LNt[3];
LNt[7] = LNt[2]*LNt[4]-LNt[5]*LNt[6];
LNt[8] = c.z-e.z;
LNt[9] = a.y-e.y;
LNt[10] = b.y-e.y;
LNt[11] = LNt[9]*LNt[4]-LNt[10]*LNt[6];
LNt[12] = c.x*c.x+c.y*c.y+c.z*c.z-LNt[3];
LNt[13] = LNt[9]*LNt[5]-LNt[10]*LNt[2];
LNt[14] = c.x-e.x;
LNt[15] = a.x-e.x;
LNt[16] = b.x-e.x;
LNt[17] = LNt[15]*LNt[4]-LNt[6]*LNt[16];
LNt[18] = LNt[15]*LNt[5]-LNt[2]*LNt[16];
LNt[19] = (0.-(d.x-e.x))*(LNt[1]*LNt[7]-LNt[8]*LNt[11]+LNt[12]*LNt[13])+(d.y-e.y)*(LNt[14]*LNt[7]-LNt[8]*LNt[17]+LNt[12]*LNt[18]);
LNt[20] = LNt[15]*LNt[10]-LNt[9]*LNt[16];
LNt[21] = LNt[19]-(d.z-e.z)*(LNt[14]*LNt[11]-LNt[1]*LNt[17]+LNt[12]*LNt[20])+(d.x*d.x+d.y*d.y+d.z*d.z-LNt[3])*(LNt[14]*LNt[13]-LNt[1]*LNt[18]+LNt[8]*LNt[20]);
if (-LNP2[238]<LNt[21] && LNt[21]<LNP2[238]) {	/* the high order 40 bits of 278 are accurate */
  LNt[22] = d.x;
  LNt[23] = float(LNP2x3[53]+LNt[22])-LNP2x3[53];	//[22,53]<<0
  LNt[22] -= LNt[23];
  LNt[24] = float(LNP2x3[45]+LNt[22])-LNP2x3[45];	//[8,31]<<0
  LNt[22] -= LNt[24];
  LNt[25] = LNt[23]+LNt[24];
  LNt[26] = float(LNP2x3[68]+LNt[25])-LNP2x3[68];	//[7,30]<<23
  LNt[25] -= LNt[26];
  LNt[27] = e.x;
  LNt[28] = float(LNP2x3[53]+LNt[27])-LNP2x3[53];	//[22,53]<<0
  LNt[27] -= LNt[28];
  LNt[29] = float(LNP2x3[45]+LNt[27])-LNP2x3[45];	//[8,31]<<0
  LNt[27] -= LNt[29];
  LNt[30] = LNt[28]+LNt[29];
  LNt[31] = float(LNP2x3[68]+LNt[30])-LNP2x3[68];	//[7,30]<<23
  LNt[30] -= LNt[31];
  LNt[32] = 0.-(LNt[22]-LNt[27]);
  LNt[33] = float(LNP2x3[45]+LNt[32])-LNP2x3[45];	//[2,25]<<0
  LNt[32] -= LNt[33];
  LNt[34] = 0.0-(LNt[25]-LNt[30])+LNt[33];
  LNt[35] = float(LNP2x3[68]+LNt[34])-LNP2x3[68];	//[2,25]<<23
  LNt[34] -= LNt[35];
  LNt[36] = c.y;
  LNt[37] = float(LNP2x3[53]+LNt[36])-LNP2x3[53];	//[22,53]<<0
  LNt[36] -= LNt[37];
  LNt[38] = float(LNP2x3[45]+LNt[36])-LNP2x3[45];	//[8,31]<<0
  LNt[36] -= LNt[38];
  LNt[39] = LNt[37]+LNt[38];
  LNt[40] = float(LNP2x3[68]+LNt[39])-LNP2x3[68];	//[7,30]<<23
  LNt[39] -= LNt[40];
  LNt[41] = e.y;
  LNt[42] = float(LNP2x3[53]+LNt[41])-LNP2x3[53];	//[22,53]<<0
  LNt[41] -= LNt[42];
  LNt[43] = float(LNP2x3[45]+LNt[41])-LNP2x3[45];	//[8,31]<<0
  LNt[41] -= LNt[43];
  LNt[44] = LNt[42]+LNt[43];
  LNt[45] = float(LNP2x3[68]+LNt[44])-LNP2x3[68];	//[7,30]<<23
  LNt[44] -= LNt[45];
  LNt[46] = LNt[36]-LNt[41];
  LNt[47] = float(LNP2x3[45]+LNt[46])-LNP2x3[45];	//[1,24]<<0
  LNt[46] -= LNt[47];
  LNt[48] = LNt[39]-LNt[44]+LNt[47];
  LNt[49] = float(LNP2x3[68]+LNt[48])-LNP2x3[68];	//[1,24]<<23
  LNt[48] -= LNt[49];
  LNt[50] = LNt[40]-LNt[45]+LNt[49];
  LNt[51] = a.z;
  LNt[52] = float(LNP2x3[53]+LNt[51])-LNP2x3[53];	//[22,53]<<0
  LNt[51] -= LNt[52];
  LNt[53] = float(LNP2x3[45]+LNt[51])-LNP2x3[45];	//[8,31]<<0
  LNt[51] -= LNt[53];
  LNt[54] = LNt[52]+LNt[53];
  LNt[55] = float(LNP2x3[68]+LNt[54])-LNP2x3[68];	//[7,30]<<23
  LNt[54] -= LNt[55];
  LNt[56] = e.z;
  LNt[57] = float(LNP2x3[53]+LNt[56])-LNP2x3[53];	//[22,53]<<0
  LNt[56] -= LNt[57];
  LNt[58] = float(LNP2x3[45]+LNt[56])-LNP2x3[45];	//[8,31]<<0
  LNt[56] -= LNt[58];
  LNt[59] = LNt[57]+LNt[58];
  LNt[60] = float(LNP2x3[68]+LNt[59])-LNP2x3[68];	//[7,30]<<23
  LNt[59] -= LNt[60];
  LNt[61] = LNt[51]-LNt[56];
  LNt[62] = float(LNP2x3[45]+LNt[61])-LNP2x3[45];	//[1,24]<<0
  LNt[61] -= LNt[62];
  LNt[63] = LNt[54]-LNt[59]+LNt[62];
  LNt[64] = float(LNP2x3[68]+LNt[63])-LNP2x3[68];	//[1,24]<<23
  LNt[63] -= LNt[64];
  LNt[65] = LNt[55]-LNt[60]+LNt[64];
  LNt[66] = b.x;
  LNt[67] = float(LNP2x3[53]+LNt[66])-LNP2x3[53];	//[22,53]<<0
  LNt[66] -= LNt[67];
  LNt[68] = float(LNP2x3[45]+LNt[66])-LNP2x3[45];	//[8,31]<<0
  LNt[66] -= LNt[68];
  LNt[69] = LNt[67]+LNt[68];
  LNt[70] = float(LNP2x3[68]+LNt[69])-LNP2x3[68];	//[7,30]<<23
  LNt[69] -= LNt[70];
  LNt[71] = b.y;
  LNt[72] = float(LNP2x3[53]+LNt[71])-LNP2x3[53];	//[22,53]<<0
  LNt[71] -= LNt[72];
  LNt[73] = float(LNP2x3[45]+LNt[71])-LNP2x3[45];	//[8,31]<<0
  LNt[71] -= LNt[73];
  LNt[74] = LNt[72]+LNt[73];
  LNt[75] = float(LNP2x3[68]+LNt[74])-LNP2x3[68];	//[7,30]<<23
  LNt[74] -= LNt[75];
  LNt[76] = LNt[66]*LNt[70]+LNt[69]*LNt[69]+LNt[70]*LNt[66]+LNt[71]*LNt[75]+LNt[74]*LNt[74]+LNt[75]*LNt[71];
  LNt[77] = b.z;
  LNt[78] = float(LNP2x3[53]+LNt[77])-LNP2x3[53];	//[22,53]<<0
  LNt[77] -= LNt[78];
  LNt[79] = float(LNP2x3[45]+LNt[77])-LNP2x3[45];	//[8,31]<<0
  LNt[77] -= LNt[79];
  LNt[80] = LNt[78]+LNt[79];
  LNt[81] = float(LNP2x3[68]+LNt[80])-LNP2x3[68];	//[7,30]<<23
  LNt[80] -= LNt[81];
  LNt[82] = LNt[66]*LNt[69]+LNt[69]*LNt[66]+LNt[71]*LNt[74]+LNt[74]*LNt[71]+LNt[77]*LNt[80]+LNt[80]*LNt[77];
  LNt[83] = LNt[69]*LNt[70]+LNt[70]*LNt[69]+LNt[74]*LNt[75]+LNt[75]*LNt[74]+LNt[80]*LNt[81]+LNt[81]*LNt[80];
  LNt[84] = LNt[27]*LNt[31]+LNt[30]*LNt[30]+LNt[31]*LNt[27]+LNt[41]*LNt[45]+LNt[44]*LNt[44]+LNt[45]*LNt[41];
  LNt[85] = LNt[27]*LNt[30]+LNt[30]*LNt[27]+LNt[41]*LNt[44]+LNt[44]*LNt[41]+LNt[56]*LNt[59]+LNt[59]*LNt[56];
  LNt[86] = LNt[30]*LNt[31]+LNt[31]*LNt[30]+LNt[44]*LNt[45]+LNt[45]*LNt[44]+LNt[59]*LNt[60]+LNt[60]*LNt[59];
  LNt[87] = LNt[27]*LNt[27]+LNt[41]*LNt[41]+LNt[56]*LNt[56];
  LNt[88] = LNt[84]+LNt[56]*LNt[60]+LNt[59]*LNt[59]+LNt[60]*LNt[56];
  LNt[89] = LNt[31]*LNt[31]+LNt[45]*LNt[45]+LNt[60]*LNt[60];
  LNt[90] = LNt[66]*LNt[66]+LNt[71]*LNt[71]+LNt[77]*LNt[77]-LNt[87];
  LNt[91] = float(LNP2x3[49]+LNt[90])-LNP2x3[49];	//[22,49]<<0
  LNt[90] -= LNt[91];
  LNt[92] = float(LNP2x3[45]+LNt[90])-LNP2x3[45];	//[4,27]<<0
  LNt[90] -= LNt[92];
  LNt[93] = LNt[82]-LNt[85]+LNt[91]+LNt[92];
  LNt[94] = float(LNP2x3[73]+LNt[93])-LNP2x3[73];	//[22,50]<<23
  LNt[93] -= LNt[94];
  LNt[95] = float(LNP2x3[68]+LNt[93])-LNP2x3[68];	//[5,28]<<23
  LNt[93] -= LNt[95];
  LNt[96] = LNt[76]+LNt[77]*LNt[81]+LNt[80]*LNt[80]+LNt[81]*LNt[77]-LNt[88]+LNt[94]+LNt[95];
  LNt[97] = float(LNP2x3[97]+LNt[96])-LNP2x3[97];	//[22,51]<<46
  LNt[96] -= LNt[97];
  LNt[98] = float(LNP2x3[91]+LNt[96])-LNP2x3[91];	//[6,29]<<46
  LNt[96] -= LNt[98];
  LNt[99] = LNt[83]-LNt[86]+LNt[97]+LNt[98];
  LNt[100] = float(LNP2x3[114]+LNt[99])-LNP2x3[114];	//[11,34]<<69
  LNt[99] -= LNt[100];
  LNt[101] = LNt[70]*LNt[70]+LNt[75]*LNt[75]+LNt[81]*LNt[81]-LNt[89]+LNt[100];
  LNt[102] = LNt[77]-LNt[56];
  LNt[103] = float(LNP2x3[45]+LNt[102])-LNP2x3[45];	//[1,24]<<0
  LNt[102] -= LNt[103];
  LNt[104] = LNt[80]-LNt[59]+LNt[103];
  LNt[105] = float(LNP2x3[68]+LNt[104])-LNP2x3[68];	//[1,24]<<23
  LNt[104] -= LNt[105];
  LNt[106] = LNt[81]-LNt[60]+LNt[105];
  LNt[107] = a.x;
  LNt[108] = float(LNP2x3[53]+LNt[107])-LNP2x3[53];	//[22,53]<<0
  LNt[107] -= LNt[108];
  LNt[109] = float(LNP2x3[45]+LNt[107])-LNP2x3[45];	//[8,31]<<0
  LNt[107] -= LNt[109];
  LNt[110] = LNt[108]+LNt[109];
  LNt[111] = float(LNP2x3[68]+LNt[110])-LNP2x3[68];	//[7,30]<<23
  LNt[110] -= LNt[111];
  LNt[112] = a.y;
  LNt[113] = float(LNP2x3[53]+LNt[112])-LNP2x3[53];	//[22,53]<<0
  LNt[112] -= LNt[113];
  LNt[114] = float(LNP2x3[45]+LNt[112])-LNP2x3[45];	//[8,31]<<0
  LNt[112] -= LNt[114];
  LNt[115] = LNt[113]+LNt[114];
  LNt[116] = float(LNP2x3[68]+LNt[115])-LNP2x3[68];	//[7,30]<<23
  LNt[115] -= LNt[116];
  LNt[117] = LNt[107]*LNt[111]+LNt[110]*LNt[110]+LNt[111]*LNt[107]+LNt[112]*LNt[116]+LNt[115]*LNt[115]+LNt[116]*LNt[112];
  LNt[118] = LNt[107]*LNt[110]+LNt[110]*LNt[107]+LNt[112]*LNt[115]+LNt[115]*LNt[112]+LNt[51]*LNt[54]+LNt[54]*LNt[51];
  LNt[119] = LNt[110]*LNt[111]+LNt[111]*LNt[110]+LNt[115]*LNt[116]+LNt[116]*LNt[115]+LNt[54]*LNt[55]+LNt[55]*LNt[54];
  LNt[120] = LNt[107]*LNt[107]+LNt[112]*LNt[112]+LNt[51]*LNt[51]-LNt[87];
  LNt[121] = float(LNP2x3[49]+LNt[120])-LNP2x3[49];	//[22,49]<<0
  LNt[120] -= LNt[121];
  LNt[122] = float(LNP2x3[45]+LNt[120])-LNP2x3[45];	//[4,27]<<0
  LNt[120] -= LNt[122];
  LNt[123] = LNt[118]-LNt[85]+LNt[121]+LNt[122];
  LNt[124] = float(LNP2x3[73]+LNt[123])-LNP2x3[73];	//[22,50]<<23
  LNt[123] -= LNt[124];
  LNt[125] = float(LNP2x3[68]+LNt[123])-LNP2x3[68];	//[5,28]<<23
  LNt[123] -= LNt[125];
  LNt[126] = LNt[117]+LNt[51]*LNt[55]+LNt[54]*LNt[54]+LNt[55]*LNt[51]-LNt[88]+LNt[124]+LNt[125];
  LNt[127] = float(LNP2x3[97]+LNt[126])-LNP2x3[97];	//[22,51]<<46
  LNt[126] -= LNt[127];
  LNt[128] = float(LNP2x3[91]+LNt[126])-LNP2x3[91];	//[6,29]<<46
  LNt[126] -= LNt[128];
  LNt[129] = LNt[119]-LNt[86]+LNt[127]+LNt[128];
  LNt[130] = float(LNP2x3[114]+LNt[129])-LNP2x3[114];	//[11,34]<<69
  LNt[129] -= LNt[130];
  LNt[131] = LNt[111]*LNt[111]+LNt[116]*LNt[116]+LNt[55]*LNt[55]-LNt[89]+LNt[130];
  LNt[132] = LNt[61]*LNt[96]+LNt[63]*LNt[93]+LNt[65]*LNt[90]-(LNt[102]*LNt[126]+LNt[104]*LNt[123]+LNt[106]*LNt[120]);
  LNt[133] = LNt[61]*LNt[99]+LNt[63]*LNt[96]+LNt[65]*LNt[93]-(LNt[102]*LNt[129]+LNt[104]*LNt[126]+LNt[106]*LNt[123]);
  LNt[134] = LNt[61]*LNt[101]+LNt[63]*LNt[99]+LNt[65]*LNt[96]-(LNt[102]*LNt[131]+LNt[104]*LNt[129]+LNt[106]*LNt[126]);
  LNt[135] = LNt[61]*LNt[90]-LNt[102]*LNt[120];
  LNt[136] = float(LNP2x3[47]+LNt[135])-LNP2x3[47];	//[22,47]<<0
  LNt[135] -= LNt[136];
  LNt[137] = float(LNP2x3[45]+LNt[135])-LNP2x3[45];	//[2,25]<<0
  LNt[135] -= LNt[137];
  LNt[138] = LNt[61]*LNt[93]+LNt[63]*LNt[90]-(LNt[102]*LNt[123]+LNt[104]*LNt[120])+LNt[136]+LNt[137];
  LNt[139] = float(LNP2x3[71]+LNt[138])-LNP2x3[71];	//[22,48]<<23
  LNt[138] -= LNt[139];
  LNt[140] = float(LNP2x3[68]+LNt[138])-LNP2x3[68];	//[3,26]<<23
  LNt[138] -= LNt[140];
  LNt[141] = LNt[132]+LNt[139]+LNt[140];
  LNt[142] = float(LNP2x3[95]+LNt[141])-LNP2x3[95];	//[22,49]<<46
  LNt[141] -= LNt[142];
  LNt[143] = float(LNP2x3[91]+LNt[141])-LNP2x3[91];	//[4,27]<<46
  LNt[141] -= LNt[143];
  LNt[144] = LNt[133]+LNt[142]+LNt[143];
  LNt[145] = float(LNP2x3[118]+LNt[144])-LNP2x3[118];	//[22,49]<<69
  LNt[144] -= LNt[145];
  LNt[146] = float(LNP2x3[114]+LNt[144])-LNP2x3[114];	//[4,27]<<69
  LNt[144] -= LNt[146];
  LNt[147] = LNt[134]+LNt[145]+LNt[146];
  LNt[148] = (float(LNP2x3[125]+LNt[147]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[147] -= LNt[148];
  LNt[149] = (float(LNP2x3[125]+LNt[147]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[147] -= LNt[149];
  LNt[150] = LNt[63]*LNt[101]+LNt[65]*LNt[99]-(LNt[104]*LNt[131]+LNt[106]*LNt[129])+LNt[148]+LNt[149];
  LNt[151] = (float(LNP2x3[125]+LNt[150]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
  LNt[150] -= LNt[151];
  LNt[152] = LNt[65]*LNt[101]-LNt[106]*LNt[131]+LNt[151];
  LNt[153] = (float(LNP2x3[125]+LNt[152]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
  LNt[152] -= LNt[153];
  LNt[154] = c.z;
  LNt[155] = float(LNP2x3[53]+LNt[154])-LNP2x3[53];	//[22,53]<<0
  LNt[154] -= LNt[155];
  LNt[156] = float(LNP2x3[45]+LNt[154])-LNP2x3[45];	//[8,31]<<0
  LNt[154] -= LNt[156];
  LNt[157] = LNt[155]+LNt[156];
  LNt[158] = float(LNP2x3[68]+LNt[157])-LNP2x3[68];	//[7,30]<<23
  LNt[157] -= LNt[158];
  LNt[159] = LNt[154]-LNt[56];
  LNt[160] = float(LNP2x3[45]+LNt[159])-LNP2x3[45];	//[1,24]<<0
  LNt[159] -= LNt[160];
  LNt[161] = LNt[157]-LNt[59]+LNt[160];
  LNt[162] = float(LNP2x3[68]+LNt[161])-LNP2x3[68];	//[1,24]<<23
  LNt[161] -= LNt[162];
  LNt[163] = LNt[158]-LNt[60]+LNt[162];
  LNt[164] = LNt[112]-LNt[41];
  LNt[165] = float(LNP2x3[45]+LNt[164])-LNP2x3[45];	//[1,24]<<0
  LNt[164] -= LNt[165];
  LNt[166] = LNt[115]-LNt[44]+LNt[165];
  LNt[167] = float(LNP2x3[68]+LNt[166])-LNP2x3[68];	//[1,24]<<23
  LNt[166] -= LNt[167];
  LNt[168] = LNt[116]-LNt[45]+LNt[167];
  LNt[169] = LNt[71]-LNt[41];
  LNt[170] = float(LNP2x3[45]+LNt[169])-LNP2x3[45];	//[1,24]<<0
  LNt[169] -= LNt[170];
  LNt[171] = LNt[74]-LNt[44]+LNt[170];
  LNt[172] = float(LNP2x3[68]+LNt[171])-LNP2x3[68];	//[1,24]<<23
  LNt[171] -= LNt[172];
  LNt[173] = LNt[75]-LNt[45]+LNt[172];
  LNt[174] = LNt[164]*LNt[96]+LNt[166]*LNt[93]+LNt[168]*LNt[90]-(LNt[169]*LNt[126]+LNt[171]*LNt[123]+LNt[173]*LNt[120]);
  LNt[175] = LNt[164]*LNt[99]+LNt[166]*LNt[96]+LNt[168]*LNt[93]-(LNt[169]*LNt[129]+LNt[171]*LNt[126]+LNt[173]*LNt[123]);
  LNt[176] = LNt[164]*LNt[101]+LNt[166]*LNt[99]+LNt[168]*LNt[96]-(LNt[169]*LNt[131]+LNt[171]*LNt[129]+LNt[173]*LNt[126]);
  LNt[177] = LNt[164]*LNt[90]-LNt[169]*LNt[120];
  LNt[178] = float(LNP2x3[47]+LNt[177])-LNP2x3[47];	//[22,47]<<0
  LNt[177] -= LNt[178];
  LNt[179] = float(LNP2x3[45]+LNt[177])-LNP2x3[45];	//[2,25]<<0
  LNt[177] -= LNt[179];
  LNt[180] = LNt[164]*LNt[93]+LNt[166]*LNt[90]-(LNt[169]*LNt[123]+LNt[171]*LNt[120])+LNt[178]+LNt[179];
  LNt[181] = float(LNP2x3[71]+LNt[180])-LNP2x3[71];	//[22,48]<<23
  LNt[180] -= LNt[181];
  LNt[182] = float(LNP2x3[68]+LNt[180])-LNP2x3[68];	//[3,26]<<23
  LNt[180] -= LNt[182];
  LNt[183] = LNt[174]+LNt[181]+LNt[182];
  LNt[184] = float(LNP2x3[95]+LNt[183])-LNP2x3[95];	//[22,49]<<46
  LNt[183] -= LNt[184];
  LNt[185] = float(LNP2x3[91]+LNt[183])-LNP2x3[91];	//[4,27]<<46
  LNt[183] -= LNt[185];
  LNt[186] = LNt[175]+LNt[184]+LNt[185];
  LNt[187] = float(LNP2x3[118]+LNt[186])-LNP2x3[118];	//[22,49]<<69
  LNt[186] -= LNt[187];
  LNt[188] = float(LNP2x3[114]+LNt[186])-LNP2x3[114];	//[4,27]<<69
  LNt[186] -= LNt[188];
  LNt[189] = LNt[176]+LNt[187]+LNt[188];
  LNt[190] = (float(LNP2x3[125]+LNt[189]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[189] -= LNt[190];
  LNt[191] = (float(LNP2x3[125]+LNt[189]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[189] -= LNt[191];
  LNt[192] = LNt[166]*LNt[101]+LNt[168]*LNt[99]-(LNt[171]*LNt[131]+LNt[173]*LNt[129])+LNt[190]+LNt[191];
  LNt[193] = (float(LNP2x3[125]+LNt[192]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
  LNt[192] -= LNt[193];
  LNt[194] = LNt[168]*LNt[101]-LNt[173]*LNt[131]+LNt[193];
  LNt[195] = (float(LNP2x3[125]+LNt[194]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
  LNt[194] -= LNt[195];
  LNt[196] = LNt[46]*LNt[141]+LNt[48]*LNt[138]+LNt[50]*LNt[135]-(LNt[159]*LNt[183]+LNt[161]*LNt[180]+LNt[163]*LNt[177]);
  LNt[197] = LNt[46]*LNt[144]+LNt[48]*LNt[141]+LNt[50]*LNt[138]-(LNt[159]*LNt[186]+LNt[161]*LNt[183]+LNt[163]*LNt[180]);
  LNt[198] = LNt[46]*LNt[147]+LNt[48]*LNt[144]+LNt[50]*LNt[141]-(LNt[159]*LNt[189]+LNt[161]*LNt[186]+LNt[163]*LNt[183]);
  LNt[199] = LNt[46]*LNt[150]+LNt[48]*LNt[147]+LNt[50]*LNt[144]-(LNt[159]*LNt[192]+LNt[161]*LNt[189]+LNt[163]*LNt[186]);
  LNt[200] = LNt[46]*LNt[152]+LNt[48]*LNt[150]+LNt[50]*LNt[147]-(LNt[159]*LNt[194]+LNt[161]*LNt[192]+LNt[163]*LNt[189]);
  LNt[201] = LNt[46]*LNt[153]+LNt[48]*LNt[152]+LNt[50]*LNt[150]-(LNt[159]*LNt[195]+LNt[161]*LNt[194]+LNt[163]*LNt[192]);
  LNt[202] = c.x;
  LNt[203] = float(LNP2x3[53]+LNt[202])-LNP2x3[53];	//[22,53]<<0
  LNt[202] -= LNt[203];
  LNt[204] = float(LNP2x3[45]+LNt[202])-LNP2x3[45];	//[8,31]<<0
  LNt[202] -= LNt[204];
  LNt[205] = LNt[203]+LNt[204];
  LNt[206] = float(LNP2x3[68]+LNt[205])-LNP2x3[68];	//[7,30]<<23
  LNt[205] -= LNt[206];
  LNt[207] = LNt[202]*LNt[206]+LNt[205]*LNt[205]+LNt[206]*LNt[202]+LNt[36]*LNt[40]+LNt[39]*LNt[39]+LNt[40]*LNt[36];
  LNt[208] = LNt[202]*LNt[205]+LNt[205]*LNt[202]+LNt[36]*LNt[39]+LNt[39]*LNt[36]+LNt[154]*LNt[157]+LNt[157]*LNt[154];
  LNt[209] = LNt[205]*LNt[206]+LNt[206]*LNt[205]+LNt[39]*LNt[40]+LNt[40]*LNt[39]+LNt[157]*LNt[158]+LNt[158]*LNt[157];
  LNt[210] = LNt[202]*LNt[202]+LNt[36]*LNt[36]+LNt[154]*LNt[154]-LNt[87];
  LNt[211] = float(LNP2x3[49]+LNt[210])-LNP2x3[49];	//[22,49]<<0
  LNt[210] -= LNt[211];
  LNt[212] = float(LNP2x3[45]+LNt[210])-LNP2x3[45];	//[4,27]<<0
  LNt[210] -= LNt[212];
  LNt[213] = LNt[208]-LNt[85]+LNt[211]+LNt[212];
  LNt[214] = float(LNP2x3[73]+LNt[213])-LNP2x3[73];	//[22,50]<<23
  LNt[213] -= LNt[214];
  LNt[215] = float(LNP2x3[68]+LNt[213])-LNP2x3[68];	//[5,28]<<23
  LNt[213] -= LNt[215];
  LNt[216] = LNt[207]+LNt[154]*LNt[158]+LNt[157]*LNt[157]+LNt[158]*LNt[154]-LNt[88]+LNt[214]+LNt[215];
  LNt[217] = float(LNP2x3[97]+LNt[216])-LNP2x3[97];	//[22,51]<<46
  LNt[216] -= LNt[217];
  LNt[218] = float(LNP2x3[91]+LNt[216])-LNP2x3[91];	//[6,29]<<46
  LNt[216] -= LNt[218];
  LNt[219] = LNt[209]-LNt[86]+LNt[217]+LNt[218];
  LNt[220] = float(LNP2x3[114]+LNt[219])-LNP2x3[114];	//[11,34]<<69
  LNt[219] -= LNt[220];
  LNt[221] = LNt[206]*LNt[206]+LNt[40]*LNt[40]+LNt[158]*LNt[158]-LNt[89]+LNt[220];
  LNt[222] = LNt[164]*LNt[106]+LNt[166]*LNt[104]+LNt[168]*LNt[102]-(LNt[169]*LNt[65]+LNt[171]*LNt[63]+LNt[173]*LNt[61]);
  LNt[223] = LNt[164]*LNt[102]-LNt[169]*LNt[61];
  LNt[224] = float(LNP2x3[47]+LNt[223])-LNP2x3[47];	//[22,47]<<0
  LNt[223] -= LNt[224];
  LNt[225] = float(LNP2x3[45]+LNt[223])-LNP2x3[45];	//[2,25]<<0
  LNt[223] -= LNt[225];
  LNt[226] = LNt[164]*LNt[104]+LNt[166]*LNt[102]-(LNt[169]*LNt[63]+LNt[171]*LNt[61])+LNt[224]+LNt[225];
  LNt[227] = float(LNP2x3[71]+LNt[226])-LNP2x3[71];	//[22,48]<<23
  LNt[226] -= LNt[227];
  LNt[228] = float(LNP2x3[68]+LNt[226])-LNP2x3[68];	//[3,26]<<23
  LNt[226] -= LNt[228];
  LNt[229] = LNt[222]+LNt[227]+LNt[228];
  LNt[230] = float(LNP2x3[95]+LNt[229])-LNP2x3[95];	//[22,49]<<46
  LNt[229] -= LNt[230];
  LNt[231] = float(LNP2x3[91]+LNt[229])-LNP2x3[91];	//[4,27]<<46
  LNt[229] -= LNt[231];
  LNt[232] = LNt[166]*LNt[106]+LNt[168]*LNt[104]-(LNt[171]*LNt[65]+LNt[173]*LNt[63])+LNt[230]+LNt[231];
  LNt[233] = float(LNP2x3[114]+LNt[232])-LNP2x3[114];	//[10,33]<<69
  LNt[232] -= LNt[233];
  LNt[234] = LNt[168]*LNt[106]-LNt[173]*LNt[65]+LNt[233];
  LNt[235] = LNt[210]*LNt[234]+LNt[213]*LNt[232]+LNt[216]*LNt[229]+LNt[219]*LNt[226]+LNt[221]*LNt[223];
  LNt[236] = LNt[46]*LNt[138]+LNt[48]*LNt[135]-(LNt[159]*LNt[180]+LNt[161]*LNt[177])+LNt[210]*LNt[226]+LNt[213]*LNt[223];
  LNt[237] = LNt[48]*LNt[153]+LNt[50]*LNt[152]-(LNt[161]*LNt[195]+LNt[163]*LNt[194])+LNt[221]*LNt[234];
  LNt[238] = LNt[46]*LNt[135]-LNt[159]*LNt[177]+LNt[210]*LNt[223];
  LNt[239] = float(LNP2x3[48]+LNt[238])-LNP2x3[48];	//[22,48]<<0
  LNt[238] -= LNt[239];
  LNt[240] = float(LNP2x3[45]+LNt[238])-LNP2x3[45];	//[3,26]<<0
  LNt[238] -= LNt[240];
  LNt[241] = LNt[236]+LNt[239]+LNt[240];
  LNt[242] = float(LNP2x3[72]+LNt[241])-LNP2x3[72];	//[22,49]<<23
  LNt[241] -= LNt[242];
  LNt[243] = float(LNP2x3[68]+LNt[241])-LNP2x3[68];	//[4,27]<<23
  LNt[241] -= LNt[243];
  LNt[244] = LNt[196]+LNt[210]*LNt[229]+LNt[213]*LNt[226]+LNt[216]*LNt[223]+LNt[242]+LNt[243];
  LNt[245] = float(LNP2x3[96]+LNt[244])-LNP2x3[96];	//[22,50]<<46
  LNt[244] -= LNt[245];
  LNt[246] = float(LNP2x3[91]+LNt[244])-LNP2x3[91];	//[5,28]<<46
  LNt[244] -= LNt[246];
  LNt[247] = LNt[197]+LNt[210]*LNt[232]+LNt[213]*LNt[229]+LNt[216]*LNt[226]+LNt[219]*LNt[223]+LNt[245]+LNt[246];
  LNt[248] = float(LNP2x3[119]+LNt[247])-LNP2x3[119];	//[22,50]<<69
  LNt[247] -= LNt[248];
  LNt[249] = float(LNP2x3[114]+LNt[247])-LNP2x3[114];	//[5,28]<<69
  LNt[247] -= LNt[249];
  LNt[250] = LNt[198]+LNt[235]+LNt[248]+LNt[249];
  LNt[251] = (float(LNP2x3[125]+LNt[250]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[250] -= LNt[251];
  LNt[252] = (float(LNP2x3[125]+LNt[250]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[250] -= LNt[252];
  LNt[253] = LNt[199]+LNt[213]*LNt[234]+LNt[216]*LNt[232]+LNt[219]*LNt[229]+LNt[221]*LNt[226]+LNt[251]+LNt[252];
  LNt[254] = (float(LNP2x3[125]+LNt[253]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[253] -= LNt[254];
  LNt[255] = (float(LNP2x3[125]+LNt[253]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[253] -= LNt[255];
  LNt[256] = LNt[200]+LNt[216]*LNt[234]+LNt[219]*LNt[232]+LNt[221]*LNt[229]+LNt[254]+LNt[255];
  LNt[257] = (float(LNP2x3[125]+LNt[256]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
  LNt[256] -= LNt[257];
  LNt[258] = (float(LNP2x3[125]+LNt[256]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
  LNt[256] -= LNt[258];
  LNt[259] = LNt[201]+LNt[219]*LNt[234]+LNt[221]*LNt[232]+LNt[257]+LNt[258];
  LNt[260] = (float(LNP2x3[125]+LNt[259]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
  LNt[259] -= LNt[260];
  LNt[261] = (float(LNP2x3[125]+LNt[259]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
  LNt[259] -= LNt[261];
  LNt[262] = LNt[237]+LNt[260]+LNt[261];
  LNt[263] = (float(LNP2x3[125]+LNt[262]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
  LNt[262] -= LNt[263];
  LNt[264] = LNt[50]*LNt[153]-LNt[163]*LNt[195]+LNt[263];
  LNt[265] = 0.0-(LNt[26]-LNt[31])+LNt[35];
  LNt[266] = d.y;
  LNt[267] = float(LNP2x3[53]+LNt[266])-LNP2x3[53];	//[22,53]<<0
  LNt[266] -= LNt[267];
  LNt[268] = float(LNP2x3[45]+LNt[266])-LNP2x3[45];	//[8,31]<<0
  LNt[266] -= LNt[268];
  LNt[269] = LNt[267]+LNt[268];
  LNt[270] = float(LNP2x3[68]+LNt[269])-LNP2x3[68];	//[7,30]<<23
  LNt[269] -= LNt[270];
  LNt[271] = LNt[266]-LNt[41];
  LNt[272] = float(LNP2x3[45]+LNt[271])-LNP2x3[45];	//[1,24]<<0
  LNt[271] -= LNt[272];
  LNt[273] = LNt[269]-LNt[44]+LNt[272];
  LNt[274] = float(LNP2x3[68]+LNt[273])-LNP2x3[68];	//[1,24]<<23
  LNt[273] -= LNt[274];
  LNt[275] = LNt[202]-LNt[27];
  LNt[276] = float(LNP2x3[45]+LNt[275])-LNP2x3[45];	//[1,24]<<0
  LNt[275] -= LNt[276];
  LNt[277] = LNt[205]-LNt[30]+LNt[276];
  LNt[278] = float(LNP2x3[68]+LNt[277])-LNP2x3[68];	//[1,24]<<23
  LNt[277] -= LNt[278];
  LNt[279] = LNt[206]-LNt[31]+LNt[278];
  LNt[280] = LNt[107]-LNt[27];
  LNt[281] = float(LNP2x3[45]+LNt[280])-LNP2x3[45];	//[1,24]<<0
  LNt[280] -= LNt[281];
  LNt[282] = LNt[110]-LNt[30]+LNt[281];
  LNt[283] = float(LNP2x3[68]+LNt[282])-LNP2x3[68];	//[1,24]<<23
  LNt[282] -= LNt[283];
  LNt[284] = LNt[111]-LNt[31]+LNt[283];
  LNt[285] = LNt[66]-LNt[27];
  LNt[286] = float(LNP2x3[45]+LNt[285])-LNP2x3[45];	//[1,24]<<0
  LNt[285] -= LNt[286];
  LNt[287] = LNt[69]-LNt[30]+LNt[286];
  LNt[288] = float(LNP2x3[68]+LNt[287])-LNP2x3[68];	//[1,24]<<23
  LNt[287] -= LNt[288];
  LNt[289] = LNt[70]-LNt[31]+LNt[288];
  LNt[290] = LNt[280]*LNt[96]+LNt[282]*LNt[93]+LNt[284]*LNt[90]-(LNt[120]*LNt[289]+LNt[123]*LNt[287]+LNt[126]*LNt[285]);
  LNt[291] = LNt[280]*LNt[99]+LNt[282]*LNt[96]+LNt[284]*LNt[93]-(LNt[123]*LNt[289]+LNt[126]*LNt[287]+LNt[129]*LNt[285]);
  LNt[292] = LNt[280]*LNt[101]+LNt[282]*LNt[99]+LNt[284]*LNt[96]-(LNt[126]*LNt[289]+LNt[129]*LNt[287]+LNt[131]*LNt[285]);
  LNt[293] = LNt[280]*LNt[90]-LNt[120]*LNt[285];
  LNt[294] = float(LNP2x3[47]+LNt[293])-LNP2x3[47];	//[22,47]<<0
  LNt[293] -= LNt[294];
  LNt[295] = float(LNP2x3[45]+LNt[293])-LNP2x3[45];	//[2,25]<<0
  LNt[293] -= LNt[295];
  LNt[296] = LNt[280]*LNt[93]+LNt[282]*LNt[90]-(LNt[120]*LNt[287]+LNt[123]*LNt[285])+LNt[294]+LNt[295];
  LNt[297] = float(LNP2x3[71]+LNt[296])-LNP2x3[71];	//[22,48]<<23
  LNt[296] -= LNt[297];
  LNt[298] = float(LNP2x3[68]+LNt[296])-LNP2x3[68];	//[3,26]<<23
  LNt[296] -= LNt[298];
  LNt[299] = LNt[290]+LNt[297]+LNt[298];
  LNt[300] = float(LNP2x3[95]+LNt[299])-LNP2x3[95];	//[22,49]<<46
  LNt[299] -= LNt[300];
  LNt[301] = float(LNP2x3[91]+LNt[299])-LNP2x3[91];	//[4,27]<<46
  LNt[299] -= LNt[301];
  LNt[302] = LNt[291]+LNt[300]+LNt[301];
  LNt[303] = float(LNP2x3[118]+LNt[302])-LNP2x3[118];	//[22,49]<<69
  LNt[302] -= LNt[303];
  LNt[304] = float(LNP2x3[114]+LNt[302])-LNP2x3[114];	//[4,27]<<69
  LNt[302] -= LNt[304];
  LNt[305] = LNt[292]+LNt[303]+LNt[304];
  LNt[306] = (float(LNP2x3[125]+LNt[305]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[305] -= LNt[306];
  LNt[307] = (float(LNP2x3[125]+LNt[305]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[305] -= LNt[307];
  LNt[308] = LNt[282]*LNt[101]+LNt[284]*LNt[99]-(LNt[129]*LNt[289]+LNt[131]*LNt[287])+LNt[306]+LNt[307];
  LNt[309] = (float(LNP2x3[125]+LNt[308]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
  LNt[308] -= LNt[309];
  LNt[310] = LNt[284]*LNt[101]-LNt[131]*LNt[289]+LNt[309];
  LNt[311] = (float(LNP2x3[125]+LNt[310]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
  LNt[310] -= LNt[311];
  LNt[312] = LNt[275]*LNt[141]+LNt[277]*LNt[138]+LNt[279]*LNt[135]-(LNt[159]*LNt[299]+LNt[161]*LNt[296]+LNt[163]*LNt[293]);
  LNt[313] = LNt[275]*LNt[144]+LNt[277]*LNt[141]+LNt[279]*LNt[138]-(LNt[159]*LNt[302]+LNt[161]*LNt[299]+LNt[163]*LNt[296]);
  LNt[314] = LNt[275]*LNt[147]+LNt[277]*LNt[144]+LNt[279]*LNt[141]-(LNt[159]*LNt[305]+LNt[161]*LNt[302]+LNt[163]*LNt[299]);
  LNt[315] = LNt[275]*LNt[150]+LNt[277]*LNt[147]+LNt[279]*LNt[144]-(LNt[159]*LNt[308]+LNt[161]*LNt[305]+LNt[163]*LNt[302]);
  LNt[316] = LNt[275]*LNt[152]+LNt[277]*LNt[150]+LNt[279]*LNt[147]-(LNt[159]*LNt[310]+LNt[161]*LNt[308]+LNt[163]*LNt[305]);
  LNt[317] = LNt[275]*LNt[153]+LNt[277]*LNt[152]+LNt[279]*LNt[150]-(LNt[159]*LNt[311]+LNt[161]*LNt[310]+LNt[163]*LNt[308]);
  LNt[318] = LNt[280]*LNt[106]+LNt[282]*LNt[104]+LNt[284]*LNt[102]-(LNt[61]*LNt[289]+LNt[63]*LNt[287]+LNt[65]*LNt[285]);
  LNt[319] = LNt[280]*LNt[102]-LNt[61]*LNt[285];
  LNt[320] = float(LNP2x3[47]+LNt[319])-LNP2x3[47];	//[22,47]<<0
  LNt[319] -= LNt[320];
  LNt[321] = float(LNP2x3[45]+LNt[319])-LNP2x3[45];	//[2,25]<<0
  LNt[319] -= LNt[321];
  LNt[322] = LNt[280]*LNt[104]+LNt[282]*LNt[102]-(LNt[61]*LNt[287]+LNt[63]*LNt[285])+LNt[320]+LNt[321];
  LNt[323] = float(LNP2x3[71]+LNt[322])-LNP2x3[71];	//[22,48]<<23
  LNt[322] -= LNt[323];
  LNt[324] = float(LNP2x3[68]+LNt[322])-LNP2x3[68];	//[3,26]<<23
  LNt[322] -= LNt[324];
  LNt[325] = LNt[318]+LNt[323]+LNt[324];
  LNt[326] = float(LNP2x3[95]+LNt[325])-LNP2x3[95];	//[22,49]<<46
  LNt[325] -= LNt[326];
  LNt[327] = float(LNP2x3[91]+LNt[325])-LNP2x3[91];	//[4,27]<<46
  LNt[325] -= LNt[327];
  LNt[328] = LNt[282]*LNt[106]+LNt[284]*LNt[104]-(LNt[63]*LNt[289]+LNt[65]*LNt[287])+LNt[326]+LNt[327];
  LNt[329] = float(LNP2x3[114]+LNt[328])-LNP2x3[114];	//[10,33]<<69
  LNt[328] -= LNt[329];
  LNt[330] = LNt[284]*LNt[106]-LNt[65]*LNt[289]+LNt[329];
  LNt[331] = LNt[210]*LNt[330]+LNt[213]*LNt[328]+LNt[216]*LNt[325]+LNt[219]*LNt[322]+LNt[221]*LNt[319];
  LNt[332] = LNt[275]*LNt[138]+LNt[277]*LNt[135]-(LNt[159]*LNt[296]+LNt[161]*LNt[293])+LNt[210]*LNt[322]+LNt[213]*LNt[319];
  LNt[333] = LNt[277]*LNt[153]+LNt[279]*LNt[152]-(LNt[161]*LNt[311]+LNt[163]*LNt[310])+LNt[221]*LNt[330];
  LNt[334] = LNt[275]*LNt[135]-LNt[159]*LNt[293]+LNt[210]*LNt[319];
  LNt[335] = float(LNP2x3[48]+LNt[334])-LNP2x3[48];	//[22,48]<<0
  LNt[334] -= LNt[335];
  LNt[336] = float(LNP2x3[45]+LNt[334])-LNP2x3[45];	//[3,26]<<0
  LNt[334] -= LNt[336];
  LNt[337] = LNt[332]+LNt[335]+LNt[336];
  LNt[338] = float(LNP2x3[72]+LNt[337])-LNP2x3[72];	//[22,49]<<23
  LNt[337] -= LNt[338];
  LNt[339] = float(LNP2x3[68]+LNt[337])-LNP2x3[68];	//[4,27]<<23
  LNt[337] -= LNt[339];
  LNt[340] = LNt[312]+LNt[210]*LNt[325]+LNt[213]*LNt[322]+LNt[216]*LNt[319]+LNt[338]+LNt[339];
  LNt[341] = float(LNP2x3[96]+LNt[340])-LNP2x3[96];	//[22,50]<<46
  LNt[340] -= LNt[341];
  LNt[342] = float(LNP2x3[91]+LNt[340])-LNP2x3[91];	//[5,28]<<46
  LNt[340] -= LNt[342];
  LNt[343] = LNt[313]+LNt[210]*LNt[328]+LNt[213]*LNt[325]+LNt[216]*LNt[322]+LNt[219]*LNt[319]+LNt[341]+LNt[342];
  LNt[344] = float(LNP2x3[119]+LNt[343])-LNP2x3[119];	//[22,50]<<69
  LNt[343] -= LNt[344];
  LNt[345] = float(LNP2x3[114]+LNt[343])-LNP2x3[114];	//[5,28]<<69
  LNt[343] -= LNt[345];
  LNt[346] = LNt[314]+LNt[331]+LNt[344]+LNt[345];
  LNt[347] = (float(LNP2x3[125]+LNt[346]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[346] -= LNt[347];
  LNt[348] = (float(LNP2x3[125]+LNt[346]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[346] -= LNt[348];
  LNt[349] = LNt[315]+LNt[213]*LNt[330]+LNt[216]*LNt[328]+LNt[219]*LNt[325]+LNt[221]*LNt[322]+LNt[347]+LNt[348];
  LNt[350] = (float(LNP2x3[125]+LNt[349]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[349] -= LNt[350];
  LNt[351] = (float(LNP2x3[125]+LNt[349]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[349] -= LNt[351];
  LNt[352] = LNt[316]+LNt[216]*LNt[330]+LNt[219]*LNt[328]+LNt[221]*LNt[325]+LNt[350]+LNt[351];
  LNt[353] = (float(LNP2x3[125]+LNt[352]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
  LNt[352] -= LNt[353];
  LNt[354] = (float(LNP2x3[125]+LNt[352]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
  LNt[352] -= LNt[354];
  LNt[355] = LNt[317]+LNt[219]*LNt[330]+LNt[221]*LNt[328]+LNt[353]+LNt[354];
  LNt[356] = (float(LNP2x3[125]+LNt[355]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
  LNt[355] -= LNt[356];
  LNt[357] = (float(LNP2x3[125]+LNt[355]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
  LNt[355] -= LNt[357];
  LNt[358] = LNt[333]+LNt[356]+LNt[357];
  LNt[359] = (float(LNP2x3[125]+LNt[358]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
  LNt[358] -= LNt[359];
  LNt[360] = LNt[279]*LNt[153]-LNt[163]*LNt[311]+LNt[359];
  LNt[361] = LNt[270]-LNt[45]+LNt[274];
  LNt[362] = LNt[32]*LNt[244]+LNt[34]*LNt[241]+LNt[265]*LNt[238]+LNt[271]*LNt[340]+LNt[273]*LNt[337]+LNt[361]*LNt[334];
  LNt[363] = LNt[32]*LNt[247]+LNt[34]*LNt[244]+LNt[265]*LNt[241]+LNt[271]*LNt[343]+LNt[273]*LNt[340]+LNt[361]*LNt[337];
  LNt[364] = LNt[32]*LNt[250]+LNt[34]*LNt[247]+LNt[265]*LNt[244]+LNt[271]*LNt[346]+LNt[273]*LNt[343]+LNt[361]*LNt[340];
  LNt[365] = LNt[32]*LNt[253]+LNt[34]*LNt[250]+LNt[265]*LNt[247]+LNt[271]*LNt[349]+LNt[273]*LNt[346]+LNt[361]*LNt[343];
  LNt[366] = LNt[32]*LNt[256]+LNt[34]*LNt[253]+LNt[265]*LNt[250]+LNt[271]*LNt[352]+LNt[273]*LNt[349]+LNt[361]*LNt[346];
  LNt[367] = LNt[32]*LNt[259]+LNt[34]*LNt[256]+LNt[265]*LNt[253]+LNt[271]*LNt[355]+LNt[273]*LNt[352]+LNt[361]*LNt[349];
  LNt[368] = LNt[32]*LNt[262]+LNt[34]*LNt[259]+LNt[265]*LNt[256]+LNt[271]*LNt[358]+LNt[273]*LNt[355]+LNt[361]*LNt[352];
  LNt[369] = LNt[32]*LNt[264]+LNt[34]*LNt[262]+LNt[265]*LNt[259]+LNt[271]*LNt[360]+LNt[273]*LNt[358]+LNt[361]*LNt[355];
  LNt[370] = d.z;
  LNt[371] = float(LNP2x3[53]+LNt[370])-LNP2x3[53];	//[22,53]<<0
  LNt[370] -= LNt[371];
  LNt[372] = float(LNP2x3[45]+LNt[370])-LNP2x3[45];	//[8,31]<<0
  LNt[370] -= LNt[372];
  LNt[373] = LNt[371]+LNt[372];
  LNt[374] = float(LNP2x3[68]+LNt[373])-LNP2x3[68];	//[7,30]<<23
  LNt[373] -= LNt[374];
  LNt[375] = LNt[370]-LNt[56];
  LNt[376] = float(LNP2x3[45]+LNt[375])-LNP2x3[45];	//[1,24]<<0
  LNt[375] -= LNt[376];
  LNt[377] = LNt[373]-LNt[59]+LNt[376];
  LNt[378] = float(LNP2x3[68]+LNt[377])-LNP2x3[68];	//[1,24]<<23
  LNt[377] -= LNt[378];
  LNt[379] = LNt[275]*LNt[183]+LNt[277]*LNt[180]+LNt[279]*LNt[177]-(LNt[46]*LNt[299]+LNt[48]*LNt[296]+LNt[50]*LNt[293]);
  LNt[380] = LNt[275]*LNt[186]+LNt[277]*LNt[183]+LNt[279]*LNt[180]-(LNt[46]*LNt[302]+LNt[48]*LNt[299]+LNt[50]*LNt[296]);
  LNt[381] = LNt[275]*LNt[189]+LNt[277]*LNt[186]+LNt[279]*LNt[183]-(LNt[46]*LNt[305]+LNt[48]*LNt[302]+LNt[50]*LNt[299]);
  LNt[382] = LNt[275]*LNt[192]+LNt[277]*LNt[189]+LNt[279]*LNt[186]-(LNt[46]*LNt[308]+LNt[48]*LNt[305]+LNt[50]*LNt[302]);
  LNt[383] = LNt[275]*LNt[194]+LNt[277]*LNt[192]+LNt[279]*LNt[189]-(LNt[46]*LNt[310]+LNt[48]*LNt[308]+LNt[50]*LNt[305]);
  LNt[384] = LNt[275]*LNt[195]+LNt[277]*LNt[194]+LNt[279]*LNt[192]-(LNt[46]*LNt[311]+LNt[48]*LNt[310]+LNt[50]*LNt[308]);
  LNt[385] = LNt[280]*LNt[173]+LNt[282]*LNt[171]+LNt[284]*LNt[169]-(LNt[164]*LNt[289]+LNt[166]*LNt[287]+LNt[168]*LNt[285]);
  LNt[386] = LNt[280]*LNt[169]-LNt[164]*LNt[285];
  LNt[387] = float(LNP2x3[47]+LNt[386])-LNP2x3[47];	//[22,47]<<0
  LNt[386] -= LNt[387];
  LNt[388] = float(LNP2x3[45]+LNt[386])-LNP2x3[45];	//[2,25]<<0
  LNt[386] -= LNt[388];
  LNt[389] = LNt[280]*LNt[171]+LNt[282]*LNt[169]-(LNt[164]*LNt[287]+LNt[166]*LNt[285])+LNt[387]+LNt[388];
  LNt[390] = float(LNP2x3[71]+LNt[389])-LNP2x3[71];	//[22,48]<<23
  LNt[389] -= LNt[390];
  LNt[391] = float(LNP2x3[68]+LNt[389])-LNP2x3[68];	//[3,26]<<23
  LNt[389] -= LNt[391];
  LNt[392] = LNt[385]+LNt[390]+LNt[391];
  LNt[393] = float(LNP2x3[95]+LNt[392])-LNP2x3[95];	//[22,49]<<46
  LNt[392] -= LNt[393];
  LNt[394] = float(LNP2x3[91]+LNt[392])-LNP2x3[91];	//[4,27]<<46
  LNt[392] -= LNt[394];
  LNt[395] = LNt[282]*LNt[173]+LNt[284]*LNt[171]-(LNt[166]*LNt[289]+LNt[168]*LNt[287])+LNt[393]+LNt[394];
  LNt[396] = float(LNP2x3[114]+LNt[395])-LNP2x3[114];	//[10,33]<<69
  LNt[395] -= LNt[396];
  LNt[397] = LNt[284]*LNt[173]-LNt[168]*LNt[289]+LNt[396];
  LNt[398] = LNt[210]*LNt[397]+LNt[213]*LNt[395]+LNt[216]*LNt[392]+LNt[219]*LNt[389]+LNt[221]*LNt[386];
  LNt[399] = LNt[275]*LNt[180]+LNt[277]*LNt[177]-(LNt[46]*LNt[296]+LNt[48]*LNt[293])+LNt[210]*LNt[389]+LNt[213]*LNt[386];
  LNt[400] = LNt[277]*LNt[195]+LNt[279]*LNt[194]-(LNt[48]*LNt[311]+LNt[50]*LNt[310])+LNt[221]*LNt[397];
  LNt[401] = LNt[275]*LNt[177]-LNt[46]*LNt[293]+LNt[210]*LNt[386];
  LNt[402] = float(LNP2x3[48]+LNt[401])-LNP2x3[48];	//[22,48]<<0
  LNt[401] -= LNt[402];
  LNt[403] = float(LNP2x3[45]+LNt[401])-LNP2x3[45];	//[3,26]<<0
  LNt[401] -= LNt[403];
  LNt[404] = LNt[399]+LNt[402]+LNt[403];
  LNt[405] = float(LNP2x3[72]+LNt[404])-LNP2x3[72];	//[22,49]<<23
  LNt[404] -= LNt[405];
  LNt[406] = float(LNP2x3[68]+LNt[404])-LNP2x3[68];	//[4,27]<<23
  LNt[404] -= LNt[406];
  LNt[407] = LNt[379]+LNt[210]*LNt[392]+LNt[213]*LNt[389]+LNt[216]*LNt[386]+LNt[405]+LNt[406];
  LNt[408] = float(LNP2x3[96]+LNt[407])-LNP2x3[96];	//[22,50]<<46
  LNt[407] -= LNt[408];
  LNt[409] = float(LNP2x3[91]+LNt[407])-LNP2x3[91];	//[5,28]<<46
  LNt[407] -= LNt[409];
  LNt[410] = LNt[380]+LNt[210]*LNt[395]+LNt[213]*LNt[392]+LNt[216]*LNt[389]+LNt[219]*LNt[386]+LNt[408]+LNt[409];
  LNt[411] = float(LNP2x3[119]+LNt[410])-LNP2x3[119];	//[22,50]<<69
  LNt[410] -= LNt[411];
  LNt[412] = float(LNP2x3[114]+LNt[410])-LNP2x3[114];	//[5,28]<<69
  LNt[410] -= LNt[412];
  LNt[413] = LNt[381]+LNt[398]+LNt[411]+LNt[412];
  LNt[414] = (float(LNP2x3[125]+LNt[413]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[413] -= LNt[414];
  LNt[415] = (float(LNP2x3[125]+LNt[413]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[413] -= LNt[415];
  LNt[416] = LNt[382]+LNt[213]*LNt[397]+LNt[216]*LNt[395]+LNt[219]*LNt[392]+LNt[221]*LNt[389]+LNt[414]+LNt[415];
  LNt[417] = (float(LNP2x3[125]+LNt[416]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[416] -= LNt[417];
  LNt[418] = (float(LNP2x3[125]+LNt[416]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[416] -= LNt[418];
  LNt[419] = LNt[383]+LNt[216]*LNt[397]+LNt[219]*LNt[395]+LNt[221]*LNt[392]+LNt[417]+LNt[418];
  LNt[420] = (float(LNP2x3[125]+LNt[419]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
  LNt[419] -= LNt[420];
  LNt[421] = (float(LNP2x3[125]+LNt[419]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
  LNt[419] -= LNt[421];
  LNt[422] = LNt[384]+LNt[219]*LNt[397]+LNt[221]*LNt[395]+LNt[420]+LNt[421];
  LNt[423] = (float(LNP2x3[125]+LNt[422]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
  LNt[422] -= LNt[423];
  LNt[424] = (float(LNP2x3[125]+LNt[422]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
  LNt[422] -= LNt[424];
  LNt[425] = LNt[400]+LNt[423]+LNt[424];
  LNt[426] = (float(LNP2x3[125]+LNt[425]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
  LNt[425] -= LNt[426];
  LNt[427] = LNt[279]*LNt[195]-LNt[50]*LNt[311]+LNt[426];
  LNt[428] = LNt[374]-LNt[60]+LNt[378];
  LNt[429] = LNt[32]*LNt[241]+LNt[34]*LNt[238]+LNt[271]*LNt[337]+LNt[273]*LNt[334]-(LNt[375]*LNt[404]+LNt[377]*LNt[401]);
  LNt[430] = LNt[34]*LNt[264]+LNt[265]*LNt[262]+LNt[273]*LNt[360]+LNt[361]*LNt[358]-(LNt[377]*LNt[427]+LNt[428]*LNt[425]);
  LNt[431] = LNt[22]*LNt[26]+LNt[25]*LNt[25]+LNt[26]*LNt[22]+LNt[266]*LNt[270]+LNt[269]*LNt[269]+LNt[270]*LNt[266];
  LNt[432] = LNt[22]*LNt[25]+LNt[25]*LNt[22]+LNt[266]*LNt[269]+LNt[269]*LNt[266]+LNt[370]*LNt[373]+LNt[373]*LNt[370];
  LNt[433] = LNt[25]*LNt[26]+LNt[26]*LNt[25]+LNt[269]*LNt[270]+LNt[270]*LNt[269]+LNt[373]*LNt[374]+LNt[374]*LNt[373];
  LNt[434] = LNt[22]*LNt[22]+LNt[266]*LNt[266]+LNt[370]*LNt[370]-LNt[87];
  LNt[435] = float(LNP2x3[49]+LNt[434])-LNP2x3[49];	//[22,49]<<0
  LNt[434] -= LNt[435];
  LNt[436] = float(LNP2x3[45]+LNt[434])-LNP2x3[45];	//[4,27]<<0
  LNt[434] -= LNt[436];
  LNt[437] = LNt[432]-LNt[85]+LNt[435]+LNt[436];
  LNt[438] = float(LNP2x3[73]+LNt[437])-LNP2x3[73];	//[22,50]<<23
  LNt[437] -= LNt[438];
  LNt[439] = float(LNP2x3[68]+LNt[437])-LNP2x3[68];	//[5,28]<<23
  LNt[437] -= LNt[439];
  LNt[440] = LNt[431]+LNt[370]*LNt[374]+LNt[373]*LNt[373]+LNt[374]*LNt[370]-LNt[88]+LNt[438]+LNt[439];
  LNt[441] = float(LNP2x3[97]+LNt[440])-LNP2x3[97];	//[22,51]<<46
  LNt[440] -= LNt[441];
  LNt[442] = float(LNP2x3[91]+LNt[440])-LNP2x3[91];	//[6,29]<<46
  LNt[440] -= LNt[442];
  LNt[443] = LNt[433]-LNt[86]+LNt[441]+LNt[442];
  LNt[444] = float(LNP2x3[114]+LNt[443])-LNP2x3[114];	//[11,34]<<69
  LNt[443] -= LNt[444];
  LNt[445] = LNt[275]*LNt[229]+LNt[277]*LNt[226]+LNt[279]*LNt[223]-(LNt[46]*LNt[325]+LNt[48]*LNt[322]+LNt[50]*LNt[319]);
  LNt[446] = LNt[275]*LNt[232]+LNt[277]*LNt[229]+LNt[279]*LNt[226]-(LNt[46]*LNt[328]+LNt[48]*LNt[325]+LNt[50]*LNt[322]);
  LNt[447] = LNt[275]*LNt[234]+LNt[277]*LNt[232]+LNt[279]*LNt[229]-(LNt[46]*LNt[330]+LNt[48]*LNt[328]+LNt[50]*LNt[325]);
  LNt[448] = LNt[275]*LNt[226]+LNt[277]*LNt[223]-(LNt[46]*LNt[322]+LNt[48]*LNt[319])+LNt[159]*LNt[389]+LNt[161]*LNt[386];
  LNt[449] = LNt[277]*LNt[234]+LNt[279]*LNt[232]-(LNt[48]*LNt[330]+LNt[50]*LNt[328])+LNt[161]*LNt[397]+LNt[163]*LNt[395];
  LNt[450] = LNt[275]*LNt[223]-LNt[46]*LNt[319]+LNt[159]*LNt[386];
  LNt[451] = float(LNP2x3[48]+LNt[450])-LNP2x3[48];	//[22,48]<<0
  LNt[450] -= LNt[451];
  LNt[452] = float(LNP2x3[45]+LNt[450])-LNP2x3[45];	//[3,26]<<0
  LNt[450] -= LNt[452];
  LNt[453] = LNt[448]+LNt[451]+LNt[452];
  LNt[454] = float(LNP2x3[72]+LNt[453])-LNP2x3[72];	//[22,49]<<23
  LNt[453] -= LNt[454];
  LNt[455] = float(LNP2x3[68]+LNt[453])-LNP2x3[68];	//[4,27]<<23
  LNt[453] -= LNt[455];
  LNt[456] = LNt[445]+LNt[159]*LNt[392]+LNt[161]*LNt[389]+LNt[163]*LNt[386]+LNt[454]+LNt[455];
  LNt[457] = float(LNP2x3[96]+LNt[456])-LNP2x3[96];	//[22,50]<<46
  LNt[456] -= LNt[457];
  LNt[458] = float(LNP2x3[91]+LNt[456])-LNP2x3[91];	//[5,28]<<46
  LNt[456] -= LNt[458];
  LNt[459] = LNt[446]+LNt[159]*LNt[395]+LNt[161]*LNt[392]+LNt[163]*LNt[389]+LNt[457]+LNt[458];
  LNt[460] = float(LNP2x3[119]+LNt[459])-LNP2x3[119];	//[22,50]<<69
  LNt[459] -= LNt[460];
  LNt[461] = float(LNP2x3[114]+LNt[459])-LNP2x3[114];	//[5,28]<<69
  LNt[459] -= LNt[461];
  LNt[462] = LNt[447]+LNt[159]*LNt[397]+LNt[161]*LNt[395]+LNt[163]*LNt[392]+LNt[460]+LNt[461];
  LNt[463] = (float(LNP2x3[125]+LNt[462]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[462] -= LNt[463];
  LNt[464] = (float(LNP2x3[125]+LNt[462]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[462] -= LNt[464];
  LNt[465] = LNt[449]+LNt[463]+LNt[464];
  LNt[466] = (float(LNP2x3[125]+LNt[465]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
  LNt[465] -= LNt[466];
  LNt[467] = LNt[279]*LNt[234]-LNt[50]*LNt[330]+LNt[163]*LNt[397]+LNt[466];
  LNt[468] = (float(LNP2x3[125]+LNt[467]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[4,27]<<138
  LNt[467] -= LNt[468];
  LNt[469] = LNt[26]*LNt[26]+LNt[270]*LNt[270]+LNt[374]*LNt[374]-LNt[89]+LNt[444];
  LNt[470] = LNt[434]*LNt[462]+LNt[437]*LNt[459]+LNt[440]*LNt[456]+LNt[443]*LNt[453]+LNt[469]*LNt[450];
  LNt[471] = LNt[434]*LNt[465]+LNt[437]*LNt[462]+LNt[440]*LNt[459]+LNt[443]*LNt[456]+LNt[469]*LNt[453];
  LNt[472] = LNt[434]*LNt[467]+LNt[437]*LNt[465]+LNt[440]*LNt[462]+LNt[443]*LNt[459]+LNt[469]*LNt[456];
  LNt[473] = LNt[434]*LNt[468]+LNt[437]*LNt[467]+LNt[440]*LNt[465]+LNt[443]*LNt[462]+LNt[469]*LNt[459];
  LNt[474] = LNt[362]-(LNt[375]*LNt[407]+LNt[377]*LNt[404]+LNt[428]*LNt[401])+LNt[434]*LNt[456]+LNt[437]*LNt[453]+LNt[440]*LNt[450];
  LNt[475] = LNt[363]-(LNt[375]*LNt[410]+LNt[377]*LNt[407]+LNt[428]*LNt[404])+LNt[434]*LNt[459]+LNt[437]*LNt[456]+LNt[440]*LNt[453]+LNt[443]*LNt[450];
  LNt[476] = LNt[368]-(LNt[375]*LNt[425]+LNt[377]*LNt[422]+LNt[428]*LNt[419])+LNt[437]*LNt[468]+LNt[440]*LNt[467]+LNt[443]*LNt[465]+LNt[469]*LNt[462];
  LNt[477] = LNt[369]-(LNt[375]*LNt[427]+LNt[377]*LNt[425]+LNt[428]*LNt[422])+LNt[440]*LNt[468]+LNt[443]*LNt[467]+LNt[469]*LNt[465];
  LNt[478] = LNt[32]*LNt[238]+LNt[271]*LNt[334]-LNt[375]*LNt[401]+LNt[434]*LNt[450];
  LNt[479] = LNt[429]+LNt[434]*LNt[453]+LNt[437]*LNt[450];
  LNt[480] = LNt[364]-(LNt[375]*LNt[413]+LNt[377]*LNt[410]+LNt[428]*LNt[407])+LNt[470];
  LNt[481] = LNt[365]-(LNt[375]*LNt[416]+LNt[377]*LNt[413]+LNt[428]*LNt[410])+LNt[471];
  LNt[482] = LNt[366]-(LNt[375]*LNt[419]+LNt[377]*LNt[416]+LNt[428]*LNt[413])+LNt[472];
  LNt[483] = LNt[367]-(LNt[375]*LNt[422]+LNt[377]*LNt[419]+LNt[428]*LNt[416])+LNt[473];
  LNt[484] = LNt[430]+LNt[443]*LNt[468]+LNt[469]*LNt[467];
  LNt[485] = LNt[265]*LNt[264]+LNt[361]*LNt[360]-LNt[428]*LNt[427]+LNt[469]*LNt[468];
  LNt[486] = (((((((LNt[485])+LNt[484])+LNt[477])+LNt[476])+LNt[483])+LNt[482])+LNt[481])+LNt[480];
  LNt[21] = (((((LNt[486])+LNt[475])+LNt[474])+LNt[479])+LNt[478]);
}
if (LNt[21]<0){
  LNt[0] = -1.;
}else{
  if (LNt[21]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=860 multiplies=716 normalizes=217 */


Incircle3dHyperPlane::Incircle3dHyperPlane(const Point3d& a, const Point3d& b, const Point3d& c, const Point3d& d){
LNt[0] = d.y;
LNt[1] = float(LNP2x3[53]+LNt[0])-LNP2x3[53];	//[22,53]<<0
LNt[0] -= LNt[1];
LNt[2] = float(LNP2x3[45]+LNt[0])-LNP2x3[45];	//[8,31]<<0
LNt[0] -= LNt[2];
LNt[3] = LNt[1]+LNt[2];
LNt[4] = float(LNP2x3[68]+LNt[3])-LNP2x3[68];	//[7,30]<<23
LNt[3] -= LNt[4];
LNt[5] = c.z;
LNt[6] = float(LNP2x3[53]+LNt[5])-LNP2x3[53];	//[22,53]<<0
LNt[5] -= LNt[6];
LNt[7] = float(LNP2x3[45]+LNt[5])-LNP2x3[45];	//[8,31]<<0
LNt[5] -= LNt[7];
LNt[8] = LNt[6]+LNt[7];
LNt[9] = float(LNP2x3[68]+LNt[8])-LNP2x3[68];	//[7,30]<<23
LNt[8] -= LNt[9];
LNt[10] = a.x;
LNt[11] = float(LNP2x3[53]+LNt[10])-LNP2x3[53];	//[22,53]<<0
LNt[10] -= LNt[11];
LNt[12] = float(LNP2x3[45]+LNt[10])-LNP2x3[45];	//[8,31]<<0
LNt[10] -= LNt[12];
LNt[13] = LNt[11]+LNt[12];
LNt[14] = float(LNP2x3[68]+LNt[13])-LNP2x3[68];	//[7,30]<<23
LNt[13] -= LNt[14];
LNt[15] = a.y;
LNt[16] = float(LNP2x3[53]+LNt[15])-LNP2x3[53];	//[22,53]<<0
LNt[15] -= LNt[16];
LNt[17] = float(LNP2x3[45]+LNt[15])-LNP2x3[45];	//[8,31]<<0
LNt[15] -= LNt[17];
LNt[18] = LNt[16]+LNt[17];
LNt[19] = float(LNP2x3[68]+LNt[18])-LNP2x3[68];	//[7,30]<<23
LNt[18] -= LNt[19];
LNt[20] = LNt[10]*LNt[14]+LNt[13]*LNt[13]+LNt[14]*LNt[10]+LNt[15]*LNt[19]+LNt[18]*LNt[18]+LNt[19]*LNt[15];
LNt[21] = a.z;
LNt[22] = float(LNP2x3[53]+LNt[21])-LNP2x3[53];	//[22,53]<<0
LNt[21] -= LNt[22];
LNt[23] = float(LNP2x3[45]+LNt[21])-LNP2x3[45];	//[8,31]<<0
LNt[21] -= LNt[23];
LNt[24] = LNt[22]+LNt[23];
LNt[25] = float(LNP2x3[68]+LNt[24])-LNP2x3[68];	//[7,30]<<23
LNt[24] -= LNt[25];
LNt[26] = LNt[10]*LNt[13]+LNt[13]*LNt[10]+LNt[15]*LNt[18]+LNt[18]*LNt[15]+LNt[21]*LNt[24]+LNt[24]*LNt[21];
LNt[27] = LNt[13]*LNt[14]+LNt[14]*LNt[13]+LNt[18]*LNt[19]+LNt[19]*LNt[18]+LNt[24]*LNt[25]+LNt[25]*LNt[24];
LNt[28] = LNt[10]*LNt[10]+LNt[15]*LNt[15]+LNt[21]*LNt[21];
LNt[29] = float(LNP2x3[48]+LNt[28])-LNP2x3[48];	//[22,48]<<0
LNt[28] -= LNt[29];
LNt[30] = float(LNP2x3[45]+LNt[28])-LNP2x3[45];	//[3,26]<<0
LNt[28] -= LNt[30];
LNt[31] = LNt[26]+LNt[29]+LNt[30];
LNt[32] = float(LNP2x3[72]+LNt[31])-LNP2x3[72];	//[22,49]<<23
LNt[31] -= LNt[32];
LNt[33] = float(LNP2x3[68]+LNt[31])-LNP2x3[68];	//[4,27]<<23
LNt[31] -= LNt[33];
LNt[34] = LNt[20]+LNt[21]*LNt[25]+LNt[24]*LNt[24]+LNt[25]*LNt[21]+LNt[32]+LNt[33];
LNt[35] = float(LNP2x3[96]+LNt[34])-LNP2x3[96];	//[22,50]<<46
LNt[34] -= LNt[35];
LNt[36] = float(LNP2x3[91]+LNt[34])-LNP2x3[91];	//[5,28]<<46
LNt[34] -= LNt[36];
LNt[37] = LNt[27]+LNt[35]+LNt[36];
LNt[38] = float(LNP2x3[114]+LNt[37])-LNP2x3[114];	//[10,33]<<69
LNt[37] -= LNt[38];
LNt[39] = LNt[14]*LNt[14]+LNt[19]*LNt[19]+LNt[25]*LNt[25]+LNt[38];
LNt[40] = b.x;
LNt[41] = float(LNP2x3[53]+LNt[40])-LNP2x3[53];	//[22,53]<<0
LNt[40] -= LNt[41];
LNt[42] = float(LNP2x3[45]+LNt[40])-LNP2x3[45];	//[8,31]<<0
LNt[40] -= LNt[42];
LNt[43] = LNt[41]+LNt[42];
LNt[44] = float(LNP2x3[68]+LNt[43])-LNP2x3[68];	//[7,30]<<23
LNt[43] -= LNt[44];
LNt[45] = b.y;
LNt[46] = float(LNP2x3[53]+LNt[45])-LNP2x3[53];	//[22,53]<<0
LNt[45] -= LNt[46];
LNt[47] = float(LNP2x3[45]+LNt[45])-LNP2x3[45];	//[8,31]<<0
LNt[45] -= LNt[47];
LNt[48] = LNt[46]+LNt[47];
LNt[49] = float(LNP2x3[68]+LNt[48])-LNP2x3[68];	//[7,30]<<23
LNt[48] -= LNt[49];
LNt[50] = LNt[40]*LNt[44]+LNt[43]*LNt[43]+LNt[44]*LNt[40]+LNt[45]*LNt[49]+LNt[48]*LNt[48]+LNt[49]*LNt[45];
LNt[51] = b.z;
LNt[52] = float(LNP2x3[53]+LNt[51])-LNP2x3[53];	//[22,53]<<0
LNt[51] -= LNt[52];
LNt[53] = float(LNP2x3[45]+LNt[51])-LNP2x3[45];	//[8,31]<<0
LNt[51] -= LNt[53];
LNt[54] = LNt[52]+LNt[53];
LNt[55] = float(LNP2x3[68]+LNt[54])-LNP2x3[68];	//[7,30]<<23
LNt[54] -= LNt[55];
LNt[56] = LNt[40]*LNt[43]+LNt[43]*LNt[40]+LNt[45]*LNt[48]+LNt[48]*LNt[45]+LNt[51]*LNt[54]+LNt[54]*LNt[51];
LNt[57] = LNt[43]*LNt[44]+LNt[44]*LNt[43]+LNt[48]*LNt[49]+LNt[49]*LNt[48]+LNt[54]*LNt[55]+LNt[55]*LNt[54];
LNt[58] = LNt[40]*LNt[40]+LNt[45]*LNt[45]+LNt[51]*LNt[51];
LNt[59] = float(LNP2x3[48]+LNt[58])-LNP2x3[48];	//[22,48]<<0
LNt[58] -= LNt[59];
LNt[60] = float(LNP2x3[45]+LNt[58])-LNP2x3[45];	//[3,26]<<0
LNt[58] -= LNt[60];
LNt[61] = LNt[56]+LNt[59]+LNt[60];
LNt[62] = float(LNP2x3[72]+LNt[61])-LNP2x3[72];	//[22,49]<<23
LNt[61] -= LNt[62];
LNt[63] = float(LNP2x3[68]+LNt[61])-LNP2x3[68];	//[4,27]<<23
LNt[61] -= LNt[63];
LNt[64] = LNt[50]+LNt[51]*LNt[55]+LNt[54]*LNt[54]+LNt[55]*LNt[51]+LNt[62]+LNt[63];
LNt[65] = float(LNP2x3[96]+LNt[64])-LNP2x3[96];	//[22,50]<<46
LNt[64] -= LNt[65];
LNt[66] = float(LNP2x3[91]+LNt[64])-LNP2x3[91];	//[5,28]<<46
LNt[64] -= LNt[66];
LNt[67] = LNt[57]+LNt[65]+LNt[66];
LNt[68] = float(LNP2x3[114]+LNt[67])-LNP2x3[114];	//[10,33]<<69
LNt[67] -= LNt[68];
LNt[69] = LNt[44]*LNt[44]+LNt[49]*LNt[49]+LNt[55]*LNt[55]+LNt[68];
LNt[70] = LNt[28]-LNt[58];
LNt[71] = float(LNP2x3[45]+LNt[70])-LNP2x3[45];	//[1,24]<<0
LNt[70] -= LNt[71];
LNt[72] = LNt[31]-LNt[61]+LNt[71];
LNt[73] = float(LNP2x3[68]+LNt[72])-LNP2x3[68];	//[1,24]<<23
LNt[72] -= LNt[73];
LNt[74] = LNt[34]-LNt[64]+LNt[73];
LNt[75] = float(LNP2x3[91]+LNt[74])-LNP2x3[91];	//[1,24]<<46
LNt[74] -= LNt[75];
LNt[76] = LNt[37]-LNt[67]+LNt[75];
LNt[77] = float(LNP2x3[114]+LNt[76])-LNP2x3[114];	//[1,24]<<69
LNt[76] -= LNt[77];
LNt[78] = LNt[39]-LNt[69]+LNt[77];
LNt[79] = c.x;
LNt[80] = float(LNP2x3[53]+LNt[79])-LNP2x3[53];	//[22,53]<<0
LNt[79] -= LNt[80];
LNt[81] = float(LNP2x3[45]+LNt[79])-LNP2x3[45];	//[8,31]<<0
LNt[79] -= LNt[81];
LNt[82] = LNt[80]+LNt[81];
LNt[83] = float(LNP2x3[68]+LNt[82])-LNP2x3[68];	//[7,30]<<23
LNt[82] -= LNt[83];
LNt[84] = c.y;
LNt[85] = float(LNP2x3[53]+LNt[84])-LNP2x3[53];	//[22,53]<<0
LNt[84] -= LNt[85];
LNt[86] = float(LNP2x3[45]+LNt[84])-LNP2x3[45];	//[8,31]<<0
LNt[84] -= LNt[86];
LNt[87] = LNt[85]+LNt[86];
LNt[88] = float(LNP2x3[68]+LNt[87])-LNP2x3[68];	//[7,30]<<23
LNt[87] -= LNt[88];
LNt[89] = LNt[79]*LNt[83]+LNt[82]*LNt[82]+LNt[83]*LNt[79]+LNt[84]*LNt[88]+LNt[87]*LNt[87]+LNt[88]*LNt[84];
LNt[90] = LNt[79]*LNt[82]+LNt[82]*LNt[79]+LNt[84]*LNt[87]+LNt[87]*LNt[84]+LNt[5]*LNt[8]+LNt[8]*LNt[5];
LNt[91] = LNt[82]*LNt[83]+LNt[83]*LNt[82]+LNt[87]*LNt[88]+LNt[88]*LNt[87]+LNt[8]*LNt[9]+LNt[9]*LNt[8];
LNt[92] = LNt[79]*LNt[79]+LNt[84]*LNt[84]+LNt[5]*LNt[5];
LNt[93] = float(LNP2x3[48]+LNt[92])-LNP2x3[48];	//[22,48]<<0
LNt[92] -= LNt[93];
LNt[94] = float(LNP2x3[45]+LNt[92])-LNP2x3[45];	//[3,26]<<0
LNt[92] -= LNt[94];
LNt[95] = LNt[90]+LNt[93]+LNt[94];
LNt[96] = float(LNP2x3[72]+LNt[95])-LNP2x3[72];	//[22,49]<<23
LNt[95] -= LNt[96];
LNt[97] = float(LNP2x3[68]+LNt[95])-LNP2x3[68];	//[4,27]<<23
LNt[95] -= LNt[97];
LNt[98] = LNt[89]+LNt[5]*LNt[9]+LNt[8]*LNt[8]+LNt[9]*LNt[5]+LNt[96]+LNt[97];
LNt[99] = float(LNP2x3[96]+LNt[98])-LNP2x3[96];	//[22,50]<<46
LNt[98] -= LNt[99];
LNt[100] = float(LNP2x3[91]+LNt[98])-LNP2x3[91];	//[5,28]<<46
LNt[98] -= LNt[100];
LNt[101] = LNt[91]+LNt[99]+LNt[100];
LNt[102] = float(LNP2x3[114]+LNt[101])-LNP2x3[114];	//[10,33]<<69
LNt[101] -= LNt[102];
LNt[103] = LNt[83]*LNt[83]+LNt[88]*LNt[88]+LNt[9]*LNt[9]+LNt[102];
LNt[104] = LNt[21]-LNt[51];
LNt[105] = float(LNP2x3[45]+LNt[104])-LNP2x3[45];	//[1,24]<<0
LNt[104] -= LNt[105];
LNt[106] = LNt[24]-LNt[54]+LNt[105];
LNt[107] = float(LNP2x3[68]+LNt[106])-LNP2x3[68];	//[1,24]<<23
LNt[106] -= LNt[107];
LNt[108] = LNt[25]-LNt[55]+LNt[107];
LNt[109] = LNt[5]*LNt[74]+LNt[8]*LNt[72]+LNt[9]*LNt[70]-(LNt[92]*LNt[108]+LNt[95]*LNt[106]+LNt[98]*LNt[104]);
LNt[110] = LNt[5]*LNt[76]+LNt[8]*LNt[74]+LNt[9]*LNt[72]-(LNt[95]*LNt[108]+LNt[98]*LNt[106]+LNt[101]*LNt[104]);
LNt[111] = LNt[5]*LNt[78]+LNt[8]*LNt[76]+LNt[9]*LNt[74]-(LNt[98]*LNt[108]+LNt[101]*LNt[106]+LNt[103]*LNt[104]);
LNt[112] = LNt[21]*LNt[64]+LNt[24]*LNt[61]+LNt[25]*LNt[58]-(LNt[51]*LNt[34]+LNt[54]*LNt[31]+LNt[55]*LNt[28]);
LNt[113] = LNt[21]*LNt[67]+LNt[24]*LNt[64]+LNt[25]*LNt[61]-(LNt[51]*LNt[37]+LNt[54]*LNt[34]+LNt[55]*LNt[31]);
LNt[114] = LNt[21]*LNt[69]+LNt[24]*LNt[67]+LNt[25]*LNt[64]-(LNt[51]*LNt[39]+LNt[54]*LNt[37]+LNt[55]*LNt[34]);
LNt[115] = LNt[21]*LNt[58]-LNt[51]*LNt[28];
LNt[116] = float(LNP2x3[47]+LNt[115])-LNP2x3[47];	//[22,47]<<0
LNt[115] -= LNt[116];
LNt[117] = float(LNP2x3[45]+LNt[115])-LNP2x3[45];	//[2,25]<<0
LNt[115] -= LNt[117];
LNt[118] = LNt[21]*LNt[61]+LNt[24]*LNt[58]-(LNt[51]*LNt[31]+LNt[54]*LNt[28])+LNt[116]+LNt[117];
LNt[119] = float(LNP2x3[71]+LNt[118])-LNP2x3[71];	//[22,48]<<23
LNt[118] -= LNt[119];
LNt[120] = float(LNP2x3[68]+LNt[118])-LNP2x3[68];	//[3,26]<<23
LNt[118] -= LNt[120];
LNt[121] = LNt[112]+LNt[119]+LNt[120];
LNt[122] = float(LNP2x3[95]+LNt[121])-LNP2x3[95];	//[22,49]<<46
LNt[121] -= LNt[122];
LNt[123] = float(LNP2x3[91]+LNt[121])-LNP2x3[91];	//[4,27]<<46
LNt[121] -= LNt[123];
LNt[124] = LNt[113]+LNt[122]+LNt[123];
LNt[125] = float(LNP2x3[118]+LNt[124])-LNP2x3[118];	//[22,49]<<69
LNt[124] -= LNt[125];
LNt[126] = float(LNP2x3[114]+LNt[124])-LNP2x3[114];	//[4,27]<<69
LNt[124] -= LNt[126];
LNt[127] = LNt[114]+LNt[125]+LNt[126];
LNt[128] = (float(LNP2x3[125]+LNt[127]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
LNt[127] -= LNt[128];
LNt[129] = (float(LNP2x3[125]+LNt[127]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
LNt[127] -= LNt[129];
LNt[130] = LNt[24]*LNt[69]+LNt[25]*LNt[67]-(LNt[54]*LNt[39]+LNt[55]*LNt[37])+LNt[128]+LNt[129];
LNt[131] = (float(LNP2x3[125]+LNt[130]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[130] -= LNt[131];
LNt[132] = LNt[25]*LNt[69]-LNt[55]*LNt[39]+LNt[131];
LNt[133] = (float(LNP2x3[125]+LNt[132]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[132] -= LNt[133];
LNt[134] = LNt[5]*LNt[70]-LNt[92]*LNt[104]+LNt[115];
LNt[135] = float(LNP2x3[48]+LNt[134])-LNP2x3[48];	//[22,48]<<0
LNt[134] -= LNt[135];
LNt[136] = float(LNP2x3[45]+LNt[134])-LNP2x3[45];	//[3,26]<<0
LNt[134] -= LNt[136];
LNt[137] = LNt[5]*LNt[72]+LNt[8]*LNt[70]-(LNt[92]*LNt[106]+LNt[95]*LNt[104])+LNt[118]+LNt[135]+LNt[136];
LNt[138] = float(LNP2x3[72]+LNt[137])-LNP2x3[72];	//[22,49]<<23
LNt[137] -= LNt[138];
LNt[139] = float(LNP2x3[68]+LNt[137])-LNP2x3[68];	//[4,27]<<23
LNt[137] -= LNt[139];
LNt[140] = LNt[109]+LNt[121]+LNt[138]+LNt[139];
LNt[141] = float(LNP2x3[96]+LNt[140])-LNP2x3[96];	//[22,50]<<46
LNt[140] -= LNt[141];
LNt[142] = float(LNP2x3[91]+LNt[140])-LNP2x3[91];	//[5,28]<<46
LNt[140] -= LNt[142];
LNt[143] = LNt[110]+LNt[124]+LNt[141]+LNt[142];
LNt[144] = float(LNP2x3[119]+LNt[143])-LNP2x3[119];	//[22,50]<<69
LNt[143] -= LNt[144];
LNt[145] = float(LNP2x3[114]+LNt[143])-LNP2x3[114];	//[5,28]<<69
LNt[143] -= LNt[145];
LNt[146] = LNt[111]+LNt[127]+LNt[144]+LNt[145];
LNt[147] = (float(LNP2x3[125]+LNt[146]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[146] -= LNt[147];
LNt[148] = (float(LNP2x3[125]+LNt[146]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[146] -= LNt[148];
LNt[149] = LNt[8]*LNt[78]+LNt[9]*LNt[76]-(LNt[101]*LNt[108]+LNt[103]*LNt[106])+LNt[130]+LNt[147]+LNt[148];
LNt[150] = (float(LNP2x3[125]+LNt[149]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
LNt[149] -= LNt[150];
LNt[151] = LNt[9]*LNt[78]-LNt[103]*LNt[108]+LNt[132]+LNt[150];
LNt[152] = (float(LNP2x3[125]+LNt[151]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
LNt[151] -= LNt[152];
LNt[153] = LNt[133]+LNt[152];
LNt[154] = d.z;
LNt[155] = float(LNP2x3[53]+LNt[154])-LNP2x3[53];	//[22,53]<<0
LNt[154] -= LNt[155];
LNt[156] = float(LNP2x3[45]+LNt[154])-LNP2x3[45];	//[8,31]<<0
LNt[154] -= LNt[156];
LNt[157] = LNt[155]+LNt[156];
LNt[158] = float(LNP2x3[68]+LNt[157])-LNP2x3[68];	//[7,30]<<23
LNt[157] -= LNt[158];
LNt[159] = LNt[15]-LNt[45];
LNt[160] = float(LNP2x3[45]+LNt[159])-LNP2x3[45];	//[1,24]<<0
LNt[159] -= LNt[160];
LNt[161] = LNt[18]-LNt[48]+LNt[160];
LNt[162] = float(LNP2x3[68]+LNt[161])-LNP2x3[68];	//[1,24]<<23
LNt[161] -= LNt[162];
LNt[163] = LNt[19]-LNt[49]+LNt[162];
LNt[164] = LNt[84]*LNt[74]+LNt[87]*LNt[72]+LNt[88]*LNt[70]-(LNt[92]*LNt[163]+LNt[95]*LNt[161]+LNt[98]*LNt[159]);
LNt[165] = LNt[84]*LNt[76]+LNt[87]*LNt[74]+LNt[88]*LNt[72]-(LNt[95]*LNt[163]+LNt[98]*LNt[161]+LNt[101]*LNt[159]);
LNt[166] = LNt[84]*LNt[78]+LNt[87]*LNt[76]+LNt[88]*LNt[74]-(LNt[98]*LNt[163]+LNt[101]*LNt[161]+LNt[103]*LNt[159]);
LNt[167] = LNt[15]*LNt[64]+LNt[18]*LNt[61]+LNt[19]*LNt[58]-(LNt[45]*LNt[34]+LNt[48]*LNt[31]+LNt[49]*LNt[28]);
LNt[168] = LNt[15]*LNt[67]+LNt[18]*LNt[64]+LNt[19]*LNt[61]-(LNt[45]*LNt[37]+LNt[48]*LNt[34]+LNt[49]*LNt[31]);
LNt[169] = LNt[15]*LNt[69]+LNt[18]*LNt[67]+LNt[19]*LNt[64]-(LNt[45]*LNt[39]+LNt[48]*LNt[37]+LNt[49]*LNt[34]);
LNt[170] = LNt[15]*LNt[58]-LNt[45]*LNt[28];
LNt[171] = float(LNP2x3[47]+LNt[170])-LNP2x3[47];	//[22,47]<<0
LNt[170] -= LNt[171];
LNt[172] = float(LNP2x3[45]+LNt[170])-LNP2x3[45];	//[2,25]<<0
LNt[170] -= LNt[172];
LNt[173] = LNt[15]*LNt[61]+LNt[18]*LNt[58]-(LNt[45]*LNt[31]+LNt[48]*LNt[28])+LNt[171]+LNt[172];
LNt[174] = float(LNP2x3[71]+LNt[173])-LNP2x3[71];	//[22,48]<<23
LNt[173] -= LNt[174];
LNt[175] = float(LNP2x3[68]+LNt[173])-LNP2x3[68];	//[3,26]<<23
LNt[173] -= LNt[175];
LNt[176] = LNt[167]+LNt[174]+LNt[175];
LNt[177] = float(LNP2x3[95]+LNt[176])-LNP2x3[95];	//[22,49]<<46
LNt[176] -= LNt[177];
LNt[178] = float(LNP2x3[91]+LNt[176])-LNP2x3[91];	//[4,27]<<46
LNt[176] -= LNt[178];
LNt[179] = LNt[168]+LNt[177]+LNt[178];
LNt[180] = float(LNP2x3[118]+LNt[179])-LNP2x3[118];	//[22,49]<<69
LNt[179] -= LNt[180];
LNt[181] = float(LNP2x3[114]+LNt[179])-LNP2x3[114];	//[4,27]<<69
LNt[179] -= LNt[181];
LNt[182] = LNt[169]+LNt[180]+LNt[181];
LNt[183] = (float(LNP2x3[125]+LNt[182]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
LNt[182] -= LNt[183];
LNt[184] = (float(LNP2x3[125]+LNt[182]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
LNt[182] -= LNt[184];
LNt[185] = LNt[18]*LNt[69]+LNt[19]*LNt[67]-(LNt[48]*LNt[39]+LNt[49]*LNt[37])+LNt[183]+LNt[184];
LNt[186] = (float(LNP2x3[125]+LNt[185]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[185] -= LNt[186];
LNt[187] = LNt[19]*LNt[69]-LNt[49]*LNt[39]+LNt[186];
LNt[188] = (float(LNP2x3[125]+LNt[187]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[187] -= LNt[188];
LNt[189] = LNt[84]*LNt[70]-LNt[92]*LNt[159]+LNt[170];
LNt[190] = float(LNP2x3[48]+LNt[189])-LNP2x3[48];	//[22,48]<<0
LNt[189] -= LNt[190];
LNt[191] = float(LNP2x3[45]+LNt[189])-LNP2x3[45];	//[3,26]<<0
LNt[189] -= LNt[191];
LNt[192] = LNt[84]*LNt[72]+LNt[87]*LNt[70]-(LNt[92]*LNt[161]+LNt[95]*LNt[159])+LNt[173]+LNt[190]+LNt[191];
LNt[193] = float(LNP2x3[72]+LNt[192])-LNP2x3[72];	//[22,49]<<23
LNt[192] -= LNt[193];
LNt[194] = float(LNP2x3[68]+LNt[192])-LNP2x3[68];	//[4,27]<<23
LNt[192] -= LNt[194];
LNt[195] = LNt[164]+LNt[176]+LNt[193]+LNt[194];
LNt[196] = float(LNP2x3[96]+LNt[195])-LNP2x3[96];	//[22,50]<<46
LNt[195] -= LNt[196];
LNt[197] = float(LNP2x3[91]+LNt[195])-LNP2x3[91];	//[5,28]<<46
LNt[195] -= LNt[197];
LNt[198] = LNt[165]+LNt[179]+LNt[196]+LNt[197];
LNt[199] = float(LNP2x3[119]+LNt[198])-LNP2x3[119];	//[22,50]<<69
LNt[198] -= LNt[199];
LNt[200] = float(LNP2x3[114]+LNt[198])-LNP2x3[114];	//[5,28]<<69
LNt[198] -= LNt[200];
LNt[201] = LNt[166]+LNt[182]+LNt[199]+LNt[200];
LNt[202] = (float(LNP2x3[125]+LNt[201]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[201] -= LNt[202];
LNt[203] = (float(LNP2x3[125]+LNt[201]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[201] -= LNt[203];
LNt[204] = LNt[87]*LNt[78]+LNt[88]*LNt[76]-(LNt[101]*LNt[163]+LNt[103]*LNt[161])+LNt[185]+LNt[202]+LNt[203];
LNt[205] = (float(LNP2x3[125]+LNt[204]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
LNt[204] -= LNt[205];
LNt[206] = LNt[88]*LNt[78]-LNt[103]*LNt[163]+LNt[187]+LNt[205];
LNt[207] = (float(LNP2x3[125]+LNt[206]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
LNt[206] -= LNt[207];
LNt[208] = LNt[188]+LNt[207];
LNt[209] = LNt[0]*LNt[140]+LNt[3]*LNt[137]+LNt[4]*LNt[134]-(LNt[154]*LNt[195]+LNt[157]*LNt[192]+LNt[158]*LNt[189]);
LNt[210] = LNt[0]*LNt[143]+LNt[3]*LNt[140]+LNt[4]*LNt[137]-(LNt[154]*LNt[198]+LNt[157]*LNt[195]+LNt[158]*LNt[192]);
LNt[211] = LNt[0]*LNt[146]+LNt[3]*LNt[143]+LNt[4]*LNt[140]-(LNt[154]*LNt[201]+LNt[157]*LNt[198]+LNt[158]*LNt[195]);
LNt[212] = LNt[0]*LNt[149]+LNt[3]*LNt[146]+LNt[4]*LNt[143]-(LNt[154]*LNt[204]+LNt[157]*LNt[201]+LNt[158]*LNt[198]);
LNt[213] = LNt[0]*LNt[151]+LNt[3]*LNt[149]+LNt[4]*LNt[146]-(LNt[154]*LNt[206]+LNt[157]*LNt[204]+LNt[158]*LNt[201]);
LNt[214] = LNt[0]*LNt[153]+LNt[3]*LNt[151]+LNt[4]*LNt[149]-(LNt[154]*LNt[208]+LNt[157]*LNt[206]+LNt[158]*LNt[204]);
LNt[215] = d.x;
LNt[216] = float(LNP2x3[53]+LNt[215])-LNP2x3[53];	//[22,53]<<0
LNt[215] -= LNt[216];
LNt[217] = float(LNP2x3[45]+LNt[215])-LNP2x3[45];	//[8,31]<<0
LNt[215] -= LNt[217];
LNt[218] = LNt[216]+LNt[217];
LNt[219] = float(LNP2x3[68]+LNt[218])-LNP2x3[68];	//[7,30]<<23
LNt[218] -= LNt[219];
LNt[220] = LNt[215]*LNt[219]+LNt[218]*LNt[218]+LNt[219]*LNt[215]+LNt[0]*LNt[4]+LNt[3]*LNt[3]+LNt[4]*LNt[0];
LNt[221] = LNt[215]*LNt[218]+LNt[218]*LNt[215]+LNt[0]*LNt[3]+LNt[3]*LNt[0]+LNt[154]*LNt[157]+LNt[157]*LNt[154];
LNt[222] = LNt[218]*LNt[219]+LNt[219]*LNt[218]+LNt[3]*LNt[4]+LNt[4]*LNt[3]+LNt[157]*LNt[158]+LNt[158]*LNt[157];
LNt[223] = LNt[215]*LNt[215]+LNt[0]*LNt[0]+LNt[154]*LNt[154];
LNt[224] = float(LNP2x3[48]+LNt[223])-LNP2x3[48];	//[22,48]<<0
LNt[223] -= LNt[224];
LNt[225] = float(LNP2x3[45]+LNt[223])-LNP2x3[45];	//[3,26]<<0
LNt[223] -= LNt[225];
LNt[226] = LNt[221]+LNt[224]+LNt[225];
LNt[227] = float(LNP2x3[72]+LNt[226])-LNP2x3[72];	//[22,49]<<23
LNt[226] -= LNt[227];
LNt[228] = float(LNP2x3[68]+LNt[226])-LNP2x3[68];	//[4,27]<<23
LNt[226] -= LNt[228];
LNt[229] = LNt[220]+LNt[154]*LNt[158]+LNt[157]*LNt[157]+LNt[158]*LNt[154]+LNt[227]+LNt[228];
LNt[230] = float(LNP2x3[96]+LNt[229])-LNP2x3[96];	//[22,50]<<46
LNt[229] -= LNt[230];
LNt[231] = float(LNP2x3[91]+LNt[229])-LNP2x3[91];	//[5,28]<<46
LNt[229] -= LNt[231];
LNt[232] = LNt[222]+LNt[230]+LNt[231];
LNt[233] = float(LNP2x3[114]+LNt[232])-LNP2x3[114];	//[10,33]<<69
LNt[232] -= LNt[233];
LNt[234] = LNt[219]*LNt[219]+LNt[4]*LNt[4]+LNt[158]*LNt[158]+LNt[233];
LNt[235] = LNt[84]*LNt[108]+LNt[87]*LNt[106]+LNt[88]*LNt[104]-(LNt[5]*LNt[163]+LNt[8]*LNt[161]+LNt[9]*LNt[159]);
LNt[236] = LNt[15]*LNt[55]+LNt[18]*LNt[54]+LNt[19]*LNt[51]-(LNt[45]*LNt[25]+LNt[48]*LNt[24]+LNt[49]*LNt[21]);
LNt[237] = LNt[15]*LNt[51]-LNt[45]*LNt[21];
LNt[238] = float(LNP2x3[47]+LNt[237])-LNP2x3[47];	//[22,47]<<0
LNt[237] -= LNt[238];
LNt[239] = float(LNP2x3[45]+LNt[237])-LNP2x3[45];	//[2,25]<<0
LNt[237] -= LNt[239];
LNt[240] = LNt[15]*LNt[54]+LNt[18]*LNt[51]-(LNt[45]*LNt[24]+LNt[48]*LNt[21])+LNt[238]+LNt[239];
LNt[241] = float(LNP2x3[71]+LNt[240])-LNP2x3[71];	//[22,48]<<23
LNt[240] -= LNt[241];
LNt[242] = float(LNP2x3[68]+LNt[240])-LNP2x3[68];	//[3,26]<<23
LNt[240] -= LNt[242];
LNt[243] = LNt[236]+LNt[241]+LNt[242];
LNt[244] = float(LNP2x3[95]+LNt[243])-LNP2x3[95];	//[22,49]<<46
LNt[243] -= LNt[244];
LNt[245] = float(LNP2x3[91]+LNt[243])-LNP2x3[91];	//[4,27]<<46
LNt[243] -= LNt[245];
LNt[246] = LNt[18]*LNt[55]+LNt[19]*LNt[54]-(LNt[48]*LNt[25]+LNt[49]*LNt[24])+LNt[244]+LNt[245];
LNt[247] = float(LNP2x3[114]+LNt[246])-LNP2x3[114];	//[9,32]<<69
LNt[246] -= LNt[247];
LNt[248] = LNt[19]*LNt[55]-LNt[49]*LNt[25]+LNt[247];
LNt[249] = LNt[84]*LNt[104]-LNt[5]*LNt[159]+LNt[237];
LNt[250] = float(LNP2x3[48]+LNt[249])-LNP2x3[48];	//[22,48]<<0
LNt[249] -= LNt[250];
LNt[251] = float(LNP2x3[45]+LNt[249])-LNP2x3[45];	//[3,26]<<0
LNt[249] -= LNt[251];
LNt[252] = LNt[84]*LNt[106]+LNt[87]*LNt[104]-(LNt[5]*LNt[161]+LNt[8]*LNt[159])+LNt[240]+LNt[250]+LNt[251];
LNt[253] = float(LNP2x3[72]+LNt[252])-LNP2x3[72];	//[22,49]<<23
LNt[252] -= LNt[253];
LNt[254] = float(LNP2x3[68]+LNt[252])-LNP2x3[68];	//[4,27]<<23
LNt[252] -= LNt[254];
LNt[255] = LNt[235]+LNt[243]+LNt[253]+LNt[254];
LNt[256] = float(LNP2x3[96]+LNt[255])-LNP2x3[96];	//[22,50]<<46
LNt[255] -= LNt[256];
LNt[257] = float(LNP2x3[91]+LNt[255])-LNP2x3[91];	//[5,28]<<46
LNt[255] -= LNt[257];
LNt[258] = LNt[87]*LNt[108]+LNt[88]*LNt[106]-(LNt[8]*LNt[163]+LNt[9]*LNt[161])+LNt[246]+LNt[256]+LNt[257];
LNt[259] = float(LNP2x3[114]+LNt[258])-LNP2x3[114];	//[11,34]<<69
LNt[258] -= LNt[259];
LNt[260] = LNt[88]*LNt[108]-LNt[9]*LNt[163]+LNt[248]+LNt[259];
LNt[261] = LNt[223]*LNt[260]+LNt[226]*LNt[258]+LNt[229]*LNt[255]+LNt[232]*LNt[252]+LNt[234]*LNt[249];
LNt[262] = LNt[0]*LNt[137]+LNt[3]*LNt[134]-(LNt[154]*LNt[192]+LNt[157]*LNt[189])+LNt[223]*LNt[252]+LNt[226]*LNt[249];
LNt[263] = LNt[3]*LNt[153]+LNt[4]*LNt[151]-(LNt[157]*LNt[208]+LNt[158]*LNt[206])+LNt[234]*LNt[260];
LNt[264] = LNt[84]*LNt[121]+LNt[87]*LNt[118]+LNt[88]*LNt[115]-(LNt[5]*LNt[176]+LNt[8]*LNt[173]+LNt[9]*LNt[170]);
LNt[265] = LNt[84]*LNt[124]+LNt[87]*LNt[121]+LNt[88]*LNt[118]-(LNt[5]*LNt[179]+LNt[8]*LNt[176]+LNt[9]*LNt[173]);
LNt[266] = LNt[84]*LNt[127]+LNt[87]*LNt[124]+LNt[88]*LNt[121]-(LNt[5]*LNt[182]+LNt[8]*LNt[179]+LNt[9]*LNt[176]);
LNt[267] = LNt[84]*LNt[130]+LNt[87]*LNt[127]+LNt[88]*LNt[124]-(LNt[5]*LNt[185]+LNt[8]*LNt[182]+LNt[9]*LNt[179]);
LNt[268] = LNt[84]*LNt[132]+LNt[87]*LNt[130]+LNt[88]*LNt[127]-(LNt[5]*LNt[187]+LNt[8]*LNt[185]+LNt[9]*LNt[182]);
LNt[269] = LNt[84]*LNt[133]+LNt[87]*LNt[132]+LNt[88]*LNt[130]-(LNt[5]*LNt[188]+LNt[8]*LNt[187]+LNt[9]*LNt[185]);
LNt[270] = LNt[92]*LNt[248]+LNt[95]*LNt[246]+LNt[98]*LNt[243]+LNt[101]*LNt[240]+LNt[103]*LNt[237];
LNt[271] = LNt[84]*LNt[118]+LNt[87]*LNt[115]-(LNt[5]*LNt[173]+LNt[8]*LNt[170])+LNt[92]*LNt[240]+LNt[95]*LNt[237];
LNt[272] = LNt[87]*LNt[133]+LNt[88]*LNt[132]-(LNt[8]*LNt[188]+LNt[9]*LNt[187])+LNt[103]*LNt[248];
LNt[273] = LNt[84]*LNt[115]-LNt[5]*LNt[170]+LNt[92]*LNt[237];
LNt[274] = float(LNP2x3[48]+LNt[273])-LNP2x3[48];	//[22,48]<<0
LNt[273] -= LNt[274];
LNt[275] = float(LNP2x3[45]+LNt[273])-LNP2x3[45];	//[3,26]<<0
LNt[273] -= LNt[275];
LNt[276] = LNt[271]+LNt[274]+LNt[275];
LNt[277] = float(LNP2x3[72]+LNt[276])-LNP2x3[72];	//[22,49]<<23
LNt[276] -= LNt[277];
LNt[278] = float(LNP2x3[68]+LNt[276])-LNP2x3[68];	//[4,27]<<23
LNt[276] -= LNt[278];
LNt[279] = LNt[264]+LNt[92]*LNt[243]+LNt[95]*LNt[240]+LNt[98]*LNt[237]+LNt[277]+LNt[278];
LNt[280] = float(LNP2x3[96]+LNt[279])-LNP2x3[96];	//[22,50]<<46
LNt[279] -= LNt[280];
LNt[281] = float(LNP2x3[91]+LNt[279])-LNP2x3[91];	//[5,28]<<46
LNt[279] -= LNt[281];
LNt[282] = LNt[265]+LNt[92]*LNt[246]+LNt[95]*LNt[243]+LNt[98]*LNt[240]+LNt[101]*LNt[237]+LNt[280]+LNt[281];
LNt[283] = float(LNP2x3[119]+LNt[282])-LNP2x3[119];	//[22,50]<<69
LNt[282] -= LNt[283];
LNt[284] = float(LNP2x3[114]+LNt[282])-LNP2x3[114];	//[5,28]<<69
LNt[282] -= LNt[284];
LNt[285] = LNt[266]+LNt[270]+LNt[283]+LNt[284];
LNt[286] = (float(LNP2x3[125]+LNt[285]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
LNt[285] -= LNt[286];
LNt[287] = (float(LNP2x3[125]+LNt[285]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
LNt[285] -= LNt[287];
LNt[288] = LNt[267]+LNt[95]*LNt[248]+LNt[98]*LNt[246]+LNt[101]*LNt[243]+LNt[103]*LNt[240]+LNt[286]+LNt[287];
LNt[289] = (float(LNP2x3[125]+LNt[288]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
LNt[288] -= LNt[289];
LNt[290] = (float(LNP2x3[125]+LNt[288]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
LNt[288] -= LNt[290];
LNt[291] = LNt[268]+LNt[98]*LNt[248]+LNt[101]*LNt[246]+LNt[103]*LNt[243]+LNt[289]+LNt[290];
LNt[292] = (float(LNP2x3[125]+LNt[291]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
LNt[291] -= LNt[292];
LNt[293] = (float(LNP2x3[125]+LNt[291]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
LNt[291] -= LNt[293];
LNt[294] = LNt[269]+LNt[101]*LNt[248]+LNt[103]*LNt[246]+LNt[292]+LNt[293];
LNt[295] = (float(LNP2x3[125]+LNt[294]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
LNt[294] -= LNt[295];
LNt[296] = (float(LNP2x3[125]+LNt[294]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
LNt[294] -= LNt[296];
LNt[297] = LNt[272]+LNt[295]+LNt[296];
LNt[298] = (float(LNP2x3[125]+LNt[297]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[10,33]<<184
LNt[297] -= LNt[298];
LNt[299] = LNt[88]*LNt[133]-LNt[9]*LNt[188]+LNt[298];
LNt[300] = LNt[210]+LNt[223]*LNt[258]+LNt[226]*LNt[255]+LNt[229]*LNt[252]+LNt[232]*LNt[249]-LNt[282];
LNt[301] = LNt[212]+LNt[226]*LNt[260]+LNt[229]*LNt[258]+LNt[232]*LNt[255]+LNt[234]*LNt[252]-LNt[288];
LNt[302] = LNt[10]-LNt[40];
LNt[303] = float(LNP2x3[45]+LNt[302])-LNP2x3[45];	//[1,24]<<0
LNt[302] -= LNt[303];
LNt[304] = LNt[13]-LNt[43]+LNt[303];
LNt[305] = float(LNP2x3[68]+LNt[304])-LNP2x3[68];	//[1,24]<<23
LNt[304] -= LNt[305];
LNt[306] = LNt[14]-LNt[44]+LNt[305];
LNt[307] = LNt[79]*LNt[74]+LNt[82]*LNt[72]+LNt[83]*LNt[70]-(LNt[92]*LNt[306]+LNt[95]*LNt[304]+LNt[98]*LNt[302]);
LNt[308] = LNt[79]*LNt[76]+LNt[82]*LNt[74]+LNt[83]*LNt[72]-(LNt[95]*LNt[306]+LNt[98]*LNt[304]+LNt[101]*LNt[302]);
LNt[309] = LNt[79]*LNt[78]+LNt[82]*LNt[76]+LNt[83]*LNt[74]-(LNt[98]*LNt[306]+LNt[101]*LNt[304]+LNt[103]*LNt[302]);
LNt[310] = LNt[10]*LNt[64]+LNt[13]*LNt[61]+LNt[14]*LNt[58]-(LNt[28]*LNt[44]+LNt[31]*LNt[43]+LNt[34]*LNt[40]);
LNt[311] = LNt[10]*LNt[67]+LNt[13]*LNt[64]+LNt[14]*LNt[61]-(LNt[31]*LNt[44]+LNt[34]*LNt[43]+LNt[37]*LNt[40]);
LNt[312] = LNt[10]*LNt[69]+LNt[13]*LNt[67]+LNt[14]*LNt[64]-(LNt[34]*LNt[44]+LNt[37]*LNt[43]+LNt[39]*LNt[40]);
LNt[313] = LNt[10]*LNt[58]-LNt[28]*LNt[40];
LNt[314] = float(LNP2x3[47]+LNt[313])-LNP2x3[47];	//[22,47]<<0
LNt[313] -= LNt[314];
LNt[315] = float(LNP2x3[45]+LNt[313])-LNP2x3[45];	//[2,25]<<0
LNt[313] -= LNt[315];
LNt[316] = LNt[10]*LNt[61]+LNt[13]*LNt[58]-(LNt[28]*LNt[43]+LNt[31]*LNt[40])+LNt[314]+LNt[315];
LNt[317] = float(LNP2x3[71]+LNt[316])-LNP2x3[71];	//[22,48]<<23
LNt[316] -= LNt[317];
LNt[318] = float(LNP2x3[68]+LNt[316])-LNP2x3[68];	//[3,26]<<23
LNt[316] -= LNt[318];
LNt[319] = LNt[310]+LNt[317]+LNt[318];
LNt[320] = float(LNP2x3[95]+LNt[319])-LNP2x3[95];	//[22,49]<<46
LNt[319] -= LNt[320];
LNt[321] = float(LNP2x3[91]+LNt[319])-LNP2x3[91];	//[4,27]<<46
LNt[319] -= LNt[321];
LNt[322] = LNt[311]+LNt[320]+LNt[321];
LNt[323] = float(LNP2x3[118]+LNt[322])-LNP2x3[118];	//[22,49]<<69
LNt[322] -= LNt[323];
LNt[324] = float(LNP2x3[114]+LNt[322])-LNP2x3[114];	//[4,27]<<69
LNt[322] -= LNt[324];
LNt[325] = LNt[312]+LNt[323]+LNt[324];
LNt[326] = (float(LNP2x3[125]+LNt[325]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
LNt[325] -= LNt[326];
LNt[327] = (float(LNP2x3[125]+LNt[325]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
LNt[325] -= LNt[327];
LNt[328] = LNt[13]*LNt[69]+LNt[14]*LNt[67]-(LNt[37]*LNt[44]+LNt[39]*LNt[43])+LNt[326]+LNt[327];
LNt[329] = (float(LNP2x3[125]+LNt[328]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[328] -= LNt[329];
LNt[330] = LNt[14]*LNt[69]-LNt[39]*LNt[44]+LNt[329];
LNt[331] = (float(LNP2x3[125]+LNt[330]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[330] -= LNt[331];
LNt[332] = LNt[79]*LNt[70]-LNt[92]*LNt[302]+LNt[313];
LNt[333] = float(LNP2x3[48]+LNt[332])-LNP2x3[48];	//[22,48]<<0
LNt[332] -= LNt[333];
LNt[334] = float(LNP2x3[45]+LNt[332])-LNP2x3[45];	//[3,26]<<0
LNt[332] -= LNt[334];
LNt[335] = LNt[79]*LNt[72]+LNt[82]*LNt[70]-(LNt[92]*LNt[304]+LNt[95]*LNt[302])+LNt[316]+LNt[333]+LNt[334];
LNt[336] = float(LNP2x3[72]+LNt[335])-LNP2x3[72];	//[22,49]<<23
LNt[335] -= LNt[336];
LNt[337] = float(LNP2x3[68]+LNt[335])-LNP2x3[68];	//[4,27]<<23
LNt[335] -= LNt[337];
LNt[338] = LNt[307]+LNt[319]+LNt[336]+LNt[337];
LNt[339] = float(LNP2x3[96]+LNt[338])-LNP2x3[96];	//[22,50]<<46
LNt[338] -= LNt[339];
LNt[340] = float(LNP2x3[91]+LNt[338])-LNP2x3[91];	//[5,28]<<46
LNt[338] -= LNt[340];
LNt[341] = LNt[308]+LNt[322]+LNt[339]+LNt[340];
LNt[342] = float(LNP2x3[119]+LNt[341])-LNP2x3[119];	//[22,50]<<69
LNt[341] -= LNt[342];
LNt[343] = float(LNP2x3[114]+LNt[341])-LNP2x3[114];	//[5,28]<<69
LNt[341] -= LNt[343];
LNt[344] = LNt[309]+LNt[325]+LNt[342]+LNt[343];
LNt[345] = (float(LNP2x3[125]+LNt[344]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[344] -= LNt[345];
LNt[346] = (float(LNP2x3[125]+LNt[344]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[344] -= LNt[346];
LNt[347] = LNt[82]*LNt[78]+LNt[83]*LNt[76]-(LNt[101]*LNt[306]+LNt[103]*LNt[304])+LNt[328]+LNt[345]+LNt[346];
LNt[348] = (float(LNP2x3[125]+LNt[347]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
LNt[347] -= LNt[348];
LNt[349] = LNt[83]*LNt[78]-LNt[103]*LNt[306]+LNt[330]+LNt[348];
LNt[350] = (float(LNP2x3[125]+LNt[349]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
LNt[349] -= LNt[350];
LNt[351] = LNt[331]+LNt[350];
LNt[352] = LNt[215]*LNt[140]+LNt[218]*LNt[137]+LNt[219]*LNt[134]-(LNt[154]*LNt[338]+LNt[157]*LNt[335]+LNt[158]*LNt[332]);
LNt[353] = LNt[215]*LNt[143]+LNt[218]*LNt[140]+LNt[219]*LNt[137]-(LNt[154]*LNt[341]+LNt[157]*LNt[338]+LNt[158]*LNt[335]);
LNt[354] = LNt[215]*LNt[146]+LNt[218]*LNt[143]+LNt[219]*LNt[140]-(LNt[154]*LNt[344]+LNt[157]*LNt[341]+LNt[158]*LNt[338]);
LNt[355] = LNt[215]*LNt[149]+LNt[218]*LNt[146]+LNt[219]*LNt[143]-(LNt[154]*LNt[347]+LNt[157]*LNt[344]+LNt[158]*LNt[341]);
LNt[356] = LNt[215]*LNt[151]+LNt[218]*LNt[149]+LNt[219]*LNt[146]-(LNt[154]*LNt[349]+LNt[157]*LNt[347]+LNt[158]*LNt[344]);
LNt[357] = LNt[215]*LNt[153]+LNt[218]*LNt[151]+LNt[219]*LNt[149]-(LNt[154]*LNt[351]+LNt[157]*LNt[349]+LNt[158]*LNt[347]);
LNt[358] = LNt[79]*LNt[108]+LNt[82]*LNt[106]+LNt[83]*LNt[104]-(LNt[5]*LNt[306]+LNt[8]*LNt[304]+LNt[9]*LNt[302]);
LNt[359] = LNt[10]*LNt[55]+LNt[13]*LNt[54]+LNt[14]*LNt[51]-(LNt[21]*LNt[44]+LNt[24]*LNt[43]+LNt[25]*LNt[40]);
LNt[360] = LNt[10]*LNt[51]-LNt[21]*LNt[40];
LNt[361] = float(LNP2x3[47]+LNt[360])-LNP2x3[47];	//[22,47]<<0
LNt[360] -= LNt[361];
LNt[362] = float(LNP2x3[45]+LNt[360])-LNP2x3[45];	//[2,25]<<0
LNt[360] -= LNt[362];
LNt[363] = LNt[10]*LNt[54]+LNt[13]*LNt[51]-(LNt[21]*LNt[43]+LNt[24]*LNt[40])+LNt[361]+LNt[362];
LNt[364] = float(LNP2x3[71]+LNt[363])-LNP2x3[71];	//[22,48]<<23
LNt[363] -= LNt[364];
LNt[365] = float(LNP2x3[68]+LNt[363])-LNP2x3[68];	//[3,26]<<23
LNt[363] -= LNt[365];
LNt[366] = LNt[359]+LNt[364]+LNt[365];
LNt[367] = float(LNP2x3[95]+LNt[366])-LNP2x3[95];	//[22,49]<<46
LNt[366] -= LNt[367];
LNt[368] = float(LNP2x3[91]+LNt[366])-LNP2x3[91];	//[4,27]<<46
LNt[366] -= LNt[368];
LNt[369] = LNt[13]*LNt[55]+LNt[14]*LNt[54]-(LNt[24]*LNt[44]+LNt[25]*LNt[43])+LNt[367]+LNt[368];
LNt[370] = float(LNP2x3[114]+LNt[369])-LNP2x3[114];	//[9,32]<<69
LNt[369] -= LNt[370];
LNt[371] = LNt[14]*LNt[55]-LNt[25]*LNt[44]+LNt[370];
LNt[372] = LNt[79]*LNt[104]-LNt[5]*LNt[302]+LNt[360];
LNt[373] = float(LNP2x3[48]+LNt[372])-LNP2x3[48];	//[22,48]<<0
LNt[372] -= LNt[373];
LNt[374] = float(LNP2x3[45]+LNt[372])-LNP2x3[45];	//[3,26]<<0
LNt[372] -= LNt[374];
LNt[375] = LNt[79]*LNt[106]+LNt[82]*LNt[104]-(LNt[5]*LNt[304]+LNt[8]*LNt[302])+LNt[363]+LNt[373]+LNt[374];
LNt[376] = float(LNP2x3[72]+LNt[375])-LNP2x3[72];	//[22,49]<<23
LNt[375] -= LNt[376];
LNt[377] = float(LNP2x3[68]+LNt[375])-LNP2x3[68];	//[4,27]<<23
LNt[375] -= LNt[377];
LNt[378] = LNt[358]+LNt[366]+LNt[376]+LNt[377];
LNt[379] = float(LNP2x3[96]+LNt[378])-LNP2x3[96];	//[22,50]<<46
LNt[378] -= LNt[379];
LNt[380] = float(LNP2x3[91]+LNt[378])-LNP2x3[91];	//[5,28]<<46
LNt[378] -= LNt[380];
LNt[381] = LNt[82]*LNt[108]+LNt[83]*LNt[106]-(LNt[8]*LNt[306]+LNt[9]*LNt[304])+LNt[369]+LNt[379]+LNt[380];
LNt[382] = float(LNP2x3[114]+LNt[381])-LNP2x3[114];	//[11,34]<<69
LNt[381] -= LNt[382];
LNt[383] = LNt[83]*LNt[108]-LNt[9]*LNt[306]+LNt[371]+LNt[382];
LNt[384] = LNt[223]*LNt[383]+LNt[226]*LNt[381]+LNt[229]*LNt[378]+LNt[232]*LNt[375]+LNt[234]*LNt[372];
LNt[385] = LNt[215]*LNt[137]+LNt[218]*LNt[134]-(LNt[154]*LNt[335]+LNt[157]*LNt[332])+LNt[223]*LNt[375]+LNt[226]*LNt[372];
LNt[386] = LNt[218]*LNt[153]+LNt[219]*LNt[151]-(LNt[157]*LNt[351]+LNt[158]*LNt[349])+LNt[234]*LNt[383];
LNt[387] = LNt[79]*LNt[121]+LNt[82]*LNt[118]+LNt[83]*LNt[115]-(LNt[5]*LNt[319]+LNt[8]*LNt[316]+LNt[9]*LNt[313]);
LNt[388] = LNt[79]*LNt[124]+LNt[82]*LNt[121]+LNt[83]*LNt[118]-(LNt[5]*LNt[322]+LNt[8]*LNt[319]+LNt[9]*LNt[316]);
LNt[389] = LNt[79]*LNt[127]+LNt[82]*LNt[124]+LNt[83]*LNt[121]-(LNt[5]*LNt[325]+LNt[8]*LNt[322]+LNt[9]*LNt[319]);
LNt[390] = LNt[79]*LNt[130]+LNt[82]*LNt[127]+LNt[83]*LNt[124]-(LNt[5]*LNt[328]+LNt[8]*LNt[325]+LNt[9]*LNt[322]);
LNt[391] = LNt[79]*LNt[132]+LNt[82]*LNt[130]+LNt[83]*LNt[127]-(LNt[5]*LNt[330]+LNt[8]*LNt[328]+LNt[9]*LNt[325]);
LNt[392] = LNt[79]*LNt[133]+LNt[82]*LNt[132]+LNt[83]*LNt[130]-(LNt[5]*LNt[331]+LNt[8]*LNt[330]+LNt[9]*LNt[328]);
LNt[393] = LNt[92]*LNt[371]+LNt[95]*LNt[369]+LNt[98]*LNt[366]+LNt[101]*LNt[363]+LNt[103]*LNt[360];
LNt[394] = LNt[79]*LNt[118]+LNt[82]*LNt[115]-(LNt[5]*LNt[316]+LNt[8]*LNt[313])+LNt[92]*LNt[363]+LNt[95]*LNt[360];
LNt[395] = LNt[82]*LNt[133]+LNt[83]*LNt[132]-(LNt[8]*LNt[331]+LNt[9]*LNt[330])+LNt[103]*LNt[371];
LNt[396] = LNt[79]*LNt[115]-LNt[5]*LNt[313]+LNt[92]*LNt[360];
LNt[397] = float(LNP2x3[48]+LNt[396])-LNP2x3[48];	//[22,48]<<0
LNt[396] -= LNt[397];
LNt[398] = float(LNP2x3[45]+LNt[396])-LNP2x3[45];	//[3,26]<<0
LNt[396] -= LNt[398];
LNt[399] = LNt[394]+LNt[397]+LNt[398];
LNt[400] = float(LNP2x3[72]+LNt[399])-LNP2x3[72];	//[22,49]<<23
LNt[399] -= LNt[400];
LNt[401] = float(LNP2x3[68]+LNt[399])-LNP2x3[68];	//[4,27]<<23
LNt[399] -= LNt[401];
LNt[402] = LNt[387]+LNt[92]*LNt[366]+LNt[95]*LNt[363]+LNt[98]*LNt[360]+LNt[400]+LNt[401];
LNt[403] = float(LNP2x3[96]+LNt[402])-LNP2x3[96];	//[22,50]<<46
LNt[402] -= LNt[403];
LNt[404] = float(LNP2x3[91]+LNt[402])-LNP2x3[91];	//[5,28]<<46
LNt[402] -= LNt[404];
LNt[405] = LNt[388]+LNt[92]*LNt[369]+LNt[95]*LNt[366]+LNt[98]*LNt[363]+LNt[101]*LNt[360]+LNt[403]+LNt[404];
LNt[406] = float(LNP2x3[119]+LNt[405])-LNP2x3[119];	//[22,50]<<69
LNt[405] -= LNt[406];
LNt[407] = float(LNP2x3[114]+LNt[405])-LNP2x3[114];	//[5,28]<<69
LNt[405] -= LNt[407];
LNt[408] = LNt[389]+LNt[393]+LNt[406]+LNt[407];
LNt[409] = (float(LNP2x3[125]+LNt[408]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
LNt[408] -= LNt[409];
LNt[410] = (float(LNP2x3[125]+LNt[408]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
LNt[408] -= LNt[410];
LNt[411] = LNt[390]+LNt[95]*LNt[371]+LNt[98]*LNt[369]+LNt[101]*LNt[366]+LNt[103]*LNt[363]+LNt[409]+LNt[410];
LNt[412] = (float(LNP2x3[125]+LNt[411]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
LNt[411] -= LNt[412];
LNt[413] = (float(LNP2x3[125]+LNt[411]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
LNt[411] -= LNt[413];
LNt[414] = LNt[391]+LNt[98]*LNt[371]+LNt[101]*LNt[369]+LNt[103]*LNt[366]+LNt[412]+LNt[413];
LNt[415] = (float(LNP2x3[125]+LNt[414]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
LNt[414] -= LNt[415];
LNt[416] = (float(LNP2x3[125]+LNt[414]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
LNt[414] -= LNt[416];
LNt[417] = LNt[392]+LNt[101]*LNt[371]+LNt[103]*LNt[369]+LNt[415]+LNt[416];
LNt[418] = (float(LNP2x3[125]+LNt[417]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
LNt[417] -= LNt[418];
LNt[419] = (float(LNP2x3[125]+LNt[417]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
LNt[417] -= LNt[419];
LNt[420] = LNt[395]+LNt[418]+LNt[419];
LNt[421] = (float(LNP2x3[125]+LNt[420]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[10,33]<<184
LNt[420] -= LNt[421];
LNt[422] = LNt[83]*LNt[133]-LNt[9]*LNt[331]+LNt[421];
LNt[423] = LNt[353]+LNt[223]*LNt[381]+LNt[226]*LNt[378]+LNt[229]*LNt[375]+LNt[232]*LNt[372]-LNt[405];
LNt[424] = LNt[355]+LNt[226]*LNt[383]+LNt[229]*LNt[381]+LNt[232]*LNt[378]+LNt[234]*LNt[375]-LNt[411];
LNt[425] = LNt[215]*LNt[195]+LNt[218]*LNt[192]+LNt[219]*LNt[189]-(LNt[0]*LNt[338]+LNt[3]*LNt[335]+LNt[4]*LNt[332]);
LNt[426] = LNt[215]*LNt[198]+LNt[218]*LNt[195]+LNt[219]*LNt[192]-(LNt[0]*LNt[341]+LNt[3]*LNt[338]+LNt[4]*LNt[335]);
LNt[427] = LNt[215]*LNt[201]+LNt[218]*LNt[198]+LNt[219]*LNt[195]-(LNt[0]*LNt[344]+LNt[3]*LNt[341]+LNt[4]*LNt[338]);
LNt[428] = LNt[215]*LNt[204]+LNt[218]*LNt[201]+LNt[219]*LNt[198]-(LNt[0]*LNt[347]+LNt[3]*LNt[344]+LNt[4]*LNt[341]);
LNt[429] = LNt[215]*LNt[206]+LNt[218]*LNt[204]+LNt[219]*LNt[201]-(LNt[0]*LNt[349]+LNt[3]*LNt[347]+LNt[4]*LNt[344]);
LNt[430] = LNt[215]*LNt[208]+LNt[218]*LNt[206]+LNt[219]*LNt[204]-(LNt[0]*LNt[351]+LNt[3]*LNt[349]+LNt[4]*LNt[347]);
LNt[431] = LNt[79]*LNt[163]+LNt[82]*LNt[161]+LNt[83]*LNt[159]-(LNt[84]*LNt[306]+LNt[87]*LNt[304]+LNt[88]*LNt[302]);
LNt[432] = LNt[10]*LNt[49]+LNt[13]*LNt[48]+LNt[14]*LNt[45]-(LNt[15]*LNt[44]+LNt[18]*LNt[43]+LNt[19]*LNt[40]);
LNt[433] = LNt[10]*LNt[45]-LNt[15]*LNt[40];
LNt[434] = float(LNP2x3[47]+LNt[433])-LNP2x3[47];	//[22,47]<<0
LNt[433] -= LNt[434];
LNt[435] = float(LNP2x3[45]+LNt[433])-LNP2x3[45];	//[2,25]<<0
LNt[433] -= LNt[435];
LNt[436] = LNt[10]*LNt[48]+LNt[13]*LNt[45]-(LNt[15]*LNt[43]+LNt[18]*LNt[40])+LNt[434]+LNt[435];
LNt[437] = float(LNP2x3[71]+LNt[436])-LNP2x3[71];	//[22,48]<<23
LNt[436] -= LNt[437];
LNt[438] = float(LNP2x3[68]+LNt[436])-LNP2x3[68];	//[3,26]<<23
LNt[436] -= LNt[438];
LNt[439] = LNt[432]+LNt[437]+LNt[438];
LNt[440] = float(LNP2x3[95]+LNt[439])-LNP2x3[95];	//[22,49]<<46
LNt[439] -= LNt[440];
LNt[441] = float(LNP2x3[91]+LNt[439])-LNP2x3[91];	//[4,27]<<46
LNt[439] -= LNt[441];
LNt[442] = LNt[13]*LNt[49]+LNt[14]*LNt[48]-(LNt[18]*LNt[44]+LNt[19]*LNt[43])+LNt[440]+LNt[441];
LNt[443] = float(LNP2x3[114]+LNt[442])-LNP2x3[114];	//[9,32]<<69
LNt[442] -= LNt[443];
LNt[444] = LNt[14]*LNt[49]-LNt[19]*LNt[44]+LNt[443];
LNt[445] = LNt[79]*LNt[159]-LNt[84]*LNt[302]+LNt[433];
LNt[446] = float(LNP2x3[48]+LNt[445])-LNP2x3[48];	//[22,48]<<0
LNt[445] -= LNt[446];
LNt[447] = float(LNP2x3[45]+LNt[445])-LNP2x3[45];	//[3,26]<<0
LNt[445] -= LNt[447];
LNt[448] = LNt[79]*LNt[161]+LNt[82]*LNt[159]-(LNt[84]*LNt[304]+LNt[87]*LNt[302])+LNt[436]+LNt[446]+LNt[447];
LNt[449] = float(LNP2x3[72]+LNt[448])-LNP2x3[72];	//[22,49]<<23
LNt[448] -= LNt[449];
LNt[450] = float(LNP2x3[68]+LNt[448])-LNP2x3[68];	//[4,27]<<23
LNt[448] -= LNt[450];
LNt[451] = LNt[431]+LNt[439]+LNt[449]+LNt[450];
LNt[452] = float(LNP2x3[96]+LNt[451])-LNP2x3[96];	//[22,50]<<46
LNt[451] -= LNt[452];
LNt[453] = float(LNP2x3[91]+LNt[451])-LNP2x3[91];	//[5,28]<<46
LNt[451] -= LNt[453];
LNt[454] = LNt[82]*LNt[163]+LNt[83]*LNt[161]-(LNt[87]*LNt[306]+LNt[88]*LNt[304])+LNt[442]+LNt[452]+LNt[453];
LNt[455] = float(LNP2x3[114]+LNt[454])-LNP2x3[114];	//[11,34]<<69
LNt[454] -= LNt[455];
LNt[456] = LNt[83]*LNt[163]-LNt[88]*LNt[306]+LNt[444]+LNt[455];
LNt[457] = LNt[223]*LNt[456]+LNt[226]*LNt[454]+LNt[229]*LNt[451]+LNt[232]*LNt[448]+LNt[234]*LNt[445];
LNt[458] = LNt[215]*LNt[192]+LNt[218]*LNt[189]-(LNt[0]*LNt[335]+LNt[3]*LNt[332])+LNt[223]*LNt[448]+LNt[226]*LNt[445];
LNt[459] = LNt[218]*LNt[208]+LNt[219]*LNt[206]-(LNt[3]*LNt[351]+LNt[4]*LNt[349])+LNt[234]*LNt[456];
LNt[460] = LNt[79]*LNt[176]+LNt[82]*LNt[173]+LNt[83]*LNt[170]-(LNt[84]*LNt[319]+LNt[87]*LNt[316]+LNt[88]*LNt[313]);
LNt[461] = LNt[79]*LNt[179]+LNt[82]*LNt[176]+LNt[83]*LNt[173]-(LNt[84]*LNt[322]+LNt[87]*LNt[319]+LNt[88]*LNt[316]);
LNt[462] = LNt[79]*LNt[182]+LNt[82]*LNt[179]+LNt[83]*LNt[176]-(LNt[84]*LNt[325]+LNt[87]*LNt[322]+LNt[88]*LNt[319]);
LNt[463] = LNt[79]*LNt[185]+LNt[82]*LNt[182]+LNt[83]*LNt[179]-(LNt[84]*LNt[328]+LNt[87]*LNt[325]+LNt[88]*LNt[322]);
LNt[464] = LNt[79]*LNt[187]+LNt[82]*LNt[185]+LNt[83]*LNt[182]-(LNt[84]*LNt[330]+LNt[87]*LNt[328]+LNt[88]*LNt[325]);
LNt[465] = LNt[79]*LNt[188]+LNt[82]*LNt[187]+LNt[83]*LNt[185]-(LNt[84]*LNt[331]+LNt[87]*LNt[330]+LNt[88]*LNt[328]);
LNt[466] = LNt[92]*LNt[444]+LNt[95]*LNt[442]+LNt[98]*LNt[439]+LNt[101]*LNt[436]+LNt[103]*LNt[433];
LNt[467] = LNt[79]*LNt[173]+LNt[82]*LNt[170]-(LNt[84]*LNt[316]+LNt[87]*LNt[313])+LNt[92]*LNt[436]+LNt[95]*LNt[433];
LNt[468] = LNt[82]*LNt[188]+LNt[83]*LNt[187]-(LNt[87]*LNt[331]+LNt[88]*LNt[330])+LNt[103]*LNt[444];
LNt[469] = LNt[79]*LNt[170]-LNt[84]*LNt[313]+LNt[92]*LNt[433];
LNt[470] = float(LNP2x3[48]+LNt[469])-LNP2x3[48];	//[22,48]<<0
LNt[469] -= LNt[470];
LNt[471] = float(LNP2x3[45]+LNt[469])-LNP2x3[45];	//[3,26]<<0
LNt[469] -= LNt[471];
LNt[472] = LNt[467]+LNt[470]+LNt[471];
LNt[473] = float(LNP2x3[72]+LNt[472])-LNP2x3[72];	//[22,49]<<23
LNt[472] -= LNt[473];
LNt[474] = float(LNP2x3[68]+LNt[472])-LNP2x3[68];	//[4,27]<<23
LNt[472] -= LNt[474];
LNt[475] = LNt[460]+LNt[92]*LNt[439]+LNt[95]*LNt[436]+LNt[98]*LNt[433]+LNt[473]+LNt[474];
LNt[476] = float(LNP2x3[96]+LNt[475])-LNP2x3[96];	//[22,50]<<46
LNt[475] -= LNt[476];
LNt[477] = float(LNP2x3[91]+LNt[475])-LNP2x3[91];	//[5,28]<<46
LNt[475] -= LNt[477];
LNt[478] = LNt[461]+LNt[92]*LNt[442]+LNt[95]*LNt[439]+LNt[98]*LNt[436]+LNt[101]*LNt[433]+LNt[476]+LNt[477];
LNt[479] = float(LNP2x3[119]+LNt[478])-LNP2x3[119];	//[22,50]<<69
LNt[478] -= LNt[479];
LNt[480] = float(LNP2x3[114]+LNt[478])-LNP2x3[114];	//[5,28]<<69
LNt[478] -= LNt[480];
LNt[481] = LNt[462]+LNt[466]+LNt[479]+LNt[480];
LNt[482] = (float(LNP2x3[125]+LNt[481]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
LNt[481] -= LNt[482];
LNt[483] = (float(LNP2x3[125]+LNt[481]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
LNt[481] -= LNt[483];
LNt[484] = LNt[463]+LNt[95]*LNt[444]+LNt[98]*LNt[442]+LNt[101]*LNt[439]+LNt[103]*LNt[436]+LNt[482]+LNt[483];
LNt[485] = (float(LNP2x3[125]+LNt[484]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
LNt[484] -= LNt[485];
LNt[486] = (float(LNP2x3[125]+LNt[484]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
LNt[484] -= LNt[486];
LNt[487] = LNt[464]+LNt[98]*LNt[444]+LNt[101]*LNt[442]+LNt[103]*LNt[439]+LNt[485]+LNt[486];
LNt[488] = (float(LNP2x3[125]+LNt[487]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
LNt[487] -= LNt[488];
LNt[489] = (float(LNP2x3[125]+LNt[487]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
LNt[487] -= LNt[489];
LNt[490] = LNt[465]+LNt[101]*LNt[444]+LNt[103]*LNt[442]+LNt[488]+LNt[489];
LNt[491] = (float(LNP2x3[125]+LNt[490]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
LNt[490] -= LNt[491];
LNt[492] = (float(LNP2x3[125]+LNt[490]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
LNt[490] -= LNt[492];
LNt[493] = LNt[468]+LNt[491]+LNt[492];
LNt[494] = (float(LNP2x3[125]+LNt[493]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[10,33]<<184
LNt[493] -= LNt[494];
LNt[495] = LNt[83]*LNt[188]-LNt[88]*LNt[331]+LNt[494];
LNt[496] = LNt[426]+LNt[223]*LNt[454]+LNt[226]*LNt[451]+LNt[229]*LNt[448]+LNt[232]*LNt[445]-LNt[478];
LNt[497] = LNt[428]+LNt[226]*LNt[456]+LNt[229]*LNt[454]+LNt[232]*LNt[451]+LNt[234]*LNt[448]-LNt[484];
LNt[498] = LNt[215]*LNt[255]+LNt[218]*LNt[252]+LNt[219]*LNt[249]-(LNt[0]*LNt[378]+LNt[3]*LNt[375]+LNt[4]*LNt[372]);
LNt[499] = LNt[215]*LNt[258]+LNt[218]*LNt[255]+LNt[219]*LNt[252]-(LNt[0]*LNt[381]+LNt[3]*LNt[378]+LNt[4]*LNt[375]);
LNt[500] = LNt[215]*LNt[260]+LNt[218]*LNt[258]+LNt[219]*LNt[255]-(LNt[0]*LNt[383]+LNt[3]*LNt[381]+LNt[4]*LNt[378]);
LNt[501] = LNt[215]*LNt[252]+LNt[218]*LNt[249]-(LNt[0]*LNt[375]+LNt[3]*LNt[372])+LNt[154]*LNt[448]+LNt[157]*LNt[445];
LNt[502] = LNt[218]*LNt[260]+LNt[219]*LNt[258]-(LNt[3]*LNt[383]+LNt[4]*LNt[381])+LNt[157]*LNt[456]+LNt[158]*LNt[454];
LNt[503] = LNt[79]*LNt[243]+LNt[82]*LNt[240]+LNt[83]*LNt[237]-(LNt[84]*LNt[366]+LNt[87]*LNt[363]+LNt[88]*LNt[360]);
LNt[504] = LNt[79]*LNt[246]+LNt[82]*LNt[243]+LNt[83]*LNt[240]-(LNt[84]*LNt[369]+LNt[87]*LNt[366]+LNt[88]*LNt[363]);
LNt[505] = LNt[79]*LNt[248]+LNt[82]*LNt[246]+LNt[83]*LNt[243]-(LNt[84]*LNt[371]+LNt[87]*LNt[369]+LNt[88]*LNt[366]);
LNt[506] = LNt[79]*LNt[240]+LNt[82]*LNt[237]-(LNt[84]*LNt[363]+LNt[87]*LNt[360])+LNt[5]*LNt[436]+LNt[8]*LNt[433];
LNt[507] = LNt[82]*LNt[248]+LNt[83]*LNt[246]-(LNt[87]*LNt[371]+LNt[88]*LNt[369])+LNt[8]*LNt[444]+LNt[9]*LNt[442];
LNt[508] = LNt[79]*LNt[237]-LNt[84]*LNt[360]+LNt[5]*LNt[433];
LNt[509] = float(LNP2x3[48]+LNt[508])-LNP2x3[48];	//[22,48]<<0
LNt[508] -= LNt[509];
LNt[510] = float(LNP2x3[45]+LNt[508])-LNP2x3[45];	//[3,26]<<0
LNt[508] -= LNt[510];
LNt[511] = LNt[506]+LNt[509]+LNt[510];
LNt[512] = float(LNP2x3[72]+LNt[511])-LNP2x3[72];	//[22,49]<<23
LNt[511] -= LNt[512];
LNt[513] = float(LNP2x3[68]+LNt[511])-LNP2x3[68];	//[4,27]<<23
LNt[511] -= LNt[513];
LNt[514] = LNt[503]+LNt[5]*LNt[439]+LNt[8]*LNt[436]+LNt[9]*LNt[433]+LNt[512]+LNt[513];
LNt[515] = float(LNP2x3[96]+LNt[514])-LNP2x3[96];	//[22,50]<<46
LNt[514] -= LNt[515];
LNt[516] = float(LNP2x3[91]+LNt[514])-LNP2x3[91];	//[5,28]<<46
LNt[514] -= LNt[516];
LNt[517] = LNt[504]+LNt[5]*LNt[442]+LNt[8]*LNt[439]+LNt[9]*LNt[436]+LNt[515]+LNt[516];
LNt[518] = float(LNP2x3[119]+LNt[517])-LNP2x3[119];	//[22,50]<<69
LNt[517] -= LNt[518];
LNt[519] = float(LNP2x3[114]+LNt[517])-LNP2x3[114];	//[5,28]<<69
LNt[517] -= LNt[519];
LNt[520] = LNt[505]+LNt[5]*LNt[444]+LNt[8]*LNt[442]+LNt[9]*LNt[439]+LNt[518]+LNt[519];
LNt[521] = (float(LNP2x3[125]+LNt[520]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[520] -= LNt[521];
LNt[522] = (float(LNP2x3[125]+LNt[520]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[520] -= LNt[522];
LNt[523] = LNt[507]+LNt[521]+LNt[522];
LNt[524] = (float(LNP2x3[125]+LNt[523]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[523] -= LNt[524];
LNt[525] = LNt[83]*LNt[248]-LNt[88]*LNt[371]+LNt[9]*LNt[444]+LNt[524];
LNt[526] = (float(LNP2x3[125]+LNt[525]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[525] -= LNt[526];
LNt[527] = LNt[215]*LNt[279]+LNt[218]*LNt[276]+LNt[219]*LNt[273]-(LNt[0]*LNt[402]+LNt[3]*LNt[399]+LNt[4]*LNt[396]);
LNt[528] = LNt[215]*LNt[282]+LNt[218]*LNt[279]+LNt[219]*LNt[276]-(LNt[0]*LNt[405]+LNt[3]*LNt[402]+LNt[4]*LNt[399]);
LNt[529] = LNt[215]*LNt[285]+LNt[218]*LNt[282]+LNt[219]*LNt[279]-(LNt[0]*LNt[408]+LNt[3]*LNt[405]+LNt[4]*LNt[402]);
LNt[530] = LNt[215]*LNt[288]+LNt[218]*LNt[285]+LNt[219]*LNt[282]-(LNt[0]*LNt[411]+LNt[3]*LNt[408]+LNt[4]*LNt[405]);
LNt[531] = LNt[215]*LNt[291]+LNt[218]*LNt[288]+LNt[219]*LNt[285]-(LNt[0]*LNt[414]+LNt[3]*LNt[411]+LNt[4]*LNt[408]);
LNt[532] = LNt[215]*LNt[294]+LNt[218]*LNt[291]+LNt[219]*LNt[288]-(LNt[0]*LNt[417]+LNt[3]*LNt[414]+LNt[4]*LNt[411]);
LNt[533] = LNt[215]*LNt[297]+LNt[218]*LNt[294]+LNt[219]*LNt[291]-(LNt[0]*LNt[420]+LNt[3]*LNt[417]+LNt[4]*LNt[414]);
LNt[534] = LNt[215]*LNt[299]+LNt[218]*LNt[297]+LNt[219]*LNt[294]-(LNt[0]*LNt[422]+LNt[3]*LNt[420]+LNt[4]*LNt[417]);
LNt[535] = LNt[215]*LNt[276]+LNt[218]*LNt[273]-(LNt[0]*LNt[399]+LNt[3]*LNt[396])+LNt[154]*LNt[472]+LNt[157]*LNt[469];
LNt[536] = LNt[218]*LNt[299]+LNt[219]*LNt[297]-(LNt[3]*LNt[422]+LNt[4]*LNt[420])+LNt[157]*LNt[495]+LNt[158]*LNt[493];
LNt[537] = LNt[223]*LNt[520]+LNt[226]*LNt[517]+LNt[229]*LNt[514]+LNt[232]*LNt[511]+LNt[234]*LNt[508];
LNt[538] = LNt[223]*LNt[523]+LNt[226]*LNt[520]+LNt[229]*LNt[517]+LNt[232]*LNt[514]+LNt[234]*LNt[511];
LNt[539] = LNt[223]*LNt[525]+LNt[226]*LNt[523]+LNt[229]*LNt[520]+LNt[232]*LNt[517]+LNt[234]*LNt[514];
LNt[540] = LNt[223]*LNt[526]+LNt[226]*LNt[525]+LNt[229]*LNt[523]+LNt[232]*LNt[520]+LNt[234]*LNt[517];
LNt[541] = LNt[527]+LNt[154]*LNt[475]+LNt[157]*LNt[472]+LNt[158]*LNt[469]-(LNt[223]*LNt[514]+LNt[226]*LNt[511]+LNt[229]*LNt[508]);
LNt[542] = LNt[528]+LNt[154]*LNt[478]+LNt[157]*LNt[475]+LNt[158]*LNt[472]-(LNt[223]*LNt[517]+LNt[226]*LNt[514]+LNt[229]*LNt[511]+LNt[232]*LNt[508]);
LNt[543] = LNt[533]+LNt[154]*LNt[493]+LNt[157]*LNt[490]+LNt[158]*LNt[487]-(LNt[226]*LNt[526]+LNt[229]*LNt[525]+LNt[232]*LNt[523]+LNt[234]*LNt[520]);
LNt[544] = LNt[534]+LNt[154]*LNt[495]+LNt[157]*LNt[493]+LNt[158]*LNt[490]-(LNt[229]*LNt[526]+LNt[232]*LNt[525]+LNt[234]*LNt[523]);
(*this).a.v0 = 0.-(LNt[0]*LNt[134]-LNt[154]*LNt[189]+LNt[223]*LNt[249]-LNt[273]);
LNt[545] = float(LNP2x3[50]+(*this).a.v0)-LNP2x3[50];	//[22,50]<<0
(*this).a.v0 -= LNt[545];
LNt[546] = float(LNP2x3[45]+(*this).a.v0)-LNP2x3[45];	//[5,28]<<0
(*this).a.v0 -= LNt[546];
(*this).a.v1 = 0.0-(LNt[262]-LNt[276])+LNt[545]+LNt[546];
LNt[547] = float(LNP2x3[74]+(*this).a.v1)-LNP2x3[74];	//[22,51]<<23
(*this).a.v1 -= LNt[547];
LNt[548] = float(LNP2x3[68]+(*this).a.v1)-LNP2x3[68];	//[6,29]<<23
(*this).a.v1 -= LNt[548];
LNt[549] = 0.0-(LNt[209]+LNt[223]*LNt[255]+LNt[226]*LNt[252]+LNt[229]*LNt[249]-LNt[279])+LNt[547]+LNt[548];
(*this).a.v2 = LNt[549];
LNt[550] = float(LNP2x3[98]+(*this).a.v2)-LNP2x3[98];	//[22,52]<<46
(*this).a.v2 -= LNt[550];
LNt[551] = float(LNP2x3[91]+(*this).a.v2)-LNP2x3[91];	//[7,30]<<46
(*this).a.v2 -= LNt[551];
(*this).a.v3 = 0.0-LNt[300]+LNt[550]+LNt[551];
LNt[552] = float(LNP2x3[121]+(*this).a.v3)-LNP2x3[121];	//[22,52]<<69
(*this).a.v3 -= LNt[552];
LNt[553] = float(LNP2x3[114]+(*this).a.v3)-LNP2x3[114];	//[7,30]<<69
(*this).a.v3 -= LNt[553];
(*this).a.v4 = 0.0-(LNt[211]+LNt[261]-LNt[285])+LNt[552]+LNt[553];
LNt[554] = (float(LNP2x3[125]+(*this).a.v4/LNP2[20])-LNP2x3[125])*LNP2[20];	//[22,53]<<92
(*this).a.v4 -= LNt[554];
LNt[555] = (float(LNP2x3[125]+(*this).a.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[8,31]<<92
(*this).a.v4 -= LNt[555];
(*this).a.v5 = 0.0-LNt[301]+LNt[554]+LNt[555];
LNt[556] = (float(LNP2x3[125]+(*this).a.v5/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
(*this).a.v5 -= LNt[556];
LNt[557] = (float(LNP2x3[125]+(*this).a.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
(*this).a.v5 -= LNt[557];
LNt[558] = 0.0-(LNt[213]+LNt[229]*LNt[260]+LNt[232]*LNt[258]+LNt[234]*LNt[255]-LNt[291])+LNt[556]+LNt[557];
(*this).a.v6 = LNt[558];
LNt[559] = (float(LNP2x3[125]+(*this).a.v6/LNP2[65])-LNP2x3[125])*LNP2[65];	//[22,52]<<138
(*this).a.v6 -= LNt[559];
LNt[560] = (float(LNP2x3[125]+(*this).a.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[7,30]<<138
(*this).a.v6 -= LNt[560];
(*this).a.v7 = 0.0-(LNt[214]+LNt[232]*LNt[260]+LNt[234]*LNt[258]-LNt[294])+LNt[559]+LNt[560];
LNt[561] = (float(LNP2x3[125]+(*this).a.v7/LNP2[88])-LNP2x3[125])*LNP2[88];	//[22,52]<<161
(*this).a.v7 -= LNt[561];
LNt[562] = (float(LNP2x3[125]+(*this).a.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[7,30]<<161
(*this).a.v7 -= LNt[562];
(*this).a.v8 = 0.0-(LNt[263]-LNt[297])+LNt[561]+LNt[562];
LNt[563] = (float(LNP2x3[125]+(*this).a.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[13,36]<<184
(*this).a.v8 -= LNt[563];
(*this).a.v9 = 0.0-(LNt[4]*LNt[153]-LNt[158]*LNt[208]-LNt[299])+LNt[563];
(*this).b.v0 = LNt[215]*LNt[134]-LNt[154]*LNt[332]+LNt[223]*LNt[372]-LNt[396];
LNt[564] = float(LNP2x3[49]+(*this).b.v0)-LNP2x3[49];	//[22,49]<<0
(*this).b.v0 -= LNt[564];
LNt[565] = float(LNP2x3[45]+(*this).b.v0)-LNP2x3[45];	//[4,27]<<0
(*this).b.v0 -= LNt[565];
(*this).b.v1 = LNt[385]-LNt[399]+LNt[564]+LNt[565];
LNt[566] = float(LNP2x3[73]+(*this).b.v1)-LNP2x3[73];	//[22,50]<<23
(*this).b.v1 -= LNt[566];
LNt[567] = float(LNP2x3[68]+(*this).b.v1)-LNP2x3[68];	//[5,28]<<23
(*this).b.v1 -= LNt[567];
LNt[568] = LNt[352]+LNt[223]*LNt[378]+LNt[226]*LNt[375]+LNt[229]*LNt[372]-LNt[402]+LNt[566]+LNt[567];
(*this).b.v2 = LNt[568];
LNt[569] = float(LNP2x3[97]+(*this).b.v2)-LNP2x3[97];	//[22,51]<<46
(*this).b.v2 -= LNt[569];
LNt[570] = float(LNP2x3[91]+(*this).b.v2)-LNP2x3[91];	//[6,29]<<46
(*this).b.v2 -= LNt[570];
(*this).b.v3 = LNt[423]+LNt[569]+LNt[570];
LNt[571] = float(LNP2x3[120]+(*this).b.v3)-LNP2x3[120];	//[22,51]<<69
(*this).b.v3 -= LNt[571];
LNt[572] = float(LNP2x3[114]+(*this).b.v3)-LNP2x3[114];	//[6,29]<<69
(*this).b.v3 -= LNt[572];
(*this).b.v4 = LNt[354]+LNt[384]-LNt[408]+LNt[571]+LNt[572];
LNt[573] = (float(LNP2x3[125]+(*this).b.v4/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
(*this).b.v4 -= LNt[573];
LNt[574] = (float(LNP2x3[125]+(*this).b.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
(*this).b.v4 -= LNt[574];
(*this).b.v5 = LNt[424]+LNt[573]+LNt[574];
LNt[575] = (float(LNP2x3[125]+(*this).b.v5/LNP2[41])-LNP2x3[125])*LNP2[41];	//[22,51]<<115
(*this).b.v5 -= LNt[575];
LNt[576] = (float(LNP2x3[125]+(*this).b.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[6,29]<<115
(*this).b.v5 -= LNt[576];
LNt[577] = LNt[356]+LNt[229]*LNt[383]+LNt[232]*LNt[381]+LNt[234]*LNt[378]-LNt[414]+LNt[575]+LNt[576];
(*this).b.v6 = LNt[577];
LNt[578] = (float(LNP2x3[125]+(*this).b.v6/LNP2[64])-LNP2x3[125])*LNP2[64];	//[22,51]<<138
(*this).b.v6 -= LNt[578];
LNt[579] = (float(LNP2x3[125]+(*this).b.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[6,29]<<138
(*this).b.v6 -= LNt[579];
(*this).b.v7 = LNt[357]+LNt[232]*LNt[383]+LNt[234]*LNt[381]-LNt[417]+LNt[578]+LNt[579];
LNt[580] = (float(LNP2x3[125]+(*this).b.v7/LNP2[87])-LNP2x3[125])*LNP2[87];	//[22,51]<<161
(*this).b.v7 -= LNt[580];
LNt[581] = (float(LNP2x3[125]+(*this).b.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[6,29]<<161
(*this).b.v7 -= LNt[581];
(*this).b.v8 = LNt[386]-LNt[420]+LNt[580]+LNt[581];
LNt[582] = (float(LNP2x3[125]+(*this).b.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
(*this).b.v8 -= LNt[582];
(*this).b.v9 = LNt[219]*LNt[153]-LNt[158]*LNt[351]-LNt[422]+LNt[582];
(*this).c.v0 = 0.-(LNt[215]*LNt[189]-LNt[0]*LNt[332]+LNt[223]*LNt[445]-LNt[469]);
LNt[583] = float(LNP2x3[50]+(*this).c.v0)-LNP2x3[50];	//[22,50]<<0
(*this).c.v0 -= LNt[583];
LNt[584] = float(LNP2x3[45]+(*this).c.v0)-LNP2x3[45];	//[5,28]<<0
(*this).c.v0 -= LNt[584];
(*this).c.v1 = 0.0-(LNt[458]-LNt[472])+LNt[583]+LNt[584];
LNt[585] = float(LNP2x3[74]+(*this).c.v1)-LNP2x3[74];	//[22,51]<<23
(*this).c.v1 -= LNt[585];
LNt[586] = float(LNP2x3[68]+(*this).c.v1)-LNP2x3[68];	//[6,29]<<23
(*this).c.v1 -= LNt[586];
LNt[587] = 0.0-(LNt[425]+LNt[223]*LNt[451]+LNt[226]*LNt[448]+LNt[229]*LNt[445]-LNt[475])+LNt[585]+LNt[586];
(*this).c.v2 = LNt[587];
LNt[588] = float(LNP2x3[98]+(*this).c.v2)-LNP2x3[98];	//[22,52]<<46
(*this).c.v2 -= LNt[588];
LNt[589] = float(LNP2x3[91]+(*this).c.v2)-LNP2x3[91];	//[7,30]<<46
(*this).c.v2 -= LNt[589];
(*this).c.v3 = 0.0-LNt[496]+LNt[588]+LNt[589];
LNt[590] = float(LNP2x3[121]+(*this).c.v3)-LNP2x3[121];	//[22,52]<<69
(*this).c.v3 -= LNt[590];
LNt[591] = float(LNP2x3[114]+(*this).c.v3)-LNP2x3[114];	//[7,30]<<69
(*this).c.v3 -= LNt[591];
(*this).c.v4 = 0.0-(LNt[427]+LNt[457]-LNt[481])+LNt[590]+LNt[591];
LNt[592] = (float(LNP2x3[125]+(*this).c.v4/LNP2[20])-LNP2x3[125])*LNP2[20];	//[22,53]<<92
(*this).c.v4 -= LNt[592];
LNt[593] = (float(LNP2x3[125]+(*this).c.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[8,31]<<92
(*this).c.v4 -= LNt[593];
(*this).c.v5 = 0.0-LNt[497]+LNt[592]+LNt[593];
LNt[594] = (float(LNP2x3[125]+(*this).c.v5/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
(*this).c.v5 -= LNt[594];
LNt[595] = (float(LNP2x3[125]+(*this).c.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
(*this).c.v5 -= LNt[595];
LNt[596] = 0.0-(LNt[429]+LNt[229]*LNt[456]+LNt[232]*LNt[454]+LNt[234]*LNt[451]-LNt[487])+LNt[594]+LNt[595];
(*this).c.v6 = LNt[596];
LNt[597] = (float(LNP2x3[125]+(*this).c.v6/LNP2[65])-LNP2x3[125])*LNP2[65];	//[22,52]<<138
(*this).c.v6 -= LNt[597];
LNt[598] = (float(LNP2x3[125]+(*this).c.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[7,30]<<138
(*this).c.v6 -= LNt[598];
(*this).c.v7 = 0.0-(LNt[430]+LNt[232]*LNt[456]+LNt[234]*LNt[454]-LNt[490])+LNt[597]+LNt[598];
LNt[599] = (float(LNP2x3[125]+(*this).c.v7/LNP2[88])-LNP2x3[125])*LNP2[88];	//[22,52]<<161
(*this).c.v7 -= LNt[599];
LNt[600] = (float(LNP2x3[125]+(*this).c.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[7,30]<<161
(*this).c.v7 -= LNt[600];
(*this).c.v8 = 0.0-(LNt[459]-LNt[493])+LNt[599]+LNt[600];
LNt[601] = (float(LNP2x3[125]+(*this).c.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[13,36]<<184
(*this).c.v8 -= LNt[601];
(*this).c.v9 = 0.0-(LNt[219]*LNt[208]-LNt[4]*LNt[351]-LNt[495])+LNt[601];
(*this).d.v0 = LNt[215]*LNt[249]-LNt[0]*LNt[372]+LNt[154]*LNt[445]-LNt[508];
LNt[602] = float(LNP2x3[49]+(*this).d.v0)-LNP2x3[49];	//[22,49]<<0
(*this).d.v0 -= LNt[602];
LNt[603] = float(LNP2x3[45]+(*this).d.v0)-LNP2x3[45];	//[4,27]<<0
(*this).d.v0 -= LNt[603];
(*this).d.v1 = LNt[501]-LNt[511]+LNt[602]+LNt[603];
LNt[604] = float(LNP2x3[73]+(*this).d.v1)-LNP2x3[73];	//[22,50]<<23
(*this).d.v1 -= LNt[604];
LNt[605] = float(LNP2x3[68]+(*this).d.v1)-LNP2x3[68];	//[5,28]<<23
(*this).d.v1 -= LNt[605];
LNt[606] = LNt[498]+LNt[154]*LNt[451]+LNt[157]*LNt[448]+LNt[158]*LNt[445]-LNt[514]+LNt[604]+LNt[605];
(*this).d.v2 = LNt[606];
LNt[607] = float(LNP2x3[97]+(*this).d.v2)-LNP2x3[97];	//[22,51]<<46
(*this).d.v2 -= LNt[607];
LNt[608] = float(LNP2x3[91]+(*this).d.v2)-LNP2x3[91];	//[6,29]<<46
(*this).d.v2 -= LNt[608];
LNt[609] = LNt[499]+LNt[154]*LNt[454]+LNt[157]*LNt[451]+LNt[158]*LNt[448]-LNt[517]+LNt[607]+LNt[608];
(*this).d.v3 = LNt[609];
LNt[610] = float(LNP2x3[120]+(*this).d.v3)-LNP2x3[120];	//[22,51]<<69
(*this).d.v3 -= LNt[610];
LNt[611] = float(LNP2x3[114]+(*this).d.v3)-LNP2x3[114];	//[6,29]<<69
(*this).d.v3 -= LNt[611];
LNt[612] = LNt[500]+LNt[154]*LNt[456]+LNt[157]*LNt[454]+LNt[158]*LNt[451]-LNt[520]+LNt[610]+LNt[611];
(*this).d.v4 = LNt[612];
LNt[613] = (float(LNP2x3[125]+(*this).d.v4/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
(*this).d.v4 -= LNt[613];
LNt[614] = (float(LNP2x3[125]+(*this).d.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
(*this).d.v4 -= LNt[614];
(*this).d.v5 = LNt[502]-LNt[523]+LNt[613]+LNt[614];
LNt[615] = (float(LNP2x3[125]+(*this).d.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[21,44]<<115
(*this).d.v5 -= LNt[615];
(*this).d.v6 = LNt[219]*LNt[260]-LNt[4]*LNt[383]+LNt[158]*LNt[456]-LNt[525]+LNt[615];
LNt[616] = (float(LNP2x3[125]+(*this).d.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[4,27]<<138
(*this).d.v6 -= LNt[616];
(*this).d.v7 = 0.0-LNt[526]+LNt[616];
(*this).e.v0 = 0.-(LNt[215]*LNt[273]-LNt[0]*LNt[396]+LNt[154]*LNt[469]-LNt[223]*LNt[508]);
LNt[617] = float(LNP2x3[50]+(*this).e.v0)-LNP2x3[50];	//[22,50]<<0
(*this).e.v0 -= LNt[617];
LNt[618] = float(LNP2x3[45]+(*this).e.v0)-LNP2x3[45];	//[5,28]<<0
(*this).e.v0 -= LNt[618];
(*this).e.v1 = 0.0-(LNt[535]-(LNt[223]*LNt[511]+LNt[226]*LNt[508]))+LNt[617]+LNt[618];
LNt[619] = float(LNP2x3[74]+(*this).e.v1)-LNP2x3[74];	//[22,51]<<23
(*this).e.v1 -= LNt[619];
LNt[620] = float(LNP2x3[68]+(*this).e.v1)-LNP2x3[68];	//[6,29]<<23
(*this).e.v1 -= LNt[620];
(*this).e.v2 = 0.0-LNt[541]+LNt[619]+LNt[620];
LNt[621] = float(LNP2x3[98]+(*this).e.v2)-LNP2x3[98];	//[22,52]<<46
(*this).e.v2 -= LNt[621];
LNt[622] = float(LNP2x3[91]+(*this).e.v2)-LNP2x3[91];	//[7,30]<<46
(*this).e.v2 -= LNt[622];
(*this).e.v3 = 0.0-LNt[542]+LNt[621]+LNt[622];
LNt[623] = float(LNP2x3[121]+(*this).e.v3)-LNP2x3[121];	//[22,52]<<69
(*this).e.v3 -= LNt[623];
LNt[624] = float(LNP2x3[114]+(*this).e.v3)-LNP2x3[114];	//[7,30]<<69
(*this).e.v3 -= LNt[624];
LNt[625] = 0.0-(LNt[529]+LNt[154]*LNt[481]+LNt[157]*LNt[478]+LNt[158]*LNt[475]-LNt[537])+LNt[623]+LNt[624];
(*this).e.v4 = LNt[625];
LNt[626] = (float(LNP2x3[125]+(*this).e.v4/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
(*this).e.v4 -= LNt[626];
LNt[627] = (float(LNP2x3[125]+(*this).e.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
(*this).e.v4 -= LNt[627];
LNt[628] = 0.0-(LNt[530]+LNt[154]*LNt[484]+LNt[157]*LNt[481]+LNt[158]*LNt[478]-LNt[538])+LNt[626]+LNt[627];
(*this).e.v5 = LNt[628];
LNt[629] = (float(LNP2x3[125]+(*this).e.v5/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
(*this).e.v5 -= LNt[629];
LNt[630] = (float(LNP2x3[125]+(*this).e.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
(*this).e.v5 -= LNt[630];
LNt[631] = 0.0-(LNt[531]+LNt[154]*LNt[487]+LNt[157]*LNt[484]+LNt[158]*LNt[481]-LNt[539])+LNt[629]+LNt[630];
(*this).e.v6 = LNt[631];
LNt[632] = (float(LNP2x3[125]+(*this).e.v6/LNP2[65])-LNP2x3[125])*LNP2[65];	//[22,52]<<138
(*this).e.v6 -= LNt[632];
LNt[633] = (float(LNP2x3[125]+(*this).e.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[7,30]<<138
(*this).e.v6 -= LNt[633];
LNt[634] = 0.0-(LNt[532]+LNt[154]*LNt[490]+LNt[157]*LNt[487]+LNt[158]*LNt[484]-LNt[540])+LNt[632]+LNt[633];
(*this).e.v7 = LNt[634];
LNt[635] = (float(LNP2x3[125]+(*this).e.v7/LNP2[88])-LNP2x3[125])*LNP2[88];	//[22,52]<<161
(*this).e.v7 -= LNt[635];
LNt[636] = (float(LNP2x3[125]+(*this).e.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[7,30]<<161
(*this).e.v7 -= LNt[636];
(*this).e.v8 = 0.0-LNt[543]+LNt[635]+LNt[636];
LNt[637] = (float(LNP2x3[125]+(*this).e.v8/LNP2[111])-LNP2x3[125])*LNP2[111];	//[22,52]<<184
(*this).e.v8 -= LNt[637];
LNt[638] = (float(LNP2x3[125]+(*this).e.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[7,30]<<184
(*this).e.v8 -= LNt[638];
(*this).e.v9 = 0.0-LNt[544]+LNt[637]+LNt[638];
LNt[639] = (float(LNP2x3[125]+(*this).e.v9/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
(*this).e.v9 -= LNt[639];
LNt[640] = (float(LNP2x3[125]+(*this).e.v9/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
(*this).e.v9 -= LNt[640];
(*this).e.v10 = 0.0-(LNt[536]-(LNt[232]*LNt[526]+LNt[234]*LNt[525]))+LNt[639]+LNt[640];
LNt[641] = (float(LNP2x3[125]+(*this).e.v10/LNP2[150])-LNP2x3[125])*LNP2[150];	//[19,42]<<230
(*this).e.v10 -= LNt[641];
LNt[642] = 0.0-(LNt[219]*LNt[299]-LNt[4]*LNt[422]+LNt[158]*LNt[495]-LNt[234]*LNt[526])+LNt[641];
(*this).e.v11 = LNt[642];
} /* adds=1303 multiplies=1054 normalizes=335 */


integer incircle3dbeyond(const Point3d& p, const Incircle3dHyperPlane& pi){
integer LNans;
LNt[1] = p.x*(pi.a.v9+pi.a.v8+pi.a.v7)+p.y*(pi.b.v9+pi.b.v8+pi.b.v7)+p.z*(pi.c.v9+pi.c.v8+pi.c.v7);
LNt[2] = LNt[1]+(p.x*p.x+p.y*p.y+p.z*p.z)*(pi.d.v7+pi.d.v6+pi.d.v5+pi.d.v4)+pi.e.v11+pi.e.v10+pi.e.v9;
if (-LNP2[231]<LNt[2] && LNt[2]<LNP2[231]) {	/* the high order 47 bits of 278 are accurate */
  LNt[3] = p.x;
  LNt[4] = float(LNP2x3[53]+LNt[3])-LNP2x3[53];	//[22,53]<<0
  LNt[3] -= LNt[4];
  LNt[5] = float(LNP2x3[45]+LNt[3])-LNP2x3[45];	//[8,31]<<0
  LNt[3] -= LNt[5];
  LNt[6] = LNt[4]+LNt[5];
  LNt[7] = float(LNP2x3[68]+LNt[6])-LNP2x3[68];	//[7,30]<<23
  LNt[6] -= LNt[7];
  LNt[8] = p.y;
  LNt[9] = float(LNP2x3[53]+LNt[8])-LNP2x3[53];	//[22,53]<<0
  LNt[8] -= LNt[9];
  LNt[10] = float(LNP2x3[45]+LNt[8])-LNP2x3[45];	//[8,31]<<0
  LNt[8] -= LNt[10];
  LNt[11] = LNt[9]+LNt[10];
  LNt[12] = float(LNP2x3[68]+LNt[11])-LNP2x3[68];	//[7,30]<<23
  LNt[11] -= LNt[12];
  LNt[13] = LNt[3]*pi.a.v2+LNt[6]*pi.a.v1+LNt[7]*pi.a.v0+LNt[8]*pi.b.v2+LNt[11]*pi.b.v1+LNt[12]*pi.b.v0;
  LNt[14] = LNt[3]*pi.a.v3+LNt[6]*pi.a.v2+LNt[7]*pi.a.v1+LNt[8]*pi.b.v3+LNt[11]*pi.b.v2+LNt[12]*pi.b.v1;
  LNt[15] = LNt[3]*pi.a.v4+LNt[6]*pi.a.v3+LNt[7]*pi.a.v2+LNt[8]*pi.b.v4+LNt[11]*pi.b.v3+LNt[12]*pi.b.v2;
  LNt[16] = LNt[3]*pi.a.v5+LNt[6]*pi.a.v4+LNt[7]*pi.a.v3+LNt[8]*pi.b.v5+LNt[11]*pi.b.v4+LNt[12]*pi.b.v3;
  LNt[17] = LNt[3]*pi.a.v6+LNt[6]*pi.a.v5+LNt[7]*pi.a.v4+LNt[8]*pi.b.v6+LNt[11]*pi.b.v5+LNt[12]*pi.b.v4;
  LNt[18] = LNt[3]*pi.a.v7+LNt[6]*pi.a.v6+LNt[7]*pi.a.v5+LNt[8]*pi.b.v7+LNt[11]*pi.b.v6+LNt[12]*pi.b.v5;
  LNt[19] = LNt[3]*pi.a.v8+LNt[6]*pi.a.v7+LNt[7]*pi.a.v6+LNt[8]*pi.b.v8+LNt[11]*pi.b.v7+LNt[12]*pi.b.v6;
  LNt[20] = LNt[3]*pi.a.v9+LNt[6]*pi.a.v8+LNt[7]*pi.a.v7+LNt[8]*pi.b.v9+LNt[11]*pi.b.v8+LNt[12]*pi.b.v7;
  LNt[21] = p.z;
  LNt[22] = float(LNP2x3[53]+LNt[21])-LNP2x3[53];	//[22,53]<<0
  LNt[21] -= LNt[22];
  LNt[23] = float(LNP2x3[45]+LNt[21])-LNP2x3[45];	//[8,31]<<0
  LNt[21] -= LNt[23];
  LNt[24] = LNt[22]+LNt[23];
  LNt[25] = float(LNP2x3[68]+LNt[24])-LNP2x3[68];	//[7,30]<<23
  LNt[24] -= LNt[25];
  LNt[26] = LNt[3]*pi.a.v1+LNt[6]*pi.a.v0+LNt[8]*pi.b.v1+LNt[11]*pi.b.v0+LNt[21]*pi.c.v1+LNt[24]*pi.c.v0;
  LNt[27] = LNt[6]*pi.a.v9+LNt[7]*pi.a.v8+LNt[11]*pi.b.v9+LNt[12]*pi.b.v8+LNt[24]*pi.c.v9+LNt[25]*pi.c.v8;
  LNt[28] = LNt[3]*LNt[7]+LNt[6]*LNt[6]+LNt[7]*LNt[3]+LNt[8]*LNt[12]+LNt[11]*LNt[11]+LNt[12]*LNt[8];
  LNt[29] = LNt[3]*LNt[6]+LNt[6]*LNt[3]+LNt[8]*LNt[11]+LNt[11]*LNt[8]+LNt[21]*LNt[24]+LNt[24]*LNt[21];
  LNt[30] = LNt[6]*LNt[7]+LNt[7]*LNt[6]+LNt[11]*LNt[12]+LNt[12]*LNt[11]+LNt[24]*LNt[25]+LNt[25]*LNt[24];
  LNt[31] = LNt[3]*LNt[3]+LNt[8]*LNt[8]+LNt[21]*LNt[21];
  LNt[32] = float(LNP2x3[48]+LNt[31])-LNP2x3[48];	//[22,48]<<0
  LNt[31] -= LNt[32];
  LNt[33] = float(LNP2x3[45]+LNt[31])-LNP2x3[45];	//[3,26]<<0
  LNt[31] -= LNt[33];
  LNt[34] = LNt[29]+LNt[32]+LNt[33];
  LNt[35] = float(LNP2x3[72]+LNt[34])-LNP2x3[72];	//[22,49]<<23
  LNt[34] -= LNt[35];
  LNt[36] = float(LNP2x3[68]+LNt[34])-LNP2x3[68];	//[4,27]<<23
  LNt[34] -= LNt[36];
  LNt[37] = LNt[28]+LNt[21]*LNt[25]+LNt[24]*LNt[24]+LNt[25]*LNt[21]+LNt[35]+LNt[36];
  LNt[38] = float(LNP2x3[96]+LNt[37])-LNP2x3[96];	//[22,50]<<46
  LNt[37] -= LNt[38];
  LNt[39] = float(LNP2x3[91]+LNt[37])-LNP2x3[91];	//[5,28]<<46
  LNt[37] -= LNt[39];
  LNt[40] = LNt[30]+LNt[38]+LNt[39];
  LNt[41] = float(LNP2x3[114]+LNt[40])-LNP2x3[114];	//[10,33]<<69
  LNt[40] -= LNt[41];
  LNt[42] = LNt[7]*LNt[7]+LNt[12]*LNt[12]+LNt[25]*LNt[25]+LNt[41];
  LNt[43] = LNt[13]+LNt[21]*pi.c.v2+LNt[24]*pi.c.v1+LNt[25]*pi.c.v0+LNt[31]*pi.d.v2+LNt[34]*pi.d.v1+LNt[37]*pi.d.v0;
  LNt[44] = LNt[14]+LNt[21]*pi.c.v3+LNt[24]*pi.c.v2+LNt[25]*pi.c.v1+LNt[31]*pi.d.v3+LNt[34]*pi.d.v2+LNt[37]*pi.d.v1+LNt[40]*pi.d.v0;
  LNt[45] = LNt[15]+LNt[21]*pi.c.v4+LNt[24]*pi.c.v3+LNt[25]*pi.c.v2+LNt[31]*pi.d.v4+LNt[34]*pi.d.v3+LNt[37]*pi.d.v2+LNt[40]*pi.d.v1+LNt[42]*pi.d.v0;
  LNt[46] = LNt[16]+LNt[21]*pi.c.v5+LNt[24]*pi.c.v4+LNt[25]*pi.c.v3+LNt[31]*pi.d.v5+LNt[34]*pi.d.v4+LNt[37]*pi.d.v3+LNt[40]*pi.d.v2+LNt[42]*pi.d.v1;
  LNt[47] = LNt[17]+LNt[21]*pi.c.v6+LNt[24]*pi.c.v5+LNt[25]*pi.c.v4+LNt[31]*pi.d.v6+LNt[34]*pi.d.v5+LNt[37]*pi.d.v4+LNt[40]*pi.d.v3+LNt[42]*pi.d.v2;
  LNt[48] = LNt[18]+LNt[21]*pi.c.v7+LNt[24]*pi.c.v6+LNt[25]*pi.c.v5+LNt[31]*pi.d.v7+LNt[34]*pi.d.v6+LNt[37]*pi.d.v5+LNt[40]*pi.d.v4+LNt[42]*pi.d.v3;
  LNt[49] = LNt[19]+LNt[21]*pi.c.v8+LNt[24]*pi.c.v7+LNt[25]*pi.c.v6+LNt[34]*pi.d.v7+LNt[37]*pi.d.v6+LNt[40]*pi.d.v5+LNt[42]*pi.d.v4;
  LNt[50] = LNt[20]+LNt[21]*pi.c.v9+LNt[24]*pi.c.v8+LNt[25]*pi.c.v7+LNt[37]*pi.d.v7+LNt[40]*pi.d.v6+LNt[42]*pi.d.v5;
  LNt[51] = LNt[3]*pi.a.v0+LNt[8]*pi.b.v0+LNt[21]*pi.c.v0+LNt[31]*pi.d.v0+pi.e.v0;
  LNt[52] = LNt[26]+LNt[31]*pi.d.v1+LNt[34]*pi.d.v0+pi.e.v1;
  LNt[53] = LNt[43]+pi.e.v2;
  LNt[54] = LNt[44]+pi.e.v3;
  LNt[55] = LNt[45]+pi.e.v4;
  LNt[56] = LNt[46]+pi.e.v5;
  LNt[57] = LNt[47]+pi.e.v6;
  LNt[58] = LNt[48]+pi.e.v7;
  LNt[59] = LNt[49]+pi.e.v8;
  LNt[60] = LNt[50]+pi.e.v9;
  LNt[61] = LNt[27]+LNt[40]*pi.d.v7+LNt[42]*pi.d.v6+pi.e.v10;
  LNt[62] = LNt[7]*pi.a.v9+LNt[12]*pi.b.v9+LNt[25]*pi.c.v9+LNt[42]*pi.d.v7+pi.e.v11;
  LNt[63] = ((((((((LNt[62])+LNt[61])+LNt[60])+LNt[59])+LNt[58])+LNt[57])+LNt[56])+LNt[55])+LNt[54];
  LNt[2] = ((((LNt[63])+LNt[53])+LNt[52])+LNt[51]);
}
if (LNt[2]<0){
  LNt[0] = -1.;
}else{
  if (LNt[2]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=190 multiplies=164 normalizes=16 */


integer wincircle3d(const WPoint3d& a, const WPoint3d& b, const WPoint3d& c, const WPoint3d& d, const WPoint3d& e){
integer LNans;
LNt[1] = c.y-e.y;
LNt[2] = a.z-e.z;
LNt[3] = e.x*e.x+e.y*e.y+e.z*e.z-e.w;
LNt[4] = b.x*b.x+b.y*b.y+b.z*b.z-b.w-LNt[3];
LNt[5] = b.z-e.z;
LNt[6] = a.x*a.x+a.y*a.y+a.z*a.z-a.w-LNt[3];
LNt[7] = LNt[2]*LNt[4]-LNt[5]*LNt[6];
LNt[8] = c.z-e.z;
LNt[9] = a.y-e.y;
LNt[10] = b.y-e.y;
LNt[11] = LNt[9]*LNt[4]-LNt[10]*LNt[6];
LNt[12] = c.x*c.x+c.y*c.y+c.z*c.z-c.w-LNt[3];
LNt[13] = LNt[9]*LNt[5]-LNt[10]*LNt[2];
LNt[14] = c.x-e.x;
LNt[15] = a.x-e.x;
LNt[16] = b.x-e.x;
LNt[17] = LNt[15]*LNt[4]-LNt[6]*LNt[16];
LNt[18] = LNt[15]*LNt[5]-LNt[2]*LNt[16];
LNt[19] = (0.-(d.x-e.x))*(LNt[1]*LNt[7]-LNt[8]*LNt[11]+LNt[12]*LNt[13])+(d.y-e.y)*(LNt[14]*LNt[7]-LNt[8]*LNt[17]+LNt[12]*LNt[18]);
LNt[20] = LNt[15]*LNt[10]-LNt[9]*LNt[16];
LNt[21] = (d.x*d.x+d.y*d.y+d.z*d.z-d.w-LNt[3])*(LNt[14]*LNt[13]-LNt[1]*LNt[18]+LNt[8]*LNt[20]);
LNt[22] = LNt[19]-(d.z-e.z)*(LNt[14]*LNt[11]-LNt[1]*LNt[17]+LNt[12]*LNt[20])+LNt[21];
if (-LNP2[240]<LNt[22] && LNt[22]<LNP2[240]) {	/* the high order 39 bits of 279 are accurate */
  LNt[23] = d.x;
  LNt[24] = float(LNP2x3[53]+LNt[23])-LNP2x3[53];	//[22,53]<<0
  LNt[23] -= LNt[24];
  LNt[25] = float(LNP2x3[45]+LNt[23])-LNP2x3[45];	//[8,31]<<0
  LNt[23] -= LNt[25];
  LNt[26] = LNt[24]+LNt[25];
  LNt[27] = float(LNP2x3[68]+LNt[26])-LNP2x3[68];	//[7,30]<<23
  LNt[26] -= LNt[27];
  LNt[28] = e.x;
  LNt[29] = float(LNP2x3[53]+LNt[28])-LNP2x3[53];	//[22,53]<<0
  LNt[28] -= LNt[29];
  LNt[30] = float(LNP2x3[45]+LNt[28])-LNP2x3[45];	//[8,31]<<0
  LNt[28] -= LNt[30];
  LNt[31] = LNt[29]+LNt[30];
  LNt[32] = float(LNP2x3[68]+LNt[31])-LNP2x3[68];	//[7,30]<<23
  LNt[31] -= LNt[32];
  LNt[33] = 0.-(LNt[23]-LNt[28]);
  LNt[34] = float(LNP2x3[45]+LNt[33])-LNP2x3[45];	//[2,25]<<0
  LNt[33] -= LNt[34];
  LNt[35] = 0.0-(LNt[26]-LNt[31])+LNt[34];
  LNt[36] = float(LNP2x3[68]+LNt[35])-LNP2x3[68];	//[2,25]<<23
  LNt[35] -= LNt[36];
  LNt[37] = c.y;
  LNt[38] = float(LNP2x3[53]+LNt[37])-LNP2x3[53];	//[22,53]<<0
  LNt[37] -= LNt[38];
  LNt[39] = float(LNP2x3[45]+LNt[37])-LNP2x3[45];	//[8,31]<<0
  LNt[37] -= LNt[39];
  LNt[40] = LNt[38]+LNt[39];
  LNt[41] = float(LNP2x3[68]+LNt[40])-LNP2x3[68];	//[7,30]<<23
  LNt[40] -= LNt[41];
  LNt[42] = e.y;
  LNt[43] = float(LNP2x3[53]+LNt[42])-LNP2x3[53];	//[22,53]<<0
  LNt[42] -= LNt[43];
  LNt[44] = float(LNP2x3[45]+LNt[42])-LNP2x3[45];	//[8,31]<<0
  LNt[42] -= LNt[44];
  LNt[45] = LNt[43]+LNt[44];
  LNt[46] = float(LNP2x3[68]+LNt[45])-LNP2x3[68];	//[7,30]<<23
  LNt[45] -= LNt[46];
  LNt[47] = LNt[37]-LNt[42];
  LNt[48] = float(LNP2x3[45]+LNt[47])-LNP2x3[45];	//[1,24]<<0
  LNt[47] -= LNt[48];
  LNt[49] = LNt[40]-LNt[45]+LNt[48];
  LNt[50] = float(LNP2x3[68]+LNt[49])-LNP2x3[68];	//[1,24]<<23
  LNt[49] -= LNt[50];
  LNt[51] = LNt[41]-LNt[46]+LNt[50];
  LNt[52] = a.z;
  LNt[53] = float(LNP2x3[53]+LNt[52])-LNP2x3[53];	//[22,53]<<0
  LNt[52] -= LNt[53];
  LNt[54] = float(LNP2x3[45]+LNt[52])-LNP2x3[45];	//[8,31]<<0
  LNt[52] -= LNt[54];
  LNt[55] = LNt[53]+LNt[54];
  LNt[56] = float(LNP2x3[68]+LNt[55])-LNP2x3[68];	//[7,30]<<23
  LNt[55] -= LNt[56];
  LNt[57] = e.z;
  LNt[58] = float(LNP2x3[53]+LNt[57])-LNP2x3[53];	//[22,53]<<0
  LNt[57] -= LNt[58];
  LNt[59] = float(LNP2x3[45]+LNt[57])-LNP2x3[45];	//[8,31]<<0
  LNt[57] -= LNt[59];
  LNt[60] = LNt[58]+LNt[59];
  LNt[61] = float(LNP2x3[68]+LNt[60])-LNP2x3[68];	//[7,30]<<23
  LNt[60] -= LNt[61];
  LNt[62] = LNt[52]-LNt[57];
  LNt[63] = float(LNP2x3[45]+LNt[62])-LNP2x3[45];	//[1,24]<<0
  LNt[62] -= LNt[63];
  LNt[64] = LNt[55]-LNt[60]+LNt[63];
  LNt[65] = float(LNP2x3[68]+LNt[64])-LNP2x3[68];	//[1,24]<<23
  LNt[64] -= LNt[65];
  LNt[66] = LNt[56]-LNt[61]+LNt[65];
  LNt[67] = b.x;
  LNt[68] = float(LNP2x3[53]+LNt[67])-LNP2x3[53];	//[22,53]<<0
  LNt[67] -= LNt[68];
  LNt[69] = float(LNP2x3[45]+LNt[67])-LNP2x3[45];	//[8,31]<<0
  LNt[67] -= LNt[69];
  LNt[70] = LNt[68]+LNt[69];
  LNt[71] = float(LNP2x3[68]+LNt[70])-LNP2x3[68];	//[7,30]<<23
  LNt[70] -= LNt[71];
  LNt[72] = b.y;
  LNt[73] = float(LNP2x3[53]+LNt[72])-LNP2x3[53];	//[22,53]<<0
  LNt[72] -= LNt[73];
  LNt[74] = float(LNP2x3[45]+LNt[72])-LNP2x3[45];	//[8,31]<<0
  LNt[72] -= LNt[74];
  LNt[75] = LNt[73]+LNt[74];
  LNt[76] = float(LNP2x3[68]+LNt[75])-LNP2x3[68];	//[7,30]<<23
  LNt[75] -= LNt[76];
  LNt[77] = LNt[67]*LNt[71]+LNt[70]*LNt[70]+LNt[71]*LNt[67]+LNt[72]*LNt[76]+LNt[75]*LNt[75]+LNt[76]*LNt[72];
  LNt[78] = b.z;
  LNt[79] = float(LNP2x3[53]+LNt[78])-LNP2x3[53];	//[22,53]<<0
  LNt[78] -= LNt[79];
  LNt[80] = float(LNP2x3[45]+LNt[78])-LNP2x3[45];	//[8,31]<<0
  LNt[78] -= LNt[80];
  LNt[81] = LNt[79]+LNt[80];
  LNt[82] = float(LNP2x3[68]+LNt[81])-LNP2x3[68];	//[7,30]<<23
  LNt[81] -= LNt[82];
  LNt[83] = LNt[67]*LNt[70]+LNt[70]*LNt[67]+LNt[72]*LNt[75]+LNt[75]*LNt[72]+LNt[78]*LNt[81]+LNt[81]*LNt[78];
  LNt[84] = LNt[70]*LNt[71]+LNt[71]*LNt[70]+LNt[75]*LNt[76]+LNt[76]*LNt[75]+LNt[81]*LNt[82]+LNt[82]*LNt[81];
  LNt[85] = b.w;
  LNt[86] = float(LNP2x3[74]+LNt[85])-LNP2x3[74];	//[1,53]<<0
  LNt[85] -= LNt[86];
  LNt[87] = LNt[67]*LNt[67]+LNt[72]*LNt[72]+LNt[78]*LNt[78]-LNt[85];
  LNt[88] = float(LNP2x3[74]+LNt[87])-LNP2x3[74];	//[1,53]<<0
  LNt[87] -= LNt[88];
  LNt[89] = LNt[28]*LNt[32]+LNt[31]*LNt[31]+LNt[32]*LNt[28]+LNt[42]*LNt[46]+LNt[45]*LNt[45]+LNt[46]*LNt[42];
  LNt[90] = LNt[28]*LNt[31]+LNt[31]*LNt[28]+LNt[42]*LNt[45]+LNt[45]*LNt[42]+LNt[57]*LNt[60]+LNt[60]*LNt[57];
  LNt[91] = LNt[31]*LNt[32]+LNt[32]*LNt[31]+LNt[45]*LNt[46]+LNt[46]*LNt[45]+LNt[60]*LNt[61]+LNt[61]*LNt[60];
  LNt[92] = e.w;
  LNt[93] = float(LNP2x3[74]+LNt[92])-LNP2x3[74];	//[1,53]<<0
  LNt[92] -= LNt[93];
  LNt[94] = LNt[28]*LNt[28]+LNt[42]*LNt[42]+LNt[57]*LNt[57]-LNt[92];
  LNt[95] = float(LNP2x3[74]+LNt[94])-LNP2x3[74];	//[1,53]<<0
  LNt[94] -= LNt[95];
  LNt[96] = LNt[90]-LNt[93]+LNt[95];
  LNt[97] = LNt[89]+LNt[57]*LNt[61]+LNt[60]*LNt[60]+LNt[61]*LNt[57];
  LNt[98] = LNt[32]*LNt[32]+LNt[46]*LNt[46]+LNt[61]*LNt[61];
  LNt[99] = LNt[87]-LNt[94];
  LNt[100] = float(LNP2x3[53]+LNt[99])-LNP2x3[53];	//[22,53]<<0
  LNt[99] -= LNt[100];
  LNt[101] = float(LNP2x3[45]+LNt[99])-LNP2x3[45];	//[8,31]<<0
  LNt[99] -= LNt[101];
  LNt[102] = LNt[83]-LNt[86]+LNt[88]-LNt[96]+LNt[100]+LNt[101];
  LNt[103] = float(LNP2x3[74]+LNt[102])-LNP2x3[74];	//[22,51]<<23
  LNt[102] -= LNt[103];
  LNt[104] = float(LNP2x3[68]+LNt[102])-LNP2x3[68];	//[6,29]<<23
  LNt[102] -= LNt[104];
  LNt[105] = LNt[77]+LNt[78]*LNt[82]+LNt[81]*LNt[81]+LNt[82]*LNt[78]-LNt[97]+LNt[103]+LNt[104];
  LNt[106] = float(LNP2x3[97]+LNt[105])-LNP2x3[97];	//[22,51]<<46
  LNt[105] -= LNt[106];
  LNt[107] = float(LNP2x3[91]+LNt[105])-LNP2x3[91];	//[6,29]<<46
  LNt[105] -= LNt[107];
  LNt[108] = LNt[84]-LNt[91]+LNt[106]+LNt[107];
  LNt[109] = float(LNP2x3[114]+LNt[108])-LNP2x3[114];	//[11,34]<<69
  LNt[108] -= LNt[109];
  LNt[110] = LNt[71]*LNt[71]+LNt[76]*LNt[76]+LNt[82]*LNt[82]-LNt[98]+LNt[109];
  LNt[111] = LNt[78]-LNt[57];
  LNt[112] = float(LNP2x3[45]+LNt[111])-LNP2x3[45];	//[1,24]<<0
  LNt[111] -= LNt[112];
  LNt[113] = LNt[81]-LNt[60]+LNt[112];
  LNt[114] = float(LNP2x3[68]+LNt[113])-LNP2x3[68];	//[1,24]<<23
  LNt[113] -= LNt[114];
  LNt[115] = LNt[82]-LNt[61]+LNt[114];
  LNt[116] = a.x;
  LNt[117] = float(LNP2x3[53]+LNt[116])-LNP2x3[53];	//[22,53]<<0
  LNt[116] -= LNt[117];
  LNt[118] = float(LNP2x3[45]+LNt[116])-LNP2x3[45];	//[8,31]<<0
  LNt[116] -= LNt[118];
  LNt[119] = LNt[117]+LNt[118];
  LNt[120] = float(LNP2x3[68]+LNt[119])-LNP2x3[68];	//[7,30]<<23
  LNt[119] -= LNt[120];
  LNt[121] = a.y;
  LNt[122] = float(LNP2x3[53]+LNt[121])-LNP2x3[53];	//[22,53]<<0
  LNt[121] -= LNt[122];
  LNt[123] = float(LNP2x3[45]+LNt[121])-LNP2x3[45];	//[8,31]<<0
  LNt[121] -= LNt[123];
  LNt[124] = LNt[122]+LNt[123];
  LNt[125] = float(LNP2x3[68]+LNt[124])-LNP2x3[68];	//[7,30]<<23
  LNt[124] -= LNt[125];
  LNt[126] = LNt[116]*LNt[120]+LNt[119]*LNt[119]+LNt[120]*LNt[116]+LNt[121]*LNt[125]+LNt[124]*LNt[124]+LNt[125]*LNt[121];
  LNt[127] = LNt[116]*LNt[119]+LNt[119]*LNt[116]+LNt[121]*LNt[124]+LNt[124]*LNt[121]+LNt[52]*LNt[55]+LNt[55]*LNt[52];
  LNt[128] = LNt[119]*LNt[120]+LNt[120]*LNt[119]+LNt[124]*LNt[125]+LNt[125]*LNt[124]+LNt[55]*LNt[56]+LNt[56]*LNt[55];
  LNt[129] = a.w;
  LNt[130] = float(LNP2x3[74]+LNt[129])-LNP2x3[74];	//[1,53]<<0
  LNt[129] -= LNt[130];
  LNt[131] = LNt[116]*LNt[116]+LNt[121]*LNt[121]+LNt[52]*LNt[52]-LNt[129];
  LNt[132] = float(LNP2x3[74]+LNt[131])-LNP2x3[74];	//[1,53]<<0
  LNt[131] -= LNt[132];
  LNt[133] = LNt[131]-LNt[94];
  LNt[134] = float(LNP2x3[53]+LNt[133])-LNP2x3[53];	//[22,53]<<0
  LNt[133] -= LNt[134];
  LNt[135] = float(LNP2x3[45]+LNt[133])-LNP2x3[45];	//[8,31]<<0
  LNt[133] -= LNt[135];
  LNt[136] = LNt[127]-LNt[130]+LNt[132]-LNt[96]+LNt[134]+LNt[135];
  LNt[137] = float(LNP2x3[74]+LNt[136])-LNP2x3[74];	//[22,51]<<23
  LNt[136] -= LNt[137];
  LNt[138] = float(LNP2x3[68]+LNt[136])-LNP2x3[68];	//[6,29]<<23
  LNt[136] -= LNt[138];
  LNt[139] = LNt[126]+LNt[52]*LNt[56]+LNt[55]*LNt[55]+LNt[56]*LNt[52]-LNt[97]+LNt[137]+LNt[138];
  LNt[140] = float(LNP2x3[97]+LNt[139])-LNP2x3[97];	//[22,51]<<46
  LNt[139] -= LNt[140];
  LNt[141] = float(LNP2x3[91]+LNt[139])-LNP2x3[91];	//[6,29]<<46
  LNt[139] -= LNt[141];
  LNt[142] = LNt[128]-LNt[91]+LNt[140]+LNt[141];
  LNt[143] = float(LNP2x3[114]+LNt[142])-LNP2x3[114];	//[11,34]<<69
  LNt[142] -= LNt[143];
  LNt[144] = LNt[120]*LNt[120]+LNt[125]*LNt[125]+LNt[56]*LNt[56]-LNt[98]+LNt[143];
  LNt[145] = LNt[62]*LNt[105]+LNt[64]*LNt[102]+LNt[66]*LNt[99]-(LNt[111]*LNt[139]+LNt[113]*LNt[136]+LNt[115]*LNt[133]);
  LNt[146] = LNt[62]*LNt[108]+LNt[64]*LNt[105]+LNt[66]*LNt[102]-(LNt[111]*LNt[142]+LNt[113]*LNt[139]+LNt[115]*LNt[136]);
  LNt[147] = LNt[62]*LNt[110]+LNt[64]*LNt[108]+LNt[66]*LNt[105]-(LNt[111]*LNt[144]+LNt[113]*LNt[142]+LNt[115]*LNt[139]);
  LNt[148] = LNt[62]*LNt[99]-LNt[111]*LNt[133];
  LNt[149] = float(LNP2x3[47]+LNt[148])-LNP2x3[47];	//[22,47]<<0
  LNt[148] -= LNt[149];
  LNt[150] = float(LNP2x3[45]+LNt[148])-LNP2x3[45];	//[2,25]<<0
  LNt[148] -= LNt[150];
  LNt[151] = LNt[62]*LNt[102]+LNt[64]*LNt[99]-(LNt[111]*LNt[136]+LNt[113]*LNt[133])+LNt[149]+LNt[150];
  LNt[152] = float(LNP2x3[71]+LNt[151])-LNP2x3[71];	//[22,48]<<23
  LNt[151] -= LNt[152];
  LNt[153] = float(LNP2x3[68]+LNt[151])-LNP2x3[68];	//[3,26]<<23
  LNt[151] -= LNt[153];
  LNt[154] = LNt[145]+LNt[152]+LNt[153];
  LNt[155] = float(LNP2x3[95]+LNt[154])-LNP2x3[95];	//[22,49]<<46
  LNt[154] -= LNt[155];
  LNt[156] = float(LNP2x3[91]+LNt[154])-LNP2x3[91];	//[4,27]<<46
  LNt[154] -= LNt[156];
  LNt[157] = LNt[146]+LNt[155]+LNt[156];
  LNt[158] = float(LNP2x3[118]+LNt[157])-LNP2x3[118];	//[22,49]<<69
  LNt[157] -= LNt[158];
  LNt[159] = float(LNP2x3[114]+LNt[157])-LNP2x3[114];	//[4,27]<<69
  LNt[157] -= LNt[159];
  LNt[160] = LNt[147]+LNt[158]+LNt[159];
  LNt[161] = (float(LNP2x3[125]+LNt[160]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[160] -= LNt[161];
  LNt[162] = (float(LNP2x3[125]+LNt[160]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[160] -= LNt[162];
  LNt[163] = LNt[64]*LNt[110]+LNt[66]*LNt[108]-(LNt[113]*LNt[144]+LNt[115]*LNt[142])+LNt[161]+LNt[162];
  LNt[164] = (float(LNP2x3[125]+LNt[163]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
  LNt[163] -= LNt[164];
  LNt[165] = LNt[66]*LNt[110]-LNt[115]*LNt[144]+LNt[164];
  LNt[166] = (float(LNP2x3[125]+LNt[165]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
  LNt[165] -= LNt[166];
  LNt[167] = c.z;
  LNt[168] = float(LNP2x3[53]+LNt[167])-LNP2x3[53];	//[22,53]<<0
  LNt[167] -= LNt[168];
  LNt[169] = float(LNP2x3[45]+LNt[167])-LNP2x3[45];	//[8,31]<<0
  LNt[167] -= LNt[169];
  LNt[170] = LNt[168]+LNt[169];
  LNt[171] = float(LNP2x3[68]+LNt[170])-LNP2x3[68];	//[7,30]<<23
  LNt[170] -= LNt[171];
  LNt[172] = LNt[167]-LNt[57];
  LNt[173] = float(LNP2x3[45]+LNt[172])-LNP2x3[45];	//[1,24]<<0
  LNt[172] -= LNt[173];
  LNt[174] = LNt[170]-LNt[60]+LNt[173];
  LNt[175] = float(LNP2x3[68]+LNt[174])-LNP2x3[68];	//[1,24]<<23
  LNt[174] -= LNt[175];
  LNt[176] = LNt[171]-LNt[61]+LNt[175];
  LNt[177] = LNt[121]-LNt[42];
  LNt[178] = float(LNP2x3[45]+LNt[177])-LNP2x3[45];	//[1,24]<<0
  LNt[177] -= LNt[178];
  LNt[179] = LNt[124]-LNt[45]+LNt[178];
  LNt[180] = float(LNP2x3[68]+LNt[179])-LNP2x3[68];	//[1,24]<<23
  LNt[179] -= LNt[180];
  LNt[181] = LNt[125]-LNt[46]+LNt[180];
  LNt[182] = LNt[72]-LNt[42];
  LNt[183] = float(LNP2x3[45]+LNt[182])-LNP2x3[45];	//[1,24]<<0
  LNt[182] -= LNt[183];
  LNt[184] = LNt[75]-LNt[45]+LNt[183];
  LNt[185] = float(LNP2x3[68]+LNt[184])-LNP2x3[68];	//[1,24]<<23
  LNt[184] -= LNt[185];
  LNt[186] = LNt[76]-LNt[46]+LNt[185];
  LNt[187] = LNt[177]*LNt[105]+LNt[179]*LNt[102]+LNt[181]*LNt[99]-(LNt[182]*LNt[139]+LNt[184]*LNt[136]+LNt[186]*LNt[133]);
  LNt[188] = LNt[177]*LNt[108]+LNt[179]*LNt[105]+LNt[181]*LNt[102]-(LNt[182]*LNt[142]+LNt[184]*LNt[139]+LNt[186]*LNt[136]);
  LNt[189] = LNt[177]*LNt[110]+LNt[179]*LNt[108]+LNt[181]*LNt[105]-(LNt[182]*LNt[144]+LNt[184]*LNt[142]+LNt[186]*LNt[139]);
  LNt[190] = LNt[177]*LNt[99]-LNt[182]*LNt[133];
  LNt[191] = float(LNP2x3[47]+LNt[190])-LNP2x3[47];	//[22,47]<<0
  LNt[190] -= LNt[191];
  LNt[192] = float(LNP2x3[45]+LNt[190])-LNP2x3[45];	//[2,25]<<0
  LNt[190] -= LNt[192];
  LNt[193] = LNt[177]*LNt[102]+LNt[179]*LNt[99]-(LNt[182]*LNt[136]+LNt[184]*LNt[133])+LNt[191]+LNt[192];
  LNt[194] = float(LNP2x3[71]+LNt[193])-LNP2x3[71];	//[22,48]<<23
  LNt[193] -= LNt[194];
  LNt[195] = float(LNP2x3[68]+LNt[193])-LNP2x3[68];	//[3,26]<<23
  LNt[193] -= LNt[195];
  LNt[196] = LNt[187]+LNt[194]+LNt[195];
  LNt[197] = float(LNP2x3[95]+LNt[196])-LNP2x3[95];	//[22,49]<<46
  LNt[196] -= LNt[197];
  LNt[198] = float(LNP2x3[91]+LNt[196])-LNP2x3[91];	//[4,27]<<46
  LNt[196] -= LNt[198];
  LNt[199] = LNt[188]+LNt[197]+LNt[198];
  LNt[200] = float(LNP2x3[118]+LNt[199])-LNP2x3[118];	//[22,49]<<69
  LNt[199] -= LNt[200];
  LNt[201] = float(LNP2x3[114]+LNt[199])-LNP2x3[114];	//[4,27]<<69
  LNt[199] -= LNt[201];
  LNt[202] = LNt[189]+LNt[200]+LNt[201];
  LNt[203] = (float(LNP2x3[125]+LNt[202]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[202] -= LNt[203];
  LNt[204] = (float(LNP2x3[125]+LNt[202]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[202] -= LNt[204];
  LNt[205] = LNt[179]*LNt[110]+LNt[181]*LNt[108]-(LNt[184]*LNt[144]+LNt[186]*LNt[142])+LNt[203]+LNt[204];
  LNt[206] = (float(LNP2x3[125]+LNt[205]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
  LNt[205] -= LNt[206];
  LNt[207] = LNt[181]*LNt[110]-LNt[186]*LNt[144]+LNt[206];
  LNt[208] = (float(LNP2x3[125]+LNt[207]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
  LNt[207] -= LNt[208];
  LNt[209] = LNt[47]*LNt[154]+LNt[49]*LNt[151]+LNt[51]*LNt[148]-(LNt[172]*LNt[196]+LNt[174]*LNt[193]+LNt[176]*LNt[190]);
  LNt[210] = LNt[47]*LNt[157]+LNt[49]*LNt[154]+LNt[51]*LNt[151]-(LNt[172]*LNt[199]+LNt[174]*LNt[196]+LNt[176]*LNt[193]);
  LNt[211] = LNt[47]*LNt[160]+LNt[49]*LNt[157]+LNt[51]*LNt[154]-(LNt[172]*LNt[202]+LNt[174]*LNt[199]+LNt[176]*LNt[196]);
  LNt[212] = LNt[47]*LNt[163]+LNt[49]*LNt[160]+LNt[51]*LNt[157]-(LNt[172]*LNt[205]+LNt[174]*LNt[202]+LNt[176]*LNt[199]);
  LNt[213] = LNt[47]*LNt[165]+LNt[49]*LNt[163]+LNt[51]*LNt[160]-(LNt[172]*LNt[207]+LNt[174]*LNt[205]+LNt[176]*LNt[202]);
  LNt[214] = LNt[47]*LNt[166]+LNt[49]*LNt[165]+LNt[51]*LNt[163]-(LNt[172]*LNt[208]+LNt[174]*LNt[207]+LNt[176]*LNt[205]);
  LNt[215] = c.x;
  LNt[216] = float(LNP2x3[53]+LNt[215])-LNP2x3[53];	//[22,53]<<0
  LNt[215] -= LNt[216];
  LNt[217] = float(LNP2x3[45]+LNt[215])-LNP2x3[45];	//[8,31]<<0
  LNt[215] -= LNt[217];
  LNt[218] = LNt[216]+LNt[217];
  LNt[219] = float(LNP2x3[68]+LNt[218])-LNP2x3[68];	//[7,30]<<23
  LNt[218] -= LNt[219];
  LNt[220] = LNt[215]*LNt[219]+LNt[218]*LNt[218]+LNt[219]*LNt[215]+LNt[37]*LNt[41]+LNt[40]*LNt[40]+LNt[41]*LNt[37];
  LNt[221] = LNt[215]*LNt[218]+LNt[218]*LNt[215]+LNt[37]*LNt[40]+LNt[40]*LNt[37]+LNt[167]*LNt[170]+LNt[170]*LNt[167];
  LNt[222] = LNt[218]*LNt[219]+LNt[219]*LNt[218]+LNt[40]*LNt[41]+LNt[41]*LNt[40]+LNt[170]*LNt[171]+LNt[171]*LNt[170];
  LNt[223] = c.w;
  LNt[224] = float(LNP2x3[74]+LNt[223])-LNP2x3[74];	//[1,53]<<0
  LNt[223] -= LNt[224];
  LNt[225] = LNt[215]*LNt[215]+LNt[37]*LNt[37]+LNt[167]*LNt[167]-LNt[223];
  LNt[226] = float(LNP2x3[74]+LNt[225])-LNP2x3[74];	//[1,53]<<0
  LNt[225] -= LNt[226];
  LNt[227] = LNt[225]-LNt[94];
  LNt[228] = float(LNP2x3[53]+LNt[227])-LNP2x3[53];	//[22,53]<<0
  LNt[227] -= LNt[228];
  LNt[229] = float(LNP2x3[45]+LNt[227])-LNP2x3[45];	//[8,31]<<0
  LNt[227] -= LNt[229];
  LNt[230] = LNt[221]-LNt[224]+LNt[226]-LNt[96]+LNt[228]+LNt[229];
  LNt[231] = float(LNP2x3[74]+LNt[230])-LNP2x3[74];	//[22,51]<<23
  LNt[230] -= LNt[231];
  LNt[232] = float(LNP2x3[68]+LNt[230])-LNP2x3[68];	//[6,29]<<23
  LNt[230] -= LNt[232];
  LNt[233] = LNt[220]+LNt[167]*LNt[171]+LNt[170]*LNt[170]+LNt[171]*LNt[167]-LNt[97]+LNt[231]+LNt[232];
  LNt[234] = float(LNP2x3[97]+LNt[233])-LNP2x3[97];	//[22,51]<<46
  LNt[233] -= LNt[234];
  LNt[235] = float(LNP2x3[91]+LNt[233])-LNP2x3[91];	//[6,29]<<46
  LNt[233] -= LNt[235];
  LNt[236] = LNt[222]-LNt[91]+LNt[234]+LNt[235];
  LNt[237] = float(LNP2x3[114]+LNt[236])-LNP2x3[114];	//[11,34]<<69
  LNt[236] -= LNt[237];
  LNt[238] = LNt[219]*LNt[219]+LNt[41]*LNt[41]+LNt[171]*LNt[171]-LNt[98]+LNt[237];
  LNt[239] = LNt[177]*LNt[115]+LNt[179]*LNt[113]+LNt[181]*LNt[111]-(LNt[182]*LNt[66]+LNt[184]*LNt[64]+LNt[186]*LNt[62]);
  LNt[240] = LNt[177]*LNt[111]-LNt[182]*LNt[62];
  LNt[241] = float(LNP2x3[47]+LNt[240])-LNP2x3[47];	//[22,47]<<0
  LNt[240] -= LNt[241];
  LNt[242] = float(LNP2x3[45]+LNt[240])-LNP2x3[45];	//[2,25]<<0
  LNt[240] -= LNt[242];
  LNt[243] = LNt[177]*LNt[113]+LNt[179]*LNt[111]-(LNt[182]*LNt[64]+LNt[184]*LNt[62])+LNt[241]+LNt[242];
  LNt[244] = float(LNP2x3[71]+LNt[243])-LNP2x3[71];	//[22,48]<<23
  LNt[243] -= LNt[244];
  LNt[245] = float(LNP2x3[68]+LNt[243])-LNP2x3[68];	//[3,26]<<23
  LNt[243] -= LNt[245];
  LNt[246] = LNt[239]+LNt[244]+LNt[245];
  LNt[247] = float(LNP2x3[95]+LNt[246])-LNP2x3[95];	//[22,49]<<46
  LNt[246] -= LNt[247];
  LNt[248] = float(LNP2x3[91]+LNt[246])-LNP2x3[91];	//[4,27]<<46
  LNt[246] -= LNt[248];
  LNt[249] = LNt[179]*LNt[115]+LNt[181]*LNt[113]-(LNt[184]*LNt[66]+LNt[186]*LNt[64])+LNt[247]+LNt[248];
  LNt[250] = float(LNP2x3[114]+LNt[249])-LNP2x3[114];	//[10,33]<<69
  LNt[249] -= LNt[250];
  LNt[251] = LNt[181]*LNt[115]-LNt[186]*LNt[66]+LNt[250];
  LNt[252] = LNt[227]*LNt[251]+LNt[230]*LNt[249]+LNt[233]*LNt[246]+LNt[236]*LNt[243]+LNt[238]*LNt[240];
  LNt[253] = LNt[47]*LNt[151]+LNt[49]*LNt[148]-(LNt[172]*LNt[193]+LNt[174]*LNt[190])+LNt[227]*LNt[243]+LNt[230]*LNt[240];
  LNt[254] = LNt[49]*LNt[166]+LNt[51]*LNt[165]-(LNt[174]*LNt[208]+LNt[176]*LNt[207])+LNt[238]*LNt[251];
  LNt[255] = LNt[47]*LNt[148]-LNt[172]*LNt[190]+LNt[227]*LNt[240];
  LNt[256] = float(LNP2x3[48]+LNt[255])-LNP2x3[48];	//[22,48]<<0
  LNt[255] -= LNt[256];
  LNt[257] = float(LNP2x3[45]+LNt[255])-LNP2x3[45];	//[3,26]<<0
  LNt[255] -= LNt[257];
  LNt[258] = LNt[253]+LNt[256]+LNt[257];
  LNt[259] = float(LNP2x3[72]+LNt[258])-LNP2x3[72];	//[22,49]<<23
  LNt[258] -= LNt[259];
  LNt[260] = float(LNP2x3[68]+LNt[258])-LNP2x3[68];	//[4,27]<<23
  LNt[258] -= LNt[260];
  LNt[261] = LNt[209]+LNt[227]*LNt[246]+LNt[230]*LNt[243]+LNt[233]*LNt[240]+LNt[259]+LNt[260];
  LNt[262] = float(LNP2x3[96]+LNt[261])-LNP2x3[96];	//[22,50]<<46
  LNt[261] -= LNt[262];
  LNt[263] = float(LNP2x3[91]+LNt[261])-LNP2x3[91];	//[5,28]<<46
  LNt[261] -= LNt[263];
  LNt[264] = LNt[210]+LNt[227]*LNt[249]+LNt[230]*LNt[246]+LNt[233]*LNt[243]+LNt[236]*LNt[240]+LNt[262]+LNt[263];
  LNt[265] = float(LNP2x3[119]+LNt[264])-LNP2x3[119];	//[22,50]<<69
  LNt[264] -= LNt[265];
  LNt[266] = float(LNP2x3[114]+LNt[264])-LNP2x3[114];	//[5,28]<<69
  LNt[264] -= LNt[266];
  LNt[267] = LNt[211]+LNt[252]+LNt[265]+LNt[266];
  LNt[268] = (float(LNP2x3[125]+LNt[267]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[267] -= LNt[268];
  LNt[269] = (float(LNP2x3[125]+LNt[267]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[267] -= LNt[269];
  LNt[270] = LNt[212]+LNt[230]*LNt[251]+LNt[233]*LNt[249]+LNt[236]*LNt[246]+LNt[238]*LNt[243]+LNt[268]+LNt[269];
  LNt[271] = (float(LNP2x3[125]+LNt[270]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[270] -= LNt[271];
  LNt[272] = (float(LNP2x3[125]+LNt[270]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[270] -= LNt[272];
  LNt[273] = LNt[213]+LNt[233]*LNt[251]+LNt[236]*LNt[249]+LNt[238]*LNt[246]+LNt[271]+LNt[272];
  LNt[274] = (float(LNP2x3[125]+LNt[273]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
  LNt[273] -= LNt[274];
  LNt[275] = (float(LNP2x3[125]+LNt[273]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
  LNt[273] -= LNt[275];
  LNt[276] = LNt[214]+LNt[236]*LNt[251]+LNt[238]*LNt[249]+LNt[274]+LNt[275];
  LNt[277] = (float(LNP2x3[125]+LNt[276]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
  LNt[276] -= LNt[277];
  LNt[278] = (float(LNP2x3[125]+LNt[276]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
  LNt[276] -= LNt[278];
  LNt[279] = LNt[254]+LNt[277]+LNt[278];
  LNt[280] = (float(LNP2x3[125]+LNt[279]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
  LNt[279] -= LNt[280];
  LNt[281] = LNt[51]*LNt[166]-LNt[176]*LNt[208]+LNt[280];
  LNt[282] = 0.0-(LNt[27]-LNt[32])+LNt[36];
  LNt[283] = d.y;
  LNt[284] = float(LNP2x3[53]+LNt[283])-LNP2x3[53];	//[22,53]<<0
  LNt[283] -= LNt[284];
  LNt[285] = float(LNP2x3[45]+LNt[283])-LNP2x3[45];	//[8,31]<<0
  LNt[283] -= LNt[285];
  LNt[286] = LNt[284]+LNt[285];
  LNt[287] = float(LNP2x3[68]+LNt[286])-LNP2x3[68];	//[7,30]<<23
  LNt[286] -= LNt[287];
  LNt[288] = LNt[283]-LNt[42];
  LNt[289] = float(LNP2x3[45]+LNt[288])-LNP2x3[45];	//[1,24]<<0
  LNt[288] -= LNt[289];
  LNt[290] = LNt[286]-LNt[45]+LNt[289];
  LNt[291] = float(LNP2x3[68]+LNt[290])-LNP2x3[68];	//[1,24]<<23
  LNt[290] -= LNt[291];
  LNt[292] = LNt[215]-LNt[28];
  LNt[293] = float(LNP2x3[45]+LNt[292])-LNP2x3[45];	//[1,24]<<0
  LNt[292] -= LNt[293];
  LNt[294] = LNt[218]-LNt[31]+LNt[293];
  LNt[295] = float(LNP2x3[68]+LNt[294])-LNP2x3[68];	//[1,24]<<23
  LNt[294] -= LNt[295];
  LNt[296] = LNt[219]-LNt[32]+LNt[295];
  LNt[297] = LNt[116]-LNt[28];
  LNt[298] = float(LNP2x3[45]+LNt[297])-LNP2x3[45];	//[1,24]<<0
  LNt[297] -= LNt[298];
  LNt[299] = LNt[119]-LNt[31]+LNt[298];
  LNt[300] = float(LNP2x3[68]+LNt[299])-LNP2x3[68];	//[1,24]<<23
  LNt[299] -= LNt[300];
  LNt[301] = LNt[120]-LNt[32]+LNt[300];
  LNt[302] = LNt[67]-LNt[28];
  LNt[303] = float(LNP2x3[45]+LNt[302])-LNP2x3[45];	//[1,24]<<0
  LNt[302] -= LNt[303];
  LNt[304] = LNt[70]-LNt[31]+LNt[303];
  LNt[305] = float(LNP2x3[68]+LNt[304])-LNP2x3[68];	//[1,24]<<23
  LNt[304] -= LNt[305];
  LNt[306] = LNt[71]-LNt[32]+LNt[305];
  LNt[307] = LNt[297]*LNt[105]+LNt[299]*LNt[102]+LNt[301]*LNt[99]-(LNt[133]*LNt[306]+LNt[136]*LNt[304]+LNt[139]*LNt[302]);
  LNt[308] = LNt[297]*LNt[108]+LNt[299]*LNt[105]+LNt[301]*LNt[102]-(LNt[136]*LNt[306]+LNt[139]*LNt[304]+LNt[142]*LNt[302]);
  LNt[309] = LNt[297]*LNt[110]+LNt[299]*LNt[108]+LNt[301]*LNt[105]-(LNt[139]*LNt[306]+LNt[142]*LNt[304]+LNt[144]*LNt[302]);
  LNt[310] = LNt[297]*LNt[99]-LNt[133]*LNt[302];
  LNt[311] = float(LNP2x3[47]+LNt[310])-LNP2x3[47];	//[22,47]<<0
  LNt[310] -= LNt[311];
  LNt[312] = float(LNP2x3[45]+LNt[310])-LNP2x3[45];	//[2,25]<<0
  LNt[310] -= LNt[312];
  LNt[313] = LNt[297]*LNt[102]+LNt[299]*LNt[99]-(LNt[133]*LNt[304]+LNt[136]*LNt[302])+LNt[311]+LNt[312];
  LNt[314] = float(LNP2x3[71]+LNt[313])-LNP2x3[71];	//[22,48]<<23
  LNt[313] -= LNt[314];
  LNt[315] = float(LNP2x3[68]+LNt[313])-LNP2x3[68];	//[3,26]<<23
  LNt[313] -= LNt[315];
  LNt[316] = LNt[307]+LNt[314]+LNt[315];
  LNt[317] = float(LNP2x3[95]+LNt[316])-LNP2x3[95];	//[22,49]<<46
  LNt[316] -= LNt[317];
  LNt[318] = float(LNP2x3[91]+LNt[316])-LNP2x3[91];	//[4,27]<<46
  LNt[316] -= LNt[318];
  LNt[319] = LNt[308]+LNt[317]+LNt[318];
  LNt[320] = float(LNP2x3[118]+LNt[319])-LNP2x3[118];	//[22,49]<<69
  LNt[319] -= LNt[320];
  LNt[321] = float(LNP2x3[114]+LNt[319])-LNP2x3[114];	//[4,27]<<69
  LNt[319] -= LNt[321];
  LNt[322] = LNt[309]+LNt[320]+LNt[321];
  LNt[323] = (float(LNP2x3[125]+LNt[322]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
  LNt[322] -= LNt[323];
  LNt[324] = (float(LNP2x3[125]+LNt[322]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
  LNt[322] -= LNt[324];
  LNt[325] = LNt[299]*LNt[110]+LNt[301]*LNt[108]-(LNt[142]*LNt[306]+LNt[144]*LNt[304])+LNt[323]+LNt[324];
  LNt[326] = (float(LNP2x3[125]+LNt[325]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
  LNt[325] -= LNt[326];
  LNt[327] = LNt[301]*LNt[110]-LNt[144]*LNt[306]+LNt[326];
  LNt[328] = (float(LNP2x3[125]+LNt[327]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
  LNt[327] -= LNt[328];
  LNt[329] = LNt[292]*LNt[154]+LNt[294]*LNt[151]+LNt[296]*LNt[148]-(LNt[172]*LNt[316]+LNt[174]*LNt[313]+LNt[176]*LNt[310]);
  LNt[330] = LNt[292]*LNt[157]+LNt[294]*LNt[154]+LNt[296]*LNt[151]-(LNt[172]*LNt[319]+LNt[174]*LNt[316]+LNt[176]*LNt[313]);
  LNt[331] = LNt[292]*LNt[160]+LNt[294]*LNt[157]+LNt[296]*LNt[154]-(LNt[172]*LNt[322]+LNt[174]*LNt[319]+LNt[176]*LNt[316]);
  LNt[332] = LNt[292]*LNt[163]+LNt[294]*LNt[160]+LNt[296]*LNt[157]-(LNt[172]*LNt[325]+LNt[174]*LNt[322]+LNt[176]*LNt[319]);
  LNt[333] = LNt[292]*LNt[165]+LNt[294]*LNt[163]+LNt[296]*LNt[160]-(LNt[172]*LNt[327]+LNt[174]*LNt[325]+LNt[176]*LNt[322]);
  LNt[334] = LNt[292]*LNt[166]+LNt[294]*LNt[165]+LNt[296]*LNt[163]-(LNt[172]*LNt[328]+LNt[174]*LNt[327]+LNt[176]*LNt[325]);
  LNt[335] = LNt[297]*LNt[115]+LNt[299]*LNt[113]+LNt[301]*LNt[111]-(LNt[62]*LNt[306]+LNt[64]*LNt[304]+LNt[66]*LNt[302]);
  LNt[336] = LNt[297]*LNt[111]-LNt[62]*LNt[302];
  LNt[337] = float(LNP2x3[47]+LNt[336])-LNP2x3[47];	//[22,47]<<0
  LNt[336] -= LNt[337];
  LNt[338] = float(LNP2x3[45]+LNt[336])-LNP2x3[45];	//[2,25]<<0
  LNt[336] -= LNt[338];
  LNt[339] = LNt[297]*LNt[113]+LNt[299]*LNt[111]-(LNt[62]*LNt[304]+LNt[64]*LNt[302])+LNt[337]+LNt[338];
  LNt[340] = float(LNP2x3[71]+LNt[339])-LNP2x3[71];	//[22,48]<<23
  LNt[339] -= LNt[340];
  LNt[341] = float(LNP2x3[68]+LNt[339])-LNP2x3[68];	//[3,26]<<23
  LNt[339] -= LNt[341];
  LNt[342] = LNt[335]+LNt[340]+LNt[341];
  LNt[343] = float(LNP2x3[95]+LNt[342])-LNP2x3[95];	//[22,49]<<46
  LNt[342] -= LNt[343];
  LNt[344] = float(LNP2x3[91]+LNt[342])-LNP2x3[91];	//[4,27]<<46
  LNt[342] -= LNt[344];
  LNt[345] = LNt[299]*LNt[115]+LNt[301]*LNt[113]-(LNt[64]*LNt[306]+LNt[66]*LNt[304])+LNt[343]+LNt[344];
  LNt[346] = float(LNP2x3[114]+LNt[345])-LNP2x3[114];	//[10,33]<<69
  LNt[345] -= LNt[346];
  LNt[347] = LNt[301]*LNt[115]-LNt[66]*LNt[306]+LNt[346];
  LNt[348] = LNt[227]*LNt[347]+LNt[230]*LNt[345]+LNt[233]*LNt[342]+LNt[236]*LNt[339]+LNt[238]*LNt[336];
  LNt[349] = LNt[292]*LNt[151]+LNt[294]*LNt[148]-(LNt[172]*LNt[313]+LNt[174]*LNt[310])+LNt[227]*LNt[339]+LNt[230]*LNt[336];
  LNt[350] = LNt[294]*LNt[166]+LNt[296]*LNt[165]-(LNt[174]*LNt[328]+LNt[176]*LNt[327])+LNt[238]*LNt[347];
  LNt[351] = LNt[292]*LNt[148]-LNt[172]*LNt[310]+LNt[227]*LNt[336];
  LNt[352] = float(LNP2x3[48]+LNt[351])-LNP2x3[48];	//[22,48]<<0
  LNt[351] -= LNt[352];
  LNt[353] = float(LNP2x3[45]+LNt[351])-LNP2x3[45];	//[3,26]<<0
  LNt[351] -= LNt[353];
  LNt[354] = LNt[349]+LNt[352]+LNt[353];
  LNt[355] = float(LNP2x3[72]+LNt[354])-LNP2x3[72];	//[22,49]<<23
  LNt[354] -= LNt[355];
  LNt[356] = float(LNP2x3[68]+LNt[354])-LNP2x3[68];	//[4,27]<<23
  LNt[354] -= LNt[356];
  LNt[357] = LNt[329]+LNt[227]*LNt[342]+LNt[230]*LNt[339]+LNt[233]*LNt[336]+LNt[355]+LNt[356];
  LNt[358] = float(LNP2x3[96]+LNt[357])-LNP2x3[96];	//[22,50]<<46
  LNt[357] -= LNt[358];
  LNt[359] = float(LNP2x3[91]+LNt[357])-LNP2x3[91];	//[5,28]<<46
  LNt[357] -= LNt[359];
  LNt[360] = LNt[330]+LNt[227]*LNt[345]+LNt[230]*LNt[342]+LNt[233]*LNt[339]+LNt[236]*LNt[336]+LNt[358]+LNt[359];
  LNt[361] = float(LNP2x3[119]+LNt[360])-LNP2x3[119];	//[22,50]<<69
  LNt[360] -= LNt[361];
  LNt[362] = float(LNP2x3[114]+LNt[360])-LNP2x3[114];	//[5,28]<<69
  LNt[360] -= LNt[362];
  LNt[363] = LNt[331]+LNt[348]+LNt[361]+LNt[362];
  LNt[364] = (float(LNP2x3[125]+LNt[363]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[363] -= LNt[364];
  LNt[365] = (float(LNP2x3[125]+LNt[363]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[363] -= LNt[365];
  LNt[366] = LNt[332]+LNt[230]*LNt[347]+LNt[233]*LNt[345]+LNt[236]*LNt[342]+LNt[238]*LNt[339]+LNt[364]+LNt[365];
  LNt[367] = (float(LNP2x3[125]+LNt[366]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[366] -= LNt[367];
  LNt[368] = (float(LNP2x3[125]+LNt[366]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[366] -= LNt[368];
  LNt[369] = LNt[333]+LNt[233]*LNt[347]+LNt[236]*LNt[345]+LNt[238]*LNt[342]+LNt[367]+LNt[368];
  LNt[370] = (float(LNP2x3[125]+LNt[369]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
  LNt[369] -= LNt[370];
  LNt[371] = (float(LNP2x3[125]+LNt[369]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
  LNt[369] -= LNt[371];
  LNt[372] = LNt[334]+LNt[236]*LNt[347]+LNt[238]*LNt[345]+LNt[370]+LNt[371];
  LNt[373] = (float(LNP2x3[125]+LNt[372]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
  LNt[372] -= LNt[373];
  LNt[374] = (float(LNP2x3[125]+LNt[372]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
  LNt[372] -= LNt[374];
  LNt[375] = LNt[350]+LNt[373]+LNt[374];
  LNt[376] = (float(LNP2x3[125]+LNt[375]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
  LNt[375] -= LNt[376];
  LNt[377] = LNt[296]*LNt[166]-LNt[176]*LNt[328]+LNt[376];
  LNt[378] = LNt[287]-LNt[46]+LNt[291];
  LNt[379] = LNt[33]*LNt[261]+LNt[35]*LNt[258]+LNt[282]*LNt[255]+LNt[288]*LNt[357]+LNt[290]*LNt[354]+LNt[378]*LNt[351];
  LNt[380] = LNt[33]*LNt[264]+LNt[35]*LNt[261]+LNt[282]*LNt[258]+LNt[288]*LNt[360]+LNt[290]*LNt[357]+LNt[378]*LNt[354];
  LNt[381] = LNt[33]*LNt[267]+LNt[35]*LNt[264]+LNt[282]*LNt[261]+LNt[288]*LNt[363]+LNt[290]*LNt[360]+LNt[378]*LNt[357];
  LNt[382] = LNt[33]*LNt[270]+LNt[35]*LNt[267]+LNt[282]*LNt[264]+LNt[288]*LNt[366]+LNt[290]*LNt[363]+LNt[378]*LNt[360];
  LNt[383] = LNt[33]*LNt[273]+LNt[35]*LNt[270]+LNt[282]*LNt[267]+LNt[288]*LNt[369]+LNt[290]*LNt[366]+LNt[378]*LNt[363];
  LNt[384] = LNt[33]*LNt[276]+LNt[35]*LNt[273]+LNt[282]*LNt[270]+LNt[288]*LNt[372]+LNt[290]*LNt[369]+LNt[378]*LNt[366];
  LNt[385] = LNt[33]*LNt[279]+LNt[35]*LNt[276]+LNt[282]*LNt[273]+LNt[288]*LNt[375]+LNt[290]*LNt[372]+LNt[378]*LNt[369];
  LNt[386] = LNt[33]*LNt[281]+LNt[35]*LNt[279]+LNt[282]*LNt[276]+LNt[288]*LNt[377]+LNt[290]*LNt[375]+LNt[378]*LNt[372];
  LNt[387] = d.z;
  LNt[388] = float(LNP2x3[53]+LNt[387])-LNP2x3[53];	//[22,53]<<0
  LNt[387] -= LNt[388];
  LNt[389] = float(LNP2x3[45]+LNt[387])-LNP2x3[45];	//[8,31]<<0
  LNt[387] -= LNt[389];
  LNt[390] = LNt[388]+LNt[389];
  LNt[391] = float(LNP2x3[68]+LNt[390])-LNP2x3[68];	//[7,30]<<23
  LNt[390] -= LNt[391];
  LNt[392] = LNt[387]-LNt[57];
  LNt[393] = float(LNP2x3[45]+LNt[392])-LNP2x3[45];	//[1,24]<<0
  LNt[392] -= LNt[393];
  LNt[394] = LNt[390]-LNt[60]+LNt[393];
  LNt[395] = float(LNP2x3[68]+LNt[394])-LNP2x3[68];	//[1,24]<<23
  LNt[394] -= LNt[395];
  LNt[396] = LNt[292]*LNt[196]+LNt[294]*LNt[193]+LNt[296]*LNt[190]-(LNt[47]*LNt[316]+LNt[49]*LNt[313]+LNt[51]*LNt[310]);
  LNt[397] = LNt[292]*LNt[199]+LNt[294]*LNt[196]+LNt[296]*LNt[193]-(LNt[47]*LNt[319]+LNt[49]*LNt[316]+LNt[51]*LNt[313]);
  LNt[398] = LNt[292]*LNt[202]+LNt[294]*LNt[199]+LNt[296]*LNt[196]-(LNt[47]*LNt[322]+LNt[49]*LNt[319]+LNt[51]*LNt[316]);
  LNt[399] = LNt[292]*LNt[205]+LNt[294]*LNt[202]+LNt[296]*LNt[199]-(LNt[47]*LNt[325]+LNt[49]*LNt[322]+LNt[51]*LNt[319]);
  LNt[400] = LNt[292]*LNt[207]+LNt[294]*LNt[205]+LNt[296]*LNt[202]-(LNt[47]*LNt[327]+LNt[49]*LNt[325]+LNt[51]*LNt[322]);
  LNt[401] = LNt[292]*LNt[208]+LNt[294]*LNt[207]+LNt[296]*LNt[205]-(LNt[47]*LNt[328]+LNt[49]*LNt[327]+LNt[51]*LNt[325]);
  LNt[402] = LNt[297]*LNt[186]+LNt[299]*LNt[184]+LNt[301]*LNt[182]-(LNt[177]*LNt[306]+LNt[179]*LNt[304]+LNt[181]*LNt[302]);
  LNt[403] = LNt[297]*LNt[182]-LNt[177]*LNt[302];
  LNt[404] = float(LNP2x3[47]+LNt[403])-LNP2x3[47];	//[22,47]<<0
  LNt[403] -= LNt[404];
  LNt[405] = float(LNP2x3[45]+LNt[403])-LNP2x3[45];	//[2,25]<<0
  LNt[403] -= LNt[405];
  LNt[406] = LNt[297]*LNt[184]+LNt[299]*LNt[182]-(LNt[177]*LNt[304]+LNt[179]*LNt[302])+LNt[404]+LNt[405];
  LNt[407] = float(LNP2x3[71]+LNt[406])-LNP2x3[71];	//[22,48]<<23
  LNt[406] -= LNt[407];
  LNt[408] = float(LNP2x3[68]+LNt[406])-LNP2x3[68];	//[3,26]<<23
  LNt[406] -= LNt[408];
  LNt[409] = LNt[402]+LNt[407]+LNt[408];
  LNt[410] = float(LNP2x3[95]+LNt[409])-LNP2x3[95];	//[22,49]<<46
  LNt[409] -= LNt[410];
  LNt[411] = float(LNP2x3[91]+LNt[409])-LNP2x3[91];	//[4,27]<<46
  LNt[409] -= LNt[411];
  LNt[412] = LNt[299]*LNt[186]+LNt[301]*LNt[184]-(LNt[179]*LNt[306]+LNt[181]*LNt[304])+LNt[410]+LNt[411];
  LNt[413] = float(LNP2x3[114]+LNt[412])-LNP2x3[114];	//[10,33]<<69
  LNt[412] -= LNt[413];
  LNt[414] = LNt[301]*LNt[186]-LNt[181]*LNt[306]+LNt[413];
  LNt[415] = LNt[227]*LNt[414]+LNt[230]*LNt[412]+LNt[233]*LNt[409]+LNt[236]*LNt[406]+LNt[238]*LNt[403];
  LNt[416] = LNt[292]*LNt[193]+LNt[294]*LNt[190]-(LNt[47]*LNt[313]+LNt[49]*LNt[310])+LNt[227]*LNt[406]+LNt[230]*LNt[403];
  LNt[417] = LNt[294]*LNt[208]+LNt[296]*LNt[207]-(LNt[49]*LNt[328]+LNt[51]*LNt[327])+LNt[238]*LNt[414];
  LNt[418] = LNt[292]*LNt[190]-LNt[47]*LNt[310]+LNt[227]*LNt[403];
  LNt[419] = float(LNP2x3[48]+LNt[418])-LNP2x3[48];	//[22,48]<<0
  LNt[418] -= LNt[419];
  LNt[420] = float(LNP2x3[45]+LNt[418])-LNP2x3[45];	//[3,26]<<0
  LNt[418] -= LNt[420];
  LNt[421] = LNt[416]+LNt[419]+LNt[420];
  LNt[422] = float(LNP2x3[72]+LNt[421])-LNP2x3[72];	//[22,49]<<23
  LNt[421] -= LNt[422];
  LNt[423] = float(LNP2x3[68]+LNt[421])-LNP2x3[68];	//[4,27]<<23
  LNt[421] -= LNt[423];
  LNt[424] = LNt[396]+LNt[227]*LNt[409]+LNt[230]*LNt[406]+LNt[233]*LNt[403]+LNt[422]+LNt[423];
  LNt[425] = float(LNP2x3[96]+LNt[424])-LNP2x3[96];	//[22,50]<<46
  LNt[424] -= LNt[425];
  LNt[426] = float(LNP2x3[91]+LNt[424])-LNP2x3[91];	//[5,28]<<46
  LNt[424] -= LNt[426];
  LNt[427] = LNt[397]+LNt[227]*LNt[412]+LNt[230]*LNt[409]+LNt[233]*LNt[406]+LNt[236]*LNt[403]+LNt[425]+LNt[426];
  LNt[428] = float(LNP2x3[119]+LNt[427])-LNP2x3[119];	//[22,50]<<69
  LNt[427] -= LNt[428];
  LNt[429] = float(LNP2x3[114]+LNt[427])-LNP2x3[114];	//[5,28]<<69
  LNt[427] -= LNt[429];
  LNt[430] = LNt[398]+LNt[415]+LNt[428]+LNt[429];
  LNt[431] = (float(LNP2x3[125]+LNt[430]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[430] -= LNt[431];
  LNt[432] = (float(LNP2x3[125]+LNt[430]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[430] -= LNt[432];
  LNt[433] = LNt[399]+LNt[230]*LNt[414]+LNt[233]*LNt[412]+LNt[236]*LNt[409]+LNt[238]*LNt[406]+LNt[431]+LNt[432];
  LNt[434] = (float(LNP2x3[125]+LNt[433]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[433] -= LNt[434];
  LNt[435] = (float(LNP2x3[125]+LNt[433]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[433] -= LNt[435];
  LNt[436] = LNt[400]+LNt[233]*LNt[414]+LNt[236]*LNt[412]+LNt[238]*LNt[409]+LNt[434]+LNt[435];
  LNt[437] = (float(LNP2x3[125]+LNt[436]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
  LNt[436] -= LNt[437];
  LNt[438] = (float(LNP2x3[125]+LNt[436]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
  LNt[436] -= LNt[438];
  LNt[439] = LNt[401]+LNt[236]*LNt[414]+LNt[238]*LNt[412]+LNt[437]+LNt[438];
  LNt[440] = (float(LNP2x3[125]+LNt[439]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
  LNt[439] -= LNt[440];
  LNt[441] = (float(LNP2x3[125]+LNt[439]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
  LNt[439] -= LNt[441];
  LNt[442] = LNt[417]+LNt[440]+LNt[441];
  LNt[443] = (float(LNP2x3[125]+LNt[442]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
  LNt[442] -= LNt[443];
  LNt[444] = LNt[296]*LNt[208]-LNt[51]*LNt[328]+LNt[443];
  LNt[445] = LNt[391]-LNt[61]+LNt[395];
  LNt[446] = LNt[33]*LNt[258]+LNt[35]*LNt[255]+LNt[288]*LNt[354]+LNt[290]*LNt[351]-(LNt[392]*LNt[421]+LNt[394]*LNt[418]);
  LNt[447] = LNt[35]*LNt[281]+LNt[282]*LNt[279]+LNt[290]*LNt[377]+LNt[378]*LNt[375]-(LNt[394]*LNt[444]+LNt[445]*LNt[442]);
  LNt[448] = LNt[23]*LNt[27]+LNt[26]*LNt[26]+LNt[27]*LNt[23]+LNt[283]*LNt[287]+LNt[286]*LNt[286]+LNt[287]*LNt[283];
  LNt[449] = LNt[23]*LNt[26]+LNt[26]*LNt[23]+LNt[283]*LNt[286]+LNt[286]*LNt[283]+LNt[387]*LNt[390]+LNt[390]*LNt[387];
  LNt[450] = LNt[26]*LNt[27]+LNt[27]*LNt[26]+LNt[286]*LNt[287]+LNt[287]*LNt[286]+LNt[390]*LNt[391]+LNt[391]*LNt[390];
  LNt[451] = d.w;
  LNt[452] = float(LNP2x3[74]+LNt[451])-LNP2x3[74];	//[1,53]<<0
  LNt[451] -= LNt[452];
  LNt[453] = LNt[23]*LNt[23]+LNt[283]*LNt[283]+LNt[387]*LNt[387]-LNt[451];
  LNt[454] = float(LNP2x3[74]+LNt[453])-LNP2x3[74];	//[1,53]<<0
  LNt[453] -= LNt[454];
  LNt[455] = LNt[453]-LNt[94];
  LNt[456] = float(LNP2x3[53]+LNt[455])-LNP2x3[53];	//[22,53]<<0
  LNt[455] -= LNt[456];
  LNt[457] = float(LNP2x3[45]+LNt[455])-LNP2x3[45];	//[8,31]<<0
  LNt[455] -= LNt[457];
  LNt[458] = LNt[449]-LNt[452]+LNt[454]-LNt[96]+LNt[456]+LNt[457];
  LNt[459] = float(LNP2x3[74]+LNt[458])-LNP2x3[74];	//[22,51]<<23
  LNt[458] -= LNt[459];
  LNt[460] = float(LNP2x3[68]+LNt[458])-LNP2x3[68];	//[6,29]<<23
  LNt[458] -= LNt[460];
  LNt[461] = LNt[448]+LNt[387]*LNt[391]+LNt[390]*LNt[390]+LNt[391]*LNt[387]-LNt[97]+LNt[459]+LNt[460];
  LNt[462] = float(LNP2x3[97]+LNt[461])-LNP2x3[97];	//[22,51]<<46
  LNt[461] -= LNt[462];
  LNt[463] = float(LNP2x3[91]+LNt[461])-LNP2x3[91];	//[6,29]<<46
  LNt[461] -= LNt[463];
  LNt[464] = LNt[450]-LNt[91]+LNt[462]+LNt[463];
  LNt[465] = float(LNP2x3[114]+LNt[464])-LNP2x3[114];	//[11,34]<<69
  LNt[464] -= LNt[465];
  LNt[466] = LNt[292]*LNt[246]+LNt[294]*LNt[243]+LNt[296]*LNt[240]-(LNt[47]*LNt[342]+LNt[49]*LNt[339]+LNt[51]*LNt[336]);
  LNt[467] = LNt[292]*LNt[249]+LNt[294]*LNt[246]+LNt[296]*LNt[243]-(LNt[47]*LNt[345]+LNt[49]*LNt[342]+LNt[51]*LNt[339]);
  LNt[468] = LNt[292]*LNt[251]+LNt[294]*LNt[249]+LNt[296]*LNt[246]-(LNt[47]*LNt[347]+LNt[49]*LNt[345]+LNt[51]*LNt[342]);
  LNt[469] = LNt[292]*LNt[243]+LNt[294]*LNt[240]-(LNt[47]*LNt[339]+LNt[49]*LNt[336])+LNt[172]*LNt[406]+LNt[174]*LNt[403];
  LNt[470] = LNt[294]*LNt[251]+LNt[296]*LNt[249]-(LNt[49]*LNt[347]+LNt[51]*LNt[345])+LNt[174]*LNt[414]+LNt[176]*LNt[412];
  LNt[471] = LNt[292]*LNt[240]-LNt[47]*LNt[336]+LNt[172]*LNt[403];
  LNt[472] = float(LNP2x3[48]+LNt[471])-LNP2x3[48];	//[22,48]<<0
  LNt[471] -= LNt[472];
  LNt[473] = float(LNP2x3[45]+LNt[471])-LNP2x3[45];	//[3,26]<<0
  LNt[471] -= LNt[473];
  LNt[474] = LNt[469]+LNt[472]+LNt[473];
  LNt[475] = float(LNP2x3[72]+LNt[474])-LNP2x3[72];	//[22,49]<<23
  LNt[474] -= LNt[475];
  LNt[476] = float(LNP2x3[68]+LNt[474])-LNP2x3[68];	//[4,27]<<23
  LNt[474] -= LNt[476];
  LNt[477] = LNt[466]+LNt[172]*LNt[409]+LNt[174]*LNt[406]+LNt[176]*LNt[403]+LNt[475]+LNt[476];
  LNt[478] = float(LNP2x3[96]+LNt[477])-LNP2x3[96];	//[22,50]<<46
  LNt[477] -= LNt[478];
  LNt[479] = float(LNP2x3[91]+LNt[477])-LNP2x3[91];	//[5,28]<<46
  LNt[477] -= LNt[479];
  LNt[480] = LNt[467]+LNt[172]*LNt[412]+LNt[174]*LNt[409]+LNt[176]*LNt[406]+LNt[478]+LNt[479];
  LNt[481] = float(LNP2x3[119]+LNt[480])-LNP2x3[119];	//[22,50]<<69
  LNt[480] -= LNt[481];
  LNt[482] = float(LNP2x3[114]+LNt[480])-LNP2x3[114];	//[5,28]<<69
  LNt[480] -= LNt[482];
  LNt[483] = LNt[468]+LNt[172]*LNt[414]+LNt[174]*LNt[412]+LNt[176]*LNt[409]+LNt[481]+LNt[482];
  LNt[484] = (float(LNP2x3[125]+LNt[483]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[483] -= LNt[484];
  LNt[485] = (float(LNP2x3[125]+LNt[483]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[483] -= LNt[485];
  LNt[486] = LNt[470]+LNt[484]+LNt[485];
  LNt[487] = (float(LNP2x3[125]+LNt[486]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
  LNt[486] -= LNt[487];
  LNt[488] = LNt[296]*LNt[251]-LNt[51]*LNt[347]+LNt[176]*LNt[414]+LNt[487];
  LNt[489] = (float(LNP2x3[125]+LNt[488]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[4,27]<<138
  LNt[488] -= LNt[489];
  LNt[490] = LNt[27]*LNt[27]+LNt[287]*LNt[287]+LNt[391]*LNt[391]-LNt[98]+LNt[465];
  LNt[491] = LNt[455]*LNt[483]+LNt[458]*LNt[480]+LNt[461]*LNt[477]+LNt[464]*LNt[474]+LNt[490]*LNt[471];
  LNt[492] = LNt[455]*LNt[486]+LNt[458]*LNt[483]+LNt[461]*LNt[480]+LNt[464]*LNt[477]+LNt[490]*LNt[474];
  LNt[493] = LNt[455]*LNt[488]+LNt[458]*LNt[486]+LNt[461]*LNt[483]+LNt[464]*LNt[480]+LNt[490]*LNt[477];
  LNt[494] = LNt[455]*LNt[489]+LNt[458]*LNt[488]+LNt[461]*LNt[486]+LNt[464]*LNt[483]+LNt[490]*LNt[480];
  LNt[495] = LNt[379]-(LNt[392]*LNt[424]+LNt[394]*LNt[421]+LNt[445]*LNt[418])+LNt[455]*LNt[477]+LNt[458]*LNt[474]+LNt[461]*LNt[471];
  LNt[496] = LNt[380]-(LNt[392]*LNt[427]+LNt[394]*LNt[424]+LNt[445]*LNt[421])+LNt[455]*LNt[480]+LNt[458]*LNt[477]+LNt[461]*LNt[474]+LNt[464]*LNt[471];
  LNt[497] = LNt[385]-(LNt[392]*LNt[442]+LNt[394]*LNt[439]+LNt[445]*LNt[436])+LNt[458]*LNt[489]+LNt[461]*LNt[488]+LNt[464]*LNt[486]+LNt[490]*LNt[483];
  LNt[498] = LNt[386]-(LNt[392]*LNt[444]+LNt[394]*LNt[442]+LNt[445]*LNt[439])+LNt[461]*LNt[489]+LNt[464]*LNt[488]+LNt[490]*LNt[486];
  LNt[499] = LNt[33]*LNt[255]+LNt[288]*LNt[351]-LNt[392]*LNt[418]+LNt[455]*LNt[471];
  LNt[500] = LNt[446]+LNt[455]*LNt[474]+LNt[458]*LNt[471];
  LNt[501] = LNt[381]-(LNt[392]*LNt[430]+LNt[394]*LNt[427]+LNt[445]*LNt[424])+LNt[491];
  LNt[502] = LNt[382]-(LNt[392]*LNt[433]+LNt[394]*LNt[430]+LNt[445]*LNt[427])+LNt[492];
  LNt[503] = LNt[383]-(LNt[392]*LNt[436]+LNt[394]*LNt[433]+LNt[445]*LNt[430])+LNt[493];
  LNt[504] = LNt[384]-(LNt[392]*LNt[439]+LNt[394]*LNt[436]+LNt[445]*LNt[433])+LNt[494];
  LNt[505] = LNt[447]+LNt[464]*LNt[489]+LNt[490]*LNt[488];
  LNt[506] = LNt[282]*LNt[281]+LNt[378]*LNt[377]-LNt[445]*LNt[444]+LNt[490]*LNt[489];
  LNt[507] = (((((((LNt[506])+LNt[505])+LNt[498])+LNt[497])+LNt[504])+LNt[503])+LNt[502])+LNt[501];
  LNt[22] = (((((LNt[507])+LNt[496])+LNt[495])+LNt[500])+LNt[499]);
}
if (LNt[22]<0){
  LNt[0] = -1.;
}else{
  if (LNt[22]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=880 multiplies=716 normalizes=227 */


WLPoint3d::WLPoint3d(const integer x, const integer y, const integer z, const integer w){
LNt[0] = x;
LNt[1] = float(LNP2x3[53]+LNt[0])-LNP2x3[53];	//[22,53]<<0
LNt[0] -= LNt[1];
LNt[2] = float(LNP2x3[45]+LNt[0])-LNP2x3[45];	//[8,31]<<0
LNt[0] -= LNt[2];
LNt[3] = LNt[1]+LNt[2];
LNt[4] = float(LNP2x3[68]+LNt[3])-LNP2x3[68];	//[7,30]<<23
LNt[3] -= LNt[4];
LNt[5] = y;
LNt[6] = float(LNP2x3[53]+LNt[5])-LNP2x3[53];	//[22,53]<<0
LNt[5] -= LNt[6];
LNt[7] = float(LNP2x3[45]+LNt[5])-LNP2x3[45];	//[8,31]<<0
LNt[5] -= LNt[7];
LNt[8] = LNt[6]+LNt[7];
LNt[9] = float(LNP2x3[68]+LNt[8])-LNP2x3[68];	//[7,30]<<23
LNt[8] -= LNt[9];
LNt[10] = z;
LNt[11] = float(LNP2x3[53]+LNt[10])-LNP2x3[53];	//[22,53]<<0
LNt[10] -= LNt[11];
LNt[12] = float(LNP2x3[45]+LNt[10])-LNP2x3[45];	//[8,31]<<0
LNt[10] -= LNt[12];
LNt[13] = LNt[11]+LNt[12];
LNt[14] = float(LNP2x3[68]+LNt[13])-LNP2x3[68];	//[7,30]<<23
LNt[13] -= LNt[14];
LNt[15] = LNt[0]*LNt[4]+LNt[3]*LNt[3]+LNt[4]*LNt[0]+LNt[5]*LNt[9]+LNt[8]*LNt[8]+LNt[9]*LNt[5];
LNt[16] = LNt[0]*LNt[3]+LNt[3]*LNt[0]+LNt[5]*LNt[8]+LNt[8]*LNt[5]+LNt[10]*LNt[13]+LNt[13]*LNt[10];
LNt[17] = LNt[3]*LNt[4]+LNt[4]*LNt[3]+LNt[8]*LNt[9]+LNt[9]*LNt[8]+LNt[13]*LNt[14]+LNt[14]*LNt[13];
LNt[18] = w;
LNt[19] = float(LNP2x3[74]+LNt[18])-LNP2x3[74];	//[1,53]<<0
LNt[18] -= LNt[19];
(*this).x = LNt[0];
(*this).y = LNt[5];
(*this).z = LNt[10];
(*this).w.v0 = LNt[0]*LNt[0]+LNt[5]*LNt[5]+LNt[10]*LNt[10]-LNt[18];
LNt[20] = float(LNP2x3[53]+(*this).w.v0)-LNP2x3[53];	//[22,53]<<0
(*this).w.v0 -= LNt[20];
LNt[21] = float(LNP2x3[45]+(*this).w.v0)-LNP2x3[45];	//[8,31]<<0
(*this).w.v0 -= LNt[21];
(*this).w.v1 = LNt[16]-LNt[19]+LNt[20]+LNt[21];
LNt[22] = float(LNP2x3[73]+(*this).w.v1)-LNP2x3[73];	//[22,50]<<23
(*this).w.v1 -= LNt[22];
LNt[23] = float(LNP2x3[68]+(*this).w.v1)-LNP2x3[68];	//[5,28]<<23
(*this).w.v1 -= LNt[23];
(*this).w.v2 = LNt[15]+LNt[10]*LNt[14]+LNt[13]*LNt[13]+LNt[14]*LNt[10]+LNt[22]+LNt[23];
LNt[24] = float(LNP2x3[96]+(*this).w.v2)-LNP2x3[96];	//[22,50]<<46
(*this).w.v2 -= LNt[24];
LNt[25] = float(LNP2x3[87]+(*this).w.v2)-LNP2x3[87];	//[9,28]<<46
(*this).w.v2 -= LNt[25];
} /* adds=32 multiplies=27 normalizes=16 */


integer wincircle3d(const WLPoint3d& a, const WLPoint3d& b, const WLPoint3d& c, const WLPoint3d& d, const WLPoint3d& e){
integer LNans;
LNt[1] = c.y-e.y;
LNt[2] = a.z-e.z;
LNt[3] = e.w.v2+e.w.v1+e.w.v0;
LNt[4] = b.w.v2+b.w.v1+b.w.v0-LNt[3];
LNt[5] = b.z-e.z;
LNt[6] = a.w.v2+a.w.v1+a.w.v0-LNt[3];
LNt[7] = LNt[2]*LNt[4]-LNt[5]*LNt[6];
LNt[8] = c.z-e.z;
LNt[9] = a.y-e.y;
LNt[10] = b.y-e.y;
LNt[11] = LNt[9]*LNt[4]-LNt[10]*LNt[6];
LNt[12] = c.w.v2+c.w.v1+c.w.v0-LNt[3];
LNt[13] = LNt[9]*LNt[5]-LNt[10]*LNt[2];
LNt[14] = c.x-e.x;
LNt[15] = a.x-e.x;
LNt[16] = b.x-e.x;
LNt[17] = LNt[15]*LNt[4]-LNt[6]*LNt[16];
LNt[18] = LNt[15]*LNt[5]-LNt[2]*LNt[16];
LNt[19] = (0.-(d.x-e.x))*(LNt[1]*LNt[7]-LNt[8]*LNt[11]+LNt[12]*LNt[13])+(d.y-e.y)*(LNt[14]*LNt[7]-LNt[8]*LNt[17]+LNt[12]*LNt[18]);
LNt[20] = LNt[15]*LNt[10]-LNt[9]*LNt[16];
LNt[21] = LNt[19]-(d.z-e.z)*(LNt[14]*LNt[11]-LNt[1]*LNt[17]+LNt[12]*LNt[20])+(d.w.v2+d.w.v1+d.w.v0-LNt[3])*(LNt[14]*LNt[13]-LNt[1]*LNt[18]+LNt[8]*LNt[20]);
if (-LNP2[193]<LNt[21] && LNt[21]<LNP2[193]) {	/* the high order 42 bits of 235 are accurate */
  LNt[22] = d.x;
  LNt[23] = float(LNP2x3[74]+LNt[22])-LNP2x3[74];	//[1,53]<<0
  LNt[22] -= LNt[23];
  LNt[24] = e.x;
  LNt[25] = float(LNP2x3[74]+LNt[24])-LNP2x3[74];	//[1,53]<<0
  LNt[24] -= LNt[25];
  LNt[26] = LNt[22]-LNt[24];
  LNt[27] = float(LNP2x3[74]+LNt[26])-LNP2x3[74];	//[1,53]<<0
  LNt[26] -= LNt[27];
  LNt[28] = 0.-LNt[26];
  LNt[29] = float(LNP2x3[53]+LNt[28])-LNP2x3[53];	//[22,53]<<0
  LNt[28] -= LNt[29];
  LNt[30] = float(LNP2x3[45]+LNt[28])-LNP2x3[45];	//[8,31]<<0
  LNt[28] -= LNt[30];
  LNt[31] = 0.0-(LNt[23]-LNt[25]+LNt[27])+LNt[29]+LNt[30];
  LNt[32] = float(LNP2x3[68]+LNt[31])-LNP2x3[68];	//[7,30]<<23
  LNt[31] -= LNt[32];
  LNt[33] = c.y;
  LNt[34] = float(LNP2x3[74]+LNt[33])-LNP2x3[74];	//[1,53]<<0
  LNt[33] -= LNt[34];
  LNt[35] = e.y;
  LNt[36] = float(LNP2x3[74]+LNt[35])-LNP2x3[74];	//[1,53]<<0
  LNt[35] -= LNt[36];
  LNt[37] = LNt[33]-LNt[35];
  LNt[38] = float(LNP2x3[53]+LNt[37])-LNP2x3[53];	//[22,53]<<0
  LNt[37] -= LNt[38];
  LNt[39] = float(LNP2x3[45]+LNt[37])-LNP2x3[45];	//[8,31]<<0
  LNt[37] -= LNt[39];
  LNt[40] = LNt[34]-LNt[36]+LNt[38]+LNt[39];
  LNt[41] = float(LNP2x3[68]+LNt[40])-LNP2x3[68];	//[7,30]<<23
  LNt[40] -= LNt[41];
  LNt[42] = a.z;
  LNt[43] = float(LNP2x3[74]+LNt[42])-LNP2x3[74];	//[1,53]<<0
  LNt[42] -= LNt[43];
  LNt[44] = e.z;
  LNt[45] = float(LNP2x3[74]+LNt[44])-LNP2x3[74];	//[1,53]<<0
  LNt[44] -= LNt[45];
  LNt[46] = LNt[42]-LNt[44];
  LNt[47] = float(LNP2x3[53]+LNt[46])-LNP2x3[53];	//[22,53]<<0
  LNt[46] -= LNt[47];
  LNt[48] = float(LNP2x3[45]+LNt[46])-LNP2x3[45];	//[8,31]<<0
  LNt[46] -= LNt[48];
  LNt[49] = LNt[43]-LNt[45]+LNt[47]+LNt[48];
  LNt[50] = float(LNP2x3[68]+LNt[49])-LNP2x3[68];	//[7,30]<<23
  LNt[49] -= LNt[50];
  LNt[51] = b.w.v0-e.w.v0;
  LNt[52] = float(LNP2x3[45]+LNt[51])-LNP2x3[45];	//[1,24]<<0
  LNt[51] -= LNt[52];
  LNt[53] = b.w.v1-e.w.v1+LNt[52];
  LNt[54] = float(LNP2x3[68]+LNt[53])-LNP2x3[68];	//[1,24]<<23
  LNt[53] -= LNt[54];
  LNt[55] = b.w.v2-e.w.v2+LNt[54];
  LNt[56] = b.z;
  LNt[57] = float(LNP2x3[74]+LNt[56])-LNP2x3[74];	//[1,53]<<0
  LNt[56] -= LNt[57];
  LNt[58] = LNt[56]-LNt[44];
  LNt[59] = float(LNP2x3[53]+LNt[58])-LNP2x3[53];	//[22,53]<<0
  LNt[58] -= LNt[59];
  LNt[60] = float(LNP2x3[45]+LNt[58])-LNP2x3[45];	//[8,31]<<0
  LNt[58] -= LNt[60];
  LNt[61] = LNt[57]-LNt[45]+LNt[59]+LNt[60];
  LNt[62] = float(LNP2x3[68]+LNt[61])-LNP2x3[68];	//[7,30]<<23
  LNt[61] -= LNt[62];
  LNt[63] = a.w.v0-e.w.v0;
  LNt[64] = float(LNP2x3[45]+LNt[63])-LNP2x3[45];	//[1,24]<<0
  LNt[63] -= LNt[64];
  LNt[65] = a.w.v1-e.w.v1+LNt[64];
  LNt[66] = float(LNP2x3[68]+LNt[65])-LNP2x3[68];	//[1,24]<<23
  LNt[65] -= LNt[66];
  LNt[67] = a.w.v2-e.w.v2+LNt[66];
  LNt[68] = LNt[46]*LNt[55]+LNt[49]*LNt[53]+LNt[50]*LNt[51]-(LNt[58]*LNt[67]+LNt[61]*LNt[65]+LNt[62]*LNt[63]);
  LNt[69] = LNt[46]*LNt[51]-LNt[58]*LNt[63];
  LNt[70] = float(LNP2x3[47]+LNt[69])-LNP2x3[47];	//[22,47]<<0
  LNt[69] -= LNt[70];
  LNt[71] = float(LNP2x3[45]+LNt[69])-LNP2x3[45];	//[2,25]<<0
  LNt[69] -= LNt[71];
  LNt[72] = LNt[46]*LNt[53]+LNt[49]*LNt[51]-(LNt[58]*LNt[65]+LNt[61]*LNt[63])+LNt[70]+LNt[71];
  LNt[73] = float(LNP2x3[71]+LNt[72])-LNP2x3[71];	//[22,48]<<23
  LNt[72] -= LNt[73];
  LNt[74] = float(LNP2x3[68]+LNt[72])-LNP2x3[68];	//[3,26]<<23
  LNt[72] -= LNt[74];
  LNt[75] = LNt[68]+LNt[73]+LNt[74];
  LNt[76] = float(LNP2x3[95]+LNt[75])-LNP2x3[95];	//[22,49]<<46
  LNt[75] -= LNt[76];
  LNt[77] = float(LNP2x3[91]+LNt[75])-LNP2x3[91];	//[4,27]<<46
  LNt[75] -= LNt[77];
  LNt[78] = LNt[49]*LNt[55]+LNt[50]*LNt[53]-(LNt[61]*LNt[67]+LNt[62]*LNt[65])+LNt[76]+LNt[77];
  LNt[79] = float(LNP2x3[114]+LNt[78])-LNP2x3[114];	//[22,45]<<69
  LNt[78] -= LNt[79];
  LNt[80] = LNt[50]*LNt[55]-LNt[62]*LNt[67]+LNt[79];
  LNt[81] = (float(LNP2x3[125]+LNt[80]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[80] -= LNt[81];
  LNt[82] = c.z;
  LNt[83] = float(LNP2x3[74]+LNt[82])-LNP2x3[74];	//[1,53]<<0
  LNt[82] -= LNt[83];
  LNt[84] = LNt[82]-LNt[44];
  LNt[85] = float(LNP2x3[53]+LNt[84])-LNP2x3[53];	//[22,53]<<0
  LNt[84] -= LNt[85];
  LNt[86] = float(LNP2x3[45]+LNt[84])-LNP2x3[45];	//[8,31]<<0
  LNt[84] -= LNt[86];
  LNt[87] = LNt[83]-LNt[45]+LNt[85]+LNt[86];
  LNt[88] = float(LNP2x3[68]+LNt[87])-LNP2x3[68];	//[7,30]<<23
  LNt[87] -= LNt[88];
  LNt[89] = a.y;
  LNt[90] = float(LNP2x3[74]+LNt[89])-LNP2x3[74];	//[1,53]<<0
  LNt[89] -= LNt[90];
  LNt[91] = LNt[89]-LNt[35];
  LNt[92] = float(LNP2x3[53]+LNt[91])-LNP2x3[53];	//[22,53]<<0
  LNt[91] -= LNt[92];
  LNt[93] = float(LNP2x3[45]+LNt[91])-LNP2x3[45];	//[8,31]<<0
  LNt[91] -= LNt[93];
  LNt[94] = LNt[90]-LNt[36]+LNt[92]+LNt[93];
  LNt[95] = float(LNP2x3[68]+LNt[94])-LNP2x3[68];	//[7,30]<<23
  LNt[94] -= LNt[95];
  LNt[96] = b.y;
  LNt[97] = float(LNP2x3[74]+LNt[96])-LNP2x3[74];	//[1,53]<<0
  LNt[96] -= LNt[97];
  LNt[98] = LNt[96]-LNt[35];
  LNt[99] = float(LNP2x3[53]+LNt[98])-LNP2x3[53];	//[22,53]<<0
  LNt[98] -= LNt[99];
  LNt[100] = float(LNP2x3[45]+LNt[98])-LNP2x3[45];	//[8,31]<<0
  LNt[98] -= LNt[100];
  LNt[101] = LNt[97]-LNt[36]+LNt[99]+LNt[100];
  LNt[102] = float(LNP2x3[68]+LNt[101])-LNP2x3[68];	//[7,30]<<23
  LNt[101] -= LNt[102];
  LNt[103] = LNt[91]*LNt[55]+LNt[94]*LNt[53]+LNt[95]*LNt[51]-(LNt[98]*LNt[67]+LNt[101]*LNt[65]+LNt[102]*LNt[63]);
  LNt[104] = LNt[91]*LNt[51]-LNt[98]*LNt[63];
  LNt[105] = float(LNP2x3[47]+LNt[104])-LNP2x3[47];	//[22,47]<<0
  LNt[104] -= LNt[105];
  LNt[106] = float(LNP2x3[45]+LNt[104])-LNP2x3[45];	//[2,25]<<0
  LNt[104] -= LNt[106];
  LNt[107] = LNt[91]*LNt[53]+LNt[94]*LNt[51]-(LNt[98]*LNt[65]+LNt[101]*LNt[63])+LNt[105]+LNt[106];
  LNt[108] = float(LNP2x3[71]+LNt[107])-LNP2x3[71];	//[22,48]<<23
  LNt[107] -= LNt[108];
  LNt[109] = float(LNP2x3[68]+LNt[107])-LNP2x3[68];	//[3,26]<<23
  LNt[107] -= LNt[109];
  LNt[110] = LNt[103]+LNt[108]+LNt[109];
  LNt[111] = float(LNP2x3[95]+LNt[110])-LNP2x3[95];	//[22,49]<<46
  LNt[110] -= LNt[111];
  LNt[112] = float(LNP2x3[91]+LNt[110])-LNP2x3[91];	//[4,27]<<46
  LNt[110] -= LNt[112];
  LNt[113] = LNt[94]*LNt[55]+LNt[95]*LNt[53]-(LNt[101]*LNt[67]+LNt[102]*LNt[65])+LNt[111]+LNt[112];
  LNt[114] = float(LNP2x3[114]+LNt[113])-LNP2x3[114];	//[22,45]<<69
  LNt[113] -= LNt[114];
  LNt[115] = LNt[95]*LNt[55]-LNt[102]*LNt[67]+LNt[114];
  LNt[116] = (float(LNP2x3[125]+LNt[115]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[115] -= LNt[116];
  LNt[117] = LNt[37]*LNt[75]+LNt[40]*LNt[72]+LNt[41]*LNt[69]-(LNt[84]*LNt[110]+LNt[87]*LNt[107]+LNt[88]*LNt[104]);
  LNt[118] = LNt[37]*LNt[78]+LNt[40]*LNt[75]+LNt[41]*LNt[72]-(LNt[84]*LNt[113]+LNt[87]*LNt[110]+LNt[88]*LNt[107]);
  LNt[119] = LNt[37]*LNt[80]+LNt[40]*LNt[78]+LNt[41]*LNt[75]-(LNt[84]*LNt[115]+LNt[87]*LNt[113]+LNt[88]*LNt[110]);
  LNt[120] = LNt[37]*LNt[81]+LNt[40]*LNt[80]+LNt[41]*LNt[78]-(LNt[84]*LNt[116]+LNt[87]*LNt[115]+LNt[88]*LNt[113]);
  LNt[121] = c.w.v0-e.w.v0;
  LNt[122] = float(LNP2x3[45]+LNt[121])-LNP2x3[45];	//[1,24]<<0
  LNt[121] -= LNt[122];
  LNt[123] = c.w.v1-e.w.v1+LNt[122];
  LNt[124] = float(LNP2x3[68]+LNt[123])-LNP2x3[68];	//[1,24]<<23
  LNt[123] -= LNt[124];
  LNt[125] = c.w.v2-e.w.v2+LNt[124];
  LNt[126] = LNt[91]*LNt[62]+LNt[94]*LNt[61]+LNt[95]*LNt[58]-(LNt[98]*LNt[50]+LNt[101]*LNt[49]+LNt[102]*LNt[46]);
  LNt[127] = LNt[91]*LNt[58]-LNt[98]*LNt[46];
  LNt[128] = float(LNP2x3[47]+LNt[127])-LNP2x3[47];	//[22,47]<<0
  LNt[127] -= LNt[128];
  LNt[129] = float(LNP2x3[45]+LNt[127])-LNP2x3[45];	//[2,25]<<0
  LNt[127] -= LNt[129];
  LNt[130] = LNt[91]*LNt[61]+LNt[94]*LNt[58]-(LNt[98]*LNt[49]+LNt[101]*LNt[46])+LNt[128]+LNt[129];
  LNt[131] = float(LNP2x3[71]+LNt[130])-LNP2x3[71];	//[22,48]<<23
  LNt[130] -= LNt[131];
  LNt[132] = float(LNP2x3[68]+LNt[130])-LNP2x3[68];	//[3,26]<<23
  LNt[130] -= LNt[132];
  LNt[133] = LNt[126]+LNt[131]+LNt[132];
  LNt[134] = float(LNP2x3[95]+LNt[133])-LNP2x3[95];	//[22,49]<<46
  LNt[133] -= LNt[134];
  LNt[135] = float(LNP2x3[91]+LNt[133])-LNP2x3[91];	//[4,27]<<46
  LNt[133] -= LNt[135];
  LNt[136] = LNt[94]*LNt[62]+LNt[95]*LNt[61]-(LNt[101]*LNt[50]+LNt[102]*LNt[49])+LNt[134]+LNt[135];
  LNt[137] = float(LNP2x3[114]+LNt[136])-LNP2x3[114];	//[9,32]<<69
  LNt[136] -= LNt[137];
  LNt[138] = LNt[95]*LNt[62]-LNt[102]*LNt[50]+LNt[137];
  LNt[139] = LNt[37]*LNt[72]+LNt[40]*LNt[69]-(LNt[84]*LNt[107]+LNt[87]*LNt[104])+LNt[121]*LNt[130]+LNt[123]*LNt[127];
  LNt[140] = LNt[40]*LNt[81]+LNt[41]*LNt[80]-(LNt[87]*LNt[116]+LNt[88]*LNt[115])+LNt[125]*LNt[138];
  LNt[141] = LNt[37]*LNt[69]-LNt[84]*LNt[104]+LNt[121]*LNt[127];
  LNt[142] = float(LNP2x3[48]+LNt[141])-LNP2x3[48];	//[22,48]<<0
  LNt[141] -= LNt[142];
  LNt[143] = float(LNP2x3[45]+LNt[141])-LNP2x3[45];	//[3,26]<<0
  LNt[141] -= LNt[143];
  LNt[144] = LNt[139]+LNt[142]+LNt[143];
  LNt[145] = float(LNP2x3[72]+LNt[144])-LNP2x3[72];	//[22,49]<<23
  LNt[144] -= LNt[145];
  LNt[146] = float(LNP2x3[68]+LNt[144])-LNP2x3[68];	//[4,27]<<23
  LNt[144] -= LNt[146];
  LNt[147] = LNt[117]+LNt[121]*LNt[133]+LNt[123]*LNt[130]+LNt[125]*LNt[127]+LNt[145]+LNt[146];
  LNt[148] = float(LNP2x3[96]+LNt[147])-LNP2x3[96];	//[22,50]<<46
  LNt[147] -= LNt[148];
  LNt[149] = float(LNP2x3[91]+LNt[147])-LNP2x3[91];	//[5,28]<<46
  LNt[147] -= LNt[149];
  LNt[150] = LNt[118]+LNt[121]*LNt[136]+LNt[123]*LNt[133]+LNt[125]*LNt[130]+LNt[148]+LNt[149];
  LNt[151] = float(LNP2x3[119]+LNt[150])-LNP2x3[119];	//[22,50]<<69
  LNt[150] -= LNt[151];
  LNt[152] = float(LNP2x3[114]+LNt[150])-LNP2x3[114];	//[5,28]<<69
  LNt[150] -= LNt[152];
  LNt[153] = LNt[119]+LNt[121]*LNt[138]+LNt[123]*LNt[136]+LNt[125]*LNt[133]+LNt[151]+LNt[152];
  LNt[154] = (float(LNP2x3[125]+LNt[153]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[153] -= LNt[154];
  LNt[155] = (float(LNP2x3[125]+LNt[153]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[153] -= LNt[155];
  LNt[156] = LNt[120]+LNt[123]*LNt[138]+LNt[125]*LNt[136]+LNt[154]+LNt[155];
  LNt[157] = (float(LNP2x3[125]+LNt[156]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[156] -= LNt[157];
  LNt[158] = (float(LNP2x3[125]+LNt[156]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[156] -= LNt[158];
  LNt[159] = LNt[140]+LNt[157]+LNt[158];
  LNt[160] = (float(LNP2x3[125]+LNt[159]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[13,36]<<138
  LNt[159] -= LNt[160];
  LNt[161] = LNt[41]*LNt[81]-LNt[88]*LNt[116]+LNt[160];
  LNt[162] = d.y;
  LNt[163] = float(LNP2x3[74]+LNt[162])-LNP2x3[74];	//[1,53]<<0
  LNt[162] -= LNt[163];
  LNt[164] = LNt[162]-LNt[35];
  LNt[165] = float(LNP2x3[53]+LNt[164])-LNP2x3[53];	//[22,53]<<0
  LNt[164] -= LNt[165];
  LNt[166] = float(LNP2x3[45]+LNt[164])-LNP2x3[45];	//[8,31]<<0
  LNt[164] -= LNt[166];
  LNt[167] = LNt[163]-LNt[36]+LNt[165]+LNt[166];
  LNt[168] = float(LNP2x3[68]+LNt[167])-LNP2x3[68];	//[7,30]<<23
  LNt[167] -= LNt[168];
  LNt[169] = c.x;
  LNt[170] = float(LNP2x3[74]+LNt[169])-LNP2x3[74];	//[1,53]<<0
  LNt[169] -= LNt[170];
  LNt[171] = LNt[169]-LNt[24];
  LNt[172] = float(LNP2x3[53]+LNt[171])-LNP2x3[53];	//[22,53]<<0
  LNt[171] -= LNt[172];
  LNt[173] = float(LNP2x3[45]+LNt[171])-LNP2x3[45];	//[8,31]<<0
  LNt[171] -= LNt[173];
  LNt[174] = LNt[170]-LNt[25]+LNt[172]+LNt[173];
  LNt[175] = float(LNP2x3[68]+LNt[174])-LNP2x3[68];	//[7,30]<<23
  LNt[174] -= LNt[175];
  LNt[176] = a.x;
  LNt[177] = float(LNP2x3[74]+LNt[176])-LNP2x3[74];	//[1,53]<<0
  LNt[176] -= LNt[177];
  LNt[178] = LNt[176]-LNt[24];
  LNt[179] = float(LNP2x3[53]+LNt[178])-LNP2x3[53];	//[22,53]<<0
  LNt[178] -= LNt[179];
  LNt[180] = float(LNP2x3[45]+LNt[178])-LNP2x3[45];	//[8,31]<<0
  LNt[178] -= LNt[180];
  LNt[181] = LNt[177]-LNt[25]+LNt[179]+LNt[180];
  LNt[182] = float(LNP2x3[68]+LNt[181])-LNP2x3[68];	//[7,30]<<23
  LNt[181] -= LNt[182];
  LNt[183] = b.x;
  LNt[184] = float(LNP2x3[74]+LNt[183])-LNP2x3[74];	//[1,53]<<0
  LNt[183] -= LNt[184];
  LNt[185] = LNt[183]-LNt[24];
  LNt[186] = float(LNP2x3[53]+LNt[185])-LNP2x3[53];	//[22,53]<<0
  LNt[185] -= LNt[186];
  LNt[187] = float(LNP2x3[45]+LNt[185])-LNP2x3[45];	//[8,31]<<0
  LNt[185] -= LNt[187];
  LNt[188] = LNt[184]-LNt[25]+LNt[186]+LNt[187];
  LNt[189] = float(LNP2x3[68]+LNt[188])-LNP2x3[68];	//[7,30]<<23
  LNt[188] -= LNt[189];
  LNt[190] = LNt[178]*LNt[55]+LNt[181]*LNt[53]+LNt[182]*LNt[51]-(LNt[63]*LNt[189]+LNt[65]*LNt[188]+LNt[67]*LNt[185]);
  LNt[191] = LNt[178]*LNt[51]-LNt[63]*LNt[185];
  LNt[192] = float(LNP2x3[47]+LNt[191])-LNP2x3[47];	//[22,47]<<0
  LNt[191] -= LNt[192];
  LNt[193] = float(LNP2x3[45]+LNt[191])-LNP2x3[45];	//[2,25]<<0
  LNt[191] -= LNt[193];
  LNt[194] = LNt[178]*LNt[53]+LNt[181]*LNt[51]-(LNt[63]*LNt[188]+LNt[65]*LNt[185])+LNt[192]+LNt[193];
  LNt[195] = float(LNP2x3[71]+LNt[194])-LNP2x3[71];	//[22,48]<<23
  LNt[194] -= LNt[195];
  LNt[196] = float(LNP2x3[68]+LNt[194])-LNP2x3[68];	//[3,26]<<23
  LNt[194] -= LNt[196];
  LNt[197] = LNt[190]+LNt[195]+LNt[196];
  LNt[198] = float(LNP2x3[95]+LNt[197])-LNP2x3[95];	//[22,49]<<46
  LNt[197] -= LNt[198];
  LNt[199] = float(LNP2x3[91]+LNt[197])-LNP2x3[91];	//[4,27]<<46
  LNt[197] -= LNt[199];
  LNt[200] = LNt[181]*LNt[55]+LNt[182]*LNt[53]-(LNt[65]*LNt[189]+LNt[67]*LNt[188])+LNt[198]+LNt[199];
  LNt[201] = float(LNP2x3[114]+LNt[200])-LNP2x3[114];	//[22,45]<<69
  LNt[200] -= LNt[201];
  LNt[202] = LNt[182]*LNt[55]-LNt[67]*LNt[189]+LNt[201];
  LNt[203] = (float(LNP2x3[125]+LNt[202]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[202] -= LNt[203];
  LNt[204] = LNt[171]*LNt[75]+LNt[174]*LNt[72]+LNt[175]*LNt[69]-(LNt[84]*LNt[197]+LNt[87]*LNt[194]+LNt[88]*LNt[191]);
  LNt[205] = LNt[171]*LNt[78]+LNt[174]*LNt[75]+LNt[175]*LNt[72]-(LNt[84]*LNt[200]+LNt[87]*LNt[197]+LNt[88]*LNt[194]);
  LNt[206] = LNt[171]*LNt[80]+LNt[174]*LNt[78]+LNt[175]*LNt[75]-(LNt[84]*LNt[202]+LNt[87]*LNt[200]+LNt[88]*LNt[197]);
  LNt[207] = LNt[171]*LNt[81]+LNt[174]*LNt[80]+LNt[175]*LNt[78]-(LNt[84]*LNt[203]+LNt[87]*LNt[202]+LNt[88]*LNt[200]);
  LNt[208] = LNt[178]*LNt[62]+LNt[181]*LNt[61]+LNt[182]*LNt[58]-(LNt[46]*LNt[189]+LNt[49]*LNt[188]+LNt[50]*LNt[185]);
  LNt[209] = LNt[178]*LNt[58]-LNt[46]*LNt[185];
  LNt[210] = float(LNP2x3[47]+LNt[209])-LNP2x3[47];	//[22,47]<<0
  LNt[209] -= LNt[210];
  LNt[211] = float(LNP2x3[45]+LNt[209])-LNP2x3[45];	//[2,25]<<0
  LNt[209] -= LNt[211];
  LNt[212] = LNt[178]*LNt[61]+LNt[181]*LNt[58]-(LNt[46]*LNt[188]+LNt[49]*LNt[185])+LNt[210]+LNt[211];
  LNt[213] = float(LNP2x3[71]+LNt[212])-LNP2x3[71];	//[22,48]<<23
  LNt[212] -= LNt[213];
  LNt[214] = float(LNP2x3[68]+LNt[212])-LNP2x3[68];	//[3,26]<<23
  LNt[212] -= LNt[214];
  LNt[215] = LNt[208]+LNt[213]+LNt[214];
  LNt[216] = float(LNP2x3[95]+LNt[215])-LNP2x3[95];	//[22,49]<<46
  LNt[215] -= LNt[216];
  LNt[217] = float(LNP2x3[91]+LNt[215])-LNP2x3[91];	//[4,27]<<46
  LNt[215] -= LNt[217];
  LNt[218] = LNt[181]*LNt[62]+LNt[182]*LNt[61]-(LNt[49]*LNt[189]+LNt[50]*LNt[188])+LNt[216]+LNt[217];
  LNt[219] = float(LNP2x3[114]+LNt[218])-LNP2x3[114];	//[9,32]<<69
  LNt[218] -= LNt[219];
  LNt[220] = LNt[182]*LNt[62]-LNt[50]*LNt[189]+LNt[219];
  LNt[221] = LNt[171]*LNt[72]+LNt[174]*LNt[69]-(LNt[84]*LNt[194]+LNt[87]*LNt[191])+LNt[121]*LNt[212]+LNt[123]*LNt[209];
  LNt[222] = LNt[174]*LNt[81]+LNt[175]*LNt[80]-(LNt[87]*LNt[203]+LNt[88]*LNt[202])+LNt[125]*LNt[220];
  LNt[223] = LNt[171]*LNt[69]-LNt[84]*LNt[191]+LNt[121]*LNt[209];
  LNt[224] = float(LNP2x3[48]+LNt[223])-LNP2x3[48];	//[22,48]<<0
  LNt[223] -= LNt[224];
  LNt[225] = float(LNP2x3[45]+LNt[223])-LNP2x3[45];	//[3,26]<<0
  LNt[223] -= LNt[225];
  LNt[226] = LNt[221]+LNt[224]+LNt[225];
  LNt[227] = float(LNP2x3[72]+LNt[226])-LNP2x3[72];	//[22,49]<<23
  LNt[226] -= LNt[227];
  LNt[228] = float(LNP2x3[68]+LNt[226])-LNP2x3[68];	//[4,27]<<23
  LNt[226] -= LNt[228];
  LNt[229] = LNt[204]+LNt[121]*LNt[215]+LNt[123]*LNt[212]+LNt[125]*LNt[209]+LNt[227]+LNt[228];
  LNt[230] = float(LNP2x3[96]+LNt[229])-LNP2x3[96];	//[22,50]<<46
  LNt[229] -= LNt[230];
  LNt[231] = float(LNP2x3[91]+LNt[229])-LNP2x3[91];	//[5,28]<<46
  LNt[229] -= LNt[231];
  LNt[232] = LNt[205]+LNt[121]*LNt[218]+LNt[123]*LNt[215]+LNt[125]*LNt[212]+LNt[230]+LNt[231];
  LNt[233] = float(LNP2x3[119]+LNt[232])-LNP2x3[119];	//[22,50]<<69
  LNt[232] -= LNt[233];
  LNt[234] = float(LNP2x3[114]+LNt[232])-LNP2x3[114];	//[5,28]<<69
  LNt[232] -= LNt[234];
  LNt[235] = LNt[206]+LNt[121]*LNt[220]+LNt[123]*LNt[218]+LNt[125]*LNt[215]+LNt[233]+LNt[234];
  LNt[236] = (float(LNP2x3[125]+LNt[235]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[235] -= LNt[236];
  LNt[237] = (float(LNP2x3[125]+LNt[235]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[235] -= LNt[237];
  LNt[238] = LNt[207]+LNt[123]*LNt[220]+LNt[125]*LNt[218]+LNt[236]+LNt[237];
  LNt[239] = (float(LNP2x3[125]+LNt[238]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[238] -= LNt[239];
  LNt[240] = (float(LNP2x3[125]+LNt[238]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[238] -= LNt[240];
  LNt[241] = LNt[222]+LNt[239]+LNt[240];
  LNt[242] = (float(LNP2x3[125]+LNt[241]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[13,36]<<138
  LNt[241] -= LNt[242];
  LNt[243] = LNt[175]*LNt[81]-LNt[88]*LNt[203]+LNt[242];
  LNt[244] = LNt[28]*LNt[147]+LNt[31]*LNt[144]+LNt[32]*LNt[141]+LNt[164]*LNt[229]+LNt[167]*LNt[226]+LNt[168]*LNt[223];
  LNt[245] = LNt[28]*LNt[150]+LNt[31]*LNt[147]+LNt[32]*LNt[144]+LNt[164]*LNt[232]+LNt[167]*LNt[229]+LNt[168]*LNt[226];
  LNt[246] = LNt[28]*LNt[153]+LNt[31]*LNt[150]+LNt[32]*LNt[147]+LNt[164]*LNt[235]+LNt[167]*LNt[232]+LNt[168]*LNt[229];
  LNt[247] = LNt[28]*LNt[156]+LNt[31]*LNt[153]+LNt[32]*LNt[150]+LNt[164]*LNt[238]+LNt[167]*LNt[235]+LNt[168]*LNt[232];
  LNt[248] = LNt[28]*LNt[159]+LNt[31]*LNt[156]+LNt[32]*LNt[153]+LNt[164]*LNt[241]+LNt[167]*LNt[238]+LNt[168]*LNt[235];
  LNt[249] = LNt[28]*LNt[161]+LNt[31]*LNt[159]+LNt[32]*LNt[156]+LNt[164]*LNt[243]+LNt[167]*LNt[241]+LNt[168]*LNt[238];
  LNt[250] = d.z;
  LNt[251] = float(LNP2x3[74]+LNt[250])-LNP2x3[74];	//[1,53]<<0
  LNt[250] -= LNt[251];
  LNt[252] = LNt[250]-LNt[44];
  LNt[253] = float(LNP2x3[53]+LNt[252])-LNP2x3[53];	//[22,53]<<0
  LNt[252] -= LNt[253];
  LNt[254] = float(LNP2x3[45]+LNt[252])-LNP2x3[45];	//[8,31]<<0
  LNt[252] -= LNt[254];
  LNt[255] = LNt[251]-LNt[45]+LNt[253]+LNt[254];
  LNt[256] = float(LNP2x3[68]+LNt[255])-LNP2x3[68];	//[7,30]<<23
  LNt[255] -= LNt[256];
  LNt[257] = LNt[171]*LNt[110]+LNt[174]*LNt[107]+LNt[175]*LNt[104]-(LNt[37]*LNt[197]+LNt[40]*LNt[194]+LNt[41]*LNt[191]);
  LNt[258] = LNt[171]*LNt[113]+LNt[174]*LNt[110]+LNt[175]*LNt[107]-(LNt[37]*LNt[200]+LNt[40]*LNt[197]+LNt[41]*LNt[194]);
  LNt[259] = LNt[171]*LNt[115]+LNt[174]*LNt[113]+LNt[175]*LNt[110]-(LNt[37]*LNt[202]+LNt[40]*LNt[200]+LNt[41]*LNt[197]);
  LNt[260] = LNt[171]*LNt[116]+LNt[174]*LNt[115]+LNt[175]*LNt[113]-(LNt[37]*LNt[203]+LNt[40]*LNt[202]+LNt[41]*LNt[200]);
  LNt[261] = LNt[178]*LNt[102]+LNt[181]*LNt[101]+LNt[182]*LNt[98]-(LNt[91]*LNt[189]+LNt[94]*LNt[188]+LNt[95]*LNt[185]);
  LNt[262] = LNt[178]*LNt[98]-LNt[91]*LNt[185];
  LNt[263] = float(LNP2x3[47]+LNt[262])-LNP2x3[47];	//[22,47]<<0
  LNt[262] -= LNt[263];
  LNt[264] = float(LNP2x3[45]+LNt[262])-LNP2x3[45];	//[2,25]<<0
  LNt[262] -= LNt[264];
  LNt[265] = LNt[178]*LNt[101]+LNt[181]*LNt[98]-(LNt[91]*LNt[188]+LNt[94]*LNt[185])+LNt[263]+LNt[264];
  LNt[266] = float(LNP2x3[71]+LNt[265])-LNP2x3[71];	//[22,48]<<23
  LNt[265] -= LNt[266];
  LNt[267] = float(LNP2x3[68]+LNt[265])-LNP2x3[68];	//[3,26]<<23
  LNt[265] -= LNt[267];
  LNt[268] = LNt[261]+LNt[266]+LNt[267];
  LNt[269] = float(LNP2x3[95]+LNt[268])-LNP2x3[95];	//[22,49]<<46
  LNt[268] -= LNt[269];
  LNt[270] = float(LNP2x3[91]+LNt[268])-LNP2x3[91];	//[4,27]<<46
  LNt[268] -= LNt[270];
  LNt[271] = LNt[181]*LNt[102]+LNt[182]*LNt[101]-(LNt[94]*LNt[189]+LNt[95]*LNt[188])+LNt[269]+LNt[270];
  LNt[272] = float(LNP2x3[114]+LNt[271])-LNP2x3[114];	//[9,32]<<69
  LNt[271] -= LNt[272];
  LNt[273] = LNt[182]*LNt[102]-LNt[95]*LNt[189]+LNt[272];
  LNt[274] = LNt[171]*LNt[107]+LNt[174]*LNt[104]-(LNt[37]*LNt[194]+LNt[40]*LNt[191])+LNt[121]*LNt[265]+LNt[123]*LNt[262];
  LNt[275] = LNt[174]*LNt[116]+LNt[175]*LNt[115]-(LNt[40]*LNt[203]+LNt[41]*LNt[202])+LNt[125]*LNt[273];
  LNt[276] = LNt[171]*LNt[104]-LNt[37]*LNt[191]+LNt[121]*LNt[262];
  LNt[277] = float(LNP2x3[48]+LNt[276])-LNP2x3[48];	//[22,48]<<0
  LNt[276] -= LNt[277];
  LNt[278] = float(LNP2x3[45]+LNt[276])-LNP2x3[45];	//[3,26]<<0
  LNt[276] -= LNt[278];
  LNt[279] = LNt[274]+LNt[277]+LNt[278];
  LNt[280] = float(LNP2x3[72]+LNt[279])-LNP2x3[72];	//[22,49]<<23
  LNt[279] -= LNt[280];
  LNt[281] = float(LNP2x3[68]+LNt[279])-LNP2x3[68];	//[4,27]<<23
  LNt[279] -= LNt[281];
  LNt[282] = LNt[257]+LNt[121]*LNt[268]+LNt[123]*LNt[265]+LNt[125]*LNt[262]+LNt[280]+LNt[281];
  LNt[283] = float(LNP2x3[96]+LNt[282])-LNP2x3[96];	//[22,50]<<46
  LNt[282] -= LNt[283];
  LNt[284] = float(LNP2x3[91]+LNt[282])-LNP2x3[91];	//[5,28]<<46
  LNt[282] -= LNt[284];
  LNt[285] = LNt[258]+LNt[121]*LNt[271]+LNt[123]*LNt[268]+LNt[125]*LNt[265]+LNt[283]+LNt[284];
  LNt[286] = float(LNP2x3[119]+LNt[285])-LNP2x3[119];	//[22,50]<<69
  LNt[285] -= LNt[286];
  LNt[287] = float(LNP2x3[114]+LNt[285])-LNP2x3[114];	//[5,28]<<69
  LNt[285] -= LNt[287];
  LNt[288] = LNt[259]+LNt[121]*LNt[273]+LNt[123]*LNt[271]+LNt[125]*LNt[268]+LNt[286]+LNt[287];
  LNt[289] = (float(LNP2x3[125]+LNt[288]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[288] -= LNt[289];
  LNt[290] = (float(LNP2x3[125]+LNt[288]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[288] -= LNt[290];
  LNt[291] = LNt[260]+LNt[123]*LNt[273]+LNt[125]*LNt[271]+LNt[289]+LNt[290];
  LNt[292] = (float(LNP2x3[125]+LNt[291]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
  LNt[291] -= LNt[292];
  LNt[293] = (float(LNP2x3[125]+LNt[291]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
  LNt[291] -= LNt[293];
  LNt[294] = LNt[275]+LNt[292]+LNt[293];
  LNt[295] = (float(LNP2x3[125]+LNt[294]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[13,36]<<138
  LNt[294] -= LNt[295];
  LNt[296] = LNt[175]*LNt[116]-LNt[41]*LNt[203]+LNt[295];
  LNt[297] = LNt[28]*LNt[144]+LNt[31]*LNt[141]+LNt[164]*LNt[226]+LNt[167]*LNt[223]-(LNt[252]*LNt[279]+LNt[255]*LNt[276]);
  LNt[298] = LNt[31]*LNt[161]+LNt[32]*LNt[159]+LNt[167]*LNt[243]+LNt[168]*LNt[241]-(LNt[255]*LNt[296]+LNt[256]*LNt[294]);
  LNt[299] = d.w.v0-e.w.v0;
  LNt[300] = float(LNP2x3[45]+LNt[299])-LNP2x3[45];	//[1,24]<<0
  LNt[299] -= LNt[300];
  LNt[301] = d.w.v1-e.w.v1+LNt[300];
  LNt[302] = float(LNP2x3[68]+LNt[301])-LNP2x3[68];	//[1,24]<<23
  LNt[301] -= LNt[302];
  LNt[303] = LNt[171]*LNt[133]+LNt[174]*LNt[130]+LNt[175]*LNt[127]-(LNt[37]*LNt[215]+LNt[40]*LNt[212]+LNt[41]*LNt[209]);
  LNt[304] = LNt[171]*LNt[136]+LNt[174]*LNt[133]+LNt[175]*LNt[130]-(LNt[37]*LNt[218]+LNt[40]*LNt[215]+LNt[41]*LNt[212]);
  LNt[305] = LNt[171]*LNt[138]+LNt[174]*LNt[136]+LNt[175]*LNt[133]-(LNt[37]*LNt[220]+LNt[40]*LNt[218]+LNt[41]*LNt[215]);
  LNt[306] = LNt[171]*LNt[130]+LNt[174]*LNt[127]-(LNt[37]*LNt[212]+LNt[40]*LNt[209])+LNt[84]*LNt[265]+LNt[87]*LNt[262];
  LNt[307] = LNt[174]*LNt[138]+LNt[175]*LNt[136]-(LNt[40]*LNt[220]+LNt[41]*LNt[218])+LNt[87]*LNt[273]+LNt[88]*LNt[271];
  LNt[308] = LNt[171]*LNt[127]-LNt[37]*LNt[209]+LNt[84]*LNt[262];
  LNt[309] = float(LNP2x3[48]+LNt[308])-LNP2x3[48];	//[22,48]<<0
  LNt[308] -= LNt[309];
  LNt[310] = float(LNP2x3[45]+LNt[308])-LNP2x3[45];	//[3,26]<<0
  LNt[308] -= LNt[310];
  LNt[311] = LNt[306]+LNt[309]+LNt[310];
  LNt[312] = float(LNP2x3[72]+LNt[311])-LNP2x3[72];	//[22,49]<<23
  LNt[311] -= LNt[312];
  LNt[313] = float(LNP2x3[68]+LNt[311])-LNP2x3[68];	//[4,27]<<23
  LNt[311] -= LNt[313];
  LNt[314] = LNt[303]+LNt[84]*LNt[268]+LNt[87]*LNt[265]+LNt[88]*LNt[262]+LNt[312]+LNt[313];
  LNt[315] = float(LNP2x3[96]+LNt[314])-LNP2x3[96];	//[22,50]<<46
  LNt[314] -= LNt[315];
  LNt[316] = float(LNP2x3[91]+LNt[314])-LNP2x3[91];	//[5,28]<<46
  LNt[314] -= LNt[316];
  LNt[317] = LNt[304]+LNt[84]*LNt[271]+LNt[87]*LNt[268]+LNt[88]*LNt[265]+LNt[315]+LNt[316];
  LNt[318] = float(LNP2x3[119]+LNt[317])-LNP2x3[119];	//[22,50]<<69
  LNt[317] -= LNt[318];
  LNt[319] = float(LNP2x3[114]+LNt[317])-LNP2x3[114];	//[5,28]<<69
  LNt[317] -= LNt[319];
  LNt[320] = LNt[305]+LNt[84]*LNt[273]+LNt[87]*LNt[271]+LNt[88]*LNt[268]+LNt[318]+LNt[319];
  LNt[321] = (float(LNP2x3[125]+LNt[320]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
  LNt[320] -= LNt[321];
  LNt[322] = (float(LNP2x3[125]+LNt[320]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
  LNt[320] -= LNt[322];
  LNt[323] = LNt[307]+LNt[321]+LNt[322];
  LNt[324] = (float(LNP2x3[125]+LNt[323]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
  LNt[323] -= LNt[324];
  LNt[325] = LNt[175]*LNt[138]-LNt[41]*LNt[220]+LNt[88]*LNt[273]+LNt[324];
  LNt[326] = (float(LNP2x3[125]+LNt[325]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[325] -= LNt[326];
  LNt[327] = d.w.v2-e.w.v2+LNt[302];
  LNt[328] = LNt[244]-(LNt[252]*LNt[282]+LNt[255]*LNt[279]+LNt[256]*LNt[276])+LNt[299]*LNt[314]+LNt[301]*LNt[311]+LNt[327]*LNt[308];
  LNt[329] = LNt[245]-(LNt[252]*LNt[285]+LNt[255]*LNt[282]+LNt[256]*LNt[279])+LNt[299]*LNt[317]+LNt[301]*LNt[314]+LNt[327]*LNt[311];
  LNt[330] = LNt[246]-(LNt[252]*LNt[288]+LNt[255]*LNt[285]+LNt[256]*LNt[282])+LNt[299]*LNt[320]+LNt[301]*LNt[317]+LNt[327]*LNt[314];
  LNt[331] = LNt[247]-(LNt[252]*LNt[291]+LNt[255]*LNt[288]+LNt[256]*LNt[285])+LNt[299]*LNt[323]+LNt[301]*LNt[320]+LNt[327]*LNt[317];
  LNt[332] = LNt[248]-(LNt[252]*LNt[294]+LNt[255]*LNt[291]+LNt[256]*LNt[288])+LNt[299]*LNt[325]+LNt[301]*LNt[323]+LNt[327]*LNt[320];
  LNt[333] = LNt[249]-(LNt[252]*LNt[296]+LNt[255]*LNt[294]+LNt[256]*LNt[291])+LNt[299]*LNt[326]+LNt[301]*LNt[325]+LNt[327]*LNt[323];
  LNt[334] = LNt[28]*LNt[141]+LNt[164]*LNt[223]-LNt[252]*LNt[276]+LNt[299]*LNt[308];
  LNt[335] = LNt[297]+LNt[299]*LNt[311]+LNt[301]*LNt[308];
  LNt[336] = LNt[298]+LNt[301]*LNt[326]+LNt[327]*LNt[325];
  LNt[337] = LNt[32]*LNt[161]+LNt[168]*LNt[243]-LNt[256]*LNt[296]+LNt[327]*LNt[326];
  LNt[338] = (((((((LNt[337])+LNt[336])+LNt[333])+LNt[332])+LNt[331])+LNt[330])+LNt[329])+LNt[328];
  LNt[21] = (((LNt[338])+LNt[335])+LNt[334]);
}
if (LNt[21]<0){
  LNt[0] = -1.;
}else{
  if (LNt[21]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=547 multiplies=430 normalizes=156 */


WeightedIncircle3dHyperPlane::WeightedIncircle3dHyperPlane(const WPoint3d& a, const WPoint3d& b, const WPoint3d& c, const WPoint3d& d){
LNt[0] = d.y;
LNt[1] = float(LNP2x3[53]+LNt[0])-LNP2x3[53];	//[22,53]<<0
LNt[0] -= LNt[1];
LNt[2] = float(LNP2x3[45]+LNt[0])-LNP2x3[45];	//[8,31]<<0
LNt[0] -= LNt[2];
LNt[3] = LNt[1]+LNt[2];
LNt[4] = float(LNP2x3[68]+LNt[3])-LNP2x3[68];	//[7,30]<<23
LNt[3] -= LNt[4];
LNt[5] = c.z;
LNt[6] = float(LNP2x3[53]+LNt[5])-LNP2x3[53];	//[22,53]<<0
LNt[5] -= LNt[6];
LNt[7] = float(LNP2x3[45]+LNt[5])-LNP2x3[45];	//[8,31]<<0
LNt[5] -= LNt[7];
LNt[8] = LNt[6]+LNt[7];
LNt[9] = float(LNP2x3[68]+LNt[8])-LNP2x3[68];	//[7,30]<<23
LNt[8] -= LNt[9];
LNt[10] = a.x;
LNt[11] = float(LNP2x3[53]+LNt[10])-LNP2x3[53];	//[22,53]<<0
LNt[10] -= LNt[11];
LNt[12] = float(LNP2x3[45]+LNt[10])-LNP2x3[45];	//[8,31]<<0
LNt[10] -= LNt[12];
LNt[13] = LNt[11]+LNt[12];
LNt[14] = float(LNP2x3[68]+LNt[13])-LNP2x3[68];	//[7,30]<<23
LNt[13] -= LNt[14];
LNt[15] = a.y;
LNt[16] = float(LNP2x3[53]+LNt[15])-LNP2x3[53];	//[22,53]<<0
LNt[15] -= LNt[16];
LNt[17] = float(LNP2x3[45]+LNt[15])-LNP2x3[45];	//[8,31]<<0
LNt[15] -= LNt[17];
LNt[18] = LNt[16]+LNt[17];
LNt[19] = float(LNP2x3[68]+LNt[18])-LNP2x3[68];	//[7,30]<<23
LNt[18] -= LNt[19];
LNt[20] = LNt[10]*LNt[14]+LNt[13]*LNt[13]+LNt[14]*LNt[10]+LNt[15]*LNt[19]+LNt[18]*LNt[18]+LNt[19]*LNt[15];
LNt[21] = a.z;
LNt[22] = float(LNP2x3[53]+LNt[21])-LNP2x3[53];	//[22,53]<<0
LNt[21] -= LNt[22];
LNt[23] = float(LNP2x3[45]+LNt[21])-LNP2x3[45];	//[8,31]<<0
LNt[21] -= LNt[23];
LNt[24] = LNt[22]+LNt[23];
LNt[25] = float(LNP2x3[68]+LNt[24])-LNP2x3[68];	//[7,30]<<23
LNt[24] -= LNt[25];
LNt[26] = LNt[10]*LNt[13]+LNt[13]*LNt[10]+LNt[15]*LNt[18]+LNt[18]*LNt[15]+LNt[21]*LNt[24]+LNt[24]*LNt[21];
LNt[27] = LNt[13]*LNt[14]+LNt[14]*LNt[13]+LNt[18]*LNt[19]+LNt[19]*LNt[18]+LNt[24]*LNt[25]+LNt[25]*LNt[24];
LNt[28] = a.w;
LNt[29] = float(LNP2x3[74]+LNt[28])-LNP2x3[74];	//[1,53]<<0
LNt[28] -= LNt[29];
LNt[30] = LNt[10]*LNt[10]+LNt[15]*LNt[15]+LNt[21]*LNt[21]-LNt[28];
LNt[31] = float(LNP2x3[53]+LNt[30])-LNP2x3[53];	//[22,53]<<0
LNt[30] -= LNt[31];
LNt[32] = float(LNP2x3[45]+LNt[30])-LNP2x3[45];	//[8,31]<<0
LNt[30] -= LNt[32];
LNt[33] = LNt[26]-LNt[29]+LNt[31]+LNt[32];
LNt[34] = float(LNP2x3[73]+LNt[33])-LNP2x3[73];	//[22,50]<<23
LNt[33] -= LNt[34];
LNt[35] = float(LNP2x3[68]+LNt[33])-LNP2x3[68];	//[5,28]<<23
LNt[33] -= LNt[35];
LNt[36] = LNt[20]+LNt[21]*LNt[25]+LNt[24]*LNt[24]+LNt[25]*LNt[21]+LNt[34]+LNt[35];
LNt[37] = float(LNP2x3[96]+LNt[36])-LNP2x3[96];	//[22,50]<<46
LNt[36] -= LNt[37];
LNt[38] = float(LNP2x3[91]+LNt[36])-LNP2x3[91];	//[5,28]<<46
LNt[36] -= LNt[38];
LNt[39] = LNt[27]+LNt[37]+LNt[38];
LNt[40] = float(LNP2x3[114]+LNt[39])-LNP2x3[114];	//[10,33]<<69
LNt[39] -= LNt[40];
LNt[41] = LNt[14]*LNt[14]+LNt[19]*LNt[19]+LNt[25]*LNt[25]+LNt[40];
LNt[42] = b.x;
LNt[43] = float(LNP2x3[53]+LNt[42])-LNP2x3[53];	//[22,53]<<0
LNt[42] -= LNt[43];
LNt[44] = float(LNP2x3[45]+LNt[42])-LNP2x3[45];	//[8,31]<<0
LNt[42] -= LNt[44];
LNt[45] = LNt[43]+LNt[44];
LNt[46] = float(LNP2x3[68]+LNt[45])-LNP2x3[68];	//[7,30]<<23
LNt[45] -= LNt[46];
LNt[47] = b.y;
LNt[48] = float(LNP2x3[53]+LNt[47])-LNP2x3[53];	//[22,53]<<0
LNt[47] -= LNt[48];
LNt[49] = float(LNP2x3[45]+LNt[47])-LNP2x3[45];	//[8,31]<<0
LNt[47] -= LNt[49];
LNt[50] = LNt[48]+LNt[49];
LNt[51] = float(LNP2x3[68]+LNt[50])-LNP2x3[68];	//[7,30]<<23
LNt[50] -= LNt[51];
LNt[52] = LNt[42]*LNt[46]+LNt[45]*LNt[45]+LNt[46]*LNt[42]+LNt[47]*LNt[51]+LNt[50]*LNt[50]+LNt[51]*LNt[47];
LNt[53] = b.z;
LNt[54] = float(LNP2x3[53]+LNt[53])-LNP2x3[53];	//[22,53]<<0
LNt[53] -= LNt[54];
LNt[55] = float(LNP2x3[45]+LNt[53])-LNP2x3[45];	//[8,31]<<0
LNt[53] -= LNt[55];
LNt[56] = LNt[54]+LNt[55];
LNt[57] = float(LNP2x3[68]+LNt[56])-LNP2x3[68];	//[7,30]<<23
LNt[56] -= LNt[57];
LNt[58] = LNt[42]*LNt[45]+LNt[45]*LNt[42]+LNt[47]*LNt[50]+LNt[50]*LNt[47]+LNt[53]*LNt[56]+LNt[56]*LNt[53];
LNt[59] = LNt[45]*LNt[46]+LNt[46]*LNt[45]+LNt[50]*LNt[51]+LNt[51]*LNt[50]+LNt[56]*LNt[57]+LNt[57]*LNt[56];
LNt[60] = b.w;
LNt[61] = float(LNP2x3[74]+LNt[60])-LNP2x3[74];	//[1,53]<<0
LNt[60] -= LNt[61];
LNt[62] = LNt[42]*LNt[42]+LNt[47]*LNt[47]+LNt[53]*LNt[53]-LNt[60];
LNt[63] = float(LNP2x3[53]+LNt[62])-LNP2x3[53];	//[22,53]<<0
LNt[62] -= LNt[63];
LNt[64] = float(LNP2x3[45]+LNt[62])-LNP2x3[45];	//[8,31]<<0
LNt[62] -= LNt[64];
LNt[65] = LNt[58]-LNt[61]+LNt[63]+LNt[64];
LNt[66] = float(LNP2x3[73]+LNt[65])-LNP2x3[73];	//[22,50]<<23
LNt[65] -= LNt[66];
LNt[67] = float(LNP2x3[68]+LNt[65])-LNP2x3[68];	//[5,28]<<23
LNt[65] -= LNt[67];
LNt[68] = LNt[52]+LNt[53]*LNt[57]+LNt[56]*LNt[56]+LNt[57]*LNt[53]+LNt[66]+LNt[67];
LNt[69] = float(LNP2x3[96]+LNt[68])-LNP2x3[96];	//[22,50]<<46
LNt[68] -= LNt[69];
LNt[70] = float(LNP2x3[91]+LNt[68])-LNP2x3[91];	//[5,28]<<46
LNt[68] -= LNt[70];
LNt[71] = LNt[59]+LNt[69]+LNt[70];
LNt[72] = float(LNP2x3[114]+LNt[71])-LNP2x3[114];	//[10,33]<<69
LNt[71] -= LNt[72];
LNt[73] = LNt[46]*LNt[46]+LNt[51]*LNt[51]+LNt[57]*LNt[57]+LNt[72];
LNt[74] = LNt[30]-LNt[62];
LNt[75] = float(LNP2x3[45]+LNt[74])-LNP2x3[45];	//[1,24]<<0
LNt[74] -= LNt[75];
LNt[76] = LNt[33]-LNt[65]+LNt[75];
LNt[77] = float(LNP2x3[68]+LNt[76])-LNP2x3[68];	//[1,24]<<23
LNt[76] -= LNt[77];
LNt[78] = LNt[36]-LNt[68]+LNt[77];
LNt[79] = float(LNP2x3[91]+LNt[78])-LNP2x3[91];	//[1,24]<<46
LNt[78] -= LNt[79];
LNt[80] = LNt[39]-LNt[71]+LNt[79];
LNt[81] = float(LNP2x3[114]+LNt[80])-LNP2x3[114];	//[1,24]<<69
LNt[80] -= LNt[81];
LNt[82] = LNt[41]-LNt[73]+LNt[81];
LNt[83] = c.x;
LNt[84] = float(LNP2x3[53]+LNt[83])-LNP2x3[53];	//[22,53]<<0
LNt[83] -= LNt[84];
LNt[85] = float(LNP2x3[45]+LNt[83])-LNP2x3[45];	//[8,31]<<0
LNt[83] -= LNt[85];
LNt[86] = LNt[84]+LNt[85];
LNt[87] = float(LNP2x3[68]+LNt[86])-LNP2x3[68];	//[7,30]<<23
LNt[86] -= LNt[87];
LNt[88] = c.y;
LNt[89] = float(LNP2x3[53]+LNt[88])-LNP2x3[53];	//[22,53]<<0
LNt[88] -= LNt[89];
LNt[90] = float(LNP2x3[45]+LNt[88])-LNP2x3[45];	//[8,31]<<0
LNt[88] -= LNt[90];
LNt[91] = LNt[89]+LNt[90];
LNt[92] = float(LNP2x3[68]+LNt[91])-LNP2x3[68];	//[7,30]<<23
LNt[91] -= LNt[92];
LNt[93] = LNt[83]*LNt[87]+LNt[86]*LNt[86]+LNt[87]*LNt[83]+LNt[88]*LNt[92]+LNt[91]*LNt[91]+LNt[92]*LNt[88];
LNt[94] = LNt[83]*LNt[86]+LNt[86]*LNt[83]+LNt[88]*LNt[91]+LNt[91]*LNt[88]+LNt[5]*LNt[8]+LNt[8]*LNt[5];
LNt[95] = LNt[86]*LNt[87]+LNt[87]*LNt[86]+LNt[91]*LNt[92]+LNt[92]*LNt[91]+LNt[8]*LNt[9]+LNt[9]*LNt[8];
LNt[96] = c.w;
LNt[97] = float(LNP2x3[74]+LNt[96])-LNP2x3[74];	//[1,53]<<0
LNt[96] -= LNt[97];
LNt[98] = LNt[83]*LNt[83]+LNt[88]*LNt[88]+LNt[5]*LNt[5]-LNt[96];
LNt[99] = float(LNP2x3[53]+LNt[98])-LNP2x3[53];	//[22,53]<<0
LNt[98] -= LNt[99];
LNt[100] = float(LNP2x3[45]+LNt[98])-LNP2x3[45];	//[8,31]<<0
LNt[98] -= LNt[100];
LNt[101] = LNt[94]-LNt[97]+LNt[99]+LNt[100];
LNt[102] = float(LNP2x3[73]+LNt[101])-LNP2x3[73];	//[22,50]<<23
LNt[101] -= LNt[102];
LNt[103] = float(LNP2x3[68]+LNt[101])-LNP2x3[68];	//[5,28]<<23
LNt[101] -= LNt[103];
LNt[104] = LNt[93]+LNt[5]*LNt[9]+LNt[8]*LNt[8]+LNt[9]*LNt[5]+LNt[102]+LNt[103];
LNt[105] = float(LNP2x3[96]+LNt[104])-LNP2x3[96];	//[22,50]<<46
LNt[104] -= LNt[105];
LNt[106] = float(LNP2x3[91]+LNt[104])-LNP2x3[91];	//[5,28]<<46
LNt[104] -= LNt[106];
LNt[107] = LNt[95]+LNt[105]+LNt[106];
LNt[108] = float(LNP2x3[114]+LNt[107])-LNP2x3[114];	//[10,33]<<69
LNt[107] -= LNt[108];
LNt[109] = LNt[87]*LNt[87]+LNt[92]*LNt[92]+LNt[9]*LNt[9]+LNt[108];
LNt[110] = LNt[21]-LNt[53];
LNt[111] = float(LNP2x3[45]+LNt[110])-LNP2x3[45];	//[1,24]<<0
LNt[110] -= LNt[111];
LNt[112] = LNt[24]-LNt[56]+LNt[111];
LNt[113] = float(LNP2x3[68]+LNt[112])-LNP2x3[68];	//[1,24]<<23
LNt[112] -= LNt[113];
LNt[114] = LNt[25]-LNt[57]+LNt[113];
LNt[115] = LNt[5]*LNt[78]+LNt[8]*LNt[76]+LNt[9]*LNt[74]-(LNt[98]*LNt[114]+LNt[101]*LNt[112]+LNt[104]*LNt[110]);
LNt[116] = LNt[5]*LNt[80]+LNt[8]*LNt[78]+LNt[9]*LNt[76]-(LNt[101]*LNt[114]+LNt[104]*LNt[112]+LNt[107]*LNt[110]);
LNt[117] = LNt[5]*LNt[82]+LNt[8]*LNt[80]+LNt[9]*LNt[78]-(LNt[104]*LNt[114]+LNt[107]*LNt[112]+LNt[109]*LNt[110]);
LNt[118] = LNt[21]*LNt[68]+LNt[24]*LNt[65]+LNt[25]*LNt[62]-(LNt[53]*LNt[36]+LNt[56]*LNt[33]+LNt[57]*LNt[30]);
LNt[119] = LNt[21]*LNt[71]+LNt[24]*LNt[68]+LNt[25]*LNt[65]-(LNt[53]*LNt[39]+LNt[56]*LNt[36]+LNt[57]*LNt[33]);
LNt[120] = LNt[21]*LNt[73]+LNt[24]*LNt[71]+LNt[25]*LNt[68]-(LNt[53]*LNt[41]+LNt[56]*LNt[39]+LNt[57]*LNt[36]);
LNt[121] = LNt[21]*LNt[62]-LNt[53]*LNt[30];
LNt[122] = float(LNP2x3[47]+LNt[121])-LNP2x3[47];	//[22,47]<<0
LNt[121] -= LNt[122];
LNt[123] = float(LNP2x3[45]+LNt[121])-LNP2x3[45];	//[2,25]<<0
LNt[121] -= LNt[123];
LNt[124] = LNt[21]*LNt[65]+LNt[24]*LNt[62]-(LNt[53]*LNt[33]+LNt[56]*LNt[30])+LNt[122]+LNt[123];
LNt[125] = float(LNP2x3[71]+LNt[124])-LNP2x3[71];	//[22,48]<<23
LNt[124] -= LNt[125];
LNt[126] = float(LNP2x3[68]+LNt[124])-LNP2x3[68];	//[3,26]<<23
LNt[124] -= LNt[126];
LNt[127] = LNt[118]+LNt[125]+LNt[126];
LNt[128] = float(LNP2x3[95]+LNt[127])-LNP2x3[95];	//[22,49]<<46
LNt[127] -= LNt[128];
LNt[129] = float(LNP2x3[91]+LNt[127])-LNP2x3[91];	//[4,27]<<46
LNt[127] -= LNt[129];
LNt[130] = LNt[119]+LNt[128]+LNt[129];
LNt[131] = float(LNP2x3[118]+LNt[130])-LNP2x3[118];	//[22,49]<<69
LNt[130] -= LNt[131];
LNt[132] = float(LNP2x3[114]+LNt[130])-LNP2x3[114];	//[4,27]<<69
LNt[130] -= LNt[132];
LNt[133] = LNt[120]+LNt[131]+LNt[132];
LNt[134] = (float(LNP2x3[125]+LNt[133]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
LNt[133] -= LNt[134];
LNt[135] = (float(LNP2x3[125]+LNt[133]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
LNt[133] -= LNt[135];
LNt[136] = LNt[24]*LNt[73]+LNt[25]*LNt[71]-(LNt[56]*LNt[41]+LNt[57]*LNt[39])+LNt[134]+LNt[135];
LNt[137] = (float(LNP2x3[125]+LNt[136]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[136] -= LNt[137];
LNt[138] = LNt[25]*LNt[73]-LNt[57]*LNt[41]+LNt[137];
LNt[139] = (float(LNP2x3[125]+LNt[138]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[138] -= LNt[139];
LNt[140] = LNt[5]*LNt[74]-LNt[98]*LNt[110]+LNt[121];
LNt[141] = float(LNP2x3[48]+LNt[140])-LNP2x3[48];	//[22,48]<<0
LNt[140] -= LNt[141];
LNt[142] = float(LNP2x3[45]+LNt[140])-LNP2x3[45];	//[3,26]<<0
LNt[140] -= LNt[142];
LNt[143] = LNt[5]*LNt[76]+LNt[8]*LNt[74]-(LNt[98]*LNt[112]+LNt[101]*LNt[110])+LNt[124]+LNt[141]+LNt[142];
LNt[144] = float(LNP2x3[72]+LNt[143])-LNP2x3[72];	//[22,49]<<23
LNt[143] -= LNt[144];
LNt[145] = float(LNP2x3[68]+LNt[143])-LNP2x3[68];	//[4,27]<<23
LNt[143] -= LNt[145];
LNt[146] = LNt[115]+LNt[127]+LNt[144]+LNt[145];
LNt[147] = float(LNP2x3[96]+LNt[146])-LNP2x3[96];	//[22,50]<<46
LNt[146] -= LNt[147];
LNt[148] = float(LNP2x3[91]+LNt[146])-LNP2x3[91];	//[5,28]<<46
LNt[146] -= LNt[148];
LNt[149] = LNt[116]+LNt[130]+LNt[147]+LNt[148];
LNt[150] = float(LNP2x3[119]+LNt[149])-LNP2x3[119];	//[22,50]<<69
LNt[149] -= LNt[150];
LNt[151] = float(LNP2x3[114]+LNt[149])-LNP2x3[114];	//[5,28]<<69
LNt[149] -= LNt[151];
LNt[152] = LNt[117]+LNt[133]+LNt[150]+LNt[151];
LNt[153] = (float(LNP2x3[125]+LNt[152]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[152] -= LNt[153];
LNt[154] = (float(LNP2x3[125]+LNt[152]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[152] -= LNt[154];
LNt[155] = LNt[8]*LNt[82]+LNt[9]*LNt[80]-(LNt[107]*LNt[114]+LNt[109]*LNt[112])+LNt[136]+LNt[153]+LNt[154];
LNt[156] = (float(LNP2x3[125]+LNt[155]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
LNt[155] -= LNt[156];
LNt[157] = LNt[9]*LNt[82]-LNt[109]*LNt[114]+LNt[138]+LNt[156];
LNt[158] = (float(LNP2x3[125]+LNt[157]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
LNt[157] -= LNt[158];
LNt[159] = LNt[139]+LNt[158];
LNt[160] = d.z;
LNt[161] = float(LNP2x3[53]+LNt[160])-LNP2x3[53];	//[22,53]<<0
LNt[160] -= LNt[161];
LNt[162] = float(LNP2x3[45]+LNt[160])-LNP2x3[45];	//[8,31]<<0
LNt[160] -= LNt[162];
LNt[163] = LNt[161]+LNt[162];
LNt[164] = float(LNP2x3[68]+LNt[163])-LNP2x3[68];	//[7,30]<<23
LNt[163] -= LNt[164];
LNt[165] = LNt[15]-LNt[47];
LNt[166] = float(LNP2x3[45]+LNt[165])-LNP2x3[45];	//[1,24]<<0
LNt[165] -= LNt[166];
LNt[167] = LNt[18]-LNt[50]+LNt[166];
LNt[168] = float(LNP2x3[68]+LNt[167])-LNP2x3[68];	//[1,24]<<23
LNt[167] -= LNt[168];
LNt[169] = LNt[19]-LNt[51]+LNt[168];
LNt[170] = LNt[88]*LNt[78]+LNt[91]*LNt[76]+LNt[92]*LNt[74]-(LNt[98]*LNt[169]+LNt[101]*LNt[167]+LNt[104]*LNt[165]);
LNt[171] = LNt[88]*LNt[80]+LNt[91]*LNt[78]+LNt[92]*LNt[76]-(LNt[101]*LNt[169]+LNt[104]*LNt[167]+LNt[107]*LNt[165]);
LNt[172] = LNt[88]*LNt[82]+LNt[91]*LNt[80]+LNt[92]*LNt[78]-(LNt[104]*LNt[169]+LNt[107]*LNt[167]+LNt[109]*LNt[165]);
LNt[173] = LNt[15]*LNt[68]+LNt[18]*LNt[65]+LNt[19]*LNt[62]-(LNt[47]*LNt[36]+LNt[50]*LNt[33]+LNt[51]*LNt[30]);
LNt[174] = LNt[15]*LNt[71]+LNt[18]*LNt[68]+LNt[19]*LNt[65]-(LNt[47]*LNt[39]+LNt[50]*LNt[36]+LNt[51]*LNt[33]);
LNt[175] = LNt[15]*LNt[73]+LNt[18]*LNt[71]+LNt[19]*LNt[68]-(LNt[47]*LNt[41]+LNt[50]*LNt[39]+LNt[51]*LNt[36]);
LNt[176] = LNt[15]*LNt[62]-LNt[47]*LNt[30];
LNt[177] = float(LNP2x3[47]+LNt[176])-LNP2x3[47];	//[22,47]<<0
LNt[176] -= LNt[177];
LNt[178] = float(LNP2x3[45]+LNt[176])-LNP2x3[45];	//[2,25]<<0
LNt[176] -= LNt[178];
LNt[179] = LNt[15]*LNt[65]+LNt[18]*LNt[62]-(LNt[47]*LNt[33]+LNt[50]*LNt[30])+LNt[177]+LNt[178];
LNt[180] = float(LNP2x3[71]+LNt[179])-LNP2x3[71];	//[22,48]<<23
LNt[179] -= LNt[180];
LNt[181] = float(LNP2x3[68]+LNt[179])-LNP2x3[68];	//[3,26]<<23
LNt[179] -= LNt[181];
LNt[182] = LNt[173]+LNt[180]+LNt[181];
LNt[183] = float(LNP2x3[95]+LNt[182])-LNP2x3[95];	//[22,49]<<46
LNt[182] -= LNt[183];
LNt[184] = float(LNP2x3[91]+LNt[182])-LNP2x3[91];	//[4,27]<<46
LNt[182] -= LNt[184];
LNt[185] = LNt[174]+LNt[183]+LNt[184];
LNt[186] = float(LNP2x3[118]+LNt[185])-LNP2x3[118];	//[22,49]<<69
LNt[185] -= LNt[186];
LNt[187] = float(LNP2x3[114]+LNt[185])-LNP2x3[114];	//[4,27]<<69
LNt[185] -= LNt[187];
LNt[188] = LNt[175]+LNt[186]+LNt[187];
LNt[189] = (float(LNP2x3[125]+LNt[188]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
LNt[188] -= LNt[189];
LNt[190] = (float(LNP2x3[125]+LNt[188]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
LNt[188] -= LNt[190];
LNt[191] = LNt[18]*LNt[73]+LNt[19]*LNt[71]-(LNt[50]*LNt[41]+LNt[51]*LNt[39])+LNt[189]+LNt[190];
LNt[192] = (float(LNP2x3[125]+LNt[191]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[191] -= LNt[192];
LNt[193] = LNt[19]*LNt[73]-LNt[51]*LNt[41]+LNt[192];
LNt[194] = (float(LNP2x3[125]+LNt[193]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[193] -= LNt[194];
LNt[195] = LNt[88]*LNt[74]-LNt[98]*LNt[165]+LNt[176];
LNt[196] = float(LNP2x3[48]+LNt[195])-LNP2x3[48];	//[22,48]<<0
LNt[195] -= LNt[196];
LNt[197] = float(LNP2x3[45]+LNt[195])-LNP2x3[45];	//[3,26]<<0
LNt[195] -= LNt[197];
LNt[198] = LNt[88]*LNt[76]+LNt[91]*LNt[74]-(LNt[98]*LNt[167]+LNt[101]*LNt[165])+LNt[179]+LNt[196]+LNt[197];
LNt[199] = float(LNP2x3[72]+LNt[198])-LNP2x3[72];	//[22,49]<<23
LNt[198] -= LNt[199];
LNt[200] = float(LNP2x3[68]+LNt[198])-LNP2x3[68];	//[4,27]<<23
LNt[198] -= LNt[200];
LNt[201] = LNt[170]+LNt[182]+LNt[199]+LNt[200];
LNt[202] = float(LNP2x3[96]+LNt[201])-LNP2x3[96];	//[22,50]<<46
LNt[201] -= LNt[202];
LNt[203] = float(LNP2x3[91]+LNt[201])-LNP2x3[91];	//[5,28]<<46
LNt[201] -= LNt[203];
LNt[204] = LNt[171]+LNt[185]+LNt[202]+LNt[203];
LNt[205] = float(LNP2x3[119]+LNt[204])-LNP2x3[119];	//[22,50]<<69
LNt[204] -= LNt[205];
LNt[206] = float(LNP2x3[114]+LNt[204])-LNP2x3[114];	//[5,28]<<69
LNt[204] -= LNt[206];
LNt[207] = LNt[172]+LNt[188]+LNt[205]+LNt[206];
LNt[208] = (float(LNP2x3[125]+LNt[207]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[207] -= LNt[208];
LNt[209] = (float(LNP2x3[125]+LNt[207]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[207] -= LNt[209];
LNt[210] = LNt[91]*LNt[82]+LNt[92]*LNt[80]-(LNt[107]*LNt[169]+LNt[109]*LNt[167])+LNt[191]+LNt[208]+LNt[209];
LNt[211] = (float(LNP2x3[125]+LNt[210]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
LNt[210] -= LNt[211];
LNt[212] = LNt[92]*LNt[82]-LNt[109]*LNt[169]+LNt[193]+LNt[211];
LNt[213] = (float(LNP2x3[125]+LNt[212]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
LNt[212] -= LNt[213];
LNt[214] = LNt[194]+LNt[213];
LNt[215] = LNt[0]*LNt[146]+LNt[3]*LNt[143]+LNt[4]*LNt[140]-(LNt[160]*LNt[201]+LNt[163]*LNt[198]+LNt[164]*LNt[195]);
LNt[216] = LNt[0]*LNt[149]+LNt[3]*LNt[146]+LNt[4]*LNt[143]-(LNt[160]*LNt[204]+LNt[163]*LNt[201]+LNt[164]*LNt[198]);
LNt[217] = LNt[0]*LNt[152]+LNt[3]*LNt[149]+LNt[4]*LNt[146]-(LNt[160]*LNt[207]+LNt[163]*LNt[204]+LNt[164]*LNt[201]);
LNt[218] = LNt[0]*LNt[155]+LNt[3]*LNt[152]+LNt[4]*LNt[149]-(LNt[160]*LNt[210]+LNt[163]*LNt[207]+LNt[164]*LNt[204]);
LNt[219] = LNt[0]*LNt[157]+LNt[3]*LNt[155]+LNt[4]*LNt[152]-(LNt[160]*LNt[212]+LNt[163]*LNt[210]+LNt[164]*LNt[207]);
LNt[220] = LNt[0]*LNt[159]+LNt[3]*LNt[157]+LNt[4]*LNt[155]-(LNt[160]*LNt[214]+LNt[163]*LNt[212]+LNt[164]*LNt[210]);
LNt[221] = d.x;
LNt[222] = float(LNP2x3[53]+LNt[221])-LNP2x3[53];	//[22,53]<<0
LNt[221] -= LNt[222];
LNt[223] = float(LNP2x3[45]+LNt[221])-LNP2x3[45];	//[8,31]<<0
LNt[221] -= LNt[223];
LNt[224] = LNt[222]+LNt[223];
LNt[225] = float(LNP2x3[68]+LNt[224])-LNP2x3[68];	//[7,30]<<23
LNt[224] -= LNt[225];
LNt[226] = LNt[221]*LNt[225]+LNt[224]*LNt[224]+LNt[225]*LNt[221]+LNt[0]*LNt[4]+LNt[3]*LNt[3]+LNt[4]*LNt[0];
LNt[227] = LNt[221]*LNt[224]+LNt[224]*LNt[221]+LNt[0]*LNt[3]+LNt[3]*LNt[0]+LNt[160]*LNt[163]+LNt[163]*LNt[160];
LNt[228] = LNt[224]*LNt[225]+LNt[225]*LNt[224]+LNt[3]*LNt[4]+LNt[4]*LNt[3]+LNt[163]*LNt[164]+LNt[164]*LNt[163];
LNt[229] = d.w;
LNt[230] = float(LNP2x3[74]+LNt[229])-LNP2x3[74];	//[1,53]<<0
LNt[229] -= LNt[230];
LNt[231] = LNt[221]*LNt[221]+LNt[0]*LNt[0]+LNt[160]*LNt[160]-LNt[229];
LNt[232] = float(LNP2x3[53]+LNt[231])-LNP2x3[53];	//[22,53]<<0
LNt[231] -= LNt[232];
LNt[233] = float(LNP2x3[45]+LNt[231])-LNP2x3[45];	//[8,31]<<0
LNt[231] -= LNt[233];
LNt[234] = LNt[227]-LNt[230]+LNt[232]+LNt[233];
LNt[235] = float(LNP2x3[73]+LNt[234])-LNP2x3[73];	//[22,50]<<23
LNt[234] -= LNt[235];
LNt[236] = float(LNP2x3[68]+LNt[234])-LNP2x3[68];	//[5,28]<<23
LNt[234] -= LNt[236];
LNt[237] = LNt[226]+LNt[160]*LNt[164]+LNt[163]*LNt[163]+LNt[164]*LNt[160]+LNt[235]+LNt[236];
LNt[238] = float(LNP2x3[96]+LNt[237])-LNP2x3[96];	//[22,50]<<46
LNt[237] -= LNt[238];
LNt[239] = float(LNP2x3[91]+LNt[237])-LNP2x3[91];	//[5,28]<<46
LNt[237] -= LNt[239];
LNt[240] = LNt[228]+LNt[238]+LNt[239];
LNt[241] = float(LNP2x3[114]+LNt[240])-LNP2x3[114];	//[10,33]<<69
LNt[240] -= LNt[241];
LNt[242] = LNt[225]*LNt[225]+LNt[4]*LNt[4]+LNt[164]*LNt[164]+LNt[241];
LNt[243] = LNt[88]*LNt[114]+LNt[91]*LNt[112]+LNt[92]*LNt[110]-(LNt[5]*LNt[169]+LNt[8]*LNt[167]+LNt[9]*LNt[165]);
LNt[244] = LNt[15]*LNt[57]+LNt[18]*LNt[56]+LNt[19]*LNt[53]-(LNt[47]*LNt[25]+LNt[50]*LNt[24]+LNt[51]*LNt[21]);
LNt[245] = LNt[15]*LNt[53]-LNt[47]*LNt[21];
LNt[246] = float(LNP2x3[47]+LNt[245])-LNP2x3[47];	//[22,47]<<0
LNt[245] -= LNt[246];
LNt[247] = float(LNP2x3[45]+LNt[245])-LNP2x3[45];	//[2,25]<<0
LNt[245] -= LNt[247];
LNt[248] = LNt[15]*LNt[56]+LNt[18]*LNt[53]-(LNt[47]*LNt[24]+LNt[50]*LNt[21])+LNt[246]+LNt[247];
LNt[249] = float(LNP2x3[71]+LNt[248])-LNP2x3[71];	//[22,48]<<23
LNt[248] -= LNt[249];
LNt[250] = float(LNP2x3[68]+LNt[248])-LNP2x3[68];	//[3,26]<<23
LNt[248] -= LNt[250];
LNt[251] = LNt[244]+LNt[249]+LNt[250];
LNt[252] = float(LNP2x3[95]+LNt[251])-LNP2x3[95];	//[22,49]<<46
LNt[251] -= LNt[252];
LNt[253] = float(LNP2x3[91]+LNt[251])-LNP2x3[91];	//[4,27]<<46
LNt[251] -= LNt[253];
LNt[254] = LNt[18]*LNt[57]+LNt[19]*LNt[56]-(LNt[50]*LNt[25]+LNt[51]*LNt[24])+LNt[252]+LNt[253];
LNt[255] = float(LNP2x3[114]+LNt[254])-LNP2x3[114];	//[9,32]<<69
LNt[254] -= LNt[255];
LNt[256] = LNt[19]*LNt[57]-LNt[51]*LNt[25]+LNt[255];
LNt[257] = LNt[88]*LNt[110]-LNt[5]*LNt[165]+LNt[245];
LNt[258] = float(LNP2x3[48]+LNt[257])-LNP2x3[48];	//[22,48]<<0
LNt[257] -= LNt[258];
LNt[259] = float(LNP2x3[45]+LNt[257])-LNP2x3[45];	//[3,26]<<0
LNt[257] -= LNt[259];
LNt[260] = LNt[88]*LNt[112]+LNt[91]*LNt[110]-(LNt[5]*LNt[167]+LNt[8]*LNt[165])+LNt[248]+LNt[258]+LNt[259];
LNt[261] = float(LNP2x3[72]+LNt[260])-LNP2x3[72];	//[22,49]<<23
LNt[260] -= LNt[261];
LNt[262] = float(LNP2x3[68]+LNt[260])-LNP2x3[68];	//[4,27]<<23
LNt[260] -= LNt[262];
LNt[263] = LNt[243]+LNt[251]+LNt[261]+LNt[262];
LNt[264] = float(LNP2x3[96]+LNt[263])-LNP2x3[96];	//[22,50]<<46
LNt[263] -= LNt[264];
LNt[265] = float(LNP2x3[91]+LNt[263])-LNP2x3[91];	//[5,28]<<46
LNt[263] -= LNt[265];
LNt[266] = LNt[91]*LNt[114]+LNt[92]*LNt[112]-(LNt[8]*LNt[169]+LNt[9]*LNt[167])+LNt[254]+LNt[264]+LNt[265];
LNt[267] = float(LNP2x3[114]+LNt[266])-LNP2x3[114];	//[11,34]<<69
LNt[266] -= LNt[267];
LNt[268] = LNt[92]*LNt[114]-LNt[9]*LNt[169]+LNt[256]+LNt[267];
LNt[269] = LNt[231]*LNt[268]+LNt[234]*LNt[266]+LNt[237]*LNt[263]+LNt[240]*LNt[260]+LNt[242]*LNt[257];
LNt[270] = LNt[0]*LNt[143]+LNt[3]*LNt[140]-(LNt[160]*LNt[198]+LNt[163]*LNt[195])+LNt[231]*LNt[260]+LNt[234]*LNt[257];
LNt[271] = LNt[3]*LNt[159]+LNt[4]*LNt[157]-(LNt[163]*LNt[214]+LNt[164]*LNt[212])+LNt[242]*LNt[268];
LNt[272] = LNt[88]*LNt[127]+LNt[91]*LNt[124]+LNt[92]*LNt[121]-(LNt[5]*LNt[182]+LNt[8]*LNt[179]+LNt[9]*LNt[176]);
LNt[273] = LNt[88]*LNt[130]+LNt[91]*LNt[127]+LNt[92]*LNt[124]-(LNt[5]*LNt[185]+LNt[8]*LNt[182]+LNt[9]*LNt[179]);
LNt[274] = LNt[88]*LNt[133]+LNt[91]*LNt[130]+LNt[92]*LNt[127]-(LNt[5]*LNt[188]+LNt[8]*LNt[185]+LNt[9]*LNt[182]);
LNt[275] = LNt[88]*LNt[136]+LNt[91]*LNt[133]+LNt[92]*LNt[130]-(LNt[5]*LNt[191]+LNt[8]*LNt[188]+LNt[9]*LNt[185]);
LNt[276] = LNt[88]*LNt[138]+LNt[91]*LNt[136]+LNt[92]*LNt[133]-(LNt[5]*LNt[193]+LNt[8]*LNt[191]+LNt[9]*LNt[188]);
LNt[277] = LNt[88]*LNt[139]+LNt[91]*LNt[138]+LNt[92]*LNt[136]-(LNt[5]*LNt[194]+LNt[8]*LNt[193]+LNt[9]*LNt[191]);
LNt[278] = LNt[98]*LNt[256]+LNt[101]*LNt[254]+LNt[104]*LNt[251]+LNt[107]*LNt[248]+LNt[109]*LNt[245];
LNt[279] = LNt[88]*LNt[124]+LNt[91]*LNt[121]-(LNt[5]*LNt[179]+LNt[8]*LNt[176])+LNt[98]*LNt[248]+LNt[101]*LNt[245];
LNt[280] = LNt[91]*LNt[139]+LNt[92]*LNt[138]-(LNt[8]*LNt[194]+LNt[9]*LNt[193])+LNt[109]*LNt[256];
LNt[281] = LNt[88]*LNt[121]-LNt[5]*LNt[176]+LNt[98]*LNt[245];
LNt[282] = float(LNP2x3[48]+LNt[281])-LNP2x3[48];	//[22,48]<<0
LNt[281] -= LNt[282];
LNt[283] = float(LNP2x3[45]+LNt[281])-LNP2x3[45];	//[3,26]<<0
LNt[281] -= LNt[283];
LNt[284] = LNt[279]+LNt[282]+LNt[283];
LNt[285] = float(LNP2x3[72]+LNt[284])-LNP2x3[72];	//[22,49]<<23
LNt[284] -= LNt[285];
LNt[286] = float(LNP2x3[68]+LNt[284])-LNP2x3[68];	//[4,27]<<23
LNt[284] -= LNt[286];
LNt[287] = LNt[272]+LNt[98]*LNt[251]+LNt[101]*LNt[248]+LNt[104]*LNt[245]+LNt[285]+LNt[286];
LNt[288] = float(LNP2x3[96]+LNt[287])-LNP2x3[96];	//[22,50]<<46
LNt[287] -= LNt[288];
LNt[289] = float(LNP2x3[91]+LNt[287])-LNP2x3[91];	//[5,28]<<46
LNt[287] -= LNt[289];
LNt[290] = LNt[273]+LNt[98]*LNt[254]+LNt[101]*LNt[251]+LNt[104]*LNt[248]+LNt[107]*LNt[245]+LNt[288]+LNt[289];
LNt[291] = float(LNP2x3[119]+LNt[290])-LNP2x3[119];	//[22,50]<<69
LNt[290] -= LNt[291];
LNt[292] = float(LNP2x3[114]+LNt[290])-LNP2x3[114];	//[5,28]<<69
LNt[290] -= LNt[292];
LNt[293] = LNt[274]+LNt[278]+LNt[291]+LNt[292];
LNt[294] = (float(LNP2x3[125]+LNt[293]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
LNt[293] -= LNt[294];
LNt[295] = (float(LNP2x3[125]+LNt[293]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
LNt[293] -= LNt[295];
LNt[296] = LNt[275]+LNt[101]*LNt[256]+LNt[104]*LNt[254]+LNt[107]*LNt[251]+LNt[109]*LNt[248]+LNt[294]+LNt[295];
LNt[297] = (float(LNP2x3[125]+LNt[296]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
LNt[296] -= LNt[297];
LNt[298] = (float(LNP2x3[125]+LNt[296]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
LNt[296] -= LNt[298];
LNt[299] = LNt[276]+LNt[104]*LNt[256]+LNt[107]*LNt[254]+LNt[109]*LNt[251]+LNt[297]+LNt[298];
LNt[300] = (float(LNP2x3[125]+LNt[299]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
LNt[299] -= LNt[300];
LNt[301] = (float(LNP2x3[125]+LNt[299]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
LNt[299] -= LNt[301];
LNt[302] = LNt[277]+LNt[107]*LNt[256]+LNt[109]*LNt[254]+LNt[300]+LNt[301];
LNt[303] = (float(LNP2x3[125]+LNt[302]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
LNt[302] -= LNt[303];
LNt[304] = (float(LNP2x3[125]+LNt[302]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
LNt[302] -= LNt[304];
LNt[305] = LNt[280]+LNt[303]+LNt[304];
LNt[306] = (float(LNP2x3[125]+LNt[305]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[10,33]<<184
LNt[305] -= LNt[306];
LNt[307] = LNt[92]*LNt[139]-LNt[9]*LNt[194]+LNt[306];
LNt[308] = LNt[216]+LNt[231]*LNt[266]+LNt[234]*LNt[263]+LNt[237]*LNt[260]+LNt[240]*LNt[257]-LNt[290];
LNt[309] = LNt[218]+LNt[234]*LNt[268]+LNt[237]*LNt[266]+LNt[240]*LNt[263]+LNt[242]*LNt[260]-LNt[296];
LNt[310] = LNt[10]-LNt[42];
LNt[311] = float(LNP2x3[45]+LNt[310])-LNP2x3[45];	//[1,24]<<0
LNt[310] -= LNt[311];
LNt[312] = LNt[13]-LNt[45]+LNt[311];
LNt[313] = float(LNP2x3[68]+LNt[312])-LNP2x3[68];	//[1,24]<<23
LNt[312] -= LNt[313];
LNt[314] = LNt[14]-LNt[46]+LNt[313];
LNt[315] = LNt[83]*LNt[78]+LNt[86]*LNt[76]+LNt[87]*LNt[74]-(LNt[98]*LNt[314]+LNt[101]*LNt[312]+LNt[104]*LNt[310]);
LNt[316] = LNt[83]*LNt[80]+LNt[86]*LNt[78]+LNt[87]*LNt[76]-(LNt[101]*LNt[314]+LNt[104]*LNt[312]+LNt[107]*LNt[310]);
LNt[317] = LNt[83]*LNt[82]+LNt[86]*LNt[80]+LNt[87]*LNt[78]-(LNt[104]*LNt[314]+LNt[107]*LNt[312]+LNt[109]*LNt[310]);
LNt[318] = LNt[10]*LNt[68]+LNt[13]*LNt[65]+LNt[14]*LNt[62]-(LNt[30]*LNt[46]+LNt[33]*LNt[45]+LNt[36]*LNt[42]);
LNt[319] = LNt[10]*LNt[71]+LNt[13]*LNt[68]+LNt[14]*LNt[65]-(LNt[33]*LNt[46]+LNt[36]*LNt[45]+LNt[39]*LNt[42]);
LNt[320] = LNt[10]*LNt[73]+LNt[13]*LNt[71]+LNt[14]*LNt[68]-(LNt[36]*LNt[46]+LNt[39]*LNt[45]+LNt[41]*LNt[42]);
LNt[321] = LNt[10]*LNt[62]-LNt[30]*LNt[42];
LNt[322] = float(LNP2x3[47]+LNt[321])-LNP2x3[47];	//[22,47]<<0
LNt[321] -= LNt[322];
LNt[323] = float(LNP2x3[45]+LNt[321])-LNP2x3[45];	//[2,25]<<0
LNt[321] -= LNt[323];
LNt[324] = LNt[10]*LNt[65]+LNt[13]*LNt[62]-(LNt[30]*LNt[45]+LNt[33]*LNt[42])+LNt[322]+LNt[323];
LNt[325] = float(LNP2x3[71]+LNt[324])-LNP2x3[71];	//[22,48]<<23
LNt[324] -= LNt[325];
LNt[326] = float(LNP2x3[68]+LNt[324])-LNP2x3[68];	//[3,26]<<23
LNt[324] -= LNt[326];
LNt[327] = LNt[318]+LNt[325]+LNt[326];
LNt[328] = float(LNP2x3[95]+LNt[327])-LNP2x3[95];	//[22,49]<<46
LNt[327] -= LNt[328];
LNt[329] = float(LNP2x3[91]+LNt[327])-LNP2x3[91];	//[4,27]<<46
LNt[327] -= LNt[329];
LNt[330] = LNt[319]+LNt[328]+LNt[329];
LNt[331] = float(LNP2x3[118]+LNt[330])-LNP2x3[118];	//[22,49]<<69
LNt[330] -= LNt[331];
LNt[332] = float(LNP2x3[114]+LNt[330])-LNP2x3[114];	//[4,27]<<69
LNt[330] -= LNt[332];
LNt[333] = LNt[320]+LNt[331]+LNt[332];
LNt[334] = (float(LNP2x3[125]+LNt[333]/LNP2[16])-LNP2x3[125])*LNP2[16];	//[22,49]<<92
LNt[333] -= LNt[334];
LNt[335] = (float(LNP2x3[125]+LNt[333]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[4,27]<<92
LNt[333] -= LNt[335];
LNt[336] = LNt[13]*LNt[73]+LNt[14]*LNt[71]-(LNt[39]*LNt[46]+LNt[41]*LNt[45])+LNt[334]+LNt[335];
LNt[337] = (float(LNP2x3[125]+LNt[336]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[336] -= LNt[337];
LNt[338] = LNt[14]*LNt[73]-LNt[41]*LNt[46]+LNt[337];
LNt[339] = (float(LNP2x3[125]+LNt[338]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[338] -= LNt[339];
LNt[340] = LNt[83]*LNt[74]-LNt[98]*LNt[310]+LNt[321];
LNt[341] = float(LNP2x3[48]+LNt[340])-LNP2x3[48];	//[22,48]<<0
LNt[340] -= LNt[341];
LNt[342] = float(LNP2x3[45]+LNt[340])-LNP2x3[45];	//[3,26]<<0
LNt[340] -= LNt[342];
LNt[343] = LNt[83]*LNt[76]+LNt[86]*LNt[74]-(LNt[98]*LNt[312]+LNt[101]*LNt[310])+LNt[324]+LNt[341]+LNt[342];
LNt[344] = float(LNP2x3[72]+LNt[343])-LNP2x3[72];	//[22,49]<<23
LNt[343] -= LNt[344];
LNt[345] = float(LNP2x3[68]+LNt[343])-LNP2x3[68];	//[4,27]<<23
LNt[343] -= LNt[345];
LNt[346] = LNt[315]+LNt[327]+LNt[344]+LNt[345];
LNt[347] = float(LNP2x3[96]+LNt[346])-LNP2x3[96];	//[22,50]<<46
LNt[346] -= LNt[347];
LNt[348] = float(LNP2x3[91]+LNt[346])-LNP2x3[91];	//[5,28]<<46
LNt[346] -= LNt[348];
LNt[349] = LNt[316]+LNt[330]+LNt[347]+LNt[348];
LNt[350] = float(LNP2x3[119]+LNt[349])-LNP2x3[119];	//[22,50]<<69
LNt[349] -= LNt[350];
LNt[351] = float(LNP2x3[114]+LNt[349])-LNP2x3[114];	//[5,28]<<69
LNt[349] -= LNt[351];
LNt[352] = LNt[317]+LNt[333]+LNt[350]+LNt[351];
LNt[353] = (float(LNP2x3[125]+LNt[352]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[352] -= LNt[353];
LNt[354] = (float(LNP2x3[125]+LNt[352]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[352] -= LNt[354];
LNt[355] = LNt[86]*LNt[82]+LNt[87]*LNt[80]-(LNt[107]*LNt[314]+LNt[109]*LNt[312])+LNt[336]+LNt[353]+LNt[354];
LNt[356] = (float(LNP2x3[125]+LNt[355]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[20,43]<<115
LNt[355] -= LNt[356];
LNt[357] = LNt[87]*LNt[82]-LNt[109]*LNt[314]+LNt[338]+LNt[356];
LNt[358] = (float(LNP2x3[125]+LNt[357]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[3,26]<<138
LNt[357] -= LNt[358];
LNt[359] = LNt[339]+LNt[358];
LNt[360] = LNt[221]*LNt[146]+LNt[224]*LNt[143]+LNt[225]*LNt[140]-(LNt[160]*LNt[346]+LNt[163]*LNt[343]+LNt[164]*LNt[340]);
LNt[361] = LNt[221]*LNt[149]+LNt[224]*LNt[146]+LNt[225]*LNt[143]-(LNt[160]*LNt[349]+LNt[163]*LNt[346]+LNt[164]*LNt[343]);
LNt[362] = LNt[221]*LNt[152]+LNt[224]*LNt[149]+LNt[225]*LNt[146]-(LNt[160]*LNt[352]+LNt[163]*LNt[349]+LNt[164]*LNt[346]);
LNt[363] = LNt[221]*LNt[155]+LNt[224]*LNt[152]+LNt[225]*LNt[149]-(LNt[160]*LNt[355]+LNt[163]*LNt[352]+LNt[164]*LNt[349]);
LNt[364] = LNt[221]*LNt[157]+LNt[224]*LNt[155]+LNt[225]*LNt[152]-(LNt[160]*LNt[357]+LNt[163]*LNt[355]+LNt[164]*LNt[352]);
LNt[365] = LNt[221]*LNt[159]+LNt[224]*LNt[157]+LNt[225]*LNt[155]-(LNt[160]*LNt[359]+LNt[163]*LNt[357]+LNt[164]*LNt[355]);
LNt[366] = LNt[83]*LNt[114]+LNt[86]*LNt[112]+LNt[87]*LNt[110]-(LNt[5]*LNt[314]+LNt[8]*LNt[312]+LNt[9]*LNt[310]);
LNt[367] = LNt[10]*LNt[57]+LNt[13]*LNt[56]+LNt[14]*LNt[53]-(LNt[21]*LNt[46]+LNt[24]*LNt[45]+LNt[25]*LNt[42]);
LNt[368] = LNt[10]*LNt[53]-LNt[21]*LNt[42];
LNt[369] = float(LNP2x3[47]+LNt[368])-LNP2x3[47];	//[22,47]<<0
LNt[368] -= LNt[369];
LNt[370] = float(LNP2x3[45]+LNt[368])-LNP2x3[45];	//[2,25]<<0
LNt[368] -= LNt[370];
LNt[371] = LNt[10]*LNt[56]+LNt[13]*LNt[53]-(LNt[21]*LNt[45]+LNt[24]*LNt[42])+LNt[369]+LNt[370];
LNt[372] = float(LNP2x3[71]+LNt[371])-LNP2x3[71];	//[22,48]<<23
LNt[371] -= LNt[372];
LNt[373] = float(LNP2x3[68]+LNt[371])-LNP2x3[68];	//[3,26]<<23
LNt[371] -= LNt[373];
LNt[374] = LNt[367]+LNt[372]+LNt[373];
LNt[375] = float(LNP2x3[95]+LNt[374])-LNP2x3[95];	//[22,49]<<46
LNt[374] -= LNt[375];
LNt[376] = float(LNP2x3[91]+LNt[374])-LNP2x3[91];	//[4,27]<<46
LNt[374] -= LNt[376];
LNt[377] = LNt[13]*LNt[57]+LNt[14]*LNt[56]-(LNt[24]*LNt[46]+LNt[25]*LNt[45])+LNt[375]+LNt[376];
LNt[378] = float(LNP2x3[114]+LNt[377])-LNP2x3[114];	//[9,32]<<69
LNt[377] -= LNt[378];
LNt[379] = LNt[14]*LNt[57]-LNt[25]*LNt[46]+LNt[378];
LNt[380] = LNt[83]*LNt[110]-LNt[5]*LNt[310]+LNt[368];
LNt[381] = float(LNP2x3[48]+LNt[380])-LNP2x3[48];	//[22,48]<<0
LNt[380] -= LNt[381];
LNt[382] = float(LNP2x3[45]+LNt[380])-LNP2x3[45];	//[3,26]<<0
LNt[380] -= LNt[382];
LNt[383] = LNt[83]*LNt[112]+LNt[86]*LNt[110]-(LNt[5]*LNt[312]+LNt[8]*LNt[310])+LNt[371]+LNt[381]+LNt[382];
LNt[384] = float(LNP2x3[72]+LNt[383])-LNP2x3[72];	//[22,49]<<23
LNt[383] -= LNt[384];
LNt[385] = float(LNP2x3[68]+LNt[383])-LNP2x3[68];	//[4,27]<<23
LNt[383] -= LNt[385];
LNt[386] = LNt[366]+LNt[374]+LNt[384]+LNt[385];
LNt[387] = float(LNP2x3[96]+LNt[386])-LNP2x3[96];	//[22,50]<<46
LNt[386] -= LNt[387];
LNt[388] = float(LNP2x3[91]+LNt[386])-LNP2x3[91];	//[5,28]<<46
LNt[386] -= LNt[388];
LNt[389] = LNt[86]*LNt[114]+LNt[87]*LNt[112]-(LNt[8]*LNt[314]+LNt[9]*LNt[312])+LNt[377]+LNt[387]+LNt[388];
LNt[390] = float(LNP2x3[114]+LNt[389])-LNP2x3[114];	//[11,34]<<69
LNt[389] -= LNt[390];
LNt[391] = LNt[87]*LNt[114]-LNt[9]*LNt[314]+LNt[379]+LNt[390];
LNt[392] = LNt[231]*LNt[391]+LNt[234]*LNt[389]+LNt[237]*LNt[386]+LNt[240]*LNt[383]+LNt[242]*LNt[380];
LNt[393] = LNt[221]*LNt[143]+LNt[224]*LNt[140]-(LNt[160]*LNt[343]+LNt[163]*LNt[340])+LNt[231]*LNt[383]+LNt[234]*LNt[380];
LNt[394] = LNt[224]*LNt[159]+LNt[225]*LNt[157]-(LNt[163]*LNt[359]+LNt[164]*LNt[357])+LNt[242]*LNt[391];
LNt[395] = LNt[83]*LNt[127]+LNt[86]*LNt[124]+LNt[87]*LNt[121]-(LNt[5]*LNt[327]+LNt[8]*LNt[324]+LNt[9]*LNt[321]);
LNt[396] = LNt[83]*LNt[130]+LNt[86]*LNt[127]+LNt[87]*LNt[124]-(LNt[5]*LNt[330]+LNt[8]*LNt[327]+LNt[9]*LNt[324]);
LNt[397] = LNt[83]*LNt[133]+LNt[86]*LNt[130]+LNt[87]*LNt[127]-(LNt[5]*LNt[333]+LNt[8]*LNt[330]+LNt[9]*LNt[327]);
LNt[398] = LNt[83]*LNt[136]+LNt[86]*LNt[133]+LNt[87]*LNt[130]-(LNt[5]*LNt[336]+LNt[8]*LNt[333]+LNt[9]*LNt[330]);
LNt[399] = LNt[83]*LNt[138]+LNt[86]*LNt[136]+LNt[87]*LNt[133]-(LNt[5]*LNt[338]+LNt[8]*LNt[336]+LNt[9]*LNt[333]);
LNt[400] = LNt[83]*LNt[139]+LNt[86]*LNt[138]+LNt[87]*LNt[136]-(LNt[5]*LNt[339]+LNt[8]*LNt[338]+LNt[9]*LNt[336]);
LNt[401] = LNt[98]*LNt[379]+LNt[101]*LNt[377]+LNt[104]*LNt[374]+LNt[107]*LNt[371]+LNt[109]*LNt[368];
LNt[402] = LNt[83]*LNt[124]+LNt[86]*LNt[121]-(LNt[5]*LNt[324]+LNt[8]*LNt[321])+LNt[98]*LNt[371]+LNt[101]*LNt[368];
LNt[403] = LNt[86]*LNt[139]+LNt[87]*LNt[138]-(LNt[8]*LNt[339]+LNt[9]*LNt[338])+LNt[109]*LNt[379];
LNt[404] = LNt[83]*LNt[121]-LNt[5]*LNt[321]+LNt[98]*LNt[368];
LNt[405] = float(LNP2x3[48]+LNt[404])-LNP2x3[48];	//[22,48]<<0
LNt[404] -= LNt[405];
LNt[406] = float(LNP2x3[45]+LNt[404])-LNP2x3[45];	//[3,26]<<0
LNt[404] -= LNt[406];
LNt[407] = LNt[402]+LNt[405]+LNt[406];
LNt[408] = float(LNP2x3[72]+LNt[407])-LNP2x3[72];	//[22,49]<<23
LNt[407] -= LNt[408];
LNt[409] = float(LNP2x3[68]+LNt[407])-LNP2x3[68];	//[4,27]<<23
LNt[407] -= LNt[409];
LNt[410] = LNt[395]+LNt[98]*LNt[374]+LNt[101]*LNt[371]+LNt[104]*LNt[368]+LNt[408]+LNt[409];
LNt[411] = float(LNP2x3[96]+LNt[410])-LNP2x3[96];	//[22,50]<<46
LNt[410] -= LNt[411];
LNt[412] = float(LNP2x3[91]+LNt[410])-LNP2x3[91];	//[5,28]<<46
LNt[410] -= LNt[412];
LNt[413] = LNt[396]+LNt[98]*LNt[377]+LNt[101]*LNt[374]+LNt[104]*LNt[371]+LNt[107]*LNt[368]+LNt[411]+LNt[412];
LNt[414] = float(LNP2x3[119]+LNt[413])-LNP2x3[119];	//[22,50]<<69
LNt[413] -= LNt[414];
LNt[415] = float(LNP2x3[114]+LNt[413])-LNP2x3[114];	//[5,28]<<69
LNt[413] -= LNt[415];
LNt[416] = LNt[397]+LNt[401]+LNt[414]+LNt[415];
LNt[417] = (float(LNP2x3[125]+LNt[416]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
LNt[416] -= LNt[417];
LNt[418] = (float(LNP2x3[125]+LNt[416]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
LNt[416] -= LNt[418];
LNt[419] = LNt[398]+LNt[101]*LNt[379]+LNt[104]*LNt[377]+LNt[107]*LNt[374]+LNt[109]*LNt[371]+LNt[417]+LNt[418];
LNt[420] = (float(LNP2x3[125]+LNt[419]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
LNt[419] -= LNt[420];
LNt[421] = (float(LNP2x3[125]+LNt[419]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
LNt[419] -= LNt[421];
LNt[422] = LNt[399]+LNt[104]*LNt[379]+LNt[107]*LNt[377]+LNt[109]*LNt[374]+LNt[420]+LNt[421];
LNt[423] = (float(LNP2x3[125]+LNt[422]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
LNt[422] -= LNt[423];
LNt[424] = (float(LNP2x3[125]+LNt[422]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
LNt[422] -= LNt[424];
LNt[425] = LNt[400]+LNt[107]*LNt[379]+LNt[109]*LNt[377]+LNt[423]+LNt[424];
LNt[426] = (float(LNP2x3[125]+LNt[425]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
LNt[425] -= LNt[426];
LNt[427] = (float(LNP2x3[125]+LNt[425]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
LNt[425] -= LNt[427];
LNt[428] = LNt[403]+LNt[426]+LNt[427];
LNt[429] = (float(LNP2x3[125]+LNt[428]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[10,33]<<184
LNt[428] -= LNt[429];
LNt[430] = LNt[87]*LNt[139]-LNt[9]*LNt[339]+LNt[429];
LNt[431] = LNt[361]+LNt[231]*LNt[389]+LNt[234]*LNt[386]+LNt[237]*LNt[383]+LNt[240]*LNt[380]-LNt[413];
LNt[432] = LNt[363]+LNt[234]*LNt[391]+LNt[237]*LNt[389]+LNt[240]*LNt[386]+LNt[242]*LNt[383]-LNt[419];
LNt[433] = LNt[221]*LNt[201]+LNt[224]*LNt[198]+LNt[225]*LNt[195]-(LNt[0]*LNt[346]+LNt[3]*LNt[343]+LNt[4]*LNt[340]);
LNt[434] = LNt[221]*LNt[204]+LNt[224]*LNt[201]+LNt[225]*LNt[198]-(LNt[0]*LNt[349]+LNt[3]*LNt[346]+LNt[4]*LNt[343]);
LNt[435] = LNt[221]*LNt[207]+LNt[224]*LNt[204]+LNt[225]*LNt[201]-(LNt[0]*LNt[352]+LNt[3]*LNt[349]+LNt[4]*LNt[346]);
LNt[436] = LNt[221]*LNt[210]+LNt[224]*LNt[207]+LNt[225]*LNt[204]-(LNt[0]*LNt[355]+LNt[3]*LNt[352]+LNt[4]*LNt[349]);
LNt[437] = LNt[221]*LNt[212]+LNt[224]*LNt[210]+LNt[225]*LNt[207]-(LNt[0]*LNt[357]+LNt[3]*LNt[355]+LNt[4]*LNt[352]);
LNt[438] = LNt[221]*LNt[214]+LNt[224]*LNt[212]+LNt[225]*LNt[210]-(LNt[0]*LNt[359]+LNt[3]*LNt[357]+LNt[4]*LNt[355]);
LNt[439] = LNt[83]*LNt[169]+LNt[86]*LNt[167]+LNt[87]*LNt[165]-(LNt[88]*LNt[314]+LNt[91]*LNt[312]+LNt[92]*LNt[310]);
LNt[440] = LNt[10]*LNt[51]+LNt[13]*LNt[50]+LNt[14]*LNt[47]-(LNt[15]*LNt[46]+LNt[18]*LNt[45]+LNt[19]*LNt[42]);
LNt[441] = LNt[10]*LNt[47]-LNt[15]*LNt[42];
LNt[442] = float(LNP2x3[47]+LNt[441])-LNP2x3[47];	//[22,47]<<0
LNt[441] -= LNt[442];
LNt[443] = float(LNP2x3[45]+LNt[441])-LNP2x3[45];	//[2,25]<<0
LNt[441] -= LNt[443];
LNt[444] = LNt[10]*LNt[50]+LNt[13]*LNt[47]-(LNt[15]*LNt[45]+LNt[18]*LNt[42])+LNt[442]+LNt[443];
LNt[445] = float(LNP2x3[71]+LNt[444])-LNP2x3[71];	//[22,48]<<23
LNt[444] -= LNt[445];
LNt[446] = float(LNP2x3[68]+LNt[444])-LNP2x3[68];	//[3,26]<<23
LNt[444] -= LNt[446];
LNt[447] = LNt[440]+LNt[445]+LNt[446];
LNt[448] = float(LNP2x3[95]+LNt[447])-LNP2x3[95];	//[22,49]<<46
LNt[447] -= LNt[448];
LNt[449] = float(LNP2x3[91]+LNt[447])-LNP2x3[91];	//[4,27]<<46
LNt[447] -= LNt[449];
LNt[450] = LNt[13]*LNt[51]+LNt[14]*LNt[50]-(LNt[18]*LNt[46]+LNt[19]*LNt[45])+LNt[448]+LNt[449];
LNt[451] = float(LNP2x3[114]+LNt[450])-LNP2x3[114];	//[9,32]<<69
LNt[450] -= LNt[451];
LNt[452] = LNt[14]*LNt[51]-LNt[19]*LNt[46]+LNt[451];
LNt[453] = LNt[83]*LNt[165]-LNt[88]*LNt[310]+LNt[441];
LNt[454] = float(LNP2x3[48]+LNt[453])-LNP2x3[48];	//[22,48]<<0
LNt[453] -= LNt[454];
LNt[455] = float(LNP2x3[45]+LNt[453])-LNP2x3[45];	//[3,26]<<0
LNt[453] -= LNt[455];
LNt[456] = LNt[83]*LNt[167]+LNt[86]*LNt[165]-(LNt[88]*LNt[312]+LNt[91]*LNt[310])+LNt[444]+LNt[454]+LNt[455];
LNt[457] = float(LNP2x3[72]+LNt[456])-LNP2x3[72];	//[22,49]<<23
LNt[456] -= LNt[457];
LNt[458] = float(LNP2x3[68]+LNt[456])-LNP2x3[68];	//[4,27]<<23
LNt[456] -= LNt[458];
LNt[459] = LNt[439]+LNt[447]+LNt[457]+LNt[458];
LNt[460] = float(LNP2x3[96]+LNt[459])-LNP2x3[96];	//[22,50]<<46
LNt[459] -= LNt[460];
LNt[461] = float(LNP2x3[91]+LNt[459])-LNP2x3[91];	//[5,28]<<46
LNt[459] -= LNt[461];
LNt[462] = LNt[86]*LNt[169]+LNt[87]*LNt[167]-(LNt[91]*LNt[314]+LNt[92]*LNt[312])+LNt[450]+LNt[460]+LNt[461];
LNt[463] = float(LNP2x3[114]+LNt[462])-LNP2x3[114];	//[11,34]<<69
LNt[462] -= LNt[463];
LNt[464] = LNt[87]*LNt[169]-LNt[92]*LNt[314]+LNt[452]+LNt[463];
LNt[465] = LNt[231]*LNt[464]+LNt[234]*LNt[462]+LNt[237]*LNt[459]+LNt[240]*LNt[456]+LNt[242]*LNt[453];
LNt[466] = LNt[221]*LNt[198]+LNt[224]*LNt[195]-(LNt[0]*LNt[343]+LNt[3]*LNt[340])+LNt[231]*LNt[456]+LNt[234]*LNt[453];
LNt[467] = LNt[224]*LNt[214]+LNt[225]*LNt[212]-(LNt[3]*LNt[359]+LNt[4]*LNt[357])+LNt[242]*LNt[464];
LNt[468] = LNt[83]*LNt[182]+LNt[86]*LNt[179]+LNt[87]*LNt[176]-(LNt[88]*LNt[327]+LNt[91]*LNt[324]+LNt[92]*LNt[321]);
LNt[469] = LNt[83]*LNt[185]+LNt[86]*LNt[182]+LNt[87]*LNt[179]-(LNt[88]*LNt[330]+LNt[91]*LNt[327]+LNt[92]*LNt[324]);
LNt[470] = LNt[83]*LNt[188]+LNt[86]*LNt[185]+LNt[87]*LNt[182]-(LNt[88]*LNt[333]+LNt[91]*LNt[330]+LNt[92]*LNt[327]);
LNt[471] = LNt[83]*LNt[191]+LNt[86]*LNt[188]+LNt[87]*LNt[185]-(LNt[88]*LNt[336]+LNt[91]*LNt[333]+LNt[92]*LNt[330]);
LNt[472] = LNt[83]*LNt[193]+LNt[86]*LNt[191]+LNt[87]*LNt[188]-(LNt[88]*LNt[338]+LNt[91]*LNt[336]+LNt[92]*LNt[333]);
LNt[473] = LNt[83]*LNt[194]+LNt[86]*LNt[193]+LNt[87]*LNt[191]-(LNt[88]*LNt[339]+LNt[91]*LNt[338]+LNt[92]*LNt[336]);
LNt[474] = LNt[98]*LNt[452]+LNt[101]*LNt[450]+LNt[104]*LNt[447]+LNt[107]*LNt[444]+LNt[109]*LNt[441];
LNt[475] = LNt[83]*LNt[179]+LNt[86]*LNt[176]-(LNt[88]*LNt[324]+LNt[91]*LNt[321])+LNt[98]*LNt[444]+LNt[101]*LNt[441];
LNt[476] = LNt[86]*LNt[194]+LNt[87]*LNt[193]-(LNt[91]*LNt[339]+LNt[92]*LNt[338])+LNt[109]*LNt[452];
LNt[477] = LNt[83]*LNt[176]-LNt[88]*LNt[321]+LNt[98]*LNt[441];
LNt[478] = float(LNP2x3[48]+LNt[477])-LNP2x3[48];	//[22,48]<<0
LNt[477] -= LNt[478];
LNt[479] = float(LNP2x3[45]+LNt[477])-LNP2x3[45];	//[3,26]<<0
LNt[477] -= LNt[479];
LNt[480] = LNt[475]+LNt[478]+LNt[479];
LNt[481] = float(LNP2x3[72]+LNt[480])-LNP2x3[72];	//[22,49]<<23
LNt[480] -= LNt[481];
LNt[482] = float(LNP2x3[68]+LNt[480])-LNP2x3[68];	//[4,27]<<23
LNt[480] -= LNt[482];
LNt[483] = LNt[468]+LNt[98]*LNt[447]+LNt[101]*LNt[444]+LNt[104]*LNt[441]+LNt[481]+LNt[482];
LNt[484] = float(LNP2x3[96]+LNt[483])-LNP2x3[96];	//[22,50]<<46
LNt[483] -= LNt[484];
LNt[485] = float(LNP2x3[91]+LNt[483])-LNP2x3[91];	//[5,28]<<46
LNt[483] -= LNt[485];
LNt[486] = LNt[469]+LNt[98]*LNt[450]+LNt[101]*LNt[447]+LNt[104]*LNt[444]+LNt[107]*LNt[441]+LNt[484]+LNt[485];
LNt[487] = float(LNP2x3[119]+LNt[486])-LNP2x3[119];	//[22,50]<<69
LNt[486] -= LNt[487];
LNt[488] = float(LNP2x3[114]+LNt[486])-LNP2x3[114];	//[5,28]<<69
LNt[486] -= LNt[488];
LNt[489] = LNt[470]+LNt[474]+LNt[487]+LNt[488];
LNt[490] = (float(LNP2x3[125]+LNt[489]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
LNt[489] -= LNt[490];
LNt[491] = (float(LNP2x3[125]+LNt[489]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
LNt[489] -= LNt[491];
LNt[492] = LNt[471]+LNt[101]*LNt[452]+LNt[104]*LNt[450]+LNt[107]*LNt[447]+LNt[109]*LNt[444]+LNt[490]+LNt[491];
LNt[493] = (float(LNP2x3[125]+LNt[492]/LNP2[40])-LNP2x3[125])*LNP2[40];	//[22,50]<<115
LNt[492] -= LNt[493];
LNt[494] = (float(LNP2x3[125]+LNt[492]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[5,28]<<115
LNt[492] -= LNt[494];
LNt[495] = LNt[472]+LNt[104]*LNt[452]+LNt[107]*LNt[450]+LNt[109]*LNt[447]+LNt[493]+LNt[494];
LNt[496] = (float(LNP2x3[125]+LNt[495]/LNP2[63])-LNP2x3[125])*LNP2[63];	//[22,50]<<138
LNt[495] -= LNt[496];
LNt[497] = (float(LNP2x3[125]+LNt[495]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[5,28]<<138
LNt[495] -= LNt[497];
LNt[498] = LNt[473]+LNt[107]*LNt[452]+LNt[109]*LNt[450]+LNt[496]+LNt[497];
LNt[499] = (float(LNP2x3[125]+LNt[498]/LNP2[86])-LNP2x3[125])*LNP2[86];	//[22,50]<<161
LNt[498] -= LNt[499];
LNt[500] = (float(LNP2x3[125]+LNt[498]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[5,28]<<161
LNt[498] -= LNt[500];
LNt[501] = LNt[476]+LNt[499]+LNt[500];
LNt[502] = (float(LNP2x3[125]+LNt[501]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[10,33]<<184
LNt[501] -= LNt[502];
LNt[503] = LNt[87]*LNt[194]-LNt[92]*LNt[339]+LNt[502];
LNt[504] = LNt[434]+LNt[231]*LNt[462]+LNt[234]*LNt[459]+LNt[237]*LNt[456]+LNt[240]*LNt[453]-LNt[486];
LNt[505] = LNt[436]+LNt[234]*LNt[464]+LNt[237]*LNt[462]+LNt[240]*LNt[459]+LNt[242]*LNt[456]-LNt[492];
LNt[506] = LNt[221]*LNt[263]+LNt[224]*LNt[260]+LNt[225]*LNt[257]-(LNt[0]*LNt[386]+LNt[3]*LNt[383]+LNt[4]*LNt[380]);
LNt[507] = LNt[221]*LNt[266]+LNt[224]*LNt[263]+LNt[225]*LNt[260]-(LNt[0]*LNt[389]+LNt[3]*LNt[386]+LNt[4]*LNt[383]);
LNt[508] = LNt[221]*LNt[268]+LNt[224]*LNt[266]+LNt[225]*LNt[263]-(LNt[0]*LNt[391]+LNt[3]*LNt[389]+LNt[4]*LNt[386]);
LNt[509] = LNt[221]*LNt[260]+LNt[224]*LNt[257]-(LNt[0]*LNt[383]+LNt[3]*LNt[380])+LNt[160]*LNt[456]+LNt[163]*LNt[453];
LNt[510] = LNt[224]*LNt[268]+LNt[225]*LNt[266]-(LNt[3]*LNt[391]+LNt[4]*LNt[389])+LNt[163]*LNt[464]+LNt[164]*LNt[462];
LNt[511] = LNt[83]*LNt[251]+LNt[86]*LNt[248]+LNt[87]*LNt[245]-(LNt[88]*LNt[374]+LNt[91]*LNt[371]+LNt[92]*LNt[368]);
LNt[512] = LNt[83]*LNt[254]+LNt[86]*LNt[251]+LNt[87]*LNt[248]-(LNt[88]*LNt[377]+LNt[91]*LNt[374]+LNt[92]*LNt[371]);
LNt[513] = LNt[83]*LNt[256]+LNt[86]*LNt[254]+LNt[87]*LNt[251]-(LNt[88]*LNt[379]+LNt[91]*LNt[377]+LNt[92]*LNt[374]);
LNt[514] = LNt[83]*LNt[248]+LNt[86]*LNt[245]-(LNt[88]*LNt[371]+LNt[91]*LNt[368])+LNt[5]*LNt[444]+LNt[8]*LNt[441];
LNt[515] = LNt[86]*LNt[256]+LNt[87]*LNt[254]-(LNt[91]*LNt[379]+LNt[92]*LNt[377])+LNt[8]*LNt[452]+LNt[9]*LNt[450];
LNt[516] = LNt[83]*LNt[245]-LNt[88]*LNt[368]+LNt[5]*LNt[441];
LNt[517] = float(LNP2x3[48]+LNt[516])-LNP2x3[48];	//[22,48]<<0
LNt[516] -= LNt[517];
LNt[518] = float(LNP2x3[45]+LNt[516])-LNP2x3[45];	//[3,26]<<0
LNt[516] -= LNt[518];
LNt[519] = LNt[514]+LNt[517]+LNt[518];
LNt[520] = float(LNP2x3[72]+LNt[519])-LNP2x3[72];	//[22,49]<<23
LNt[519] -= LNt[520];
LNt[521] = float(LNP2x3[68]+LNt[519])-LNP2x3[68];	//[4,27]<<23
LNt[519] -= LNt[521];
LNt[522] = LNt[511]+LNt[5]*LNt[447]+LNt[8]*LNt[444]+LNt[9]*LNt[441]+LNt[520]+LNt[521];
LNt[523] = float(LNP2x3[96]+LNt[522])-LNP2x3[96];	//[22,50]<<46
LNt[522] -= LNt[523];
LNt[524] = float(LNP2x3[91]+LNt[522])-LNP2x3[91];	//[5,28]<<46
LNt[522] -= LNt[524];
LNt[525] = LNt[512]+LNt[5]*LNt[450]+LNt[8]*LNt[447]+LNt[9]*LNt[444]+LNt[523]+LNt[524];
LNt[526] = float(LNP2x3[119]+LNt[525])-LNP2x3[119];	//[22,50]<<69
LNt[525] -= LNt[526];
LNt[527] = float(LNP2x3[114]+LNt[525])-LNP2x3[114];	//[5,28]<<69
LNt[525] -= LNt[527];
LNt[528] = LNt[513]+LNt[5]*LNt[452]+LNt[8]*LNt[450]+LNt[9]*LNt[447]+LNt[526]+LNt[527];
LNt[529] = (float(LNP2x3[125]+LNt[528]/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
LNt[528] -= LNt[529];
LNt[530] = (float(LNP2x3[125]+LNt[528]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
LNt[528] -= LNt[530];
LNt[531] = LNt[515]+LNt[529]+LNt[530];
LNt[532] = (float(LNP2x3[125]+LNt[531]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
LNt[531] -= LNt[532];
LNt[533] = LNt[87]*LNt[256]-LNt[92]*LNt[379]+LNt[9]*LNt[452]+LNt[532];
LNt[534] = (float(LNP2x3[125]+LNt[533]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
LNt[533] -= LNt[534];
LNt[535] = LNt[221]*LNt[287]+LNt[224]*LNt[284]+LNt[225]*LNt[281]-(LNt[0]*LNt[410]+LNt[3]*LNt[407]+LNt[4]*LNt[404]);
LNt[536] = LNt[221]*LNt[290]+LNt[224]*LNt[287]+LNt[225]*LNt[284]-(LNt[0]*LNt[413]+LNt[3]*LNt[410]+LNt[4]*LNt[407]);
LNt[537] = LNt[221]*LNt[293]+LNt[224]*LNt[290]+LNt[225]*LNt[287]-(LNt[0]*LNt[416]+LNt[3]*LNt[413]+LNt[4]*LNt[410]);
LNt[538] = LNt[221]*LNt[296]+LNt[224]*LNt[293]+LNt[225]*LNt[290]-(LNt[0]*LNt[419]+LNt[3]*LNt[416]+LNt[4]*LNt[413]);
LNt[539] = LNt[221]*LNt[299]+LNt[224]*LNt[296]+LNt[225]*LNt[293]-(LNt[0]*LNt[422]+LNt[3]*LNt[419]+LNt[4]*LNt[416]);
LNt[540] = LNt[221]*LNt[302]+LNt[224]*LNt[299]+LNt[225]*LNt[296]-(LNt[0]*LNt[425]+LNt[3]*LNt[422]+LNt[4]*LNt[419]);
LNt[541] = LNt[221]*LNt[305]+LNt[224]*LNt[302]+LNt[225]*LNt[299]-(LNt[0]*LNt[428]+LNt[3]*LNt[425]+LNt[4]*LNt[422]);
LNt[542] = LNt[221]*LNt[307]+LNt[224]*LNt[305]+LNt[225]*LNt[302]-(LNt[0]*LNt[430]+LNt[3]*LNt[428]+LNt[4]*LNt[425]);
LNt[543] = LNt[221]*LNt[284]+LNt[224]*LNt[281]-(LNt[0]*LNt[407]+LNt[3]*LNt[404])+LNt[160]*LNt[480]+LNt[163]*LNt[477];
LNt[544] = LNt[224]*LNt[307]+LNt[225]*LNt[305]-(LNt[3]*LNt[430]+LNt[4]*LNt[428])+LNt[163]*LNt[503]+LNt[164]*LNt[501];
LNt[545] = LNt[231]*LNt[528]+LNt[234]*LNt[525]+LNt[237]*LNt[522]+LNt[240]*LNt[519]+LNt[242]*LNt[516];
LNt[546] = LNt[231]*LNt[531]+LNt[234]*LNt[528]+LNt[237]*LNt[525]+LNt[240]*LNt[522]+LNt[242]*LNt[519];
LNt[547] = LNt[231]*LNt[533]+LNt[234]*LNt[531]+LNt[237]*LNt[528]+LNt[240]*LNt[525]+LNt[242]*LNt[522];
LNt[548] = LNt[231]*LNt[534]+LNt[234]*LNt[533]+LNt[237]*LNt[531]+LNt[240]*LNt[528]+LNt[242]*LNt[525];
LNt[549] = LNt[535]+LNt[160]*LNt[483]+LNt[163]*LNt[480]+LNt[164]*LNt[477]-(LNt[231]*LNt[522]+LNt[234]*LNt[519]+LNt[237]*LNt[516]);
LNt[550] = LNt[536]+LNt[160]*LNt[486]+LNt[163]*LNt[483]+LNt[164]*LNt[480]-(LNt[231]*LNt[525]+LNt[234]*LNt[522]+LNt[237]*LNt[519]+LNt[240]*LNt[516]);
LNt[551] = LNt[541]+LNt[160]*LNt[501]+LNt[163]*LNt[498]+LNt[164]*LNt[495]-(LNt[234]*LNt[534]+LNt[237]*LNt[533]+LNt[240]*LNt[531]+LNt[242]*LNt[528]);
LNt[552] = LNt[542]+LNt[160]*LNt[503]+LNt[163]*LNt[501]+LNt[164]*LNt[498]-(LNt[237]*LNt[534]+LNt[240]*LNt[533]+LNt[242]*LNt[531]);
(*this).a.v0 = 0.-(LNt[0]*LNt[140]-LNt[160]*LNt[195]+LNt[231]*LNt[257]-LNt[281]);
LNt[553] = float(LNP2x3[50]+(*this).a.v0)-LNP2x3[50];	//[22,50]<<0
(*this).a.v0 -= LNt[553];
LNt[554] = float(LNP2x3[45]+(*this).a.v0)-LNP2x3[45];	//[5,28]<<0
(*this).a.v0 -= LNt[554];
(*this).a.v1 = 0.0-(LNt[270]-LNt[284])+LNt[553]+LNt[554];
LNt[555] = float(LNP2x3[74]+(*this).a.v1)-LNP2x3[74];	//[22,51]<<23
(*this).a.v1 -= LNt[555];
LNt[556] = float(LNP2x3[68]+(*this).a.v1)-LNP2x3[68];	//[6,29]<<23
(*this).a.v1 -= LNt[556];
LNt[557] = 0.0-(LNt[215]+LNt[231]*LNt[263]+LNt[234]*LNt[260]+LNt[237]*LNt[257]-LNt[287])+LNt[555]+LNt[556];
(*this).a.v2 = LNt[557];
LNt[558] = float(LNP2x3[98]+(*this).a.v2)-LNP2x3[98];	//[22,52]<<46
(*this).a.v2 -= LNt[558];
LNt[559] = float(LNP2x3[91]+(*this).a.v2)-LNP2x3[91];	//[7,30]<<46
(*this).a.v2 -= LNt[559];
(*this).a.v3 = 0.0-LNt[308]+LNt[558]+LNt[559];
LNt[560] = float(LNP2x3[121]+(*this).a.v3)-LNP2x3[121];	//[22,52]<<69
(*this).a.v3 -= LNt[560];
LNt[561] = float(LNP2x3[114]+(*this).a.v3)-LNP2x3[114];	//[7,30]<<69
(*this).a.v3 -= LNt[561];
(*this).a.v4 = 0.0-(LNt[217]+LNt[269]-LNt[293])+LNt[560]+LNt[561];
LNt[562] = (float(LNP2x3[125]+(*this).a.v4/LNP2[20])-LNP2x3[125])*LNP2[20];	//[22,53]<<92
(*this).a.v4 -= LNt[562];
LNt[563] = (float(LNP2x3[125]+(*this).a.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[8,31]<<92
(*this).a.v4 -= LNt[563];
(*this).a.v5 = 0.0-LNt[309]+LNt[562]+LNt[563];
LNt[564] = (float(LNP2x3[125]+(*this).a.v5/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
(*this).a.v5 -= LNt[564];
LNt[565] = (float(LNP2x3[125]+(*this).a.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
(*this).a.v5 -= LNt[565];
LNt[566] = 0.0-(LNt[219]+LNt[237]*LNt[268]+LNt[240]*LNt[266]+LNt[242]*LNt[263]-LNt[299])+LNt[564]+LNt[565];
(*this).a.v6 = LNt[566];
LNt[567] = (float(LNP2x3[125]+(*this).a.v6/LNP2[65])-LNP2x3[125])*LNP2[65];	//[22,52]<<138
(*this).a.v6 -= LNt[567];
LNt[568] = (float(LNP2x3[125]+(*this).a.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[7,30]<<138
(*this).a.v6 -= LNt[568];
(*this).a.v7 = 0.0-(LNt[220]+LNt[240]*LNt[268]+LNt[242]*LNt[266]-LNt[302])+LNt[567]+LNt[568];
LNt[569] = (float(LNP2x3[125]+(*this).a.v7/LNP2[88])-LNP2x3[125])*LNP2[88];	//[22,52]<<161
(*this).a.v7 -= LNt[569];
LNt[570] = (float(LNP2x3[125]+(*this).a.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[7,30]<<161
(*this).a.v7 -= LNt[570];
(*this).a.v8 = 0.0-(LNt[271]-LNt[305])+LNt[569]+LNt[570];
LNt[571] = (float(LNP2x3[125]+(*this).a.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[13,36]<<184
(*this).a.v8 -= LNt[571];
(*this).a.v9 = 0.0-(LNt[4]*LNt[159]-LNt[164]*LNt[214]-LNt[307])+LNt[571];
(*this).b.v0 = LNt[221]*LNt[140]-LNt[160]*LNt[340]+LNt[231]*LNt[380]-LNt[404];
LNt[572] = float(LNP2x3[49]+(*this).b.v0)-LNP2x3[49];	//[22,49]<<0
(*this).b.v0 -= LNt[572];
LNt[573] = float(LNP2x3[45]+(*this).b.v0)-LNP2x3[45];	//[4,27]<<0
(*this).b.v0 -= LNt[573];
(*this).b.v1 = LNt[393]-LNt[407]+LNt[572]+LNt[573];
LNt[574] = float(LNP2x3[73]+(*this).b.v1)-LNP2x3[73];	//[22,50]<<23
(*this).b.v1 -= LNt[574];
LNt[575] = float(LNP2x3[68]+(*this).b.v1)-LNP2x3[68];	//[5,28]<<23
(*this).b.v1 -= LNt[575];
LNt[576] = LNt[360]+LNt[231]*LNt[386]+LNt[234]*LNt[383]+LNt[237]*LNt[380]-LNt[410]+LNt[574]+LNt[575];
(*this).b.v2 = LNt[576];
LNt[577] = float(LNP2x3[97]+(*this).b.v2)-LNP2x3[97];	//[22,51]<<46
(*this).b.v2 -= LNt[577];
LNt[578] = float(LNP2x3[91]+(*this).b.v2)-LNP2x3[91];	//[6,29]<<46
(*this).b.v2 -= LNt[578];
(*this).b.v3 = LNt[431]+LNt[577]+LNt[578];
LNt[579] = float(LNP2x3[120]+(*this).b.v3)-LNP2x3[120];	//[22,51]<<69
(*this).b.v3 -= LNt[579];
LNt[580] = float(LNP2x3[114]+(*this).b.v3)-LNP2x3[114];	//[6,29]<<69
(*this).b.v3 -= LNt[580];
(*this).b.v4 = LNt[362]+LNt[392]-LNt[416]+LNt[579]+LNt[580];
LNt[581] = (float(LNP2x3[125]+(*this).b.v4/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
(*this).b.v4 -= LNt[581];
LNt[582] = (float(LNP2x3[125]+(*this).b.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
(*this).b.v4 -= LNt[582];
(*this).b.v5 = LNt[432]+LNt[581]+LNt[582];
LNt[583] = (float(LNP2x3[125]+(*this).b.v5/LNP2[41])-LNP2x3[125])*LNP2[41];	//[22,51]<<115
(*this).b.v5 -= LNt[583];
LNt[584] = (float(LNP2x3[125]+(*this).b.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[6,29]<<115
(*this).b.v5 -= LNt[584];
LNt[585] = LNt[364]+LNt[237]*LNt[391]+LNt[240]*LNt[389]+LNt[242]*LNt[386]-LNt[422]+LNt[583]+LNt[584];
(*this).b.v6 = LNt[585];
LNt[586] = (float(LNP2x3[125]+(*this).b.v6/LNP2[64])-LNP2x3[125])*LNP2[64];	//[22,51]<<138
(*this).b.v6 -= LNt[586];
LNt[587] = (float(LNP2x3[125]+(*this).b.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[6,29]<<138
(*this).b.v6 -= LNt[587];
(*this).b.v7 = LNt[365]+LNt[240]*LNt[391]+LNt[242]*LNt[389]-LNt[425]+LNt[586]+LNt[587];
LNt[588] = (float(LNP2x3[125]+(*this).b.v7/LNP2[87])-LNP2x3[125])*LNP2[87];	//[22,51]<<161
(*this).b.v7 -= LNt[588];
LNt[589] = (float(LNP2x3[125]+(*this).b.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[6,29]<<161
(*this).b.v7 -= LNt[589];
(*this).b.v8 = LNt[394]-LNt[428]+LNt[588]+LNt[589];
LNt[590] = (float(LNP2x3[125]+(*this).b.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[12,35]<<184
(*this).b.v8 -= LNt[590];
(*this).b.v9 = LNt[225]*LNt[159]-LNt[164]*LNt[359]-LNt[430]+LNt[590];
(*this).c.v0 = 0.-(LNt[221]*LNt[195]-LNt[0]*LNt[340]+LNt[231]*LNt[453]-LNt[477]);
LNt[591] = float(LNP2x3[50]+(*this).c.v0)-LNP2x3[50];	//[22,50]<<0
(*this).c.v0 -= LNt[591];
LNt[592] = float(LNP2x3[45]+(*this).c.v0)-LNP2x3[45];	//[5,28]<<0
(*this).c.v0 -= LNt[592];
(*this).c.v1 = 0.0-(LNt[466]-LNt[480])+LNt[591]+LNt[592];
LNt[593] = float(LNP2x3[74]+(*this).c.v1)-LNP2x3[74];	//[22,51]<<23
(*this).c.v1 -= LNt[593];
LNt[594] = float(LNP2x3[68]+(*this).c.v1)-LNP2x3[68];	//[6,29]<<23
(*this).c.v1 -= LNt[594];
LNt[595] = 0.0-(LNt[433]+LNt[231]*LNt[459]+LNt[234]*LNt[456]+LNt[237]*LNt[453]-LNt[483])+LNt[593]+LNt[594];
(*this).c.v2 = LNt[595];
LNt[596] = float(LNP2x3[98]+(*this).c.v2)-LNP2x3[98];	//[22,52]<<46
(*this).c.v2 -= LNt[596];
LNt[597] = float(LNP2x3[91]+(*this).c.v2)-LNP2x3[91];	//[7,30]<<46
(*this).c.v2 -= LNt[597];
(*this).c.v3 = 0.0-LNt[504]+LNt[596]+LNt[597];
LNt[598] = float(LNP2x3[121]+(*this).c.v3)-LNP2x3[121];	//[22,52]<<69
(*this).c.v3 -= LNt[598];
LNt[599] = float(LNP2x3[114]+(*this).c.v3)-LNP2x3[114];	//[7,30]<<69
(*this).c.v3 -= LNt[599];
(*this).c.v4 = 0.0-(LNt[435]+LNt[465]-LNt[489])+LNt[598]+LNt[599];
LNt[600] = (float(LNP2x3[125]+(*this).c.v4/LNP2[20])-LNP2x3[125])*LNP2[20];	//[22,53]<<92
(*this).c.v4 -= LNt[600];
LNt[601] = (float(LNP2x3[125]+(*this).c.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[8,31]<<92
(*this).c.v4 -= LNt[601];
(*this).c.v5 = 0.0-LNt[505]+LNt[600]+LNt[601];
LNt[602] = (float(LNP2x3[125]+(*this).c.v5/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
(*this).c.v5 -= LNt[602];
LNt[603] = (float(LNP2x3[125]+(*this).c.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
(*this).c.v5 -= LNt[603];
LNt[604] = 0.0-(LNt[437]+LNt[237]*LNt[464]+LNt[240]*LNt[462]+LNt[242]*LNt[459]-LNt[495])+LNt[602]+LNt[603];
(*this).c.v6 = LNt[604];
LNt[605] = (float(LNP2x3[125]+(*this).c.v6/LNP2[65])-LNP2x3[125])*LNP2[65];	//[22,52]<<138
(*this).c.v6 -= LNt[605];
LNt[606] = (float(LNP2x3[125]+(*this).c.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[7,30]<<138
(*this).c.v6 -= LNt[606];
(*this).c.v7 = 0.0-(LNt[438]+LNt[240]*LNt[464]+LNt[242]*LNt[462]-LNt[498])+LNt[605]+LNt[606];
LNt[607] = (float(LNP2x3[125]+(*this).c.v7/LNP2[88])-LNP2x3[125])*LNP2[88];	//[22,52]<<161
(*this).c.v7 -= LNt[607];
LNt[608] = (float(LNP2x3[125]+(*this).c.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[7,30]<<161
(*this).c.v7 -= LNt[608];
(*this).c.v8 = 0.0-(LNt[467]-LNt[501])+LNt[607]+LNt[608];
LNt[609] = (float(LNP2x3[125]+(*this).c.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[13,36]<<184
(*this).c.v8 -= LNt[609];
(*this).c.v9 = 0.0-(LNt[225]*LNt[214]-LNt[4]*LNt[359]-LNt[503])+LNt[609];
(*this).d.v0 = LNt[221]*LNt[257]-LNt[0]*LNt[380]+LNt[160]*LNt[453]-LNt[516];
LNt[610] = float(LNP2x3[49]+(*this).d.v0)-LNP2x3[49];	//[22,49]<<0
(*this).d.v0 -= LNt[610];
LNt[611] = float(LNP2x3[45]+(*this).d.v0)-LNP2x3[45];	//[4,27]<<0
(*this).d.v0 -= LNt[611];
(*this).d.v1 = LNt[509]-LNt[519]+LNt[610]+LNt[611];
LNt[612] = float(LNP2x3[73]+(*this).d.v1)-LNP2x3[73];	//[22,50]<<23
(*this).d.v1 -= LNt[612];
LNt[613] = float(LNP2x3[68]+(*this).d.v1)-LNP2x3[68];	//[5,28]<<23
(*this).d.v1 -= LNt[613];
LNt[614] = LNt[506]+LNt[160]*LNt[459]+LNt[163]*LNt[456]+LNt[164]*LNt[453]-LNt[522]+LNt[612]+LNt[613];
(*this).d.v2 = LNt[614];
LNt[615] = float(LNP2x3[97]+(*this).d.v2)-LNP2x3[97];	//[22,51]<<46
(*this).d.v2 -= LNt[615];
LNt[616] = float(LNP2x3[91]+(*this).d.v2)-LNP2x3[91];	//[6,29]<<46
(*this).d.v2 -= LNt[616];
LNt[617] = LNt[507]+LNt[160]*LNt[462]+LNt[163]*LNt[459]+LNt[164]*LNt[456]-LNt[525]+LNt[615]+LNt[616];
(*this).d.v3 = LNt[617];
LNt[618] = float(LNP2x3[120]+(*this).d.v3)-LNP2x3[120];	//[22,51]<<69
(*this).d.v3 -= LNt[618];
LNt[619] = float(LNP2x3[114]+(*this).d.v3)-LNP2x3[114];	//[6,29]<<69
(*this).d.v3 -= LNt[619];
LNt[620] = LNt[508]+LNt[160]*LNt[464]+LNt[163]*LNt[462]+LNt[164]*LNt[459]-LNt[528]+LNt[618]+LNt[619];
(*this).d.v4 = LNt[620];
LNt[621] = (float(LNP2x3[125]+(*this).d.v4/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
(*this).d.v4 -= LNt[621];
LNt[622] = (float(LNP2x3[125]+(*this).d.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
(*this).d.v4 -= LNt[622];
(*this).d.v5 = LNt[510]-LNt[531]+LNt[621]+LNt[622];
LNt[623] = (float(LNP2x3[125]+(*this).d.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[21,44]<<115
(*this).d.v5 -= LNt[623];
(*this).d.v6 = LNt[225]*LNt[268]-LNt[4]*LNt[391]+LNt[164]*LNt[464]-LNt[533]+LNt[623];
LNt[624] = (float(LNP2x3[125]+(*this).d.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[4,27]<<138
(*this).d.v6 -= LNt[624];
(*this).d.v7 = 0.0-LNt[534]+LNt[624];
(*this).e.v0 = 0.-(LNt[221]*LNt[281]-LNt[0]*LNt[404]+LNt[160]*LNt[477]-LNt[231]*LNt[516]);
LNt[625] = float(LNP2x3[50]+(*this).e.v0)-LNP2x3[50];	//[22,50]<<0
(*this).e.v0 -= LNt[625];
LNt[626] = float(LNP2x3[45]+(*this).e.v0)-LNP2x3[45];	//[5,28]<<0
(*this).e.v0 -= LNt[626];
(*this).e.v1 = 0.0-(LNt[543]-(LNt[231]*LNt[519]+LNt[234]*LNt[516]))+LNt[625]+LNt[626];
LNt[627] = float(LNP2x3[74]+(*this).e.v1)-LNP2x3[74];	//[22,51]<<23
(*this).e.v1 -= LNt[627];
LNt[628] = float(LNP2x3[68]+(*this).e.v1)-LNP2x3[68];	//[6,29]<<23
(*this).e.v1 -= LNt[628];
(*this).e.v2 = 0.0-LNt[549]+LNt[627]+LNt[628];
LNt[629] = float(LNP2x3[98]+(*this).e.v2)-LNP2x3[98];	//[22,52]<<46
(*this).e.v2 -= LNt[629];
LNt[630] = float(LNP2x3[91]+(*this).e.v2)-LNP2x3[91];	//[7,30]<<46
(*this).e.v2 -= LNt[630];
(*this).e.v3 = 0.0-LNt[550]+LNt[629]+LNt[630];
LNt[631] = float(LNP2x3[121]+(*this).e.v3)-LNP2x3[121];	//[22,52]<<69
(*this).e.v3 -= LNt[631];
LNt[632] = float(LNP2x3[114]+(*this).e.v3)-LNP2x3[114];	//[7,30]<<69
(*this).e.v3 -= LNt[632];
LNt[633] = 0.0-(LNt[537]+LNt[160]*LNt[489]+LNt[163]*LNt[486]+LNt[164]*LNt[483]-LNt[545])+LNt[631]+LNt[632];
(*this).e.v4 = LNt[633];
LNt[634] = (float(LNP2x3[125]+(*this).e.v4/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
(*this).e.v4 -= LNt[634];
LNt[635] = (float(LNP2x3[125]+(*this).e.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
(*this).e.v4 -= LNt[635];
LNt[636] = 0.0-(LNt[538]+LNt[160]*LNt[492]+LNt[163]*LNt[489]+LNt[164]*LNt[486]-LNt[546])+LNt[634]+LNt[635];
(*this).e.v5 = LNt[636];
LNt[637] = (float(LNP2x3[125]+(*this).e.v5/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
(*this).e.v5 -= LNt[637];
LNt[638] = (float(LNP2x3[125]+(*this).e.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
(*this).e.v5 -= LNt[638];
LNt[639] = 0.0-(LNt[539]+LNt[160]*LNt[495]+LNt[163]*LNt[492]+LNt[164]*LNt[489]-LNt[547])+LNt[637]+LNt[638];
(*this).e.v6 = LNt[639];
LNt[640] = (float(LNP2x3[125]+(*this).e.v6/LNP2[65])-LNP2x3[125])*LNP2[65];	//[22,52]<<138
(*this).e.v6 -= LNt[640];
LNt[641] = (float(LNP2x3[125]+(*this).e.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[7,30]<<138
(*this).e.v6 -= LNt[641];
LNt[642] = 0.0-(LNt[540]+LNt[160]*LNt[498]+LNt[163]*LNt[495]+LNt[164]*LNt[492]-LNt[548])+LNt[640]+LNt[641];
(*this).e.v7 = LNt[642];
LNt[643] = (float(LNP2x3[125]+(*this).e.v7/LNP2[88])-LNP2x3[125])*LNP2[88];	//[22,52]<<161
(*this).e.v7 -= LNt[643];
LNt[644] = (float(LNP2x3[125]+(*this).e.v7/LNP2[81])-LNP2x3[125])*LNP2[81];	//[7,30]<<161
(*this).e.v7 -= LNt[644];
(*this).e.v8 = 0.0-LNt[551]+LNt[643]+LNt[644];
LNt[645] = (float(LNP2x3[125]+(*this).e.v8/LNP2[111])-LNP2x3[125])*LNP2[111];	//[22,52]<<184
(*this).e.v8 -= LNt[645];
LNt[646] = (float(LNP2x3[125]+(*this).e.v8/LNP2[104])-LNP2x3[125])*LNP2[104];	//[7,30]<<184
(*this).e.v8 -= LNt[646];
(*this).e.v9 = 0.0-LNt[552]+LNt[645]+LNt[646];
LNt[647] = (float(LNP2x3[125]+(*this).e.v9/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
(*this).e.v9 -= LNt[647];
LNt[648] = (float(LNP2x3[125]+(*this).e.v9/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
(*this).e.v9 -= LNt[648];
(*this).e.v10 = 0.0-(LNt[544]-(LNt[240]*LNt[534]+LNt[242]*LNt[533]))+LNt[647]+LNt[648];
LNt[649] = (float(LNP2x3[125]+(*this).e.v10/LNP2[150])-LNP2x3[125])*LNP2[150];	//[19,42]<<230
(*this).e.v10 -= LNt[649];
LNt[650] = 0.0-(LNt[225]*LNt[307]-LNt[4]*LNt[430]+LNt[164]*LNt[503]-LNt[242]*LNt[534])+LNt[649];
(*this).e.v11 = LNt[650];
} /* adds=1311 multiplies=1054 normalizes=339 */


integer weightedincircle3dbeyond(const WPoint3d& p, const WeightedIncircle3dHyperPlane& pi){
integer LNans;
LNt[1] = p.x*(pi.a.v9+pi.a.v8+pi.a.v7)+p.y*(pi.b.v9+pi.b.v8+pi.b.v7)+p.z*(pi.c.v9+pi.c.v8+pi.c.v7);
LNt[2] = LNt[1]+(p.x*p.x+p.y*p.y+p.z*p.z-p.w)*(pi.d.v7+pi.d.v6+pi.d.v5+pi.d.v4)+pi.e.v11+pi.e.v10+pi.e.v9;
if (-LNP2[233]<LNt[2] && LNt[2]<LNP2[233]) {	/* the high order 46 bits of 279 are accurate */
  LNt[3] = p.x;
  LNt[4] = float(LNP2x3[53]+LNt[3])-LNP2x3[53];	//[22,53]<<0
  LNt[3] -= LNt[4];
  LNt[5] = float(LNP2x3[45]+LNt[3])-LNP2x3[45];	//[8,31]<<0
  LNt[3] -= LNt[5];
  LNt[6] = LNt[4]+LNt[5];
  LNt[7] = float(LNP2x3[68]+LNt[6])-LNP2x3[68];	//[7,30]<<23
  LNt[6] -= LNt[7];
  LNt[8] = p.y;
  LNt[9] = float(LNP2x3[53]+LNt[8])-LNP2x3[53];	//[22,53]<<0
  LNt[8] -= LNt[9];
  LNt[10] = float(LNP2x3[45]+LNt[8])-LNP2x3[45];	//[8,31]<<0
  LNt[8] -= LNt[10];
  LNt[11] = LNt[9]+LNt[10];
  LNt[12] = float(LNP2x3[68]+LNt[11])-LNP2x3[68];	//[7,30]<<23
  LNt[11] -= LNt[12];
  LNt[13] = LNt[3]*pi.a.v2+LNt[6]*pi.a.v1+LNt[7]*pi.a.v0+LNt[8]*pi.b.v2+LNt[11]*pi.b.v1+LNt[12]*pi.b.v0;
  LNt[14] = LNt[3]*pi.a.v3+LNt[6]*pi.a.v2+LNt[7]*pi.a.v1+LNt[8]*pi.b.v3+LNt[11]*pi.b.v2+LNt[12]*pi.b.v1;
  LNt[15] = LNt[3]*pi.a.v4+LNt[6]*pi.a.v3+LNt[7]*pi.a.v2+LNt[8]*pi.b.v4+LNt[11]*pi.b.v3+LNt[12]*pi.b.v2;
  LNt[16] = LNt[3]*pi.a.v5+LNt[6]*pi.a.v4+LNt[7]*pi.a.v3+LNt[8]*pi.b.v5+LNt[11]*pi.b.v4+LNt[12]*pi.b.v3;
  LNt[17] = LNt[3]*pi.a.v6+LNt[6]*pi.a.v5+LNt[7]*pi.a.v4+LNt[8]*pi.b.v6+LNt[11]*pi.b.v5+LNt[12]*pi.b.v4;
  LNt[18] = LNt[3]*pi.a.v7+LNt[6]*pi.a.v6+LNt[7]*pi.a.v5+LNt[8]*pi.b.v7+LNt[11]*pi.b.v6+LNt[12]*pi.b.v5;
  LNt[19] = LNt[3]*pi.a.v8+LNt[6]*pi.a.v7+LNt[7]*pi.a.v6+LNt[8]*pi.b.v8+LNt[11]*pi.b.v7+LNt[12]*pi.b.v6;
  LNt[20] = LNt[3]*pi.a.v9+LNt[6]*pi.a.v8+LNt[7]*pi.a.v7+LNt[8]*pi.b.v9+LNt[11]*pi.b.v8+LNt[12]*pi.b.v7;
  LNt[21] = p.z;
  LNt[22] = float(LNP2x3[53]+LNt[21])-LNP2x3[53];	//[22,53]<<0
  LNt[21] -= LNt[22];
  LNt[23] = float(LNP2x3[45]+LNt[21])-LNP2x3[45];	//[8,31]<<0
  LNt[21] -= LNt[23];
  LNt[24] = LNt[22]+LNt[23];
  LNt[25] = float(LNP2x3[68]+LNt[24])-LNP2x3[68];	//[7,30]<<23
  LNt[24] -= LNt[25];
  LNt[26] = LNt[3]*pi.a.v1+LNt[6]*pi.a.v0+LNt[8]*pi.b.v1+LNt[11]*pi.b.v0+LNt[21]*pi.c.v1+LNt[24]*pi.c.v0;
  LNt[27] = LNt[6]*pi.a.v9+LNt[7]*pi.a.v8+LNt[11]*pi.b.v9+LNt[12]*pi.b.v8+LNt[24]*pi.c.v9+LNt[25]*pi.c.v8;
  LNt[28] = LNt[3]*LNt[7]+LNt[6]*LNt[6]+LNt[7]*LNt[3]+LNt[8]*LNt[12]+LNt[11]*LNt[11]+LNt[12]*LNt[8];
  LNt[29] = LNt[3]*LNt[6]+LNt[6]*LNt[3]+LNt[8]*LNt[11]+LNt[11]*LNt[8]+LNt[21]*LNt[24]+LNt[24]*LNt[21];
  LNt[30] = LNt[6]*LNt[7]+LNt[7]*LNt[6]+LNt[11]*LNt[12]+LNt[12]*LNt[11]+LNt[24]*LNt[25]+LNt[25]*LNt[24];
  LNt[31] = p.w;
  LNt[32] = float(LNP2x3[74]+LNt[31])-LNP2x3[74];	//[1,53]<<0
  LNt[31] -= LNt[32];
  LNt[33] = LNt[3]*LNt[3]+LNt[8]*LNt[8]+LNt[21]*LNt[21]-LNt[31];
  LNt[34] = float(LNP2x3[53]+LNt[33])-LNP2x3[53];	//[22,53]<<0
  LNt[33] -= LNt[34];
  LNt[35] = float(LNP2x3[45]+LNt[33])-LNP2x3[45];	//[8,31]<<0
  LNt[33] -= LNt[35];
  LNt[36] = LNt[29]-LNt[32]+LNt[34]+LNt[35];
  LNt[37] = float(LNP2x3[73]+LNt[36])-LNP2x3[73];	//[22,50]<<23
  LNt[36] -= LNt[37];
  LNt[38] = float(LNP2x3[68]+LNt[36])-LNP2x3[68];	//[5,28]<<23
  LNt[36] -= LNt[38];
  LNt[39] = LNt[28]+LNt[21]*LNt[25]+LNt[24]*LNt[24]+LNt[25]*LNt[21]+LNt[37]+LNt[38];
  LNt[40] = float(LNP2x3[96]+LNt[39])-LNP2x3[96];	//[22,50]<<46
  LNt[39] -= LNt[40];
  LNt[41] = float(LNP2x3[91]+LNt[39])-LNP2x3[91];	//[5,28]<<46
  LNt[39] -= LNt[41];
  LNt[42] = LNt[30]+LNt[40]+LNt[41];
  LNt[43] = float(LNP2x3[114]+LNt[42])-LNP2x3[114];	//[10,33]<<69
  LNt[42] -= LNt[43];
  LNt[44] = LNt[7]*LNt[7]+LNt[12]*LNt[12]+LNt[25]*LNt[25]+LNt[43];
  LNt[45] = LNt[13]+LNt[21]*pi.c.v2+LNt[24]*pi.c.v1+LNt[25]*pi.c.v0+LNt[33]*pi.d.v2+LNt[36]*pi.d.v1+LNt[39]*pi.d.v0;
  LNt[46] = LNt[14]+LNt[21]*pi.c.v3+LNt[24]*pi.c.v2+LNt[25]*pi.c.v1+LNt[33]*pi.d.v3+LNt[36]*pi.d.v2+LNt[39]*pi.d.v1+LNt[42]*pi.d.v0;
  LNt[47] = LNt[15]+LNt[21]*pi.c.v4+LNt[24]*pi.c.v3+LNt[25]*pi.c.v2+LNt[33]*pi.d.v4+LNt[36]*pi.d.v3+LNt[39]*pi.d.v2+LNt[42]*pi.d.v1+LNt[44]*pi.d.v0;
  LNt[48] = LNt[16]+LNt[21]*pi.c.v5+LNt[24]*pi.c.v4+LNt[25]*pi.c.v3+LNt[33]*pi.d.v5+LNt[36]*pi.d.v4+LNt[39]*pi.d.v3+LNt[42]*pi.d.v2+LNt[44]*pi.d.v1;
  LNt[49] = LNt[17]+LNt[21]*pi.c.v6+LNt[24]*pi.c.v5+LNt[25]*pi.c.v4+LNt[33]*pi.d.v6+LNt[36]*pi.d.v5+LNt[39]*pi.d.v4+LNt[42]*pi.d.v3+LNt[44]*pi.d.v2;
  LNt[50] = LNt[18]+LNt[21]*pi.c.v7+LNt[24]*pi.c.v6+LNt[25]*pi.c.v5+LNt[33]*pi.d.v7+LNt[36]*pi.d.v6+LNt[39]*pi.d.v5+LNt[42]*pi.d.v4+LNt[44]*pi.d.v3;
  LNt[51] = LNt[19]+LNt[21]*pi.c.v8+LNt[24]*pi.c.v7+LNt[25]*pi.c.v6+LNt[36]*pi.d.v7+LNt[39]*pi.d.v6+LNt[42]*pi.d.v5+LNt[44]*pi.d.v4;
  LNt[52] = LNt[20]+LNt[21]*pi.c.v9+LNt[24]*pi.c.v8+LNt[25]*pi.c.v7+LNt[39]*pi.d.v7+LNt[42]*pi.d.v6+LNt[44]*pi.d.v5;
  LNt[53] = LNt[3]*pi.a.v0+LNt[8]*pi.b.v0+LNt[21]*pi.c.v0+LNt[33]*pi.d.v0+pi.e.v0;
  LNt[54] = LNt[26]+LNt[33]*pi.d.v1+LNt[36]*pi.d.v0+pi.e.v1;
  LNt[55] = LNt[45]+pi.e.v2;
  LNt[56] = LNt[46]+pi.e.v3;
  LNt[57] = LNt[47]+pi.e.v4;
  LNt[58] = LNt[48]+pi.e.v5;
  LNt[59] = LNt[49]+pi.e.v6;
  LNt[60] = LNt[50]+pi.e.v7;
  LNt[61] = LNt[51]+pi.e.v8;
  LNt[62] = LNt[52]+pi.e.v9;
  LNt[63] = LNt[27]+LNt[42]*pi.d.v7+LNt[44]*pi.d.v6+pi.e.v10;
  LNt[64] = LNt[7]*pi.a.v9+LNt[12]*pi.b.v9+LNt[25]*pi.c.v9+LNt[44]*pi.d.v7+pi.e.v11;
  LNt[65] = ((((((((LNt[64])+LNt[63])+LNt[62])+LNt[61])+LNt[60])+LNt[59])+LNt[58])+LNt[57])+LNt[56];
  LNt[2] = ((((LNt[65])+LNt[55])+LNt[54])+LNt[53]);
}
if (LNt[2]<0){
  LNt[0] = -1.;
}else{
  if (LNt[2]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=193 multiplies=164 normalizes=17 */


LongHomogPoint3d::LongHomogPoint3d(const Plane& pi, const Plane& pj, const Plane& pk){
LNt[0] = pk.b;
LNt[1] = float(LNP2x3[53]+LNt[0])-LNP2x3[53];	//[22,53]<<0
LNt[0] -= LNt[1];
LNt[2] = float(LNP2x3[45]+LNt[0])-LNP2x3[45];	//[8,31]<<0
LNt[0] -= LNt[2];
LNt[3] = LNt[1]+LNt[2];
LNt[4] = float(LNP2x3[68]+LNt[3])-LNP2x3[68];	//[7,30]<<23
LNt[3] -= LNt[4];
LNt[5] = pi.c;
LNt[6] = float(LNP2x3[53]+LNt[5])-LNP2x3[53];	//[22,53]<<0
LNt[5] -= LNt[6];
LNt[7] = float(LNP2x3[45]+LNt[5])-LNP2x3[45];	//[8,31]<<0
LNt[5] -= LNt[7];
LNt[8] = LNt[6]+LNt[7];
LNt[9] = float(LNP2x3[68]+LNt[8])-LNP2x3[68];	//[7,30]<<23
LNt[8] -= LNt[9];
LNt[10] = pj.d;
LNt[11] = float(LNP2x3[53]+LNt[10])-LNP2x3[53];	//[22,53]<<0
LNt[10] -= LNt[11];
LNt[12] = float(LNP2x3[45]+LNt[10])-LNP2x3[45];	//[8,31]<<0
LNt[10] -= LNt[12];
LNt[13] = LNt[11]+LNt[12];
LNt[14] = float(LNP2x3[68]+LNt[13])-LNP2x3[68];	//[7,30]<<23
LNt[13] -= LNt[14];
LNt[15] = pj.c;
LNt[16] = float(LNP2x3[53]+LNt[15])-LNP2x3[53];	//[22,53]<<0
LNt[15] -= LNt[16];
LNt[17] = float(LNP2x3[45]+LNt[15])-LNP2x3[45];	//[8,31]<<0
LNt[15] -= LNt[17];
LNt[18] = LNt[16]+LNt[17];
LNt[19] = float(LNP2x3[68]+LNt[18])-LNP2x3[68];	//[7,30]<<23
LNt[18] -= LNt[19];
LNt[20] = pi.d;
LNt[21] = float(LNP2x3[53]+LNt[20])-LNP2x3[53];	//[22,53]<<0
LNt[20] -= LNt[21];
LNt[22] = float(LNP2x3[45]+LNt[20])-LNP2x3[45];	//[8,31]<<0
LNt[20] -= LNt[22];
LNt[23] = LNt[21]+LNt[22];
LNt[24] = float(LNP2x3[68]+LNt[23])-LNP2x3[68];	//[7,30]<<23
LNt[23] -= LNt[24];
LNt[25] = LNt[5]*LNt[14]+LNt[8]*LNt[13]+LNt[9]*LNt[10]-(LNt[15]*LNt[24]+LNt[18]*LNt[23]+LNt[19]*LNt[20]);
LNt[26] = LNt[5]*LNt[10]-LNt[15]*LNt[20];
LNt[27] = float(LNP2x3[47]+LNt[26])-LNP2x3[47];	//[22,47]<<0
LNt[26] -= LNt[27];
LNt[28] = float(LNP2x3[45]+LNt[26])-LNP2x3[45];	//[2,25]<<0
LNt[26] -= LNt[28];
LNt[29] = LNt[5]*LNt[13]+LNt[8]*LNt[10]-(LNt[15]*LNt[23]+LNt[18]*LNt[20])+LNt[27]+LNt[28];
LNt[30] = float(LNP2x3[71]+LNt[29])-LNP2x3[71];	//[22,48]<<23
LNt[29] -= LNt[30];
LNt[31] = float(LNP2x3[68]+LNt[29])-LNP2x3[68];	//[3,26]<<23
LNt[29] -= LNt[31];
LNt[32] = LNt[25]+LNt[30]+LNt[31];
LNt[33] = float(LNP2x3[95]+LNt[32])-LNP2x3[95];	//[22,49]<<46
LNt[32] -= LNt[33];
LNt[34] = float(LNP2x3[91]+LNt[32])-LNP2x3[91];	//[4,27]<<46
LNt[32] -= LNt[34];
LNt[35] = LNt[8]*LNt[14]+LNt[9]*LNt[13]-(LNt[18]*LNt[24]+LNt[19]*LNt[23])+LNt[33]+LNt[34];
LNt[36] = float(LNP2x3[114]+LNt[35])-LNP2x3[114];	//[9,32]<<69
LNt[35] -= LNt[36];
LNt[37] = LNt[9]*LNt[14]-LNt[19]*LNt[24]+LNt[36];
LNt[38] = pk.c;
LNt[39] = float(LNP2x3[53]+LNt[38])-LNP2x3[53];	//[22,53]<<0
LNt[38] -= LNt[39];
LNt[40] = float(LNP2x3[45]+LNt[38])-LNP2x3[45];	//[8,31]<<0
LNt[38] -= LNt[40];
LNt[41] = LNt[39]+LNt[40];
LNt[42] = float(LNP2x3[68]+LNt[41])-LNP2x3[68];	//[7,30]<<23
LNt[41] -= LNt[42];
LNt[43] = pi.b;
LNt[44] = float(LNP2x3[53]+LNt[43])-LNP2x3[53];	//[22,53]<<0
LNt[43] -= LNt[44];
LNt[45] = float(LNP2x3[45]+LNt[43])-LNP2x3[45];	//[8,31]<<0
LNt[43] -= LNt[45];
LNt[46] = LNt[44]+LNt[45];
LNt[47] = float(LNP2x3[68]+LNt[46])-LNP2x3[68];	//[7,30]<<23
LNt[46] -= LNt[47];
LNt[48] = pj.b;
LNt[49] = float(LNP2x3[53]+LNt[48])-LNP2x3[53];	//[22,53]<<0
LNt[48] -= LNt[49];
LNt[50] = float(LNP2x3[45]+LNt[48])-LNP2x3[45];	//[8,31]<<0
LNt[48] -= LNt[50];
LNt[51] = LNt[49]+LNt[50];
LNt[52] = float(LNP2x3[68]+LNt[51])-LNP2x3[68];	//[7,30]<<23
LNt[51] -= LNt[52];
LNt[53] = LNt[43]*LNt[14]+LNt[46]*LNt[13]+LNt[47]*LNt[10]-(LNt[48]*LNt[24]+LNt[51]*LNt[23]+LNt[52]*LNt[20]);
LNt[54] = LNt[43]*LNt[10]-LNt[48]*LNt[20];
LNt[55] = float(LNP2x3[47]+LNt[54])-LNP2x3[47];	//[22,47]<<0
LNt[54] -= LNt[55];
LNt[56] = float(LNP2x3[45]+LNt[54])-LNP2x3[45];	//[2,25]<<0
LNt[54] -= LNt[56];
LNt[57] = LNt[43]*LNt[13]+LNt[46]*LNt[10]-(LNt[48]*LNt[23]+LNt[51]*LNt[20])+LNt[55]+LNt[56];
LNt[58] = float(LNP2x3[71]+LNt[57])-LNP2x3[71];	//[22,48]<<23
LNt[57] -= LNt[58];
LNt[59] = float(LNP2x3[68]+LNt[57])-LNP2x3[68];	//[3,26]<<23
LNt[57] -= LNt[59];
LNt[60] = LNt[53]+LNt[58]+LNt[59];
LNt[61] = float(LNP2x3[95]+LNt[60])-LNP2x3[95];	//[22,49]<<46
LNt[60] -= LNt[61];
LNt[62] = float(LNP2x3[91]+LNt[60])-LNP2x3[91];	//[4,27]<<46
LNt[60] -= LNt[62];
LNt[63] = LNt[46]*LNt[14]+LNt[47]*LNt[13]-(LNt[51]*LNt[24]+LNt[52]*LNt[23])+LNt[61]+LNt[62];
LNt[64] = float(LNP2x3[114]+LNt[63])-LNP2x3[114];	//[9,32]<<69
LNt[63] -= LNt[64];
LNt[65] = LNt[47]*LNt[14]-LNt[52]*LNt[24]+LNt[64];
LNt[66] = LNt[0]*LNt[32]+LNt[3]*LNt[29]+LNt[4]*LNt[26]-(LNt[38]*LNt[60]+LNt[41]*LNt[57]+LNt[42]*LNt[54]);
LNt[67] = LNt[0]*LNt[35]+LNt[3]*LNt[32]+LNt[4]*LNt[29]-(LNt[38]*LNt[63]+LNt[41]*LNt[60]+LNt[42]*LNt[57]);
LNt[68] = LNt[0]*LNt[37]+LNt[3]*LNt[35]+LNt[4]*LNt[32]-(LNt[38]*LNt[65]+LNt[41]*LNt[63]+LNt[42]*LNt[60]);
LNt[69] = pk.d;
LNt[70] = float(LNP2x3[53]+LNt[69])-LNP2x3[53];	//[22,53]<<0
LNt[69] -= LNt[70];
LNt[71] = float(LNP2x3[45]+LNt[69])-LNP2x3[45];	//[8,31]<<0
LNt[69] -= LNt[71];
LNt[72] = LNt[70]+LNt[71];
LNt[73] = float(LNP2x3[68]+LNt[72])-LNP2x3[68];	//[7,30]<<23
LNt[72] -= LNt[73];
LNt[74] = LNt[43]*LNt[19]+LNt[46]*LNt[18]+LNt[47]*LNt[15]-(LNt[48]*LNt[9]+LNt[51]*LNt[8]+LNt[52]*LNt[5]);
LNt[75] = LNt[43]*LNt[15]-LNt[48]*LNt[5];
LNt[76] = float(LNP2x3[47]+LNt[75])-LNP2x3[47];	//[22,47]<<0
LNt[75] -= LNt[76];
LNt[77] = float(LNP2x3[45]+LNt[75])-LNP2x3[45];	//[2,25]<<0
LNt[75] -= LNt[77];
LNt[78] = LNt[43]*LNt[18]+LNt[46]*LNt[15]-(LNt[48]*LNt[8]+LNt[51]*LNt[5])+LNt[76]+LNt[77];
LNt[79] = float(LNP2x3[71]+LNt[78])-LNP2x3[71];	//[22,48]<<23
LNt[78] -= LNt[79];
LNt[80] = float(LNP2x3[68]+LNt[78])-LNP2x3[68];	//[3,26]<<23
LNt[78] -= LNt[80];
LNt[81] = LNt[74]+LNt[79]+LNt[80];
LNt[82] = float(LNP2x3[95]+LNt[81])-LNP2x3[95];	//[22,49]<<46
LNt[81] -= LNt[82];
LNt[83] = float(LNP2x3[91]+LNt[81])-LNP2x3[91];	//[4,27]<<46
LNt[81] -= LNt[83];
LNt[84] = LNt[46]*LNt[19]+LNt[47]*LNt[18]-(LNt[51]*LNt[9]+LNt[52]*LNt[8])+LNt[82]+LNt[83];
LNt[85] = float(LNP2x3[114]+LNt[84])-LNP2x3[114];	//[9,32]<<69
LNt[84] -= LNt[85];
LNt[86] = LNt[47]*LNt[19]-LNt[52]*LNt[9]+LNt[85];
LNt[87] = LNt[0]*LNt[29]+LNt[3]*LNt[26]-(LNt[38]*LNt[57]+LNt[41]*LNt[54])+LNt[69]*LNt[78]+LNt[72]*LNt[75];
LNt[88] = LNt[3]*LNt[37]+LNt[4]*LNt[35]-(LNt[41]*LNt[65]+LNt[42]*LNt[63])+LNt[72]*LNt[86]+LNt[73]*LNt[84];
LNt[89] = pk.a;
LNt[90] = float(LNP2x3[53]+LNt[89])-LNP2x3[53];	//[22,53]<<0
LNt[89] -= LNt[90];
LNt[91] = float(LNP2x3[45]+LNt[89])-LNP2x3[45];	//[8,31]<<0
LNt[89] -= LNt[91];
LNt[92] = LNt[90]+LNt[91];
LNt[93] = float(LNP2x3[68]+LNt[92])-LNP2x3[68];	//[7,30]<<23
LNt[92] -= LNt[93];
LNt[94] = pi.a;
LNt[95] = float(LNP2x3[53]+LNt[94])-LNP2x3[53];	//[22,53]<<0
LNt[94] -= LNt[95];
LNt[96] = float(LNP2x3[45]+LNt[94])-LNP2x3[45];	//[8,31]<<0
LNt[94] -= LNt[96];
LNt[97] = LNt[95]+LNt[96];
LNt[98] = float(LNP2x3[68]+LNt[97])-LNP2x3[68];	//[7,30]<<23
LNt[97] -= LNt[98];
LNt[99] = pj.a;
LNt[100] = float(LNP2x3[53]+LNt[99])-LNP2x3[53];	//[22,53]<<0
LNt[99] -= LNt[100];
LNt[101] = float(LNP2x3[45]+LNt[99])-LNP2x3[45];	//[8,31]<<0
LNt[99] -= LNt[101];
LNt[102] = LNt[100]+LNt[101];
LNt[103] = float(LNP2x3[68]+LNt[102])-LNP2x3[68];	//[7,30]<<23
LNt[102] -= LNt[103];
LNt[104] = LNt[94]*LNt[14]+LNt[97]*LNt[13]+LNt[98]*LNt[10]-(LNt[99]*LNt[24]+LNt[102]*LNt[23]+LNt[103]*LNt[20]);
LNt[105] = LNt[94]*LNt[10]-LNt[99]*LNt[20];
LNt[106] = float(LNP2x3[47]+LNt[105])-LNP2x3[47];	//[22,47]<<0
LNt[105] -= LNt[106];
LNt[107] = float(LNP2x3[45]+LNt[105])-LNP2x3[45];	//[2,25]<<0
LNt[105] -= LNt[107];
LNt[108] = LNt[94]*LNt[13]+LNt[97]*LNt[10]-(LNt[99]*LNt[23]+LNt[102]*LNt[20])+LNt[106]+LNt[107];
LNt[109] = float(LNP2x3[71]+LNt[108])-LNP2x3[71];	//[22,48]<<23
LNt[108] -= LNt[109];
LNt[110] = float(LNP2x3[68]+LNt[108])-LNP2x3[68];	//[3,26]<<23
LNt[108] -= LNt[110];
LNt[111] = LNt[104]+LNt[109]+LNt[110];
LNt[112] = float(LNP2x3[95]+LNt[111])-LNP2x3[95];	//[22,49]<<46
LNt[111] -= LNt[112];
LNt[113] = float(LNP2x3[91]+LNt[111])-LNP2x3[91];	//[4,27]<<46
LNt[111] -= LNt[113];
LNt[114] = LNt[97]*LNt[14]+LNt[98]*LNt[13]-(LNt[102]*LNt[24]+LNt[103]*LNt[23])+LNt[112]+LNt[113];
LNt[115] = float(LNP2x3[114]+LNt[114])-LNP2x3[114];	//[9,32]<<69
LNt[114] -= LNt[115];
LNt[116] = LNt[98]*LNt[14]-LNt[103]*LNt[24]+LNt[115];
LNt[117] = LNt[89]*LNt[32]+LNt[92]*LNt[29]+LNt[93]*LNt[26]-(LNt[38]*LNt[111]+LNt[41]*LNt[108]+LNt[42]*LNt[105]);
LNt[118] = LNt[89]*LNt[35]+LNt[92]*LNt[32]+LNt[93]*LNt[29]-(LNt[38]*LNt[114]+LNt[41]*LNt[111]+LNt[42]*LNt[108]);
LNt[119] = LNt[89]*LNt[37]+LNt[92]*LNt[35]+LNt[93]*LNt[32]-(LNt[38]*LNt[116]+LNt[41]*LNt[114]+LNt[42]*LNt[111]);
LNt[120] = LNt[94]*LNt[19]+LNt[97]*LNt[18]+LNt[98]*LNt[15]-(LNt[99]*LNt[9]+LNt[102]*LNt[8]+LNt[103]*LNt[5]);
LNt[121] = LNt[94]*LNt[15]-LNt[99]*LNt[5];
LNt[122] = float(LNP2x3[47]+LNt[121])-LNP2x3[47];	//[22,47]<<0
LNt[121] -= LNt[122];
LNt[123] = float(LNP2x3[45]+LNt[121])-LNP2x3[45];	//[2,25]<<0
LNt[121] -= LNt[123];
LNt[124] = LNt[94]*LNt[18]+LNt[97]*LNt[15]-(LNt[99]*LNt[8]+LNt[102]*LNt[5])+LNt[122]+LNt[123];
LNt[125] = float(LNP2x3[71]+LNt[124])-LNP2x3[71];	//[22,48]<<23
LNt[124] -= LNt[125];
LNt[126] = float(LNP2x3[68]+LNt[124])-LNP2x3[68];	//[3,26]<<23
LNt[124] -= LNt[126];
LNt[127] = LNt[120]+LNt[125]+LNt[126];
LNt[128] = float(LNP2x3[95]+LNt[127])-LNP2x3[95];	//[22,49]<<46
LNt[127] -= LNt[128];
LNt[129] = float(LNP2x3[91]+LNt[127])-LNP2x3[91];	//[4,27]<<46
LNt[127] -= LNt[129];
LNt[130] = LNt[97]*LNt[19]+LNt[98]*LNt[18]-(LNt[102]*LNt[9]+LNt[103]*LNt[8])+LNt[128]+LNt[129];
LNt[131] = float(LNP2x3[114]+LNt[130])-LNP2x3[114];	//[9,32]<<69
LNt[130] -= LNt[131];
LNt[132] = LNt[98]*LNt[19]-LNt[103]*LNt[9]+LNt[131];
LNt[133] = LNt[89]*LNt[29]+LNt[92]*LNt[26]-(LNt[38]*LNt[108]+LNt[41]*LNt[105])+LNt[69]*LNt[124]+LNt[72]*LNt[121];
LNt[134] = LNt[92]*LNt[37]+LNt[93]*LNt[35]-(LNt[41]*LNt[116]+LNt[42]*LNt[114])+LNt[72]*LNt[132]+LNt[73]*LNt[130];
LNt[135] = LNt[89]*LNt[60]+LNt[92]*LNt[57]+LNt[93]*LNt[54]-(LNt[0]*LNt[111]+LNt[3]*LNt[108]+LNt[4]*LNt[105]);
LNt[136] = LNt[89]*LNt[63]+LNt[92]*LNt[60]+LNt[93]*LNt[57]-(LNt[0]*LNt[114]+LNt[3]*LNt[111]+LNt[4]*LNt[108]);
LNt[137] = LNt[89]*LNt[65]+LNt[92]*LNt[63]+LNt[93]*LNt[60]-(LNt[0]*LNt[116]+LNt[3]*LNt[114]+LNt[4]*LNt[111]);
LNt[138] = LNt[94]*LNt[52]+LNt[97]*LNt[51]+LNt[98]*LNt[48]-(LNt[99]*LNt[47]+LNt[102]*LNt[46]+LNt[103]*LNt[43]);
LNt[139] = LNt[94]*LNt[48]-LNt[99]*LNt[43];
LNt[140] = float(LNP2x3[47]+LNt[139])-LNP2x3[47];	//[22,47]<<0
LNt[139] -= LNt[140];
LNt[141] = float(LNP2x3[45]+LNt[139])-LNP2x3[45];	//[2,25]<<0
LNt[139] -= LNt[141];
LNt[142] = LNt[94]*LNt[51]+LNt[97]*LNt[48]-(LNt[99]*LNt[46]+LNt[102]*LNt[43])+LNt[140]+LNt[141];
LNt[143] = float(LNP2x3[71]+LNt[142])-LNP2x3[71];	//[22,48]<<23
LNt[142] -= LNt[143];
LNt[144] = float(LNP2x3[68]+LNt[142])-LNP2x3[68];	//[3,26]<<23
LNt[142] -= LNt[144];
LNt[145] = LNt[138]+LNt[143]+LNt[144];
LNt[146] = float(LNP2x3[95]+LNt[145])-LNP2x3[95];	//[22,49]<<46
LNt[145] -= LNt[146];
LNt[147] = float(LNP2x3[91]+LNt[145])-LNP2x3[91];	//[4,27]<<46
LNt[145] -= LNt[147];
LNt[148] = LNt[97]*LNt[52]+LNt[98]*LNt[51]-(LNt[102]*LNt[47]+LNt[103]*LNt[46])+LNt[146]+LNt[147];
LNt[149] = float(LNP2x3[114]+LNt[148])-LNP2x3[114];	//[9,32]<<69
LNt[148] -= LNt[149];
LNt[150] = LNt[98]*LNt[52]-LNt[103]*LNt[47]+LNt[149];
LNt[151] = LNt[89]*LNt[57]+LNt[92]*LNt[54]-(LNt[0]*LNt[108]+LNt[3]*LNt[105])+LNt[69]*LNt[142]+LNt[72]*LNt[139];
LNt[152] = LNt[92]*LNt[65]+LNt[93]*LNt[63]-(LNt[3]*LNt[116]+LNt[4]*LNt[114])+LNt[72]*LNt[150]+LNt[73]*LNt[148];
LNt[153] = LNt[89]*LNt[81]+LNt[92]*LNt[78]+LNt[93]*LNt[75]-(LNt[0]*LNt[127]+LNt[3]*LNt[124]+LNt[4]*LNt[121]);
LNt[154] = LNt[89]*LNt[84]+LNt[92]*LNt[81]+LNt[93]*LNt[78]-(LNt[0]*LNt[130]+LNt[3]*LNt[127]+LNt[4]*LNt[124]);
LNt[155] = LNt[89]*LNt[86]+LNt[92]*LNt[84]+LNt[93]*LNt[81]-(LNt[0]*LNt[132]+LNt[3]*LNt[130]+LNt[4]*LNt[127]);
LNt[156] = LNt[89]*LNt[78]+LNt[92]*LNt[75]-(LNt[0]*LNt[124]+LNt[3]*LNt[121])+LNt[38]*LNt[142]+LNt[41]*LNt[139];
LNt[157] = LNt[92]*LNt[86]+LNt[93]*LNt[84]-(LNt[3]*LNt[132]+LNt[4]*LNt[130])+LNt[41]*LNt[150]+LNt[42]*LNt[148];
(*this).x.v0 = 0.-(LNt[0]*LNt[26]-LNt[38]*LNt[54]+LNt[69]*LNt[75]);
LNt[158] = float(LNP2x3[49]+(*this).x.v0)-LNP2x3[49];	//[22,49]<<0
(*this).x.v0 -= LNt[158];
LNt[159] = float(LNP2x3[45]+(*this).x.v0)-LNP2x3[45];	//[4,27]<<0
(*this).x.v0 -= LNt[159];
(*this).x.v1 = 0.0-LNt[87]+LNt[158]+LNt[159];
LNt[160] = float(LNP2x3[73]+(*this).x.v1)-LNP2x3[73];	//[22,50]<<23
(*this).x.v1 -= LNt[160];
LNt[161] = float(LNP2x3[68]+(*this).x.v1)-LNP2x3[68];	//[5,28]<<23
(*this).x.v1 -= LNt[161];
(*this).x.v2 = 0.0-(LNt[66]+LNt[69]*LNt[81]+LNt[72]*LNt[78]+LNt[73]*LNt[75])+LNt[160]+LNt[161];
LNt[162] = float(LNP2x3[97]+(*this).x.v2)-LNP2x3[97];	//[22,51]<<46
(*this).x.v2 -= LNt[162];
LNt[163] = float(LNP2x3[91]+(*this).x.v2)-LNP2x3[91];	//[6,29]<<46
(*this).x.v2 -= LNt[163];
(*this).x.v3 = 0.0-(LNt[67]+LNt[69]*LNt[84]+LNt[72]*LNt[81]+LNt[73]*LNt[78])+LNt[162]+LNt[163];
LNt[164] = float(LNP2x3[120]+(*this).x.v3)-LNP2x3[120];	//[22,51]<<69
(*this).x.v3 -= LNt[164];
LNt[165] = float(LNP2x3[114]+(*this).x.v3)-LNP2x3[114];	//[6,29]<<69
(*this).x.v3 -= LNt[165];
(*this).x.v4 = 0.0-(LNt[68]+LNt[69]*LNt[86]+LNt[72]*LNt[84]+LNt[73]*LNt[81])+LNt[164]+LNt[165];
LNt[166] = (float(LNP2x3[125]+(*this).x.v4/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
(*this).x.v4 -= LNt[166];
LNt[167] = (float(LNP2x3[125]+(*this).x.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
(*this).x.v4 -= LNt[167];
(*this).x.v5 = 0.0-LNt[88]+LNt[166]+LNt[167];
LNt[168] = (float(LNP2x3[125]+(*this).x.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
(*this).x.v5 -= LNt[168];
(*this).x.v6 = 0.0-(LNt[4]*LNt[37]-LNt[42]*LNt[65]+LNt[73]*LNt[86])+LNt[168];
LNt[169] = (float(LNP2x3[125]+(*this).x.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[2,25]<<138
(*this).x.v6 -= LNt[169];
(*this).x.v7 = LNt[169];
(*this).y.v0 = LNt[89]*LNt[26]-LNt[38]*LNt[105]+LNt[69]*LNt[121];
LNt[170] = float(LNP2x3[48]+(*this).y.v0)-LNP2x3[48];	//[22,48]<<0
(*this).y.v0 -= LNt[170];
LNt[171] = float(LNP2x3[45]+(*this).y.v0)-LNP2x3[45];	//[3,26]<<0
(*this).y.v0 -= LNt[171];
(*this).y.v1 = LNt[133]+LNt[170]+LNt[171];
LNt[172] = float(LNP2x3[72]+(*this).y.v1)-LNP2x3[72];	//[22,49]<<23
(*this).y.v1 -= LNt[172];
LNt[173] = float(LNP2x3[68]+(*this).y.v1)-LNP2x3[68];	//[4,27]<<23
(*this).y.v1 -= LNt[173];
(*this).y.v2 = LNt[117]+LNt[69]*LNt[127]+LNt[72]*LNt[124]+LNt[73]*LNt[121]+LNt[172]+LNt[173];
LNt[174] = float(LNP2x3[96]+(*this).y.v2)-LNP2x3[96];	//[22,50]<<46
(*this).y.v2 -= LNt[174];
LNt[175] = float(LNP2x3[91]+(*this).y.v2)-LNP2x3[91];	//[5,28]<<46
(*this).y.v2 -= LNt[175];
(*this).y.v3 = LNt[118]+LNt[69]*LNt[130]+LNt[72]*LNt[127]+LNt[73]*LNt[124]+LNt[174]+LNt[175];
LNt[176] = float(LNP2x3[119]+(*this).y.v3)-LNP2x3[119];	//[22,50]<<69
(*this).y.v3 -= LNt[176];
LNt[177] = float(LNP2x3[114]+(*this).y.v3)-LNP2x3[114];	//[5,28]<<69
(*this).y.v3 -= LNt[177];
(*this).y.v4 = LNt[119]+LNt[69]*LNt[132]+LNt[72]*LNt[130]+LNt[73]*LNt[127]+LNt[176]+LNt[177];
LNt[178] = (float(LNP2x3[125]+(*this).y.v4/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
(*this).y.v4 -= LNt[178];
LNt[179] = (float(LNP2x3[125]+(*this).y.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
(*this).y.v4 -= LNt[179];
(*this).y.v5 = LNt[134]+LNt[178]+LNt[179];
LNt[180] = (float(LNP2x3[125]+(*this).y.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
(*this).y.v5 -= LNt[180];
(*this).y.v6 = LNt[93]*LNt[37]-LNt[42]*LNt[116]+LNt[73]*LNt[132]+LNt[180];
LNt[181] = (float(LNP2x3[125]+(*this).y.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
(*this).y.v6 -= LNt[181];
(*this).y.v7 = LNt[181];
(*this).z.v0 = 0.-(LNt[89]*LNt[54]-LNt[0]*LNt[105]+LNt[69]*LNt[139]);
LNt[182] = float(LNP2x3[49]+(*this).z.v0)-LNP2x3[49];	//[22,49]<<0
(*this).z.v0 -= LNt[182];
LNt[183] = float(LNP2x3[45]+(*this).z.v0)-LNP2x3[45];	//[4,27]<<0
(*this).z.v0 -= LNt[183];
(*this).z.v1 = 0.0-LNt[151]+LNt[182]+LNt[183];
LNt[184] = float(LNP2x3[73]+(*this).z.v1)-LNP2x3[73];	//[22,50]<<23
(*this).z.v1 -= LNt[184];
LNt[185] = float(LNP2x3[68]+(*this).z.v1)-LNP2x3[68];	//[5,28]<<23
(*this).z.v1 -= LNt[185];
LNt[186] = 0.0-(LNt[135]+LNt[69]*LNt[145]+LNt[72]*LNt[142]+LNt[73]*LNt[139])+LNt[184]+LNt[185];
(*this).z.v2 = LNt[186];
LNt[187] = float(LNP2x3[97]+(*this).z.v2)-LNP2x3[97];	//[22,51]<<46
(*this).z.v2 -= LNt[187];
LNt[188] = float(LNP2x3[91]+(*this).z.v2)-LNP2x3[91];	//[6,29]<<46
(*this).z.v2 -= LNt[188];
LNt[189] = 0.0-(LNt[136]+LNt[69]*LNt[148]+LNt[72]*LNt[145]+LNt[73]*LNt[142])+LNt[187]+LNt[188];
(*this).z.v3 = LNt[189];
LNt[190] = float(LNP2x3[120]+(*this).z.v3)-LNP2x3[120];	//[22,51]<<69
(*this).z.v3 -= LNt[190];
LNt[191] = float(LNP2x3[114]+(*this).z.v3)-LNP2x3[114];	//[6,29]<<69
(*this).z.v3 -= LNt[191];
LNt[192] = 0.0-(LNt[137]+LNt[69]*LNt[150]+LNt[72]*LNt[148]+LNt[73]*LNt[145])+LNt[190]+LNt[191];
(*this).z.v4 = LNt[192];
LNt[193] = (float(LNP2x3[125]+(*this).z.v4/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
(*this).z.v4 -= LNt[193];
LNt[194] = (float(LNP2x3[125]+(*this).z.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
(*this).z.v4 -= LNt[194];
(*this).z.v5 = 0.0-LNt[152]+LNt[193]+LNt[194];
LNt[195] = (float(LNP2x3[125]+(*this).z.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[19,42]<<115
(*this).z.v5 -= LNt[195];
(*this).z.v6 = 0.0-(LNt[93]*LNt[65]-LNt[4]*LNt[116]+LNt[73]*LNt[150])+LNt[195];
LNt[196] = (float(LNP2x3[125]+(*this).z.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[2,25]<<138
(*this).z.v6 -= LNt[196];
(*this).z.v7 = LNt[196];
(*this).w.v0 = LNt[89]*LNt[75]-LNt[0]*LNt[121]+LNt[38]*LNt[139];
LNt[197] = float(LNP2x3[48]+(*this).w.v0)-LNP2x3[48];	//[22,48]<<0
(*this).w.v0 -= LNt[197];
LNt[198] = float(LNP2x3[45]+(*this).w.v0)-LNP2x3[45];	//[3,26]<<0
(*this).w.v0 -= LNt[198];
(*this).w.v1 = LNt[156]+LNt[197]+LNt[198];
LNt[199] = float(LNP2x3[72]+(*this).w.v1)-LNP2x3[72];	//[22,49]<<23
(*this).w.v1 -= LNt[199];
LNt[200] = float(LNP2x3[68]+(*this).w.v1)-LNP2x3[68];	//[4,27]<<23
(*this).w.v1 -= LNt[200];
(*this).w.v2 = LNt[153]+LNt[38]*LNt[145]+LNt[41]*LNt[142]+LNt[42]*LNt[139]+LNt[199]+LNt[200];
LNt[201] = float(LNP2x3[96]+(*this).w.v2)-LNP2x3[96];	//[22,50]<<46
(*this).w.v2 -= LNt[201];
LNt[202] = float(LNP2x3[91]+(*this).w.v2)-LNP2x3[91];	//[5,28]<<46
(*this).w.v2 -= LNt[202];
(*this).w.v3 = LNt[154]+LNt[38]*LNt[148]+LNt[41]*LNt[145]+LNt[42]*LNt[142]+LNt[201]+LNt[202];
LNt[203] = float(LNP2x3[119]+(*this).w.v3)-LNP2x3[119];	//[22,50]<<69
(*this).w.v3 -= LNt[203];
LNt[204] = float(LNP2x3[114]+(*this).w.v3)-LNP2x3[114];	//[5,28]<<69
(*this).w.v3 -= LNt[204];
(*this).w.v4 = LNt[155]+LNt[38]*LNt[150]+LNt[41]*LNt[148]+LNt[42]*LNt[145]+LNt[203]+LNt[204];
LNt[205] = (float(LNP2x3[125]+(*this).w.v4/LNP2[17])-LNP2x3[125])*LNP2[17];	//[22,50]<<92
(*this).w.v4 -= LNt[205];
LNt[206] = (float(LNP2x3[125]+(*this).w.v4/LNP2[12])-LNP2x3[125])*LNP2[12];	//[5,28]<<92
(*this).w.v4 -= LNt[206];
(*this).w.v5 = LNt[157]+LNt[205]+LNt[206];
LNt[207] = (float(LNP2x3[125]+(*this).w.v5/LNP2[35])-LNP2x3[125])*LNP2[35];	//[18,41]<<115
(*this).w.v5 -= LNt[207];
(*this).w.v6 = LNt[93]*LNt[86]-LNt[4]*LNt[132]+LNt[42]*LNt[150]+LNt[207];
LNt[208] = (float(LNP2x3[125]+(*this).w.v6/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
(*this).w.v6 -= LNt[208];
(*this).w.v7 = LNt[208];
} /* adds=342 multiplies=288 normalizes=126 */


integer dot(const LongHomogPoint3d& p, const Plane& pi){
integer LNans;
LNt[1] = pi.a*(p.x.v7+p.x.v6+p.x.v5+p.x.v4)+pi.b*(p.y.v7+p.y.v6+p.y.v5+p.y.v4)+pi.c*(p.z.v7+p.z.v6+p.z.v5+p.z.v4);
LNt[2] = LNt[1]+pi.d*(p.w.v7+p.w.v6+p.w.v5+p.w.v4);
if (-LNP2[171]<LNt[2] && LNt[2]<LNP2[171]) {	/* the high order 48 bits of 219 are accurate */
  LNt[3] = pi.a;
  LNt[4] = float(LNP2x3[53]+LNt[3])-LNP2x3[53];	//[22,53]<<0
  LNt[3] -= LNt[4];
  LNt[5] = float(LNP2x3[45]+LNt[3])-LNP2x3[45];	//[8,31]<<0
  LNt[3] -= LNt[5];
  LNt[6] = LNt[4]+LNt[5];
  LNt[7] = float(LNP2x3[68]+LNt[6])-LNP2x3[68];	//[7,30]<<23
  LNt[6] -= LNt[7];
  LNt[8] = pi.b;
  LNt[9] = float(LNP2x3[53]+LNt[8])-LNP2x3[53];	//[22,53]<<0
  LNt[8] -= LNt[9];
  LNt[10] = float(LNP2x3[45]+LNt[8])-LNP2x3[45];	//[8,31]<<0
  LNt[8] -= LNt[10];
  LNt[11] = LNt[9]+LNt[10];
  LNt[12] = float(LNP2x3[68]+LNt[11])-LNP2x3[68];	//[7,30]<<23
  LNt[11] -= LNt[12];
  LNt[13] = LNt[3]*p.x.v2+LNt[6]*p.x.v1+LNt[7]*p.x.v0+LNt[8]*p.y.v2+LNt[11]*p.y.v1+LNt[12]*p.y.v0;
  LNt[14] = LNt[3]*p.x.v3+LNt[6]*p.x.v2+LNt[7]*p.x.v1+LNt[8]*p.y.v3+LNt[11]*p.y.v2+LNt[12]*p.y.v1;
  LNt[15] = LNt[3]*p.x.v4+LNt[6]*p.x.v3+LNt[7]*p.x.v2+LNt[8]*p.y.v4+LNt[11]*p.y.v3+LNt[12]*p.y.v2;
  LNt[16] = LNt[3]*p.x.v5+LNt[6]*p.x.v4+LNt[7]*p.x.v3+LNt[8]*p.y.v5+LNt[11]*p.y.v4+LNt[12]*p.y.v3;
  LNt[17] = LNt[3]*p.x.v6+LNt[6]*p.x.v5+LNt[7]*p.x.v4+LNt[8]*p.y.v6+LNt[11]*p.y.v5+LNt[12]*p.y.v4;
  LNt[18] = LNt[3]*p.x.v7+LNt[6]*p.x.v6+LNt[7]*p.x.v5+LNt[8]*p.y.v7+LNt[11]*p.y.v6+LNt[12]*p.y.v5;
  LNt[19] = pi.c;
  LNt[20] = float(LNP2x3[53]+LNt[19])-LNP2x3[53];	//[22,53]<<0
  LNt[19] -= LNt[20];
  LNt[21] = float(LNP2x3[45]+LNt[19])-LNP2x3[45];	//[8,31]<<0
  LNt[19] -= LNt[21];
  LNt[22] = LNt[20]+LNt[21];
  LNt[23] = float(LNP2x3[68]+LNt[22])-LNP2x3[68];	//[7,30]<<23
  LNt[22] -= LNt[23];
  LNt[24] = LNt[3]*p.x.v1+LNt[6]*p.x.v0+LNt[8]*p.y.v1+LNt[11]*p.y.v0+LNt[19]*p.z.v1+LNt[22]*p.z.v0;
  LNt[25] = LNt[6]*p.x.v7+LNt[7]*p.x.v6+LNt[11]*p.y.v7+LNt[12]*p.y.v6+LNt[22]*p.z.v7+LNt[23]*p.z.v6;
  LNt[26] = pi.d;
  LNt[27] = float(LNP2x3[53]+LNt[26])-LNP2x3[53];	//[22,53]<<0
  LNt[26] -= LNt[27];
  LNt[28] = float(LNP2x3[45]+LNt[26])-LNP2x3[45];	//[8,31]<<0
  LNt[26] -= LNt[28];
  LNt[29] = LNt[27]+LNt[28];
  LNt[30] = float(LNP2x3[68]+LNt[29])-LNP2x3[68];	//[7,30]<<23
  LNt[29] -= LNt[30];
  LNt[31] = LNt[13]+LNt[19]*p.z.v2+LNt[22]*p.z.v1+LNt[23]*p.z.v0+LNt[26]*p.w.v2+LNt[29]*p.w.v1+LNt[30]*p.w.v0;
  LNt[32] = LNt[14]+LNt[19]*p.z.v3+LNt[22]*p.z.v2+LNt[23]*p.z.v1+LNt[26]*p.w.v3+LNt[29]*p.w.v2+LNt[30]*p.w.v1;
  LNt[33] = LNt[15]+LNt[19]*p.z.v4+LNt[22]*p.z.v3+LNt[23]*p.z.v2+LNt[26]*p.w.v4+LNt[29]*p.w.v3+LNt[30]*p.w.v2;
  LNt[34] = LNt[16]+LNt[19]*p.z.v5+LNt[22]*p.z.v4+LNt[23]*p.z.v3+LNt[26]*p.w.v5+LNt[29]*p.w.v4+LNt[30]*p.w.v3;
  LNt[35] = LNt[17]+LNt[19]*p.z.v6+LNt[22]*p.z.v5+LNt[23]*p.z.v4+LNt[26]*p.w.v6+LNt[29]*p.w.v5+LNt[30]*p.w.v4;
  LNt[36] = LNt[18]+LNt[19]*p.z.v7+LNt[22]*p.z.v6+LNt[23]*p.z.v5+LNt[26]*p.w.v7+LNt[29]*p.w.v6+LNt[30]*p.w.v5;
  LNt[37] = LNt[3]*p.x.v0+LNt[8]*p.y.v0+LNt[19]*p.z.v0+LNt[26]*p.w.v0;
  LNt[38] = LNt[24]+LNt[26]*p.w.v1+LNt[29]*p.w.v0;
  LNt[39] = LNt[25]+LNt[29]*p.w.v7+LNt[30]*p.w.v6;
  LNt[40] = LNt[7]*p.x.v7+LNt[12]*p.y.v7+LNt[23]*p.z.v7+LNt[30]*p.w.v7;
  LNt[41] = ((((((((LNt[40])+LNt[39])+LNt[36])+LNt[35])+LNt[34])+LNt[33])+LNt[32])+LNt[31])+LNt[38];
  LNt[2] = ((LNt[41])+LNt[37]);
}
if (LNt[2]<0){
  LNt[0] = -1.;
}else{
  if (LNt[2]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=114 multiplies=100 normalizes=12 */


integer LongHomogOrient3d(const LongHomogPoint3d& a, const LongHomogPoint3d& b, const LongHomogPoint3d& c, const LongHomogPoint3d& d){
integer LNans;
LNt[1] = c.y.v7+c.y.v6+c.y.v5+c.y.v4;
LNt[2] = a.z.v7+a.z.v6+a.z.v5+a.z.v4;
LNt[3] = b.w.v7+b.w.v6+b.w.v5+b.w.v4;
LNt[4] = b.z.v7+b.z.v6+b.z.v5+b.z.v4;
LNt[5] = a.w.v7+a.w.v6+a.w.v5+a.w.v4;
LNt[6] = LNt[2]*LNt[3]-LNt[4]*LNt[5];
LNt[7] = c.z.v7+c.z.v6+c.z.v5+c.z.v4;
LNt[8] = a.y.v7+a.y.v6+a.y.v5+a.y.v4;
LNt[9] = b.y.v7+b.y.v6+b.y.v5+b.y.v4;
LNt[10] = LNt[8]*LNt[3]-LNt[9]*LNt[5];
LNt[11] = c.w.v7+c.w.v6+c.w.v5+c.w.v4;
LNt[12] = LNt[8]*LNt[4]-LNt[9]*LNt[2];
LNt[13] = (0.-(d.x.v7+d.x.v6+d.x.v5+d.x.v4))*(LNt[1]*LNt[6]-LNt[7]*LNt[10]+LNt[11]*LNt[12]);
LNt[14] = c.x.v7+c.x.v6+c.x.v5+c.x.v4;
LNt[15] = a.x.v7+a.x.v6+a.x.v5+a.x.v4;
LNt[16] = b.x.v7+b.x.v6+b.x.v5+b.x.v4;
LNt[17] = LNt[15]*LNt[3]-LNt[5]*LNt[16];
LNt[18] = LNt[15]*LNt[4]-LNt[2]*LNt[16];
LNt[19] = LNt[13]+(d.y.v7+d.y.v6+d.y.v5+d.y.v4)*(LNt[14]*LNt[6]-LNt[7]*LNt[17]+LNt[11]*LNt[18]);
LNt[20] = LNt[15]*LNt[9]-LNt[8]*LNt[16];
LNt[21] = LNt[19]-(d.z.v7+d.z.v6+d.z.v5+d.z.v4)*(LNt[14]*LNt[10]-LNt[1]*LNt[17]+LNt[11]*LNt[20]);
LNt[22] = LNt[21]+(d.w.v7+d.w.v6+d.w.v5+d.w.v4)*(LNt[14]*LNt[12]-LNt[1]*LNt[18]+LNt[7]*LNt[20]);
if (-LNP2[614]<LNt[22] && LNt[22]<LNP2[614]) {	/* the high order 43 bits of 657 are accurate */
  LNt[23] = 0.-d.x.v0;
  LNt[24] = float(LNP2x3[45]+LNt[23])-LNP2x3[45];	//[1,24]<<0
  LNt[23] -= LNt[24];
  LNt[25] = 0.0-d.x.v1+LNt[24];
  LNt[26] = float(LNP2x3[68]+LNt[25])-LNP2x3[68];	//[1,24]<<23
  LNt[25] -= LNt[26];
  LNt[27] = 0.0-d.x.v2+LNt[26];
  LNt[28] = float(LNP2x3[91]+LNt[27])-LNP2x3[91];	//[1,24]<<46
  LNt[27] -= LNt[28];
  LNt[29] = 0.0-d.x.v3+LNt[28];
  LNt[30] = float(LNP2x3[114]+LNt[29])-LNP2x3[114];	//[1,24]<<69
  LNt[29] -= LNt[30];
  LNt[31] = 0.0-d.x.v4+LNt[30];
  LNt[32] = (float(LNP2x3[125]+LNt[31]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[1,24]<<92
  LNt[31] -= LNt[32];
  LNt[33] = 0.0-d.x.v5+LNt[32];
  LNt[34] = (float(LNP2x3[125]+LNt[33]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[1,24]<<115
  LNt[33] -= LNt[34];
  LNt[35] = 0.0-d.x.v6+LNt[34];
  LNt[36] = (float(LNP2x3[125]+LNt[35]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[1,24]<<138
  LNt[35] -= LNt[36];
  LNt[37] = a.z.v0*b.w.v5+a.z.v1*b.w.v4+a.z.v2*b.w.v3+a.z.v3*b.w.v2+a.z.v4*b.w.v1+a.z.v5*b.w.v0;
  LNt[38] = a.z.v0*b.w.v6+a.z.v1*b.w.v5+a.z.v2*b.w.v4+a.z.v3*b.w.v3+a.z.v4*b.w.v2+a.z.v5*b.w.v1;
  LNt[39] = a.z.v0*b.w.v7+a.z.v1*b.w.v6+a.z.v2*b.w.v5+a.z.v3*b.w.v4+a.z.v4*b.w.v3+a.z.v5*b.w.v2;
  LNt[40] = a.z.v1*b.w.v7+a.z.v2*b.w.v6+a.z.v3*b.w.v5+a.z.v4*b.w.v4+a.z.v5*b.w.v3+a.z.v6*b.w.v2;
  LNt[41] = a.z.v2*b.w.v7+a.z.v3*b.w.v6+a.z.v4*b.w.v5+a.z.v5*b.w.v4+a.z.v6*b.w.v3+a.z.v7*b.w.v2;
  LNt[42] = LNt[39]+a.z.v6*b.w.v1+a.z.v7*b.w.v0;
  LNt[43] = (float(LNP2x3[125]+LNt[42]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[42] -= LNt[43];
  LNt[44] = b.z.v0*a.w.v5+b.z.v1*a.w.v4+b.z.v2*a.w.v3+b.z.v3*a.w.v2+b.z.v4*a.w.v1+b.z.v5*a.w.v0;
  LNt[45] = b.z.v0*a.w.v6+b.z.v1*a.w.v5+b.z.v2*a.w.v4+b.z.v3*a.w.v3+b.z.v4*a.w.v2+b.z.v5*a.w.v1;
  LNt[46] = b.z.v0*a.w.v7+b.z.v1*a.w.v6+b.z.v2*a.w.v5+b.z.v3*a.w.v4+b.z.v4*a.w.v3+b.z.v5*a.w.v2;
  LNt[47] = b.z.v1*a.w.v7+b.z.v2*a.w.v6+b.z.v3*a.w.v5+b.z.v4*a.w.v4+b.z.v5*a.w.v3+b.z.v6*a.w.v2;
  LNt[48] = b.z.v2*a.w.v7+b.z.v3*a.w.v6+b.z.v4*a.w.v5+b.z.v5*a.w.v4+b.z.v6*a.w.v3+b.z.v7*a.w.v2;
  LNt[49] = LNt[46]+b.z.v6*a.w.v1+b.z.v7*a.w.v0;
  LNt[50] = (float(LNP2x3[125]+LNt[49]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[49] -= LNt[50];
  LNt[51] = a.z.v0*b.w.v2+a.z.v1*b.w.v1+a.z.v2*b.w.v0-(b.z.v0*a.w.v2+b.z.v1*a.w.v1+b.z.v2*a.w.v0);
  LNt[52] = a.z.v0*b.w.v3+a.z.v1*b.w.v2+a.z.v2*b.w.v1+a.z.v3*b.w.v0-(b.z.v0*a.w.v3+b.z.v1*a.w.v2+b.z.v2*a.w.v1+b.z.v3*a.w.v0);
  LNt[53] = a.z.v0*b.w.v4+a.z.v1*b.w.v3+a.z.v2*b.w.v2+a.z.v3*b.w.v1+a.z.v4*b.w.v0-(b.z.v0*a.w.v4+b.z.v1*a.w.v3+b.z.v2*a.w.v2+b.z.v3*a.w.v1+b.z.v4*a.w.v0);
  LNt[54] = a.z.v3*b.w.v7+a.z.v4*b.w.v6+a.z.v5*b.w.v5+a.z.v6*b.w.v4+a.z.v7*b.w.v3-(b.z.v3*a.w.v7+b.z.v4*a.w.v6+b.z.v5*a.w.v5+b.z.v6*a.w.v4+b.z.v7*a.w.v3);
  LNt[55] = a.z.v4*b.w.v7+a.z.v5*b.w.v6+a.z.v6*b.w.v5+a.z.v7*b.w.v4-(b.z.v4*a.w.v7+b.z.v5*a.w.v6+b.z.v6*a.w.v5+b.z.v7*a.w.v4);
  LNt[56] = a.z.v5*b.w.v7+a.z.v6*b.w.v6+a.z.v7*b.w.v5-(b.z.v5*a.w.v7+b.z.v6*a.w.v6+b.z.v7*a.w.v5);
  LNt[57] = a.z.v0*b.w.v0-b.z.v0*a.w.v0;
  LNt[58] = float(LNP2x3[47]+LNt[57])-LNP2x3[47];	//[22,47]<<0
  LNt[57] -= LNt[58];
  LNt[59] = float(LNP2x3[45]+LNt[57])-LNP2x3[45];	//[2,25]<<0
  LNt[57] -= LNt[59];
  LNt[60] = a.z.v0*b.w.v1+a.z.v1*b.w.v0-(b.z.v0*a.w.v1+b.z.v1*a.w.v0)+LNt[58]+LNt[59];
  LNt[61] = float(LNP2x3[71]+LNt[60])-LNP2x3[71];	//[22,48]<<23
  LNt[60] -= LNt[61];
  LNt[62] = float(LNP2x3[68]+LNt[60])-LNP2x3[68];	//[3,26]<<23
  LNt[60] -= LNt[62];
  LNt[63] = LNt[51]+LNt[61]+LNt[62];
  LNt[64] = float(LNP2x3[95]+LNt[63])-LNP2x3[95];	//[22,49]<<46
  LNt[63] -= LNt[64];
  LNt[65] = float(LNP2x3[91]+LNt[63])-LNP2x3[91];	//[4,27]<<46
  LNt[63] -= LNt[65];
  LNt[66] = LNt[52]+LNt[64]+LNt[65];
  LNt[67] = float(LNP2x3[119]+LNt[66])-LNP2x3[119];	//[22,50]<<69
  LNt[66] -= LNt[67];
  LNt[68] = float(LNP2x3[114]+LNt[66])-LNP2x3[114];	//[5,28]<<69
  LNt[66] -= LNt[68];
  LNt[69] = LNt[53]+LNt[67]+LNt[68];
  LNt[70] = (float(LNP2x3[125]+LNt[69]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[69] -= LNt[70];
  LNt[71] = (float(LNP2x3[125]+LNt[69]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[69] -= LNt[71];
  LNt[72] = LNt[37]-LNt[44]+LNt[70]+LNt[71];
  LNt[73] = (float(LNP2x3[125]+LNt[72]/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
  LNt[72] -= LNt[73];
  LNt[74] = (float(LNP2x3[125]+LNt[72]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
  LNt[72] -= LNt[74];
  LNt[75] = LNt[38]+a.z.v6*b.w.v0-(LNt[45]+b.z.v6*a.w.v0)+LNt[73]+LNt[74];
  LNt[76] = (float(LNP2x3[125]+LNt[75]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[75] -= LNt[76];
  LNt[77] = (float(LNP2x3[125]+LNt[75]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[75] -= LNt[77];
  LNt[78] = LNt[42]-LNt[49]+LNt[76]+LNt[77];
  LNt[79] = (float(LNP2x3[125]+LNt[78]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[78] -= LNt[79];
  LNt[80] = (float(LNP2x3[125]+LNt[78]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[78] -= LNt[80];
  LNt[81] = LNt[40]+a.z.v7*b.w.v1+LNt[43]-(LNt[47]+b.z.v7*a.w.v1+LNt[50])+LNt[79]+LNt[80];
  LNt[82] = (float(LNP2x3[125]+LNt[81]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[81] -= LNt[82];
  LNt[83] = (float(LNP2x3[125]+LNt[81]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[81] -= LNt[83];
  LNt[84] = LNt[41]-LNt[48]+LNt[82]+LNt[83];
  LNt[85] = (float(LNP2x3[125]+LNt[84]/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
  LNt[84] -= LNt[85];
  LNt[86] = (float(LNP2x3[125]+LNt[84]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
  LNt[84] -= LNt[86];
  LNt[87] = LNt[54]+LNt[85]+LNt[86];
  LNt[88] = (float(LNP2x3[125]+LNt[87]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[22,51]<<230
  LNt[87] -= LNt[88];
  LNt[89] = (float(LNP2x3[125]+LNt[87]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[6,29]<<230
  LNt[87] -= LNt[89];
  LNt[90] = LNt[55]+LNt[88]+LNt[89];
  LNt[91] = (float(LNP2x3[125]+LNt[90]/LNP2[178])-LNP2x3[125])*LNP2[178];	//[22,50]<<253
  LNt[90] -= LNt[91];
  LNt[92] = (float(LNP2x3[125]+LNt[90]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[5,28]<<253
  LNt[90] -= LNt[92];
  LNt[93] = LNt[56]+LNt[91]+LNt[92];
  LNt[94] = (float(LNP2x3[125]+LNt[93]/LNP2[200])-LNP2x3[125])*LNP2[200];	//[22,49]<<276
  LNt[93] -= LNt[94];
  LNt[95] = (float(LNP2x3[125]+LNt[93]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[4,27]<<276
  LNt[93] -= LNt[95];
  LNt[96] = a.z.v6*b.w.v7+a.z.v7*b.w.v6-(b.z.v6*a.w.v7+b.z.v7*a.w.v6)+LNt[94]+LNt[95];
  LNt[97] = (float(LNP2x3[125]+LNt[96]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[4,27]<<299
  LNt[96] -= LNt[97];
  LNt[98] = a.z.v7*b.w.v7-b.z.v7*a.w.v7+LNt[97];
  LNt[99] = c.y.v0*LNt[72]+c.y.v1*LNt[69]+c.y.v2*LNt[66]+c.y.v3*LNt[63]+c.y.v4*LNt[60]+c.y.v5*LNt[57];
  LNt[100] = c.y.v0*LNt[75]+c.y.v1*LNt[72]+c.y.v2*LNt[69]+c.y.v3*LNt[66]+c.y.v4*LNt[63]+c.y.v5*LNt[60];
  LNt[101] = c.y.v0*LNt[78]+c.y.v1*LNt[75]+c.y.v2*LNt[72]+c.y.v3*LNt[69]+c.y.v4*LNt[66]+c.y.v5*LNt[63];
  LNt[102] = c.y.v0*LNt[81]+c.y.v1*LNt[78]+c.y.v2*LNt[75]+c.y.v3*LNt[72]+c.y.v4*LNt[69]+c.y.v5*LNt[66];
  LNt[103] = c.y.v0*LNt[84]+c.y.v1*LNt[81]+c.y.v2*LNt[78]+c.y.v3*LNt[75]+c.y.v4*LNt[72]+c.y.v5*LNt[69];
  LNt[104] = c.y.v0*LNt[87]+c.y.v1*LNt[84]+c.y.v2*LNt[81]+c.y.v3*LNt[78]+c.y.v4*LNt[75]+c.y.v5*LNt[72];
  LNt[105] = c.y.v0*LNt[90]+c.y.v1*LNt[87]+c.y.v2*LNt[84]+c.y.v3*LNt[81]+c.y.v4*LNt[78]+c.y.v5*LNt[75];
  LNt[106] = c.y.v0*LNt[93]+c.y.v1*LNt[90]+c.y.v2*LNt[87]+c.y.v3*LNt[84]+c.y.v4*LNt[81]+c.y.v5*LNt[78];
  LNt[107] = c.y.v0*LNt[96]+c.y.v1*LNt[93]+c.y.v2*LNt[90]+c.y.v3*LNt[87]+c.y.v4*LNt[84]+c.y.v5*LNt[81];
  LNt[108] = c.y.v0*LNt[98]+c.y.v1*LNt[96]+c.y.v2*LNt[93]+c.y.v3*LNt[90]+c.y.v4*LNt[87]+c.y.v5*LNt[84];
  LNt[109] = c.y.v1*LNt[98]+c.y.v2*LNt[96]+c.y.v3*LNt[93]+c.y.v4*LNt[90]+c.y.v5*LNt[87]+c.y.v6*LNt[84];
  LNt[110] = c.y.v2*LNt[98]+c.y.v3*LNt[96]+c.y.v4*LNt[93]+c.y.v5*LNt[90]+c.y.v6*LNt[87]+c.y.v7*LNt[84];
  LNt[111] = LNt[101]+c.y.v6*LNt[60]+c.y.v7*LNt[57];
  LNt[112] = (float(LNP2x3[125]+LNt[111]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[111] -= LNt[112];
  LNt[113] = LNt[102]+c.y.v6*LNt[63]+c.y.v7*LNt[60]+LNt[112];
  LNt[114] = (float(LNP2x3[125]+LNt[113]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[113] -= LNt[114];
  LNt[115] = LNt[103]+c.y.v6*LNt[66]+c.y.v7*LNt[63]+LNt[114];
  LNt[116] = (float(LNP2x3[125]+LNt[115]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[115] -= LNt[116];
  LNt[117] = LNt[104]+c.y.v6*LNt[69]+c.y.v7*LNt[66]+LNt[116];
  LNt[118] = (float(LNP2x3[125]+LNt[117]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[117] -= LNt[118];
  LNt[119] = LNt[105]+c.y.v6*LNt[72]+c.y.v7*LNt[69]+LNt[118];
  LNt[120] = (float(LNP2x3[125]+LNt[119]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[119] -= LNt[120];
  LNt[121] = LNt[106]+c.y.v6*LNt[75]+c.y.v7*LNt[72]+LNt[120];
  LNt[122] = (float(LNP2x3[125]+LNt[121]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[121] -= LNt[122];
  LNt[123] = LNt[107]+c.y.v6*LNt[78]+c.y.v7*LNt[75]+LNt[122];
  LNt[124] = (float(LNP2x3[125]+LNt[123]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[123] -= LNt[124];
  LNt[125] = LNt[108]+c.y.v6*LNt[81]+c.y.v7*LNt[78]+LNt[124];
  LNt[126] = (float(LNP2x3[125]+LNt[125]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[125] -= LNt[126];
  LNt[127] = a.y.v0*b.w.v5+a.y.v1*b.w.v4+a.y.v2*b.w.v3+a.y.v3*b.w.v2+a.y.v4*b.w.v1+a.y.v5*b.w.v0;
  LNt[128] = a.y.v0*b.w.v6+a.y.v1*b.w.v5+a.y.v2*b.w.v4+a.y.v3*b.w.v3+a.y.v4*b.w.v2+a.y.v5*b.w.v1;
  LNt[129] = a.y.v0*b.w.v7+a.y.v1*b.w.v6+a.y.v2*b.w.v5+a.y.v3*b.w.v4+a.y.v4*b.w.v3+a.y.v5*b.w.v2;
  LNt[130] = a.y.v1*b.w.v7+a.y.v2*b.w.v6+a.y.v3*b.w.v5+a.y.v4*b.w.v4+a.y.v5*b.w.v3+a.y.v6*b.w.v2;
  LNt[131] = a.y.v2*b.w.v7+a.y.v3*b.w.v6+a.y.v4*b.w.v5+a.y.v5*b.w.v4+a.y.v6*b.w.v3+a.y.v7*b.w.v2;
  LNt[132] = LNt[129]+a.y.v6*b.w.v1+a.y.v7*b.w.v0;
  LNt[133] = (float(LNP2x3[125]+LNt[132]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[132] -= LNt[133];
  LNt[134] = b.y.v0*a.w.v5+b.y.v1*a.w.v4+b.y.v2*a.w.v3+b.y.v3*a.w.v2+b.y.v4*a.w.v1+b.y.v5*a.w.v0;
  LNt[135] = b.y.v0*a.w.v6+b.y.v1*a.w.v5+b.y.v2*a.w.v4+b.y.v3*a.w.v3+b.y.v4*a.w.v2+b.y.v5*a.w.v1;
  LNt[136] = b.y.v0*a.w.v7+b.y.v1*a.w.v6+b.y.v2*a.w.v5+b.y.v3*a.w.v4+b.y.v4*a.w.v3+b.y.v5*a.w.v2;
  LNt[137] = b.y.v1*a.w.v7+b.y.v2*a.w.v6+b.y.v3*a.w.v5+b.y.v4*a.w.v4+b.y.v5*a.w.v3+b.y.v6*a.w.v2;
  LNt[138] = b.y.v2*a.w.v7+b.y.v3*a.w.v6+b.y.v4*a.w.v5+b.y.v5*a.w.v4+b.y.v6*a.w.v3+b.y.v7*a.w.v2;
  LNt[139] = LNt[136]+b.y.v6*a.w.v1+b.y.v7*a.w.v0;
  LNt[140] = (float(LNP2x3[125]+LNt[139]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[139] -= LNt[140];
  LNt[141] = a.y.v0*b.w.v2+a.y.v1*b.w.v1+a.y.v2*b.w.v0-(b.y.v0*a.w.v2+b.y.v1*a.w.v1+b.y.v2*a.w.v0);
  LNt[142] = a.y.v0*b.w.v3+a.y.v1*b.w.v2+a.y.v2*b.w.v1+a.y.v3*b.w.v0-(b.y.v0*a.w.v3+b.y.v1*a.w.v2+b.y.v2*a.w.v1+b.y.v3*a.w.v0);
  LNt[143] = a.y.v0*b.w.v4+a.y.v1*b.w.v3+a.y.v2*b.w.v2+a.y.v3*b.w.v1+a.y.v4*b.w.v0-(b.y.v0*a.w.v4+b.y.v1*a.w.v3+b.y.v2*a.w.v2+b.y.v3*a.w.v1+b.y.v4*a.w.v0);
  LNt[144] = a.y.v3*b.w.v7+a.y.v4*b.w.v6+a.y.v5*b.w.v5+a.y.v6*b.w.v4+a.y.v7*b.w.v3-(b.y.v3*a.w.v7+b.y.v4*a.w.v6+b.y.v5*a.w.v5+b.y.v6*a.w.v4+b.y.v7*a.w.v3);
  LNt[145] = a.y.v4*b.w.v7+a.y.v5*b.w.v6+a.y.v6*b.w.v5+a.y.v7*b.w.v4-(b.y.v4*a.w.v7+b.y.v5*a.w.v6+b.y.v6*a.w.v5+b.y.v7*a.w.v4);
  LNt[146] = a.y.v5*b.w.v7+a.y.v6*b.w.v6+a.y.v7*b.w.v5-(b.y.v5*a.w.v7+b.y.v6*a.w.v6+b.y.v7*a.w.v5);
  LNt[147] = a.y.v0*b.w.v0-b.y.v0*a.w.v0;
  LNt[148] = float(LNP2x3[47]+LNt[147])-LNP2x3[47];	//[22,47]<<0
  LNt[147] -= LNt[148];
  LNt[149] = float(LNP2x3[45]+LNt[147])-LNP2x3[45];	//[2,25]<<0
  LNt[147] -= LNt[149];
  LNt[150] = a.y.v0*b.w.v1+a.y.v1*b.w.v0-(b.y.v0*a.w.v1+b.y.v1*a.w.v0)+LNt[148]+LNt[149];
  LNt[151] = float(LNP2x3[71]+LNt[150])-LNP2x3[71];	//[22,48]<<23
  LNt[150] -= LNt[151];
  LNt[152] = float(LNP2x3[68]+LNt[150])-LNP2x3[68];	//[3,26]<<23
  LNt[150] -= LNt[152];
  LNt[153] = LNt[141]+LNt[151]+LNt[152];
  LNt[154] = float(LNP2x3[95]+LNt[153])-LNP2x3[95];	//[22,49]<<46
  LNt[153] -= LNt[154];
  LNt[155] = float(LNP2x3[91]+LNt[153])-LNP2x3[91];	//[4,27]<<46
  LNt[153] -= LNt[155];
  LNt[156] = LNt[142]+LNt[154]+LNt[155];
  LNt[157] = float(LNP2x3[119]+LNt[156])-LNP2x3[119];	//[22,50]<<69
  LNt[156] -= LNt[157];
  LNt[158] = float(LNP2x3[114]+LNt[156])-LNP2x3[114];	//[5,28]<<69
  LNt[156] -= LNt[158];
  LNt[159] = LNt[143]+LNt[157]+LNt[158];
  LNt[160] = (float(LNP2x3[125]+LNt[159]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[159] -= LNt[160];
  LNt[161] = (float(LNP2x3[125]+LNt[159]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[159] -= LNt[161];
  LNt[162] = LNt[127]-LNt[134]+LNt[160]+LNt[161];
  LNt[163] = (float(LNP2x3[125]+LNt[162]/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
  LNt[162] -= LNt[163];
  LNt[164] = (float(LNP2x3[125]+LNt[162]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
  LNt[162] -= LNt[164];
  LNt[165] = LNt[128]+a.y.v6*b.w.v0-(LNt[135]+b.y.v6*a.w.v0)+LNt[163]+LNt[164];
  LNt[166] = (float(LNP2x3[125]+LNt[165]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[165] -= LNt[166];
  LNt[167] = (float(LNP2x3[125]+LNt[165]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[165] -= LNt[167];
  LNt[168] = LNt[132]-LNt[139]+LNt[166]+LNt[167];
  LNt[169] = (float(LNP2x3[125]+LNt[168]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[168] -= LNt[169];
  LNt[170] = (float(LNP2x3[125]+LNt[168]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[168] -= LNt[170];
  LNt[171] = LNt[130]+a.y.v7*b.w.v1+LNt[133]-(LNt[137]+b.y.v7*a.w.v1+LNt[140])+LNt[169]+LNt[170];
  LNt[172] = (float(LNP2x3[125]+LNt[171]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[171] -= LNt[172];
  LNt[173] = (float(LNP2x3[125]+LNt[171]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[171] -= LNt[173];
  LNt[174] = LNt[131]-LNt[138]+LNt[172]+LNt[173];
  LNt[175] = (float(LNP2x3[125]+LNt[174]/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
  LNt[174] -= LNt[175];
  LNt[176] = (float(LNP2x3[125]+LNt[174]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
  LNt[174] -= LNt[176];
  LNt[177] = LNt[144]+LNt[175]+LNt[176];
  LNt[178] = (float(LNP2x3[125]+LNt[177]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[22,51]<<230
  LNt[177] -= LNt[178];
  LNt[179] = (float(LNP2x3[125]+LNt[177]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[6,29]<<230
  LNt[177] -= LNt[179];
  LNt[180] = LNt[145]+LNt[178]+LNt[179];
  LNt[181] = (float(LNP2x3[125]+LNt[180]/LNP2[178])-LNP2x3[125])*LNP2[178];	//[22,50]<<253
  LNt[180] -= LNt[181];
  LNt[182] = (float(LNP2x3[125]+LNt[180]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[5,28]<<253
  LNt[180] -= LNt[182];
  LNt[183] = LNt[146]+LNt[181]+LNt[182];
  LNt[184] = (float(LNP2x3[125]+LNt[183]/LNP2[200])-LNP2x3[125])*LNP2[200];	//[22,49]<<276
  LNt[183] -= LNt[184];
  LNt[185] = (float(LNP2x3[125]+LNt[183]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[4,27]<<276
  LNt[183] -= LNt[185];
  LNt[186] = a.y.v6*b.w.v7+a.y.v7*b.w.v6-(b.y.v6*a.w.v7+b.y.v7*a.w.v6)+LNt[184]+LNt[185];
  LNt[187] = (float(LNP2x3[125]+LNt[186]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[3,26]<<299
  LNt[186] -= LNt[187];
  LNt[188] = a.y.v7*b.w.v7-b.y.v7*a.w.v7+LNt[187];
  LNt[189] = c.z.v0*LNt[162]+c.z.v1*LNt[159]+c.z.v2*LNt[156]+c.z.v3*LNt[153]+c.z.v4*LNt[150]+c.z.v5*LNt[147];
  LNt[190] = c.z.v0*LNt[165]+c.z.v1*LNt[162]+c.z.v2*LNt[159]+c.z.v3*LNt[156]+c.z.v4*LNt[153]+c.z.v5*LNt[150];
  LNt[191] = c.z.v0*LNt[168]+c.z.v1*LNt[165]+c.z.v2*LNt[162]+c.z.v3*LNt[159]+c.z.v4*LNt[156]+c.z.v5*LNt[153];
  LNt[192] = c.z.v0*LNt[171]+c.z.v1*LNt[168]+c.z.v2*LNt[165]+c.z.v3*LNt[162]+c.z.v4*LNt[159]+c.z.v5*LNt[156];
  LNt[193] = c.z.v0*LNt[174]+c.z.v1*LNt[171]+c.z.v2*LNt[168]+c.z.v3*LNt[165]+c.z.v4*LNt[162]+c.z.v5*LNt[159];
  LNt[194] = c.z.v0*LNt[177]+c.z.v1*LNt[174]+c.z.v2*LNt[171]+c.z.v3*LNt[168]+c.z.v4*LNt[165]+c.z.v5*LNt[162];
  LNt[195] = c.z.v0*LNt[180]+c.z.v1*LNt[177]+c.z.v2*LNt[174]+c.z.v3*LNt[171]+c.z.v4*LNt[168]+c.z.v5*LNt[165];
  LNt[196] = c.z.v0*LNt[183]+c.z.v1*LNt[180]+c.z.v2*LNt[177]+c.z.v3*LNt[174]+c.z.v4*LNt[171]+c.z.v5*LNt[168];
  LNt[197] = c.z.v0*LNt[186]+c.z.v1*LNt[183]+c.z.v2*LNt[180]+c.z.v3*LNt[177]+c.z.v4*LNt[174]+c.z.v5*LNt[171];
  LNt[198] = c.z.v0*LNt[188]+c.z.v1*LNt[186]+c.z.v2*LNt[183]+c.z.v3*LNt[180]+c.z.v4*LNt[177]+c.z.v5*LNt[174];
  LNt[199] = c.z.v1*LNt[188]+c.z.v2*LNt[186]+c.z.v3*LNt[183]+c.z.v4*LNt[180]+c.z.v5*LNt[177]+c.z.v6*LNt[174];
  LNt[200] = c.z.v2*LNt[188]+c.z.v3*LNt[186]+c.z.v4*LNt[183]+c.z.v5*LNt[180]+c.z.v6*LNt[177]+c.z.v7*LNt[174];
  LNt[201] = LNt[191]+c.z.v6*LNt[150]+c.z.v7*LNt[147];
  LNt[202] = (float(LNP2x3[125]+LNt[201]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[201] -= LNt[202];
  LNt[203] = LNt[192]+c.z.v6*LNt[153]+c.z.v7*LNt[150]+LNt[202];
  LNt[204] = (float(LNP2x3[125]+LNt[203]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[203] -= LNt[204];
  LNt[205] = LNt[193]+c.z.v6*LNt[156]+c.z.v7*LNt[153]+LNt[204];
  LNt[206] = (float(LNP2x3[125]+LNt[205]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[205] -= LNt[206];
  LNt[207] = LNt[194]+c.z.v6*LNt[159]+c.z.v7*LNt[156]+LNt[206];
  LNt[208] = (float(LNP2x3[125]+LNt[207]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[207] -= LNt[208];
  LNt[209] = LNt[195]+c.z.v6*LNt[162]+c.z.v7*LNt[159]+LNt[208];
  LNt[210] = (float(LNP2x3[125]+LNt[209]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[209] -= LNt[210];
  LNt[211] = LNt[196]+c.z.v6*LNt[165]+c.z.v7*LNt[162]+LNt[210];
  LNt[212] = (float(LNP2x3[125]+LNt[211]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[211] -= LNt[212];
  LNt[213] = LNt[197]+c.z.v6*LNt[168]+c.z.v7*LNt[165]+LNt[212];
  LNt[214] = (float(LNP2x3[125]+LNt[213]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[213] -= LNt[214];
  LNt[215] = LNt[198]+c.z.v6*LNt[171]+c.z.v7*LNt[168]+LNt[214];
  LNt[216] = (float(LNP2x3[125]+LNt[215]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[215] -= LNt[216];
  LNt[217] = c.y.v0*LNt[63]+c.y.v1*LNt[60]+c.y.v2*LNt[57]-(c.z.v0*LNt[153]+c.z.v1*LNt[150]+c.z.v2*LNt[147]);
  LNt[218] = c.y.v0*LNt[66]+c.y.v1*LNt[63]+c.y.v2*LNt[60]+c.y.v3*LNt[57]-(c.z.v0*LNt[156]+c.z.v1*LNt[153]+c.z.v2*LNt[150]+c.z.v3*LNt[147]);
  LNt[219] = c.y.v0*LNt[69]+c.y.v1*LNt[66]+c.y.v2*LNt[63]+c.y.v3*LNt[60]+c.y.v4*LNt[57]-(c.z.v0*LNt[159]+c.z.v1*LNt[156]+c.z.v2*LNt[153]+c.z.v3*LNt[150]+c.z.v4*LNt[147]);
  LNt[220] = c.y.v3*LNt[98]+c.y.v4*LNt[96]+c.y.v5*LNt[93]+c.y.v6*LNt[90]+c.y.v7*LNt[87]-(c.z.v3*LNt[188]+c.z.v4*LNt[186]+c.z.v5*LNt[183]+c.z.v6*LNt[180]+c.z.v7*LNt[177]);
  LNt[221] = c.y.v4*LNt[98]+c.y.v5*LNt[96]+c.y.v6*LNt[93]+c.y.v7*LNt[90]-(c.z.v4*LNt[188]+c.z.v5*LNt[186]+c.z.v6*LNt[183]+c.z.v7*LNt[180]);
  LNt[222] = c.y.v5*LNt[98]+c.y.v6*LNt[96]+c.y.v7*LNt[93]-(c.z.v5*LNt[188]+c.z.v6*LNt[186]+c.z.v7*LNt[183]);
  LNt[223] = LNt[100]+c.y.v6*LNt[57]-(LNt[190]+c.z.v6*LNt[147]);
  LNt[224] = (float(LNP2x3[125]+LNt[223]/LNP2[87])-LNP2x3[125])*LNP2[87];	//[1,53]<<138
  LNt[223] -= LNt[224];
  LNt[225] = LNt[111]-LNt[201]+LNt[224];
  LNt[226] = (float(LNP2x3[125]+LNt[225]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[225] -= LNt[226];
  LNt[227] = LNt[113]-LNt[203]+LNt[226];
  LNt[228] = (float(LNP2x3[125]+LNt[227]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[227] -= LNt[228];
  LNt[229] = LNt[115]-LNt[205]+LNt[228];
  LNt[230] = (float(LNP2x3[125]+LNt[229]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[229] -= LNt[230];
  LNt[231] = LNt[117]-LNt[207]+LNt[230];
  LNt[232] = (float(LNP2x3[125]+LNt[231]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[231] -= LNt[232];
  LNt[233] = LNt[119]-LNt[209]+LNt[232];
  LNt[234] = (float(LNP2x3[125]+LNt[233]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[233] -= LNt[234];
  LNt[235] = LNt[121]-LNt[211]+LNt[234];
  LNt[236] = (float(LNP2x3[125]+LNt[235]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[235] -= LNt[236];
  LNt[237] = LNt[123]-LNt[213]+LNt[236];
  LNt[238] = (float(LNP2x3[125]+LNt[237]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[237] -= LNt[238];
  LNt[239] = LNt[125]-LNt[215]+LNt[238];
  LNt[240] = (float(LNP2x3[125]+LNt[239]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[239] -= LNt[240];
  LNt[241] = LNt[109]+c.y.v7*LNt[81]+LNt[126]-(LNt[199]+c.z.v7*LNt[171]+LNt[216])+LNt[240];
  LNt[242] = (float(LNP2x3[125]+LNt[241]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[241] -= LNt[242];
  LNt[243] = a.y.v0*b.z.v5+a.y.v1*b.z.v4+a.y.v2*b.z.v3+a.y.v3*b.z.v2+a.y.v4*b.z.v1+a.y.v5*b.z.v0;
  LNt[244] = a.y.v0*b.z.v6+a.y.v1*b.z.v5+a.y.v2*b.z.v4+a.y.v3*b.z.v3+a.y.v4*b.z.v2+a.y.v5*b.z.v1;
  LNt[245] = a.y.v0*b.z.v7+a.y.v1*b.z.v6+a.y.v2*b.z.v5+a.y.v3*b.z.v4+a.y.v4*b.z.v3+a.y.v5*b.z.v2;
  LNt[246] = a.y.v1*b.z.v7+a.y.v2*b.z.v6+a.y.v3*b.z.v5+a.y.v4*b.z.v4+a.y.v5*b.z.v3+a.y.v6*b.z.v2;
  LNt[247] = a.y.v2*b.z.v7+a.y.v3*b.z.v6+a.y.v4*b.z.v5+a.y.v5*b.z.v4+a.y.v6*b.z.v3+a.y.v7*b.z.v2;
  LNt[248] = LNt[245]+a.y.v6*b.z.v1+a.y.v7*b.z.v0;
  LNt[249] = (float(LNP2x3[125]+LNt[248]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[248] -= LNt[249];
  LNt[250] = b.y.v0*a.z.v5+b.y.v1*a.z.v4+b.y.v2*a.z.v3+b.y.v3*a.z.v2+b.y.v4*a.z.v1+b.y.v5*a.z.v0;
  LNt[251] = b.y.v0*a.z.v6+b.y.v1*a.z.v5+b.y.v2*a.z.v4+b.y.v3*a.z.v3+b.y.v4*a.z.v2+b.y.v5*a.z.v1;
  LNt[252] = b.y.v0*a.z.v7+b.y.v1*a.z.v6+b.y.v2*a.z.v5+b.y.v3*a.z.v4+b.y.v4*a.z.v3+b.y.v5*a.z.v2;
  LNt[253] = b.y.v1*a.z.v7+b.y.v2*a.z.v6+b.y.v3*a.z.v5+b.y.v4*a.z.v4+b.y.v5*a.z.v3+b.y.v6*a.z.v2;
  LNt[254] = b.y.v2*a.z.v7+b.y.v3*a.z.v6+b.y.v4*a.z.v5+b.y.v5*a.z.v4+b.y.v6*a.z.v3+b.y.v7*a.z.v2;
  LNt[255] = LNt[252]+b.y.v6*a.z.v1+b.y.v7*a.z.v0;
  LNt[256] = (float(LNP2x3[125]+LNt[255]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[255] -= LNt[256];
  LNt[257] = a.y.v0*b.z.v2+a.y.v1*b.z.v1+a.y.v2*b.z.v0-(b.y.v0*a.z.v2+b.y.v1*a.z.v1+b.y.v2*a.z.v0);
  LNt[258] = a.y.v0*b.z.v3+a.y.v1*b.z.v2+a.y.v2*b.z.v1+a.y.v3*b.z.v0-(b.y.v0*a.z.v3+b.y.v1*a.z.v2+b.y.v2*a.z.v1+b.y.v3*a.z.v0);
  LNt[259] = a.y.v0*b.z.v4+a.y.v1*b.z.v3+a.y.v2*b.z.v2+a.y.v3*b.z.v1+a.y.v4*b.z.v0-(b.y.v0*a.z.v4+b.y.v1*a.z.v3+b.y.v2*a.z.v2+b.y.v3*a.z.v1+b.y.v4*a.z.v0);
  LNt[260] = a.y.v3*b.z.v7+a.y.v4*b.z.v6+a.y.v5*b.z.v5+a.y.v6*b.z.v4+a.y.v7*b.z.v3-(b.y.v3*a.z.v7+b.y.v4*a.z.v6+b.y.v5*a.z.v5+b.y.v6*a.z.v4+b.y.v7*a.z.v3);
  LNt[261] = a.y.v4*b.z.v7+a.y.v5*b.z.v6+a.y.v6*b.z.v5+a.y.v7*b.z.v4-(b.y.v4*a.z.v7+b.y.v5*a.z.v6+b.y.v6*a.z.v5+b.y.v7*a.z.v4);
  LNt[262] = a.y.v5*b.z.v7+a.y.v6*b.z.v6+a.y.v7*b.z.v5-(b.y.v5*a.z.v7+b.y.v6*a.z.v6+b.y.v7*a.z.v5);
  LNt[263] = a.y.v0*b.z.v0-b.y.v0*a.z.v0;
  LNt[264] = float(LNP2x3[47]+LNt[263])-LNP2x3[47];	//[22,47]<<0
  LNt[263] -= LNt[264];
  LNt[265] = float(LNP2x3[45]+LNt[263])-LNP2x3[45];	//[2,25]<<0
  LNt[263] -= LNt[265];
  LNt[266] = a.y.v0*b.z.v1+a.y.v1*b.z.v0-(b.y.v0*a.z.v1+b.y.v1*a.z.v0)+LNt[264]+LNt[265];
  LNt[267] = float(LNP2x3[71]+LNt[266])-LNP2x3[71];	//[22,48]<<23
  LNt[266] -= LNt[267];
  LNt[268] = float(LNP2x3[68]+LNt[266])-LNP2x3[68];	//[3,26]<<23
  LNt[266] -= LNt[268];
  LNt[269] = LNt[257]+LNt[267]+LNt[268];
  LNt[270] = float(LNP2x3[95]+LNt[269])-LNP2x3[95];	//[22,49]<<46
  LNt[269] -= LNt[270];
  LNt[271] = float(LNP2x3[91]+LNt[269])-LNP2x3[91];	//[4,27]<<46
  LNt[269] -= LNt[271];
  LNt[272] = LNt[258]+LNt[270]+LNt[271];
  LNt[273] = float(LNP2x3[119]+LNt[272])-LNP2x3[119];	//[22,50]<<69
  LNt[272] -= LNt[273];
  LNt[274] = float(LNP2x3[114]+LNt[272])-LNP2x3[114];	//[5,28]<<69
  LNt[272] -= LNt[274];
  LNt[275] = LNt[259]+LNt[273]+LNt[274];
  LNt[276] = (float(LNP2x3[125]+LNt[275]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[275] -= LNt[276];
  LNt[277] = (float(LNP2x3[125]+LNt[275]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[275] -= LNt[277];
  LNt[278] = LNt[243]-LNt[250]+LNt[276]+LNt[277];
  LNt[279] = (float(LNP2x3[125]+LNt[278]/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
  LNt[278] -= LNt[279];
  LNt[280] = (float(LNP2x3[125]+LNt[278]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
  LNt[278] -= LNt[280];
  LNt[281] = LNt[244]+a.y.v6*b.z.v0-(LNt[251]+b.y.v6*a.z.v0)+LNt[279]+LNt[280];
  LNt[282] = (float(LNP2x3[125]+LNt[281]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[281] -= LNt[282];
  LNt[283] = (float(LNP2x3[125]+LNt[281]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[281] -= LNt[283];
  LNt[284] = LNt[248]-LNt[255]+LNt[282]+LNt[283];
  LNt[285] = (float(LNP2x3[125]+LNt[284]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[284] -= LNt[285];
  LNt[286] = (float(LNP2x3[125]+LNt[284]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[284] -= LNt[286];
  LNt[287] = LNt[246]+a.y.v7*b.z.v1+LNt[249]-(LNt[253]+b.y.v7*a.z.v1+LNt[256])+LNt[285]+LNt[286];
  LNt[288] = (float(LNP2x3[125]+LNt[287]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[287] -= LNt[288];
  LNt[289] = (float(LNP2x3[125]+LNt[287]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[287] -= LNt[289];
  LNt[290] = LNt[247]-LNt[254]+LNt[288]+LNt[289];
  LNt[291] = (float(LNP2x3[125]+LNt[290]/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
  LNt[290] -= LNt[291];
  LNt[292] = (float(LNP2x3[125]+LNt[290]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
  LNt[290] -= LNt[292];
  LNt[293] = LNt[260]+LNt[291]+LNt[292];
  LNt[294] = (float(LNP2x3[125]+LNt[293]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[22,51]<<230
  LNt[293] -= LNt[294];
  LNt[295] = (float(LNP2x3[125]+LNt[293]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[6,29]<<230
  LNt[293] -= LNt[295];
  LNt[296] = LNt[261]+LNt[294]+LNt[295];
  LNt[297] = (float(LNP2x3[125]+LNt[296]/LNP2[178])-LNP2x3[125])*LNP2[178];	//[22,50]<<253
  LNt[296] -= LNt[297];
  LNt[298] = (float(LNP2x3[125]+LNt[296]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[5,28]<<253
  LNt[296] -= LNt[298];
  LNt[299] = LNt[262]+LNt[297]+LNt[298];
  LNt[300] = (float(LNP2x3[125]+LNt[299]/LNP2[200])-LNP2x3[125])*LNP2[200];	//[22,49]<<276
  LNt[299] -= LNt[300];
  LNt[301] = (float(LNP2x3[125]+LNt[299]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[4,27]<<276
  LNt[299] -= LNt[301];
  LNt[302] = a.y.v6*b.z.v7+a.y.v7*b.z.v6-(b.y.v6*a.z.v7+b.y.v7*a.z.v6)+LNt[300]+LNt[301];
  LNt[303] = (float(LNP2x3[125]+LNt[302]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[4,27]<<299
  LNt[302] -= LNt[303];
  LNt[304] = a.y.v7*b.z.v7-b.y.v7*a.z.v7+LNt[303];
  LNt[305] = c.w.v0*LNt[278]+c.w.v1*LNt[275]+c.w.v2*LNt[272]+c.w.v3*LNt[269]+c.w.v4*LNt[266]+c.w.v5*LNt[263];
  LNt[306] = c.w.v0*LNt[281]+c.w.v1*LNt[278]+c.w.v2*LNt[275]+c.w.v3*LNt[272]+c.w.v4*LNt[269]+c.w.v5*LNt[266];
  LNt[307] = c.w.v0*LNt[284]+c.w.v1*LNt[281]+c.w.v2*LNt[278]+c.w.v3*LNt[275]+c.w.v4*LNt[272]+c.w.v5*LNt[269];
  LNt[308] = c.w.v0*LNt[287]+c.w.v1*LNt[284]+c.w.v2*LNt[281]+c.w.v3*LNt[278]+c.w.v4*LNt[275]+c.w.v5*LNt[272];
  LNt[309] = c.w.v0*LNt[290]+c.w.v1*LNt[287]+c.w.v2*LNt[284]+c.w.v3*LNt[281]+c.w.v4*LNt[278]+c.w.v5*LNt[275];
  LNt[310] = c.w.v0*LNt[293]+c.w.v1*LNt[290]+c.w.v2*LNt[287]+c.w.v3*LNt[284]+c.w.v4*LNt[281]+c.w.v5*LNt[278];
  LNt[311] = c.w.v0*LNt[296]+c.w.v1*LNt[293]+c.w.v2*LNt[290]+c.w.v3*LNt[287]+c.w.v4*LNt[284]+c.w.v5*LNt[281];
  LNt[312] = c.w.v0*LNt[299]+c.w.v1*LNt[296]+c.w.v2*LNt[293]+c.w.v3*LNt[290]+c.w.v4*LNt[287]+c.w.v5*LNt[284];
  LNt[313] = c.w.v0*LNt[302]+c.w.v1*LNt[299]+c.w.v2*LNt[296]+c.w.v3*LNt[293]+c.w.v4*LNt[290]+c.w.v5*LNt[287];
  LNt[314] = c.w.v0*LNt[304]+c.w.v1*LNt[302]+c.w.v2*LNt[299]+c.w.v3*LNt[296]+c.w.v4*LNt[293]+c.w.v5*LNt[290];
  LNt[315] = c.w.v1*LNt[304]+c.w.v2*LNt[302]+c.w.v3*LNt[299]+c.w.v4*LNt[296]+c.w.v5*LNt[293]+c.w.v6*LNt[290];
  LNt[316] = c.w.v2*LNt[304]+c.w.v3*LNt[302]+c.w.v4*LNt[299]+c.w.v5*LNt[296]+c.w.v6*LNt[293]+c.w.v7*LNt[290];
  LNt[317] = LNt[307]+c.w.v6*LNt[266]+c.w.v7*LNt[263];
  LNt[318] = (float(LNP2x3[125]+LNt[317]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[317] -= LNt[318];
  LNt[319] = LNt[308]+c.w.v6*LNt[269]+c.w.v7*LNt[266]+LNt[318];
  LNt[320] = (float(LNP2x3[125]+LNt[319]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[319] -= LNt[320];
  LNt[321] = LNt[309]+c.w.v6*LNt[272]+c.w.v7*LNt[269]+LNt[320];
  LNt[322] = (float(LNP2x3[125]+LNt[321]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[321] -= LNt[322];
  LNt[323] = LNt[310]+c.w.v6*LNt[275]+c.w.v7*LNt[272]+LNt[322];
  LNt[324] = (float(LNP2x3[125]+LNt[323]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[323] -= LNt[324];
  LNt[325] = LNt[311]+c.w.v6*LNt[278]+c.w.v7*LNt[275]+LNt[324];
  LNt[326] = (float(LNP2x3[125]+LNt[325]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[325] -= LNt[326];
  LNt[327] = LNt[312]+c.w.v6*LNt[281]+c.w.v7*LNt[278]+LNt[326];
  LNt[328] = (float(LNP2x3[125]+LNt[327]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[327] -= LNt[328];
  LNt[329] = LNt[313]+c.w.v6*LNt[284]+c.w.v7*LNt[281]+LNt[328];
  LNt[330] = (float(LNP2x3[125]+LNt[329]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[329] -= LNt[330];
  LNt[331] = LNt[314]+c.w.v6*LNt[287]+c.w.v7*LNt[284]+LNt[330];
  LNt[332] = (float(LNP2x3[125]+LNt[331]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[331] -= LNt[332];
  LNt[333] = c.y.v0*LNt[60]+c.y.v1*LNt[57]-(c.z.v0*LNt[150]+c.z.v1*LNt[147])+c.w.v0*LNt[266]+c.w.v1*LNt[263];
  LNt[334] = LNt[219]+c.w.v0*LNt[275]+c.w.v1*LNt[272]+c.w.v2*LNt[269]+c.w.v3*LNt[266]+c.w.v4*LNt[263];
  LNt[335] = LNt[220]+c.w.v3*LNt[304]+c.w.v4*LNt[302]+c.w.v5*LNt[299]+c.w.v6*LNt[296]+c.w.v7*LNt[293];
  LNt[336] = c.y.v6*LNt[98]+c.y.v7*LNt[96]-(c.z.v6*LNt[188]+c.z.v7*LNt[186])+c.w.v6*LNt[304]+c.w.v7*LNt[302];
  LNt[337] = c.y.v0*LNt[57]-c.z.v0*LNt[147]+c.w.v0*LNt[263];
  LNt[338] = float(LNP2x3[48]+LNt[337])-LNP2x3[48];	//[22,48]<<0
  LNt[337] -= LNt[338];
  LNt[339] = float(LNP2x3[45]+LNt[337])-LNP2x3[45];	//[3,26]<<0
  LNt[337] -= LNt[339];
  LNt[340] = LNt[333]+LNt[338]+LNt[339];
  LNt[341] = float(LNP2x3[72]+LNt[340])-LNP2x3[72];	//[22,49]<<23
  LNt[340] -= LNt[341];
  LNt[342] = float(LNP2x3[68]+LNt[340])-LNP2x3[68];	//[4,27]<<23
  LNt[340] -= LNt[342];
  LNt[343] = LNt[217]+c.w.v0*LNt[269]+c.w.v1*LNt[266]+c.w.v2*LNt[263]+LNt[341]+LNt[342];
  LNt[344] = float(LNP2x3[96]+LNt[343])-LNP2x3[96];	//[22,50]<<46
  LNt[343] -= LNt[344];
  LNt[345] = float(LNP2x3[91]+LNt[343])-LNP2x3[91];	//[5,28]<<46
  LNt[343] -= LNt[345];
  LNt[346] = LNt[218]+c.w.v0*LNt[272]+c.w.v1*LNt[269]+c.w.v2*LNt[266]+c.w.v3*LNt[263]+LNt[344]+LNt[345];
  LNt[347] = float(LNP2x3[120]+LNt[346])-LNP2x3[120];	//[22,51]<<69
  LNt[346] -= LNt[347];
  LNt[348] = float(LNP2x3[114]+LNt[346])-LNP2x3[114];	//[6,29]<<69
  LNt[346] -= LNt[348];
  LNt[349] = LNt[334]+LNt[347]+LNt[348];
  LNt[350] = (float(LNP2x3[125]+LNt[349]/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
  LNt[349] -= LNt[350];
  LNt[351] = (float(LNP2x3[125]+LNt[349]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
  LNt[349] -= LNt[351];
  LNt[352] = LNt[99]-LNt[189]+LNt[305]+LNt[350]+LNt[351];
  LNt[353] = (float(LNP2x3[125]+LNt[352]/LNP2[43])-LNP2x3[125])*LNP2[43];	//[22,53]<<115
  LNt[352] -= LNt[353];
  LNt[354] = (float(LNP2x3[125]+LNt[352]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[8,31]<<115
  LNt[352] -= LNt[354];
  LNt[355] = LNt[223]+LNt[306]+c.w.v6*LNt[263]+LNt[353]+LNt[354];
  LNt[356] = (float(LNP2x3[125]+LNt[355]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[355] -= LNt[356];
  LNt[357] = (float(LNP2x3[125]+LNt[355]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[355] -= LNt[357];
  LNt[358] = LNt[225]+LNt[317]+LNt[356]+LNt[357];
  LNt[359] = (float(LNP2x3[125]+LNt[358]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[358] -= LNt[359];
  LNt[360] = (float(LNP2x3[125]+LNt[358]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[358] -= LNt[360];
  LNt[361] = LNt[227]+LNt[319]+LNt[359]+LNt[360];
  LNt[362] = (float(LNP2x3[125]+LNt[361]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[361] -= LNt[362];
  LNt[363] = (float(LNP2x3[125]+LNt[361]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[361] -= LNt[363];
  LNt[364] = LNt[229]+LNt[321]+LNt[362]+LNt[363];
  LNt[365] = (float(LNP2x3[125]+LNt[364]/LNP2[135])-LNP2x3[125])*LNP2[135];	//[22,53]<<207
  LNt[364] -= LNt[365];
  LNt[366] = (float(LNP2x3[125]+LNt[364]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[8,31]<<207
  LNt[364] -= LNt[366];
  LNt[367] = LNt[231]+LNt[323]+LNt[365]+LNt[366];
  LNt[368] = (float(LNP2x3[125]+LNt[367]/LNP2[158])-LNP2x3[125])*LNP2[158];	//[22,53]<<230
  LNt[367] -= LNt[368];
  LNt[369] = (float(LNP2x3[125]+LNt[367]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[8,31]<<230
  LNt[367] -= LNt[369];
  LNt[370] = LNt[233]+LNt[325]+LNt[368]+LNt[369];
  LNt[371] = (float(LNP2x3[125]+LNt[370]/LNP2[181])-LNP2x3[125])*LNP2[181];	//[22,53]<<253
  LNt[370] -= LNt[371];
  LNt[372] = (float(LNP2x3[125]+LNt[370]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[8,31]<<253
  LNt[370] -= LNt[372];
  LNt[373] = LNt[235]+LNt[327]+LNt[371]+LNt[372];
  LNt[374] = (float(LNP2x3[125]+LNt[373]/LNP2[204])-LNP2x3[125])*LNP2[204];	//[22,53]<<276
  LNt[373] -= LNt[374];
  LNt[375] = (float(LNP2x3[125]+LNt[373]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[8,31]<<276
  LNt[373] -= LNt[375];
  LNt[376] = LNt[237]+LNt[329]+LNt[374]+LNt[375];
  LNt[377] = (float(LNP2x3[125]+LNt[376]/LNP2[227])-LNP2x3[125])*LNP2[227];	//[22,53]<<299
  LNt[376] -= LNt[377];
  LNt[378] = (float(LNP2x3[125]+LNt[376]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[8,31]<<299
  LNt[376] -= LNt[378];
  LNt[379] = LNt[239]+LNt[331]+LNt[377]+LNt[378];
  LNt[380] = (float(LNP2x3[125]+LNt[379]/LNP2[250])-LNP2x3[125])*LNP2[250];	//[22,53]<<322
  LNt[379] -= LNt[380];
  LNt[381] = (float(LNP2x3[125]+LNt[379]/LNP2[242])-LNP2x3[125])*LNP2[242];	//[8,31]<<322
  LNt[379] -= LNt[381];
  LNt[382] = LNt[241]+LNt[315]+c.w.v7*LNt[287]+LNt[332]+LNt[380]+LNt[381];
  LNt[383] = (float(LNP2x3[125]+LNt[382]/LNP2[273])-LNP2x3[125])*LNP2[273];	//[22,53]<<345
  LNt[382] -= LNt[383];
  LNt[384] = (float(LNP2x3[125]+LNt[382]/LNP2[265])-LNP2x3[125])*LNP2[265];	//[8,31]<<345
  LNt[382] -= LNt[384];
  LNt[385] = LNt[110]-LNt[200]+LNt[242]+LNt[316]+LNt[383]+LNt[384];
  LNt[386] = (float(LNP2x3[125]+LNt[385]/LNP2[296])-LNP2x3[125])*LNP2[296];	//[22,53]<<368
  LNt[385] -= LNt[386];
  LNt[387] = (float(LNP2x3[125]+LNt[385]/LNP2[288])-LNP2x3[125])*LNP2[288];	//[8,31]<<368
  LNt[385] -= LNt[387];
  LNt[388] = LNt[335]+LNt[386]+LNt[387];
  LNt[389] = (float(LNP2x3[125]+LNt[388]/LNP2[318])-LNP2x3[125])*LNP2[318];	//[22,52]<<391
  LNt[388] -= LNt[389];
  LNt[390] = (float(LNP2x3[125]+LNt[388]/LNP2[311])-LNP2x3[125])*LNP2[311];	//[7,30]<<391
  LNt[388] -= LNt[390];
  LNt[391] = LNt[221]+c.w.v4*LNt[304]+c.w.v5*LNt[302]+c.w.v6*LNt[299]+c.w.v7*LNt[296]+LNt[389]+LNt[390];
  LNt[392] = (float(LNP2x3[125]+LNt[391]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[22,51]<<414
  LNt[391] -= LNt[392];
  LNt[393] = (float(LNP2x3[125]+LNt[391]/LNP2[334])-LNP2x3[125])*LNP2[334];	//[6,29]<<414
  LNt[391] -= LNt[393];
  LNt[394] = LNt[222]+c.w.v5*LNt[304]+c.w.v6*LNt[302]+c.w.v7*LNt[299]+LNt[392]+LNt[393];
  LNt[395] = (float(LNP2x3[125]+LNt[394]/LNP2[362])-LNP2x3[125])*LNP2[362];	//[22,50]<<437
  LNt[394] -= LNt[395];
  LNt[396] = (float(LNP2x3[125]+LNt[394]/LNP2[357])-LNP2x3[125])*LNP2[357];	//[5,28]<<437
  LNt[394] -= LNt[396];
  LNt[397] = LNt[336]+LNt[395]+LNt[396];
  LNt[398] = (float(LNP2x3[125]+LNt[397]/LNP2[380])-LNP2x3[125])*LNP2[380];	//[7,30]<<460
  LNt[397] -= LNt[398];
  LNt[399] = c.y.v7*LNt[98]-c.z.v7*LNt[188]+c.w.v7*LNt[304]+LNt[398];
  LNt[400] = 0.0-d.x.v7+LNt[36];
  LNt[401] = LNt[23]*LNt[349]+LNt[25]*LNt[346]+LNt[27]*LNt[343]+LNt[29]*LNt[340]+LNt[31]*LNt[337];
  LNt[402] = LNt[23]*LNt[352]+LNt[25]*LNt[349]+LNt[27]*LNt[346]+LNt[29]*LNt[343]+LNt[31]*LNt[340];
  LNt[403] = LNt[23]*LNt[355]+LNt[25]*LNt[352]+LNt[27]*LNt[349]+LNt[29]*LNt[346]+LNt[31]*LNt[343];
  LNt[404] = LNt[23]*LNt[358]+LNt[25]*LNt[355]+LNt[27]*LNt[352]+LNt[29]*LNt[349]+LNt[31]*LNt[346];
  LNt[405] = LNt[23]*LNt[361]+LNt[25]*LNt[358]+LNt[27]*LNt[355]+LNt[29]*LNt[352]+LNt[31]*LNt[349];
  LNt[406] = LNt[23]*LNt[364]+LNt[25]*LNt[361]+LNt[27]*LNt[358]+LNt[29]*LNt[355]+LNt[31]*LNt[352];
  LNt[407] = LNt[23]*LNt[367]+LNt[25]*LNt[364]+LNt[27]*LNt[361]+LNt[29]*LNt[358]+LNt[31]*LNt[355];
  LNt[408] = LNt[23]*LNt[370]+LNt[25]*LNt[367]+LNt[27]*LNt[364]+LNt[29]*LNt[361]+LNt[31]*LNt[358];
  LNt[409] = LNt[23]*LNt[373]+LNt[25]*LNt[370]+LNt[27]*LNt[367]+LNt[29]*LNt[364]+LNt[31]*LNt[361];
  LNt[410] = LNt[23]*LNt[376]+LNt[25]*LNt[373]+LNt[27]*LNt[370]+LNt[29]*LNt[367]+LNt[31]*LNt[364];
  LNt[411] = LNt[23]*LNt[379]+LNt[25]*LNt[376]+LNt[27]*LNt[373]+LNt[29]*LNt[370]+LNt[31]*LNt[367];
  LNt[412] = LNt[23]*LNt[382]+LNt[25]*LNt[379]+LNt[27]*LNt[376]+LNt[29]*LNt[373]+LNt[31]*LNt[370];
  LNt[413] = LNt[23]*LNt[385]+LNt[25]*LNt[382]+LNt[27]*LNt[379]+LNt[29]*LNt[376]+LNt[31]*LNt[373];
  LNt[414] = LNt[23]*LNt[388]+LNt[25]*LNt[385]+LNt[27]*LNt[382]+LNt[29]*LNt[379]+LNt[31]*LNt[376];
  LNt[415] = LNt[23]*LNt[391]+LNt[25]*LNt[388]+LNt[27]*LNt[385]+LNt[29]*LNt[382]+LNt[31]*LNt[379];
  LNt[416] = LNt[23]*LNt[394]+LNt[25]*LNt[391]+LNt[27]*LNt[388]+LNt[29]*LNt[385]+LNt[31]*LNt[382];
  LNt[417] = LNt[23]*LNt[397]+LNt[25]*LNt[394]+LNt[27]*LNt[391]+LNt[29]*LNt[388]+LNt[31]*LNt[385];
  LNt[418] = LNt[23]*LNt[399]+LNt[25]*LNt[397]+LNt[27]*LNt[394]+LNt[29]*LNt[391]+LNt[31]*LNt[388];
  LNt[419] = LNt[25]*LNt[399]+LNt[27]*LNt[397]+LNt[29]*LNt[394]+LNt[31]*LNt[391]+LNt[33]*LNt[388];
  LNt[420] = LNt[27]*LNt[399]+LNt[29]*LNt[397]+LNt[31]*LNt[394]+LNt[33]*LNt[391]+LNt[35]*LNt[388];
  LNt[421] = LNt[29]*LNt[399]+LNt[31]*LNt[397]+LNt[33]*LNt[394]+LNt[35]*LNt[391]+LNt[400]*LNt[388];
  LNt[422] = LNt[404]+LNt[33]*LNt[343]+LNt[35]*LNt[340]+LNt[400]*LNt[337];
  LNt[423] = (float(LNP2x3[125]+LNt[422]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[422] -= LNt[423];
  LNt[424] = LNt[405]+LNt[33]*LNt[346]+LNt[35]*LNt[343]+LNt[400]*LNt[340]+LNt[423];
  LNt[425] = (float(LNP2x3[125]+LNt[424]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[424] -= LNt[425];
  LNt[426] = LNt[406]+LNt[33]*LNt[349]+LNt[35]*LNt[346]+LNt[400]*LNt[343]+LNt[425];
  LNt[427] = (float(LNP2x3[125]+LNt[426]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[426] -= LNt[427];
  LNt[428] = LNt[407]+LNt[33]*LNt[352]+LNt[35]*LNt[349]+LNt[400]*LNt[346]+LNt[427];
  LNt[429] = (float(LNP2x3[125]+LNt[428]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[428] -= LNt[429];
  LNt[430] = LNt[408]+LNt[33]*LNt[355]+LNt[35]*LNt[352]+LNt[400]*LNt[349]+LNt[429];
  LNt[431] = (float(LNP2x3[125]+LNt[430]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[430] -= LNt[431];
  LNt[432] = LNt[409]+LNt[33]*LNt[358]+LNt[35]*LNt[355]+LNt[400]*LNt[352]+LNt[431];
  LNt[433] = (float(LNP2x3[125]+LNt[432]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[432] -= LNt[433];
  LNt[434] = LNt[410]+LNt[33]*LNt[361]+LNt[35]*LNt[358]+LNt[400]*LNt[355]+LNt[433];
  LNt[435] = (float(LNP2x3[125]+LNt[434]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[434] -= LNt[435];
  LNt[436] = LNt[411]+LNt[33]*LNt[364]+LNt[35]*LNt[361]+LNt[400]*LNt[358]+LNt[435];
  LNt[437] = (float(LNP2x3[125]+LNt[436]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[436] -= LNt[437];
  LNt[438] = LNt[412]+LNt[33]*LNt[367]+LNt[35]*LNt[364]+LNt[400]*LNt[361]+LNt[437];
  LNt[439] = (float(LNP2x3[125]+LNt[438]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[438] -= LNt[439];
  LNt[440] = LNt[413]+LNt[33]*LNt[370]+LNt[35]*LNt[367]+LNt[400]*LNt[364]+LNt[439];
  LNt[441] = (float(LNP2x3[125]+LNt[440]/LNP2[317])-LNP2x3[125])*LNP2[317];	//[1,53]<<368
  LNt[440] -= LNt[441];
  LNt[442] = LNt[414]+LNt[33]*LNt[373]+LNt[35]*LNt[370]+LNt[400]*LNt[367]+LNt[441];
  LNt[443] = (float(LNP2x3[125]+LNt[442]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[1,53]<<391
  LNt[442] -= LNt[443];
  LNt[444] = LNt[415]+LNt[33]*LNt[376]+LNt[35]*LNt[373]+LNt[400]*LNt[370]+LNt[443];
  LNt[445] = (float(LNP2x3[125]+LNt[444]/LNP2[363])-LNP2x3[125])*LNP2[363];	//[1,53]<<414
  LNt[444] -= LNt[445];
  LNt[446] = LNt[416]+LNt[33]*LNt[379]+LNt[35]*LNt[376]+LNt[400]*LNt[373]+LNt[445];
  LNt[447] = (float(LNP2x3[125]+LNt[446]/LNP2[386])-LNP2x3[125])*LNP2[386];	//[1,53]<<437
  LNt[446] -= LNt[447];
  LNt[448] = LNt[417]+LNt[33]*LNt[382]+LNt[35]*LNt[379]+LNt[400]*LNt[376]+LNt[447];
  LNt[449] = (float(LNP2x3[125]+LNt[448]/LNP2[409])-LNP2x3[125])*LNP2[409];	//[1,53]<<460
  LNt[448] -= LNt[449];
  LNt[450] = LNt[418]+LNt[33]*LNt[385]+LNt[35]*LNt[382]+LNt[400]*LNt[379]+LNt[449];
  LNt[451] = (float(LNP2x3[125]+LNt[450]/LNP2[432])-LNP2x3[125])*LNP2[432];	//[1,53]<<483
  LNt[450] -= LNt[451];
  LNt[452] = c.x.v0*LNt[72]+c.x.v1*LNt[69]+c.x.v2*LNt[66]+c.x.v3*LNt[63]+c.x.v4*LNt[60]+c.x.v5*LNt[57];
  LNt[453] = c.x.v0*LNt[75]+c.x.v1*LNt[72]+c.x.v2*LNt[69]+c.x.v3*LNt[66]+c.x.v4*LNt[63]+c.x.v5*LNt[60];
  LNt[454] = c.x.v0*LNt[78]+c.x.v1*LNt[75]+c.x.v2*LNt[72]+c.x.v3*LNt[69]+c.x.v4*LNt[66]+c.x.v5*LNt[63];
  LNt[455] = c.x.v0*LNt[81]+c.x.v1*LNt[78]+c.x.v2*LNt[75]+c.x.v3*LNt[72]+c.x.v4*LNt[69]+c.x.v5*LNt[66];
  LNt[456] = c.x.v0*LNt[84]+c.x.v1*LNt[81]+c.x.v2*LNt[78]+c.x.v3*LNt[75]+c.x.v4*LNt[72]+c.x.v5*LNt[69];
  LNt[457] = c.x.v0*LNt[87]+c.x.v1*LNt[84]+c.x.v2*LNt[81]+c.x.v3*LNt[78]+c.x.v4*LNt[75]+c.x.v5*LNt[72];
  LNt[458] = c.x.v0*LNt[90]+c.x.v1*LNt[87]+c.x.v2*LNt[84]+c.x.v3*LNt[81]+c.x.v4*LNt[78]+c.x.v5*LNt[75];
  LNt[459] = c.x.v0*LNt[93]+c.x.v1*LNt[90]+c.x.v2*LNt[87]+c.x.v3*LNt[84]+c.x.v4*LNt[81]+c.x.v5*LNt[78];
  LNt[460] = c.x.v0*LNt[96]+c.x.v1*LNt[93]+c.x.v2*LNt[90]+c.x.v3*LNt[87]+c.x.v4*LNt[84]+c.x.v5*LNt[81];
  LNt[461] = c.x.v0*LNt[98]+c.x.v1*LNt[96]+c.x.v2*LNt[93]+c.x.v3*LNt[90]+c.x.v4*LNt[87]+c.x.v5*LNt[84];
  LNt[462] = c.x.v1*LNt[98]+c.x.v2*LNt[96]+c.x.v3*LNt[93]+c.x.v4*LNt[90]+c.x.v5*LNt[87]+c.x.v6*LNt[84];
  LNt[463] = c.x.v2*LNt[98]+c.x.v3*LNt[96]+c.x.v4*LNt[93]+c.x.v5*LNt[90]+c.x.v6*LNt[87]+c.x.v7*LNt[84];
  LNt[464] = LNt[454]+c.x.v6*LNt[60]+c.x.v7*LNt[57];
  LNt[465] = (float(LNP2x3[125]+LNt[464]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[464] -= LNt[465];
  LNt[466] = LNt[455]+c.x.v6*LNt[63]+c.x.v7*LNt[60]+LNt[465];
  LNt[467] = (float(LNP2x3[125]+LNt[466]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[466] -= LNt[467];
  LNt[468] = LNt[456]+c.x.v6*LNt[66]+c.x.v7*LNt[63]+LNt[467];
  LNt[469] = (float(LNP2x3[125]+LNt[468]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[468] -= LNt[469];
  LNt[470] = LNt[457]+c.x.v6*LNt[69]+c.x.v7*LNt[66]+LNt[469];
  LNt[471] = (float(LNP2x3[125]+LNt[470]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[470] -= LNt[471];
  LNt[472] = LNt[458]+c.x.v6*LNt[72]+c.x.v7*LNt[69]+LNt[471];
  LNt[473] = (float(LNP2x3[125]+LNt[472]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[472] -= LNt[473];
  LNt[474] = LNt[459]+c.x.v6*LNt[75]+c.x.v7*LNt[72]+LNt[473];
  LNt[475] = (float(LNP2x3[125]+LNt[474]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[474] -= LNt[475];
  LNt[476] = LNt[460]+c.x.v6*LNt[78]+c.x.v7*LNt[75]+LNt[475];
  LNt[477] = (float(LNP2x3[125]+LNt[476]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[476] -= LNt[477];
  LNt[478] = LNt[461]+c.x.v6*LNt[81]+c.x.v7*LNt[78]+LNt[477];
  LNt[479] = (float(LNP2x3[125]+LNt[478]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[478] -= LNt[479];
  LNt[480] = a.x.v0*b.w.v5+a.x.v1*b.w.v4+a.x.v2*b.w.v3+a.x.v3*b.w.v2+a.x.v4*b.w.v1+a.x.v5*b.w.v0;
  LNt[481] = a.x.v0*b.w.v6+a.x.v1*b.w.v5+a.x.v2*b.w.v4+a.x.v3*b.w.v3+a.x.v4*b.w.v2+a.x.v5*b.w.v1;
  LNt[482] = a.x.v0*b.w.v7+a.x.v1*b.w.v6+a.x.v2*b.w.v5+a.x.v3*b.w.v4+a.x.v4*b.w.v3+a.x.v5*b.w.v2;
  LNt[483] = a.x.v1*b.w.v7+a.x.v2*b.w.v6+a.x.v3*b.w.v5+a.x.v4*b.w.v4+a.x.v5*b.w.v3+a.x.v6*b.w.v2;
  LNt[484] = a.x.v2*b.w.v7+a.x.v3*b.w.v6+a.x.v4*b.w.v5+a.x.v5*b.w.v4+a.x.v6*b.w.v3+a.x.v7*b.w.v2;
  LNt[485] = LNt[482]+a.x.v6*b.w.v1+a.x.v7*b.w.v0;
  LNt[486] = (float(LNP2x3[125]+LNt[485]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[485] -= LNt[486];
  LNt[487] = a.w.v0*b.x.v5+a.w.v1*b.x.v4+a.w.v2*b.x.v3+a.w.v3*b.x.v2+a.w.v4*b.x.v1+a.w.v5*b.x.v0;
  LNt[488] = a.w.v0*b.x.v6+a.w.v1*b.x.v5+a.w.v2*b.x.v4+a.w.v3*b.x.v3+a.w.v4*b.x.v2+a.w.v5*b.x.v1;
  LNt[489] = a.w.v0*b.x.v7+a.w.v1*b.x.v6+a.w.v2*b.x.v5+a.w.v3*b.x.v4+a.w.v4*b.x.v3+a.w.v5*b.x.v2;
  LNt[490] = a.w.v1*b.x.v7+a.w.v2*b.x.v6+a.w.v3*b.x.v5+a.w.v4*b.x.v4+a.w.v5*b.x.v3+a.w.v6*b.x.v2;
  LNt[491] = a.w.v2*b.x.v7+a.w.v3*b.x.v6+a.w.v4*b.x.v5+a.w.v5*b.x.v4+a.w.v6*b.x.v3+a.w.v7*b.x.v2;
  LNt[492] = LNt[489]+a.w.v6*b.x.v1+a.w.v7*b.x.v0;
  LNt[493] = (float(LNP2x3[125]+LNt[492]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[492] -= LNt[493];
  LNt[494] = a.x.v0*b.w.v2+a.x.v1*b.w.v1+a.x.v2*b.w.v0-(a.w.v0*b.x.v2+a.w.v1*b.x.v1+a.w.v2*b.x.v0);
  LNt[495] = a.x.v0*b.w.v3+a.x.v1*b.w.v2+a.x.v2*b.w.v1+a.x.v3*b.w.v0-(a.w.v0*b.x.v3+a.w.v1*b.x.v2+a.w.v2*b.x.v1+a.w.v3*b.x.v0);
  LNt[496] = a.x.v0*b.w.v4+a.x.v1*b.w.v3+a.x.v2*b.w.v2+a.x.v3*b.w.v1+a.x.v4*b.w.v0-(a.w.v0*b.x.v4+a.w.v1*b.x.v3+a.w.v2*b.x.v2+a.w.v3*b.x.v1+a.w.v4*b.x.v0);
  LNt[497] = a.x.v3*b.w.v7+a.x.v4*b.w.v6+a.x.v5*b.w.v5+a.x.v6*b.w.v4+a.x.v7*b.w.v3-(a.w.v3*b.x.v7+a.w.v4*b.x.v6+a.w.v5*b.x.v5+a.w.v6*b.x.v4+a.w.v7*b.x.v3);
  LNt[498] = a.x.v4*b.w.v7+a.x.v5*b.w.v6+a.x.v6*b.w.v5+a.x.v7*b.w.v4-(a.w.v4*b.x.v7+a.w.v5*b.x.v6+a.w.v6*b.x.v5+a.w.v7*b.x.v4);
  LNt[499] = a.x.v5*b.w.v7+a.x.v6*b.w.v6+a.x.v7*b.w.v5-(a.w.v5*b.x.v7+a.w.v6*b.x.v6+a.w.v7*b.x.v5);
  LNt[500] = a.x.v0*b.w.v0-a.w.v0*b.x.v0;
  LNt[501] = float(LNP2x3[47]+LNt[500])-LNP2x3[47];	//[22,47]<<0
  LNt[500] -= LNt[501];
  LNt[502] = float(LNP2x3[45]+LNt[500])-LNP2x3[45];	//[2,25]<<0
  LNt[500] -= LNt[502];
  LNt[503] = a.x.v0*b.w.v1+a.x.v1*b.w.v0-(a.w.v0*b.x.v1+a.w.v1*b.x.v0)+LNt[501]+LNt[502];
  LNt[504] = float(LNP2x3[71]+LNt[503])-LNP2x3[71];	//[22,48]<<23
  LNt[503] -= LNt[504];
  LNt[505] = float(LNP2x3[68]+LNt[503])-LNP2x3[68];	//[3,26]<<23
  LNt[503] -= LNt[505];
  LNt[506] = LNt[494]+LNt[504]+LNt[505];
  LNt[507] = float(LNP2x3[95]+LNt[506])-LNP2x3[95];	//[22,49]<<46
  LNt[506] -= LNt[507];
  LNt[508] = float(LNP2x3[91]+LNt[506])-LNP2x3[91];	//[4,27]<<46
  LNt[506] -= LNt[508];
  LNt[509] = LNt[495]+LNt[507]+LNt[508];
  LNt[510] = float(LNP2x3[119]+LNt[509])-LNP2x3[119];	//[22,50]<<69
  LNt[509] -= LNt[510];
  LNt[511] = float(LNP2x3[114]+LNt[509])-LNP2x3[114];	//[5,28]<<69
  LNt[509] -= LNt[511];
  LNt[512] = LNt[496]+LNt[510]+LNt[511];
  LNt[513] = (float(LNP2x3[125]+LNt[512]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[512] -= LNt[513];
  LNt[514] = (float(LNP2x3[125]+LNt[512]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[512] -= LNt[514];
  LNt[515] = LNt[480]-LNt[487]+LNt[513]+LNt[514];
  LNt[516] = (float(LNP2x3[125]+LNt[515]/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
  LNt[515] -= LNt[516];
  LNt[517] = (float(LNP2x3[125]+LNt[515]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
  LNt[515] -= LNt[517];
  LNt[518] = LNt[481]+a.x.v6*b.w.v0-(LNt[488]+a.w.v6*b.x.v0)+LNt[516]+LNt[517];
  LNt[519] = (float(LNP2x3[125]+LNt[518]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[518] -= LNt[519];
  LNt[520] = (float(LNP2x3[125]+LNt[518]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[518] -= LNt[520];
  LNt[521] = LNt[485]-LNt[492]+LNt[519]+LNt[520];
  LNt[522] = (float(LNP2x3[125]+LNt[521]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[521] -= LNt[522];
  LNt[523] = (float(LNP2x3[125]+LNt[521]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[521] -= LNt[523];
  LNt[524] = LNt[483]+a.x.v7*b.w.v1+LNt[486]-(LNt[490]+a.w.v7*b.x.v1+LNt[493])+LNt[522]+LNt[523];
  LNt[525] = (float(LNP2x3[125]+LNt[524]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[524] -= LNt[525];
  LNt[526] = (float(LNP2x3[125]+LNt[524]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[524] -= LNt[526];
  LNt[527] = LNt[484]-LNt[491]+LNt[525]+LNt[526];
  LNt[528] = (float(LNP2x3[125]+LNt[527]/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
  LNt[527] -= LNt[528];
  LNt[529] = (float(LNP2x3[125]+LNt[527]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
  LNt[527] -= LNt[529];
  LNt[530] = LNt[497]+LNt[528]+LNt[529];
  LNt[531] = (float(LNP2x3[125]+LNt[530]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[22,51]<<230
  LNt[530] -= LNt[531];
  LNt[532] = (float(LNP2x3[125]+LNt[530]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[6,29]<<230
  LNt[530] -= LNt[532];
  LNt[533] = LNt[498]+LNt[531]+LNt[532];
  LNt[534] = (float(LNP2x3[125]+LNt[533]/LNP2[178])-LNP2x3[125])*LNP2[178];	//[22,50]<<253
  LNt[533] -= LNt[534];
  LNt[535] = (float(LNP2x3[125]+LNt[533]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[5,28]<<253
  LNt[533] -= LNt[535];
  LNt[536] = LNt[499]+LNt[534]+LNt[535];
  LNt[537] = (float(LNP2x3[125]+LNt[536]/LNP2[200])-LNP2x3[125])*LNP2[200];	//[22,49]<<276
  LNt[536] -= LNt[537];
  LNt[538] = (float(LNP2x3[125]+LNt[536]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[4,27]<<276
  LNt[536] -= LNt[538];
  LNt[539] = a.x.v6*b.w.v7+a.x.v7*b.w.v6-(a.w.v6*b.x.v7+a.w.v7*b.x.v6)+LNt[537]+LNt[538];
  LNt[540] = (float(LNP2x3[125]+LNt[539]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[4,27]<<299
  LNt[539] -= LNt[540];
  LNt[541] = a.x.v7*b.w.v7-a.w.v7*b.x.v7+LNt[540];
  LNt[542] = c.z.v0*LNt[515]+c.z.v1*LNt[512]+c.z.v2*LNt[509]+c.z.v3*LNt[506]+c.z.v4*LNt[503]+c.z.v5*LNt[500];
  LNt[543] = c.z.v0*LNt[518]+c.z.v1*LNt[515]+c.z.v2*LNt[512]+c.z.v3*LNt[509]+c.z.v4*LNt[506]+c.z.v5*LNt[503];
  LNt[544] = c.z.v0*LNt[521]+c.z.v1*LNt[518]+c.z.v2*LNt[515]+c.z.v3*LNt[512]+c.z.v4*LNt[509]+c.z.v5*LNt[506];
  LNt[545] = c.z.v0*LNt[524]+c.z.v1*LNt[521]+c.z.v2*LNt[518]+c.z.v3*LNt[515]+c.z.v4*LNt[512]+c.z.v5*LNt[509];
  LNt[546] = c.z.v0*LNt[527]+c.z.v1*LNt[524]+c.z.v2*LNt[521]+c.z.v3*LNt[518]+c.z.v4*LNt[515]+c.z.v5*LNt[512];
  LNt[547] = c.z.v0*LNt[530]+c.z.v1*LNt[527]+c.z.v2*LNt[524]+c.z.v3*LNt[521]+c.z.v4*LNt[518]+c.z.v5*LNt[515];
  LNt[548] = c.z.v0*LNt[533]+c.z.v1*LNt[530]+c.z.v2*LNt[527]+c.z.v3*LNt[524]+c.z.v4*LNt[521]+c.z.v5*LNt[518];
  LNt[549] = c.z.v0*LNt[536]+c.z.v1*LNt[533]+c.z.v2*LNt[530]+c.z.v3*LNt[527]+c.z.v4*LNt[524]+c.z.v5*LNt[521];
  LNt[550] = c.z.v0*LNt[539]+c.z.v1*LNt[536]+c.z.v2*LNt[533]+c.z.v3*LNt[530]+c.z.v4*LNt[527]+c.z.v5*LNt[524];
  LNt[551] = c.z.v0*LNt[541]+c.z.v1*LNt[539]+c.z.v2*LNt[536]+c.z.v3*LNt[533]+c.z.v4*LNt[530]+c.z.v5*LNt[527];
  LNt[552] = c.z.v1*LNt[541]+c.z.v2*LNt[539]+c.z.v3*LNt[536]+c.z.v4*LNt[533]+c.z.v5*LNt[530]+c.z.v6*LNt[527];
  LNt[553] = c.z.v2*LNt[541]+c.z.v3*LNt[539]+c.z.v4*LNt[536]+c.z.v5*LNt[533]+c.z.v6*LNt[530]+c.z.v7*LNt[527];
  LNt[554] = LNt[544]+c.z.v6*LNt[503]+c.z.v7*LNt[500];
  LNt[555] = (float(LNP2x3[125]+LNt[554]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[554] -= LNt[555];
  LNt[556] = LNt[545]+c.z.v6*LNt[506]+c.z.v7*LNt[503]+LNt[555];
  LNt[557] = (float(LNP2x3[125]+LNt[556]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[556] -= LNt[557];
  LNt[558] = LNt[546]+c.z.v6*LNt[509]+c.z.v7*LNt[506]+LNt[557];
  LNt[559] = (float(LNP2x3[125]+LNt[558]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[558] -= LNt[559];
  LNt[560] = LNt[547]+c.z.v6*LNt[512]+c.z.v7*LNt[509]+LNt[559];
  LNt[561] = (float(LNP2x3[125]+LNt[560]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[560] -= LNt[561];
  LNt[562] = LNt[548]+c.z.v6*LNt[515]+c.z.v7*LNt[512]+LNt[561];
  LNt[563] = (float(LNP2x3[125]+LNt[562]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[562] -= LNt[563];
  LNt[564] = LNt[549]+c.z.v6*LNt[518]+c.z.v7*LNt[515]+LNt[563];
  LNt[565] = (float(LNP2x3[125]+LNt[564]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[564] -= LNt[565];
  LNt[566] = LNt[550]+c.z.v6*LNt[521]+c.z.v7*LNt[518]+LNt[565];
  LNt[567] = (float(LNP2x3[125]+LNt[566]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[566] -= LNt[567];
  LNt[568] = LNt[551]+c.z.v6*LNt[524]+c.z.v7*LNt[521]+LNt[567];
  LNt[569] = (float(LNP2x3[125]+LNt[568]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[568] -= LNt[569];
  LNt[570] = c.x.v0*LNt[63]+c.x.v1*LNt[60]+c.x.v2*LNt[57]-(c.z.v0*LNt[506]+c.z.v1*LNt[503]+c.z.v2*LNt[500]);
  LNt[571] = c.x.v0*LNt[66]+c.x.v1*LNt[63]+c.x.v2*LNt[60]+c.x.v3*LNt[57]-(c.z.v0*LNt[509]+c.z.v1*LNt[506]+c.z.v2*LNt[503]+c.z.v3*LNt[500]);
  LNt[572] = c.x.v0*LNt[69]+c.x.v1*LNt[66]+c.x.v2*LNt[63]+c.x.v3*LNt[60]+c.x.v4*LNt[57]-(c.z.v0*LNt[512]+c.z.v1*LNt[509]+c.z.v2*LNt[506]+c.z.v3*LNt[503]+c.z.v4*LNt[500]);
  LNt[573] = c.x.v3*LNt[98]+c.x.v4*LNt[96]+c.x.v5*LNt[93]+c.x.v6*LNt[90]+c.x.v7*LNt[87]-(c.z.v3*LNt[541]+c.z.v4*LNt[539]+c.z.v5*LNt[536]+c.z.v6*LNt[533]+c.z.v7*LNt[530]);
  LNt[574] = c.x.v4*LNt[98]+c.x.v5*LNt[96]+c.x.v6*LNt[93]+c.x.v7*LNt[90]-(c.z.v4*LNt[541]+c.z.v5*LNt[539]+c.z.v6*LNt[536]+c.z.v7*LNt[533]);
  LNt[575] = c.x.v5*LNt[98]+c.x.v6*LNt[96]+c.x.v7*LNt[93]-(c.z.v5*LNt[541]+c.z.v6*LNt[539]+c.z.v7*LNt[536]);
  LNt[576] = LNt[453]+c.x.v6*LNt[57]-(LNt[543]+c.z.v6*LNt[500]);
  LNt[577] = (float(LNP2x3[125]+LNt[576]/LNP2[87])-LNP2x3[125])*LNP2[87];	//[1,53]<<138
  LNt[576] -= LNt[577];
  LNt[578] = LNt[464]-LNt[554]+LNt[577];
  LNt[579] = (float(LNP2x3[125]+LNt[578]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[578] -= LNt[579];
  LNt[580] = LNt[466]-LNt[556]+LNt[579];
  LNt[581] = (float(LNP2x3[125]+LNt[580]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[580] -= LNt[581];
  LNt[582] = LNt[468]-LNt[558]+LNt[581];
  LNt[583] = (float(LNP2x3[125]+LNt[582]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[582] -= LNt[583];
  LNt[584] = LNt[470]-LNt[560]+LNt[583];
  LNt[585] = (float(LNP2x3[125]+LNt[584]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[584] -= LNt[585];
  LNt[586] = LNt[472]-LNt[562]+LNt[585];
  LNt[587] = (float(LNP2x3[125]+LNt[586]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[586] -= LNt[587];
  LNt[588] = LNt[474]-LNt[564]+LNt[587];
  LNt[589] = (float(LNP2x3[125]+LNt[588]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[588] -= LNt[589];
  LNt[590] = LNt[476]-LNt[566]+LNt[589];
  LNt[591] = (float(LNP2x3[125]+LNt[590]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[590] -= LNt[591];
  LNt[592] = LNt[478]-LNt[568]+LNt[591];
  LNt[593] = (float(LNP2x3[125]+LNt[592]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[592] -= LNt[593];
  LNt[594] = LNt[462]+c.x.v7*LNt[81]+LNt[479]-(LNt[552]+c.z.v7*LNt[524]+LNt[569])+LNt[593];
  LNt[595] = (float(LNP2x3[125]+LNt[594]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[594] -= LNt[595];
  LNt[596] = a.x.v0*b.z.v5+a.x.v1*b.z.v4+a.x.v2*b.z.v3+a.x.v3*b.z.v2+a.x.v4*b.z.v1+a.x.v5*b.z.v0;
  LNt[597] = a.x.v0*b.z.v6+a.x.v1*b.z.v5+a.x.v2*b.z.v4+a.x.v3*b.z.v3+a.x.v4*b.z.v2+a.x.v5*b.z.v1;
  LNt[598] = a.x.v0*b.z.v7+a.x.v1*b.z.v6+a.x.v2*b.z.v5+a.x.v3*b.z.v4+a.x.v4*b.z.v3+a.x.v5*b.z.v2;
  LNt[599] = a.x.v1*b.z.v7+a.x.v2*b.z.v6+a.x.v3*b.z.v5+a.x.v4*b.z.v4+a.x.v5*b.z.v3+a.x.v6*b.z.v2;
  LNt[600] = a.x.v2*b.z.v7+a.x.v3*b.z.v6+a.x.v4*b.z.v5+a.x.v5*b.z.v4+a.x.v6*b.z.v3+a.x.v7*b.z.v2;
  LNt[601] = LNt[598]+a.x.v6*b.z.v1+a.x.v7*b.z.v0;
  LNt[602] = (float(LNP2x3[125]+LNt[601]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[601] -= LNt[602];
  LNt[603] = a.z.v0*b.x.v5+a.z.v1*b.x.v4+a.z.v2*b.x.v3+a.z.v3*b.x.v2+a.z.v4*b.x.v1+a.z.v5*b.x.v0;
  LNt[604] = a.z.v0*b.x.v6+a.z.v1*b.x.v5+a.z.v2*b.x.v4+a.z.v3*b.x.v3+a.z.v4*b.x.v2+a.z.v5*b.x.v1;
  LNt[605] = a.z.v0*b.x.v7+a.z.v1*b.x.v6+a.z.v2*b.x.v5+a.z.v3*b.x.v4+a.z.v4*b.x.v3+a.z.v5*b.x.v2;
  LNt[606] = a.z.v1*b.x.v7+a.z.v2*b.x.v6+a.z.v3*b.x.v5+a.z.v4*b.x.v4+a.z.v5*b.x.v3+a.z.v6*b.x.v2;
  LNt[607] = a.z.v2*b.x.v7+a.z.v3*b.x.v6+a.z.v4*b.x.v5+a.z.v5*b.x.v4+a.z.v6*b.x.v3+a.z.v7*b.x.v2;
  LNt[608] = LNt[605]+a.z.v6*b.x.v1+a.z.v7*b.x.v0;
  LNt[609] = (float(LNP2x3[125]+LNt[608]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[608] -= LNt[609];
  LNt[610] = a.x.v0*b.z.v2+a.x.v1*b.z.v1+a.x.v2*b.z.v0-(a.z.v0*b.x.v2+a.z.v1*b.x.v1+a.z.v2*b.x.v0);
  LNt[611] = a.x.v0*b.z.v3+a.x.v1*b.z.v2+a.x.v2*b.z.v1+a.x.v3*b.z.v0-(a.z.v0*b.x.v3+a.z.v1*b.x.v2+a.z.v2*b.x.v1+a.z.v3*b.x.v0);
  LNt[612] = a.x.v0*b.z.v4+a.x.v1*b.z.v3+a.x.v2*b.z.v2+a.x.v3*b.z.v1+a.x.v4*b.z.v0-(a.z.v0*b.x.v4+a.z.v1*b.x.v3+a.z.v2*b.x.v2+a.z.v3*b.x.v1+a.z.v4*b.x.v0);
  LNt[613] = a.x.v3*b.z.v7+a.x.v4*b.z.v6+a.x.v5*b.z.v5+a.x.v6*b.z.v4+a.x.v7*b.z.v3-(a.z.v3*b.x.v7+a.z.v4*b.x.v6+a.z.v5*b.x.v5+a.z.v6*b.x.v4+a.z.v7*b.x.v3);
  LNt[614] = a.x.v4*b.z.v7+a.x.v5*b.z.v6+a.x.v6*b.z.v5+a.x.v7*b.z.v4-(a.z.v4*b.x.v7+a.z.v5*b.x.v6+a.z.v6*b.x.v5+a.z.v7*b.x.v4);
  LNt[615] = a.x.v5*b.z.v7+a.x.v6*b.z.v6+a.x.v7*b.z.v5-(a.z.v5*b.x.v7+a.z.v6*b.x.v6+a.z.v7*b.x.v5);
  LNt[616] = a.x.v0*b.z.v0-a.z.v0*b.x.v0;
  LNt[617] = float(LNP2x3[47]+LNt[616])-LNP2x3[47];	//[22,47]<<0
  LNt[616] -= LNt[617];
  LNt[618] = float(LNP2x3[45]+LNt[616])-LNP2x3[45];	//[2,25]<<0
  LNt[616] -= LNt[618];
  LNt[619] = a.x.v0*b.z.v1+a.x.v1*b.z.v0-(a.z.v0*b.x.v1+a.z.v1*b.x.v0)+LNt[617]+LNt[618];
  LNt[620] = float(LNP2x3[71]+LNt[619])-LNP2x3[71];	//[22,48]<<23
  LNt[619] -= LNt[620];
  LNt[621] = float(LNP2x3[68]+LNt[619])-LNP2x3[68];	//[3,26]<<23
  LNt[619] -= LNt[621];
  LNt[622] = LNt[610]+LNt[620]+LNt[621];
  LNt[623] = float(LNP2x3[95]+LNt[622])-LNP2x3[95];	//[22,49]<<46
  LNt[622] -= LNt[623];
  LNt[624] = float(LNP2x3[91]+LNt[622])-LNP2x3[91];	//[4,27]<<46
  LNt[622] -= LNt[624];
  LNt[625] = LNt[611]+LNt[623]+LNt[624];
  LNt[626] = float(LNP2x3[119]+LNt[625])-LNP2x3[119];	//[22,50]<<69
  LNt[625] -= LNt[626];
  LNt[627] = float(LNP2x3[114]+LNt[625])-LNP2x3[114];	//[5,28]<<69
  LNt[625] -= LNt[627];
  LNt[628] = LNt[612]+LNt[626]+LNt[627];
  LNt[629] = (float(LNP2x3[125]+LNt[628]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[628] -= LNt[629];
  LNt[630] = (float(LNP2x3[125]+LNt[628]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[628] -= LNt[630];
  LNt[631] = LNt[596]-LNt[603]+LNt[629]+LNt[630];
  LNt[632] = (float(LNP2x3[125]+LNt[631]/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
  LNt[631] -= LNt[632];
  LNt[633] = (float(LNP2x3[125]+LNt[631]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
  LNt[631] -= LNt[633];
  LNt[634] = LNt[597]+a.x.v6*b.z.v0-(LNt[604]+a.z.v6*b.x.v0)+LNt[632]+LNt[633];
  LNt[635] = (float(LNP2x3[125]+LNt[634]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[634] -= LNt[635];
  LNt[636] = (float(LNP2x3[125]+LNt[634]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[634] -= LNt[636];
  LNt[637] = LNt[601]-LNt[608]+LNt[635]+LNt[636];
  LNt[638] = (float(LNP2x3[125]+LNt[637]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[637] -= LNt[638];
  LNt[639] = (float(LNP2x3[125]+LNt[637]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[637] -= LNt[639];
  LNt[640] = LNt[599]+a.x.v7*b.z.v1+LNt[602]-(LNt[606]+a.z.v7*b.x.v1+LNt[609])+LNt[638]+LNt[639];
  LNt[641] = (float(LNP2x3[125]+LNt[640]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[640] -= LNt[641];
  LNt[642] = (float(LNP2x3[125]+LNt[640]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[640] -= LNt[642];
  LNt[643] = LNt[600]-LNt[607]+LNt[641]+LNt[642];
  LNt[644] = (float(LNP2x3[125]+LNt[643]/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
  LNt[643] -= LNt[644];
  LNt[645] = (float(LNP2x3[125]+LNt[643]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
  LNt[643] -= LNt[645];
  LNt[646] = LNt[613]+LNt[644]+LNt[645];
  LNt[647] = (float(LNP2x3[125]+LNt[646]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[22,51]<<230
  LNt[646] -= LNt[647];
  LNt[648] = (float(LNP2x3[125]+LNt[646]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[6,29]<<230
  LNt[646] -= LNt[648];
  LNt[649] = LNt[614]+LNt[647]+LNt[648];
  LNt[650] = (float(LNP2x3[125]+LNt[649]/LNP2[178])-LNP2x3[125])*LNP2[178];	//[22,50]<<253
  LNt[649] -= LNt[650];
  LNt[651] = (float(LNP2x3[125]+LNt[649]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[5,28]<<253
  LNt[649] -= LNt[651];
  LNt[652] = LNt[615]+LNt[650]+LNt[651];
  LNt[653] = (float(LNP2x3[125]+LNt[652]/LNP2[200])-LNP2x3[125])*LNP2[200];	//[22,49]<<276
  LNt[652] -= LNt[653];
  LNt[654] = (float(LNP2x3[125]+LNt[652]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[4,27]<<276
  LNt[652] -= LNt[654];
  LNt[655] = a.x.v6*b.z.v7+a.x.v7*b.z.v6-(a.z.v6*b.x.v7+a.z.v7*b.x.v6)+LNt[653]+LNt[654];
  LNt[656] = (float(LNP2x3[125]+LNt[655]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[4,27]<<299
  LNt[655] -= LNt[656];
  LNt[657] = a.x.v7*b.z.v7-a.z.v7*b.x.v7+LNt[656];
  LNt[658] = c.w.v0*LNt[631]+c.w.v1*LNt[628]+c.w.v2*LNt[625]+c.w.v3*LNt[622]+c.w.v4*LNt[619]+c.w.v5*LNt[616];
  LNt[659] = c.w.v0*LNt[634]+c.w.v1*LNt[631]+c.w.v2*LNt[628]+c.w.v3*LNt[625]+c.w.v4*LNt[622]+c.w.v5*LNt[619];
  LNt[660] = c.w.v0*LNt[637]+c.w.v1*LNt[634]+c.w.v2*LNt[631]+c.w.v3*LNt[628]+c.w.v4*LNt[625]+c.w.v5*LNt[622];
  LNt[661] = c.w.v0*LNt[640]+c.w.v1*LNt[637]+c.w.v2*LNt[634]+c.w.v3*LNt[631]+c.w.v4*LNt[628]+c.w.v5*LNt[625];
  LNt[662] = c.w.v0*LNt[643]+c.w.v1*LNt[640]+c.w.v2*LNt[637]+c.w.v3*LNt[634]+c.w.v4*LNt[631]+c.w.v5*LNt[628];
  LNt[663] = c.w.v0*LNt[646]+c.w.v1*LNt[643]+c.w.v2*LNt[640]+c.w.v3*LNt[637]+c.w.v4*LNt[634]+c.w.v5*LNt[631];
  LNt[664] = c.w.v0*LNt[649]+c.w.v1*LNt[646]+c.w.v2*LNt[643]+c.w.v3*LNt[640]+c.w.v4*LNt[637]+c.w.v5*LNt[634];
  LNt[665] = c.w.v0*LNt[652]+c.w.v1*LNt[649]+c.w.v2*LNt[646]+c.w.v3*LNt[643]+c.w.v4*LNt[640]+c.w.v5*LNt[637];
  LNt[666] = c.w.v0*LNt[655]+c.w.v1*LNt[652]+c.w.v2*LNt[649]+c.w.v3*LNt[646]+c.w.v4*LNt[643]+c.w.v5*LNt[640];
  LNt[667] = c.w.v0*LNt[657]+c.w.v1*LNt[655]+c.w.v2*LNt[652]+c.w.v3*LNt[649]+c.w.v4*LNt[646]+c.w.v5*LNt[643];
  LNt[668] = c.w.v1*LNt[657]+c.w.v2*LNt[655]+c.w.v3*LNt[652]+c.w.v4*LNt[649]+c.w.v5*LNt[646]+c.w.v6*LNt[643];
  LNt[669] = c.w.v2*LNt[657]+c.w.v3*LNt[655]+c.w.v4*LNt[652]+c.w.v5*LNt[649]+c.w.v6*LNt[646]+c.w.v7*LNt[643];
  LNt[670] = LNt[660]+c.w.v6*LNt[619]+c.w.v7*LNt[616];
  LNt[671] = (float(LNP2x3[125]+LNt[670]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[670] -= LNt[671];
  LNt[672] = LNt[661]+c.w.v6*LNt[622]+c.w.v7*LNt[619]+LNt[671];
  LNt[673] = (float(LNP2x3[125]+LNt[672]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[672] -= LNt[673];
  LNt[674] = LNt[662]+c.w.v6*LNt[625]+c.w.v7*LNt[622]+LNt[673];
  LNt[675] = (float(LNP2x3[125]+LNt[674]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[674] -= LNt[675];
  LNt[676] = LNt[663]+c.w.v6*LNt[628]+c.w.v7*LNt[625]+LNt[675];
  LNt[677] = (float(LNP2x3[125]+LNt[676]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[676] -= LNt[677];
  LNt[678] = LNt[664]+c.w.v6*LNt[631]+c.w.v7*LNt[628]+LNt[677];
  LNt[679] = (float(LNP2x3[125]+LNt[678]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[678] -= LNt[679];
  LNt[680] = LNt[665]+c.w.v6*LNt[634]+c.w.v7*LNt[631]+LNt[679];
  LNt[681] = (float(LNP2x3[125]+LNt[680]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[680] -= LNt[681];
  LNt[682] = LNt[666]+c.w.v6*LNt[637]+c.w.v7*LNt[634]+LNt[681];
  LNt[683] = (float(LNP2x3[125]+LNt[682]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[682] -= LNt[683];
  LNt[684] = LNt[667]+c.w.v6*LNt[640]+c.w.v7*LNt[637]+LNt[683];
  LNt[685] = (float(LNP2x3[125]+LNt[684]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[684] -= LNt[685];
  LNt[686] = c.x.v0*LNt[60]+c.x.v1*LNt[57]-(c.z.v0*LNt[503]+c.z.v1*LNt[500])+c.w.v0*LNt[619]+c.w.v1*LNt[616];
  LNt[687] = LNt[572]+c.w.v0*LNt[628]+c.w.v1*LNt[625]+c.w.v2*LNt[622]+c.w.v3*LNt[619]+c.w.v4*LNt[616];
  LNt[688] = LNt[573]+c.w.v3*LNt[657]+c.w.v4*LNt[655]+c.w.v5*LNt[652]+c.w.v6*LNt[649]+c.w.v7*LNt[646];
  LNt[689] = c.x.v6*LNt[98]+c.x.v7*LNt[96]-(c.z.v6*LNt[541]+c.z.v7*LNt[539])+c.w.v6*LNt[657]+c.w.v7*LNt[655];
  LNt[690] = c.x.v0*LNt[57]-c.z.v0*LNt[500]+c.w.v0*LNt[616];
  LNt[691] = float(LNP2x3[48]+LNt[690])-LNP2x3[48];	//[22,48]<<0
  LNt[690] -= LNt[691];
  LNt[692] = float(LNP2x3[45]+LNt[690])-LNP2x3[45];	//[3,26]<<0
  LNt[690] -= LNt[692];
  LNt[693] = LNt[686]+LNt[691]+LNt[692];
  LNt[694] = float(LNP2x3[72]+LNt[693])-LNP2x3[72];	//[22,49]<<23
  LNt[693] -= LNt[694];
  LNt[695] = float(LNP2x3[68]+LNt[693])-LNP2x3[68];	//[4,27]<<23
  LNt[693] -= LNt[695];
  LNt[696] = LNt[570]+c.w.v0*LNt[622]+c.w.v1*LNt[619]+c.w.v2*LNt[616]+LNt[694]+LNt[695];
  LNt[697] = float(LNP2x3[96]+LNt[696])-LNP2x3[96];	//[22,50]<<46
  LNt[696] -= LNt[697];
  LNt[698] = float(LNP2x3[91]+LNt[696])-LNP2x3[91];	//[5,28]<<46
  LNt[696] -= LNt[698];
  LNt[699] = LNt[571]+c.w.v0*LNt[625]+c.w.v1*LNt[622]+c.w.v2*LNt[619]+c.w.v3*LNt[616]+LNt[697]+LNt[698];
  LNt[700] = float(LNP2x3[120]+LNt[699])-LNP2x3[120];	//[22,51]<<69
  LNt[699] -= LNt[700];
  LNt[701] = float(LNP2x3[114]+LNt[699])-LNP2x3[114];	//[6,29]<<69
  LNt[699] -= LNt[701];
  LNt[702] = LNt[687]+LNt[700]+LNt[701];
  LNt[703] = (float(LNP2x3[125]+LNt[702]/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
  LNt[702] -= LNt[703];
  LNt[704] = (float(LNP2x3[125]+LNt[702]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
  LNt[702] -= LNt[704];
  LNt[705] = LNt[452]-LNt[542]+LNt[658]+LNt[703]+LNt[704];
  LNt[706] = (float(LNP2x3[125]+LNt[705]/LNP2[43])-LNP2x3[125])*LNP2[43];	//[22,53]<<115
  LNt[705] -= LNt[706];
  LNt[707] = (float(LNP2x3[125]+LNt[705]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[8,31]<<115
  LNt[705] -= LNt[707];
  LNt[708] = LNt[576]+LNt[659]+c.w.v6*LNt[616]+LNt[706]+LNt[707];
  LNt[709] = (float(LNP2x3[125]+LNt[708]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[708] -= LNt[709];
  LNt[710] = (float(LNP2x3[125]+LNt[708]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[708] -= LNt[710];
  LNt[711] = LNt[578]+LNt[670]+LNt[709]+LNt[710];
  LNt[712] = (float(LNP2x3[125]+LNt[711]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[711] -= LNt[712];
  LNt[713] = (float(LNP2x3[125]+LNt[711]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[711] -= LNt[713];
  LNt[714] = LNt[580]+LNt[672]+LNt[712]+LNt[713];
  LNt[715] = (float(LNP2x3[125]+LNt[714]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[714] -= LNt[715];
  LNt[716] = (float(LNP2x3[125]+LNt[714]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[714] -= LNt[716];
  LNt[717] = LNt[582]+LNt[674]+LNt[715]+LNt[716];
  LNt[718] = (float(LNP2x3[125]+LNt[717]/LNP2[135])-LNP2x3[125])*LNP2[135];	//[22,53]<<207
  LNt[717] -= LNt[718];
  LNt[719] = (float(LNP2x3[125]+LNt[717]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[8,31]<<207
  LNt[717] -= LNt[719];
  LNt[720] = LNt[584]+LNt[676]+LNt[718]+LNt[719];
  LNt[721] = (float(LNP2x3[125]+LNt[720]/LNP2[158])-LNP2x3[125])*LNP2[158];	//[22,53]<<230
  LNt[720] -= LNt[721];
  LNt[722] = (float(LNP2x3[125]+LNt[720]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[8,31]<<230
  LNt[720] -= LNt[722];
  LNt[723] = LNt[586]+LNt[678]+LNt[721]+LNt[722];
  LNt[724] = (float(LNP2x3[125]+LNt[723]/LNP2[181])-LNP2x3[125])*LNP2[181];	//[22,53]<<253
  LNt[723] -= LNt[724];
  LNt[725] = (float(LNP2x3[125]+LNt[723]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[8,31]<<253
  LNt[723] -= LNt[725];
  LNt[726] = LNt[588]+LNt[680]+LNt[724]+LNt[725];
  LNt[727] = (float(LNP2x3[125]+LNt[726]/LNP2[204])-LNP2x3[125])*LNP2[204];	//[22,53]<<276
  LNt[726] -= LNt[727];
  LNt[728] = (float(LNP2x3[125]+LNt[726]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[8,31]<<276
  LNt[726] -= LNt[728];
  LNt[729] = LNt[590]+LNt[682]+LNt[727]+LNt[728];
  LNt[730] = (float(LNP2x3[125]+LNt[729]/LNP2[227])-LNP2x3[125])*LNP2[227];	//[22,53]<<299
  LNt[729] -= LNt[730];
  LNt[731] = (float(LNP2x3[125]+LNt[729]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[8,31]<<299
  LNt[729] -= LNt[731];
  LNt[732] = LNt[592]+LNt[684]+LNt[730]+LNt[731];
  LNt[733] = (float(LNP2x3[125]+LNt[732]/LNP2[250])-LNP2x3[125])*LNP2[250];	//[22,53]<<322
  LNt[732] -= LNt[733];
  LNt[734] = (float(LNP2x3[125]+LNt[732]/LNP2[242])-LNP2x3[125])*LNP2[242];	//[8,31]<<322
  LNt[732] -= LNt[734];
  LNt[735] = LNt[594]+LNt[668]+c.w.v7*LNt[640]+LNt[685]+LNt[733]+LNt[734];
  LNt[736] = (float(LNP2x3[125]+LNt[735]/LNP2[273])-LNP2x3[125])*LNP2[273];	//[22,53]<<345
  LNt[735] -= LNt[736];
  LNt[737] = (float(LNP2x3[125]+LNt[735]/LNP2[265])-LNP2x3[125])*LNP2[265];	//[8,31]<<345
  LNt[735] -= LNt[737];
  LNt[738] = LNt[463]-LNt[553]+LNt[595]+LNt[669]+LNt[736]+LNt[737];
  LNt[739] = (float(LNP2x3[125]+LNt[738]/LNP2[296])-LNP2x3[125])*LNP2[296];	//[22,53]<<368
  LNt[738] -= LNt[739];
  LNt[740] = (float(LNP2x3[125]+LNt[738]/LNP2[288])-LNP2x3[125])*LNP2[288];	//[8,31]<<368
  LNt[738] -= LNt[740];
  LNt[741] = LNt[688]+LNt[739]+LNt[740];
  LNt[742] = (float(LNP2x3[125]+LNt[741]/LNP2[318])-LNP2x3[125])*LNP2[318];	//[22,52]<<391
  LNt[741] -= LNt[742];
  LNt[743] = (float(LNP2x3[125]+LNt[741]/LNP2[311])-LNP2x3[125])*LNP2[311];	//[7,30]<<391
  LNt[741] -= LNt[743];
  LNt[744] = LNt[574]+c.w.v4*LNt[657]+c.w.v5*LNt[655]+c.w.v6*LNt[652]+c.w.v7*LNt[649]+LNt[742]+LNt[743];
  LNt[745] = (float(LNP2x3[125]+LNt[744]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[22,51]<<414
  LNt[744] -= LNt[745];
  LNt[746] = (float(LNP2x3[125]+LNt[744]/LNP2[334])-LNP2x3[125])*LNP2[334];	//[6,29]<<414
  LNt[744] -= LNt[746];
  LNt[747] = LNt[575]+c.w.v5*LNt[657]+c.w.v6*LNt[655]+c.w.v7*LNt[652]+LNt[745]+LNt[746];
  LNt[748] = (float(LNP2x3[125]+LNt[747]/LNP2[362])-LNP2x3[125])*LNP2[362];	//[22,50]<<437
  LNt[747] -= LNt[748];
  LNt[749] = (float(LNP2x3[125]+LNt[747]/LNP2[357])-LNP2x3[125])*LNP2[357];	//[5,28]<<437
  LNt[747] -= LNt[749];
  LNt[750] = LNt[689]+LNt[748]+LNt[749];
  LNt[751] = (float(LNP2x3[125]+LNt[750]/LNP2[380])-LNP2x3[125])*LNP2[380];	//[7,30]<<460
  LNt[750] -= LNt[751];
  LNt[752] = c.x.v7*LNt[98]-c.z.v7*LNt[541]+c.w.v7*LNt[657]+LNt[751];
  LNt[753] = d.y.v0*LNt[705]+d.y.v1*LNt[702]+d.y.v2*LNt[699]+d.y.v3*LNt[696]+d.y.v4*LNt[693]+d.y.v5*LNt[690];
  LNt[754] = d.y.v0*LNt[708]+d.y.v1*LNt[705]+d.y.v2*LNt[702]+d.y.v3*LNt[699]+d.y.v4*LNt[696]+d.y.v5*LNt[693];
  LNt[755] = d.y.v0*LNt[711]+d.y.v1*LNt[708]+d.y.v2*LNt[705]+d.y.v3*LNt[702]+d.y.v4*LNt[699]+d.y.v5*LNt[696];
  LNt[756] = d.y.v0*LNt[714]+d.y.v1*LNt[711]+d.y.v2*LNt[708]+d.y.v3*LNt[705]+d.y.v4*LNt[702]+d.y.v5*LNt[699];
  LNt[757] = d.y.v0*LNt[717]+d.y.v1*LNt[714]+d.y.v2*LNt[711]+d.y.v3*LNt[708]+d.y.v4*LNt[705]+d.y.v5*LNt[702];
  LNt[758] = d.y.v0*LNt[720]+d.y.v1*LNt[717]+d.y.v2*LNt[714]+d.y.v3*LNt[711]+d.y.v4*LNt[708]+d.y.v5*LNt[705];
  LNt[759] = d.y.v0*LNt[723]+d.y.v1*LNt[720]+d.y.v2*LNt[717]+d.y.v3*LNt[714]+d.y.v4*LNt[711]+d.y.v5*LNt[708];
  LNt[760] = d.y.v0*LNt[726]+d.y.v1*LNt[723]+d.y.v2*LNt[720]+d.y.v3*LNt[717]+d.y.v4*LNt[714]+d.y.v5*LNt[711];
  LNt[761] = d.y.v0*LNt[729]+d.y.v1*LNt[726]+d.y.v2*LNt[723]+d.y.v3*LNt[720]+d.y.v4*LNt[717]+d.y.v5*LNt[714];
  LNt[762] = d.y.v0*LNt[732]+d.y.v1*LNt[729]+d.y.v2*LNt[726]+d.y.v3*LNt[723]+d.y.v4*LNt[720]+d.y.v5*LNt[717];
  LNt[763] = d.y.v0*LNt[735]+d.y.v1*LNt[732]+d.y.v2*LNt[729]+d.y.v3*LNt[726]+d.y.v4*LNt[723]+d.y.v5*LNt[720];
  LNt[764] = d.y.v0*LNt[738]+d.y.v1*LNt[735]+d.y.v2*LNt[732]+d.y.v3*LNt[729]+d.y.v4*LNt[726]+d.y.v5*LNt[723];
  LNt[765] = d.y.v0*LNt[741]+d.y.v1*LNt[738]+d.y.v2*LNt[735]+d.y.v3*LNt[732]+d.y.v4*LNt[729]+d.y.v5*LNt[726];
  LNt[766] = d.y.v0*LNt[744]+d.y.v1*LNt[741]+d.y.v2*LNt[738]+d.y.v3*LNt[735]+d.y.v4*LNt[732]+d.y.v5*LNt[729];
  LNt[767] = d.y.v0*LNt[747]+d.y.v1*LNt[744]+d.y.v2*LNt[741]+d.y.v3*LNt[738]+d.y.v4*LNt[735]+d.y.v5*LNt[732];
  LNt[768] = d.y.v0*LNt[750]+d.y.v1*LNt[747]+d.y.v2*LNt[744]+d.y.v3*LNt[741]+d.y.v4*LNt[738]+d.y.v5*LNt[735];
  LNt[769] = d.y.v0*LNt[752]+d.y.v1*LNt[750]+d.y.v2*LNt[747]+d.y.v3*LNt[744]+d.y.v4*LNt[741]+d.y.v5*LNt[738];
  LNt[770] = d.y.v1*LNt[752]+d.y.v2*LNt[750]+d.y.v3*LNt[747]+d.y.v4*LNt[744]+d.y.v5*LNt[741]+d.y.v6*LNt[738];
  LNt[771] = d.y.v2*LNt[752]+d.y.v3*LNt[750]+d.y.v4*LNt[747]+d.y.v5*LNt[744]+d.y.v6*LNt[741]+d.y.v7*LNt[738];
  LNt[772] = LNt[755]+d.y.v6*LNt[693]+d.y.v7*LNt[690];
  LNt[773] = (float(LNP2x3[125]+LNt[772]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[772] -= LNt[773];
  LNt[774] = LNt[756]+d.y.v6*LNt[696]+d.y.v7*LNt[693]+LNt[773];
  LNt[775] = (float(LNP2x3[125]+LNt[774]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[774] -= LNt[775];
  LNt[776] = LNt[757]+d.y.v6*LNt[699]+d.y.v7*LNt[696]+LNt[775];
  LNt[777] = (float(LNP2x3[125]+LNt[776]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[776] -= LNt[777];
  LNt[778] = LNt[758]+d.y.v6*LNt[702]+d.y.v7*LNt[699]+LNt[777];
  LNt[779] = (float(LNP2x3[125]+LNt[778]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[778] -= LNt[779];
  LNt[780] = LNt[759]+d.y.v6*LNt[705]+d.y.v7*LNt[702]+LNt[779];
  LNt[781] = (float(LNP2x3[125]+LNt[780]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[780] -= LNt[781];
  LNt[782] = LNt[760]+d.y.v6*LNt[708]+d.y.v7*LNt[705]+LNt[781];
  LNt[783] = (float(LNP2x3[125]+LNt[782]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[782] -= LNt[783];
  LNt[784] = LNt[761]+d.y.v6*LNt[711]+d.y.v7*LNt[708]+LNt[783];
  LNt[785] = (float(LNP2x3[125]+LNt[784]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[784] -= LNt[785];
  LNt[786] = LNt[762]+d.y.v6*LNt[714]+d.y.v7*LNt[711]+LNt[785];
  LNt[787] = (float(LNP2x3[125]+LNt[786]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[786] -= LNt[787];
  LNt[788] = LNt[763]+d.y.v6*LNt[717]+d.y.v7*LNt[714]+LNt[787];
  LNt[789] = (float(LNP2x3[125]+LNt[788]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[788] -= LNt[789];
  LNt[790] = LNt[764]+d.y.v6*LNt[720]+d.y.v7*LNt[717]+LNt[789];
  LNt[791] = (float(LNP2x3[125]+LNt[790]/LNP2[317])-LNP2x3[125])*LNP2[317];	//[1,53]<<368
  LNt[790] -= LNt[791];
  LNt[792] = LNt[765]+d.y.v6*LNt[723]+d.y.v7*LNt[720]+LNt[791];
  LNt[793] = (float(LNP2x3[125]+LNt[792]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[1,53]<<391
  LNt[792] -= LNt[793];
  LNt[794] = LNt[766]+d.y.v6*LNt[726]+d.y.v7*LNt[723]+LNt[793];
  LNt[795] = (float(LNP2x3[125]+LNt[794]/LNP2[363])-LNP2x3[125])*LNP2[363];	//[1,53]<<414
  LNt[794] -= LNt[795];
  LNt[796] = LNt[767]+d.y.v6*LNt[729]+d.y.v7*LNt[726]+LNt[795];
  LNt[797] = (float(LNP2x3[125]+LNt[796]/LNP2[386])-LNP2x3[125])*LNP2[386];	//[1,53]<<437
  LNt[796] -= LNt[797];
  LNt[798] = LNt[768]+d.y.v6*LNt[732]+d.y.v7*LNt[729]+LNt[797];
  LNt[799] = (float(LNP2x3[125]+LNt[798]/LNP2[409])-LNP2x3[125])*LNP2[409];	//[1,53]<<460
  LNt[798] -= LNt[799];
  LNt[800] = LNt[769]+d.y.v6*LNt[735]+d.y.v7*LNt[732]+LNt[799];
  LNt[801] = (float(LNP2x3[125]+LNt[800]/LNP2[432])-LNP2x3[125])*LNP2[432];	//[1,53]<<483
  LNt[800] -= LNt[801];
  LNt[802] = LNt[23]*LNt[343]+LNt[25]*LNt[340]+LNt[27]*LNt[337]+d.y.v0*LNt[696]+d.y.v1*LNt[693]+d.y.v2*LNt[690];
  LNt[803] = LNt[23]*LNt[346]+LNt[25]*LNt[343]+LNt[27]*LNt[340]+LNt[29]*LNt[337]+d.y.v0*LNt[699]+d.y.v1*LNt[696]+d.y.v2*LNt[693]+d.y.v3*LNt[690];
  LNt[804] = LNt[401]+d.y.v0*LNt[702]+d.y.v1*LNt[699]+d.y.v2*LNt[696]+d.y.v3*LNt[693]+d.y.v4*LNt[690];
  LNt[805] = LNt[419]+LNt[35]*LNt[385]+LNt[400]*LNt[382]+LNt[451]+LNt[770]+d.y.v7*LNt[735]+LNt[801];
  LNt[806] = LNt[421]+d.y.v3*LNt[752]+d.y.v4*LNt[750]+d.y.v5*LNt[747]+d.y.v6*LNt[744]+d.y.v7*LNt[741];
  LNt[807] = LNt[31]*LNt[399]+LNt[33]*LNt[397]+LNt[35]*LNt[394]+LNt[400]*LNt[391]+d.y.v4*LNt[752]+d.y.v5*LNt[750]+d.y.v6*LNt[747]+d.y.v7*LNt[744];
  LNt[808] = LNt[33]*LNt[399]+LNt[35]*LNt[397]+LNt[400]*LNt[394]+d.y.v5*LNt[752]+d.y.v6*LNt[750]+d.y.v7*LNt[747];
  LNt[809] = LNt[403]+LNt[33]*LNt[340]+LNt[35]*LNt[337]+LNt[754]+d.y.v6*LNt[690];
  LNt[810] = (float(LNP2x3[125]+LNt[809]/LNP2[87])-LNP2x3[125])*LNP2[87];	//[1,53]<<138
  LNt[809] -= LNt[810];
  LNt[811] = LNt[422]+LNt[772]+LNt[810];
  LNt[812] = (float(LNP2x3[125]+LNt[811]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[811] -= LNt[812];
  LNt[813] = LNt[424]+LNt[774]+LNt[812];
  LNt[814] = (float(LNP2x3[125]+LNt[813]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[813] -= LNt[814];
  LNt[815] = LNt[426]+LNt[776]+LNt[814];
  LNt[816] = (float(LNP2x3[125]+LNt[815]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[815] -= LNt[816];
  LNt[817] = LNt[428]+LNt[778]+LNt[816];
  LNt[818] = (float(LNP2x3[125]+LNt[817]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[817] -= LNt[818];
  LNt[819] = LNt[430]+LNt[780]+LNt[818];
  LNt[820] = (float(LNP2x3[125]+LNt[819]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[819] -= LNt[820];
  LNt[821] = LNt[432]+LNt[782]+LNt[820];
  LNt[822] = (float(LNP2x3[125]+LNt[821]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[821] -= LNt[822];
  LNt[823] = LNt[434]+LNt[784]+LNt[822];
  LNt[824] = (float(LNP2x3[125]+LNt[823]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[823] -= LNt[824];
  LNt[825] = LNt[436]+LNt[786]+LNt[824];
  LNt[826] = (float(LNP2x3[125]+LNt[825]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[825] -= LNt[826];
  LNt[827] = LNt[438]+LNt[788]+LNt[826];
  LNt[828] = (float(LNP2x3[125]+LNt[827]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[827] -= LNt[828];
  LNt[829] = LNt[440]+LNt[790]+LNt[828];
  LNt[830] = (float(LNP2x3[125]+LNt[829]/LNP2[317])-LNP2x3[125])*LNP2[317];	//[1,53]<<368
  LNt[829] -= LNt[830];
  LNt[831] = LNt[442]+LNt[792]+LNt[830];
  LNt[832] = (float(LNP2x3[125]+LNt[831]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[1,53]<<391
  LNt[831] -= LNt[832];
  LNt[833] = LNt[444]+LNt[794]+LNt[832];
  LNt[834] = (float(LNP2x3[125]+LNt[833]/LNP2[363])-LNP2x3[125])*LNP2[363];	//[1,53]<<414
  LNt[833] -= LNt[834];
  LNt[835] = LNt[446]+LNt[796]+LNt[834];
  LNt[836] = (float(LNP2x3[125]+LNt[835]/LNP2[386])-LNP2x3[125])*LNP2[386];	//[1,53]<<437
  LNt[835] -= LNt[836];
  LNt[837] = LNt[448]+LNt[798]+LNt[836];
  LNt[838] = (float(LNP2x3[125]+LNt[837]/LNP2[409])-LNP2x3[125])*LNP2[409];	//[1,53]<<460
  LNt[837] -= LNt[838];
  LNt[839] = LNt[450]+LNt[800]+LNt[838];
  LNt[840] = (float(LNP2x3[125]+LNt[839]/LNP2[432])-LNP2x3[125])*LNP2[432];	//[1,53]<<483
  LNt[839] -= LNt[840];
  LNt[841] = LNt[805]+LNt[840];
  LNt[842] = (float(LNP2x3[125]+LNt[841]/LNP2[455])-LNP2x3[125])*LNP2[455];	//[1,53]<<506
  LNt[841] -= LNt[842];
  LNt[843] = c.x.v0*LNt[162]+c.x.v1*LNt[159]+c.x.v2*LNt[156]+c.x.v3*LNt[153]+c.x.v4*LNt[150]+c.x.v5*LNt[147];
  LNt[844] = c.x.v0*LNt[165]+c.x.v1*LNt[162]+c.x.v2*LNt[159]+c.x.v3*LNt[156]+c.x.v4*LNt[153]+c.x.v5*LNt[150];
  LNt[845] = c.x.v0*LNt[168]+c.x.v1*LNt[165]+c.x.v2*LNt[162]+c.x.v3*LNt[159]+c.x.v4*LNt[156]+c.x.v5*LNt[153];
  LNt[846] = c.x.v0*LNt[171]+c.x.v1*LNt[168]+c.x.v2*LNt[165]+c.x.v3*LNt[162]+c.x.v4*LNt[159]+c.x.v5*LNt[156];
  LNt[847] = c.x.v0*LNt[174]+c.x.v1*LNt[171]+c.x.v2*LNt[168]+c.x.v3*LNt[165]+c.x.v4*LNt[162]+c.x.v5*LNt[159];
  LNt[848] = c.x.v0*LNt[177]+c.x.v1*LNt[174]+c.x.v2*LNt[171]+c.x.v3*LNt[168]+c.x.v4*LNt[165]+c.x.v5*LNt[162];
  LNt[849] = c.x.v0*LNt[180]+c.x.v1*LNt[177]+c.x.v2*LNt[174]+c.x.v3*LNt[171]+c.x.v4*LNt[168]+c.x.v5*LNt[165];
  LNt[850] = c.x.v0*LNt[183]+c.x.v1*LNt[180]+c.x.v2*LNt[177]+c.x.v3*LNt[174]+c.x.v4*LNt[171]+c.x.v5*LNt[168];
  LNt[851] = c.x.v0*LNt[186]+c.x.v1*LNt[183]+c.x.v2*LNt[180]+c.x.v3*LNt[177]+c.x.v4*LNt[174]+c.x.v5*LNt[171];
  LNt[852] = c.x.v0*LNt[188]+c.x.v1*LNt[186]+c.x.v2*LNt[183]+c.x.v3*LNt[180]+c.x.v4*LNt[177]+c.x.v5*LNt[174];
  LNt[853] = c.x.v1*LNt[188]+c.x.v2*LNt[186]+c.x.v3*LNt[183]+c.x.v4*LNt[180]+c.x.v5*LNt[177]+c.x.v6*LNt[174];
  LNt[854] = c.x.v2*LNt[188]+c.x.v3*LNt[186]+c.x.v4*LNt[183]+c.x.v5*LNt[180]+c.x.v6*LNt[177]+c.x.v7*LNt[174];
  LNt[855] = LNt[845]+c.x.v6*LNt[150]+c.x.v7*LNt[147];
  LNt[856] = (float(LNP2x3[125]+LNt[855]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[855] -= LNt[856];
  LNt[857] = LNt[846]+c.x.v6*LNt[153]+c.x.v7*LNt[150]+LNt[856];
  LNt[858] = (float(LNP2x3[125]+LNt[857]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[857] -= LNt[858];
  LNt[859] = LNt[847]+c.x.v6*LNt[156]+c.x.v7*LNt[153]+LNt[858];
  LNt[860] = (float(LNP2x3[125]+LNt[859]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[859] -= LNt[860];
  LNt[861] = LNt[848]+c.x.v6*LNt[159]+c.x.v7*LNt[156]+LNt[860];
  LNt[862] = (float(LNP2x3[125]+LNt[861]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[861] -= LNt[862];
  LNt[863] = LNt[849]+c.x.v6*LNt[162]+c.x.v7*LNt[159]+LNt[862];
  LNt[864] = (float(LNP2x3[125]+LNt[863]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[863] -= LNt[864];
  LNt[865] = LNt[850]+c.x.v6*LNt[165]+c.x.v7*LNt[162]+LNt[864];
  LNt[866] = (float(LNP2x3[125]+LNt[865]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[865] -= LNt[866];
  LNt[867] = LNt[851]+c.x.v6*LNt[168]+c.x.v7*LNt[165]+LNt[866];
  LNt[868] = (float(LNP2x3[125]+LNt[867]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[867] -= LNt[868];
  LNt[869] = LNt[852]+c.x.v6*LNt[171]+c.x.v7*LNt[168]+LNt[868];
  LNt[870] = (float(LNP2x3[125]+LNt[869]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[869] -= LNt[870];
  LNt[871] = c.y.v0*LNt[515]+c.y.v1*LNt[512]+c.y.v2*LNt[509]+c.y.v3*LNt[506]+c.y.v4*LNt[503]+c.y.v5*LNt[500];
  LNt[872] = c.y.v0*LNt[518]+c.y.v1*LNt[515]+c.y.v2*LNt[512]+c.y.v3*LNt[509]+c.y.v4*LNt[506]+c.y.v5*LNt[503];
  LNt[873] = c.y.v0*LNt[521]+c.y.v1*LNt[518]+c.y.v2*LNt[515]+c.y.v3*LNt[512]+c.y.v4*LNt[509]+c.y.v5*LNt[506];
  LNt[874] = c.y.v0*LNt[524]+c.y.v1*LNt[521]+c.y.v2*LNt[518]+c.y.v3*LNt[515]+c.y.v4*LNt[512]+c.y.v5*LNt[509];
  LNt[875] = c.y.v0*LNt[527]+c.y.v1*LNt[524]+c.y.v2*LNt[521]+c.y.v3*LNt[518]+c.y.v4*LNt[515]+c.y.v5*LNt[512];
  LNt[876] = c.y.v0*LNt[530]+c.y.v1*LNt[527]+c.y.v2*LNt[524]+c.y.v3*LNt[521]+c.y.v4*LNt[518]+c.y.v5*LNt[515];
  LNt[877] = c.y.v0*LNt[533]+c.y.v1*LNt[530]+c.y.v2*LNt[527]+c.y.v3*LNt[524]+c.y.v4*LNt[521]+c.y.v5*LNt[518];
  LNt[878] = c.y.v0*LNt[536]+c.y.v1*LNt[533]+c.y.v2*LNt[530]+c.y.v3*LNt[527]+c.y.v4*LNt[524]+c.y.v5*LNt[521];
  LNt[879] = c.y.v0*LNt[539]+c.y.v1*LNt[536]+c.y.v2*LNt[533]+c.y.v3*LNt[530]+c.y.v4*LNt[527]+c.y.v5*LNt[524];
  LNt[880] = c.y.v0*LNt[541]+c.y.v1*LNt[539]+c.y.v2*LNt[536]+c.y.v3*LNt[533]+c.y.v4*LNt[530]+c.y.v5*LNt[527];
  LNt[881] = c.y.v1*LNt[541]+c.y.v2*LNt[539]+c.y.v3*LNt[536]+c.y.v4*LNt[533]+c.y.v5*LNt[530]+c.y.v6*LNt[527];
  LNt[882] = c.y.v2*LNt[541]+c.y.v3*LNt[539]+c.y.v4*LNt[536]+c.y.v5*LNt[533]+c.y.v6*LNt[530]+c.y.v7*LNt[527];
  LNt[883] = LNt[873]+c.y.v6*LNt[503]+c.y.v7*LNt[500];
  LNt[884] = (float(LNP2x3[125]+LNt[883]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[883] -= LNt[884];
  LNt[885] = LNt[874]+c.y.v6*LNt[506]+c.y.v7*LNt[503]+LNt[884];
  LNt[886] = (float(LNP2x3[125]+LNt[885]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[885] -= LNt[886];
  LNt[887] = LNt[875]+c.y.v6*LNt[509]+c.y.v7*LNt[506]+LNt[886];
  LNt[888] = (float(LNP2x3[125]+LNt[887]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[887] -= LNt[888];
  LNt[889] = LNt[876]+c.y.v6*LNt[512]+c.y.v7*LNt[509]+LNt[888];
  LNt[890] = (float(LNP2x3[125]+LNt[889]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[889] -= LNt[890];
  LNt[891] = LNt[877]+c.y.v6*LNt[515]+c.y.v7*LNt[512]+LNt[890];
  LNt[892] = (float(LNP2x3[125]+LNt[891]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[891] -= LNt[892];
  LNt[893] = LNt[878]+c.y.v6*LNt[518]+c.y.v7*LNt[515]+LNt[892];
  LNt[894] = (float(LNP2x3[125]+LNt[893]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[893] -= LNt[894];
  LNt[895] = LNt[879]+c.y.v6*LNt[521]+c.y.v7*LNt[518]+LNt[894];
  LNt[896] = (float(LNP2x3[125]+LNt[895]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[895] -= LNt[896];
  LNt[897] = LNt[880]+c.y.v6*LNt[524]+c.y.v7*LNt[521]+LNt[896];
  LNt[898] = (float(LNP2x3[125]+LNt[897]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[897] -= LNt[898];
  LNt[899] = c.x.v0*LNt[153]+c.x.v1*LNt[150]+c.x.v2*LNt[147]-(c.y.v0*LNt[506]+c.y.v1*LNt[503]+c.y.v2*LNt[500]);
  LNt[900] = c.x.v0*LNt[156]+c.x.v1*LNt[153]+c.x.v2*LNt[150]+c.x.v3*LNt[147]-(c.y.v0*LNt[509]+c.y.v1*LNt[506]+c.y.v2*LNt[503]+c.y.v3*LNt[500]);
  LNt[901] = c.x.v0*LNt[159]+c.x.v1*LNt[156]+c.x.v2*LNt[153]+c.x.v3*LNt[150]+c.x.v4*LNt[147]-(c.y.v0*LNt[512]+c.y.v1*LNt[509]+c.y.v2*LNt[506]+c.y.v3*LNt[503]+c.y.v4*LNt[500]);
  LNt[902] = c.x.v3*LNt[188]+c.x.v4*LNt[186]+c.x.v5*LNt[183]+c.x.v6*LNt[180]+c.x.v7*LNt[177]-(c.y.v3*LNt[541]+c.y.v4*LNt[539]+c.y.v5*LNt[536]+c.y.v6*LNt[533]+c.y.v7*LNt[530]);
  LNt[903] = c.x.v4*LNt[188]+c.x.v5*LNt[186]+c.x.v6*LNt[183]+c.x.v7*LNt[180]-(c.y.v4*LNt[541]+c.y.v5*LNt[539]+c.y.v6*LNt[536]+c.y.v7*LNt[533]);
  LNt[904] = c.x.v5*LNt[188]+c.x.v6*LNt[186]+c.x.v7*LNt[183]-(c.y.v5*LNt[541]+c.y.v6*LNt[539]+c.y.v7*LNt[536]);
  LNt[905] = LNt[844]+c.x.v6*LNt[147]-(LNt[872]+c.y.v6*LNt[500]);
  LNt[906] = (float(LNP2x3[125]+LNt[905]/LNP2[87])-LNP2x3[125])*LNP2[87];	//[1,53]<<138
  LNt[905] -= LNt[906];
  LNt[907] = LNt[855]-LNt[883]+LNt[906];
  LNt[908] = (float(LNP2x3[125]+LNt[907]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[907] -= LNt[908];
  LNt[909] = LNt[857]-LNt[885]+LNt[908];
  LNt[910] = (float(LNP2x3[125]+LNt[909]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[909] -= LNt[910];
  LNt[911] = LNt[859]-LNt[887]+LNt[910];
  LNt[912] = (float(LNP2x3[125]+LNt[911]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[911] -= LNt[912];
  LNt[913] = LNt[861]-LNt[889]+LNt[912];
  LNt[914] = (float(LNP2x3[125]+LNt[913]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[913] -= LNt[914];
  LNt[915] = LNt[863]-LNt[891]+LNt[914];
  LNt[916] = (float(LNP2x3[125]+LNt[915]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[915] -= LNt[916];
  LNt[917] = LNt[865]-LNt[893]+LNt[916];
  LNt[918] = (float(LNP2x3[125]+LNt[917]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[917] -= LNt[918];
  LNt[919] = LNt[867]-LNt[895]+LNt[918];
  LNt[920] = (float(LNP2x3[125]+LNt[919]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[919] -= LNt[920];
  LNt[921] = LNt[869]-LNt[897]+LNt[920];
  LNt[922] = (float(LNP2x3[125]+LNt[921]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[921] -= LNt[922];
  LNt[923] = LNt[853]+c.x.v7*LNt[171]+LNt[870]-(LNt[881]+c.y.v7*LNt[524]+LNt[898])+LNt[922];
  LNt[924] = (float(LNP2x3[125]+LNt[923]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[923] -= LNt[924];
  LNt[925] = a.x.v0*b.y.v5+a.x.v1*b.y.v4+a.x.v2*b.y.v3+a.x.v3*b.y.v2+a.x.v4*b.y.v1+a.x.v5*b.y.v0;
  LNt[926] = a.x.v0*b.y.v6+a.x.v1*b.y.v5+a.x.v2*b.y.v4+a.x.v3*b.y.v3+a.x.v4*b.y.v2+a.x.v5*b.y.v1;
  LNt[927] = a.x.v0*b.y.v7+a.x.v1*b.y.v6+a.x.v2*b.y.v5+a.x.v3*b.y.v4+a.x.v4*b.y.v3+a.x.v5*b.y.v2;
  LNt[928] = a.x.v1*b.y.v7+a.x.v2*b.y.v6+a.x.v3*b.y.v5+a.x.v4*b.y.v4+a.x.v5*b.y.v3+a.x.v6*b.y.v2;
  LNt[929] = a.x.v2*b.y.v7+a.x.v3*b.y.v6+a.x.v4*b.y.v5+a.x.v5*b.y.v4+a.x.v6*b.y.v3+a.x.v7*b.y.v2;
  LNt[930] = LNt[927]+a.x.v6*b.y.v1+a.x.v7*b.y.v0;
  LNt[931] = (float(LNP2x3[125]+LNt[930]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[930] -= LNt[931];
  LNt[932] = a.y.v0*b.x.v5+a.y.v1*b.x.v4+a.y.v2*b.x.v3+a.y.v3*b.x.v2+a.y.v4*b.x.v1+a.y.v5*b.x.v0;
  LNt[933] = a.y.v0*b.x.v6+a.y.v1*b.x.v5+a.y.v2*b.x.v4+a.y.v3*b.x.v3+a.y.v4*b.x.v2+a.y.v5*b.x.v1;
  LNt[934] = a.y.v0*b.x.v7+a.y.v1*b.x.v6+a.y.v2*b.x.v5+a.y.v3*b.x.v4+a.y.v4*b.x.v3+a.y.v5*b.x.v2;
  LNt[935] = a.y.v1*b.x.v7+a.y.v2*b.x.v6+a.y.v3*b.x.v5+a.y.v4*b.x.v4+a.y.v5*b.x.v3+a.y.v6*b.x.v2;
  LNt[936] = a.y.v2*b.x.v7+a.y.v3*b.x.v6+a.y.v4*b.x.v5+a.y.v5*b.x.v4+a.y.v6*b.x.v3+a.y.v7*b.x.v2;
  LNt[937] = LNt[934]+a.y.v6*b.x.v1+a.y.v7*b.x.v0;
  LNt[938] = (float(LNP2x3[125]+LNt[937]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[937] -= LNt[938];
  LNt[939] = a.x.v0*b.y.v2+a.x.v1*b.y.v1+a.x.v2*b.y.v0-(a.y.v0*b.x.v2+a.y.v1*b.x.v1+a.y.v2*b.x.v0);
  LNt[940] = a.x.v0*b.y.v3+a.x.v1*b.y.v2+a.x.v2*b.y.v1+a.x.v3*b.y.v0-(a.y.v0*b.x.v3+a.y.v1*b.x.v2+a.y.v2*b.x.v1+a.y.v3*b.x.v0);
  LNt[941] = a.x.v0*b.y.v4+a.x.v1*b.y.v3+a.x.v2*b.y.v2+a.x.v3*b.y.v1+a.x.v4*b.y.v0-(a.y.v0*b.x.v4+a.y.v1*b.x.v3+a.y.v2*b.x.v2+a.y.v3*b.x.v1+a.y.v4*b.x.v0);
  LNt[942] = a.x.v3*b.y.v7+a.x.v4*b.y.v6+a.x.v5*b.y.v5+a.x.v6*b.y.v4+a.x.v7*b.y.v3-(a.y.v3*b.x.v7+a.y.v4*b.x.v6+a.y.v5*b.x.v5+a.y.v6*b.x.v4+a.y.v7*b.x.v3);
  LNt[943] = a.x.v4*b.y.v7+a.x.v5*b.y.v6+a.x.v6*b.y.v5+a.x.v7*b.y.v4-(a.y.v4*b.x.v7+a.y.v5*b.x.v6+a.y.v6*b.x.v5+a.y.v7*b.x.v4);
  LNt[944] = a.x.v5*b.y.v7+a.x.v6*b.y.v6+a.x.v7*b.y.v5-(a.y.v5*b.x.v7+a.y.v6*b.x.v6+a.y.v7*b.x.v5);
  LNt[945] = a.x.v0*b.y.v0-a.y.v0*b.x.v0;
  LNt[946] = float(LNP2x3[47]+LNt[945])-LNP2x3[47];	//[22,47]<<0
  LNt[945] -= LNt[946];
  LNt[947] = float(LNP2x3[45]+LNt[945])-LNP2x3[45];	//[2,25]<<0
  LNt[945] -= LNt[947];
  LNt[948] = a.x.v0*b.y.v1+a.x.v1*b.y.v0-(a.y.v0*b.x.v1+a.y.v1*b.x.v0)+LNt[946]+LNt[947];
  LNt[949] = float(LNP2x3[71]+LNt[948])-LNP2x3[71];	//[22,48]<<23
  LNt[948] -= LNt[949];
  LNt[950] = float(LNP2x3[68]+LNt[948])-LNP2x3[68];	//[3,26]<<23
  LNt[948] -= LNt[950];
  LNt[951] = LNt[939]+LNt[949]+LNt[950];
  LNt[952] = float(LNP2x3[95]+LNt[951])-LNP2x3[95];	//[22,49]<<46
  LNt[951] -= LNt[952];
  LNt[953] = float(LNP2x3[91]+LNt[951])-LNP2x3[91];	//[4,27]<<46
  LNt[951] -= LNt[953];
  LNt[954] = LNt[940]+LNt[952]+LNt[953];
  LNt[955] = float(LNP2x3[119]+LNt[954])-LNP2x3[119];	//[22,50]<<69
  LNt[954] -= LNt[955];
  LNt[956] = float(LNP2x3[114]+LNt[954])-LNP2x3[114];	//[5,28]<<69
  LNt[954] -= LNt[956];
  LNt[957] = LNt[941]+LNt[955]+LNt[956];
  LNt[958] = (float(LNP2x3[125]+LNt[957]/LNP2[18])-LNP2x3[125])*LNP2[18];	//[22,51]<<92
  LNt[957] -= LNt[958];
  LNt[959] = (float(LNP2x3[125]+LNt[957]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[6,29]<<92
  LNt[957] -= LNt[959];
  LNt[960] = LNt[925]-LNt[932]+LNt[958]+LNt[959];
  LNt[961] = (float(LNP2x3[125]+LNt[960]/LNP2[42])-LNP2x3[125])*LNP2[42];	//[22,52]<<115
  LNt[960] -= LNt[961];
  LNt[962] = (float(LNP2x3[125]+LNt[960]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[7,30]<<115
  LNt[960] -= LNt[962];
  LNt[963] = LNt[926]+a.x.v6*b.y.v0-(LNt[933]+a.y.v6*b.x.v0)+LNt[961]+LNt[962];
  LNt[964] = (float(LNP2x3[125]+LNt[963]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[963] -= LNt[964];
  LNt[965] = (float(LNP2x3[125]+LNt[963]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[963] -= LNt[965];
  LNt[966] = LNt[930]-LNt[937]+LNt[964]+LNt[965];
  LNt[967] = (float(LNP2x3[125]+LNt[966]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[966] -= LNt[967];
  LNt[968] = (float(LNP2x3[125]+LNt[966]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[966] -= LNt[968];
  LNt[969] = LNt[928]+a.x.v7*b.y.v1+LNt[931]-(LNt[935]+a.y.v7*b.x.v1+LNt[938])+LNt[967]+LNt[968];
  LNt[970] = (float(LNP2x3[125]+LNt[969]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[969] -= LNt[970];
  LNt[971] = (float(LNP2x3[125]+LNt[969]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[969] -= LNt[971];
  LNt[972] = LNt[929]-LNt[936]+LNt[970]+LNt[971];
  LNt[973] = (float(LNP2x3[125]+LNt[972]/LNP2[134])-LNP2x3[125])*LNP2[134];	//[22,52]<<207
  LNt[972] -= LNt[973];
  LNt[974] = (float(LNP2x3[125]+LNt[972]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[7,30]<<207
  LNt[972] -= LNt[974];
  LNt[975] = LNt[942]+LNt[973]+LNt[974];
  LNt[976] = (float(LNP2x3[125]+LNt[975]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[22,51]<<230
  LNt[975] -= LNt[976];
  LNt[977] = (float(LNP2x3[125]+LNt[975]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[6,29]<<230
  LNt[975] -= LNt[977];
  LNt[978] = LNt[943]+LNt[976]+LNt[977];
  LNt[979] = (float(LNP2x3[125]+LNt[978]/LNP2[178])-LNP2x3[125])*LNP2[178];	//[22,50]<<253
  LNt[978] -= LNt[979];
  LNt[980] = (float(LNP2x3[125]+LNt[978]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[5,28]<<253
  LNt[978] -= LNt[980];
  LNt[981] = LNt[944]+LNt[979]+LNt[980];
  LNt[982] = (float(LNP2x3[125]+LNt[981]/LNP2[200])-LNP2x3[125])*LNP2[200];	//[22,49]<<276
  LNt[981] -= LNt[982];
  LNt[983] = (float(LNP2x3[125]+LNt[981]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[4,27]<<276
  LNt[981] -= LNt[983];
  LNt[984] = a.x.v6*b.y.v7+a.x.v7*b.y.v6-(a.y.v6*b.x.v7+a.y.v7*b.x.v6)+LNt[982]+LNt[983];
  LNt[985] = (float(LNP2x3[125]+LNt[984]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[4,27]<<299
  LNt[984] -= LNt[985];
  LNt[986] = a.x.v7*b.y.v7-a.y.v7*b.x.v7+LNt[985];
  LNt[987] = c.w.v0*LNt[960]+c.w.v1*LNt[957]+c.w.v2*LNt[954]+c.w.v3*LNt[951]+c.w.v4*LNt[948]+c.w.v5*LNt[945];
  LNt[988] = c.w.v0*LNt[963]+c.w.v1*LNt[960]+c.w.v2*LNt[957]+c.w.v3*LNt[954]+c.w.v4*LNt[951]+c.w.v5*LNt[948];
  LNt[989] = c.w.v0*LNt[966]+c.w.v1*LNt[963]+c.w.v2*LNt[960]+c.w.v3*LNt[957]+c.w.v4*LNt[954]+c.w.v5*LNt[951];
  LNt[990] = c.w.v0*LNt[969]+c.w.v1*LNt[966]+c.w.v2*LNt[963]+c.w.v3*LNt[960]+c.w.v4*LNt[957]+c.w.v5*LNt[954];
  LNt[991] = c.w.v0*LNt[972]+c.w.v1*LNt[969]+c.w.v2*LNt[966]+c.w.v3*LNt[963]+c.w.v4*LNt[960]+c.w.v5*LNt[957];
  LNt[992] = c.w.v0*LNt[975]+c.w.v1*LNt[972]+c.w.v2*LNt[969]+c.w.v3*LNt[966]+c.w.v4*LNt[963]+c.w.v5*LNt[960];
  LNt[993] = c.w.v0*LNt[978]+c.w.v1*LNt[975]+c.w.v2*LNt[972]+c.w.v3*LNt[969]+c.w.v4*LNt[966]+c.w.v5*LNt[963];
  LNt[994] = c.w.v0*LNt[981]+c.w.v1*LNt[978]+c.w.v2*LNt[975]+c.w.v3*LNt[972]+c.w.v4*LNt[969]+c.w.v5*LNt[966];
  LNt[995] = c.w.v0*LNt[984]+c.w.v1*LNt[981]+c.w.v2*LNt[978]+c.w.v3*LNt[975]+c.w.v4*LNt[972]+c.w.v5*LNt[969];
  LNt[996] = c.w.v0*LNt[986]+c.w.v1*LNt[984]+c.w.v2*LNt[981]+c.w.v3*LNt[978]+c.w.v4*LNt[975]+c.w.v5*LNt[972];
  LNt[997] = c.w.v1*LNt[986]+c.w.v2*LNt[984]+c.w.v3*LNt[981]+c.w.v4*LNt[978]+c.w.v5*LNt[975]+c.w.v6*LNt[972];
  LNt[998] = c.w.v2*LNt[986]+c.w.v3*LNt[984]+c.w.v4*LNt[981]+c.w.v5*LNt[978]+c.w.v6*LNt[975]+c.w.v7*LNt[972];
  LNt[999] = LNt[989]+c.w.v6*LNt[948]+c.w.v7*LNt[945];
  LNt[1000] = (float(LNP2x3[125]+LNt[999]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[999] -= LNt[1000];
  LNt[1001] = LNt[990]+c.w.v6*LNt[951]+c.w.v7*LNt[948]+LNt[1000];
  LNt[1002] = (float(LNP2x3[125]+LNt[1001]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1001] -= LNt[1002];
  LNt[1003] = LNt[991]+c.w.v6*LNt[954]+c.w.v7*LNt[951]+LNt[1002];
  LNt[1004] = (float(LNP2x3[125]+LNt[1003]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1003] -= LNt[1004];
  LNt[1005] = LNt[992]+c.w.v6*LNt[957]+c.w.v7*LNt[954]+LNt[1004];
  LNt[1006] = (float(LNP2x3[125]+LNt[1005]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1005] -= LNt[1006];
  LNt[1007] = LNt[993]+c.w.v6*LNt[960]+c.w.v7*LNt[957]+LNt[1006];
  LNt[1008] = (float(LNP2x3[125]+LNt[1007]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1007] -= LNt[1008];
  LNt[1009] = LNt[994]+c.w.v6*LNt[963]+c.w.v7*LNt[960]+LNt[1008];
  LNt[1010] = (float(LNP2x3[125]+LNt[1009]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1009] -= LNt[1010];
  LNt[1011] = LNt[995]+c.w.v6*LNt[966]+c.w.v7*LNt[963]+LNt[1010];
  LNt[1012] = (float(LNP2x3[125]+LNt[1011]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1011] -= LNt[1012];
  LNt[1013] = LNt[996]+c.w.v6*LNt[969]+c.w.v7*LNt[966]+LNt[1012];
  LNt[1014] = (float(LNP2x3[125]+LNt[1013]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1013] -= LNt[1014];
  LNt[1015] = c.x.v0*LNt[150]+c.x.v1*LNt[147]-(c.y.v0*LNt[503]+c.y.v1*LNt[500])+c.w.v0*LNt[948]+c.w.v1*LNt[945];
  LNt[1016] = LNt[901]+c.w.v0*LNt[957]+c.w.v1*LNt[954]+c.w.v2*LNt[951]+c.w.v3*LNt[948]+c.w.v4*LNt[945];
  LNt[1017] = LNt[902]+c.w.v3*LNt[986]+c.w.v4*LNt[984]+c.w.v5*LNt[981]+c.w.v6*LNt[978]+c.w.v7*LNt[975];
  LNt[1018] = c.x.v6*LNt[188]+c.x.v7*LNt[186]-(c.y.v6*LNt[541]+c.y.v7*LNt[539])+c.w.v6*LNt[986]+c.w.v7*LNt[984];
  LNt[1019] = c.x.v0*LNt[147]-c.y.v0*LNt[500]+c.w.v0*LNt[945];
  LNt[1020] = float(LNP2x3[48]+LNt[1019])-LNP2x3[48];	//[22,48]<<0
  LNt[1019] -= LNt[1020];
  LNt[1021] = float(LNP2x3[45]+LNt[1019])-LNP2x3[45];	//[3,26]<<0
  LNt[1019] -= LNt[1021];
  LNt[1022] = LNt[1015]+LNt[1020]+LNt[1021];
  LNt[1023] = float(LNP2x3[72]+LNt[1022])-LNP2x3[72];	//[22,49]<<23
  LNt[1022] -= LNt[1023];
  LNt[1024] = float(LNP2x3[68]+LNt[1022])-LNP2x3[68];	//[4,27]<<23
  LNt[1022] -= LNt[1024];
  LNt[1025] = LNt[899]+c.w.v0*LNt[951]+c.w.v1*LNt[948]+c.w.v2*LNt[945]+LNt[1023]+LNt[1024];
  LNt[1026] = float(LNP2x3[96]+LNt[1025])-LNP2x3[96];	//[22,50]<<46
  LNt[1025] -= LNt[1026];
  LNt[1027] = float(LNP2x3[91]+LNt[1025])-LNP2x3[91];	//[5,28]<<46
  LNt[1025] -= LNt[1027];
  LNt[1028] = LNt[900]+c.w.v0*LNt[954]+c.w.v1*LNt[951]+c.w.v2*LNt[948]+c.w.v3*LNt[945]+LNt[1026]+LNt[1027];
  LNt[1029] = float(LNP2x3[120]+LNt[1028])-LNP2x3[120];	//[22,51]<<69
  LNt[1028] -= LNt[1029];
  LNt[1030] = float(LNP2x3[114]+LNt[1028])-LNP2x3[114];	//[6,29]<<69
  LNt[1028] -= LNt[1030];
  LNt[1031] = LNt[1016]+LNt[1029]+LNt[1030];
  LNt[1032] = (float(LNP2x3[125]+LNt[1031]/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
  LNt[1031] -= LNt[1032];
  LNt[1033] = (float(LNP2x3[125]+LNt[1031]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
  LNt[1031] -= LNt[1033];
  LNt[1034] = LNt[843]-LNt[871]+LNt[987]+LNt[1032]+LNt[1033];
  LNt[1035] = (float(LNP2x3[125]+LNt[1034]/LNP2[43])-LNP2x3[125])*LNP2[43];	//[22,53]<<115
  LNt[1034] -= LNt[1035];
  LNt[1036] = (float(LNP2x3[125]+LNt[1034]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[8,31]<<115
  LNt[1034] -= LNt[1036];
  LNt[1037] = LNt[905]+LNt[988]+c.w.v6*LNt[945]+LNt[1035]+LNt[1036];
  LNt[1038] = (float(LNP2x3[125]+LNt[1037]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[1037] -= LNt[1038];
  LNt[1039] = (float(LNP2x3[125]+LNt[1037]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[1037] -= LNt[1039];
  LNt[1040] = LNt[907]+LNt[999]+LNt[1038]+LNt[1039];
  LNt[1041] = (float(LNP2x3[125]+LNt[1040]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[1040] -= LNt[1041];
  LNt[1042] = (float(LNP2x3[125]+LNt[1040]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[1040] -= LNt[1042];
  LNt[1043] = LNt[909]+LNt[1001]+LNt[1041]+LNt[1042];
  LNt[1044] = (float(LNP2x3[125]+LNt[1043]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[1043] -= LNt[1044];
  LNt[1045] = (float(LNP2x3[125]+LNt[1043]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[1043] -= LNt[1045];
  LNt[1046] = LNt[911]+LNt[1003]+LNt[1044]+LNt[1045];
  LNt[1047] = (float(LNP2x3[125]+LNt[1046]/LNP2[135])-LNP2x3[125])*LNP2[135];	//[22,53]<<207
  LNt[1046] -= LNt[1047];
  LNt[1048] = (float(LNP2x3[125]+LNt[1046]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[8,31]<<207
  LNt[1046] -= LNt[1048];
  LNt[1049] = LNt[913]+LNt[1005]+LNt[1047]+LNt[1048];
  LNt[1050] = (float(LNP2x3[125]+LNt[1049]/LNP2[158])-LNP2x3[125])*LNP2[158];	//[22,53]<<230
  LNt[1049] -= LNt[1050];
  LNt[1051] = (float(LNP2x3[125]+LNt[1049]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[8,31]<<230
  LNt[1049] -= LNt[1051];
  LNt[1052] = LNt[915]+LNt[1007]+LNt[1050]+LNt[1051];
  LNt[1053] = (float(LNP2x3[125]+LNt[1052]/LNP2[181])-LNP2x3[125])*LNP2[181];	//[22,53]<<253
  LNt[1052] -= LNt[1053];
  LNt[1054] = (float(LNP2x3[125]+LNt[1052]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[8,31]<<253
  LNt[1052] -= LNt[1054];
  LNt[1055] = LNt[917]+LNt[1009]+LNt[1053]+LNt[1054];
  LNt[1056] = (float(LNP2x3[125]+LNt[1055]/LNP2[204])-LNP2x3[125])*LNP2[204];	//[22,53]<<276
  LNt[1055] -= LNt[1056];
  LNt[1057] = (float(LNP2x3[125]+LNt[1055]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[8,31]<<276
  LNt[1055] -= LNt[1057];
  LNt[1058] = LNt[919]+LNt[1011]+LNt[1056]+LNt[1057];
  LNt[1059] = (float(LNP2x3[125]+LNt[1058]/LNP2[227])-LNP2x3[125])*LNP2[227];	//[22,53]<<299
  LNt[1058] -= LNt[1059];
  LNt[1060] = (float(LNP2x3[125]+LNt[1058]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[8,31]<<299
  LNt[1058] -= LNt[1060];
  LNt[1061] = LNt[921]+LNt[1013]+LNt[1059]+LNt[1060];
  LNt[1062] = (float(LNP2x3[125]+LNt[1061]/LNP2[250])-LNP2x3[125])*LNP2[250];	//[22,53]<<322
  LNt[1061] -= LNt[1062];
  LNt[1063] = (float(LNP2x3[125]+LNt[1061]/LNP2[242])-LNP2x3[125])*LNP2[242];	//[8,31]<<322
  LNt[1061] -= LNt[1063];
  LNt[1064] = LNt[923]+LNt[997]+c.w.v7*LNt[969]+LNt[1014]+LNt[1062]+LNt[1063];
  LNt[1065] = (float(LNP2x3[125]+LNt[1064]/LNP2[273])-LNP2x3[125])*LNP2[273];	//[22,53]<<345
  LNt[1064] -= LNt[1065];
  LNt[1066] = (float(LNP2x3[125]+LNt[1064]/LNP2[265])-LNP2x3[125])*LNP2[265];	//[8,31]<<345
  LNt[1064] -= LNt[1066];
  LNt[1067] = LNt[854]-LNt[882]+LNt[924]+LNt[998]+LNt[1065]+LNt[1066];
  LNt[1068] = (float(LNP2x3[125]+LNt[1067]/LNP2[296])-LNP2x3[125])*LNP2[296];	//[22,53]<<368
  LNt[1067] -= LNt[1068];
  LNt[1069] = (float(LNP2x3[125]+LNt[1067]/LNP2[288])-LNP2x3[125])*LNP2[288];	//[8,31]<<368
  LNt[1067] -= LNt[1069];
  LNt[1070] = LNt[1017]+LNt[1068]+LNt[1069];
  LNt[1071] = (float(LNP2x3[125]+LNt[1070]/LNP2[318])-LNP2x3[125])*LNP2[318];	//[22,52]<<391
  LNt[1070] -= LNt[1071];
  LNt[1072] = (float(LNP2x3[125]+LNt[1070]/LNP2[311])-LNP2x3[125])*LNP2[311];	//[7,30]<<391
  LNt[1070] -= LNt[1072];
  LNt[1073] = LNt[903]+c.w.v4*LNt[986]+c.w.v5*LNt[984]+c.w.v6*LNt[981]+c.w.v7*LNt[978]+LNt[1071]+LNt[1072];
  LNt[1074] = (float(LNP2x3[125]+LNt[1073]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[22,51]<<414
  LNt[1073] -= LNt[1074];
  LNt[1075] = (float(LNP2x3[125]+LNt[1073]/LNP2[334])-LNP2x3[125])*LNP2[334];	//[6,29]<<414
  LNt[1073] -= LNt[1075];
  LNt[1076] = LNt[904]+c.w.v5*LNt[986]+c.w.v6*LNt[984]+c.w.v7*LNt[981]+LNt[1074]+LNt[1075];
  LNt[1077] = (float(LNP2x3[125]+LNt[1076]/LNP2[362])-LNP2x3[125])*LNP2[362];	//[22,50]<<437
  LNt[1076] -= LNt[1077];
  LNt[1078] = (float(LNP2x3[125]+LNt[1076]/LNP2[357])-LNP2x3[125])*LNP2[357];	//[5,28]<<437
  LNt[1076] -= LNt[1078];
  LNt[1079] = LNt[1018]+LNt[1077]+LNt[1078];
  LNt[1080] = (float(LNP2x3[125]+LNt[1079]/LNP2[380])-LNP2x3[125])*LNP2[380];	//[7,30]<<460
  LNt[1079] -= LNt[1080];
  LNt[1081] = c.x.v7*LNt[188]-c.y.v7*LNt[541]+c.w.v7*LNt[986]+LNt[1080];
  LNt[1082] = d.z.v0*LNt[1031]+d.z.v1*LNt[1028]+d.z.v2*LNt[1025]+d.z.v3*LNt[1022]+d.z.v4*LNt[1019];
  LNt[1083] = d.z.v0*LNt[1034]+d.z.v1*LNt[1031]+d.z.v2*LNt[1028]+d.z.v3*LNt[1025]+d.z.v4*LNt[1022];
  LNt[1084] = d.z.v0*LNt[1037]+d.z.v1*LNt[1034]+d.z.v2*LNt[1031]+d.z.v3*LNt[1028]+d.z.v4*LNt[1025];
  LNt[1085] = d.z.v0*LNt[1040]+d.z.v1*LNt[1037]+d.z.v2*LNt[1034]+d.z.v3*LNt[1031]+d.z.v4*LNt[1028];
  LNt[1086] = d.z.v0*LNt[1043]+d.z.v1*LNt[1040]+d.z.v2*LNt[1037]+d.z.v3*LNt[1034]+d.z.v4*LNt[1031];
  LNt[1087] = d.z.v0*LNt[1046]+d.z.v1*LNt[1043]+d.z.v2*LNt[1040]+d.z.v3*LNt[1037]+d.z.v4*LNt[1034];
  LNt[1088] = d.z.v0*LNt[1049]+d.z.v1*LNt[1046]+d.z.v2*LNt[1043]+d.z.v3*LNt[1040]+d.z.v4*LNt[1037];
  LNt[1089] = d.z.v0*LNt[1052]+d.z.v1*LNt[1049]+d.z.v2*LNt[1046]+d.z.v3*LNt[1043]+d.z.v4*LNt[1040];
  LNt[1090] = d.z.v0*LNt[1055]+d.z.v1*LNt[1052]+d.z.v2*LNt[1049]+d.z.v3*LNt[1046]+d.z.v4*LNt[1043];
  LNt[1091] = d.z.v0*LNt[1058]+d.z.v1*LNt[1055]+d.z.v2*LNt[1052]+d.z.v3*LNt[1049]+d.z.v4*LNt[1046];
  LNt[1092] = d.z.v0*LNt[1061]+d.z.v1*LNt[1058]+d.z.v2*LNt[1055]+d.z.v3*LNt[1052]+d.z.v4*LNt[1049];
  LNt[1093] = d.z.v0*LNt[1064]+d.z.v1*LNt[1061]+d.z.v2*LNt[1058]+d.z.v3*LNt[1055]+d.z.v4*LNt[1052];
  LNt[1094] = d.z.v0*LNt[1067]+d.z.v1*LNt[1064]+d.z.v2*LNt[1061]+d.z.v3*LNt[1058]+d.z.v4*LNt[1055];
  LNt[1095] = d.z.v0*LNt[1070]+d.z.v1*LNt[1067]+d.z.v2*LNt[1064]+d.z.v3*LNt[1061]+d.z.v4*LNt[1058];
  LNt[1096] = d.z.v0*LNt[1073]+d.z.v1*LNt[1070]+d.z.v2*LNt[1067]+d.z.v3*LNt[1064]+d.z.v4*LNt[1061];
  LNt[1097] = d.z.v0*LNt[1076]+d.z.v1*LNt[1073]+d.z.v2*LNt[1070]+d.z.v3*LNt[1067]+d.z.v4*LNt[1064];
  LNt[1098] = d.z.v0*LNt[1079]+d.z.v1*LNt[1076]+d.z.v2*LNt[1073]+d.z.v3*LNt[1070]+d.z.v4*LNt[1067];
  LNt[1099] = d.z.v0*LNt[1081]+d.z.v1*LNt[1079]+d.z.v2*LNt[1076]+d.z.v3*LNt[1073]+d.z.v4*LNt[1070];
  LNt[1100] = d.z.v1*LNt[1081]+d.z.v2*LNt[1079]+d.z.v3*LNt[1076]+d.z.v4*LNt[1073]+d.z.v5*LNt[1070];
  LNt[1101] = d.z.v2*LNt[1081]+d.z.v3*LNt[1079]+d.z.v4*LNt[1076]+d.z.v5*LNt[1073]+d.z.v6*LNt[1070];
  LNt[1102] = d.z.v3*LNt[1081]+d.z.v4*LNt[1079]+d.z.v5*LNt[1076]+d.z.v6*LNt[1073]+d.z.v7*LNt[1070];
  LNt[1103] = LNt[1085]+d.z.v5*LNt[1025]+d.z.v6*LNt[1022]+d.z.v7*LNt[1019];
  LNt[1104] = (float(LNP2x3[125]+LNt[1103]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[1103] -= LNt[1104];
  LNt[1105] = LNt[1086]+d.z.v5*LNt[1028]+d.z.v6*LNt[1025]+d.z.v7*LNt[1022]+LNt[1104];
  LNt[1106] = (float(LNP2x3[125]+LNt[1105]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1105] -= LNt[1106];
  LNt[1107] = LNt[1087]+d.z.v5*LNt[1031]+d.z.v6*LNt[1028]+d.z.v7*LNt[1025]+LNt[1106];
  LNt[1108] = (float(LNP2x3[125]+LNt[1107]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1107] -= LNt[1108];
  LNt[1109] = LNt[1088]+d.z.v5*LNt[1034]+d.z.v6*LNt[1031]+d.z.v7*LNt[1028]+LNt[1108];
  LNt[1110] = (float(LNP2x3[125]+LNt[1109]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1109] -= LNt[1110];
  LNt[1111] = LNt[1089]+d.z.v5*LNt[1037]+d.z.v6*LNt[1034]+d.z.v7*LNt[1031]+LNt[1110];
  LNt[1112] = (float(LNP2x3[125]+LNt[1111]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1111] -= LNt[1112];
  LNt[1113] = LNt[1090]+d.z.v5*LNt[1040]+d.z.v6*LNt[1037]+d.z.v7*LNt[1034]+LNt[1112];
  LNt[1114] = (float(LNP2x3[125]+LNt[1113]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1113] -= LNt[1114];
  LNt[1115] = LNt[1091]+d.z.v5*LNt[1043]+d.z.v6*LNt[1040]+d.z.v7*LNt[1037]+LNt[1114];
  LNt[1116] = (float(LNP2x3[125]+LNt[1115]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1115] -= LNt[1116];
  LNt[1117] = LNt[1092]+d.z.v5*LNt[1046]+d.z.v6*LNt[1043]+d.z.v7*LNt[1040]+LNt[1116];
  LNt[1118] = (float(LNP2x3[125]+LNt[1117]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1117] -= LNt[1118];
  LNt[1119] = LNt[1093]+d.z.v5*LNt[1049]+d.z.v6*LNt[1046]+d.z.v7*LNt[1043]+LNt[1118];
  LNt[1120] = (float(LNP2x3[125]+LNt[1119]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[1119] -= LNt[1120];
  LNt[1121] = LNt[1094]+d.z.v5*LNt[1052]+d.z.v6*LNt[1049]+d.z.v7*LNt[1046]+LNt[1120];
  LNt[1122] = (float(LNP2x3[125]+LNt[1121]/LNP2[317])-LNP2x3[125])*LNP2[317];	//[1,53]<<368
  LNt[1121] -= LNt[1122];
  LNt[1123] = LNt[1095]+d.z.v5*LNt[1055]+d.z.v6*LNt[1052]+d.z.v7*LNt[1049]+LNt[1122];
  LNt[1124] = (float(LNP2x3[125]+LNt[1123]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[1,53]<<391
  LNt[1123] -= LNt[1124];
  LNt[1125] = LNt[1096]+d.z.v5*LNt[1058]+d.z.v6*LNt[1055]+d.z.v7*LNt[1052]+LNt[1124];
  LNt[1126] = (float(LNP2x3[125]+LNt[1125]/LNP2[363])-LNP2x3[125])*LNP2[363];	//[1,53]<<414
  LNt[1125] -= LNt[1126];
  LNt[1127] = LNt[1097]+d.z.v5*LNt[1061]+d.z.v6*LNt[1058]+d.z.v7*LNt[1055]+LNt[1126];
  LNt[1128] = (float(LNP2x3[125]+LNt[1127]/LNP2[386])-LNP2x3[125])*LNP2[386];	//[1,53]<<437
  LNt[1127] -= LNt[1128];
  LNt[1129] = LNt[1098]+d.z.v5*LNt[1064]+d.z.v6*LNt[1061]+d.z.v7*LNt[1058]+LNt[1128];
  LNt[1130] = (float(LNP2x3[125]+LNt[1129]/LNP2[409])-LNP2x3[125])*LNP2[409];	//[1,53]<<460
  LNt[1129] -= LNt[1130];
  LNt[1131] = LNt[1099]+d.z.v5*LNt[1067]+d.z.v6*LNt[1064]+d.z.v7*LNt[1061]+LNt[1130];
  LNt[1132] = (float(LNP2x3[125]+LNt[1131]/LNP2[432])-LNP2x3[125])*LNP2[432];	//[1,53]<<483
  LNt[1131] -= LNt[1132];
  LNt[1133] = LNt[23]*LNt[340]+LNt[25]*LNt[337]+d.y.v0*LNt[693]+d.y.v1*LNt[690]-(d.z.v0*LNt[1022]+d.z.v1*LNt[1019]);
  LNt[1134] = LNt[35]*LNt[399]+LNt[400]*LNt[397]+d.y.v6*LNt[752]+d.y.v7*LNt[750]-(d.z.v6*LNt[1081]+d.z.v7*LNt[1079]);
  LNt[1135] = LNt[402]+LNt[33]*LNt[337]+LNt[753]-(LNt[1083]+d.z.v5*LNt[1019]);
  LNt[1136] = (float(LNP2x3[125]+LNt[1135]/LNP2[64])-LNP2x3[125])*LNP2[64];	//[1,53]<<115
  LNt[1135] -= LNt[1136];
  LNt[1137] = LNt[809]-(LNt[1084]+d.z.v5*LNt[1022]+d.z.v6*LNt[1019])+LNt[1136];
  LNt[1138] = (float(LNP2x3[125]+LNt[1137]/LNP2[87])-LNP2x3[125])*LNP2[87];	//[1,53]<<138
  LNt[1137] -= LNt[1138];
  LNt[1139] = LNt[811]-LNt[1103]+LNt[1138];
  LNt[1140] = (float(LNP2x3[125]+LNt[1139]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[1139] -= LNt[1140];
  LNt[1141] = LNt[813]-LNt[1105]+LNt[1140];
  LNt[1142] = (float(LNP2x3[125]+LNt[1141]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1141] -= LNt[1142];
  LNt[1143] = LNt[815]-LNt[1107]+LNt[1142];
  LNt[1144] = (float(LNP2x3[125]+LNt[1143]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1143] -= LNt[1144];
  LNt[1145] = LNt[817]-LNt[1109]+LNt[1144];
  LNt[1146] = (float(LNP2x3[125]+LNt[1145]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1145] -= LNt[1146];
  LNt[1147] = LNt[819]-LNt[1111]+LNt[1146];
  LNt[1148] = (float(LNP2x3[125]+LNt[1147]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1147] -= LNt[1148];
  LNt[1149] = LNt[821]-LNt[1113]+LNt[1148];
  LNt[1150] = (float(LNP2x3[125]+LNt[1149]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1149] -= LNt[1150];
  LNt[1151] = LNt[823]-LNt[1115]+LNt[1150];
  LNt[1152] = (float(LNP2x3[125]+LNt[1151]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1151] -= LNt[1152];
  LNt[1153] = LNt[825]-LNt[1117]+LNt[1152];
  LNt[1154] = (float(LNP2x3[125]+LNt[1153]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1153] -= LNt[1154];
  LNt[1155] = LNt[827]-LNt[1119]+LNt[1154];
  LNt[1156] = (float(LNP2x3[125]+LNt[1155]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[1155] -= LNt[1156];
  LNt[1157] = LNt[829]-LNt[1121]+LNt[1156];
  LNt[1158] = (float(LNP2x3[125]+LNt[1157]/LNP2[317])-LNP2x3[125])*LNP2[317];	//[1,53]<<368
  LNt[1157] -= LNt[1158];
  LNt[1159] = LNt[831]-LNt[1123]+LNt[1158];
  LNt[1160] = (float(LNP2x3[125]+LNt[1159]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[1,53]<<391
  LNt[1159] -= LNt[1160];
  LNt[1161] = LNt[833]-LNt[1125]+LNt[1160];
  LNt[1162] = (float(LNP2x3[125]+LNt[1161]/LNP2[363])-LNP2x3[125])*LNP2[363];	//[1,53]<<414
  LNt[1161] -= LNt[1162];
  LNt[1163] = LNt[835]-LNt[1127]+LNt[1162];
  LNt[1164] = (float(LNP2x3[125]+LNt[1163]/LNP2[386])-LNP2x3[125])*LNP2[386];	//[1,53]<<437
  LNt[1163] -= LNt[1164];
  LNt[1165] = LNt[837]-LNt[1129]+LNt[1164];
  LNt[1166] = (float(LNP2x3[125]+LNt[1165]/LNP2[409])-LNP2x3[125])*LNP2[409];	//[1,53]<<460
  LNt[1165] -= LNt[1166];
  LNt[1167] = LNt[839]-LNt[1131]+LNt[1166];
  LNt[1168] = (float(LNP2x3[125]+LNt[1167]/LNP2[432])-LNP2x3[125])*LNP2[432];	//[1,53]<<483
  LNt[1167] -= LNt[1168];
  LNt[1169] = LNt[841]-(LNt[1100]+d.z.v6*LNt[1067]+d.z.v7*LNt[1064]+LNt[1132])+LNt[1168];
  LNt[1170] = (float(LNP2x3[125]+LNt[1169]/LNP2[455])-LNP2x3[125])*LNP2[455];	//[1,53]<<506
  LNt[1169] -= LNt[1170];
  LNt[1171] = LNt[420]+LNt[400]*LNt[385]+LNt[771]+LNt[842]-(LNt[1101]+d.z.v7*LNt[1067])+LNt[1170];
  LNt[1172] = (float(LNP2x3[125]+LNt[1171]/LNP2[478])-LNP2x3[125])*LNP2[478];	//[1,53]<<529
  LNt[1171] -= LNt[1172];
  LNt[1173] = c.x.v0*LNt[278]+c.x.v1*LNt[275]+c.x.v2*LNt[272]+c.x.v3*LNt[269]+c.x.v4*LNt[266]+c.x.v5*LNt[263];
  LNt[1174] = c.x.v0*LNt[281]+c.x.v1*LNt[278]+c.x.v2*LNt[275]+c.x.v3*LNt[272]+c.x.v4*LNt[269]+c.x.v5*LNt[266];
  LNt[1175] = c.x.v0*LNt[284]+c.x.v1*LNt[281]+c.x.v2*LNt[278]+c.x.v3*LNt[275]+c.x.v4*LNt[272]+c.x.v5*LNt[269];
  LNt[1176] = c.x.v0*LNt[287]+c.x.v1*LNt[284]+c.x.v2*LNt[281]+c.x.v3*LNt[278]+c.x.v4*LNt[275]+c.x.v5*LNt[272];
  LNt[1177] = c.x.v0*LNt[290]+c.x.v1*LNt[287]+c.x.v2*LNt[284]+c.x.v3*LNt[281]+c.x.v4*LNt[278]+c.x.v5*LNt[275];
  LNt[1178] = c.x.v0*LNt[293]+c.x.v1*LNt[290]+c.x.v2*LNt[287]+c.x.v3*LNt[284]+c.x.v4*LNt[281]+c.x.v5*LNt[278];
  LNt[1179] = c.x.v0*LNt[296]+c.x.v1*LNt[293]+c.x.v2*LNt[290]+c.x.v3*LNt[287]+c.x.v4*LNt[284]+c.x.v5*LNt[281];
  LNt[1180] = c.x.v0*LNt[299]+c.x.v1*LNt[296]+c.x.v2*LNt[293]+c.x.v3*LNt[290]+c.x.v4*LNt[287]+c.x.v5*LNt[284];
  LNt[1181] = c.x.v0*LNt[302]+c.x.v1*LNt[299]+c.x.v2*LNt[296]+c.x.v3*LNt[293]+c.x.v4*LNt[290]+c.x.v5*LNt[287];
  LNt[1182] = c.x.v0*LNt[304]+c.x.v1*LNt[302]+c.x.v2*LNt[299]+c.x.v3*LNt[296]+c.x.v4*LNt[293]+c.x.v5*LNt[290];
  LNt[1183] = c.x.v1*LNt[304]+c.x.v2*LNt[302]+c.x.v3*LNt[299]+c.x.v4*LNt[296]+c.x.v5*LNt[293]+c.x.v6*LNt[290];
  LNt[1184] = c.x.v2*LNt[304]+c.x.v3*LNt[302]+c.x.v4*LNt[299]+c.x.v5*LNt[296]+c.x.v6*LNt[293]+c.x.v7*LNt[290];
  LNt[1185] = LNt[1175]+c.x.v6*LNt[266]+c.x.v7*LNt[263];
  LNt[1186] = (float(LNP2x3[125]+LNt[1185]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[1185] -= LNt[1186];
  LNt[1187] = LNt[1176]+c.x.v6*LNt[269]+c.x.v7*LNt[266]+LNt[1186];
  LNt[1188] = (float(LNP2x3[125]+LNt[1187]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1187] -= LNt[1188];
  LNt[1189] = LNt[1177]+c.x.v6*LNt[272]+c.x.v7*LNt[269]+LNt[1188];
  LNt[1190] = (float(LNP2x3[125]+LNt[1189]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1189] -= LNt[1190];
  LNt[1191] = LNt[1178]+c.x.v6*LNt[275]+c.x.v7*LNt[272]+LNt[1190];
  LNt[1192] = (float(LNP2x3[125]+LNt[1191]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1191] -= LNt[1192];
  LNt[1193] = LNt[1179]+c.x.v6*LNt[278]+c.x.v7*LNt[275]+LNt[1192];
  LNt[1194] = (float(LNP2x3[125]+LNt[1193]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1193] -= LNt[1194];
  LNt[1195] = LNt[1180]+c.x.v6*LNt[281]+c.x.v7*LNt[278]+LNt[1194];
  LNt[1196] = (float(LNP2x3[125]+LNt[1195]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1195] -= LNt[1196];
  LNt[1197] = LNt[1181]+c.x.v6*LNt[284]+c.x.v7*LNt[281]+LNt[1196];
  LNt[1198] = (float(LNP2x3[125]+LNt[1197]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1197] -= LNt[1198];
  LNt[1199] = LNt[1182]+c.x.v6*LNt[287]+c.x.v7*LNt[284]+LNt[1198];
  LNt[1200] = (float(LNP2x3[125]+LNt[1199]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1199] -= LNt[1200];
  LNt[1201] = c.y.v0*LNt[631]+c.y.v1*LNt[628]+c.y.v2*LNt[625]+c.y.v3*LNt[622]+c.y.v4*LNt[619]+c.y.v5*LNt[616];
  LNt[1202] = c.y.v0*LNt[634]+c.y.v1*LNt[631]+c.y.v2*LNt[628]+c.y.v3*LNt[625]+c.y.v4*LNt[622]+c.y.v5*LNt[619];
  LNt[1203] = c.y.v0*LNt[637]+c.y.v1*LNt[634]+c.y.v2*LNt[631]+c.y.v3*LNt[628]+c.y.v4*LNt[625]+c.y.v5*LNt[622];
  LNt[1204] = c.y.v0*LNt[640]+c.y.v1*LNt[637]+c.y.v2*LNt[634]+c.y.v3*LNt[631]+c.y.v4*LNt[628]+c.y.v5*LNt[625];
  LNt[1205] = c.y.v0*LNt[643]+c.y.v1*LNt[640]+c.y.v2*LNt[637]+c.y.v3*LNt[634]+c.y.v4*LNt[631]+c.y.v5*LNt[628];
  LNt[1206] = c.y.v0*LNt[646]+c.y.v1*LNt[643]+c.y.v2*LNt[640]+c.y.v3*LNt[637]+c.y.v4*LNt[634]+c.y.v5*LNt[631];
  LNt[1207] = c.y.v0*LNt[649]+c.y.v1*LNt[646]+c.y.v2*LNt[643]+c.y.v3*LNt[640]+c.y.v4*LNt[637]+c.y.v5*LNt[634];
  LNt[1208] = c.y.v0*LNt[652]+c.y.v1*LNt[649]+c.y.v2*LNt[646]+c.y.v3*LNt[643]+c.y.v4*LNt[640]+c.y.v5*LNt[637];
  LNt[1209] = c.y.v0*LNt[655]+c.y.v1*LNt[652]+c.y.v2*LNt[649]+c.y.v3*LNt[646]+c.y.v4*LNt[643]+c.y.v5*LNt[640];
  LNt[1210] = c.y.v0*LNt[657]+c.y.v1*LNt[655]+c.y.v2*LNt[652]+c.y.v3*LNt[649]+c.y.v4*LNt[646]+c.y.v5*LNt[643];
  LNt[1211] = c.y.v1*LNt[657]+c.y.v2*LNt[655]+c.y.v3*LNt[652]+c.y.v4*LNt[649]+c.y.v5*LNt[646]+c.y.v6*LNt[643];
  LNt[1212] = c.y.v2*LNt[657]+c.y.v3*LNt[655]+c.y.v4*LNt[652]+c.y.v5*LNt[649]+c.y.v6*LNt[646]+c.y.v7*LNt[643];
  LNt[1213] = LNt[1203]+c.y.v6*LNt[619]+c.y.v7*LNt[616];
  LNt[1214] = (float(LNP2x3[125]+LNt[1213]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[1213] -= LNt[1214];
  LNt[1215] = LNt[1204]+c.y.v6*LNt[622]+c.y.v7*LNt[619]+LNt[1214];
  LNt[1216] = (float(LNP2x3[125]+LNt[1215]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1215] -= LNt[1216];
  LNt[1217] = LNt[1205]+c.y.v6*LNt[625]+c.y.v7*LNt[622]+LNt[1216];
  LNt[1218] = (float(LNP2x3[125]+LNt[1217]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1217] -= LNt[1218];
  LNt[1219] = LNt[1206]+c.y.v6*LNt[628]+c.y.v7*LNt[625]+LNt[1218];
  LNt[1220] = (float(LNP2x3[125]+LNt[1219]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1219] -= LNt[1220];
  LNt[1221] = LNt[1207]+c.y.v6*LNt[631]+c.y.v7*LNt[628]+LNt[1220];
  LNt[1222] = (float(LNP2x3[125]+LNt[1221]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1221] -= LNt[1222];
  LNt[1223] = LNt[1208]+c.y.v6*LNt[634]+c.y.v7*LNt[631]+LNt[1222];
  LNt[1224] = (float(LNP2x3[125]+LNt[1223]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1223] -= LNt[1224];
  LNt[1225] = LNt[1209]+c.y.v6*LNt[637]+c.y.v7*LNt[634]+LNt[1224];
  LNt[1226] = (float(LNP2x3[125]+LNt[1225]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1225] -= LNt[1226];
  LNt[1227] = LNt[1210]+c.y.v6*LNt[640]+c.y.v7*LNt[637]+LNt[1226];
  LNt[1228] = (float(LNP2x3[125]+LNt[1227]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1227] -= LNt[1228];
  LNt[1229] = c.x.v0*LNt[269]+c.x.v1*LNt[266]+c.x.v2*LNt[263]-(c.y.v0*LNt[622]+c.y.v1*LNt[619]+c.y.v2*LNt[616]);
  LNt[1230] = c.x.v0*LNt[272]+c.x.v1*LNt[269]+c.x.v2*LNt[266]+c.x.v3*LNt[263]-(c.y.v0*LNt[625]+c.y.v1*LNt[622]+c.y.v2*LNt[619]+c.y.v3*LNt[616]);
  LNt[1231] = c.x.v0*LNt[275]+c.x.v1*LNt[272]+c.x.v2*LNt[269]+c.x.v3*LNt[266]+c.x.v4*LNt[263]-(c.y.v0*LNt[628]+c.y.v1*LNt[625]+c.y.v2*LNt[622]+c.y.v3*LNt[619]+c.y.v4*LNt[616]);
  LNt[1232] = c.x.v3*LNt[304]+c.x.v4*LNt[302]+c.x.v5*LNt[299]+c.x.v6*LNt[296]+c.x.v7*LNt[293]-(c.y.v3*LNt[657]+c.y.v4*LNt[655]+c.y.v5*LNt[652]+c.y.v6*LNt[649]+c.y.v7*LNt[646]);
  LNt[1233] = c.x.v4*LNt[304]+c.x.v5*LNt[302]+c.x.v6*LNt[299]+c.x.v7*LNt[296]-(c.y.v4*LNt[657]+c.y.v5*LNt[655]+c.y.v6*LNt[652]+c.y.v7*LNt[649]);
  LNt[1234] = c.x.v5*LNt[304]+c.x.v6*LNt[302]+c.x.v7*LNt[299]-(c.y.v5*LNt[657]+c.y.v6*LNt[655]+c.y.v7*LNt[652]);
  LNt[1235] = LNt[1174]+c.x.v6*LNt[263]-(LNt[1202]+c.y.v6*LNt[616]);
  LNt[1236] = (float(LNP2x3[125]+LNt[1235]/LNP2[87])-LNP2x3[125])*LNP2[87];	//[1,53]<<138
  LNt[1235] -= LNt[1236];
  LNt[1237] = LNt[1185]-LNt[1213]+LNt[1236];
  LNt[1238] = (float(LNP2x3[125]+LNt[1237]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[1237] -= LNt[1238];
  LNt[1239] = LNt[1187]-LNt[1215]+LNt[1238];
  LNt[1240] = (float(LNP2x3[125]+LNt[1239]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1239] -= LNt[1240];
  LNt[1241] = LNt[1189]-LNt[1217]+LNt[1240];
  LNt[1242] = (float(LNP2x3[125]+LNt[1241]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1241] -= LNt[1242];
  LNt[1243] = LNt[1191]-LNt[1219]+LNt[1242];
  LNt[1244] = (float(LNP2x3[125]+LNt[1243]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1243] -= LNt[1244];
  LNt[1245] = LNt[1193]-LNt[1221]+LNt[1244];
  LNt[1246] = (float(LNP2x3[125]+LNt[1245]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1245] -= LNt[1246];
  LNt[1247] = LNt[1195]-LNt[1223]+LNt[1246];
  LNt[1248] = (float(LNP2x3[125]+LNt[1247]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1247] -= LNt[1248];
  LNt[1249] = LNt[1197]-LNt[1225]+LNt[1248];
  LNt[1250] = (float(LNP2x3[125]+LNt[1249]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1249] -= LNt[1250];
  LNt[1251] = LNt[1199]-LNt[1227]+LNt[1250];
  LNt[1252] = (float(LNP2x3[125]+LNt[1251]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1251] -= LNt[1252];
  LNt[1253] = LNt[1183]+c.x.v7*LNt[287]+LNt[1200]-(LNt[1211]+c.y.v7*LNt[640]+LNt[1228])+LNt[1252];
  LNt[1254] = (float(LNP2x3[125]+LNt[1253]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[1253] -= LNt[1254];
  LNt[1255] = c.z.v0*LNt[960]+c.z.v1*LNt[957]+c.z.v2*LNt[954]+c.z.v3*LNt[951]+c.z.v4*LNt[948]+c.z.v5*LNt[945];
  LNt[1256] = c.z.v0*LNt[963]+c.z.v1*LNt[960]+c.z.v2*LNt[957]+c.z.v3*LNt[954]+c.z.v4*LNt[951]+c.z.v5*LNt[948];
  LNt[1257] = c.z.v0*LNt[966]+c.z.v1*LNt[963]+c.z.v2*LNt[960]+c.z.v3*LNt[957]+c.z.v4*LNt[954]+c.z.v5*LNt[951];
  LNt[1258] = c.z.v0*LNt[969]+c.z.v1*LNt[966]+c.z.v2*LNt[963]+c.z.v3*LNt[960]+c.z.v4*LNt[957]+c.z.v5*LNt[954];
  LNt[1259] = c.z.v0*LNt[972]+c.z.v1*LNt[969]+c.z.v2*LNt[966]+c.z.v3*LNt[963]+c.z.v4*LNt[960]+c.z.v5*LNt[957];
  LNt[1260] = c.z.v0*LNt[975]+c.z.v1*LNt[972]+c.z.v2*LNt[969]+c.z.v3*LNt[966]+c.z.v4*LNt[963]+c.z.v5*LNt[960];
  LNt[1261] = c.z.v0*LNt[978]+c.z.v1*LNt[975]+c.z.v2*LNt[972]+c.z.v3*LNt[969]+c.z.v4*LNt[966]+c.z.v5*LNt[963];
  LNt[1262] = c.z.v0*LNt[981]+c.z.v1*LNt[978]+c.z.v2*LNt[975]+c.z.v3*LNt[972]+c.z.v4*LNt[969]+c.z.v5*LNt[966];
  LNt[1263] = c.z.v0*LNt[984]+c.z.v1*LNt[981]+c.z.v2*LNt[978]+c.z.v3*LNt[975]+c.z.v4*LNt[972]+c.z.v5*LNt[969];
  LNt[1264] = c.z.v0*LNt[986]+c.z.v1*LNt[984]+c.z.v2*LNt[981]+c.z.v3*LNt[978]+c.z.v4*LNt[975]+c.z.v5*LNt[972];
  LNt[1265] = c.z.v1*LNt[986]+c.z.v2*LNt[984]+c.z.v3*LNt[981]+c.z.v4*LNt[978]+c.z.v5*LNt[975]+c.z.v6*LNt[972];
  LNt[1266] = c.z.v2*LNt[986]+c.z.v3*LNt[984]+c.z.v4*LNt[981]+c.z.v5*LNt[978]+c.z.v6*LNt[975]+c.z.v7*LNt[972];
  LNt[1267] = LNt[1257]+c.z.v6*LNt[948]+c.z.v7*LNt[945];
  LNt[1268] = (float(LNP2x3[125]+LNt[1267]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[1267] -= LNt[1268];
  LNt[1269] = LNt[1258]+c.z.v6*LNt[951]+c.z.v7*LNt[948]+LNt[1268];
  LNt[1270] = (float(LNP2x3[125]+LNt[1269]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1269] -= LNt[1270];
  LNt[1271] = LNt[1259]+c.z.v6*LNt[954]+c.z.v7*LNt[951]+LNt[1270];
  LNt[1272] = (float(LNP2x3[125]+LNt[1271]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1271] -= LNt[1272];
  LNt[1273] = LNt[1260]+c.z.v6*LNt[957]+c.z.v7*LNt[954]+LNt[1272];
  LNt[1274] = (float(LNP2x3[125]+LNt[1273]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1273] -= LNt[1274];
  LNt[1275] = LNt[1261]+c.z.v6*LNt[960]+c.z.v7*LNt[957]+LNt[1274];
  LNt[1276] = (float(LNP2x3[125]+LNt[1275]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1275] -= LNt[1276];
  LNt[1277] = LNt[1262]+c.z.v6*LNt[963]+c.z.v7*LNt[960]+LNt[1276];
  LNt[1278] = (float(LNP2x3[125]+LNt[1277]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1277] -= LNt[1278];
  LNt[1279] = LNt[1263]+c.z.v6*LNt[966]+c.z.v7*LNt[963]+LNt[1278];
  LNt[1280] = (float(LNP2x3[125]+LNt[1279]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1279] -= LNt[1280];
  LNt[1281] = LNt[1264]+c.z.v6*LNt[969]+c.z.v7*LNt[966]+LNt[1280];
  LNt[1282] = (float(LNP2x3[125]+LNt[1281]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1281] -= LNt[1282];
  LNt[1283] = c.x.v0*LNt[266]+c.x.v1*LNt[263]-(c.y.v0*LNt[619]+c.y.v1*LNt[616])+c.z.v0*LNt[948]+c.z.v1*LNt[945];
  LNt[1284] = LNt[1231]+c.z.v0*LNt[957]+c.z.v1*LNt[954]+c.z.v2*LNt[951]+c.z.v3*LNt[948]+c.z.v4*LNt[945];
  LNt[1285] = LNt[1232]+c.z.v3*LNt[986]+c.z.v4*LNt[984]+c.z.v5*LNt[981]+c.z.v6*LNt[978]+c.z.v7*LNt[975];
  LNt[1286] = c.x.v6*LNt[304]+c.x.v7*LNt[302]-(c.y.v6*LNt[657]+c.y.v7*LNt[655])+c.z.v6*LNt[986]+c.z.v7*LNt[984];
  LNt[1287] = c.x.v0*LNt[263]-c.y.v0*LNt[616]+c.z.v0*LNt[945];
  LNt[1288] = float(LNP2x3[48]+LNt[1287])-LNP2x3[48];	//[22,48]<<0
  LNt[1287] -= LNt[1288];
  LNt[1289] = float(LNP2x3[45]+LNt[1287])-LNP2x3[45];	//[3,26]<<0
  LNt[1287] -= LNt[1289];
  LNt[1290] = LNt[1283]+LNt[1288]+LNt[1289];
  LNt[1291] = float(LNP2x3[72]+LNt[1290])-LNP2x3[72];	//[22,49]<<23
  LNt[1290] -= LNt[1291];
  LNt[1292] = float(LNP2x3[68]+LNt[1290])-LNP2x3[68];	//[4,27]<<23
  LNt[1290] -= LNt[1292];
  LNt[1293] = LNt[1229]+c.z.v0*LNt[951]+c.z.v1*LNt[948]+c.z.v2*LNt[945]+LNt[1291]+LNt[1292];
  LNt[1294] = float(LNP2x3[96]+LNt[1293])-LNP2x3[96];	//[22,50]<<46
  LNt[1293] -= LNt[1294];
  LNt[1295] = float(LNP2x3[91]+LNt[1293])-LNP2x3[91];	//[5,28]<<46
  LNt[1293] -= LNt[1295];
  LNt[1296] = LNt[1230]+c.z.v0*LNt[954]+c.z.v1*LNt[951]+c.z.v2*LNt[948]+c.z.v3*LNt[945]+LNt[1294]+LNt[1295];
  LNt[1297] = float(LNP2x3[120]+LNt[1296])-LNP2x3[120];	//[22,51]<<69
  LNt[1296] -= LNt[1297];
  LNt[1298] = float(LNP2x3[114]+LNt[1296])-LNP2x3[114];	//[6,29]<<69
  LNt[1296] -= LNt[1298];
  LNt[1299] = LNt[1284]+LNt[1297]+LNt[1298];
  LNt[1300] = (float(LNP2x3[125]+LNt[1299]/LNP2[19])-LNP2x3[125])*LNP2[19];	//[22,52]<<92
  LNt[1299] -= LNt[1300];
  LNt[1301] = (float(LNP2x3[125]+LNt[1299]/LNP2[12])-LNP2x3[125])*LNP2[12];	//[7,30]<<92
  LNt[1299] -= LNt[1301];
  LNt[1302] = LNt[1173]-LNt[1201]+LNt[1255]+LNt[1300]+LNt[1301];
  LNt[1303] = (float(LNP2x3[125]+LNt[1302]/LNP2[43])-LNP2x3[125])*LNP2[43];	//[22,53]<<115
  LNt[1302] -= LNt[1303];
  LNt[1304] = (float(LNP2x3[125]+LNt[1302]/LNP2[35])-LNP2x3[125])*LNP2[35];	//[8,31]<<115
  LNt[1302] -= LNt[1304];
  LNt[1305] = LNt[1235]+LNt[1256]+c.z.v6*LNt[945]+LNt[1303]+LNt[1304];
  LNt[1306] = (float(LNP2x3[125]+LNt[1305]/LNP2[66])-LNP2x3[125])*LNP2[66];	//[22,53]<<138
  LNt[1305] -= LNt[1306];
  LNt[1307] = (float(LNP2x3[125]+LNt[1305]/LNP2[58])-LNP2x3[125])*LNP2[58];	//[8,31]<<138
  LNt[1305] -= LNt[1307];
  LNt[1308] = LNt[1237]+LNt[1267]+LNt[1306]+LNt[1307];
  LNt[1309] = (float(LNP2x3[125]+LNt[1308]/LNP2[89])-LNP2x3[125])*LNP2[89];	//[22,53]<<161
  LNt[1308] -= LNt[1309];
  LNt[1310] = (float(LNP2x3[125]+LNt[1308]/LNP2[81])-LNP2x3[125])*LNP2[81];	//[8,31]<<161
  LNt[1308] -= LNt[1310];
  LNt[1311] = LNt[1239]+LNt[1269]+LNt[1309]+LNt[1310];
  LNt[1312] = (float(LNP2x3[125]+LNt[1311]/LNP2[112])-LNP2x3[125])*LNP2[112];	//[22,53]<<184
  LNt[1311] -= LNt[1312];
  LNt[1313] = (float(LNP2x3[125]+LNt[1311]/LNP2[104])-LNP2x3[125])*LNP2[104];	//[8,31]<<184
  LNt[1311] -= LNt[1313];
  LNt[1314] = LNt[1241]+LNt[1271]+LNt[1312]+LNt[1313];
  LNt[1315] = (float(LNP2x3[125]+LNt[1314]/LNP2[135])-LNP2x3[125])*LNP2[135];	//[22,53]<<207
  LNt[1314] -= LNt[1315];
  LNt[1316] = (float(LNP2x3[125]+LNt[1314]/LNP2[127])-LNP2x3[125])*LNP2[127];	//[8,31]<<207
  LNt[1314] -= LNt[1316];
  LNt[1317] = LNt[1243]+LNt[1273]+LNt[1315]+LNt[1316];
  LNt[1318] = (float(LNP2x3[125]+LNt[1317]/LNP2[158])-LNP2x3[125])*LNP2[158];	//[22,53]<<230
  LNt[1317] -= LNt[1318];
  LNt[1319] = (float(LNP2x3[125]+LNt[1317]/LNP2[150])-LNP2x3[125])*LNP2[150];	//[8,31]<<230
  LNt[1317] -= LNt[1319];
  LNt[1320] = LNt[1245]+LNt[1275]+LNt[1318]+LNt[1319];
  LNt[1321] = (float(LNP2x3[125]+LNt[1320]/LNP2[181])-LNP2x3[125])*LNP2[181];	//[22,53]<<253
  LNt[1320] -= LNt[1321];
  LNt[1322] = (float(LNP2x3[125]+LNt[1320]/LNP2[173])-LNP2x3[125])*LNP2[173];	//[8,31]<<253
  LNt[1320] -= LNt[1322];
  LNt[1323] = LNt[1247]+LNt[1277]+LNt[1321]+LNt[1322];
  LNt[1324] = (float(LNP2x3[125]+LNt[1323]/LNP2[204])-LNP2x3[125])*LNP2[204];	//[22,53]<<276
  LNt[1323] -= LNt[1324];
  LNt[1325] = (float(LNP2x3[125]+LNt[1323]/LNP2[196])-LNP2x3[125])*LNP2[196];	//[8,31]<<276
  LNt[1323] -= LNt[1325];
  LNt[1326] = LNt[1249]+LNt[1279]+LNt[1324]+LNt[1325];
  LNt[1327] = (float(LNP2x3[125]+LNt[1326]/LNP2[227])-LNP2x3[125])*LNP2[227];	//[22,53]<<299
  LNt[1326] -= LNt[1327];
  LNt[1328] = (float(LNP2x3[125]+LNt[1326]/LNP2[219])-LNP2x3[125])*LNP2[219];	//[8,31]<<299
  LNt[1326] -= LNt[1328];
  LNt[1329] = LNt[1251]+LNt[1281]+LNt[1327]+LNt[1328];
  LNt[1330] = (float(LNP2x3[125]+LNt[1329]/LNP2[250])-LNP2x3[125])*LNP2[250];	//[22,53]<<322
  LNt[1329] -= LNt[1330];
  LNt[1331] = (float(LNP2x3[125]+LNt[1329]/LNP2[242])-LNP2x3[125])*LNP2[242];	//[8,31]<<322
  LNt[1329] -= LNt[1331];
  LNt[1332] = LNt[1253]+LNt[1265]+c.z.v7*LNt[969]+LNt[1282]+LNt[1330]+LNt[1331];
  LNt[1333] = (float(LNP2x3[125]+LNt[1332]/LNP2[273])-LNP2x3[125])*LNP2[273];	//[22,53]<<345
  LNt[1332] -= LNt[1333];
  LNt[1334] = (float(LNP2x3[125]+LNt[1332]/LNP2[265])-LNP2x3[125])*LNP2[265];	//[8,31]<<345
  LNt[1332] -= LNt[1334];
  LNt[1335] = LNt[1184]-LNt[1212]+LNt[1254]+LNt[1266]+LNt[1333]+LNt[1334];
  LNt[1336] = (float(LNP2x3[125]+LNt[1335]/LNP2[296])-LNP2x3[125])*LNP2[296];	//[22,53]<<368
  LNt[1335] -= LNt[1336];
  LNt[1337] = (float(LNP2x3[125]+LNt[1335]/LNP2[288])-LNP2x3[125])*LNP2[288];	//[8,31]<<368
  LNt[1335] -= LNt[1337];
  LNt[1338] = LNt[1285]+LNt[1336]+LNt[1337];
  LNt[1339] = (float(LNP2x3[125]+LNt[1338]/LNP2[318])-LNP2x3[125])*LNP2[318];	//[22,52]<<391
  LNt[1338] -= LNt[1339];
  LNt[1340] = (float(LNP2x3[125]+LNt[1338]/LNP2[311])-LNP2x3[125])*LNP2[311];	//[7,30]<<391
  LNt[1338] -= LNt[1340];
  LNt[1341] = LNt[1233]+c.z.v4*LNt[986]+c.z.v5*LNt[984]+c.z.v6*LNt[981]+c.z.v7*LNt[978]+LNt[1339]+LNt[1340];
  LNt[1342] = (float(LNP2x3[125]+LNt[1341]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[22,51]<<414
  LNt[1341] -= LNt[1342];
  LNt[1343] = (float(LNP2x3[125]+LNt[1341]/LNP2[334])-LNP2x3[125])*LNP2[334];	//[6,29]<<414
  LNt[1341] -= LNt[1343];
  LNt[1344] = LNt[1234]+c.z.v5*LNt[986]+c.z.v6*LNt[984]+c.z.v7*LNt[981]+LNt[1342]+LNt[1343];
  LNt[1345] = (float(LNP2x3[125]+LNt[1344]/LNP2[362])-LNP2x3[125])*LNP2[362];	//[22,50]<<437
  LNt[1344] -= LNt[1345];
  LNt[1346] = (float(LNP2x3[125]+LNt[1344]/LNP2[357])-LNP2x3[125])*LNP2[357];	//[5,28]<<437
  LNt[1344] -= LNt[1346];
  LNt[1347] = LNt[1286]+LNt[1345]+LNt[1346];
  LNt[1348] = (float(LNP2x3[125]+LNt[1347]/LNP2[380])-LNP2x3[125])*LNP2[380];	//[8,31]<<460
  LNt[1347] -= LNt[1348];
  LNt[1349] = c.x.v7*LNt[304]-c.y.v7*LNt[657]+c.z.v7*LNt[986]+LNt[1348];
  LNt[1350] = d.w.v0*LNt[1299]+d.w.v1*LNt[1296]+d.w.v2*LNt[1293]+d.w.v3*LNt[1290]+d.w.v4*LNt[1287];
  LNt[1351] = d.w.v0*LNt[1302]+d.w.v1*LNt[1299]+d.w.v2*LNt[1296]+d.w.v3*LNt[1293]+d.w.v4*LNt[1290];
  LNt[1352] = d.w.v0*LNt[1305]+d.w.v1*LNt[1302]+d.w.v2*LNt[1299]+d.w.v3*LNt[1296]+d.w.v4*LNt[1293];
  LNt[1353] = d.w.v0*LNt[1308]+d.w.v1*LNt[1305]+d.w.v2*LNt[1302]+d.w.v3*LNt[1299]+d.w.v4*LNt[1296];
  LNt[1354] = d.w.v0*LNt[1311]+d.w.v1*LNt[1308]+d.w.v2*LNt[1305]+d.w.v3*LNt[1302]+d.w.v4*LNt[1299];
  LNt[1355] = d.w.v0*LNt[1314]+d.w.v1*LNt[1311]+d.w.v2*LNt[1308]+d.w.v3*LNt[1305]+d.w.v4*LNt[1302];
  LNt[1356] = d.w.v0*LNt[1317]+d.w.v1*LNt[1314]+d.w.v2*LNt[1311]+d.w.v3*LNt[1308]+d.w.v4*LNt[1305];
  LNt[1357] = d.w.v0*LNt[1320]+d.w.v1*LNt[1317]+d.w.v2*LNt[1314]+d.w.v3*LNt[1311]+d.w.v4*LNt[1308];
  LNt[1358] = d.w.v0*LNt[1323]+d.w.v1*LNt[1320]+d.w.v2*LNt[1317]+d.w.v3*LNt[1314]+d.w.v4*LNt[1311];
  LNt[1359] = d.w.v0*LNt[1326]+d.w.v1*LNt[1323]+d.w.v2*LNt[1320]+d.w.v3*LNt[1317]+d.w.v4*LNt[1314];
  LNt[1360] = d.w.v0*LNt[1329]+d.w.v1*LNt[1326]+d.w.v2*LNt[1323]+d.w.v3*LNt[1320]+d.w.v4*LNt[1317];
  LNt[1361] = d.w.v0*LNt[1332]+d.w.v1*LNt[1329]+d.w.v2*LNt[1326]+d.w.v3*LNt[1323]+d.w.v4*LNt[1320];
  LNt[1362] = d.w.v0*LNt[1335]+d.w.v1*LNt[1332]+d.w.v2*LNt[1329]+d.w.v3*LNt[1326]+d.w.v4*LNt[1323];
  LNt[1363] = d.w.v0*LNt[1338]+d.w.v1*LNt[1335]+d.w.v2*LNt[1332]+d.w.v3*LNt[1329]+d.w.v4*LNt[1326];
  LNt[1364] = d.w.v0*LNt[1341]+d.w.v1*LNt[1338]+d.w.v2*LNt[1335]+d.w.v3*LNt[1332]+d.w.v4*LNt[1329];
  LNt[1365] = d.w.v0*LNt[1344]+d.w.v1*LNt[1341]+d.w.v2*LNt[1338]+d.w.v3*LNt[1335]+d.w.v4*LNt[1332];
  LNt[1366] = d.w.v0*LNt[1347]+d.w.v1*LNt[1344]+d.w.v2*LNt[1341]+d.w.v3*LNt[1338]+d.w.v4*LNt[1335];
  LNt[1367] = d.w.v0*LNt[1349]+d.w.v1*LNt[1347]+d.w.v2*LNt[1344]+d.w.v3*LNt[1341]+d.w.v4*LNt[1338];
  LNt[1368] = d.w.v1*LNt[1349]+d.w.v2*LNt[1347]+d.w.v3*LNt[1344]+d.w.v4*LNt[1341]+d.w.v5*LNt[1338];
  LNt[1369] = d.w.v2*LNt[1349]+d.w.v3*LNt[1347]+d.w.v4*LNt[1344]+d.w.v5*LNt[1341]+d.w.v6*LNt[1338];
  LNt[1370] = d.w.v3*LNt[1349]+d.w.v4*LNt[1347]+d.w.v5*LNt[1344]+d.w.v6*LNt[1341]+d.w.v7*LNt[1338];
  LNt[1371] = LNt[1353]+d.w.v5*LNt[1293]+d.w.v6*LNt[1290]+d.w.v7*LNt[1287];
  LNt[1372] = (float(LNP2x3[125]+LNt[1371]/LNP2[110])-LNP2x3[125])*LNP2[110];	//[1,53]<<161
  LNt[1371] -= LNt[1372];
  LNt[1373] = LNt[1354]+d.w.v5*LNt[1296]+d.w.v6*LNt[1293]+d.w.v7*LNt[1290]+LNt[1372];
  LNt[1374] = (float(LNP2x3[125]+LNt[1373]/LNP2[133])-LNP2x3[125])*LNP2[133];	//[1,53]<<184
  LNt[1373] -= LNt[1374];
  LNt[1375] = LNt[1355]+d.w.v5*LNt[1299]+d.w.v6*LNt[1296]+d.w.v7*LNt[1293]+LNt[1374];
  LNt[1376] = (float(LNP2x3[125]+LNt[1375]/LNP2[156])-LNP2x3[125])*LNP2[156];	//[1,53]<<207
  LNt[1375] -= LNt[1376];
  LNt[1377] = LNt[1356]+d.w.v5*LNt[1302]+d.w.v6*LNt[1299]+d.w.v7*LNt[1296]+LNt[1376];
  LNt[1378] = (float(LNP2x3[125]+LNt[1377]/LNP2[179])-LNP2x3[125])*LNP2[179];	//[1,53]<<230
  LNt[1377] -= LNt[1378];
  LNt[1379] = LNt[1357]+d.w.v5*LNt[1305]+d.w.v6*LNt[1302]+d.w.v7*LNt[1299]+LNt[1378];
  LNt[1380] = (float(LNP2x3[125]+LNt[1379]/LNP2[202])-LNP2x3[125])*LNP2[202];	//[1,53]<<253
  LNt[1379] -= LNt[1380];
  LNt[1381] = LNt[1358]+d.w.v5*LNt[1308]+d.w.v6*LNt[1305]+d.w.v7*LNt[1302]+LNt[1380];
  LNt[1382] = (float(LNP2x3[125]+LNt[1381]/LNP2[225])-LNP2x3[125])*LNP2[225];	//[1,53]<<276
  LNt[1381] -= LNt[1382];
  LNt[1383] = LNt[1359]+d.w.v5*LNt[1311]+d.w.v6*LNt[1308]+d.w.v7*LNt[1305]+LNt[1382];
  LNt[1384] = (float(LNP2x3[125]+LNt[1383]/LNP2[248])-LNP2x3[125])*LNP2[248];	//[1,53]<<299
  LNt[1383] -= LNt[1384];
  LNt[1385] = LNt[1360]+d.w.v5*LNt[1314]+d.w.v6*LNt[1311]+d.w.v7*LNt[1308]+LNt[1384];
  LNt[1386] = (float(LNP2x3[125]+LNt[1385]/LNP2[271])-LNP2x3[125])*LNP2[271];	//[1,53]<<322
  LNt[1385] -= LNt[1386];
  LNt[1387] = LNt[1361]+d.w.v5*LNt[1317]+d.w.v6*LNt[1314]+d.w.v7*LNt[1311]+LNt[1386];
  LNt[1388] = (float(LNP2x3[125]+LNt[1387]/LNP2[294])-LNP2x3[125])*LNP2[294];	//[1,53]<<345
  LNt[1387] -= LNt[1388];
  LNt[1389] = LNt[1362]+d.w.v5*LNt[1320]+d.w.v6*LNt[1317]+d.w.v7*LNt[1314]+LNt[1388];
  LNt[1390] = (float(LNP2x3[125]+LNt[1389]/LNP2[317])-LNP2x3[125])*LNP2[317];	//[1,53]<<368
  LNt[1389] -= LNt[1390];
  LNt[1391] = LNt[1363]+d.w.v5*LNt[1323]+d.w.v6*LNt[1320]+d.w.v7*LNt[1317]+LNt[1390];
  LNt[1392] = (float(LNP2x3[125]+LNt[1391]/LNP2[340])-LNP2x3[125])*LNP2[340];	//[1,53]<<391
  LNt[1391] -= LNt[1392];
  LNt[1393] = LNt[1364]+d.w.v5*LNt[1326]+d.w.v6*LNt[1323]+d.w.v7*LNt[1320]+LNt[1392];
  LNt[1394] = (float(LNP2x3[125]+LNt[1393]/LNP2[363])-LNP2x3[125])*LNP2[363];	//[1,53]<<414
  LNt[1393] -= LNt[1394];
  LNt[1395] = LNt[1365]+d.w.v5*LNt[1329]+d.w.v6*LNt[1326]+d.w.v7*LNt[1323]+LNt[1394];
  LNt[1396] = (float(LNP2x3[125]+LNt[1395]/LNP2[386])-LNP2x3[125])*LNP2[386];	//[1,53]<<437
  LNt[1395] -= LNt[1396];
  LNt[1397] = LNt[1366]+d.w.v5*LNt[1332]+d.w.v6*LNt[1329]+d.w.v7*LNt[1326]+LNt[1396];
  LNt[1398] = (float(LNP2x3[125]+LNt[1397]/LNP2[409])-LNP2x3[125])*LNP2[409];	//[1,53]<<460
  LNt[1397] -= LNt[1398];
  LNt[1399] = LNt[1367]+d.w.v5*LNt[1335]+d.w.v6*LNt[1332]+d.w.v7*LNt[1329]+LNt[1398];
  LNt[1400] = (float(LNP2x3[125]+LNt[1399]/LNP2[432])-LNP2x3[125])*LNP2[432];	//[1,53]<<483
  LNt[1399] -= LNt[1400];
  LNt[1401] = LNt[802]-(d.z.v0*LNt[1025]+d.z.v1*LNt[1022]+d.z.v2*LNt[1019])+d.w.v0*LNt[1293]+d.w.v1*LNt[1290]+d.w.v2*LNt[1287];
  LNt[1402] = LNt[803]-(d.z.v0*LNt[1028]+d.z.v1*LNt[1025]+d.z.v2*LNt[1022]+d.z.v3*LNt[1019])+d.w.v0*LNt[1296]+d.w.v1*LNt[1293]+d.w.v2*LNt[1290]+d.w.v3*LNt[1287];
  LNt[1403] = LNt[807]-(d.z.v4*LNt[1081]+d.z.v5*LNt[1079]+d.z.v6*LNt[1076]+d.z.v7*LNt[1073])+d.w.v4*LNt[1349]+d.w.v5*LNt[1347]+d.w.v6*LNt[1344]+d.w.v7*LNt[1341];
  LNt[1404] = LNt[808]-(d.z.v5*LNt[1081]+d.z.v6*LNt[1079]+d.z.v7*LNt[1076])+d.w.v5*LNt[1349]+d.w.v6*LNt[1347]+d.w.v7*LNt[1344];
  LNt[1405] = LNt[23]*LNt[337]+d.y.v0*LNt[690]-d.z.v0*LNt[1019]+d.w.v0*LNt[1287];
  LNt[1406] = LNt[1133]+d.w.v0*LNt[1290]+d.w.v1*LNt[1287];
  LNt[1407] = LNt[804]-LNt[1082]+LNt[1350];
  LNt[1408] = LNt[1135]+LNt[1351]+d.w.v5*LNt[1287];
  LNt[1409] = LNt[1137]+LNt[1352]+d.w.v5*LNt[1290]+d.w.v6*LNt[1287];
  LNt[1410] = LNt[1139]+LNt[1371];
  LNt[1411] = LNt[1141]+LNt[1373];
  LNt[1412] = LNt[1143]+LNt[1375];
  LNt[1413] = LNt[1145]+LNt[1377];
  LNt[1414] = LNt[1147]+LNt[1379];
  LNt[1415] = LNt[1149]+LNt[1381];
  LNt[1416] = LNt[1151]+LNt[1383];
  LNt[1417] = LNt[1153]+LNt[1385];
  LNt[1418] = LNt[1155]+LNt[1387];
  LNt[1419] = LNt[1157]+LNt[1389];
  LNt[1420] = LNt[1159]+LNt[1391];
  LNt[1421] = LNt[1161]+LNt[1393];
  LNt[1422] = LNt[1163]+LNt[1395];
  LNt[1423] = LNt[1165]+LNt[1397];
  LNt[1424] = LNt[1167]+LNt[1399];
  LNt[1425] = LNt[1169]+LNt[1368]+d.w.v6*LNt[1335]+d.w.v7*LNt[1332]+LNt[1400];
  LNt[1426] = LNt[1171]+LNt[1369]+d.w.v7*LNt[1335];
  LNt[1427] = LNt[806]-LNt[1102]+LNt[1172]+LNt[1370];
  LNt[1428] = LNt[1134]+d.w.v6*LNt[1349]+d.w.v7*LNt[1347];
  LNt[1429] = LNt[400]*LNt[399]+d.y.v7*LNt[752]-d.z.v7*LNt[1081]+d.w.v7*LNt[1349];
  LNt[1430] = ((((((LNt[1429])+LNt[1428])+LNt[1404])+LNt[1403])+LNt[1427])+LNt[1426])+LNt[1425];
  LNt[1431] = ((((((LNt[1430])+LNt[1424])+LNt[1423])+LNt[1422])+LNt[1421])+LNt[1420])+LNt[1419];
  LNt[1432] = ((((((LNt[1431])+LNt[1418])+LNt[1417])+LNt[1416])+LNt[1415])+LNt[1414])+LNt[1413];
  LNt[1433] = ((((((LNt[1432])+LNt[1412])+LNt[1411])+LNt[1410])+LNt[1409])+LNt[1408])+LNt[1407];
  LNt[22] = (((((LNt[1433])+LNt[1402])+LNt[1401])+LNt[1406])+LNt[1405]);
}
if (LNt[22]<0){
  LNt[0] = -1.;
}else{
  if (LNt[22]>0){
    LNt[0] = 1.;
  }else{
    LNt[0] = 0.;
  }
}
LNans = LNt[0];
return LNans;
} /* adds=3384 multiplies=2940 normalizes=577 */



double LNP2[1023], LNP2x3[1023], LNt[1434];
int LNret[7];
class LNinit {  public: LNinit();};
LNinit::LNinit(){
LNP2[0]=1.;
for(int i=1;i<1023; i+=1)LNP2[i] = LNP2[i-1]*2.;
for(i=0;i<1021; i+=1)LNP2x3[i] = LNP2[i]*3.;
};
LNinit LNinitp;
